<a name="top"> </a>

[This document is formatted with GitHub-Flavored Markdown.              ]:#
[For better viewing, including hyperlinks, read it online at            ]:#
[https://github.com/sourceryinstitute/OpenCoarrays/blob/master/README.md]:#
<div align="center">

[![Sourcery Institute][sourcery-institute logo]][Sourcery, Inc.]

OpenCoarrays
============

[![CI Build Status][build img]](https://travis-ci.org/sourceryinstitute/OpenCoarrays)
[![Release Downloads][download img]][Releases]
[![Gitter](https://img.shields.io/gitter/room/sourceryinstitute/opencoarrays.svg?style=flat-square)](https://gitter.im/sourceryinstitute/opencoarrays)
[![GitHub license][license img]](./LICENSE)
[![GitHub release][release img]](https://github.com/sourceryinstitute/OpenCoarrays/releases/latest)
[![homebrew](https://img.shields.io/homebrew/v/opencoarrays.svg?style=flat-square)](https://formulae.brew.sh/formula/opencoarrays)
[![Download as PDF][pdf img]](https://md2pdf.herokuapp.com/sourceryinstitute/OpenCoarrays/blob/master/README.pdf)
[![Twitter URL][twitter img]][default tweet]

[Overview](#overview) | [Downloads](#downloads) |
[Compatibility](#compatibility) | [Prerequisites](#prerequisites) |
[Installation](#installation) | [Getting Started](#getting-started) |
[Contributing](#contributing) | [Status](#status)
[Support](#support) | [Acknowledgments](#acknowledgments) | [Donate](#donate)

</div>

Overview
--------

[OpenCoarrays] supports [Fortran 2018] compilers by providing a
parallel application binary interface (ABI) that abstracts away the
underlying parallel programming model, which can be the Message
Passing Interface ([MPI]) or [OpenSHMEM].  Parallel Fortran 2018
programs may be written and compiled into object files once and
then linked or re-linked to either MPI or [OpenSHMEM] without modifying
or recompiling the Fortran source.  Not a single line of source code
need change to switch parallel programming models.  The default
programming model is MPI because it provides the broadest capability
for supporting Fortran 2018  features.  However, having the option to
change parallel programming models at link-time may enhance portability
and performance (see [Rouson et al. (2017)]).

OpenCoarrays provides a compiler wrapper (`caf`), parallel runtime
libraries (`libcaf_mpi` and `libcaf_openshmem`), and a parallel
executable file launcher (`cafrun`).  The wrapper and launcher
provide a uniform abstraction for compiling and executing parallel
Fortran 2018 programs without direct reference to the underlying
parallel programming model.

Downloads
---------

Please see our [Releases] page.

Compatibility
-------------

The GNU Compiler Collection ([GCC]) Fortran front end ([gfortran]) has
used OpenCoarrays since the GCC 5.1.0 release .  Discussions are under
way around incorporating OpenCoarrays into other compilers.

Prerequisites
-------------

Building OpenCoarrays requires

* An MPI implementation (default: [MPICH]).
* CMake.
* A Fortran compiler (default: [GCC]).
* _Optional_: An [OpenSHMEM] implementation.

If you use a package manager or the OpenCoarrays installer, any
missing prerequisites will be built for you.


Installation
------------

Please see the [INSTALL.md] file.

Or [try OpenCoarrays online] as a [Jupyter] [notebook kernel]
using [Binder] with no downloads, configuration or installation required.
The default [index.ipynb] notebook is read only, but you can
execute it, copy it to make changes, or create an entirely
new [CAF kernel][notebook kernel] notebook.

Packaged Version
----------------

If you would like to be able to install OpenCoarrays through your
favorite package manager, please ask them to add it, or contribute it
yourself. If you see your favorite package manager has an outdated
version, please ask them to update it, or contribute an update
yourself.

[![Packaging status][repology-badge]][OC-on-repology]

Getting Started
---------------

To start using OpenCoarrays, please see the [GETTING_STARTED.md] file.

Contributing
------------

Please see the [CONTRIBUTING.md] file.

Status
------

A list of open issues can be viewed on the
[issues page](https://github.com/sourceryinstitute/opencoarrays/issues).

Support
-------

Please submit bug reports and feature requests via our [Issues] page.

Acknowledgments
----------------

We gratefully acknowledge support from the following institutions:

* [Arm] for approving compiler engineer contributions of code.
* [National Center for Atmospheric Research] for access to the
  Yellowstone/Caldera supercomputers and for logistics support during
  the initial development of OpenCoarrays.
* [CINECA] for access to Eurora/PLX for the project HyPS- BLAS under
  the ISCRA grant program for 2014.
* [Google] for support of a related [Google Summer of Code] 2014
  project.
* The National Energy Research Scientific Computing Center ([NERSC]),
  which is supported by the Office of Science of the U.S. Department
  of Energy under Contract No. DE-AC02-05CH11231, for access to the
  Hopper and Edison supercomputers under the OpenCoarrays project
  start allocation.
* [Sourcery, Inc.], for financial support for the domain registration,
  web hosting, advanced development, and conference travel.

Donate
------

If you find this software useful, please consider donating
[your time](CONTRIBUTING.md) or
[your money](http://www.sourceryinstitute.org/store/p5/Donation.html)
to aid in development efforts.

---

<div align="center">

[![GitHub forks](https://img.shields.io/github/forks/sourceryinstitute/OpenCoarrays.svg?style=social&label=Fork)](https://github.com/sourceryinstitute/OpenCoarrays/fork)
[![GitHub stars](https://img.shields.io/github/stars/sourceryinstitute/OpenCoarrays.svg?style=social&label=Star)](https://github.com/sourceryinstitute/OpenCoarrays)
[![GitHub watchers](https://img.shields.io/github/watchers/sourceryinstitute/OpenCoarrays.svg?style=social&label=Watch)](https://github.com/sourceryinstitute/OpenCoarrays)
[![Twitter URL][twitter img]][default tweet]

</div>

[Hyperlinks]:#

[Overview]: #overview
[Downloads]: #downloads
[Compatibility]: #compatibility
[Prerequisites]: #prerequisites
[Installation]: #installation
[Contributing]: #contributing
[Acknowledgments]: #acknowledgments

[Fortran 2018]: https://j3-fortran.org/doc/year/18/18-007r1.pdf 
[Arm]: https://www.arm.com

[OpenSHMEM]: http://www.openshmem.org/site/
[sourcery-institute logo]: http://www.sourceryinstitute.org/uploads/4/9/9/6/49967347/sourcery-logo-rgb-hi-rez-1.png
[OpenCoarrays]: http://www.opencoarrays.org
[ABI]: https://gcc.gnu.org/onlinedocs/gfortran/Coarray-Programming.html#Coarray-Programming
[MPI]: https://www.mpi-forum.org/
[GCC]: https://gcc.gnu.org
[gfortran]: https://gcc.gnu.org/wiki/GFortran
[MPICH]: https://www.mpich.org
[Sourcery, Inc.]: http://www.sourceryinstitute.org
[Google]: https://www.google.com
[CINECA]: https://www.cineca.it/en
[NERSC]: https://www.nersc.gov
[National Center for Atmospheric Research]: https://ncar.ucar.edu
[INSTALL.md]: ./INSTALL.md
[GASNet]: https://gasnet.lbl.gov
[CONTRIBUTING.md]: ./CONTRIBUTING.md
[GETTING_STARTED.md]: ./GETTING_STARTED.md
[Google Summer of Code]: https://www.google-melange.com/archive/gsoc/2014/orgs/gcc

[Issues]: https://github.com/sourceryinstitute/OpenCoarrays/issues
[Releases]: https://github.com/sourceryinstitute/OpenCoarrays/releases

[try OpenCoarrays online]: https://bit.ly/CAF-Binder
[notebook kernel]: https://github.com/sourceryinstitute/jupyter-CAF-kernel
[Binder]: https://mybinder.org
[Jupyter]: https://jupyter.org
[index.ipynb]: https://nbviewer.jupyter.org/github/sourceryinstitute/jupyter-CAF-kernel/blob/master/index.ipynb

[OC-on-repology]: https://repology.org/project/opencoarrays/versions
[repology-badge]: https://repology.org/badge/vertical-allrepos/opencoarrays.svg

[build img]: https://img.shields.io/travis/sourceryinstitute/OpenCoarrays.svg?style=flat-square "Build badge"
[CI Master Branch]: https://travis-ci.org/sourceryinstitute/OpenCoarrays?branch=master "View Travis-CI builds"
[download img]: https://img.shields.io/github/downloads/sourceryinstitute/OpenCoarrays/total.svg?style=flat-square "Download count badge"
[license img]: https://img.shields.io/badge/license-BSD--3-blue.svg?style=flat-square "BSD-3 License badge"
[release img]: https://img.shields.io/github/release/sourceryinstitute/OpenCoarrays.svg?style=flat-square "Latest release badge"
[pdf img]: https://img.shields.io/badge/PDF-README.md-6C2DC7.svg?style=flat-square "Download this readme as a PDF"
[twitter img]: https://img.shields.io/twitter/url/http/shields.io.svg?style=social
[Writing Fortran 2018 Today]: https://www.eventbrite.com/e/writing-fortran-2018-today-object-oriented-parallel-programming-tickets-48982176007
[Rouson et al. (2017)]: http://www.opencoarrays.org/uploads/6/9/7/4/69747895/a4-rouson.pdf

[default tweet]: https://twitter.com/intent/tweet?hashtags=HPC,Fortran,PGAS&related=zbeekman,gnutools,HPCwire,HPC_Guru,hpcprogrammer,SciNetHPC,DegenerateConic,jeffdotscience,travisci&text=Stop%20programming%20w%2F%20the%20%23MPI%20docs%20in%20your%20lap%2C%20try%20Coarray%20Fortran%20w%2F%20OpenCoarrays%20%26%20GFortran!&url=https%3A//github.com/sourceryinstitute/OpenCoarrays

<a name="top"> </a>

[This document is formatted with GitHub-Flavored Markdown.              ]:#
[For better viewing, including hyperlinks, read it online at            ]:#
[https://github.com/sourceryinstitute/OpenCoarrays/blob/master/README.md]:#
<div align="center">

[![Sourcery Institute][sourcery-institute logo]][Sourcery Institute]

OpenCoarrays
============

[![CI Build Status][build img]](https://travis-ci.org/sourceryinstitute/OpenCoarrays)
[![Release Downloads][download img]][Releases]
[![Gitter](https://img.shields.io/gitter/room/sourceryinstitute/opencoarrays.svg?style=flat-square)](https://gitter.im/sourceryinstitute/opencoarrays)
[![GitHub license][license img]](./LICENSE)
[![GitHub release][release img]](https://github.com/sourceryinstitute/OpenCoarrays/releases/latest)
[![homebrew](https://img.shields.io/homebrew/v/opencoarrays.svg?style=flat-square)](https://formulae.brew.sh/formula/opencoarrays)
[![Download as PDF][pdf img]](https://md2pdf.herokuapp.com/sourceryinstitute/OpenCoarrays/blob/master/README.pdf)
[![Twitter URL][twitter img]][default tweet]

[Overview](#overview) | [Downloads](#downloads) |
[Compatibility](#compatibility) | [Prerequisites](#prerequisites) |
[Installation](#installation) | [Getting Started](#getting-started) |
[Contributing](#contributing) | [Status](#status)
[Support](#support) | [Acknowledgments](#acknowledgments) | [Donate](#donate)

</div>

Overview
--------

[OpenCoarrays] supports the GNU Compiler Collection ([GCC]) Fortran compiler
([`gfortran`]) by providing a parallel application binary interface (ABI) that
abstracts away the underlying communication library.  OpenCoarrays thus enables
`gfortran` to support Fortran's parallel programming features, often called
"Coarray Fortran," without making direct reference to the back-end communication
library: the Message Passing Interface (MPI).  This ensures that Fortran
programs and Fortran compilers may take advantage of other communication
libraries without costly refactoring.  Work is underway on the [Caffeine]
project to support alternative communication libraries and alternative compilers
by defining a compiler-independent parallel ABI atop the [GASNet-EX] exascale
networking middleware.

OpenCoarrays provides a compiler wrapper (`caf`), a parallel runtime library
(`libcaf_mpi`), and a program launcher (`cafrun`).  The wrapper and launcher
provide a uniform abstraction for compiling and executing Coarray Fortran
without direct reference to the underlying MPI layer.

Downloads
---------

Please see our [Releases] page.

Compatibility
-------------

The OpenCoarrays ABI was adopted by `gfortran` in release the GCC 5.1.0 release
and `gfortran` continues to work with OpenCoarrays as of this writing.  

Prerequisites
-------------

Building OpenCoarrays requires

* An MPI implementation,
* CMake, and
* The GCC C and Fortran compilers: `gcc` and `gfortran`.

If you use a package manager or the OpenCoarrays installer, any missing
prerequisites will be built for you.


Installation
------------

Please see the [INSTALL.md] file.

Or [try OpenCoarrays online] as a [Jupyter] [notebook kernel]
using [Binder] with no downloads, configuration or installation required.
The default [index.ipynb] notebook is read only, but you can
execute it, copy it to make changes, or create an entirely
new [CAF kernel][notebook kernel] notebook.

Packaged Version
----------------

If you would like to be able to install OpenCoarrays through your
favorite package manager, please ask them to add it, or contribute it
yourself. If you see your favorite package manager has an outdated
version, please ask them to update it, or contribute an update
yourself.

[![Packaging status][repology-badge]][OC-on-repology]

Getting Started
---------------

To start using OpenCoarrays, please see the [GETTING_STARTED.md] file.

Contributing
------------

Please see the [CONTRIBUTING.md] file.

Status
------

A list of open issues can be viewed on the
[issues page](https://github.com/sourceryinstitute/opencoarrays/issues).

Support
-------

Please submit bug reports and feature requests via our [Issues] page.

Acknowledgments
----------------

We gratefully acknowledge support from the following institutions:

* The U.S. Nuclear Regulatory Commission ([NRC]) for funding the work that led to support for
  - the Windows operating system, 
  - the `random_init` subroutine, and 
  - `co_broadcast` of derived-type objects with `allocatable` components.
* The National Aeronautics and Space Administration [NASA] for funding the work that led to
  support for the `co_broadcast` of derived-type objects.
* [Arm] for approving compiler engineer contributions of code.
* [National Center for Atmospheric Research] for access to the
  Yellowstone/Caldera supercomputers and for logistics support during
  the initial development of OpenCoarrays.
* [CINECA] for access to Eurora/PLX for the project HyPS- BLAS under
  the ISCRA grant program for 2014.
* [Google] for support of a related [Google Summer of Code] 2014
  project.
* The National Energy Research Scientific Computing Center ([NERSC]),
  which is supported by the Office of Science of the U.S. Department
  of Energy under Contract No. DE-AC02-05CH11231, for access to the
  Hopper and Edison supercomputers under the OpenCoarrays project
  start allocation.
* [Archaeologic Inc.] for financial support for the domain registration,
  web hosting, advanced development, and conference travel.

Donate
------

If you find this software useful, please consider donating
[your time](CONTRIBUTING.md) or
[your money](http://www.sourceryinstitute.org/store/p5/Donation.html)
to aid in development efforts.

---

<div align="center">

[![GitHub forks](https://img.shields.io/github/forks/sourceryinstitute/OpenCoarrays.svg?style=social&label=Fork)](https://github.com/sourceryinstitute/OpenCoarrays/fork)
[![GitHub stars](https://img.shields.io/github/stars/sourceryinstitute/OpenCoarrays.svg?style=social&label=Star)](https://github.com/sourceryinstitute/OpenCoarrays)
[![GitHub watchers](https://img.shields.io/github/watchers/sourceryinstitute/OpenCoarrays.svg?style=social&label=Watch)](https://github.com/sourceryinstitute/OpenCoarrays)
[![Twitter URL][twitter img]][default tweet]

</div>

[Hyperlinks]:#

[Overview]: #overview
[Downloads]: #downloads
[Compatibility]: #compatibility
[Prerequisites]: #prerequisites
[Installation]: #installation
[Contributing]: #contributing
[Acknowledgments]: #acknowledgments

[Arm]: https://www.arm.com

[OpenSHMEM]: http://www.openshmem.org/site/
[sourcery-institute logo]: http://www.sourceryinstitute.org/uploads/4/9/9/6/49967347/sourcery-logo-rgb-hi-rez-1.png
[OpenCoarrays]: http://www.opencoarrays.org
[ABI]: https://gcc.gnu.org/onlinedocs/gfortran/Coarray-Programming.html#Coarray-Programming
[MPI]: https://www.mpi-forum.org/
[GCC]: https://gcc.gnu.org
[`gfortran`]: https://gcc.gnu.org/wiki/GFortran
[MPICH]: https://www.mpich.org
[Sourcery Institute]: http://www.sourceryinstitute.org
[Google]: https://www.google.com
[CINECA]: https://www.cineca.it/en
[NERSC]: https://www.nersc.gov
[National Center for Atmospheric Research]: https://ncar.ucar.edu
[INSTALL.md]: ./INSTALL.md
[GASNet]: https://gasnet.lbl.gov
[CONTRIBUTING.md]: ./CONTRIBUTING.md
[GETTING_STARTED.md]: ./GETTING_STARTED.md
[Google Summer of Code]: https://www.google-melange.com/archive/gsoc/2014/orgs/gcc

[Issues]: https://github.com/sourceryinstitute/OpenCoarrays/issues
[Releases]: https://github.com/sourceryinstitute/OpenCoarrays/releases

[try OpenCoarrays online]: https://bit.ly/CAF-Binder
[notebook kernel]: https://github.com/sourceryinstitute/jupyter-CAF-kernel
[Binder]: https://mybinder.org
[Jupyter]: https://jupyter.org
[index.ipynb]: https://nbviewer.jupyter.org/github/sourceryinstitute/jupyter-CAF-kernel/blob/master/index.ipynb

[OC-on-repology]: https://repology.org/project/opencoarrays/versions
[repology-badge]: https://repology.org/badge/vertical-allrepos/opencoarrays.svg

[build img]: https://img.shields.io/travis/sourceryinstitute/OpenCoarrays.svg?style=flat-square "Build badge"
[CI Master Branch]: https://travis-ci.org/sourceryinstitute/OpenCoarrays?branch=master "View Travis-CI builds"
[download img]: https://img.shields.io/github/downloads/sourceryinstitute/OpenCoarrays/total.svg?style=flat-square "Download count badge"
[license img]: https://img.shields.io/badge/license-BSD--3-blue.svg?style=flat-square "BSD-3 License badge"
[release img]: https://img.shields.io/github/release/sourceryinstitute/OpenCoarrays.svg?style=flat-square "Latest release badge"
[pdf img]: https://img.shields.io/badge/PDF-README.md-6C2DC7.svg?style=flat-square "Download this readme as a PDF"
[twitter img]: https://img.shields.io/twitter/url/http/shields.io.svg?style=social
[NRC]: https://www.nrc.gov
[NASA]: https://www.nasa.gov
[Caffeine]: https://go.lbl.gov/caffeine
[Archaeologic Inc.]: https://www.archaeologic.codes
[GASNet-EX]: https://go.lbl.gov/gasnet

[default tweet]: https://twitter.com/intent/tweet?hashtags=HPC,Fortran,PGAS&related=zbeekman,gnutools,HPCwire,HPC_Guru,hpcprogrammer,SciNetHPC,DegenerateConic,jeffdotscience,travisci&text=Stop%20programming%20w%2F%20the%20%23MPI%20docs%20in%20your%20lap%2C%20try%20Coarray%20Fortran%20w%2F%20OpenCoarrays%20%26%20GFortran!&url=https%3A//github.com/sourceryinstitute/OpenCoarrays

<a name="top"> </a>

[This document is formatted with GitHub-Flavored Markdown.              ]:#
[For better viewing, including hyperlinks, read it online at            ]:#
[https://github.com/sourceryinstitute/opencoarrays/blob/master/README.md]:#

OpenCoarrays
============

[![CI Build Status][build img]](https://travis-ci.org/sourceryinstitute/opencoarrays)
[![GitHub license][license img]](./LICENSE)
[![Download as PDF][pdf img]](http://md2pdf.herokuapp.com/sourceryinstitute/opencoarrays/blob/master/README.pdf)
<!-- [![GitHub release][release img]](https://github.com/sourceryinstitute/opencoarrays/releases/latest) -->
<!-- [![Release Downloads][download img]](https://github.com/sourceryinstitute/opencoarrays/releases) -->

Download this file as a PDF document [here](http://md2pdf.herokuapp.com/sourceryinstitute/opencoarrays/blob/master/README.pdf).

* [Overview](#overview)
* [Downloads](#downloads)
* [Compatibility](#compatibility)
* [Prerequisites](#prerequisites)
* [Installation](#installation)
* [Getting Started](#getting-started)
* [Contributing](#contributing)
* [Status](#status)
* [Support](#support)
* [Acknowledgements](#acknowledgements)

Overview
--------
[OpenCoarrays] is an open-source software project that supports the coarray Fortran (CAF) parallel programming features of the Fortran 2008 standard and several features proposed for Fortran 2015 in the draft Technical Specification [TS 18508] _Additional Parallel Features in Fortran_.

OpenCoarrays provides a compiler wrapper (named `caf`), a runtime library (named `libcaf_mpi.a` by default), and an executable file launcher (named `cafrun`).  With OpenCoarrays-aware compilers, the compiler wrapper passes the provided source code to the chosen compiler (`mpif90` by default).  For non-OpenCoarrays-aware compilers, the wrapper transforms CAF syntax into OpenCoarrys procedure calls before invoking the chosen compiler on the transformed code.  The runtime library supports compiler communication and synchronization requests by invoking a lower-level communication library--the Message Passing Interface ([MPI]) by default.  The launcher passes execution to the chosen communication library's parallel program launcher (`mpirun` by default).

OpenCoarrays defines an application binary interface ([ABI]) that translates high-level communication and synchronization requests into low-level calls to a user-specified communication library.  This design decision liberates compiler teams from hardwiring communication-library choice into their compilers and it frees Fortran programmers to express parallel algorithms once and reuse identical CAF source with whichever communication library is most efficient for a given hardware platform.  The communication substrate for OpenCoarrays built with the preferred build system, CMake, is the Message Passing Interface ([MPI]).

OpenCoarrays enables CAF application developers to express parallel algorithms without hardwiring a particular version of a particular communication library or library version into their codes.  Such abstraction makes application code less sensitive to the evolution of the underlying communication libraries and hardware platforms.

Downloads
---------
<!--[![Release Downloads][download img]](https://github.com/sourceryinstitute/opencoarrays/releases/latest)-->

Please see our [Releases] page.

Compatibility
-------------
The GNU Compiler Collection ([GCC]) Fortran front end ([gfortran]) is OpenCoarrays-aware for release versions 5.1.0 and higher.  Users of other compilers, including earlier versions of gfortran, can access a limited subset of CAF features via the provided [opencoarrays module].  After installation, please execute the `caf` script (which is installed in the `bin` directory of the installation path) with no arguments to see a list of the corresponding limitations.  Please also notify the corresponding compiler vendor and the OpenCoarrays team that you would like for a future version of the compiler to be OpenCoarrays-aware.

Prerequisites
-------------
We expect our LIBCAF_MPI library to be the default OpenCoarrays library.  LIBCAF_MPI is the most straightforward to install and use, the most robust in terms of its internal complexity, and the most frequently updated and maintained.  Building LIBCAF_MPI requires prior installation of an MPI implementation.  We recommend [MPICH] generally or, if available, [MVAPICH] for better performance. [OpenMPI] is another option.

We offer an unsupported LIBCAF_GASNet alternative.  We intend for LIBCAF_GASNet to be an "expert" alternative capable of outperforming MPI for some applications on some platforms.  LIBCAF_GASNet requires greater care to configure and use and building LIBCAF_GASNet requires prior installation of [GASNet].

Installation
------------

Please see the [INSTALL.md] file.

Getting Started
---------------

To start using OpenCoarrays, please see the [GETTING_STARTED.md] file.

Contributing
------------

Please see the [CONTRIBUTING.md] file.

Status
------

Please see the [STATUS.md] file.

Support
-------

* Please submit bug reports and feature requests via our [Issues] page.
* Please submit questions regarding installation and use via our [Google Group] by signing into [Google Groups] or [subscribing] and sending email to [opencoarrays@googlegroups.com].

Acknowledgements
----------------
We gratefully acknowledge support from the following institutions:

* [National Center for Atmospheric Research] for access to the Yellowstone/Caldera supercomputers and for logistics support during the initial development of OpenCoarrays.
* [CINECA] for access to Eurora/PLX for the project HyPS- BLAS under the ISCRA grant program for 2014.
* [Google] for support of a related [Google Summer of Code] 2014 project.
* The National Energy Research Scientific Computing Center ([NERSC]), which is supported by the Office of Science of the U.S. Department of Energy under Contract No. DE-AC02-05CH11231, for access to the Hopper and Edison supercomputers under the OpenCoarrays project start allocation.
* [Sourcery, Inc.], for financial support for the domain registration, web hosting, advanced development, and conference travel.

[Hyperlinks]:#

[Overview]: #overview
[Downloads]: #downloads
[Compatibility]: #compatibility
[Prerequisites]: #prerequisites
[Installation]: #installation
[Contributing]: #contributing
[Acknowledgements]: #acknowledgements


[OpenCoarrays]: http://www.opencoarrays.org
[ABI]: https://gcc.gnu.org/onlinedocs/gfortran/Coarray-Programming.html#Coarray-Programming
[TS 18508]: http://isotc.iso.org/livelink/livelink?func=ll&objId=16769292&objAction=Open
[MPI]: http://www.mpi-forum.org
[GCC]: http://gcc.gnu.org
[gfortran]: https://gcc.gnu.org/wiki/GFortran
[opencoarrays module]: ./src/extensions/opencoarrays.F90
[MPICH]: http://www.mpich.org
[MVAPICH]: http://mvapich.cse.ohio-state.edu/)
[OpenMPI]: http://www.open-mpi.org
[Sourcery, Inc.]: http://www.sourceryinstitute.org
[Google]: http://google.com
[CINECA]: http://www.cineca.it/en
[NERSC]: http://www.nersc.gov
[National Center for Atmospheric Research]: http://ncar.ucar.edu
[INSTALL.md]: ./INSTALL.md
[GASNet]: http://gasnet.lbl.gov
[CONTRIBUTING.md]: ./CONTRIBUTING.md
[STATUS.md]: ./STATUS.md
[GETTING_STARTED.md]: ./GETTING_STARTED.md
[Google Groups]: https://groups.google.com
[Google Group]: https://groups.google.com/forum/#!forum/opencoarrays
[subscribing]: https://groups.google.com/forum/#!forum/opencoarrays/join
[opencoarrays@googlegroups.com]: mailto:opencoarrays@googlegroups.com
[Google Summer of Code]: https://www.google-melange.com/gsoc/org2/google/gsoc2014/gcc
[OpenCoarrays Google Group]: https://groups.google.com/forum/#!forum/opencoarrays)
[Issues]: https://github.com/sourceryinstitute/opencoarrays/issues
[Releases]: https://github.com/sourceryinstitute/opencoarrays/releases

[build img]: https://img.shields.io/travis-ci/sourceryinstitute/opencoarrays/master.svg?style=flat-square "View Travis-CI builds"
[CI Master Branch]: https://travis-ci.org/sourceryinstitute/opencoarrays?branch=master "View Travis-CI builds"
[download img]: https://img.shields.io/github/downloads/sourceryinstitute/opencoarrays/total.svg?style=flat-square "Download count image source"
[license img]: https://img.shields.io/badge/License-BSD--3-blue.svg?style=flat-square "View BSD-3 License"
[release img]: https://img.shields.io/github/release/sourceryinstitute/opencoarrays.svg?style=flat-square "View latest release"
[pdf img]: https://img.shields.io/badge/PDF-README.md-6C2DC7.svg?style=flat-square "Download as PDF"

OpenCoarrays Runtime Libraries
==============================

One original goal of the OpenCoarrays project was to provide a transparent application binary interface (ABI) supported by interchangeable parallel runtime libraries based on a range of communication libraries.  The following header files in this directory define that ABI:

* libcaf.h
* libcaf-gfortran-descriptor.h
* libcaf-version-def.h: 

where the above files are in dependency order: each file depends on the file(s) listed below it.  The [runtime-libraries](./runtime-libraries) subdirectory contains runtimes based on the following communication libraries:

* Message Passing Interface (MPI)
* OpenSHMEM
* GASNet

We currently maintain, build, and test only the MPI runtime.  The GASNet and OpenSHMEM runtime library source code serve only to provide detailed, open-source documentation of the research described by [Fanfarillo et al. (2014)] and [Rouson et al. (2017)].  For a Fortran 2018 parallel runtime library based on the more recent GASNet-EX exascale networking middleware described by [Bonachea and Hargrove (2018)], please see the [Caffeine] repository.

One exception regarding the transparent nature of the ABI is the [opencoarrays module], which provides a public function that returns the underlying MPI communicator. This capability can be useful for using coarray Fortran to drive an ensemble of simulations using pre-existing MPI as described in [Rouson, McCreight, and Fanfarillo (2017)].

[Fanfarillo et al. (2014)]: http://dx.doi.org/10.1145/2676870.2676876
[Rouson et al. (2017)]: https://doi.org/10.1145/3144779.3169104
[Bonachea and Hargrove (2018)]: https://doi.org/10.25344/S4QP4W
[Caffeine]: https://go.lbl.gov/caffeine
[opencoarrays module]: ./runtime-libraries/mpi/opencoarrays.F90
[Rouson, McCreight, and Fanfarillo (2017)]: https://doi.org/10.1145/3144779.3169110

[This document is formatted with GitHub-Flavored Markdown.   ]:#
[For better viewing, including hyperlinks, read it online at ]:#
[https://github.com/sourceryinstitute/opencoarrays/edit/master/src/tests/integration/pde_solvers/README.txt]:#

Partial Differential Equation (PDE) Solvers
===========================================

This directory contains three PDE solvers listed here in order from simplest to most complex:

* A one-dimensional (1D) finite-difference, unsteady [heat equation solver],
* A 1D finite-difference, unsteady, nonlinear [Burgers equation solver], and
* A three-dimensional (3D), unsteady, spectral [Navier-Stokes equation solver].

The first two solvers contain correctness checks that result in the printing of the 
message "Test passed" before terminating a correct execution.  For more details on the 
heat equation solver please view the [Sourcery Institute] [tutorial videos] online.  

For more details on the Burgers solver, please see Chapter 12 of the textbook 
[Scientific Sofware Design] or the open-access journal article 
"[High Performance Design Patterns for Modern Fortran]."  The [coarrayBurgers] 
subdirectory includes a [run.sh] launch script that works inside the open-source 
Linux virtual machine available in the Sourcery Institute [store].

The launch script instruments the Burgers solver for performance analysis using the 
open-source Tuning and Analysis Utilities ([TAU]) package.  The instrumented Burgers 
solver has been demonstrated to execute with 87% parallel efficiency on 16,384
cores in weak scaling when compiled with the Cray Compiler Environment.  For
new scalabiliby studies, it is important to run problems of sufficient size.  For
performance and complexity comparisons, an MPI version of the Burgers solver is
in the [performance] directory at the same level as the current directory.

The Navier-Stokes solver uses Fourier-spectral methods and Runge-Kutta time advancement
to simulate the evolution of statistically homogeneous turbulent flow in a 3D box with 
periodic boundary conditions.  For performance and complexity comparisons, the 
[navier-stokes] subdirectory contains both a  Message Passing Interface (MPI) version 
and a coarray Fortran (CAF) version of the same solution algorithm.

[heat equation solver]: ./coarrayHeatSimplified
[Burgers equation solver]: ./coarrayBurgers
[Navier-Stokes equation solver]: ./navier-stokes
[Sourcery Institute]: http://www.sourceryinstitute.org
[tutorial videos]: http://www.sourceryinstitute.org/videos
[Scientific Sofwtware Design]: http://www.cambridge.org/rouson
[High Performance Design Patterns for Modern Fortran]: http://www.hindawi.com/journals/sp/2015/942059/
[store]: http://www.sourceryinstitute.org/store
[coarrayBurgers]: ./coarrayBurgers
[run.sh]: ./coarrayBurgers/run.sh
[TAU]: http://tau.uoregon.edu
[navier-stokes]: ./navier-stokes
[performance]: ../../performance

[This document is formatted with GitHub-Flavored Markdown.   ]:#
[For better viewing, including hyperlinks, read it online at ]:#
[https://github.com/sourceryinstitute/OpenCoarrays/edit/master/src/tests/integration/pde_solvers/README.txt]:#

Partial Differential Equation (PDE) Solvers
===========================================

This directory contains three PDE solvers listed here in order from simplest to most complex:

* A one-dimensional (1D) finite-difference, unsteady [heat equation solver],
* A 1D finite-difference, unsteady, nonlinear [Burgers equation solver], and
* A three-dimensional (3D), unsteady, spectral [Navier-Stokes equation solver].

The first two solvers contain correctness checks that result in the printing of the 
message "Test passed" before terminating a correct execution.  For more details on the 
heat equation solver please view the [Sourcery Institute] [tutorial videos] online.  

For more details on the Burgers solver, please see Chapter 12 of the textbook 
[Scientific Sofware Design] or the open-access journal article 
"[High Performance Design Patterns for Modern Fortran]."  The [coarrayBurgers] 
subdirectory includes a [run.sh] launch script that works inside the open-source 
Linux virtual machine available in the Sourcery Institute [store].

The launch script instruments the Burgers solver for performance analysis using the 
open-source Tuning and Analysis Utilities ([TAU]) package.  The instrumented Burgers 
solver has been demonstrated to execute with 87% parallel efficiency on 16,384
cores in weak scaling when compiled with the Cray Compiler Environment.  For
new scalabiliby studies, it is important to run problems of sufficient size.  For
performance and complexity comparisons, an MPI version of the Burgers solver is
in the [performance] directory at the same level as the current directory.

The Navier-Stokes solver uses Fourier-spectral methods and Runge-Kutta time advancement
to simulate the evolution of statistically homogeneous turbulent flow in a 3D box with 
periodic boundary conditions.  For performance and complexity comparisons, the 
[navier-stokes] subdirectory contains both a  Message Passing Interface (MPI) version 
and a coarray Fortran (CAF) version of the same solution algorithm.

[heat equation solver]: ./coarrayHeatSimplified
[Burgers equation solver]: ./coarrayBurgers
[Navier-Stokes equation solver]: ./navier-stokes
[Sourcery Institute]: http://www.sourceryinstitute.org
[tutorial videos]: http://www.sourceryinstitute.org/videos
[Scientific Sofwtware Design]: http://www.cambridge.org/rouson
[High Performance Design Patterns for Modern Fortran]: http://www.hindawi.com/journals/sp/2015/942059/
[store]: http://www.sourceryinstitute.org/store
[coarrayBurgers]: ./coarrayBurgers
[run.sh]: ./coarrayBurgers/run.sh
[TAU]: http://tau.uoregon.edu
[navier-stokes]: ./navier-stokes
[performance]: ../../performance

! Copyright (c) 2012-2016, Sourcery, Inc.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of Sourcery, Inc., nor the
!       names of any other contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

! Unit tests for co_sum
program main
  use iso_fortran_env, only : error_unit
  use iso_c_binding, only : c_int,c_double
#ifdef USE_EXTENSIONS
  use opencoarrays
#endif
  implicit none
  logical :: co_sum_c_int_verified=.false.,co_sum_c_double_verified=.false.

#ifdef USE_EXTENSIONS
  if (this_image()==1) print *,"Using the extensions from the opencoarrays module."
#endif

  ! Verify collective sum of integer data by tallying image numbers
  c_int_co_sum: block
    integer(c_int) :: i,me
    me=this_image()
    sync all
    call co_sum(me)
    if (me==sum([(i,i=1,num_images())])) then
      co_sum_c_int_verified=.true.
    else
      write(error_unit,"(2(a,i2))") "co_broadcast with integer(c_int) argument fails with result (",me,") on image",this_image()
    end if
  end block c_int_co_sum

  ! Verify collective sum by calculuating pi
  c_double_co_sum: block
    real(c_double), parameter :: four=4._c_double,one=1._c_double,half=0.5_c_double
    real(c_double), save :: pi
    integer(c_int) :: i,points_per_image
    integer(c_int), parameter :: resolution=1024_c_int ! Number of points used in pi calculation
    integer(c_int) :: me
    me=this_image()
    ! Partition the calculation evenly across all images
    if (mod(resolution,num_images())/=0) then
      write(error_unit,"(a)") "number of images doesn't evenly divide into number of points"
      error stop
    end if
    points_per_image=resolution/num_images()
    associate(n=>resolution,my_first=>points_per_image*(me-1)+1,my_last=>points_per_image*me)
      pi = sum([ (four/(one+((i-half)/n)**2),i=my_first,my_last) ])/n
    end associate
    sync all
    ! Replace pi on each image with the sum of the pi contributions from all images
    call co_sum(pi)
    associate (pi_ref=>acos(-1._c_double),allowable_fractional_error=>0.000001_c_double)
      if (abs((pi-pi_ref)/pi_ref)<=allowable_fractional_error) then
        co_sum_c_double_verified=.true.
      else
        write(error_unit,*) "co_broadcast with real(c_double) argument fails with result (",pi,") result on image ",me
      end if
    end associate
  end block c_double_co_sum

  if (.not. all([co_sum_c_int_verified,co_sum_c_double_verified])) error stop
  ! Wait for every image to pass
  sync all
  if (this_image()==1) print *, "Test passed."
end program

! Copyright (c) 2011, Damian Rouson, Jim Xia, and Xiaofeng Xu.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the names of Damian Rouson, Jim Xia, and Xiaofeng Xu nor the
!       names of any other contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL DAMIAN ROUSON, JIM XIA, and XIAOFENG XU BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

module kind_parameters       ! Type kind parameter
  implicit none
  private
  public :: rkind,ikind,ckind
  integer ,parameter :: digits=8  ! num. digits of kind
  integer ,parameter :: decades=9 ! num. representable decades
  integer ,parameter :: rkind = selected_real_kind(digits)
  integer ,parameter :: ikind = selected_int_kind(decades)
  integer ,parameter :: ckind = selected_char_kind('default')
end module

! Coarray Distributed Transpose Test
!
! Copyright (c) 2012-2014, Sourcery, Inc.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of the Sourcery, Inc., nor the
!       names of its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE FOR ANY
! DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
!
! Robodoc header:
!****m* dist_transpose/run_size
! NAME
!   run_size
!  SYNOPSIS
!   Encapsulate problem state, wall-clock timer interface, integer broadcasts, and a data copy.
!******
!==================  test transposes with integer x,y,z values  ===============================
module run_size
    use iso_fortran_env
#ifndef HAVE_WALLTIME
    use MPI, only : WALLTIME=>MPI_WTIME
#endif
    implicit none
        integer(int64), codimension[*] :: nx, ny, nz
        integer(int64), codimension[*] :: my, mx, first_y, last_y, first_x, last_x
        integer(int64) :: my_node, num_nodes
        real(real64), codimension[*] :: tran_time

#ifdef HAVE_WALLTIME
interface
   function WALLTIME() bind(C, name = "WALLTIME")
   use iso_fortran_env
       real(real64) :: WALLTIME
   end function WALLTIME
end interface
#endif

contains

!****s* run_size/broadcast_int
! NAME
!   broadcast_int
!  SYNOPSIS
!   Broadcast a scalar coarray integer from image 1 to all other images.
!******
    subroutine broadcast_int( variable )
        integer(int64), codimension[*] :: variable
        integer(int64) :: i
        if( my_node == 1 ) then
            do i = 2, num_nodes;    variable[i] = variable;      end do
        end if
    end subroutine broadcast_int

subroutine copy3( A,B, n1, sA1, sB1, n2, sA2, sB2, n3, sA3, sB3 )
  implicit none
  complex, intent(in)  :: A(0:*)
  complex, intent(out) :: B(0:*)
  integer(int64), intent(in) :: n1, sA1, sB1
  integer(int64), intent(in) :: n2, sA2, sB2
  integer(int64), intent(in) :: n3, sA3, sB3
  integer(int64) i,j,k

  do k=0,n3-1
     do j=0,n2-1
        do i=0,n1-1
           B(i*sB1+j*sB2+k*sB3) = A(i*sA1+j*sA2+k*sA3)
        end do
     end do
  end do
end subroutine copy3

end module run_size

!****e* dist_transpose/coarray_distributed_transpose
! NAME
!   coarray_distributed_transpose
! SYNOPSIS
!   This program tests the transpose routines used in Fourier-spectral simulations of homogeneous turbulence.
!   The data is presented to the physics routines as groups of y-z or x-z planes distributed among the images.
!   The (out-of-place) transpose routines do the x <--> y transposes required and consist of transposes within
!   data blocks (intra-image) and a transpose of the distribution of these blocks among the images (inter-image).
!
!   Two methods are tested here:
!   RECEIVE: receive block from other image and transpose it
!   SEND:    transpose block and send it to other image
!
!   This code is the coarray analog of mpi_distributed_transpose.
!******

program coarray_distributed_transpose
  !(***********************************************************************************************************
  !                   m a i n   p r o g r a m
  !***********************************************************************************************************)
      use run_size
      implicit none

      complex, allocatable ::  u(:,:,:,:)[:]    ! u(nz,4,first_x:last_x,ny)[*]    !(*-- ny = my * num_nodes --*)
      complex, allocatable ::  ur(:,:,:,:)[:]   !ur(nz,4,first_y:last_y,nx/2)[*]  !(*-- nx/2 = mx * num_nodes --*)
      complex, allocatable :: bufr_X_Y(:,:,:,:)
      complex, allocatable :: bufr_Y_X(:,:,:,:)
      integer(int64) :: x, y, z, msg_size, iter

      num_nodes = num_images()
      my_node = this_image()

      if( my_node == 1 ) then
           !write(6,*) "nx,ny,nz : ";      read(5,*) nx, ny, nz
            nx=32; ny=32; nz=32
            call broadcast_int( nx );        call broadcast_int( ny );        call broadcast_int( nz );
       end if
      sync all  !-- other nodes wait for broadcast!


      if ( mod(ny,num_nodes) == 0)  then;   my = ny / num_nodes
                                    else;   write(6,*) "node ", my_node, " ny not multiple of num_nodes";     error stop
      end if

      if ( mod(nx/2,num_nodes) == 0)  then;   mx = nx/2 / num_nodes
                                    else;   write(6,*) "node ", my_node, "nx/2 not multiple of num_nodes";     error stop
      end if

      first_y = (my_node-1)*my + 1;   last_y  = (my_node-1)*my + my
      first_x = (my_node-1)*mx + 1;   last_x  = (my_node-1)*mx + mx

      allocate (  u(nz , 4 , first_x:last_x , ny)  [*] )   !(*-- y-z planes --*)
      allocate ( ur(nz , 4 , first_y:last_y , nx/2)[*] )   !(*-- x-z planes --*)
      allocate ( bufr_X_Y(nz,4,mx,my) )
      allocate ( bufr_Y_X(nz,4,my,mx) )

      msg_size = nz*4*mx*my     !-- message size (complex data items)

!---------  initialize data u (mx y-z planes per image) ----------

        do x = first_x, last_x
            do y = 1, ny
                do z = 1, nz
                    u(z,1,x,y) = x
                    u(z,2,x,y) = y
                    u(z,3,x,y) = z
                end do
            end do
        end do

    tran_time = 0
    do iter = 1, 2  !--- 2 transform pairs per second-order time step

!---------  transpose data u -> ur (mx y-z planes to my x-z planes per image)  --------

      ur = 0

      call transpose_X_Y

!--------- test data ur (my x-z planes per image) ----------

        do x = 1, nx/2
            do y = first_y, last_y
                do z = 1, nz
                    if ( real(ur(z,1,y,x)) /= x .or. real(ur(z,2,y,x)) /= y .or. real(ur(z,3,y,x)) /= z )then
                        write(6,fmt="(A,i3,3(6X,A,f7.3,i4))") "transpose_X_Y failed:  image ", my_node &
                            , " X ",real(ur(z,1,y,x)),x, "  Y ",real(ur(z,2,y,x)),y, "  Z ", real(ur(z,3,y,x)),z
                        stop
                    end if
                end do
            end do
        end do

!---------  transpose data ur -> u (my x-z planes to mx y-z planes per image)  --------

      u = 0
      call transpose_Y_X

!--------- test data u (mx y-z planes per image) ----------

        do x = first_x, last_x
            do y = 1, ny
                do z = 1, nz
                    if ( real(u(z,1,x,y)) /= x .or. real(u(z,2,x,y)) /= y .or. real(u(z,3,x,y)) /= z )then
                        write(6,fmt="(A,i3,3(6X,A,f7.3,i4))") "transpose_Y_X failed:  image ", my_node &
                            , " X ",real(u(z,1,x,y)),x, "  Y ",real(u(z,2,x,y)),y, "  Z ", real(u(z,3,x,y)),z
                        stop
                    end if
                end do
            end do
        end do
    end do

        sync all
        if( my_node == 1 )  write(6,fmt="(A,f8.3)")  "test passed:  tran_time ", tran_time

    deallocate ( bufr_X_Y );    deallocate ( bufr_Y_X )

!=========================   end of main executable  =============================

contains

!-------------   out-of-place transpose data_s --> data_r  ----------------------------

 subroutine transpose_X_Y

    use run_size
    implicit none

    integer(int64) :: i,stage

    sync all   !--  wait for other nodes to finish compute
    tran_time = tran_time - WALLTIME()

    call copy3 (    u(1,1,first_x,1+(my_node-1)*my) &                   !-- intra-node transpose
                ,  ur(1,1,first_y,1+(my_node-1)*mx) &                   !-- no inter-node transpose needed
                ,   nz*3, 1_8, 1_8        &                                 !-- note: only 3 of 4 words needed
                ,   mx, nz*4, nz*4*my &
                ,   my, nz*4*mx, nz*4 )

#define RECEIVE
#ifdef RECEIVE

    do stage = 1, num_nodes-1
        i = 1 + mod( my_node-1+stage, num_nodes )
        bufr_X_Y(:,:,:,:) = u(:,:,:,1+(my_node-1)*my:my_node*my)[i]         !-- inter-node transpose to buffer
        call copy3 ( bufr_X_Y, ur(1,1,first_y,1+(i-1)*mx)  &                !-- intra-node transpose from buffer
                        ,   nz*3, 1_8, 1_8        &                             !-- note: only 3 of 4 words needed
                        ,   mx, nz*4, nz*4*my &
                        ,   my, nz*4*mx, nz*4 )
    end do

#else

    do stage = 1, num_nodes-1
        i = 1 + mod( my_node-1+stage, num_nodes )
        call  copy3 ( u(1,1,first_x,1+(i-1)*my), bufr_Y_X   &        !-- intra-node transpose to buffer
                    ,   nz*3, 1_8, 1_8        &
                    ,   mx, nz*4, nz*4*my &
                    ,   my, nz*4*mx, nz*4 )
        ur(:,:,:,1+(my_node-1)*mx:my_node*mx)[i] = bufr_Y_X(:,:,:,:)        !-- inter-node transpose from buffer
    end do

#endif

    sync all     !--  wait for other nodes to finish transpose
    tran_time = tran_time + WALLTIME()

 end  subroutine transpose_X_Y

!-------------   out-of-place transpose data_r --> data_s  ----------------------------

subroutine transpose_Y_X
    use run_size
    implicit none

    integer(int64) :: i, stage

    sync all   !--  wait for other nodes to finish compute
    tran_time = tran_time - WALLTIME()

    call copy3 (   ur(1,1,first_y,1+(my_node-1)*mx) &                   !-- intra-node transpose
                ,   u(1,1,first_x,1+(my_node-1)*my) &                   !-- no inter-node transpose needed
                ,   nz*4, 1_8, 1_8        &                                 !-- note: all 4 words needed
                ,   my, nz*4, nz*4*mx &
                ,   mx, nz*4*my, nz*4 )

#define RECEIVE
#ifdef RECEIVE

    do stage = 1, num_nodes-1
        i = 1 + mod( my_node-1+stage, num_nodes )
        bufr_Y_X(:,:,:,:) = ur(:,:,:,1+(my_node-1)*mx:my_node*mx)[i]        !-- inter-node transpose to buffer
        call copy3 ( bufr_Y_X, u(1,1,first_x,1+(i-1)*my)  &                 !-- intra-node transpose from buffer
                    ,   nz*4, 1_8, 1_8        &
                    ,   my, nz*4, nz*4*mx &
                    ,   mx, nz*4*my, nz*4 )
    end do

#else

    do stage = 1, num_nodes-1
        i = 1 + mod( my_node-1+stage, num_nodes )
        call copy3 ( ur(1,1,first_y,1+(i-1)*mx), bufr_X_Y  &                 !-- intra-node transpose from buffer
                    ,   nz*4, 1_8, 1_8        &
                    ,   my, nz*4, nz*4*mx &
                    ,   mx, nz*4*my, nz*4 )
        u(:,:,:,1+(my_node-1)*my:my_node*my)[i] = bufr_X_Y(:,:,:,:)        !-- inter-node transpose from buffer
    end do

#endif

    sync all     !--  wait for other nodes to finish transpose
    tran_time = tran_time + WALLTIME()

 end  subroutine transpose_Y_X


end program coarray_distributed_transpose

program co_reduce_factorial_int8
  !! author: Daniel Topa & Izaak Beekman
  !! category: regression
  !!
  !! [issue #172](https://github.com/sourceryinstitute/opencoarrays/issues/172)
  !! wherein co-reduce gets junk in the first image when binary
  !! operator's (pure function) arguments have `value` attribute
  !! instead of `intent(in)`

  implicit none
  integer(kind=1) :: value[ * ] !! Each image stores their image number here
  integer :: k
  integer(kind=1) :: np
  np = num_images ( )
  value = this_image ( )
  call co_reduce ( value, result_image = 1, operator = myProd )
  !! value[k /= 1] undefined, value[ k == 1 ] should equal $n!$ where $n$ is `num_images()`
  if ( this_image ( ) == 1 ) then
     write ( * , '( "Number of images = ", g0 )' ) num_images ( )
     do k = 1, num_images ( )
        write ( * , '( 2( a, i0 ) )' ) 'value [ ', k, ' ] is ', value [ k ]
        write ( * , '(a)' ) 'since RESULT_IMAGE is present, value on other images is undefined by the standard'
     end do
     write ( * , '( "Product  value = ", g0 )' ) value  !! should print num_images() factorial
     write ( * , 100 )
     if ( value == factorial( np ) ) then
        write ( * , '(a)' ) 'Test passed.'
     else
        write ( * , '(a, I0)') 'Answer should have been num_images()! = ', factorial( np )
        error stop 'Wrong answer for n! using co_reduce'
     end if
  end if
100 format ( "Expected value = num_images()!", /, " 2! = 2, 3! = 6, 4! = 24, ..." )

contains

  pure function myProd ( a, b ) result ( rslt )
    !! Product function to be used in `co_reduce` reduction for
    !! computing factorials. When `value` attribute is changed to
    !! `intent(in)` tests pass, and expected behavior is observed.
    integer(kind=1), value :: a, b
    !! multiply two inputs together.  If we change `value` to
    !! `intent(in)` the test passes and the issue goes away and
    !! according to C1276 of F2008:
    !!
    !! > C1276 The specification-part of a pure function subprogram
    !! > shall specify that all its nonpointer dummy data objects have
    !! > the INTENT (IN) or the VALUE attribute.
    !!
    !! Thanks to @LadaF for pointing this out.
    integer(kind=1)        :: rslt !! product of a*b
    rslt = a * b
  end function

  pure function factorial ( n ) result ( rslt )
    !! Compute $n!$
    integer(kind=1), intent(in) :: n
    integer(kind=1) :: rslt
    integer :: i
    rslt = 1
    do i = 1, n
      rslt = rslt*i
   end do
 end function
end program

program co_reduce_factorial_int8
  !! author: Daniel Topa & Izaak Beekman
  !! category: regression
  !!
  !! [issue #172](https://github.com/sourceryinstitute/opencoarrays/issues/172)
  !! wherein co-reduce gets junk in the first image when binary
  !! operator's (pure function) arguments have `value` attribute
  !! instead of `intent(in)`

  implicit none
  integer(kind=1) :: value[ * ] !! Each image stores their image number here
  integer :: k
  integer(kind=1) :: np
  np = num_images ( )
  value = this_image ( )
#if defined(__GNUC__) && __GNUC__ < 12
  call co_reduce ( value, result_image = 1, operator = myProd )
#else
  call co_reduce ( value, result_image = 1, operation = myProd )
#endif
  !! value[k /= 1] undefined, value[ k == 1 ] should equal $n!$ where $n$ is `num_images()`
  if ( this_image ( ) == 1 ) then
     write ( * , '( "Number of images = ", g0 )' ) num_images ( )
     do k = 1, num_images ( )
        write ( * , '( 2( a, i0 ) )' ) 'value [ ', k, ' ] is ', value [ k ]
        write ( * , '(a)' ) 'since RESULT_IMAGE is present, value on other images is undefined by the standard'
     end do
     write ( * , '( "Product  value = ", g0 )' ) value  !! should print num_images() factorial
     write ( * , 100 )
     if ( value == factorial( np ) ) then
        write ( * , '(a)' ) 'Test passed.'
     else
        write ( * , '(a, I0)') 'Answer should have been num_images()! = ', factorial( np )
        error stop 'Wrong answer for n! using co_reduce'
     end if
  end if
100 format ( "Expected value = num_images()!", /, " 2! = 2, 3! = 6, 4! = 24, ..." )

contains

  pure function myProd ( a, b ) result ( rslt )
    !! Product function to be used in `co_reduce` reduction for
    !! computing factorials. When `value` attribute is changed to
    !! `intent(in)` tests pass, and expected behavior is observed.
    integer(kind=1), value :: a, b
    !! multiply two inputs together.  If we change `value` to
    !! `intent(in)` the test passes and the issue goes away and
    !! according to C1276 of F2008:
    !!
    !! > C1276 The specification-part of a pure function subprogram
    !! > shall specify that all its nonpointer dummy data objects have
    !! > the INTENT (IN) or the VALUE attribute.
    !!
    !! Thanks to @LadaF for pointing this out.
    integer(kind=1)        :: rslt !! product of a*b
    rslt = a * b
  end function

  pure function factorial ( n ) result ( rslt )
    !! Compute $n!$
    integer(kind=1), intent(in) :: n
    integer(kind=1) :: rslt
    integer :: i
    rslt = 1
    do i = 1, n
      rslt = rslt*i
   end do
 end function
end program

!
! acceptable_compiler
!
! -- Report whether the compiler version equals or exceeds the first
!    OpenCoarrays-aware version
!
! OpenCoarrays is distributed under the OSI-approved BSD 3-clause License:
! Copyright (c) 2015, 2016, Sourcery, Inc.
! Copyright (c) 2015, 2016, Sourcery Institute
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without modification,
! are permitted provided that the following conditions are met:
!
! 1. Redistributions of source code must retain the above copyright notice, this
!    list of conditions and the following disclaimer.
! 2. Redistributions in binary form must reproduce the above copyright notice, this
!    list of conditions and the following disclaimer in the documentation and/or
!    other materials provided with the distribution.
! 3. Neither the names of the copyright holders nor the names of their contributors
!    may be used to endorse or promote products derived from this software without
!    specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
! IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
! INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
! NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
! WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
! ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
! POSSIBILITY OF SUCH DAMAGE.

program main
  use iso_fortran_env, only : compiler_version
  implicit none
  print *,compiler_version() >= "GCC version 6.1.0 "
end program

! random init test
!
! Copyright (c) 2021-2021, Sourcery, Inc.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of the Sourcery, Inc., nor the
!       names of its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE FOR ANY
! DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
!

program test_random_init
  implicit none
  integer :: me,np
  integer(kind=4), dimension(:), allocatable :: random_num, from_master
  integer(kind=4) :: seed_size
  integer :: seed_eq

  me = this_image()
  np = num_images()

  if (np .lt. 1) then
    error stop "Need at least two images."
  end if

  call random_seed(size=seed_size)
  allocate(random_num(1:seed_size))
  allocate(from_master(1:seed_size))

  call random_init(.true., .true.)

  sync all
  call random_seed(get=random_num)
  if (me .eq. 1) then
    from_master = random_num
  end if
  call co_broadcast(from_master, 1)
  if (me .eq. 1) then
    seed_eq = 0
  else
    seed_eq = transfer(any(random_num .eq. from_master), 0)
  end if
  call co_max(seed_eq, 1)

  if (me .eq. 1 .and. seed_eq .eq. 1) then
    error stop "Test failed. (T,T)"
  end if

  call random_init(.false., .true.)

  sync all
  call random_seed(get=random_num)
  if (me .eq. 1) then
    from_master = random_num
  end if
  call co_broadcast(from_master, 1)
  if (me .eq. 1) then
    seed_eq = 0
  else
    seed_eq = transfer(any(random_num .eq. from_master), 0)
  end if
  call co_max(seed_eq, 1)

  if (me .eq. 1 .and. seed_eq .eq. 1) then
    error stop "Test failed. (F,T)"
  end if

  sync all

  call random_init(.false., .false.)

  sync all
  call random_seed(get=random_num)
  if (me .eq. 1) then
    from_master = random_num
  end if
  call co_broadcast(from_master, 1)
  seed_eq = transfer(all(random_num .eq. from_master), 0)
  call co_min(seed_eq, 1)

print *,"me=", me, ", rand_num=", random_num, ", from_master=", from_master, ", seed_eq=", seed_eq
  if (me .eq. 1 .and. seed_eq .eq. 0) then
    error stop "Test failed. (F,F)"
  end if

  sync all

  call random_init(.true., .false.)

  sync all
  call random_seed(get=random_num)
  if (me .eq. 1) then
    from_master = random_num
  end if
  call co_broadcast(from_master, 1)
  seed_eq = transfer(all(random_num .eq. from_master), 0)
  call co_min(seed_eq, 1)

  if (me .eq. 1 .and. seed_eq .eq. 0) then
    error stop "Test failed. (T,F)"
  end if

  sync all

  if (me .eq. 1) print *,"Test passed."

end program test_random_init

! Copyright (c) 2011, Damian Rouson, Jim Xia, and Xiaofeng Xu.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the names of Damian Rouson, Jim Xia, and Xiaofeng Xu nor the
!       names of any other contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL DAMIAN ROUSON, JIM XIA, and XIAOFENG XU BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

module initializer
  use kind_parameters ,only : rkind
  implicit none
contains
  real(rkind) pure function u_initial(x)
    real(rkind) ,intent(in) :: x
    u_initial = 10._rkind*sin(x)
  end function
  real(rkind) pure function zero(x)
    real(rkind) ,intent(in) :: x
    zero = 0.
  end function
end module

program main
  use iso_fortran_env, only : output_unit
  use kind_parameters ,only : rkind
  use periodic_2nd_order_module, only : periodic_2nd_order, initial_field
  use initializer ,only : u_initial,zero
  use input_file ,only : grid_resolution !CZC
  use shared
  use mpi_share, only : mpi_object !CZC
  implicit none
  type(periodic_2nd_order), save :: u,half_uu,u_half
  real(rkind) :: dt,half=0.5,t=0.,t_final=3.08,nu=1.
  integer ,parameter :: base_output_unit=output_unit+10
  integer :: step,iostat, steps, num_steps = 100000
  character(:), allocatable :: iotype ! Allowable values: ’LISTDIRECTED’,’NAMELIST’, or ’DT’
  character(:), allocatable :: iomsg
  integer, allocatable :: v_list(:)
  procedure(initial_field) ,pointer :: initial
  real(rkind), parameter :: time_initial=0.
  real(rkind), allocatable :: u_surface(:,:)
  real(rkind) :: t_1, t_2, t_3

  ! Test parameters
  real(rkind), parameter :: pi=acos(-1._rkind),expected_zero_location=pi

  call mpi_object%mpi_begin !initiate MPI functionality, CZC
  local_grid_resolution=grid_resolution/num_procs !calculate how processors are shared, CZC

#ifdef USING_TAU
  call TAU_PROFILE_SET_NODE(my_id)
#endif
  call cpu_time(t_1)
  initial => u_initial
  call u%construct(initial,grid_resolution)
  initial => zero
  call half_uu%construct(initial,grid_resolution)
  call u_half%construct(initial,grid_resolution)
  call u%set_time(time_initial)
  step = 1
  call u%set_time((step-1)*dt)
  !numerical scheme
  call cpu_time(t_2)
  dt = u%runge_kutta_2nd_step(nu ,grid_resolution)
#ifdef BENCHMARK
  do steps = 1, num_steps
#else
  do while (t<t_final)
#endif
    half_uu = u*u*half
    u_half = u + (u%xx()*nu - half_uu%x())*dt*half ! first substep
    half_uu = u_half*u_half*half
    u  = u + (u_half%xx()*nu - half_uu%x())*dt ! second substep
    t = t + dt
    step = step + 1
  end do
  call cpu_time(t_3)
  if (my_id == 0) print *, t_2 - t_1, t_3 - t_2, t_3 - t_1
  !print *, 'this image = ', my_id, ' f_global = ',u%global_f(1:local_grid_resolution)
  iomsg = "Output result: success."
  !call u%output(70 + my_id,iotype,v_list,iostat,iomsg)
   if (u%this_image_contains(expected_zero_location)) then
     if (.not. u%has_a_zero_at(expected_zero_location)) error stop "Test failed."
     print *,'Test passed.'
   end if
 call mpi_object%mpi_end !end MPI processes

end program

program main
   real, allocatable, dimension(:, :, :, :) :: arr, arr_copy
   integer :: i, me, nimg
   real :: redc, sumc, sumnc, rednc
   real :: eps = epsilon(0.)
   logical :: failc, failnc

   allocate(arr(9, 20, 3, 18))

   me = this_image()
   nimg = num_images()

   if (me == 1) then
      arr = reshape([(i, i=1, size(arr))], shape(arr))
   end if

   call co_broadcast(arr, source_image=1)
   arr_copy = arr

   print *, '==> CONTIGUOUS <=='
   sumc = sum(arr)
   redc = sumc
   call co_sum(redc)
   print *, 'sumc=', sumc
   print *, 'excpected: nimg * sumc=', nimg * sumc
   print *, 'got: redc=', redc

   failc = abs(redc - nimg * sumc) > eps

   print *, '==> NON CONTIGUOUS <=='
   sumnc = sum(arr(::3, ::2, :, ::5))

   call co_sum(arr_copy)
   call co_sum(arr(::3, ::2, :, ::5))

   rednc = sum(arr(::3, ::2, :, ::5))
   print *, 'sumnc=', sumnc
   print *, 'expected (nimg * sumnc)=', nimg * sumnc
   print *, 'expected=', sum(arr_copy(::3, ::2, :, ::5))
   print *, 'got: rednc=', rednc

   failnc = abs(rednc - nimg * sumnc) > eps

   sync all

   if (failc .or. failnc) then
      write(*, *) 'Test failed!'
      error stop 5
   else
      write(*, *) 'Test passed.'
   end if
   deallocate(arr)
end program

! Copyright (c) 2012-2016, Sourcery, Inc.
! All rights reserved.
!
! Unit tests for co_max: verify parallel, collective maximum
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of Sourcery, Inc., nor the
!       names of any other contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

program main
  use iso_fortran_env, only : error_unit
  use iso_c_binding, only : c_int,c_double
#ifdef USE_EXTENSIONS
  use opencoarrays
#endif
  implicit none

#ifdef USE_EXTENSIONS
  if (this_image()==1) print *,"Using the extensions from the opencoarrays module."
#endif

  ! Verify that 1 is the lowest image number
  c_int_co_min: block
    integer(c_int) :: me
    me=this_image()
    sync all
    call co_max(me)
    if (me/=num_images()) then
      write(error_unit,"(2(a,i2))") "Wrong result (",me,") on image",this_image()
      error stop
    end if
    ! Wait for all images to pass the test
    sync all
    if (me==1) print *,"Correct integer(c_int) co_min"
  end block c_int_co_min

  ! Verify that the maximum real conversion of an image number is real(num_images())
  c_double_co_max: block
    real(c_double) :: me
    me=real(this_image(),c_double)
    sync all
    call co_max(me)
    if (me/=real(num_images(),c_double)) then
      write(error_unit,"(2(a,i2))") "Wrong result (",me,") on image",this_image()
      error stop
    end if
    ! Wait for all images to pass the test
    sync all
    if (this_image()==1) print *,"Correct real(c_double) co_max"
  end block c_double_co_max

  if (this_image()==1) print *, "Test passed."
end program

program hello_coarrays
  implicit none
  type :: array_type
    integer, allocatable :: values(:)
  end type
  type(array_type) :: array[*]
  allocate(array%values(2), source=0)
  array%values = this_image()
  if (all(array%values(:) .EQ. this_image())) then
    print *,"Test passed."
  end if
end program

program get_static_array
    type :: container
        integer, allocatable :: stuff(:)
    end type

    type(container) :: co_containers(10)[*]

    if (this_image() == 1) then
        allocate(co_containers(2)%stuff(4))
        co_containers(2)%stuff = [1,2,3,4]
    end if

    sync all

    if (this_image() == 2) then
        if (any(co_containers(2)[1]%stuff /= [1,2,3,4])) then
          error stop "Test failed."
        else
          print *, "Test passed."
        end if
    end if
end program

! Check that after an image has failed the failed_images function returns the
! correct indices.
! Image two is to fail, all others to continue.

program image_fail_and_failed_images_test_1
  use iso_fortran_env , only : STAT_FAILED_IMAGE
  implicit none
  integer :: i, stat
  integer, allocatable :: fimages(:)

  associate(np => num_images(), me => this_image())
    if (np < 3) error stop "I need at least 3 images to function."
    do i= 1, np
      if (image_status(i) /= 0) error stop "image_status(i) should not fail"
    end do

    ! Need a sync here to make sure all images are started and to prevent image fail
    ! is not already detected in above image_status(i).
    sync all
    if (me == 2) fail image
    sync all (STAT=stat)

    fimages = failed_images()
    if (size(fimages) /= 1) error stop "failed_images()'s size should be one."
    if (fimages(1) /= 2) error stop "The second image should have failed."

    if (me == 1) print *,"Test passed."
  end associate

end program image_fail_and_failed_images_test_1

! Unit test for register procedure. Testing static coarrays.
!
! Copyright (c) 2012-2014, Sourcery, Inc.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of the Sourcery, Inc., nor the
!       names of its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE FOR ANY
! DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

program register
  implicit none
  integer, parameter :: invalid_image_number=-1
  integer, save :: me[*] = invalid_image_number

  if (num_images()<2) error stop "This test requires at least 2 images."

  me = this_image()

  sync all
  if(me == 1) then
    block
      integer :: image2number
      image2number = me[2]
      if (image2number/= 2) error stop "Test failed."
      print *,"Test passed."
    end block
  end if

end program

program source_allocation_no_sync
  !! author: Damian Rouson and Izaak Beekman
  !! category: regression
  !!
  !! [Issue #243](https://github.com/sourceryinstitute/opencoarrays/issues/243)
  !!
  !! [GFortran PR 78505](https://gcc.gnu.org/bugzilla/show_bug.cgi?id=78505):
  !!
  !! @note The test must be run with less than or equal to 32 images,
  !! and the number of images must be a power of two. Valid numbers of
  !! images are: 2, 4, 8, 16, or 32
  !!
  !! Sourced allocation of a coarray object performs a synchronization
  !! after the allocation, BUT *before* the assignment of
  !! `source`. This violates the
  !! [standard](http://open-std.org/JTC1/SC22/WG5/5559) Section
  !! 9.7.1.2, paragraph 4:
  !!
  !! > When an ALLOCATE statement is executed for which an
  !! > allocate-object is a coarray, there is an implicit
  !! > synchronization of all active images in the current team. On
  !! > those images, if no error condition other than
  !! > STAT_STOPPED_IMAGE or STAT_FAILED_IMAGE occurs, execution of
  !! > the segment (11.6.2) following the statement is delayed until
  !! > all other active images in the current team have executed the
  !! > same statement the same number of times in this team. The
  !! > coarray shall not become allocated on an image unless it is
  !! > successfully allocated on all active images in this team.
  !!

  implicit none
  integer, allocatable :: f(:)[:]
  integer, parameter :: num_points=32
  integer :: me,ni,my_num_points,neighbor_last_element
  me = this_image()
  if (mod(num_points,num_images())/=0) error stop "num_points not evenly divisible by num_images()"
  my_num_points = num_points/num_images()
  allocate( f(my_num_points)[*], source = 1 )
  if (me>1) then
     neighbor_last_element = f(my_num_points)[me-1]
     if (neighbor_last_element /=1) then
        print *,"Image ",me," gets ",neighbor_last_element
        error stop "Synchronization did not happen after assignment in sourced allocation!"
     end if 
  end if
  sync all
  if ( me == 1 ) then
     write(*,'(a)') "Test passed."
  end if
end program source_allocation_no_sync

module global_field_module
  use iso_fortran_env, only : real64,int64
  use co_object_interface, only : co_object
  use ForTrilinos_assertion_utility, only : assert,error_message
  use local_field_module, only : local_field
  implicit none
  private
  public :: global_field,initial_condition

  type, extends(co_object) :: global_field
    private
    real(real64), allocatable :: values(:)[:]
  contains
    procedure :: set
    procedure :: state
    procedure :: x
    procedure :: xx
    procedure, nopass :: grid_spacing
    procedure, private :: assign_local_field
    procedure, private :: add_local_field
    procedure, private :: multiply
    generic :: operator(*) => multiply
    generic :: operator(+) => add_local_field
    generic :: assignment(=) => assign_local_field
    procedure :: output
  end type

  abstract interface
    pure function initial_condition(x) result(initial_values)
      import :: real64
      real(real64), intent(in) :: x
      real(real64) :: initial_values
    end function
  end interface

  real(real64), allocatable :: dx
  integer(int64), allocatable :: num_global_points,num_local_points
  integer(int64), parameter:: num_end_points=2_int64
  real(real64) :: boundary_vals(num_end_points)

contains

  function grid_spacing() result(delta_x)
    real(real64) :: delta_x
    call assert(allocated(dx),error_message("global_field%grid_spacing: dx not allocated"))
    delta_x = dx
  end function

  pure function state(this) result(local_values)
    class(global_field), intent(in) :: this
    real(real64), allocatable :: local_values(:)
    ! Requires
    if (this%user_defined()) then
      local_values = this%values
    end if
  end function

  subroutine synchronize()
    if (num_images()>1) then
      associate(me=>this_image())
        if (me==1) then
          sync images(me+1)
        else if (me==num_images()) then
          sync images(me-1)
        else
          sync images([me-1,me+1])
        end if
      end associate
    end if
  end subroutine

  subroutine set(this,initial_function,num_points)
    class(global_field), intent(inout) :: this
    integer, intent(in) :: num_points
    procedure(initial_condition), pointer :: initial_function
    integer(int64) :: num_intervals,i
    real(real64), parameter :: two_pi=2.*3.1415926535897932384626433832795028842_real64
    real(real64), allocatable :: local_grid(:)

    ! Requires
    call assert(mod(num_points,num_images())==0,error_message("global_field%set: num_points not evenly divisible by num_images()"))

    num_global_points=num_points
    num_local_points=num_points/num_images()
    num_intervals = num_global_points ! right-side boundary point is redundant and therefore not counted or stored
    dx=two_pi/real(num_intervals,real64)

    if (.not.allocated(this%values)) allocate(this%values(num_local_points)[*])
    local_grid = [((this_image()-1)*num_local_points+i-1,i=1,num_local_points)]*dx
    do concurrent(i=1:num_local_points)
      this%values(i) = initial_function(local_grid(i))
    end do
    call synchronize()

    ! Ensures
    call this%mark_as_defined
    call assert(allocated(dx),error_message("global_field%set: dx has not been allocated"))
    call assert(allocated(num_global_points),error_message("global_field%set: num_global_points has not been allocated"))
    call assert(allocated(num_local_points),error_message("global_field%set: num_local_points has not been allocated"))
  end subroutine

  subroutine assign_local_field(lhs,rhs)
    class(global_field), intent(inout) :: lhs
    class(local_field), intent(in) :: rhs
    real(real64), allocatable :: values(:)
    ! Requires
    if (.not.allocated(num_local_points)) error stop "global_field: no value established for memory allocation yet."
    if (.not.allocated(lhs%values)) allocate(lhs%values(num_local_points)[*])
    call assert(rhs%user_defined(),error_message("global_field%assign_local_field received uninitialized RHS."))
    lhs%values(:) = rhs%state()
    call synchronize()
    ! Ensures
    call lhs%mark_as_defined
  end subroutine

  pure function add_local_field(lhs,rhs) result(total)
    class(global_field), intent(in) :: lhs
    type(local_field), intent(in) :: rhs
    type(local_field) :: total
    ! Requires
    if (lhs%user_defined() .and. rhs%user_defined()) then
      total = lhs%values + rhs%state()
      call total%mark_as_defined
    end if
  end function

  pure function multiply(lhs,rhs) result(product_)
    class(global_field), intent(in) :: lhs,rhs
    type(local_field) :: product_
    ! Requires
    if (lhs%user_defined() .and. rhs%user_defined()) then
      product_= lhs%values * rhs%values
      call product_%mark_as_defined
    end if
  end function

 pure function x(this) result(this_x)
    class(global_field), intent(in) :: this
    type(local_field) :: this_x
    real(real64) :: local_this_x(num_local_points)
    integer(int64) :: i,left_neighbor,right_neighbor
    ! Requires
    if (this%user_defined() .and. allocated(dx) .and. allocated(num_local_points)) then
      associate(N=>num_local_points,me=>this_image())
        left_neighbor = merge(num_images(),me-1,me==1)
        local_this_x(1)=(this%values(2)-this%values(N)[left_neighbor])/(2._real64*dx)
        do concurrent(i=2:N-1)
          local_this_x(i)=(this%values(i+1)-this%values(i-1))/(2._real64*dx)
        end do
        right_neighbor = merge(1,me+1,me==num_images())
        local_this_x(N)=(this%values(1)[right_neighbor]-this%values(N-1))/(2._real64*dx)
      end associate
      this_x = local_this_x
      ! Ensures
      call this_x%mark_as_defined
    end if
  end function

 !pure function xx(this) result(this_xx)
  function xx(this) result(this_xx)
    class(global_field), intent(in) :: this
    type(local_field) :: this_xx
    real(real64) :: local_this_xx(num_local_points)
    integer(int64) :: i,left_neighbor,right_neighbor
    ! Requires
    if (this%user_defined() .and. allocated(dx) .and. allocated(num_local_points)) then
      associate(N=>num_local_points,me=>this_image())
        left_neighbor = merge(num_images(),me-1,me==1)
        local_this_xx(1)=(this%values(2)-2._real64*this%values(1)+this%values(N)[left_neighbor])/dx**2
        do concurrent(i=2:N-1)
          local_this_xx(i)=(this%values(i+1)-2._real64*this%values(i)+this%values(i-1))/dx**2
        end do
        right_neighbor = merge(1,me+1,me==num_images())
        local_this_xx(N)=(this%values(1)[right_neighbor]-2._real64*this%values(N)+this%values(N-1))/dx**2
      end associate
      this_xx = local_this_xx
      ! Ensures
      call this_xx%mark_as_defined
     !print *,"On image ",this_image(),", local_this_xx=",local_this_xx
     !stop
    end if
  end function

  subroutine output(this,unit,iotype,v_list,iostat,iomsg)
    class(global_field), intent(in) :: this
    integer, intent(in) :: unit ! Unit on which output happens (negative for internal file)
    character(*), intent(in) :: iotype ! Allowable values: ’LISTDIRECTED’,’NAMELIST’, or ’DT’
    integer, intent(in) :: v_list(:)
    integer, intent(out) :: iostat
    character(*), intent(inout) :: iomsg
    integer(int64) :: i
    ! Requires
    call assert(this%user_defined(),error_message("global_field%output received uninitialized object"))
    do i=1,size(this%values)
      write(unit,iostat=iostat) (this_image()-1)*size(this%values) + i, this%values(i)
    end do
  end subroutine

end module

! Coarray Distributed Transpose Test
!
! Copyright (c) 2012-2014, Sourcery, Inc.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of the Sourcery, Inc., nor the
!       names of its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE FOR ANY
! DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
!
! Robodoc header:
!****m* dist_transpose/run_size
! NAME
!   run_size
!  SYNOPSIS
!   Encapsulate problem state, wall-clock timer interface, integer broadcasts, and a data copy.
!******
!==================  test transposes with integer x,y,z values  ===============================
module run_size
    use iso_fortran_env
    implicit none

    integer(int64), codimension[*] :: nx, ny, nz
    integer(int64), codimension[*] :: my, mx, first_y, last_y, first_x, last_x
    integer(int64) :: my_node, num_nodes
    real(real64), codimension[*] :: tran_time


contains

!****s* run_size/broadcast_int
! NAME
!   broadcast_int
!  SYNOPSIS
!   Broadcast a scalar coarray integer from image 1 to all other images.
!******
    subroutine broadcast_int( variable )
        integer(int64), codimension[*] :: variable
        integer(int64) :: i
        if( my_node == 1 ) then
            do i = 2, num_nodes;    variable[i] = variable;      end do
        end if
    end subroutine broadcast_int

subroutine copy3( A,B, n1, sA1, sB1, n2, sA2, sB2, n3, sA3, sB3 )
  implicit none
  complex, intent(in)  :: A(0:*)
  complex, intent(out) :: B(0:*)
  integer(int64), intent(in) :: n1, sA1, sB1
  integer(int64), intent(in) :: n2, sA2, sB2
  integer(int64), intent(in) :: n3, sA3, sB3
  integer(int64) i,j,k

  do k=0,n3-1
     do j=0,n2-1
        do i=0,n1-1
           B(i*sB1+j*sB2+k*sB3) = A(i*sA1+j*sA2+k*sA3)
        end do
     end do
  end do
end subroutine copy3

end module run_size

!****e* dist_transpose/coarray_distributed_transpose
! NAME
!   coarray_distributed_transpose
! SYNOPSIS
!   This program tests the transpose routines used in Fourier-spectral simulations of homogeneous turbulence.
!   The data is presented to the physics routines as groups of y-z or x-z planes distributed among the images.
!   The (out-of-place) transpose routines do the x <--> y transposes required and consist of transposes within
!   data blocks (intra-image) and a transpose of the distribution of these blocks among the images (inter-image).
!
!   Two methods are tested here:
!   RECEIVE: receive block from other image and transpose it
!   SEND:    transpose block and send it to other image
!
!   This code is the coarray analog of mpi_distributed_transpose.
!******

program coarray_distributed_transpose
  !(***********************************************************************************************************
  !                   m a i n   p r o g r a m
  !***********************************************************************************************************)
      use run_size
      implicit none

      complex, allocatable ::  u(:,:,:,:)[:]    ! u(nz,4,first_x:last_x,ny)[*]    !(*-- ny = my * num_nodes --*)
      complex, allocatable ::  ur(:,:,:,:)[:]   !ur(nz,4,first_y:last_y,nx/2)[*]  !(*-- nx/2 = mx * num_nodes --*)
      complex, allocatable :: bufr_X_Y(:,:,:,:)
      complex, allocatable :: bufr_Y_X(:,:,:,:)
      integer(int64) :: x, y, z, msg_size, iter

      num_nodes = num_images()
      my_node = this_image()

      if( my_node == 1 ) then
           !write(6,*) "nx,ny,nz : ";      read(5,*) nx, ny, nz
            nx=32; ny=32; nz=32
            call broadcast_int( nx );        call broadcast_int( ny );        call broadcast_int( nz );
       end if
      sync all  !-- other nodes wait for broadcast!


      if ( mod(ny,num_nodes) == 0)  then;   my = ny / num_nodes
                                    else;   write(6,*) "node ", my_node, " ny not multiple of num_nodes";     error stop
      end if

      if ( mod(nx/2,num_nodes) == 0)  then;   mx = nx/2 / num_nodes
                                    else;   write(6,*) "node ", my_node, "nx/2 not multiple of num_nodes";     error stop
      end if

      first_y = (my_node-1)*my + 1;   last_y  = (my_node-1)*my + my
      first_x = (my_node-1)*mx + 1;   last_x  = (my_node-1)*mx + mx

      allocate (  u(nz , 4 , first_x:last_x , ny)  [*] )   !(*-- y-z planes --*)
      allocate ( ur(nz , 4 , first_y:last_y , nx/2)[*] )   !(*-- x-z planes --*)
      allocate ( bufr_X_Y(nz,4,mx,my) )
      allocate ( bufr_Y_X(nz,4,my,mx) )

      msg_size = nz*4*mx*my     !-- message size (complex data items)

!---------  initialize data u (mx y-z planes per image) ----------

        do x = first_x, last_x
            do y = 1, ny
                do z = 1, nz
                    u(z,1,x,y) = x
                    u(z,2,x,y) = y
                    u(z,3,x,y) = z
                end do
            end do
        end do

    tran_time = 0
    do iter = 1, 2  !--- 2 transform pairs per second-order time step

!---------  transpose data u -> ur (mx y-z planes to my x-z planes per image)  --------

      ur = 0

      call transpose_X_Y

!--------- test data ur (my x-z planes per image) ----------

        do x = 1, nx/2
            do y = first_y, last_y
                do z = 1, nz
                    if ( real(ur(z,1,y,x)) /= x .or. real(ur(z,2,y,x)) /= y .or. real(ur(z,3,y,x)) /= z )then
                        write(6,fmt="(A,i3,3(6X,A,f7.3,i4))") "transpose_X_Y failed:  image ", my_node &
                            , " X ",real(ur(z,1,y,x)),x, "  Y ",real(ur(z,2,y,x)),y, "  Z ", real(ur(z,3,y,x)),z
                        stop
                    end if
                end do
            end do
        end do

!---------  transpose data ur -> u (my x-z planes to mx y-z planes per image)  --------

      u = 0
      call transpose_Y_X

!--------- test data u (mx y-z planes per image) ----------

        do x = first_x, last_x
            do y = 1, ny
                do z = 1, nz
                    if ( real(u(z,1,x,y)) /= x .or. real(u(z,2,x,y)) /= y .or. real(u(z,3,x,y)) /= z )then
                        write(6,fmt="(A,i3,3(6X,A,f7.3,i4))") "transpose_Y_X failed:  image ", my_node &
                            , " X ",real(u(z,1,x,y)),x, "  Y ",real(u(z,2,x,y)),y, "  Z ", real(u(z,3,x,y)),z
                        stop
                    end if
                end do
            end do
        end do
    end do

        sync all
        if( my_node == 1 )  write(6,fmt="(A,f8.3)")  "test passed:  tran_time ", tran_time

    deallocate ( bufr_X_Y );    deallocate ( bufr_Y_X )

!=========================   end of main executable  =============================

contains

!-------------   out-of-place transpose data_s --> data_r  ----------------------------

 subroutine transpose_X_Y

    use run_size
    implicit none

    integer(int64) :: i,stage
    real(real64) :: tmp

    sync all   !--  wait for other nodes to finish compute
    call cpu_time(tmp)
    tran_time = tran_time - tmp

    call copy3 (    u(1,1,first_x,1+(my_node-1)*my) &                   !-- intra-node transpose
                ,  ur(1,1,first_y,1+(my_node-1)*mx) &                   !-- no inter-node transpose needed
                ,   nz*3, 1_8, 1_8        &                                 !-- note: only 3 of 4 words needed
                ,   mx, nz*4, nz*4*my &
                ,   my, nz*4*mx, nz*4 )

#define RECEIVE
#ifdef RECEIVE

    do stage = 1, num_nodes-1
        i = 1 + mod( my_node-1+stage, num_nodes )
        bufr_X_Y(:,:,:,:) = u(:,:,:,1+(my_node-1)*my:my_node*my)[i]         !-- inter-node transpose to buffer
        call copy3 ( bufr_X_Y, ur(1,1,first_y,1+(i-1)*mx)  &                !-- intra-node transpose from buffer
                        ,   nz*3, 1_8, 1_8        &                             !-- note: only 3 of 4 words needed
                        ,   mx, nz*4, nz*4*my &
                        ,   my, nz*4*mx, nz*4 )
    end do

#else

    do stage = 1, num_nodes-1
        i = 1 + mod( my_node-1+stage, num_nodes )
        call  copy3 ( u(1,1,first_x,1+(i-1)*my), bufr_Y_X   &        !-- intra-node transpose to buffer
                    ,   nz*3, 1_8, 1_8        &
                    ,   mx, nz*4, nz*4*my &
                    ,   my, nz*4*mx, nz*4 )
        ur(:,:,:,1+(my_node-1)*mx:my_node*mx)[i] = bufr_Y_X(:,:,:,:)        !-- inter-node transpose from buffer
    end do

#endif

    sync all     !--  wait for other nodes to finish transpose
    call cpu_time(tmp)
    tran_time = tran_time + tmp

 end  subroutine transpose_X_Y

!-------------   out-of-place transpose data_r --> data_s  ----------------------------

subroutine transpose_Y_X
    use run_size
    implicit none

    integer(int64) :: i, stage
    real(real64) :: tmp

    sync all   !--  wait for other nodes to finish compute
    call cpu_time(tmp)
    tran_time = tran_time - tmp

    call copy3 (   ur(1,1,first_y,1+(my_node-1)*mx) &                   !-- intra-node transpose
                ,   u(1,1,first_x,1+(my_node-1)*my) &                   !-- no inter-node transpose needed
                ,   nz*4, 1_8, 1_8        &                                 !-- note: all 4 words needed
                ,   my, nz*4, nz*4*mx &
                ,   mx, nz*4*my, nz*4 )

#define RECEIVE
#ifdef RECEIVE

    do stage = 1, num_nodes-1
        i = 1 + mod( my_node-1+stage, num_nodes )
        bufr_Y_X(:,:,:,:) = ur(:,:,:,1+(my_node-1)*mx:my_node*mx)[i]        !-- inter-node transpose to buffer
        call copy3 ( bufr_Y_X, u(1,1,first_x,1+(i-1)*my)  &                 !-- intra-node transpose from buffer
                    ,   nz*4, 1_8, 1_8        &
                    ,   my, nz*4, nz*4*mx &
                    ,   mx, nz*4*my, nz*4 )
    end do

#else

    do stage = 1, num_nodes-1
        i = 1 + mod( my_node-1+stage, num_nodes )
        call copy3 ( ur(1,1,first_y,1+(i-1)*mx), bufr_X_Y  &                 !-- intra-node transpose from buffer
                    ,   nz*4, 1_8, 1_8        &
                    ,   my, nz*4, nz*4*mx &
                    ,   mx, nz*4*my, nz*4 )
        u(:,:,:,1+(my_node-1)*my:my_node*my)[i] = bufr_X_Y(:,:,:,:)        !-- inter-node transpose from buffer
    end do

#endif

    sync all     !--  wait for other nodes to finish transpose
    call cpu_time(tmp)
    tran_time = tran_time + tmp

 end  subroutine transpose_Y_X


end program coarray_distributed_transpose

!! Thoroughly test sendget, i.e. foo [N] = bar [M] in all variants
!!
!! Do simple tests for sendget(). These test comprise
!!
!! FOO = BAR [N]
!!
!! where
!!
!!  FOO                BAR                 images
!! character(len=20) character(len=10)   N == M == me
!!  kind == 1         kind == 1
!!  kind == 1         kind == 4
!!  kind == 4         kind == 1
!!  kind == 4         kind == 4
!!
!! character         character
!!   (1:4, len == 5)  (1:4, len == 5)
!!  kind == 1         kind == 1
!!  kind == 1         kind == 4
!!  kind == 4         kind == 1
!!  kind == 4         kind == 4
!!
!! all of the above but for              N != M != me
!!
!! And may be some other, I've forgotten.
!!
!! Author: Andre Vehreschild, 2017


program sendget_convert_char_array

  implicit none

  character(kind=1, len=10), codimension[*] :: co_str_k1_src_scal
  character(kind=1, len=20), codimension[*] :: co_str_k1_dst_scal
  character(kind=4, len=10), codimension[*] :: co_str_k4_src_scal
  character(kind=4, len=20), codimension[*] :: co_str_k4_dst_scal

  character(kind=1, len=5), codimension[*] :: co_str_k1_src_arr(1:4)
  character(kind=1, len=7), codimension[*] :: co_str_k1_dst_arr(1:4)
  character(kind=4, len=5), codimension[*] :: co_str_k4_src_arr(1:4)
  character(kind=4, len=7), codimension[*] :: co_str_k4_dst_arr(1:4)

  logical :: error_printed=.false.

  associate(me => this_image(), np => num_images())
    if (np < 3) error stop 'Can not run with less than 3 images.'

    co_str_k1_src_scal = 'abcdefghij'
    co_str_k4_src_scal = 4_'abcdefghij'

    co_str_k1_src_arr(:) = ['abc', 'EFG', 'klm', 'NOP']
    co_str_k4_src_arr(:) = [4_'abc', 4_'EFG', 4_'klm', 4_'NOP']

    ! First check get/copy to self
    if (me == 1) then
      co_str_k1_dst_scal[1] = co_str_k1_src_scal[1]
      print *, '#' // co_str_k1_dst_scal // '#, len:', len(co_str_k1_dst_scal)
      if (co_str_k1_dst_scal /= co_str_k1_src_scal // '          ') error stop 'sendget scalar kind=1 to kind=1 self failed.'

      co_str_k4_dst_scal[1] = co_str_k4_src_scal[1]
      print *, 4_'#' // co_str_k4_dst_scal // 4_'#, len:', len(co_str_k4_dst_scal)
      if (co_str_k4_dst_scal /= co_str_k4_src_scal // 4_'          ') error stop 'sendget scalar kind=4 to kind=4 self failed.'

      co_str_k4_dst_scal[1] = co_str_k1_src_scal[1]
      print *, 4_'#' // co_str_k4_dst_scal // 4_'#, len:', len(co_str_k4_dst_scal)
      if (co_str_k4_dst_scal /= co_str_k4_src_scal // 4_'          ') error stop 'sendget scalar kind=1 to kind=4 self failed.'

      co_str_k1_dst_scal[1] = co_str_k4_src_scal[1]
      print *, '#' // co_str_k1_dst_scal // '#, len:', len(co_str_k1_dst_scal)
      if (co_str_k1_dst_scal /= co_str_k1_src_scal // '          ') error stop 'sendget scalar kind=4 to kind=1 self failed.'
    end if

    ! Do the same for arrays but on image 2
    if (me == 2) then
      co_str_k1_dst_arr(:)[2] = co_str_k1_src_arr(:)[2]
      print *, '#' // co_str_k1_dst_arr(:) // '#, len:', len(co_str_k1_dst_arr(1))
      if (any(co_str_k1_dst_arr /= ['abc    ', 'EFG    ', 'klm    ', 'NOP    '])) &
        & error stop 'sendget array kind=1 to kind=1 self failed.'

      co_str_k4_dst_arr(:)[2] = co_str_k4_src_arr(:)[2]
      print *, 4_'#' // co_str_k4_dst_arr(:) // 4_'#, len:', len(co_str_k4_dst_arr(1))
      if (any(co_str_k4_dst_arr /= [4_'abc    ', 4_'EFG    ', 4_'klm    ', 4_'NOP    '])) &
        & error stop 'sendget array kind=4 to kind=4 self failed.'

      co_str_k4_dst_arr(:)[2] = co_str_k1_src_arr(:)[2]
      print *, 4_'#' // co_str_k4_dst_arr(:) // 4_'#, len:', len(co_str_k4_dst_arr(1))
      if (any(co_str_k4_dst_arr /= [ 4_'abc    ', 4_'EFG    ', 4_'klm    ', 4_'NOP    '])) &
        & error stop 'sendget array kind=1 to kind=4 self failed.'

      co_str_k1_dst_arr(:)[2] = co_str_k4_src_arr(:)[2]
      print *, '#' // co_str_k1_dst_arr(:) // '#, len:', len(co_str_k1_dst_arr(1))
      if (any(co_str_k1_dst_arr /= ['abc    ', 'EFG    ', 'klm    ', 'NOP    '])) &
        & error stop 'sendget array kind=4 to kind=1 self failed.'
    end if

    co_str_k1_dst_arr(:) = '#######'
    co_str_k4_dst_arr(:) = 4_'#######'

    sync all
    if (me == 2) then
      co_str_k1_dst_scal[3] = co_str_k1_src_scal[1]

      co_str_k4_dst_scal[3] = co_str_k4_src_scal[1]

      co_str_k1_dst_arr(:)[3] = co_str_k1_src_arr(:)[1]

      co_str_k4_dst_arr(:)[3] = co_str_k4_src_arr(:)[1]
    end if

    sync all
    if (me == 3) then
      print *, '#' // co_str_k1_dst_scal // '#, len:', len(co_str_k1_dst_scal)
      if (co_str_k1_dst_scal /= co_str_k1_src_scal // '          ') &
        & error stop 'sendget kind=1 to kind=1 from image 1 to image 3 failed.'

      print *, 4_'#' // co_str_k4_dst_scal // 4_'#, len:', len(co_str_k4_dst_scal)
      if (co_str_k4_dst_scal /= co_str_k4_src_scal // 4_'          ') &
        & error stop 'sendget kind=4 to kind=4 from image 1 to image 3 failed.'

      print *, '#' // co_str_k1_dst_arr // '#, len:', len(co_str_k1_dst_arr(1))
      if (any(co_str_k1_dst_arr /= [co_str_k1_src_arr(1) // '  ', co_str_k1_src_arr(2) // '  ', &
        &                           co_str_k1_src_arr(3) // '  ', co_str_k1_src_arr(4) // '  '])) &
        & error stop 'sendget array kind=1 to kind=1 from image 1 to image 3 failed.'

      print *, 4_'#' // co_str_k4_dst_arr // 4_'#, len:', len(co_str_k4_dst_arr(1))
      if (any(co_str_k4_dst_arr /= [co_str_k4_src_arr(1) // 4_'  ', co_str_k4_src_arr(2) // 4_'  ', &
        &                           co_str_k4_src_arr(3) // 4_'  ', co_str_k4_src_arr(4) // 4_'  '])) &
        & error stop 'sendget array kind=4 to kind=4 from image 1 to image 3 failed.'
    end if

    co_str_k1_dst_arr(:) = '#######'
    co_str_k4_dst_arr(:) = 4_'#######'

    sync all
    if (me == 2) then
      co_str_k1_dst_scal[3] = co_str_k4_src_scal[1]

      co_str_k4_dst_scal[3] = co_str_k1_src_scal[1]

      co_str_k1_dst_arr(:)[3] = co_str_k4_src_arr(:)[1]

      co_str_k4_dst_arr(:)[3] = co_str_k1_src_arr(:)[1]
    end if

    sync all
    if (me == 3) then
      print *, '#' // co_str_k1_dst_scal // '#, len:', len(co_str_k1_dst_scal)
      if (co_str_k1_dst_scal /= co_str_k1_src_scal // '          ') &
        & error stop 'sendget kind=4 to kind=1 from image 1 to image 3 failed.'

      print *, 4_'#' // co_str_k4_dst_scal // 4_'#, len:', len(co_str_k4_dst_scal)
      if (co_str_k4_dst_scal /= co_str_k4_src_scal // 4_'          ') &
        & error stop 'sendget kind=1 to kind=4 from image 1 to image 3 failed.'

      print *, '#' // co_str_k1_dst_arr // '#, len:', len(co_str_k1_dst_arr(1))
      if (any(co_str_k1_dst_arr /= [co_str_k1_src_arr(1) // '  ', co_str_k1_src_arr(2) // '  ', &
        &                           co_str_k1_src_arr(3) // '  ', co_str_k1_src_arr(4) // '  '])) &
        & error stop 'sendget array kind=4 to kind=1 from image 1 to image 3 failed.'

      print *, 4_'#' // co_str_k4_dst_arr // 4_'#, len:', len(co_str_k4_dst_arr(1))
      if (any(co_str_k4_dst_arr /= [co_str_k4_src_arr(1) // 4_'  ', co_str_k4_src_arr(2) // 4_'  ', &
        &                           co_str_k4_src_arr(3) // 4_'  ', co_str_k4_src_arr(4) // 4_'  '])) &
        & error stop 'sendget array kind=1 to kind=4 from image 1 to image 3 failed.'
    end if

    sync all

    co_str_k1_dst_arr(:) = '#######'
    co_str_k4_dst_arr(:) = 4_'#######'

    ! Now strided.
    sync all
    if (me == 2) then
      co_str_k1_dst_arr(4:1:-2)[3] = co_str_k4_src_arr(::2)[1]

      co_str_k4_dst_arr(4:1:-2)[3] = co_str_k1_src_arr(::2)[1]
    end if

    sync all
    if (me == 3) then
      print *, '#' // co_str_k1_dst_arr // '#, len:', len(co_str_k1_dst_arr(1))
      if (any(co_str_k1_dst_arr /= ['#######', co_str_k1_src_arr(3) // '  ', &
        &                           '#######', co_str_k1_src_arr(1) // '  '])) &
        & error stop 'sendget strided kind=4 to kind=1 from image 1 to image 3 failed.'

      print *, 4_'#' // co_str_k4_dst_arr // 4_'#, len:', len(co_str_k4_dst_arr(1))
      if (any(co_str_k4_dst_arr /= [4_'#######', co_str_k4_src_arr(3) // 4_'  ', &
        &                           4_'#######', co_str_k4_src_arr(1) // 4_'  '])) &
        & error stop 'sendget strided kind=1 to kind=4 from image 1 to image 3 failed.'
    end if

    select case(me)
      case(1)
        if (error_printed) error stop
        sync images([2,3])
        print *, 'Test passed.'
      case(2)
        if (error_printed) error stop
        sync images(1)
      case(3)
        if (error_printed) error stop
        sync images(1)
    end select

  end associate

contains

  subroutine print_and_register(error_message)
    use iso_fortran_env, only : error_unit
    character(len=*), intent(in) :: error_message
    write(error_unit,*) error_message
    error_printed=.true.
  end subroutine

end program sendget_convert_char_array

! vim:ts=2:sts=2:sw=2:

program send_with_vector_index

  implicit none

  integer, parameter :: indexes(4) = [ 2, 4, 1, 3]
  integer, dimension(4) :: dst[*]

  associate (me => this_image(), np => num_images())
    if (np < 2) error stop "Need at least two images."

    dst = -1
    sync all

    if (me == 2) dst(indexes)[1] = [ 99, 999, 9999, 99999]

    sync all

    if (me == 1) then
      print *, "me=", me, ":", dst
      if (any(dst /= [9999, 99, 99999, 999])) error stop "Test failed."
    else if (me == 2) then
      dst = [ 2, 33, 222, 333]
      dst(indexes)[2] = dst
      print *, "me=", me, ":", dst
      if (any(dst /= [222, 2, 333, 33])) error stop "Test failed."
    end if

    sync all
    if (me == 1) print *, 'Test passed.'
  end associate
end program send_with_vector_index

! vim:ts=2:sts=2:sw=2:

! Copyright (c) 2011, Damian Rouson, Jim Xia, and Xiaofeng Xu.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the names of Damian Rouson, Jim Xia, and Xiaofeng Xu nor the
!       names of any other contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL DAMIAN ROUSON, JIM XIA, and XIAOFENG XU BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

module periodic_2nd_order_module
  !note co-object and field modules no longer necessary so they are not used
  use kind_parameters ,only : rkind, ikind
  use ForTrilinos_assertion_utility, only : assert,error_message
  use object_interface, only : object
  use input_file, only:grid_resolution !added input file so that multiple modules/main can access grid_resolution,CZC
  use mpi_module, only :mpi_class !CZC
  use mpi_share, only:mpi_object !CZC
  use shared !CZC
  implicit none
  private
  public :: periodic_2nd_order, initial_field

  type, extends(object) :: periodic_2nd_order
  !   private
     !Make arrays larger than necessary as they must have an explicit intialization
     real(rkind), allocatable :: global_f(:) !object MPI variable for storing function, CZC

  contains
    procedure :: construct
    procedure :: assign_field
    procedure :: add           => add_field
    procedure :: multiply      => multiply_field
    procedure :: multiply_real  !CZC
    procedure :: subtract       !CZC
    procedure :: x             => df_dx
    procedure :: xx            => d2f_dx2
    procedure :: runge_kutta_2nd_step => rk2_dt
    procedure, nopass :: this_image_contains
    procedure :: has_a_zero_at
    procedure :: local_state
    procedure, nopass :: set_time
    procedure, nopass :: get_time
    generic   :: assignment(=) => assign_field
    generic   :: operator(+)   => add
    generic   :: operator(*)   => multiply
    generic   :: operator(*)    => multiply_real!added functionality, taken from field class, CZC
    generic   :: operator(-)    => subtract !added functionality, taken from field class, CZC
    procedure :: output
   !generic :: write=>output ! Fortran 2003 derived-type output
  end type

  real(rkind) ,parameter :: pi=acos(-1._rkind)
  real(rkind), allocatable :: local_grid(:)
  real(rkind) :: time=0.

  abstract interface
    real(rkind) pure function initial_field(x)
      import :: rkind
      real(rkind) ,intent(in) :: x
    end function
  end interface

contains

  pure function local_state(this) result(local_state_vector)
     class(periodic_2nd_order), intent(in) :: this
     real(rkind), allocatable :: local_state_vector(:)
     integer(ikind) :: i
     local_state_vector = this%global_f
  end function

  subroutine output(this,unit,iotype,v_list,iostat,iomsg)
    class(periodic_2nd_order), intent(in) :: this
    integer, intent(in) :: unit ! Unit on which output happens (negative for internal file)
    character(*), intent(in) :: iotype ! Allowable values: ’LISTDIRECTED’,’NAMELIST’, or ’DT’
    integer, intent(in) :: v_list(:)
    integer, intent(out) :: iostat
    character(*), intent(inout) :: iomsg
    integer(ikind) i
    ! Requires
    call assert(this%user_defined(),error_message("periodic_2nd_order%output recieved unitialized object."))

   do i = 1, local_grid_resolution
      write (unit=unit,iostat=iostat,fmt="(i8,3(f12.4,2x))") &
      (my_id)*local_grid_resolution + i, local_grid(i),time,this%global_f(i) !modified earlier code to work with MPI, CZC
    end do
  end subroutine

  subroutine set_time(time_stamp)
    real(rkind), intent(in) :: time_stamp
    time = time_stamp
  end subroutine

  pure function get_time() result(t)
    real(rkind) :: t
    t = time
  end function

 pure function has_a_zero_at(this, expected_location) result(zero_at_expected_location)
    class(periodic_2nd_order) ,intent(in) :: this
    real(rkind) ,intent(in) :: expected_location
    real(rkind), parameter :: tolerance = 1.0E-06_rkind
    integer :: nearest_grid_point
    logical :: zero_at_expected_location
    ! Requires
    if (this%user_defined()) then
      nearest_grid_point = minloc(abs(local_grid-expected_location),dim=1)
      zero_at_expected_location = merge(.true.,.false., abs(this%global_f(nearest_grid_point)) < tolerance  )
    end if
  end function

  pure function this_image_contains(location) result(within_bounds)
     implicit none
    real(rkind), intent(in) :: location
    logical within_bounds
    within_bounds = merge(.true.,.false., (location>=minval(local_grid) .and. location<=maxval(local_grid)) )
  end function

  subroutine construct (this, initial,num_grid_pts)
     implicit none
    class(periodic_2nd_order), intent(inout) :: this
    procedure(initial_field) ,pointer, intent(in) :: initial
    integer(ikind) ,intent(in) :: num_grid_pts
    integer :: i
    !local variables for storing nearby nodes
    DOUBLE PRECISION left,right !CZC
    DOUBLE PRECISION left_sub,right_sub!CZC
    ! Requires
    call assert(mod(num_grid_pts, num_procs)==0,error_message("periodic_2nd_order%construct: invalid number of grid points."))
    local_grid = grid()
    allocate(this%global_f(local_grid_resolution))
    do concurrent (i=1:local_grid_resolution)
      this%global_f(i) = initial(local_grid(i))
    end do
  ! Ensures

    call mpi_object%oned_message(this%global_f(1:local_grid_resolution),local_grid_resolution,left_sub,right_sub)!communicate with neighbors,

    call this%mark_as_defined
  contains
    pure function grid()
     implicit none
      integer(ikind) :: i
      real(rkind) ,dimension(:) ,allocatable :: grid
      allocate(grid(local_grid_resolution))
      do concurrent (i=1:local_grid_resolution)
        grid(i)  = 2.*pi*(local_grid_resolution*(my_id)+i-1) &
                   /real(num_grid_pts,rkind)
      end do
    end function
  end subroutine

  real(rkind) function rk2_dt(this,nu,num_grid_pts)
     implicit none
    class(periodic_2nd_order) ,intent(in) :: this
    real(rkind) ,intent(in) :: nu
    integer(ikind) ,intent(in) :: num_grid_pts
    real(rkind)             :: dx, CFL, k_max
    ! Requires
    if (this%user_defined()) then
      dx=2.0*pi/num_grid_pts
      k_max=num_grid_pts/2.0_rkind
      CFL=1.0/(1.0-cos(k_max*dx))
      rk2_dt = CFL*dx**2/nu
    end if
  end function

  ! this is the assignment
  subroutine assign_field(lhs,rhs)
    implicit none
    class(periodic_2nd_order) ,intent(inout) :: lhs
    type(periodic_2nd_order) ,intent(in) :: rhs
    DOUBLE PRECISION left,right !CZC
    DOUBLE PRECISION left_sub,right_sub !CZC

    ! Requires
    call assert(rhs%user_defined(),error_message("periodic_2nd_order%copy received undefind RHS."))
    ! update global field
    lhs%global_f = rhs%global_f !CZC
    ! Ensures
    call lhs%mark_as_defined

  end subroutine

  function add_field (this, rhs)
     implicit none
    class(periodic_2nd_order), intent(in) :: this
     class(periodic_2nd_order), intent(in) :: rhs
    type(periodic_2nd_order) :: add_field
   ! Requires
    allocate(add_field%global_f(local_grid_resolution))
    if (rhs%user_defined() .and. this%user_defined()) then
      add_field%global_f(1:local_grid_resolution) = rhs%global_f(1:local_grid_resolution)+this%global_f(1:local_grid_resolution)
      ! Ensures
      call add_field%mark_as_defined
    end if
  end function

  function multiply_field (this, rhs)
     implicit none
    class(periodic_2nd_order), intent(in) :: this, rhs
    type(periodic_2nd_order) :: multiply_field

     ! Requires
    allocate(multiply_field%global_f(local_grid_resolution))
    if (this%user_defined() .and. rhs%user_defined()) then
       multiply_field%global_f(1:local_grid_resolution)=this%global_f(1:local_grid_resolution)*rhs%global_f(1:local_grid_resolution)
      ! Ensures
      call multiply_field%mark_as_defined
    end if
  end function

!New procedure, functionality taken from field, CZC
  function multiply_real(lhs,rhs) result(product_)
    class(periodic_2nd_order) ,intent(in) :: lhs
    real(rkind) ,intent(in)  :: rhs
    type(periodic_2nd_order) :: product_
    ! Requires
    allocate(product_%global_f(local_grid_resolution))
    if (lhs%user_defined()) then
      product_%global_f(1:local_grid_resolution) = lhs%global_f(1:local_grid_resolution) * rhs !multiply array with scalar
      ! Ensures
      call product_%mark_as_defined
    end if
  end function
   !new procedure, functionality taken from field, CZC
  pure function subtract(lhs,rhs) result(difference)
    class(periodic_2nd_order) ,intent(in) :: lhs
    class(periodic_2nd_order) ,intent(in)  :: rhs
    type(periodic_2nd_order) :: difference
    ! Requires
    allocate(difference%global_f(local_grid_resolution))
    if (lhs%user_defined() .and. rhs%user_defined()) then
      difference%global_f(1:local_grid_resolution) = lhs%global_f(1:local_grid_resolution) - rhs%global_f(1:local_grid_resolution) !subtract arrays
      ! Ensures
      call difference%mark_as_defined
    end if
  end function

  function df_dx(this)
     implicit none
    class(periodic_2nd_order), intent(in) :: this
    type(periodic_2nd_order)  :: df_dx
    integer(ikind) :: i,nx
    real(rkind) :: dx, left_image, right_image
    real(rkind), dimension(:), allocatable, save :: tmp_field_array
    ! Requires
    if (this%user_defined()) then

        nx = local_grid_resolution
        if (.not.allocated(tmp_field_array)) allocate(tmp_field_array(nx))
        dx=2.*pi/(real(nx,rkind)*num_procs)

        if (num_procs > 1) then
            call MPI_SENDRECV(this%global_f(1),1,MPI_DOUBLE_PRECISION,left_id,0, &
            right_image,1,MPI_DOUBLE_PRECISION,right_id,0,MPI_COMM_CART,status,ierr)
            call MPI_SENDRECV(this%global_f(local_grid_resolution),1,MPI_DOUBLE_PRECISION,right_id,0, &
            left_image,1,MPI_DOUBLE_PRECISION,left_id,0,MPI_COMM_CART,status,ierr)
        else
            left_image = this%global_f(nx)
            right_image = this%global_f(1)
        end if

      tmp_field_array(1) = &
         0.5*(this%global_f(2)-left_image)/dx

      tmp_field_array(nx) = &
         0.5*(right_image-this%global_f(nx-1))/dx

      do concurrent(i=2:nx-1)
        tmp_field_array(i)=&
          0.5*(this%global_f(i+1)-this%global_f(i-1))/dx
      end do

      df_dx%global_f = tmp_field_array
      ! Ensures
      call df_dx%mark_as_defined
    end if
  end function

  function d2f_dx2(this)
    implicit none
    class(periodic_2nd_order), intent(in) :: this
    type(periodic_2nd_order)  :: d2f_dx2
    integer(ikind) :: i,nx
    real(rkind) :: dx, left_image, right_image
    real(rkind), dimension(:), allocatable, save :: tmp_field_array

    ! Requires
    if (this%user_defined()) then

        nx = local_grid_resolution
        if (.not.allocated(tmp_field_array)) allocate(tmp_field_array(nx))
        dx=2.*pi/(real(nx,rkind)*num_procs)

        if (num_procs > 1) then
            call MPI_SENDRECV(this%global_f(1),1,MPI_DOUBLE_PRECISION,left_id,0, &
            right_image,1,MPI_DOUBLE_PRECISION,right_id,0,MPI_COMM_CART,status,ierr)
            call MPI_SENDRECV(this%global_f(local_grid_resolution),1,MPI_DOUBLE_PRECISION,right_id,0, &
            left_image,1,MPI_DOUBLE_PRECISION,left_id,0,MPI_COMM_CART,status,ierr)
        else
            left_image = this%global_f(nx)
            right_image = this%global_f(1)
        end if

        tmp_field_array(1) = &
         (this%global_f(2)-2.0*this%global_f(1)+left_image)&
         /dx**2

      tmp_field_array(nx) =&
         (right_image-2.0*this%global_f(nx)+this%global_f(nx-1))&
         /dx**2

      do concurrent (i=2:nx-1)
        tmp_field_array(i)=&
          (this%global_f(i+1)-2.0*this%global_f(i)+this%global_f(i-1))&
          /dx**2
      end do

      d2f_dx2%global_f = tmp_field_array
      ! Ensures
      call d2f_dx2%mark_as_defined
    end if
  end function
end module

!
! acceptable_compiler
!
! -- Report whether the compiler version equals or exceeds the first
!    OpenCoarrays-aware version
!
! OpenCoarrays is distributed under the OSI-approved BSD 3-clause License:
! Copyright (c) 2015, 2016, Sourcery, Inc.
! Copyright (c) 2015, 2016, Sourcery Institute
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without modification,
! are permitted provided that the following conditions are met:
!
! 1. Redistributions of source code must retain the above copyright notice, this
!    list of conditions and the following disclaimer.
! 2. Redistributions in binary form must reproduce the above copyright notice, this
!    list of conditions and the following disclaimer in the documentation and/or
!    other materials provided with the distribution.
! 3. Neither the names of the copyright holders nor the names of their contributors
!    may be used to endorse or promote products derived from this software without
!    specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
! IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
! INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
! NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
! WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
! ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
! POSSIBILITY OF SUCH DAMAGE.

program main
  use iso_fortran_env, only : compiler_version
  implicit none
  integer, parameter :: first_argument=1
  integer stat
  character(len=9) version_number
  call get_command_argument(first_argument,version_number,status=stat)
  select case(stat)
    case(-1)
       error stop "acceptable_compiler.f90: insufficient string length in attempt to read command argument"
    case(0)
      ! successful command argument read
    case(1:)
       error stop "acceptable_compiler.f90: no version-number supplied"
    case default
       error stop "invalid status"
  end select
  print *,(compiler_version() >= "GCC version "//adjustl(trim(version_number))//" ")
end program

program slice
   type coarr
      real, allocatable :: a(:, :, :)[:, :, :]
   end type

   type(coarr) :: co
   integer :: nimg, me, z, nx, ny, nz, north, south, mex, mey, mez, coords(3)
   real, allocatable :: bufxz(:, :) ! a plane (2d) slice, normal in the y direction

   nx = 6
   ny = 4
   nz = 2

   me = this_image()
   nimg = num_images()

   if (nimg /= 8) stop

   allocate(co % a(nx, ny, nz)[1:2, 1:2, *])
   allocate(bufxz(nx, nz))

   co % a = reshape([(z, z=1, nx * ny * nz)], shape(co % a))

   coords = this_image(co % a)
   mex = coords(1)
   mey = coords(2)
   mez = coords(3)

   north = mey + 1
   south = mey - 1

   sync all
   if (north <= 2) then
      z = image_index(co % a, [mex, north, mez])
      sync images(z)
      bufxz = co % a(1:nx, 1, 1:nz)[mex, north, mez]
      co % a(1:nx, ny, 1:nz) = bufxz
   end if
   if (south >= 1) then
      z = image_index(co % a, [mex, south, mez])
      sync images(z)
      bufxz = co % a(1:nx, 1, 1:nz)[mex, south, mez]
      co % a(1:nx, ny, 1:nz) = bufxz
   end if
   sync all

   deallocate(co % a, bufxz)
   if(this_image() == 1) write(*,*) "Test passed."
   ! Regression would cause error message:
   ! Fortran runtime error on image <...>: libcaf_mpi::caf_get_by_ref(): rank out of range.
 end program

! Check that after an image has failed a sync images ends correctly.
! Image two is to fail, all others to continue.

program image_fail_and_sync_test_2
  use iso_fortran_env , only : STAT_FAILED_IMAGE
  implicit none
  integer :: i, syncAllStat

  associate(np => num_images(), me => this_image())
    if (np < 3) error stop "I need at least 3 images to function."
    do i= 1, np
      if (image_status(i) /= 0) error stop "image_status(i) should not fail"
    end do

    sync all
    if (me == 2) fail image
    sync images (*, STAT=syncAllStat)
    ! Check that all images returning from the sync report the failure of an image
    if (syncAllStat /= STAT_FAILED_IMAGE) error stop "Expected sync all (STAT == STAT_FAILED_IMAGE)."

    if (me == 1) print *,"Test passed."
  end associate

end program image_fail_and_sync_test_2

!
! acceptable_compiler
!
! -- Report whether the compiler version equals or exceeds the first
!    OpenCoarrays-aware version
!
! OpenCoarrays is distributed under the OSI-approved BSD 3-clause License:
! Copyright (c) 2015, 2016, Sourcery, Inc.
! Copyright (c) 2015, 2016, Sourcery Institute
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without modification,
! are permitted provided that the following conditions are met:
!
! 1. Redistributions of source code must retain the above copyright notice, this
!    list of conditions and the following disclaimer.
! 2. Redistributions in binary form must reproduce the above copyright notice, this
!    list of conditions and the following disclaimer in the documentation and/or
!    other materials provided with the distribution.
! 3. Neither the names of the copyright holders nor the names of their contributors
!    may be used to endorse or promote products derived from this software without
!    specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
! IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
! INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
! NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
! WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
! ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
! POSSIBILITY OF SUCH DAMAGE.

program main
  !! input: acceptable compiler version in the form major.minor.patch
  !! output:
  !!   .true. if compiler version >= acceptable version
  !!   .false. otherwise
  use iso_fortran_env, only : compiler_version
  implicit none

  integer, parameter :: first_argument=1, max_version_length=len('999.999.999')
  integer stat
  character(len=max_version_length) acceptable_version

  call get_command_argument(first_argument,acceptable_version,status=stat)
  call validate_command_line( stat )

  print *, meets_minimum( acceptable_version )

contains

  pure function meets_minimum( required_version ) result( acceptable)
    character(len=*), intent(in) :: required_version
    logical acceptable

    acceptable = .false. ! default result

    associate( actual_version => compiler_version() )
      associate(major_version=>major(actual_version), acceptable_major=>major(required_version))
        if (major_version < acceptable_major) return
        if (major_version > acceptable_major) then
          acceptable = .true.
          return
        end if
        associate(minor_version=>minor(actual_version), acceptable_minor=>minor(required_version))
          if (minor_version < acceptable_minor) return
          if (minor_version > acceptable_minor) then
            acceptable = .true.
            return
          end if
          associate(patch_version=>patch(actual_version), acceptable_patch=>patch(required_version))
            if (patch_version < acceptable_patch) return
            acceptable = .true.
          end associate
        end associate
      end associate
    end associate

  end function

  pure subroutine validate_command_line( command_line_status )
    integer, intent(in) :: command_line_status
    select case(command_line_status)
      case(-1)
         error stop "acceptable_compiler.f90: insufficient string length in attempt to read command argument"
      case(0)
        ! successful command argument read
      case(1:)
         error stop "acceptable_compiler.f90: no version-number supplied"
      case default
         error stop "invalid status"
    end select
   end subroutine

  pure function major(version_string) result(major_value)
    character(len=*), intent(in) :: version_string
    integer major_value
    character(len=:), allocatable :: leading_digits

    associate( first_dot => scan(version_string, '.') )
      associate( first_digit => scan( version_string(1:first_dot-1), '0123456789' ) )
        leading_digits = version_string( first_digit : first_dot-1  )
        read(leading_digits,*) major_value
      end associate
    end associate

  end function

  pure function minor(version_string) result(minor_value)
    character(len=*), intent(in) :: version_string
    integer minor_value
    character(len=:), allocatable :: middle_digits

    associate( first_dot => scan(version_string, '.') )
      associate( second_dot => first_dot + scan(version_string(first_dot+1:), '.') )
        middle_digits = version_string( first_dot+1 : second_dot-1 )
        read(middle_digits,*) minor_value
      end associate
    end associate

  end function

  pure function patch(version_string) result(patch_value)
    use iso_fortran_env, only : iostat_end
    character(len=*), intent(in) :: version_string
    integer patch_value, io_stat
    character(len=:), allocatable :: trailing_digits

    associate( first_dot => scan(version_string, '.') )
      associate( second_dot => first_dot + scan(version_string(first_dot+1:), '.') )
        associate( next_non_digit=> second_dot + next_printable_non_digit(version_string(second_dot+1:)) )
          trailing_digits = version_string( second_dot+1 : next_non_digit-1 )
          read(trailing_digits, * , iostat=io_stat) patch_value
        end associate
      end associate
    end associate

  end function

  pure function next_printable_non_digit( string ) result(location)
    character(len=*), intent(in) :: string
    integer i, location
    integer, parameter :: ASCII_non_digit(*)=[(i,i=32,47),(i,i=58,126)]
    character(len=1), parameter :: non_digit(*)=[( char(ASCII_non_digit(i)) , i=1, size(ASCII_non_digit) )]
    character(len=size(non_digit)) non_digit_string
    write(non_digit_string,'(85a)') non_digit
    location = scan(string,non_digit_string)
    if (location==0) location=len(string)+1
  end function

end program

program main
  use, intrinsic :: iso_fortran_env, only: team_type
  implicit none
  integer, parameter :: PARENT_TEAM = 1, CURRENT_TEAM = 2, CHILD_TEAM = 3
  type(team_type) :: team(3)

  if (num_images() < 8) error stop "I need at least 8 images to function."

  form team (1, team(PARENT_TEAM))
  change team (team(PARENT_TEAM))
    form team (mod(this_image(),2)+1, team(CURRENT_TEAM))
    change team (team(CURRENT_TEAM))
      form team(mod(this_image(),2)+1, team(CHILD_TEAM))
      sync team(team(PARENT_TEAM))
      ! change order / number of syncs between teams to try to expose deadlocks
      if (team_number() == 1) then
         sync team(team(CURRENT_TEAM))
         sync team(team(CHILD_TEAM))
      else
         sync team(team(CHILD_TEAM))
         sync team(team(CURRENT_TEAM))
         sync team(team(CHILD_TEAM))
         sync team(team(CURRENT_TEAM))
      end if
    end team
  end team

  sync all

  if (this_image() == 1) write(*,*) "Test passed."

end program

! caf -o gather gather.f90
! cafrun -np 2 ./gather
! this example mimics a mpi_gatherv with root=1, and variable size chunks
! gather into specified locations from all processes in a group

program gather
   implicit none

   type gvec ! a global vector
      real, allocatable :: a(:)
   end type

   type(gvec) :: gc[*]
   real, allocatable :: gv(:), tmp(:)
   integer :: me, nimg, gsize, i, lo, hi
   logical :: fail = .false.

   me = this_image()
   nimg = num_images()

   allocate(gc % a(2 * me)) ! variable size data in container
   gc % a = [(me * i, i=1, 2 * me)] ! assignement

   ! collect the global vector size by summing local sizes
   gsize = size(gc % a)
   call co_sum(gsize, result_image=1)
   sync all

   if (me == 1) then
      if (gsize /= 6) error stop 1
      allocate(gv(gsize)) ! allocate a global vector of size 6 on img 1
      lo = 1
      do i = 1, nimg
         tmp = gc[i] % a ! note: automatic reallocation of tmp
         hi = lo + size(tmp) - 1
         gv(lo:hi) = tmp
         lo = hi + 1 ! start of next chunk
      end do
      print *, 'gv=', gv, ' sum=', sum(gv)

      if (abs(sum(gv) - 23.) > epsilon(0.)) fail = .true.
   end if

   sync all

   ! CMake test output handler
   call co_broadcast(fail, source_image=1)
   if (fail) then
      write(*, *) 'Test failed!'
      error stop 5
   else
      write(*, *) 'Test passed.'
   end if

end program

program slice
   type coarr
      real, allocatable :: a(:, :, :)[:, :, :]
   end type

   type(coarr) :: co
   integer :: nimg, me, z, nx, ny, nz, north, south, mex, mey, mez, coords(3)
   integer :: shape2d(2), shape3d(3)
   real, allocatable :: buf3d(:, :, :) ! a plane slice as a rank 3 array with a single transverse layer
   real, allocatable :: buf2d(:, :) ! a plane (2d) slice, normal in the y direction

   nx = 6
   ny = 4
   nz = 2

   me = this_image()
   nimg = num_images()

   if (nimg /= 8) stop

   allocate(co % a(nx, ny, nz)[1:2, 1:2, *])
   allocate(buf2d(nx, nz), buf3d(nx, 1, nz))

   ! this example should NOT reallocate buf2d nor buf3d
   ! compare shapes before and after syncing
   shape2d = shape(buf2d)
   shape3d = shape(buf3d)

   co % a = reshape([(z, z=1, nx * ny * nz)], shape(co % a))

   coords = this_image(co % a)
   mex = coords(1)
   mey = coords(2)
   mez = coords(3)

   north = mey + 1
   south = mey - 1

   sync all
   if (north <= 2) then
      z = image_index(co % a, [mex, north, mez])
      sync images(z)
      ! no reduction on rank
      buf3d = co % a(1:nx, 1:1, 1:nz)[mex, north, mez]
      co % a(1:nx, ny:ny, 1:nz) = buf3d

      ! reduction along dim 2
      buf2d = co % a(1:nx, 1, 1:nz)[mex, north, mez]
      co % a(1:nx, ny, 1:nz) = buf2d
   end if
   if (south >= 1) then
      z = image_index(co % a, [mex, south, mez])
      sync images(z)
      buf3d = co % a(1:nx, ny:ny, 1:nz)[mex, south, mez]
      co % a(1:nx, 1:1, 1:nz) = buf3d

      buf2d = co % a(1:nx, ny, 1:nz)[mex, south, mez]
      co % a(1:nx, 1, 1:nz) = buf2d
   end if
   sync all

   deallocate(co % a, buf2d, buf3d)
   
   if (any(shape2d /= shape(buf2d)) .or. any(shape3d /= shape(buf3d))) then
      write(*, *) 'Test failed!'
      error stop 5
   else
      write(*, *) 'Test passed.'
   end if

   ! Regression would cause error message:
   ! Fortran runtime error on image <...>: libcaf_mpi::caf_get_by_ref(): rank out of range.
end program

program test_teams1
  use iso_fortran_env, only : team_type
  implicit none

  type(team_type) :: team, initial
  integer :: x[*], me

  me = this_image()
  x = me
  
  form team (mod(me,2)+1,team)

  change team (team)

  if(me == 1) x[2, team = initial] = me

  end team

  if(me == 2 .and. x == 1) print *,"Test passed."
  
end program

! SYNC IMAGES(*) with the STAT=STAT_STOPPED_IMAGE specifier
! Based on a test taken from UH caf-testsuite

program sync_images_stat
  use, intrinsic:: iso_fortran_env
  implicit none

  integer :: stat_var = 0, me

  me = this_image()

  if (me /= 1 ) then
     call sleep(1)
     sync images(*,STAT=stat_var)
     if ( stat_var /= STAT_STOPPED_IMAGE) then
        print *, "Error:stat_var /= STAT_STOPPED_IMAGE: ", me
        ERROR STOP 1
     end if
     if(me == 2) print *, 'Test passed.'
  end if

end program sync_images_stat

! BSD 3-Clause License
!
! Copyright (c) 2016, Sourcery Institute
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

! Comments preceded by "!!" are formatted for the FORD docoumentation generator
program main
  !! author: Damian Rouson
  !! date: 2016-12-21
  !! category: regression
  !! Test whether implicit type conversion occurs before coarray put
  !! OpenCoarrays issue #292
  use iso_fortran_env, only : error_unit
  implicit none
  real :: a[*]
  integer :: receiver
  associate(me=>this_image(),ni=>num_images())
    if (me == 1) then
      put_realme_on_remote_image: do receiver= 2, ni
        a[receiver] = receiver ! implicit real(receiver) needed here
        sync images (receiver) ! notify remote image that data has been put
      end do put_realme_on_remote_image
    else
      sync images (1) ! await notification of data put by image 1
      if (a/=real(me)) then
        write(error_unit,*) "Test failed on image ",me,": received ",a,", expected ",real(me)
        error stop
      end if
    end if
    sync all ! wait for every image to pass the test
    if (me==1) print *,"Test passed."
  end associate
end program

!****p* doc/sample-fortran-source.f90
! NAME
!   sendrcv
! SYNOPSIS
!   In this simple coarray Fortran program, image 1 puts its
!   local elements of an array coarray into the corresponding
!   elements of image 2.  The corresponding C program that an
!   OpenCoarrays-compatible compiler might generate from this
!   code is in doc/sample-compiler-output.c.
! SOURCE
program sendrecv
  use iso_fortran_env
  implicit none

  integer :: me, np, i
  integer, parameter :: n=1000
  real(kind=real64), allocatable :: d(:)[:]

  allocate(d(n)[*])

  np = num_images()
  me = this_image()

  do i=1,n
     d(i) = i
  enddo

  sync all

  if(me == 1) d(:)[2] = d

  sync all

  deallocate(d)

end program
!******

! Coarray 3D Navier-Stokes Solver Test
!
! Copyright (c) 2012-2014, Sourcery, Inc.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of Sourcery, Inc., nor the
!       names of its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE FOR ANY
! DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!

!(*----------------------------------------------------------------------------------------------------------------------
!         basic in-core shear code ( 7 words/node, not threaded, in-core, no file read/write )
!------------------------------------------------------------------------------------------------------------------------*)

! Define universal constants:
! In the case of exactly representable numbers, the definitions are useful
! to ensure subprogram argument type/kind/rank matching without having to
! repeat kind specifiers everywhere.
module constants_module
  use iso_fortran_env, only : int64
  implicit none
  private
  public :: one,zero
  integer(int64), parameter :: one=1_int64,zero=0_int64
end module

! Initialize the random seed with a varying seed to ensure a different
! random number sequence for each invocation of subroutine, e.g. for
! invocations on different images of a coarray parallel program.
! Setting any seed values to zero is deprecated because it can result
! in low-quality random number sequences.
! (Source: https://gcc.gnu.org/onlinedocs/gfortran/RANDOM_005fSEED.html)
module random_module
  implicit none
  private
  public :: init_random_seed
contains
  subroutine init_random_seed()
            use iso_fortran_env, only: int64
            implicit none
            integer, allocatable :: seed(:)
            integer :: i, n, un, istat, dt(8), pid
            integer(int64) :: t

            call random_seed(size = n)
            allocate(seed(n))
            ! First try if the OS provides a random number generator
            open(newunit=un, file="/dev/urandom", access="stream", &
                 form="unformatted", action="read", status="old", iostat=istat)
            if (istat == 0) then
               if (this_image()==1) print *,"OS provides random number generator"
               read(un) seed
               close(un)
            else
               if (this_image()==1) print *,"OS does not provide random number generator"
               ! Fallback to XOR:ing the current time and pid. The PID is
               ! useful in case one launches multiple instances of the same
               ! program in parallel.
               call system_clock(t)
               if (t == 0) then
                  call date_and_time(values=dt)
                  t = (dt(1) - 1970) * 365_int64 * 24 * 60 * 60 * 1000 &
                       + dt(2) * 31_int64 * 24 * 60 * 60 * 1000 &
                       + dt(3) * 24_int64 * 60 * 60 * 1000 &
                       + dt(5) * 60 * 60 * 1000 &
                       + dt(6) * 60 * 1000 + dt(7) * 1000 &
                       + dt(8)
               end if
               pid = getpid()
               t = ieor(t, int(pid, kind(t)))
               do i = 1, n
                  seed(i) = lcg(t)
               end do
            end if
            call random_seed(put=seed)
          contains
            ! This simple PRNG might not be good enough for real work, but is
            ! sufficient for seeding a better PRNG.
            function lcg(s)
              integer :: lcg
              integer(int64) :: s
              if (s == 0) then
                 s = 104729
              else
                 s = mod(s, 4294967296_int64)
              end if
              s = mod(s * 279470273_int64, 4294967291_int64)
              lcg = int(mod(s, int(huge(0), int64)), kind(0))
            end function lcg
          end subroutine init_random_seed
end module random_module

module run_size
    use iso_fortran_env ! 64-bit integer and real kind parameters
    use constants_module, only : one         ! 64-bit unit to ensure argument kind match
    implicit none
        real, codimension[*] ::  viscos, shear, b11, b22, b33, b12, velmax
        integer(int64), codimension[*] ::  nx, ny, nz, nsteps, output_step
        integer(int64), codimension[*] :: my, mx, first_y, last_y, first_x, last_x
        real(real64), codimension[*] :: cpu_time, tran_time, sync_time, total_time
        real(real64), codimension[*] :: max_cpu_time, max_tran_time, max_sync_time, max_total_time
        real(real64), codimension[*] :: min_cpu_time, min_tran_time, min_sync_time, min_total_time
        type(lock_type),save :: l_xy_buff[*]
        type(lock_type),save :: l_yx_buff[*]
        real ::  time, cfl, dt
        integer(int64) :: my_node, num_nodes
        real, parameter :: pi = 3.141592653589793

contains

    subroutine max_velmax()
        integer(int64) :: i

        ! sync all
        ! if( my_node == 1) then
        !     do i = 2, num_nodes;     velmax = max( velmax, velmax[i] );    end do
        ! end if
        ! sync all
        call co_max(velmax,1)
        if (my_node>1) velmax = velmax[1]
        sync all
    end subroutine max_velmax

    subroutine global_times()
        integer(int64) :: i, stage

        max_cpu_time = cpu_time
        max_tran_time = tran_time
        max_total_time = sync_time
        max_total_time = total_time
        min_cpu_time = cpu_time
        min_tran_time = tran_time
        min_total_time = sync_time
        min_total_time = total_time

        do stage = 1, num_nodes-1
            i = 1 + mod( my_node-1+stage, num_nodes )
            max_cpu_time = max( max_cpu_time, cpu_time[i] )
            min_cpu_time = min( min_cpu_time, cpu_time[i] )
            max_tran_time = max( max_tran_time, tran_time[i] )
            min_tran_time = min( min_tran_time, tran_time[i] )
            max_sync_time = max( max_sync_time, sync_time[i] )
            min_sync_time = min( min_sync_time, sync_time[i] )
            max_total_time = max( max_total_time, total_time[i] )
            min_total_time = min( min_total_time, total_time[i] )
        end do
        sync all
    end subroutine global_times

subroutine copy3( A,B, n1, sA1, sB1, n2, sA2, sB2, n3, sA3, sB3 )
  implicit none
  complex, intent(in)  :: A(0:*)
  complex, intent(out) :: B(0:*)
  integer(int64), intent(in) :: n1, sA1, sB1
  integer(int64), intent(in) :: n2, sA2, sB2
  integer(int64), intent(in) :: n3, sA3, sB3
  integer(int64) i,j,k

  do k=0,n3-1
     do j=0,n2-1
        do i=0,n1-1
           B(i*sB1+j*sB2+k*sB3) = A(i*sA1+j*sA2+k*sA3)
        end do
     end do
  end do
end subroutine copy3

end module run_size

program cshear

  !(***********************************************************************************************************
  !                   m a i n   p r o g r a m
  !***********************************************************************************************************)
      use iso_fortran_env, only : int64,real64 ! 64-bit integer and real kind parameters
      use run_size
      implicit none

      interface
        subroutine solve_navier_stokes
        end subroutine solve_navier_stokes
      end interface

      num_nodes = num_images()
      my_node = this_image()

      if( my_node == 1 ) then

        write(6,*) "nx,ny,nz : ";               read(5,*) nx, ny, nz
        if ( mod(nx/2,num_nodes) /= 0) then;    write(6,*) "nx/2 not multiple of num_nodes";    stop;   end if
        if ( mod(ny,num_nodes) /= 0) then;      write(6,*) " ny not multiple of num_nodes";     stop;   end if

        write(6,*) "viscos, shear : ";          read(5,*) viscos, shear
        write(6,*) "b11 b22 b33 b12 : ";        read(5,*) b11, b22, b33, b12
        write(6,*) "nsteps, output_step : ";    read(5,*) nsteps, output_step

        write(6,fmt="(3(A,i4))") "nx =",nx,   "   ny =",ny,   "   nz =",nz
        write(6,fmt="(2(A,f7.3))") "viscos = ", viscos, "      shear = ", shear
        write(6,fmt="(A,4f7.3)") "b11 b22 b33 b12 = ", b11, b22, b33, b12
        write(6,fmt="(2(A,i6))") "nsteps = ", nsteps, "       output_step = ", output_step

        write(6,fmt="(A,i4,A)") "----------------- running on ", num_nodes, " images -------------------"

      end if

      sync all  !--- images > 1 wait on inputs from image = 1 !

      if( my_node > 1 ) then
        nx = nx[1];     ny = ny[1];     nz = nz[1]
        viscos = viscos[1];     shear = shear[1]
        b11 = b11[1];   b22 = b22[1];   b33 = b33[1];   b12 = b12[1]
        nsteps = nsteps[1];     output_step = output_step[1]
      end if

 	    mx = nx/2 / num_nodes;  first_x = (my_node-1)*mx + 1;   last_x  = (my_node-1)*mx + mx
        my = ny / num_nodes;    first_y = (my_node-1)*my + 1;   last_y  = (my_node-1)*my + my

      if(my_node == 1 ) write(6,fmt="(A, f6.2)") "message size (MB) = ", real(nz*4*mx*my*8)/real(1024*1024)

    call solve_navier_stokes

end program cshear

!  (***********************************************************************************************************
!             n a v i e r - s t o k e s   s o l v e r
!  ************************************************************************************************************)

  subroutine solve_navier_stokes
      use run_size
      implicit none

  !(*****************************   declarations     ****************************************)

       integer(int64) ::  stop, rflag, oflag, step, rkstep, nshells
       real ::  k1(nx/2), k2(ny), k3(nz), mk1(nx/2), mk2(ny), mk3(nz) &
              , kx(nx/2), ky_(nx/2,ny), ky(nx/2,ny), kz(nz)
       complex :: sx(nx/2,3), sy(ny,3), sz(nz,3)
       integer(int64) :: trigx, trigy, trigz, trigxy

       complex, allocatable ::  u(:,:,:,:)[:]    ! u(nz,4,first_x:last_x,ny)[*]    !(*-- x-y planes --*)
       complex, allocatable ::  ur(:,:,:,:)[:]   !ur(nz,4,first_y:last_y,nx/2)[*]  !(*-- x-z planes --*)
       complex, allocatable ::  un(:,:,:,:)      !un(nz,3,first_x:last_x,ny)[*]    !(*-- x-y planes --*)
       complex, allocatable :: bufr_X_Y(:,:,:,:)
       complex, allocatable :: bufr_Y_X(:,:,:,:)

interface
!--------    note: integer(int64)'s required for FFT's and other assembly-coded externals   ------

   function ctrig( len ) bind(C)               !(*-- define complex FFT trig table --*)
        import int64
        integer(int64), value, intent(in) :: len
        integer(int64) :: ctrig     !-- C pointer!
   end function ctrig

   function rtrig( len ) bind(C)              !(*-- define real FFT trig table --*)
        import int64
        integer(int64), value, intent(in):: len
        integer(int64) :: rtrig     !-- C pointer!
   end function rtrig

   subroutine cfft( len, lot, data, inc, jmp, ctrig, isign ) bind(C)    !(*-- complex FFT --*)
        import int64
        integer(int64), value, intent(in) :: len, lot, inc, jmp, ctrig, isign
        complex, dimension(0:0), intent(in) :: data
   end subroutine cfft

   subroutine rfft( len, lot, data, inc, jmp, rtrig, isign ) bind(C)   !(*-- real FFT --*)
        import int64
        integer(int64), value, intent(in) :: len, lot, inc, jmp, rtrig, isign
        complex, dimension(0:0), intent(in) :: data
   end subroutine rfft

   function WALLTIME() bind(C, name = "WALLTIME")
       import real64
       real(real64) :: WALLTIME
   end function WALLTIME


end interface

       trigx = rtrig( nx )
       trigy = ctrig( ny )
       trigz = ctrig( nz )
	   trigxy = ctrig( nx+ny )

       allocate (  u(nz , 4 , first_x:last_x , ny)[*] )     !(*-- y-z planes --*)
       allocate ( ur(nz , 4 , first_y:last_y , nx/2)[*] )   !(*-- x-z planes --*)
       allocate ( un(nz , 3 , first_x:last_x , ny) )        !(*-- y-z planes --*)
       allocate ( bufr_X_Y(nz,4,mx,my) )
       allocate ( bufr_Y_X(nz,4,my,mx) )


       stop = 0;   step = 0;  rkstep = 2;  rflag = 0;  cfl = 1;   dt = 0
       nshells = max( nx,ny,nz )

                        call define_kspace
                        call define_field
                        call enforce_conjugate_symmetry
						call copy_n_s
                        call define_shifts

       total_time =  -WALLTIME()      !-- start the clock

       tran_time = 0;       cpu_time = -WALLTIME()

  !(*********************************   begin execution loop   *****************************************)

       do while (stop == 0)

                        call phase1
            rkstep = 1
                        call transpose_X_Y
                        call phase2
                        call transpose_Y_X
                        call define_step
                        call define_shifts
                        call phase3
                        call pressure
		if (oflag /= 0) call spectra
                        call advance
                        call phase1
            rkstep = 2
                        call transpose_X_Y
                        call phase2
                        call transpose_Y_X
                        call phase3
                        call advance
                        call pressure
        if (rflag /= 0) call remesh
                        call copy_s_n

                		step = step + 1
                        time = time + dt
       end do

  !(*********************************   end execution loop   ***********************************************)

       deallocate ( u, ur, un )
       deallocate ( bufr_X_Y );    deallocate ( bufr_Y_X )
       sync all     !-- wait for all images to finish!

       total_time =  total_time + WALLTIME()    !-- stop the clock
       cpu_time =  cpu_time + WALLTIME()    !-- stop the clock
       call global_times

       if (my_node == 1 )   write(6,fmt="(3(10X,A,2f7.2))")  &
                            , "total_time ", min_total_time/step, max_total_time/step &
                            , "cpu_time ", min_cpu_time/step, max_cpu_time/step &
                            , "tran_time ", min_tran_time/step, max_tran_time/step


       write(6,fmt="(A,i4,3f7.2)")  "image ", my_node, total_time/step, cpu_time/step, tran_time/step


contains

 !(***********************************************************************************************************
 !                          transpose the Y and Z planes
 !***********************************************************************************************************)

!-----                   u(nz,4,mx,my*num_nodes) [num_nodes]
!-----                  ur(nz,4,my,mx*num_nodes) [num_nodes]
!-----                bufr(nz,4,my,mx) or bufr(nz,4,mx,my)

!-------------   out-of-place transpose data_s --> data_r  ----------------------------

 subroutine transpose_X_Y

    use constants_module, only : one
    use run_size
    use iso_fortran_env
    implicit none

    integer(int64) :: i,stage
!    type(lock_type),save :: l_xy_buff[*]

    cpu_time = cpu_time + WALLTIME()
    lock(l_xy_buff[this_image()])
    sync all   !--  wait for other nodes to finish compute
    tran_time = tran_time - WALLTIME()

    call copy3 (    u(1,1,first_x,1+(my_node-1)*my) &                   !-- intra-node transpose
                ,  ur(1,1,first_y,1+(my_node-1)*mx) &                   !-- no inter-node transpose needed
                ,   nz*3, one, one        &                                 !-- note: only 3 of 4 words needed
                ,   mx, nz*4, nz*4*my &
                ,   my, nz*4*mx, nz*4 )
    unlock(l_xy_buff[this_image()])
!    write(*,*) this_image(), 'unlocks itself xy'

    do stage = 1, num_nodes-1
        i = 1 + mod( my_node-1+stage, num_nodes )
        lock(l_xy_buff[i])
!	write(*,*) this_image(),'locks xy', i
        bufr_X_Y(:,:,:,:) = u(:,:,:,1+(my_node-1)*my:my_node*my)[i]         !-- inter-node transpose to buffer
        unlock(l_xy_buff[i])
!	write(*,*) this_image(),'unlocks xy',i
        call copy3 ( bufr_X_Y, ur(1,1,first_y,1+(i-1)*mx)  &                !-- intra-node transpose from buffer
                        ,   nz*3, one, one        &                             !-- note: only 3 of 4 words needed
                        ,   mx, nz*4, nz*4*my &
                        ,   my, nz*4*mx, nz*4 )
    end do

!    sync all     !--  wait for other nodes to finish transpose
    tran_time = tran_time + WALLTIME()
    cpu_time = cpu_time - WALLTIME()

 end  subroutine transpose_X_Y

!-------------   out-of-place transpose data_r --> data_s  ----------------------------

subroutine transpose_Y_X
    use run_size
    use iso_fortran_env
    implicit none

    integer(int64) :: i, stage
!    type(lock_type),save :: l_yx_buff[*]

    cpu_time = cpu_time + WALLTIME()
    lock(l_yx_buff[this_image()])
!    sync images(*)
    sync all   !--  wait for other nodes to finish compute
    tran_time = tran_time - WALLTIME()

    call copy3 (   ur(1,1,first_y,1+(my_node-1)*mx) &                   !-- intra-node transpose
                ,   u(1,1,first_x,1+(my_node-1)*my) &                   !-- no inter-node transpose needed
                ,   nz*4, one, one        &                                 !-- note: all 4 words needed
                ,   my, nz*4, nz*4*mx &
                ,   mx, nz*4*my, nz*4 )
    unlock(l_yx_buff[this_image()])
    do stage = 1, num_nodes-1
        i = 1 + mod( my_node-1+stage, num_nodes )
        lock(l_yx_buff[i])
	!write(*,*) this_image(),'locks yx', i
        bufr_Y_X(:,:,:,:) = ur(:,:,:,1+(my_node-1)*mx:my_node*mx)[i]        !-- inter-node transpose to buffer
        unlock(l_yx_buff[i])
	!write(*,*) this_image(),'unlocks yx', i
        call copy3 ( bufr_Y_X, u(1,1,first_x,1+(i-1)*my)  &                 !-- intra-node transpose from buffer
                    ,   nz*4, one, one        &
                    ,   my, nz*4, nz*4*mx &
                    ,   mx, nz*4*my, nz*4 )
    end do

    !sync all     !--  wait for other nodes to finish transpose
    tran_time = tran_time + WALLTIME()
    cpu_time = cpu_time - WALLTIME()

 end  subroutine transpose_Y_X


!(*************************************************************************************************************
!           enforce conjugate symmetry for plane kx=0 of wavespace  (half of this plane is redundant)
!***************************************************************************************************************)

  subroutine enforce_conjugate_symmetry

    integer(int64) ::  i, x, y, z

!(*------------------------- un( K ) = conjg( un( -K ) ) ---------------------*)

    if (my_node == 1 ) then     !-- x=1 is in node=1
        x = 1
        do i = 1, 3
            z = 1;              y = 1;              un(z,i,x,y) = 0
            z = 1;              do y = 2, ny/2;     un(z,i,x,y) = conjg( un(z,i,x,ny+2-y) );        end do
            do z = 2, nz/2;     y = 1;              un(z,i,x,y) = conjg( un(nz+2-z,i,x,y) );        end do
            do z = 2, nz/2;     do y = 2, ny;       un(z,i,x,y) = conjg( un(nz+2-z,i,x,ny+2-y) );   end do;	end do
        end do
    end if
end  subroutine enforce_conjugate_symmetry

 !(***********************************************************************************************************
 !                spectra :  accumulate spectra and other statistics over flow field
 !***********************************************************************************************************)

 subroutine  spectra

      use run_size
     implicit none

    integer(int64) :: k, x, y, z
    real :: kk, ww, uw, uu, uv, duu, factor   &
          , ek(nshells), dk(nshells), hk(nshells), tk(nshells), sample(nshells)
    real, save, codimension[*] ::  sum_ek, sum_dk, sum_hk, sum_tk

      total_time =  total_time + WALLTIME()     !-- stop the clock!  time/step does not include spectra time

	  oflag = 0
      ek = 0;       dk = 0;       hk = 0;     tk = 0;   sample = 0

 !(*---------------------   three dimensional spectra  -----------------------*)

      do x = first_x, last_x;   do y = 1, ny;      do  z = 1, nz

            if( mk1(x)+mk2(y)+mk3(z) > 2./9. ) &
                              then;   factor = 0
            else if (x == 1)  then;   factor = 1
                              else;   factor = 2
            end if

            kk = kx(x)**2 + ky(x,y)**2 + kz(z)**2
            k = 1 + int( sqrt( kk ) + 0.5 )

			  uu = factor * real( un(z,1,x,y) * conjg( un(z,1,x,y) ) &
                                + un(z,2,x,y) * conjg( un(z,2,x,y) ) &
                                + un(z,3,x,y) * conjg( un(z,3,x,y) ) )
              ww = kk * uu
              uv = factor * real( un(z,1,x,y) * conjg( un(z,2,x,y) ) )

              uw = factor * 2 * aimag( kx(x) *   un(z,2,x,y) * conjg( un(z,3,x,y) ) &
                                     + ky(x,y) * un(z,3,x,y) * conjg( un(z,1,x,y) ) &
                                     + kz(z) *   un(z,1,x,y) * conjg( un(z,2,x,y) ) )

			  duu = factor * real( un(z,1,x,y) * conjg( u(z,1,x,y) ) &
                                 + un(z,2,x,y) * conjg( u(z,2,x,y) ) &
								 + un(z,3,x,y) * conjg( u(z,3,x,y) ) ) / (dt/2) + shear * uv

              sample(k) = sample(k) + factor        !(*-- shell sample --*)
              ek(k) = ek(k) + uu                    !(*-- 2 * energy sum --*)
              dk(k) = dk(k) + ww                    !(*-- enstrophy sum --*)
              hk(k) = hk(k) + uw                    !(*-- helicity sum --*)
              tk(k) = tk(k) + duu                   !(*-- transfer sum --*)

      end do;   end do;  end do

 !(************************     finished accumulation :  compute final statistics     *************************)

    sum_ek = 0;     sum_dk = 0;     sum_hk = 0;     sum_tk = 0
    do k = nshells, 1, -1
        sum_ek  = sum_ek + ek(k)
        sum_dk  = sum_dk + dk(k)
        sum_hk  = sum_hk + hk(k)
        sum_tk  = sum_tk + tk(k)
    end do

    sync all
    call co_sum(sum_ek,1)
    call co_sum(sum_dk,1)
    call co_sum(sum_hk,1)
    call co_sum(sum_tk,1)
    if (my_node == 1)  then
        ! do k = 2, num_nodes
        !     sum_ek = sum_ek + sum_ek[k]
        !     sum_dk = sum_dk + sum_dk[k]
        !     sum_hk = sum_hk + sum_hk[k]
        !     sum_tk = sum_tk + sum_tk[k]
        ! end do

        if (step == 0)   write(6,*) "step   time     energy    enstrophy   helicity   transfer"
        write(6,fmt="(i3, 5e11.3)")  step,  time,    sum_ek,   sum_dk,     sum_hk,    sum_tk
    end if

     total_time =  total_time - WALLTIME()     !-- restart the clock!
 end  subroutine  spectra

  !(************************************************************************************************************
  !        define_field  :   define initial flow field from scratch
  !************************************************************************************************************)

 subroutine define_field

    use constants_module, only : zero
    use run_size
    use random_module
    implicit none

    real ::     k, k12, f, phi, theta1, theta2
    complex ::  alpha, beta
    integer(int64) ::  x, y, z
    real, parameter :: klo=8, khi=16

   call init_random_seed !(* seed a different pseudo-random number sequence for each image *)
   time = 0

   do x = first_x, last_x
       do  y = 1, ny
            do z = 1, nz
                 call random_number(theta1 )
                 call random_number(theta2 )
                 call random_number(phi    )
                 k   = sqrt( kx(x)**2 + ky(x,y)**2 + kz(z)**2 )
                 k12 = sqrt( kx(x)**2 + ky(x,y)**2 )

                 if ( k == 0  .or.  mk1(x)+mk2(y)+mk3(z)>2./9.  .or.  k < klo  .or.  k > khi ) &
                     then;   f = 0
                     else;   f = sqrt( 1./(2*pi) ) / k
                 end if

                 alpha = f * exp( (0,2) * pi * theta1 ) * cos( 2*pi * phi )
                 beta  = f * exp( (0,2) * pi * theta2 ) * sin( 2*pi * phi )

                 if (k12 == 0) &
                 then; un(z,1,x,y) = alpha
                       un(z,2,x,y) = beta
                       un(z,3,x,y) = 0

                 else; un(z,1,x,y) = ( beta * kz(z) * kx(x)   + alpha * k * ky(x,y) ) / ( k * k12 )
                       un(z,2,x,y) = ( beta * kz(z) * ky(x,y) - alpha * k * kx(x)   ) / ( k * k12 )
                       un(z,3,x,y) = - beta * k12 / k
                 end if

   end do;  end do; end do
 end  subroutine define_field

 !(***********************************************************************************************************
 !          define_shifts  :    define coordinate shifts for control of 1-d alias errors
 ! ***********************************************************************************************************)

    subroutine  define_shifts
    use constants_module, only : zero
    use run_size
    implicit none

           integer(int64) ::  x, y, z
           integer(int64), save ::  init = 0
           real :: delta_x, delta_y, delta_z
           integer :: i,seed_size

           if (init == 0) &     !-- Note: delta's not carried over from previous run
           then;
                init = 1
                call random_seed(size=seed_size)
                call random_seed(put=[(1234567,i=1,seed_size)])!(* same random numbers for each image! *)
                do  x = 1, nx/2;  sx(x,3) = exp (  (0,1) * ( pi / nx ) * k1(x) ); end do
                do  y = 1, ny  ;  sy(y,3) = exp (  (0,1) * ( pi / ny ) * k2(y) ); end do
                do  z = 1, nz  ;  sz(z,3) = exp (  (0,1) * ( pi / nz ) * k3(z) ); end do
            else;
                call random_number(delta_x); delta_x = 2*pi / nx * delta_x
                do  x = 1, nx/2;  sx(x,1) = sx(x,3)
                                  sx(x,2) = exp (  (0,1) * delta_x * k1(x) )
                                  sx(x,3) = exp (  (0,1) * ( delta_x + pi / nx ) * k1(x) ); end do

                call random_number(delta_y); delta_y = 2*pi / ny * delta_y
                do  y = 1, ny  ;  sy(y,1) = sy(y,3)
                                  sy(y,2) = exp (  (0,1) * delta_y * k2(y) )
                                  sy(y,3) = exp (  (0,1) * ( delta_y + pi / ny ) * k2(y) ); end do

                call random_number(delta_z); delta_z = 2*pi / nz * delta_z
                do  z = 1, nz  ;  sz(z,1) = sz(z,3)
                                  sz(z,2) = exp (  (0,1) * delta_z * k3(z) )
                                  sz(z,3) = exp (  (0,1) * ( delta_z + pi / nz ) * k3(z) ); end do
           end if

 end  subroutine  define_shifts

  !(***********************************************************************************************************
  !       define_step  :   update time, metric, shifts for the next step
  !**********************************************************************************************************)

  subroutine  define_step
      use run_size
      implicit none

    sync all

    if (cfl /= 0) then
cpu_time = cpu_time + WALLTIME()
        call max_velmax
cpu_time = cpu_time - WALLTIME()
        dt = cfl / velmax
    end if

    if (        shear > 0               &
        .and.  .01*b11*shear*dt < b12   &
        .and.  b12 <= b11*shear*dt )    then
            dt = b12 / ( b11 * shear )          !(* limit dt, hit the orthognal mesh *)
            oflag = 1
    else if ( mod (step,output_step) == 0 ) then
            oflag = 1
    end if

    b12 = b12 - b11 * shear * dt

    if ( b12 < -b22/2 )     rflag = 1                                   !(* remesh at the end of the step? *)
    if ( step == nsteps )   stop = 1                                    !(* last step? *)

 end   subroutine    define_step

   !(***********************************************************************************************************
   !      define_kspace  :   define physical wavespace from computational wavespace and metric
   !**********************************************************************************************************)

  subroutine    define_kspace
    use run_size
    implicit none

     integer(int64) ::  x, y, z

       do  x = 1, nx/2   ;   k1(x) = x - 1;     end do
       do  y = 1, ny/2+1 ;   k2(y) = y - 1;     end do
       do  z = 1, nz/2+1 ;   k3(z) = z - 1;     end do

       do  y = ny/2+2, ny;   k2(y) = y - 1 - ny;    end do
       do  z = nz/2+2, nz;   k3(z) = z - 1 - nz;    end do

       do  x = 1, nx/2 ;     mk1(x) = (k1(x)/nx)**2;    kx(x) =   b11 * k1(x);  end do
       do  z = 1, nz   ;     mk3(z) = (k3(z)/nz)**2;    kz(z) =   b33 * k3(z);  end do
       do  y = 1, ny   ;     mk2(y) = (k2(y)/ny)**2
                             do  x = 1, nx/2 ;    ky(x,y) = b22 * k2(y) + b12 * k1(x);  end do; end do

end   subroutine    define_kspace

  !(***********************************************************************************************************
  !   phase 1 :  on entry, data-plane contains velocity in wave space.  interpolate database, shifted mesh,
  !              and proceed to physical y space .
  !************************************************************************************************************)

  subroutine  phase1

      use run_size
      implicit none

    complex :: shift
    integer(int64) :: i, x, y, z

   	do  x = first_x, last_x

   		do  y = 1, ny;    do  z = 1, nz
             shift = sz(z,rkstep+1) * sy(y,rkstep+1) * sx(x,rkstep+1)
             u(z,1,x,y) = shift * u(z,1,x,y)
             u(z,2,x,y) = shift * u(z,2,x,y)
             u(z,3,x,y) = shift * u(z,3,x,y)
        end do; end do

!(*---------------------------   LEAVING FOURIER WAVE SPACE  --------------------------*)

        do i = 1, 3
            call cfft ( ny, nz, u(1,i,x,1), nz*4*mx, one, trigy, one );    end do
	end do

 end   subroutine  phase1

 !(**********************************************************************************************************
 !     phase 2 :  on entry, data-plane contains velocity in physical y space, and wave x,z space on shifted
 !                mesh.  Proceed to physical x,z space,  form nonlinear terms, and return to wave x,z space.
 !***********************************************************************************************************)

 subroutine  phase2

     use run_size
     implicit none

     complex :: s2(nz,nx/2), vs(nz,nx/2)
     integer(int64) ::  i, x, y, z
     real :: v2r, v2i, s2r, s2i, u1r, u1i, u2r, u2i, u3r, u3i, u4r, u4i

  velmax = 0

  do  y = first_y, last_y

      do  x = 1, nx/2 ;  do  z = 1, nz ;   vs(z,x) = ur(z,2,y,x);    end do; end do

      do  i = 1, 3
           call cfft ( nz, nx/2, ur(1,i,y,1), one, nz*4*my, trigz, one )
           call rfft ( nx, nz,   ur(1,i,y,1), nz*4*my, one, trigx, one )
      end do

!(*----------------------------  WELCOME TO PHYSICAL SPACE  --------------------------*)

      do  x = 1, nx/2;  do  z = 1, nz
           u1r = real(ur(z,1,y,x));  u1i = aimag(ur(z,1,y,x))
           u2r = real(ur(z,2,y,x));  u2i = aimag(ur(z,2,y,x))
           u3r = real(ur(z,3,y,x));  u3i = aimag(ur(z,3,y,x))

      if ( rkstep == 1 ) velmax = max( velmax &
                                     , b11*nx*abs(u1r) + b22*ny*abs(u2r) + b33*nz*abs(u3r) &
                                     , b11*nx*abs(u1i) + b22*ny*abs(u2i) + b33*nz*abs(u3i) )

           v2r = u2r * u2r;             v2i = u2i * u2i
           s2r = u1r * u3r;             s2i = u1i * u3i
           u4r = u2r * u3r;             u4i = u2i * u3i
           u3r = u3r * u3r  -  v2r;     u3i = u3i * u3i  -  v2i
           u2r = u1r * u2r;             u2i = u1i * u2i
           u1r = u1r * u1r  -  v2r;     u1i = u1i * u1i  -  v2i

           s2(z,x)     = cmplx(s2r, s2i)
           ur(z,1,y,x) = cmplx(u1r, u1i)
           ur(z,2,y,x) = cmplx(u2r, u2i)
           ur(z,3,y,x) = cmplx(u3r, u3i)
           ur(z,4,y,x) = cmplx(u4r, u4i)
      end do;   end do

!(*----------------------------  LEAVING PHYSICAL SPACE  --------------------------*)

      do  i = 1,  4
           call rfft ( nx, nz,   ur(1,i,y,1), nz*4*my, one, trigx, -one )
           do  z = 1, nz ;   ur(z,i,y,1) = cmplx(real(ur(z,i,y,1)),0);   end do
           call cfft ( nz, nx/2, ur(1,i,y,1), one, nz*4*my, trigz, -one )
      end do

      call rfft ( nx, nz, s2, nz, one, trigx, -one )
      do  z = 1, nz ;   s2(z,1) = cmplx(real(s2(z,1)),0);    end do
      call cfft ( nz, nx/2, s2, one, nz, trigz, -one )

      do  x = 1, nx/2;  do  z = 1, nz
          ur(z,1,y,x) = kx(x) * ur(z,1,y,x) + kz(z) * s2(z,x)   - (0,1) * 2*nx*nz*shear * vs(z,x)
          ur(z,3,y,x) = kx(x) * s2(z,x)     + kz(z) * ur(z,3,y,x)
      end do;   end do
  end do

 end  subroutine  phase2

  !(***********************************************************************************************************
  !     phase 3 :  on entry, the data-plane contains the four stresses on a shifted mesh in physical y space,
  !                wave x,z space.   Return to y  wave space on unshifted mesh and complete time derivative of
  !                velocity ( not divergence free yet )
  !***********************************************************************************************************)

  subroutine  phase3

      use run_size
      implicit none

    integer(int64) :: i, x, y, z
    complex :: shift

    do  x = first_x, last_x

       do i = 1, 4
           call cfft ( ny, nz, u(1,i,x,1), nz*4*mx, one, trigy, -one )
       end do

!(*---------------------------   WELCOME TO FOURIER WAVE SPACE  --------------------------*)

       do  y = 1, ny ;   do  z = 1, nz
               shift = -dt / (4*nx*ny*nz) * (0,1)*conjg( sy(y,rkstep) * sz(z,rkstep) * sx(x,rkstep) )
               u(z,1,x,y) = shift * (         u(z,1,x,y) + ky(x,y) * u(z,2,x,y) )
               u(z,2,x,y) = shift * ( kx(x) * u(z,2,x,y) + kz(z)   * u(z,4,x,y) )
               u(z,3,x,y) = shift * (         u(z,3,x,y) + ky(x,y) * u(z,4,x,y) )
       end do;  end do
    end do

 end   subroutine  phase3

  !(***********************************************************************************************************
  !   pressure :  add the gradient of a scalar, enforce continuity ( zero divergence )
  !***********************************************************************************************************)

  subroutine  pressure

      use run_size
      implicit none

     complex :: psi
     integer(int64) :: x, y, z

      do x = first_x, last_x ;     do  y = 1, ny

            if ( x /= 1 )  then
                  do  z = 1, nz
                        psi = ( kx(x) * u(z,1,x,y) + ky(x,y) * u(z,2,x,y) + kz(z) * u(z,3,x,y) ) &
                              / ( kx(x)**2 + ky(x,y)**2 + kz(z)**2 )
                        u(z,1,x,y) = u(z,1,x,y) - kx(x) * psi
                        u(z,2,x,y) = u(z,2,x,y) - ky(x,y) * psi
                        u(z,3,x,y) = u(z,3,x,y) - kz(z) * psi
                   end do
			else if ( y /= 1 )  then
                  do  z = 1, nz
                        psi = ( ky(1,y) * u(z,2,1,y) + kz(z) * u(z,3,1,y) ) &
                              / ( ky(1,y)**2 + kz(z)**2 )
                        u(z,2,1,y) = u(z,2,1,y) - ky(1,y) * psi
                        u(z,3,1,y) = u(z,3,1,y) - kz(z) * psi
                  end do
            else
                  do  z = 1, nz ;    u(z,3,1,1) = 0;     end do
            end if
	 end do;    end do

end   subroutine  pressure

!(*****************************************************************************************************************
!                                remesh  :  remesh the sheared coordinate system
!*****************************************************************************************************************)

subroutine   remesh

    use constants_module, only : one
    use run_size
    implicit none

    complex :: u2(nx+ny,nz), shift(nx+ny)
    integer(int64) :: i, x, y, z

    write(6,fmt="(A,i4)") "remesh image ", my_node

    total_time =  total_time + WALLTIME()     !-- stop the clock!

    do x = first_x, last_x

        do  y = 1, nx+ny ;   shift(y) =  exp( (0,-2) * pi / (nx+ny) * k1(x) * (y - 1) ) / (nx+ny);    end do

        do  i = 1,  3
            do  z = 1, nz
                do  y = 1, ny/2           ;   u2(y,z) = u(z,i,x,y);     end do
                do  y = ny/2+1, nx+ny/2+1 ;   u2(y,z) = 0;              end do
                do  y = nx+ny/2+2, nx+ny  ;   u2(y,z) = u(z,i,x,y-nx);  end do
            end do

            call cfft ( nx+ny, nz, u2, one , nx+ny, trigxy, one )

            do  z = 1, nz ;  do  y = 1, nx+ny ;     u2(y,z) = u2(y,z) * shift(y);  end do;  end do

            call cfft ( nx+ny, nz, u2, one, nx+ny, trigxy, -one )

            do  z = 1, nz
                do  y = 1, ny/2
                    if (mk1(x)+mk2(y)+mk3(z) > 2./9.) &
                        then;  u(z,i,x,y) = 0
                        else;  u(z,i,x,y) = u2(y,z)
                    end if
                end do
                do  y = ny/2+1, ny
                    if (mk1(x)+mk2(y)+mk3(z) > 2./9.) &
                        then;  u(z,i,x,y) = 0
                        else;  u(z,i,x,y) = u2(y+nx,z)
                    end if
                end do
            end do
        end do

        do  y = 1, ny ;    ky(x,y) = ky(x,y) + b22 * k1(x);     end do           !(* update ky for this x *)

    end do

    b12 = b12 + b22;     rflag = 0                                               !(*   update metric, account for remesh    *)

    total_time =  total_time - WALLTIME()     !-- restart the clock!
 end subroutine   remesh

 !(***********************************************************************************************************
 !         copy_n_s,   copy_s_n :  copy data between data_s and data_n
 !***********************************************************************************************************)

 subroutine  copy_n_s

     use run_size
     implicit none

	integer(int64) ::  x, y, z

	do y = 1, ny;    do x = first_x, last_x;   do z = 1, nz
		u(z,1,x,y) = un(z,1,x,y)
		u(z,2,x,y) = un(z,2,x,y)
    	u(z,3,x,y) = un(z,3,x,y)
	end do; end do; end do
 end  subroutine  copy_n_s

 subroutine  copy_s_n

     use run_size
     implicit none

	integer(int64) ::  x, y, z

	do y = 1, ny;	do x = first_x, last_x;     do z = 1, nz
		un(z,1,x,y) = u(z,1,x,y)
		un(z,2,x,y) = u(z,2,x,y)
		un(z,3,x,y) = u(z,3,x,y)
    end do; end do; end do

 end  subroutine  copy_s_n

 !(***********************************************************************************************************
 !                         advance :     second-order runge-kutta time step algorithm
 !***********************************************************************************************************)

 subroutine  advance

     use run_size
     implicit none

    integer(int64) ::  x, y, z
    real :: factor, xyfac, zfac(nz)	  !(* viscous integrating factors *)

    if (rkstep == 1) then
        do z = 1, nz;     zfac(z) = exp( - viscos * dt * kz(z)**2 ); end do

        do x = first_x, last_x
            do  y = 1, ny
                ky_(x,y) = ky(x,y)
                ky(x,y) = b22 * k2(y) + b12 * k1(x)

                do z = 1, nz
                    if (mk1(x)+mk2(y)+mk3(z) > 2./9.) then
                        u(z,1,x,y) = 0;     u(z,2,x,y) = 0;     u(z,3,x,y) = 0
                    else
                        factor = zfac(z) * exp( - viscos * dt * ( kx(x)**2 + ( ky_(x,y)**2 + ky_(x,y)*ky(x,y) + ky(x,y)**2 )/3 ) )

                        un(z,1,x,y) = factor * ( un(z,1,x,y) + u(z,1,x,y) )
                        u(z,1,x,y)  = un(z,1,x,y) + factor * u(z,1,x,y)

                        un(z,2,x,y) = factor * ( un(z,2,x,y) + u(z,2,x,y) )
                        u(z,2,x,y)  = un(z,2,x,y) + factor * u(z,2,x,y)

                        un(z,3,x,y) = factor * ( un(z,3,x,y) + u(z,3,x,y) )
                        u(z,3,x,y)  = un(z,3,x,y) + factor * u(z,3,x,y)
                    end if
        end do;  end do; end do

    else if (rkstep == 2) then

        do x = first_x, last_x
            do  y = 1, ny
                do z = 1, nz
                    if (mk1(x)+mk2(y)+mk3(z) > 2./9.) then
                        u(z,1,x,y) = 0;     u(z,2,x,y) = 0;     u(z,3,x,y) = 0
                    else
                        u(z,1,x,y) = un(z,1,x,y) + u(z,1,x,y)
                        u(z,2,x,y) = un(z,2,x,y) + u(z,2,x,y)
                        u(z,3,x,y) = un(z,3,x,y) + u(z,3,x,y)
                    end if
        end do; end do; end do

    end if

 end  subroutine  advance

 end   subroutine solve_navier_stokes

! This test checks if allocate on coarray variables acts as a barrier.

program alloc_as_barrier
  implicit none

  integer :: me

  call test_alloc(me)

  if(this_image() == 2) then
    if(me /= 1) then
      write(*,*) "Test failed.",me
    else
      write(*,*) "Test passed."
    endif
  endif

contains

  subroutine test_alloc(me)
    integer,intent(out) :: me
    integer,allocatable :: a(:)[:]

    me = this_image()
    if(me == 1) call sleep(1)
    allocate(a(10)[*],source=me)
    if(me > 1) me = a(2)[this_image()-1]
    deallocate(a)

  end subroutine

end program

! BSD 3-Clause License
!
! Copyright (c) 2016, Sourcery Institute
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

program main
  !! author: Damian Rouson
  !! date: 2017-08-01
  !! category: regression
  !! Test whether assigning an allocatable coarray component to an allocatable
  !! coarray component works.
  !! OpenCoarrays issue #422
  use iso_fortran_env, only : error_unit
  implicit none

  type foo
    !! A derived type is required to demonstrate issue #422
    integer, allocatable :: bar(:)[:]
  end type
  type(foo) :: foobar

  enum, bind(C)
    enumerator :: recipient=1, provider
    !! provider=2
  end enum

  integer, parameter :: message(*)=[3,4], required_images=2
    !! Data for provider image to put on recipient image

  associate( me=>this_image(), N_images=>num_images() )

    verify_num_images: if (N_images<required_images) then
      write(error_unit,*)  "issue-422-send.f90 requires at least ",required_images," images"
      error stop
    end if verify_num_images

    allocate(foobar%bar(size(message))[*],source=me)
      !! Assign each image's identifier to each element of foobar%bar
#ifndef GCC_GE_7
    sync all
      !! Fix to #243 has not been backported to GCC < 7. Implicit sync
      !! happens after allocation but before sourced assignment
#endif

    get_put_component: if (me==provider) then
      foobar%bar(:)[recipient] =  message
        !! Get bar from provider image and put bar on recipient image
      sync images(recipient)
        !! Signal recipient that get and put have completed
    end if get_put_component

    wait_and_verify: if (me==recipient) then
      sync images(provider)
        !! Wait for signal from provider image

      verify_result: if (any(foobar%bar/=message)) then
        write(error_unit,*) "Recipient image ",recipient," received ",foobar%bar," but expected ",provider
        error stop
      end if verify_result

      print *,"Test passed."
        !! Report success

    end if wait_and_verify

  end associate

end program

! syncall test
!
! Copyright (c) 2012-2014, Sourcery, Inc.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of the Sourcery, Inc., nor the
!       names of its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE FOR ANY
! DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
!
program syncall
  implicit none

  integer :: me,np,i
  integer :: scalar[*]

  me = this_image()
  np = num_images()
  scalar = -1

  if(me /= 1) call sleep(1)

  scalar = 1

  sync all

  if(me == 1) then
     do i=1,np
        if(scalar[i] /= 1) then
           write(*,*) 'Test failed.'
           stop
        endif
     end do
  end if

  if(me == 1) print *,'Test passed.'

end program syncall

! Coarray 1D Heat Equation Solver Test: main
!
! Copyright (c) 2012-2014, Sourcery, Inc.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of the Sourcery, Inc., nor the
!       names of its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE FOR ANY
! DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
!

program main
  use global_field_module, only : global_field
  implicit none
  type(global_field) :: T,laplacian_T,T_half
  real, parameter :: alpha=1.,dt=0.0001,final_time=1.,tolerance=1.E-3
  real :: time=0.
  call T%global_field_(internal_values=0.,boundary_values=[1.,0.],domain=[0.,1.],num_global_points=16384)
  call T_half%global_field_()
  do while(time<final_time)
    T_half = T + (.laplacian.T)*(alpha*dt/2.)
    T      = T + (.laplacian.T_half)*(alpha*dt)
    time = time + dt
  end do
  call laplacian_T%global_field_()
  laplacian_T = .laplacian.T
  if (any(laplacian_T%state()>tolerance)) error stop "Test failed."
  if (this_image()==1) print *,"Test passed."
end program

program main
   implicit none

   type foo
      logical, allocatable :: x(:, :)[:]
   end type

   type(foo) :: bar
   integer :: shp_loc(2), shp_rem(2)

   allocate(bar % x(2, 1)[*])

   shp_loc = shape(bar % x) ! local shape
   shp_rem = shape(bar % x(:, :)[1]) ! remote shape on this image
   print *, shp_loc, shp_rem

   if (any(shp_loc /= shp_rem)) then
      write(*, *) 'Test failed!'
      error stop 5
   else
      write(*, *) 'Test passed.'
   end if
end program

! P-SNAP test
!
! Copyright (c) 2012-2014, Sourcery, Inc.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of the Sourcery, Inc., nor the
!       names of its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE FOR ANY
! DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS

!  Fortran translation of

!/*
! * P-SNAP v1.2 -- PAL System Noise Activity Program -- LA-CC-06-025
! *        <http://www.c3.lanl.gov/pal/software/psnap/>
! *
! * Copyright (C) 2006, The Regents of the University of California
! *
! *                PAL -- Performance and Architecture Laboratory
! *                  <http://www.c3.lanl.gov/pal/>
! *                Los Alamos National Laboratory
! *                  <http://www.lanl.gov/>
! */

!  by Dan Nagle

! * This program is free software; you can redistribute it and/or modify
! * it under the terms of the GNU General Public License as published by
! * the Free Software Foundation; either version 2 of the License, or
! * (at your option) any later version.
! *
! * This program is distributed in the hope that it will be useful,
! * but WITHOUT ANY WARRANTY; without even the implied warranty of
! * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! * GNU General Public License for more details.
! *
! * You should have received a copy of the GNU General Public License
! * along with this program; if not, write to the Free Software
! * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
! * 02110-1301 USA.

program psnap

!  #define VERSION_STR "v1.2"

use, intrinsic :: iso_fortran_env, only: error_unit, output_unit, int64, real64, int32

use, intrinsic :: iso_c_binding

character( len= *), parameter :: psnap_rcs_id = &
   '$Id$'

character( len= *), parameter :: string_fmt = '( a)'

type, bind( c) :: counters

   integer( c_long) :: val
   integer( c_int) :: index

end type counters

!  int rank, np; // globals

integer :: rank
integer :: np
integer :: np_half

!integer( int64), save :: n = 100000
integer( int64), codimension[ *], save :: n = 1000
integer( int64), codimension[ *], save :: w = 1000
integer( int64), dimension( :), allocatable :: r
integer( int64) :: i
integer( int64), codimension[ *], save :: iteration_count = 0
integer( int64), codimension[ *] :: localmax, globalmax
integer( int64), codimension[ *] :: localsum
integer( int64), dimension( :), allocatable :: sum_all
integer( int64), dimension( :), allocatable, codimension[ :] :: localhist
integer( int64), codimension[ *], save :: granularity = 1000
integer( int64), codimension[ *], save :: barrier = 0

!character( kind= c_char, len= 1024), codimension[ *] :: hostname

interface
  subroutine start_timer() bind(C, name="start_timer")
    use iso_c_binding
  end subroutine
  subroutine stop_timer() bind(C, name="stop_timer")
    use iso_c_binding
  end subroutine
  function elapsed_time() bind(c,name="elapsed_time") result(res)
    use iso_c_binding
    !use, intrinsic :: iso_fortran_env, only: int64
    integer(c_int) :: res
  end function
end interface

type( counters), codimension[ *] :: count_loc, globalminloc, globalmaxloc

   integer( int64) :: j
   integer :: astat

   character( len= 32) :: cl_arg

! ----------------------------------------------------------------------

!  psnap text

continue

   rank = this_image()
   np = num_images()
   np_half = np / 2

   j = 0

   if( rank == 1 )then

      cl_args: do

         j = j + 1

         if( j >= command_argument_count() ) exit cl_args

         call get_command_argument( number= int( j, int32), value= cl_arg)

         which_arg: select case( cl_arg( 2: 2))

         case( 'b')

            j = j + 1
            call get_command_argument( number= int( j, int32), value= cl_arg)
            write( unit= barrier, fmt= *) cl_arg
            do i = 2, np
               barrier[ i] = barrier
            end do

         case( 'n')

            j = j + 1
            call get_command_argument( number= int( j, int32), value= cl_arg)
            write( unit= n, fmt= *) cl_arg
            w = n / 10
            do i = 2, np
               n[ i] = n
               w[ i] = w
            end do

         case( 'w')

            j = j + 1
            call get_command_argument( number= int( j, int32), value= cl_arg)
            write( unit= w, fmt= *) cl_arg
            do i = 2, np
               w[ i] = w
            end do

         case( 'c')

            j = j + 1
            call get_command_argument( number= int( j, int32), value= cl_arg)
            write( unit= iteration_count, fmt= *) cl_arg
            do i = 2, np
               iteration_count[ i] = iteration_count
            end do

         case( 'g')

            j = j + 1
            call get_command_argument( number= int( j, int32), value= cl_arg)
            write( unit= granularity, fmt= *) cl_arg
            do i = 2, np
               granularity[ i] = granularity
            end do

         case( 'h')

            call usage()
            stop 'normal exit in psnap'

         case default

            call usage()
            stop 'normal exit in psnap'

         end select which_arg

      end do cl_args

   end if

!  distribute sizes before allocating

   sync all

   !call get_environment_variable( name= 'HOSTNAME', value= hostname)

   allocate( r( 1: n + w), stat= astat)

   alloc_r_error: if( astat > 0 )then

      stop 'error allocating r'

   end if alloc_r_error

   allocate( sum_all( 1: np), stat= astat)

   alloc_sum_error: if( astat > 0 )then

      stop 'error allocating sum_all'

   end if alloc_sum_error

   only_rank_0: if( rank == 1 )then

      call print_banner()

   end if only_rank_0

! ----------------------------------------------------------------------

!  warmup loop here; calibration follows

   if( w > 0 ) call warmup_loop( w)

   if( iteration_count == 0 )then

      iteration_count = calibrate_loop( granularity)

	!write(*,*) 'Iteration after calibrate', iteration_count,'proc',rank

      count_loc% val = iteration_count
      count_loc% index = rank

      globalminloc = count_loc
      globalmaxloc = count_loc

!  compute global counts before communicating them

      sync all

      do i = 2, np
         if( globalminloc[ i]% val < globalminloc% val )then
            globalminloc = globalminloc[ i]
         end if
         if( globalmaxloc[ i]% val > globalmaxloc% val )then
            globalmaxloc = globalmaxloc[ i]
         end if
      end do

      if( rank == 1 )then
         write( unit= output_unit, fmt= '( a, i0/ a, i0, a, i0/ a, i0, a, i0)') "my_count= ", iteration_count, &
                                    "global_min= ", globalminloc% val, " min_loc= ", globalminloc% index, &
                                    "global_max= ", globalmaxloc% val, " max_loc= ", globalmaxloc% index
         write( unit= output_unit, fmt= string_fmt) "Using Global max for calibration"
      end if

      iteration_count = globalmaxloc% val

   end if

   r = 0

! ----------------------------------------------------------------------

!  measurement loop

   sync all

   do i = 1, n + w
      r( i) = loop( iteration_count)
      if( barrier /= 0 )then
         if(  mod( i, barrier) == 0 ) sync all
      end if
   end do

   sync all

! ----------------------------------------------------------------------

!   build histograms

   localsum = sum( r( w+1: ) )

   if( rank == 1 )then

      sum_all( 1) = localsum

      do i = 2, np
         sync images( i)
         sum_all( i) = localsum[ i]
      end do

   else
      sync images( 1)
   end if

   localmax = maxval( r( w+1: ))

   if( rank == 1 )then

      globalmax = localmax

      do i = 2, np
         sync images( i)
         globalmax = max( globalmax, localmax[ i])
      end do

   else
      sync images( 1)
   end if

   if( rank == 1 )then

      do i = 2, np
         globalmax[ i] = globalmax
      end do

   end if

   sync all

   allocate( localhist( 0: globalmax)[ *], stat= astat )

   alloc_localhist_error: if( astat > 0 )then

      stop 'error allocating localhist'

   end if alloc_localhist_error

   localhist = 0

   make_hist: do i = 1+w, n+w

      localhist( r( i)) = localhist( r( i)) + 1

   end do make_hist

   final_print: if( rank == 1 )then

!  print rank 0's histogram

      if( n > 0 )then
         write( unit= output_unit, fmt= '(a, i9, 9x, i9, 3x)') "#", 1, sum_all( 1)!, trim( hostname)
         do i = 0, globalmax
            if( localhist( i) > 0 )then
               write( unit= output_unit, fmt= '(1x, i9, i9, i9, 3x)') rank, i, localhist( i)!, trim( hostname)
            end if
         end do

      end if

!  print rank i's histogram

      do i = 2, np

         sync images( i)
         !localhist(:) = localhist(:)[ i]
         do j=lbound(localhist,dim=1),ubound(localhist,dim=1)
           localhist(j) = localhist(j)[ i]
         end do

         !hostname = hostname[ i]
         if( n > 0 )then
            write( unit= output_unit, fmt= '(a, i9, 9x, i9, 3x)') "#", i, sum_all( i)!, trim( hostname)
            do j = 0, globalmax
               if( localhist( j) > 0 )then
                  write( unit= output_unit, fmt= '(1x, i9, i9, i9, 3x)') i, j, localhist( j)!, trim( hostname)
               end if
            end do

         end if
      end do

   else final_print

      sync images( 1)

   end if final_print

stop 'normal exit in psnap'

contains

! ---------------------------------------------------------------------

function get_usecs() result( usecs)
!integer( int64) :: usecs

!  usec per sec

!integer( int64), parameter :: c = 1000000

!   integer( int64) :: t

!   integer( int64) :: r

integer(kind=8) :: t,r
real(real64) :: usecs
integer(kind=8),parameter :: c = 1000000

continue

   !call system_clock( count= t, count_rate= r)
   call cpu_time(usecs)
   usecs = usecs*1.d6
   !if( r /= c ) usecs = int( real( t, 8) / real( r, 8) * real( c, 8))
   !if( r /= c ) usecs = int( t/r * c)

return

end function get_usecs

! ---------------------------------------------------------------------

function loop( iterations) result( dt)
integer(int64) :: dt
integer( int64), intent( in) :: iterations

   integer( int64) :: i

   integer(int64) :: usecs_init, usecs_final

   integer :: next_rank, prev_rank

   integer, codimension[ *], save :: coarray

continue

!   usecs_init = get_usecs()

   call start_timer()

   next_rank = to_upper_half( rank)
   prev_rank = from_lower_half( rank)

!   write(*,*) 'Proc',rank,'Next rank',next_rank,'Prev rank',prev_rank

   counter: do i = 1, iterations

      even_odd: if( sending_half( rank) )then

!  send rank to next then fetch rank

         coarray[ next_rank] = coarray

         sync images( next_rank)

      else even_odd

!  stay calm

         coarray[ prev_rank] = coarray

         sync images( prev_rank)

      end if even_odd

   end do counter

!   usecs_final = get_usecs()
   call stop_timer()

!   write(*,*) 'usec_init',usec_init,'usec_final',usec_final

   dt = elapsed_time()

   !write(*,*) 'usec_init',usec_init,'usec_final',usec_final,'dt',dt

return

end function loop

! ---------------------------------------------------------------------

subroutine warmup_loop( wa)
integer( int64), intent( in) :: wa

!integer( int64), parameter :: counter = 1000000
integer( int64), parameter :: counter = 10000

   integer( int64) :: min_time_usecs
   integer( int64) :: loop_time

   integer :: i

continue

   min_time_usecs = huge( 0_int64)

   reloop: do i = 1, wa

      loop_time = loop( counter)

      min_time_usecs = min( loop_time, min_time_usecs)

   end do reloop

return

end subroutine warmup_loop

! ---------------------------------------------------------------------

function calibrate_loop( usecs) result( cl)
integer( int64) :: cl
integer( int64), intent( in) :: usecs

integer( int64), parameter :: calibrate_useconds = 100000000
!real( real64), parameter :: preset_tolerance = 0.001_real64
real( real64), parameter :: preset_tolerance = 1.0_real64

integer( int64), parameter :: initial_ntrial = 1000

!integer( int64), parameter :: initial_counter = 1000000
integer( int64), parameter :: initial_counter = 100000

   integer( int64) :: counter
   integer( int64) :: min_time_usecs
   integer( int64) :: tolerance
   integer( int64) :: difference
   integer( int64) :: total_time

   integer( int64) :: ntrial
   integer( int64) :: i

   integer( int64) :: loop_time

continue

   counter = initial_counter

   !write(*,*) 'Counter after initial counter',counter

!  if usecs / granularity is less than 1/preset_tolerance then use zero

   tolerance = int( real( usecs, real64) * preset_tolerance, int64)

   total_time = 0

   trials: do

      ntrial = initial_ntrial
      min_time_usecs = huge( 0_int64)

      get_min: do i = 1, ntrial

         loop_time = loop( counter)
	 !write(*,*) 'loop_time',loop_time
         min_time_usecs = min( min_time_usecs, loop_time)

      end do get_min

!  keep an estimate of total calibration time

      total_time = total_time + min_time_usecs * ntrial

      counter = int( real( counter, real64) * real( usecs, real64) / real( min_time_usecs, real64), int64)

      !write(*,*) 'Counter after assignment',counter

      difference = abs( min_time_usecs - usecs)

      if( difference <= tolerance .or. total_time >= calibrate_useconds ) exit trials

   end do trials

   cl = counter

   write( unit= output_unit, fmt= '( a, i2, a, i10, a, i10, a, i10, a, i10)' ) "#rank= ", rank, &
                                                                           " count= ", counter, " time= ", min_time_usecs, &
                                                                           " difference= ", difference, " tolerance= ", tolerance

   time_out: if( total_time > calibrate_useconds )then

      write( unit= output_unit, fmt= '( a, i2, a, f10.4, a, f10.4, a, f10.4, a, i0)' ) "PSNAP: WARNING rank ", rank, &
                                                                  " didn't converge in 10 seconds tolerance = ",  &
                                                                  real( difference) / real( usecs), &
                                                                  " should be ", preset_tolerance, " approx ", &
                                                                  preset_tolerance * 100.0, " percent, granularity= ", usecs

   end if time_out

return

end function calibrate_loop

! ---------------------------------------------------------------------

subroutine print_banner()

continue

   write( unit= output_unit, fmt= string_fmt) '########'
   write( unit= output_unit, fmt= string_fmt) '##P-SNAP: PAL System Noise Activity Program'
   write( unit= output_unit, fmt= string_fmt) '##' // psnap_rcs_id
   write( unit= output_unit, fmt= string_fmt) '##This is a Fortran translation of P-SNAP v 1.2 from'
   write( unit= output_unit, fmt= string_fmt) '##http://www.c3.lanl.gov/pal/software/psnap/'
   write( unit= output_unit, fmt= string_fmt) '##This program is the coarray ping-pong version'
   write( unit= output_unit, fmt= string_fmt) '########'

return

end subroutine print_banner

! ---------------------------------------------------------------------

subroutine usage()

character( len= *), dimension( 17), parameter :: msg = &
 [ "Usage: psnap [OPTIONS]                                             ", &
   "                                                                   ", &
   "  -n <reps>   number of repetitions                                ", &
   "                default: 100000                                    ", &
   "  -w <reps>   number of warm-up repetitions                        ", &
   "                default: 10%% of the number of reps                ", &
   "  -c <count>  calibration count                                    ", &
   "                default: perform a calibration to match granularity", &
   "  -g <usecs>  granularity of the test in microseconds              ", &
   "                default: 1000                                      ", &
   "  -b <N>      perform a barrier between every N loops              ", &
   "                default: no                                        ", &
   "  -h          this message                                         ", &
   "                                                                   ", &
   "  Example: psnap -n 1000000 -w 10 > psnap.out                      ", &
   "    runs a test with 1000000 repetitions and 10 warm-up reps.      ", &
   "                                                                   " ]

   integer :: i

continue

   write( unit= error_unit, fmt= string_fmt) ( trim( msg( i)), i = 1, size( msg, 1))

stop 'normal exit in usage'

end subroutine usage

! ---------------------------------------------------------------------

function sending_half( i) result( l)

integer, intent( in) :: i
logical :: l

continue

!  this must process np == even values only

   l = i <= np_half

return

end function sending_half

! ---------------------------------------------------------------------

function to_upper_half( i) result( l)

integer, intent( in) :: i
integer :: l

continue

!  this must process lower half ranks only

   l = i + np_half

return

end function to_upper_half

! ---------------------------------------------------------------------

function from_lower_half( i) result( l)

integer, intent( in) :: i
integer :: l

continue

!  this must process upper half ranks only

   l = i - np_half

return

end function from_lower_half

! ---------------------------------------------------------------------

end program psnap

program teams_coarray_get_by_ref
  use, intrinsic :: iso_fortran_env, only: team_type
  implicit none
  type(team_type) :: team
  type :: allocatable_array_t
    integer, allocatable :: A(:)
  end type
  type(allocatable_array_t) :: R[*]
  integer, allocatable :: L(:)
  integer :: i, my_team

  ! handle odd or even number of images
  allocate(L(num_images()/2+mod(num_images(),2)*mod(this_image(),2)))

  my_team = mod(this_image()-1,2)+1

  form team (my_team, team)

  ! size(R%A) == this_image(team)
  allocate(R%A((this_image()+1)/2), source=0)

  R%A(ubound(R%A,1)) = this_image()

  change team (team)
    do i = 1, num_images()
      L(i) = R[i]%A(i)
    end do
  end team

  if (any(L /= [(i, i=my_team, num_images(), 2)])) error stop 'Test failed.'

  sync all

  if (this_image() == 1) write(*,*) 'Test passed.'
end program teams_coarray_get_by_ref

program sync_image_ring_abort_on_stopped_image
  !! `SYNC IMAGES([this_image - 1, this_image + 1])` with
  !! `STAT=STAT_STOPPED_IMAGE` specifier on a periodic ring.  The test
  !! checks that syncing in a ring with a stopped image still
  !! terminates all images. All images other than image 1 participate
  !! in the `sync images()` call

  use, intrinsic:: iso_fortran_env
  implicit none

  integer :: stat_var = 0

  if (num_images() .lt. 3) error stop "Need at least three images to test."

  associate (me => this_image())
    if (me == 1) then
       continue !! image 1 does not participate and exits, creating a stopped image
    else
       associate (lhs => merge(me - 1, num_images(), me /= 1), &
              rhs => merge(me + 1, 1, me /= num_images()))
         sync images([lhs, rhs], STAT=stat_var)
         !! Only images bordering image 1 (i.e., 2 and `num_images()`) can
         !! accurately test whether a stopped image is present. All other
         !! images could be up ahead.
         if (stat_var /= STAT_STOPPED_IMAGE .and. me == 2) &
              error stop "Error: stat_var /= STAT_STOPPED_IMAGE: "
         if (stat_var /= STAT_STOPPED_IMAGE .and. me == num_images()) &
              error stop "Error: stat_var /= STAT_STOPPED_IMAGE: "
         if(me == 2) print *, 'Test passed.'
       end associate
    end if
  end associate
end program

! This program tests the capability of copying data on the
! same memory location and within the same image from
! different memory locations.
! NOTE:
! In order to run this test successfully the efficient
! strided transfer support must be disabled.
program sameloc
  implicit none

  integer,codimension[*] :: a
  integer,dimension(10),codimension[*] :: b,c
  integer,dimension(9,10),codimension[*] :: m
  integer,dimension(10) :: t
  integer :: i,j

  a = 10
  b(1:5) = 1
  b(6:10) = -1
  c(1:5) = 1
  c(6:10) = -1

  t(:) = b(:)
  t(1:5) = b(2:6)

  do i=1,9
    m(i,:) = (/ (j, j = 1, 10) /)
  enddo

  sync all

  a = a[1]
  if (this_image() == 1) write(*,*) 'OK',a

  t = (/ (j, j = 1, 10) /)

  if(this_image() == 1) then
    c = m(1,:)[1]
    if(any(c(:) /= t(:))) then
      call abort()
    else
      write(*,*) 'ok get row'
    endif
  endif

  sync all

  if(this_image() == 1) then
    do i=1,10
      if(m(9,i)[1] /= t(i)) then
	write(*,*) 'pos',i,'value get',m(9,i)[1],'value t',t(i)
	call abort()
      endif
    enddo
  endif

  if(this_image() == 1) write(*,*) 'Ok get element from matrix'

  sync all

  m(9,:) = 1

  if(this_image() == 1) then
    do i=1,10
      m(9,i)[1] = i
      if(m(9,i)[1] /= t(i)) then
        write(*,*) 'pos',i,'value get',m(9,i)[1],'value t',t(i)
        call abort()
      endif
    enddo
  endif

  if(this_image() == 1 ) write(*,*) 'Ok put element from matrix'

  t(:) = b(:)
  t(1:5) = b(2:6)

  c(1:5) = 1
  c(6:10) = -1

  sync all

  if(this_image() == 1) then
    b(1:5)[1] = b(2:6)
    if(any(b(:) /= t(:))) then
      call abort()
    else
      write(*,*) 'OK put overlapped'
    endif
  endif

  b(1:5) = 1
  b(6:10) = -1

  sync all

  if(this_image() == 1) then
    b(1:5)[1] = b(2:6)[1]
    if(any(b(:) /= t(:))) then
      call abort()
    else
      write(*,*) 'OK putget overlapped'
    endif
  endif

  t(:) = c(:)
  t(10:1:-1) = t(:)

  sync all

  if(this_image() == 1) then
    c(10:1:-1)[1] = c(:)
    if(any(t(:) /= c(:))) then
      write(*,*) 'Error in put reversed'
      write(*,*) c
      write(*,*) t
      call abort()
    else
      write(*,*) 'OK put reversed'
    endif
  endif

  c(1:5) = 1
  c(6:10) = -1

  t(:) = c(:)
  t(10:1:-1) = t(:)

  if(this_image() == 1) then
    c(:) = c(10:1:-1)[1]
    if(any(t(:) /= c(:))) then
      write(*,*) c
      write(*,*) t
      call abort()
    else
      write(*,*) 'OK get reversed'
    endif
  endif

end program

!
! This program does a correctness check for
! ARRAY[idx] = SCALAR, ARRAY[idx] = ARRAY and SCALAR[idx] = SCALAR
!
program main
  implicit none
  integer, parameter :: n = 3
  integer, parameter :: m = 4

  ! Allocatable coarrays
  call one(-5, 1)
  call one(0, 0)
  call one(1, -5)
  call one(0, -11)

  ! Static coarrays
  call two()
  call three()
  write(*,*) 'Test passed'
contains
  subroutine one(lb1, lb2)
    integer, value :: lb1, lb2

    integer :: i_sgn1, i_sgn2, i, i_e, i_s, j, j_e, j_s
    integer, allocatable :: caf(:,:)[:]
    integer, allocatable :: a(:,:), b(:,:)

    allocate(caf(lb1:n+lb1-1, lb2:m+lb2-1)[*], &
         a(lb1:n+lb1-1, lb2:m+lb2-1), &
         b(lb1:n+lb1-1, lb2:m+lb2-1))

    b = reshape([(i*33, i = 1, size(b))], shape(b))

    ! Whole array: ARRAY = SCALAR
    caf = -42
    a = -42
    a(:,:) = b(lb1, lb2)
    sync all
    if (this_image() == 1) then
      caf(:,:)[num_images()] = b(lb1, lb2)
    end if
    sync all
    if (this_image() == num_images()) then
      if (any (a /= caf)) &
           call abort()
    end if

    ! Whole array: ARRAY = ARRAY
    caf = -42
    a = -42
    a(:,:) = b(:, :)
    sync all
    if (this_image() == 1) then
      caf(:,:)[num_images()] = b(:, :)
    end if
    sync all
    if (this_image() == num_images()) then
      if (any (a /= caf)) &
           call abort()
    end if

    ! Scalar assignment
    caf = -42
    a = -42
    do j = lb2, m+lb2-1
      do i = n+lb1-1, 1, -2
        a(i,j) = b(i,j)
      end do
    end do
    do j = lb2, m+lb2-1
      do i = 1, n+lb1-1, 2
        a(i,j) = b(i,j)
      end do
    end do
    sync all
    if (this_image() == 1) then
      do j = lb2, m+lb2-1
        do i = n+lb1-1, 1, -2
          caf(i,j)[num_images()] = b(i, j)
        end do
      end do
      do j = lb2, m+lb2-1
        do i = 1, n+lb1-1, 2
          caf(i,j)[num_images()] = b(i, j)
        end do
      end do
    end if
    sync all
    if (this_image() == num_images()) then
      if (any (a /= caf)) &
           call abort()
    end if

    ! Array sections with different ranges and pos/neg strides
    do i_sgn1 = -1, 1, 2
      do i_sgn2 = -1, 1, 2
        do i=lb1, n+lb1-1
          do i_e=lb1, n+lb1-1
            do i_s=1, n
              do j=lb2, m+lb2-1
                do j_e=lb2, m+lb2-1
                  do j_s=1, m
                    ! ARRAY = SCALAR
                    caf = -42
                    a = -42
                    a(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2) = b(lb1, lb2)
                    sync all
                    if (this_image() == 1) then
                      caf(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2)[num_images()] &
                           = b(lb1, lb2)
                    end if
                    sync all

                    ! ARRAY = ARRAY
                    caf = -42
                    a = -42
                    a(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2) &
                         = b(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2)
                    sync all
                    if (this_image() == 1) then
                      caf(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2)[num_images()] &
                           = b(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2)
                    end if
                    sync all

                    if (this_image() == num_images()) then
                      if (any (a /= caf)) then
                        print '(*(g0))', "bounds: ", lb1,":",n+lb1-1,", ", &
                             lb2,":",m+lb2-1
                        print '(*(g0))', "section: ", i,":",i_e,":",i_s*i_sgn1, &
                             ", ", j,":",j_e,":",j_s*i_sgn2
                        print *, i
                        print *, a
                        print *, caf
                        print *, a-caf
                        call abort()
                      endif
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      end do
    end do
  end subroutine one

  subroutine two()
    integer, parameter :: lb1 = -5, lb2 = 1

    integer :: i_sgn1, i_sgn2, i, i_e, i_s, j, j_e, j_s
    integer, save :: caf(lb1:n+lb1-1, lb2:m+lb2-1)[*]
    integer, save :: a(lb1:n+lb1-1, lb2:m+lb2-1)
    integer, save :: b(lb1:n+lb1-1, lb2:m+lb2-1)

    b = reshape([(i*33, i = 1, size(b))], shape(b))

    ! Whole array: ARRAY = SCALAR
    caf = -42
    a = -42
    a(:,:) = b(lb1, lb2)
    sync all
    if (this_image() == 1) then
      caf(:,:)[num_images()] = b(lb1, lb2)
    end if
    sync all
    if (this_image() == num_images()) then
      if (any (a /= caf)) &
           call abort()
    end if

    ! Whole array: ARRAY = ARRAY
    caf = -42
    a = -42
    a(:,:) = b(:, :)
    sync all
    if (this_image() == 1) then
      caf(:,:)[num_images()] = b(:, :)
    end if
    sync all
    if (this_image() == num_images()) then
      if (any (a /= caf)) &
           call abort()
    end if

    ! Scalar assignment
    caf = -42
    a = -42
    do j = lb2, m+lb2-1
      do i = n+lb1-1, 1, -2
        a(i,j) = b(i,j)
      end do
    end do
    do j = lb2, m+lb2-1
      do i = 1, n+lb1-1, 2
        a(i,j) = b(i,j)
      end do
    end do
    sync all
    if (this_image() == 1) then
      do j = lb2, m+lb2-1
        do i = n+lb1-1, 1, -2
          caf(i,j)[num_images()] = b(i, j)
        end do
      end do
      do j = lb2, m+lb2-1
        do i = 1, n+lb1-1, 2
          caf(i,j)[num_images()] = b(i, j)
        end do
      end do
    end if
    sync all
    if (this_image() == num_images()) then
      if (any (a /= caf)) &
           call abort()
    end if

    ! Array sections with different ranges and pos/neg strides
    do i_sgn1 = -1, 1, 2
      do i_sgn2 = -1, 1, 2
        do i=lb1, n+lb1-1
          do i_e=lb1, n+lb1-1
            do i_s=1, n
              do j=lb2, m+lb2-1
                do j_e=lb2, m+lb2-1
                  do j_s=1, m
                    ! ARRAY = SCALAR
                    caf = -42
                    a = -42
                    a(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2) = b(lb1, lb2)
                    sync all
                    if (this_image() == 1) then
                      caf(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2)[num_images()] &
                           = b(lb1, lb2)
                    end if
                    sync all

                    ! ARRAY = ARRAY
                    caf = -42
                    a = -42
                    a(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2) &
                         = b(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2)
                    sync all
                    if (this_image() == 1) then
                      caf(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2)[num_images()] &
                           = b(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2)
                    end if
                    sync all

                    if (this_image() == num_images()) then
                      if (any (a /= caf)) then
                        print '(*(g0))', "bounds: ", lb1,":",n+lb1-1,", ", &
                             lb2,":",m+lb2-1
                        print '(*(g0))', "section: ", i,":",i_e,":",i_s*i_sgn1, &
                             ", ", j,":",j_e,":",j_s*i_sgn2
                        print *, i
                        print *, a
                        print *, caf
                        print *, a-caf
                        call abort()
                      endif
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      end do
    end do
  end subroutine two

  subroutine three()
    integer, parameter :: lb1 = 0, lb2 = 0

    integer :: i_sgn1, i_sgn2, i, i_e, i_s, j, j_e, j_s
    integer, save :: caf(lb1:n+lb1-1, lb2:m+lb2-1)[*]
    integer, save :: a(lb1:n+lb1-1, lb2:m+lb2-1)
    integer, save :: b(lb1:n+lb1-1, lb2:m+lb2-1)

    b = reshape([(i*33, i = 1, size(b))], shape(b))

    ! Whole array: ARRAY = SCALAR
    caf = -42
    a = -42
    a(:,:) = b(lb1, lb2)
    sync all
    if (this_image() == 1) then
      caf(:,:)[num_images()] = b(lb1, lb2)
    end if
    sync all
    if (this_image() == num_images()) then
      if (any (a /= caf)) &
           call abort()
    end if

    ! Whole array: ARRAY = ARRAY
    caf = -42
    a = -42
    a(:,:) = b(:, :)
    sync all
    if (this_image() == 1) then
      caf(:,:)[num_images()] = b(:, :)
    end if
    sync all
    if (this_image() == num_images()) then
      if (any (a /= caf)) &
           call abort()
    end if

    ! Scalar assignment
    caf = -42
    a = -42
    do j = lb2, m+lb2-1
      do i = n+lb1-1, 1, -2
        a(i,j) = b(i,j)
      end do
    end do
    do j = lb2, m+lb2-1
      do i = 1, n+lb1-1, 2
        a(i,j) = b(i,j)
      end do
    end do
    sync all
    if (this_image() == 1) then
      do j = lb2, m+lb2-1
        do i = n+lb1-1, 1, -2
          caf(i,j)[num_images()] = b(i, j)
        end do
      end do
      do j = lb2, m+lb2-1
        do i = 1, n+lb1-1, 2
          caf(i,j)[num_images()] = b(i, j)
        end do
      end do
    end if
    sync all
    if (this_image() == num_images()) then
      if (any (a /= caf)) &
           call abort()
    end if

    ! Array sections with different ranges and pos/neg strides
    do i_sgn1 = -1, 1, 2
      do i_sgn2 = -1, 1, 2
        do i=lb1, n+lb1-1
          do i_e=lb1, n+lb1-1
            do i_s=1, n
              do j=lb2, m+lb2-1
                do j_e=lb2, m+lb2-1
                  do j_s=1, m
                    ! ARRAY = SCALAR
                    caf = -42
                    a = -42
                    a(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2) = b(lb1, lb2)
                    sync all
                    if (this_image() == 1) then
                      caf(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2)[num_images()] &
                           = b(lb1, lb2)
                    end if
                    sync all

                    ! ARRAY = ARRAY
                    caf = -42
                    a = -42
                    a(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2) &
                         = b(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2)
                    sync all
                    if (this_image() == 1) then
                      caf(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2)[num_images()] &
                           = b(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2)
                    end if
                    sync all

                    if (this_image() == num_images()) then
                      if (any (a /= caf)) then
                        print '(*(g0))', "bounds: ", lb1,":",n+lb1-1,", ", &
                             lb2,":",m+lb2-1
                        print '(*(g0))', "section: ", i,":",i_e,":",i_s*i_sgn1, &
                             ", ", j,":",j_e,":",j_s*i_sgn2
                        print *, i
                        print *, a
                        print *, caf
                        print *, a-caf
                        call abort()
                      endif
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      end do
    end do
  end subroutine three
end program main

program get_offset_1d
  implicit none

  integer,allocatable :: a(:)[:],b(:)
  integer :: me,np,i

  me = this_image()
  np = num_images()

  allocate(a(100)[*],b(10))

  a = (/ (i, i=1,100) /)

  do i=1,100
    a(i) = a(i) + me
  enddo

  sync all

  if(me < np) then
    b(:) = a(21:30)[me+1]
  endif

  if(me == 1) then
    do i=1,10
      if(b(i) /= 20+i+me+1) call abort()
    enddo
    write(*,*) 'Test passed.'
  endif

end program

program main
   !! OpenCoarrays issue #488 MWE
   !! ===========================
   !!
   !! https://github.com/sourceryinstitute/OpenCoarrays/issues/488
   !!
   !! Running with 8 images, scattering from rank 1 fails when using a coarray
   !! in a derived type, whereas we observe no issue with pure coarrays.
   !!
   !! Should be run with 8 images as follows:
   !!    cafrun -np 8 ./a.out false
   !!    cafrun -np 8 ./a.out true
   implicit none

   type co_arr
      real, allocatable :: a(:, :)[:, :]
   end type

   type(co_arr) :: co1 ! derived type with coarray
   real, allocatable :: co2(:, :)[:, :] ! pure coarray
   real, allocatable :: glob(:, :), buf2d(:, :)
   integer, parameter :: nx = 2, ny = 3 ! local chunk, same over all images
   integer :: me, nimg, mx, my, i, j, k
   character(len = *), parameter :: tab = char(9), nl = char(10)
   character(len = 10) :: arg
   logical :: switch, test_passed

   test_passed = .false.
   call get_command_argument(1, arg)
   read (arg, '(L)') switch

   me = this_image()
   nimg = num_images()
   mx = nimg / 2 ! 2d grid distribution
   my = nimg / mx

   if (nimg /= 8) then
      stop 'example for 8 images'
   end if

   allocate(co1 % a(nx, ny)[mx, *])
   allocate(co2(nx, ny)[mx, *])
   allocate(buf2d(nx, ny), glob(mx * nx, my * ny))

   if (me == 1) print *, 'global size', [(mx * nx), (my * ny)], nl, 'local size', [nx, ny]

   ! call random_number(glob)
   glob = reshape([(i, i = 1, (mx * nx) * (my * ny))], shape(glob))

   sync all ! separate segments
   if (me == 1) then
      ! scatter glob from root (1st image)

      ! local to local
      co1 % a = glob(:nx, :ny)
      co2 = glob(:nx, :ny)

      ! loop over all other images
      do i = 1, mx
         do j = 1, my
            k = image_index(co2, [i, j])
            if (k /= 1) then
               buf2d = glob((i - 1) * nx + 1:i * nx, (j - 1) * ny + 1:j * ny) ! send buffer
               ! print *, 'filling up image #', k, '[', [i, j], ']', nl, tab, '==>', buf2d, nl
               if (switch) then
                  co1 % a(:nx, :ny)[i, j] = buf2d ! <= failure
               else
                  co2(:nx, :ny)[i, j] = buf2d ! ok
               end if
            end if
         end do
      end do
   end if
   sync all

   ! output local arrays after scattering
   ! print *, me, 'co1', co1 % a, nl, me, 'co2', co2

   ! collect results on rank 1
   call co_sum(co1 % a, result_image = 1)
   call co_sum(co2, result_image = 1)

   sync all
   test_passed = abs(sum(glob) - sum(merge(co1 % a, co2, switch))) < epsilon(0.)
   if (me == 1) then
      print *, 'all close ?', test_passed
      if(test_passed) then
         write(*,*) 'Test passed.'
      else
         write(*,*) 'Test failed!'
      endif
   end if
   deallocate(co1 % a, co2, glob)
end program

! Fortran 2015 feature support for Fortran 2008 compilers
!
! Copyright (c) 2015-2016, Sourcery, Inc.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of the Sourcery, Inc., nor the
!       names of its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE FOR ANY
! DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
module opencoarrays
#ifdef COMPILER_SUPPORTS_ATOMICS
  use iso_fortran_env, only : atomic_int_kind
#endif
  use iso_c_binding, only : c_int,c_char,c_ptr,c_loc,c_double,c_int32_t,c_ptrdiff_t,c_sizeof,c_bool,c_funloc
  implicit none

#ifndef MPI_WORKING_MODULE
  include 'mpif.h'
#endif

  private
  public :: co_reduce
  public :: co_broadcast
  public :: co_sum
  public :: co_min
  public :: co_max
  public :: this_image
  public :: num_images
  public :: error_stop
  public :: sync_all
  public :: team_number
#ifdef HAVE_MPI
  public :: get_communicator
#endif
#ifdef COMPILER_SUPPORTS_ATOMICS
  public :: event_type
  public :: event_post

  type event_type
    private
    integer(atomic_int_kind), allocatable :: atom[:]
  end type
#endif
#ifdef EXPOSE_INIT_FINALIZE
  public :: caf_init
  public :: caf_finalize
#endif

  ! Generic interface to co_broadcast with implementations for various types, kinds, and ranks
  interface co_reduce
     module procedure co_reduce_c_int,co_reduce_c_double,co_reduce_logical
  end interface

  ! Generic interface to co_broadcast with implementations for various types, kinds, and ranks
  interface co_broadcast
     module procedure co_broadcast_c_int,co_broadcast_c_double,co_broadcast_c_char
  end interface

  ! Generic interface to co_sum with implementations for various types, kinds, and ranks
  interface co_sum
     module procedure co_sum_c_int,co_sum_c_double
  end interface

  ! Generic interface to co_sum with implementations for various types, kinds, and ranks
  interface co_min
     module procedure co_min_c_int,co_min_c_double
  end interface

  ! Generic interface to co_sum with implementations for various types, kinds, and ranks
  interface co_max
     module procedure co_max_c_int,co_max_c_double
  end interface

  abstract interface
     pure function c_int_operator(lhs,rhs) result(lhs_op_rhs)
       import c_int
       integer(c_int), intent(in) :: lhs,rhs
       integer(c_int) :: lhs_op_rhs
     end function
     pure function c_double_operator(lhs,rhs) result(lhs_op_rhs)
       import c_double
       real(c_double), intent(in) :: lhs,rhs
       real(c_double) :: lhs_op_rhs
     end function
     pure function logical_operator(lhs,rhs) result(lhs_op_rhs)
       logical, intent(in) :: lhs,rhs
       logical :: lhs_op_rhs
     end function
  end interface

  interface
#ifdef COMPILER_SUPPORTS_CAF_INTRINSICS
    function team_number(team_type_ptr) result(my_team_number) bind(C,name="_caf_extensions_team_number")
#else
    function team_number(team_type_ptr) result(my_team_number) bind(C,name="_gfortran_caf_team_number")
#endif
       use iso_c_binding, only : c_int,c_ptr
       implicit none
       type(c_ptr), optional :: team_type_ptr
       integer(c_int) :: my_team_number
    end function

#ifdef COMPILER_SUPPORTS_CAF_INTRINSICS
    function get_communicator(team_type_ptr) result(my_team) bind(C,name="_caf_extensions_get_communicator")
#else
    function get_communicator(team_type_ptr) result(my_team) bind(C,name="_gfortran_caf_get_communicator")
#endif
       use iso_c_binding, only : c_int,c_ptr
       implicit none
       type(c_ptr), optional :: team_type_ptr
       integer(c_int) :: my_team
    end function
  end interface


  ! __________ End Public Interface _____________


  ! __________ Begin Private Implementation _____

  ! Enumeration from ../libcaf-gfortran-descriptor.h:
  !  enum
  !{ BT_UNKNOWN = 0, BT_INTEGER, BT_LOGICAL, BT_REAL, BT_COMPLEX,
  !  BT_DERIVED, BT_CHARACTER, BT_CLASS, BT_PROCEDURE, BT_HOLLERITH, BT_VOID,
  !  BT_ASSUMED
  !};

  enum ,bind(C)
    enumerator :: &
     BT_UNKNOWN = 0, BT_INTEGER, BT_LOGICAL, BT_REAL, BT_COMPLEX, &
     BT_DERIVED, BT_CHARACTER, BT_CLASS, BT_PROCEDURE, BT_HOLLERITH, BT_VOID, &
     BT_ASSUMED
  end enum

  ! Type definition from ../libcaf-gfortran-descriptor.h:
  !typedef struct descriptor_dimension
  !{
  !  ptrdiff_t _stride;
  !  ptrdiff_t lower_bound;
  !  ptrdiff_t _ubound;
  !}
  !descriptor_dimension;

  ! Fortran derived type interoperable with like-named C type:
  type, bind(C) :: descriptor_dimension
     integer(c_ptrdiff_t) :: stride
     integer(c_ptrdiff_t) :: lower_bound
     integer(c_ptrdiff_t) :: ubound_
  end type

  ! Type definition from ../libcaf-gfortran-descriptor.h:
  !typedef struct gfc_descriptor_t {
  !  void *base_addr;
  !  size_t offset;
  !  ptrdiff_t dtype;
  !  descriptor_dimension dim[];
  !} gfc_descriptor_t;

  integer, parameter :: max_dimensions=15

  ! Fortran derived type interoperable with like-named C type:
  type, bind(C) :: gfc_descriptor_t
    type(c_ptr) :: base_addr
    integer(c_ptrdiff_t) :: offset
    integer(c_ptrdiff_t) :: dtype
    type(descriptor_dimension) :: dim_(max_dimensions)
  end type

  ! C comment and source from ../libcaf.h
  ! /* When there is a vector subscript in this dimension, nvec == 0, otherwise,
  ! lower_bound, upper_bound, stride contains the bounds relative to the declared
  ! bounds; kind denotes the integer kind of the elements of vector[].  */
  ! type, bind(C) :: caf_vector_t {
  !   size_t nvec;
  !   union {
  !     struct {
  !       void *vector;
  !       int kind;
  !     } v;
  !     struct {
  !       ptrdiff_t lower_bound, upper_bound, stride;
  !     } triplet;
  !   } u;
  ! }
  ! caf_vector_t;

  type, bind(C) :: v_t
    type(c_ptr) :: vector
    integer(c_int) :: kind_
  end type

  type, bind(C) :: triplet_t
    integer(c_ptrdiff_t) :: lower_bound, upper_bound, stride
  end type

  type, bind(C) :: u_t
     type(v_t) :: v
     type(triplet_t) :: triplet
  end type

  type, bind(C) :: caf_vector_t
    integer(c_ptrdiff_t) :: nvec
    type(u_t) :: u
  end type

  ! --------------------

  integer(c_int), save, volatile, bind(C,name="CAF_COMM_WORLD") :: CAF_COMM_WORLD
  integer(c_int32_t), parameter  :: bytes_per_word=4_c_int32_t

  interface gfc_descriptor
    module procedure gfc_descriptor_c_int,gfc_descriptor_c_double,gfc_descriptor_logical
  end interface

  ! Bindings for OpenCoarrays C procedures
  interface

    ! C function signature from ../mpi/mpi_caf.c:
    ! void
    ! PREFIX (init) (int *argc, char ***argv)
#ifdef COMPILER_SUPPORTS_CAF_INTRINSICS
    subroutine caf_init(argc,argv) bind(C,name="_caf_extensions_init")
#else
    subroutine caf_init(argc,argv) bind(C,name="_gfortran_caf_init")
#endif
      import :: c_int,c_ptr
      type(c_ptr), value :: argc
      type(c_ptr), value :: argv
    end subroutine

    ! C function signature from ../mpi/mpi_caf.c:
    ! void
    ! PREFIX (finalize) (void)
#ifdef COMPILER_SUPPORTS_CAF_INTRINSICS
    subroutine caf_finalize() bind(C,name="_caf_extensions_finalize")
#else
    subroutine caf_finalize() bind(C,name="_gfortran_caf_finalize")
#endif
    end subroutine

    ! C function signature from ../mpi/mpi_caf.c:
    ! void
    ! PREFIX (co_min) (gfc_descriptor_t *a, int result_image, int *stat, char *errmsg,
    !                  int src_len, int errmsg_len)
#ifdef COMPILER_SUPPORTS_CAF_INTRINSICS
    subroutine opencoarrays_co_min(a,result_image, stat, errmsg, unused , errmsg_len) bind(C,name="_caf_extensions_co_min")
#else
    subroutine opencoarrays_co_min(a,result_image, stat, errmsg, unused, errmsg_len) bind(C,name="_gfortran_caf_co_min")
#endif
      import :: c_int,c_char,c_ptr
      type(c_ptr), intent(in), value :: a
      integer(c_int), intent(in),  value :: result_image,errmsg_len,unused
      integer(c_int), intent(out), optional, volatile :: stat
      character(kind=c_char), intent(out), optional, volatile :: errmsg(*)
    end subroutine

    ! C function signature from ../mpi/mpi_caf.c
    ! void
    ! PREFIX (co_reduce) (gfc_descriptor_t *a, void *(*opr) (void *, void *), int opr_flags,
    !                     int result_image, int *stat, char *errmsg, int a_len, int errmsg_len)
    subroutine opencoarrays_co_reduce(a, opr, opr_flags, result_image, stat, errmsg, a_len, errmsg_len) &
#ifdef COMPILER_SUPPORTS_CAF_INTRINSICS
      bind(C,name="_caf_extensions_co_reduce")
#else
      bind(C,name="_gfortran_caf_co_reduce")
#endif
      use iso_c_binding, only : c_ptr,c_funptr,c_int,c_char
      type(c_ptr), intent(in), value :: a
      type(c_funptr), intent(in), value :: opr
      integer(c_int), intent(in), value :: opr_flags,result_image
      integer(c_int), intent(out) :: stat
      character(kind=c_char), intent(out), optional, volatile :: errmsg(*)
      integer(c_int), intent(in), value :: a_len
      integer(c_int), intent(in), value :: errmsg_len
    end subroutine

    ! C function signature from ../mpi/mpi_caf.c:
    ! void
    ! PREFIX (get) (caf_token_t token, size_t offset,
    !              int image_index,
    !              gfc_descriptor_t *src ,
    !              caf_vector_t *src_vector __attribute__ ((unused)),
    !              gfc_descriptor_t *dest, int src_kind, int dst_kind,
    !              bool mrt)
    subroutine opencoarrays_get(token, offset, image_index_, src, src_vector_unused, dest, src_kind, dst_kind, mrt) &
#ifdef COMPILER_SUPPORTS_CAF_INTRINSICS
      bind(C,name="_caf_extensions_get")
#else
      bind(C,name="_gfortran_caf_get")
#endif
      import c_ptrdiff_t,c_int,gfc_descriptor_t,c_bool,caf_vector_t,c_ptr
      type(c_ptr), value :: token
      integer(c_ptrdiff_t), value :: offset
      integer(c_int), value :: image_index_
      type(gfc_descriptor_t) :: src
      type(caf_vector_t) :: src_vector_unused
      type(gfc_descriptor_t) :: dest
      integer(c_int), value :: src_kind
      integer(c_int), value :: dst_kind
      logical(c_bool), value :: mrt
    end subroutine

    ! C function signature from ../mpi/mpi_caf.c:
    ! void
    ! PREFIX (co_max) (gfc_descriptor_t *a, int result_image, int *stat,
    !                  char *errmsg, int src_len, int errmsg_len)
#ifdef COMPILER_SUPPORTS_CAF_INTRINSICS
    subroutine opencoarrays_co_max(a,result_image, stat, errmsg, unused, errmsg_len) bind(C,name="_caf_extensions_co_max")
#else
    subroutine opencoarrays_co_max(a,result_image, stat, errmsg, unused, errmsg_len) bind(C,name="_gfortran_caf_co_max")
#endif
      import :: c_int,c_char,c_ptr
      type(c_ptr), intent(in), value :: a
      integer(c_int), intent(in),  value :: result_image,errmsg_len,unused
      integer(c_int), intent(out), optional :: stat
      character(kind=c_char), intent(out), optional :: errmsg(*)
    end subroutine

    ! C function signature from ../mpi/mpi_caf.c:
    ! void
    ! PREFIX (co_sum) (gfc_descriptor_t *a, int result_image, int *stat, char *errmsg,
    !                  int errmsg_len)
#ifdef COMPILER_SUPPORTS_CAF_INTRINSICS
    subroutine opencoarrays_co_sum(a, result_image, stat, errmsg, errmsg_len) bind(C,name="_caf_extensions_co_sum")
#else
    subroutine opencoarrays_co_sum(a, result_image, stat, errmsg, errmsg_len) bind(C,name="_gfortran_caf_co_sum")
#endif
      import :: c_int,c_char,c_ptr
      type(c_ptr), intent(in), value :: a
      integer(c_int), intent(in),  value :: result_image,errmsg_len
      integer(c_int), intent(out), optional :: stat
      character(kind=c_char), intent(out), optional :: errmsg(*)
    end subroutine

    ! C function signature from ../mpi/mpi_caf.c
    ! void
    ! PREFIX (co_broadcast) (gfc_descriptor_t *a, int source_image, int *stat, char *errmsg,
    !                  int errmsg_len)
#ifdef COMPILER_SUPPORTS_CAF_INTRINSICS
    subroutine opencoarrays_co_broadcast(a,source_image, stat, errmsg, errmsg_len) bind(C,name="_caf_extensions_co_broadcast")
#else
    subroutine opencoarrays_co_broadcast(a,source_image, stat, errmsg, errmsg_len) bind(C,name="_gfortran_caf_co_broadcast")
#endif
      import :: c_int,c_char,c_ptr
      type(c_ptr), intent(in), value :: a
      integer(c_int), intent(in),  value :: source_image,errmsg_len
      integer(c_int), intent(out), optional :: stat
      character(kind=c_char), intent(out), optional :: errmsg(*)
    end subroutine

    ! C function signature from ../mpi/mpi_caf.c:
    ! int PREFIX (this_image) (int);
    function opencoarrays_this_image(coarray) bind(C,name="_gfortran_caf_this_image") result(image_num)
      import :: c_int
      integer(c_int), value, intent(in) :: coarray
      integer(c_int)  :: image_num
    end function

    ! C function signature from ../mpi/mpi_caf.c:
    ! int PREFIX (num_images) (int, int);
    function opencoarrays_num_images(coarray,dim_) bind(C,name="_gfortran_caf_num_images") result(num_images_)
      import :: c_int
      integer(c_int), value, intent(in) :: coarray,dim_
      integer(c_int) :: num_images_
    end function

    ! C function signature from ../mpi_caf.c
    ! void PREFIX (error_stop) (int32_t) __attribute__ ((noreturn));
#ifdef COMPILER_SUPPORTS_CAF_INTRINSICS
    subroutine opencoarrays_error_stop(stop_code) bind(C,name="_caf_extensions_error_stop")
#else
    subroutine opencoarrays_error_stop(stop_code) bind(C,name="_gfortran_caf_error_stop")
#endif
      import :: c_int32_t
      integer(c_int32_t), value, intent(in) :: stop_code
    end subroutine

    ! C function signature from ../mpi_caf.c
    ! void PREFIX (sync_all) (int *, char *, int);
#ifdef COMPILER_SUPPORTS_CAF_INTRINSICS
    subroutine opencoarrays_sync_all(stat,errmsg,unused) bind(C,name="_caf_extensions_sync_all")
#else
    subroutine opencoarrays_sync_all(stat,errmsg,unused) bind(C,name="_gfortran_caf_sync_all")
#endif
      import :: c_int,c_char
      integer(c_int), intent(out) :: stat,unused
      character(c_char), intent(out) :: errmsg(*)
    end subroutine

  end interface


contains

  ! __________ Descriptor constructors for for each supported type and kind ____________
  ! ____________________________________________________________________________________

  function my_dtype(type_,kind_,rank_) result(dtype_)
    integer,parameter :: GFC_DTYPE_SIZE_SHIFT = 8, GFC_DTYPE_TYPE_SHIFT=3
    integer(c_int32_t), intent(in) :: type_,kind_,rank_
    integer(c_int32_t) :: dtype_

    ! SIZE Type Rank
    ! 0000  000  000

    ! Rank is represented in the 3 least significant bits
    dtype_ = ior(0_c_int32_t,rank_)
    ! The next three bits represent the type id as expressed in libcaf-gfortran-descriptor.h
    dtype_ = ior(dtype_,ishft(type_,GFC_DTYPE_TYPE_SHIFT))
    ! The most significant bits represent the size of a the type (single or double precision).
    ! We can express the precision in terms of 32-bit words: 1 for single, 2 for double.
    dtype_ = ior(dtype_,ishft(kind_,GFC_DTYPE_SIZE_SHIFT))

  end function

  function gfc_descriptor_c_int(a) result(a_descriptor)
    integer(c_int), intent(in), target, contiguous :: a(..)
    type(gfc_descriptor_t) :: a_descriptor
    integer(c_int), parameter :: unit_stride=1,scalar_offset=-1
    integer(c_int) :: i

    a_descriptor%dtype = my_dtype(type_=BT_INTEGER,kind_=int(c_sizeof(a)/bytes_per_word,c_int32_t),rank_=rank(a))
    a_descriptor%offset = scalar_offset
    a_descriptor%base_addr = c_loc(a) ! data
    do concurrent(i=1:rank(a))
      a_descriptor%dim_(i)%stride  = unit_stride
      a_descriptor%dim_(i)%lower_bound = lbound(a,i)
      a_descriptor%dim_(i)%ubound_ = ubound(a,i)
    end do

  end function

  function gfc_descriptor_logical(a) result(a_descriptor)
    logical, intent(in), target, contiguous :: a(..)
    type(gfc_descriptor_t) :: a_descriptor
    integer(c_int), parameter :: unit_stride=1,scalar_offset=-1,words=1
    integer(c_int) :: i

    a_descriptor%dtype = my_dtype(type_=BT_LOGICAL,kind_=words,rank_=rank(a))
    a_descriptor%offset = scalar_offset
    a_descriptor%base_addr = c_loc(a) ! data
    do concurrent(i=1:rank(a))
      a_descriptor%dim_(i)%stride  = unit_stride
      a_descriptor%dim_(i)%lower_bound = lbound(a,i)
      a_descriptor%dim_(i)%ubound_ = ubound(a,i)
    end do

  end function

  function gfc_descriptor_c_double(a) result(a_descriptor)
    real(c_double), intent(in), target, contiguous :: a(..)
    type(gfc_descriptor_t) :: a_descriptor
    integer(c_int), parameter :: unit_stride=1,scalar_offset=-1
    integer(c_int) :: i

    a_descriptor%dtype = my_dtype(type_=BT_REAL,kind_=int(c_sizeof(a)/bytes_per_word,c_int32_t),rank_=rank(a))
    a_descriptor%offset = scalar_offset
    a_descriptor%base_addr = c_loc(a) ! data
    do concurrent(i=1:rank(a))
      a_descriptor%dim_(i)%stride  = unit_stride
      a_descriptor%dim_(i)%lower_bound = lbound(a,i)
      a_descriptor%dim_(i)%ubound_ = ubound(a,i)
    end do

  end function

 ! This version should work for any rank but causes an ICE with gfortran 4.9.2
 !
 !function gfc_descriptor_c_char(a) result(a_descriptor)
 !  character(c_char), intent(in), target, contiguous :: a(..)
 !  type(gfc_descriptor_t) :: a_descriptor
 !  integer(c_int), parameter :: unit_stride=1,scalar_offset=-1
 !  integer(c_int) :: i

 !  a_descriptor%dtype = my_dtype(type_=BT_CHARACTER,kind_=int(c_sizeof(a)/bytes_per_word,c_int32_t),rank_=rank(a))
 !  a_descriptor%offset = scalar_offset
 !  a_descriptor%base_addr = c_loc(a) ! data
 !  do concurrent(i=1:rank(a))
 !    a_descriptor%dim_(i)%stride  = unit_stride
 !    a_descriptor%dim_(i)%lower_bound = lbound(a,i)
 !    a_descriptor%dim_(i)%ubound_ = ubound(a,i)
 !  end do

 !end function

  ! ______ Assumed-rank co_reduce wrappers for each supported type and kind _________
  ! _________________________________________________________________________________

    subroutine co_reduce_c_int(a, opr, result_image, stat, errmsg)
      ! Dummy variables
      integer(c_int), intent(inout), volatile, contiguous :: a(..)
      procedure(c_int_operator) :: opr
      integer(c_int), intent(in), optional :: result_image
      integer(c_int), intent(out), optional, volatile :: stat
      character(kind=c_char), intent(out), optional, volatile :: errmsg(*)
      ! Local variables
      integer(c_int), volatile :: opr_flags_unused,a_len_unused,errmsg_len
      type(gfc_descriptor_t), target :: a_descriptor
      integer(c_int), parameter :: default_result_image=0
      integer(c_int) :: result_image_

      result_image_ = merge(result_image,default_result_image,present(result_image))
      a_descriptor = gfc_descriptor(a)
      call opencoarrays_co_reduce( &
        c_loc(a_descriptor), c_funloc(opr), opr_flags_unused, result_image_, stat, errmsg, a_len_unused, errmsg_len &
      )
    end subroutine

    subroutine co_reduce_logical(a, opr, result_image, stat, errmsg)
      ! Dummy variables
      logical, intent(inout), volatile, contiguous :: a(..)
      procedure(logical_operator) :: opr
      integer(c_int), intent(in), optional :: result_image
      integer(c_int), intent(out),optional , volatile :: stat
      character(kind=c_char), intent(out), optional, volatile :: errmsg(*)
      ! Local variables
      integer(c_int), volatile :: opr_flags_unused,a_len_unused,errmsg_len
      type(gfc_descriptor_t), target :: a_descriptor
      integer(c_int), parameter :: default_result_image=0
      integer(c_int) :: result_image_

      result_image_ = merge(result_image,default_result_image,present(result_image))
      a_descriptor = gfc_descriptor(a)
      call opencoarrays_co_reduce( &
        c_loc(a_descriptor), c_funloc(opr), opr_flags_unused, result_image_, stat, errmsg, a_len_unused, errmsg_len &
      )
    end subroutine

    subroutine co_reduce_c_double(a, opr, result_image, stat, errmsg)
      ! Dummy variables
      real(c_double), intent(inout), volatile, contiguous :: a(..)
      procedure(c_double_operator) :: opr
      integer(c_int), intent(in), optional :: result_image
      integer(c_int), intent(out), optional, volatile :: stat
      character(kind=c_char), intent(out), optional, volatile :: errmsg(*)
      ! Local variables
      integer(c_int), volatile :: opr_flags_unused,a_len_unused,errmsg_len
      type(gfc_descriptor_t), target :: a_descriptor
      integer(c_int), parameter :: default_result_image=0
      integer(c_int) :: result_image_

      result_image_ = merge(result_image,default_result_image,present(result_image))
      a_descriptor = gfc_descriptor(a)
      call opencoarrays_co_reduce( &
        c_loc(a_descriptor), c_funloc(opr), opr_flags_unused, result_image_, stat, errmsg, a_len_unused, errmsg_len &
      )
    end subroutine

  ! ______ Assumed-rank co_broadcast wrappers for each supported type and kind _________
  ! ____________________________________________________________________________________

  ! This provisional implementation incurs some overhead by converting the character argument
  ! to an integer(c_int) array, invoking co_broadcast_c_int and then convering the received
  ! message back from the integer(c_int) array to a character variable.
  !
  ! Replace this implementation with one that avoids the conversions and the associated copies
  ! once the compiler provides support for co_broadcast with scalar arguments.
  !
  subroutine co_broadcast_c_char(a,source_image,stat,errmsg)
    character(kind=c_char,len=*), intent(inout), volatile, target :: a
    integer(c_int), intent(in), optional :: source_image
    integer(c_int), intent(out), optional:: stat
    character(kind=1,len=*), intent(out), optional :: errmsg
    ! Local variables and constants:
    integer(c_int), allocatable :: a_cast_to_integer_array(:)

    ! Convert "a" to an integer(c_int) array where each 32-bit integer element holds four 1-byte characters
    a_cast_to_integer_array = transfer(a,[0_c_int])
    ! Broadcast the integer(c_int) array
    call co_broadcast_c_int(a_cast_to_integer_array,source_image, stat, errmsg)
    ! Recover the characters from the broadcasted integer(c_int) array
    a = transfer(a_cast_to_integer_array,repeat(' ',len(a)))

  end subroutine

  subroutine co_broadcast_c_double(a,source_image,stat,errmsg)
    real(c_double), intent(inout), volatile, target, contiguous :: a(..)
    integer(c_int), intent(in), optional :: source_image
    integer(c_int), intent(out), optional:: stat
    character(kind=1,len=*), intent(out), optional :: errmsg
    ! Local variables and constants
    integer(c_int), parameter :: default_source_image=0
    integer(c_int) :: source_image_ ! Local replacement for the corresponding intent(in) dummy argument
    type(gfc_descriptor_t), target :: a_descriptor

    source_image_ = merge(source_image,default_source_image,present(source_image))
    a_descriptor = gfc_descriptor(a)
    call opencoarrays_co_broadcast(c_loc(a_descriptor),source_image_, stat, errmsg, len(errmsg))

  end subroutine

  subroutine co_broadcast_c_int(a,source_image,stat,errmsg)
    integer(c_int), intent(inout), volatile, target, contiguous :: a(..)
    integer(c_int), intent(in), optional :: source_image
    integer(c_int), intent(out), optional:: stat
    character(kind=1,len=*), intent(out), optional :: errmsg
    ! Local variables and constants:
    integer(c_int), parameter :: default_source_image=0
    integer(c_int) :: source_image_ ! Local replacement for the corresponding intent(in) dummy argument
    type(gfc_descriptor_t), target :: a_descriptor

    source_image_ = merge(source_image,default_source_image,present(source_image))
    a_descriptor = gfc_descriptor(a)
    call opencoarrays_co_broadcast(c_loc(a_descriptor),source_image_, stat, errmsg, len(errmsg))

  end subroutine

  ! ________ Assumed-rank get wrappers for each supported type and kind ________________
  ! ________ (Incomplete, private and unsupported) _____________________________________
  ! ____________________________________________________________________________________

  subroutine get_c_int(src , dest, image_index_, offset, mrt)
    use iso_fortran_env, only : error_unit
    ! Dummy arguments:
    integer(c_int), intent(in), target, contiguous :: src(..)
    integer(c_int), intent(out), target, contiguous, volatile :: dest(..)
    integer(c_int), intent(in) :: image_index_
    integer(c_ptrdiff_t), intent(in) :: offset
    logical(c_bool), intent(in) :: mrt
    ! Local variables:
    type(gfc_descriptor_t), target, volatile ::  dest_descriptor
    type(gfc_descriptor_t), target :: src_descriptor
    type(caf_vector_t) :: src_vector_unused
    type(c_ptr) :: token

    write(error_unit,*) "Remote access of coarrays not yet supported"
    call error_stop

    src_descriptor = gfc_descriptor(src)
    dest_descriptor = gfc_descriptor(dest)
    call opencoarrays_get( &
     token, offset, image_index_, src_descriptor, src_vector_unused, dest_descriptor, kind(src), kind(dest), mrt &
    )
  end subroutine

  ! ________ Assumed-rank co_min wrappers for each supported type and kind _____________
  ! ____________________________________________________________________________________

  subroutine co_min_c_int(a,result_image,stat,errmsg)
    integer(c_int), intent(inout), volatile, target, contiguous :: a(..)
    integer(c_int), intent(in), optional :: result_image
    integer(c_int), intent(out), optional:: stat
    character(kind=1,len=*), intent(out), optional :: errmsg
    ! Local variables and constants:
    type(gfc_descriptor_t), target :: a_descriptor
    integer(c_int), parameter :: default_result_image=0
    integer(c_int) :: unused, result_image_ ! Local replacement for the corresponding intent(in) dummy argument

    a_descriptor = gfc_descriptor(a)
    result_image_ = merge(result_image,default_result_image,present(result_image))
    call opencoarrays_co_min(c_loc(a_descriptor),result_image_, stat, errmsg, unused, len(errmsg))

  end subroutine

  subroutine co_min_c_double(a,result_image,stat,errmsg)
    real(c_double), intent(inout), volatile, target, contiguous :: a(..)
    integer(c_int), intent(in), optional :: result_image
    integer(c_int), intent(out), optional:: stat
    character(kind=1,len=*), intent(out), optional :: errmsg
    ! Local variables and constants:
    type(gfc_descriptor_t), target :: a_descriptor
    integer(c_int), parameter :: default_result_image=0
    integer(c_int) :: unused, result_image_ ! Local replacement for the corresponding intent(in) dummy argument

    a_descriptor = gfc_descriptor(a)
    result_image_ = merge(result_image,default_result_image,present(result_image))
    call opencoarrays_co_min(c_loc(a_descriptor),result_image_, stat, errmsg, unused, len(errmsg))

  end subroutine


  ! ________ Assumed-rank co_max wrappers for each supported type and kind _____________
  ! ____________________________________________________________________________________

  subroutine co_max_c_int(a,result_image,stat,errmsg)
    integer(c_int), intent(inout), volatile, target, contiguous :: a(..)
    integer(c_int), intent(in), optional :: result_image
    integer(c_int), intent(out), optional:: stat
    character(kind=1,len=*), intent(out), optional :: errmsg
    ! Local variables and constants:
    type(gfc_descriptor_t), target :: a_descriptor
    integer(c_int), parameter :: default_result_image=0
    integer(c_int) :: unused, result_image_ ! Local replacement for the corresponding intent(in) dummy argument

    a_descriptor = gfc_descriptor(a)
    result_image_ = merge(result_image,default_result_image,present(result_image))
    call opencoarrays_co_max(c_loc(a_descriptor),result_image_, stat, errmsg, unused, len(errmsg))

  end subroutine

  subroutine co_max_c_double(a,result_image,stat,errmsg)
    real(c_double), intent(inout), volatile, target, contiguous :: a(..)
    integer(c_int), intent(in), optional :: result_image
    integer(c_int), intent(out), optional:: stat
    character(kind=1,len=*), intent(out), optional :: errmsg
    ! Local variables and constants:
    type(gfc_descriptor_t), target :: a_descriptor
    integer(c_int), parameter :: default_result_image=0
    integer(c_int) :: unused, result_image_ ! Local replacement for the corresponding intent(in) dummy argument

    a_descriptor = gfc_descriptor(a)
    result_image_ = merge(result_image,default_result_image,present(result_image))
    call opencoarrays_co_max(c_loc(a_descriptor),result_image_, stat, errmsg, unused, len(errmsg))

  end subroutine

  ! ________ Assumed-rank co_sum wrappers for each supported type and kind _____________
  ! ____________________________________________________________________________________

  subroutine co_sum_c_double(a,result_image,stat,errmsg)
    real(c_double), intent(inout), volatile, target, contiguous :: a(..)
    integer(c_int), intent(in), optional :: result_image
    integer(c_int), intent(out), optional:: stat
    character(kind=1,len=*), intent(out), optional :: errmsg
    ! Local variables and constants:
    type(gfc_descriptor_t), target :: a_descriptor
    integer(c_int), parameter :: default_result_image=0
    integer(c_int) :: result_image_ ! Local replacement for the corresponding intent(in) dummy argument

    a_descriptor = gfc_descriptor(a)
    result_image_ = merge(result_image,default_result_image,present(result_image))
    call opencoarrays_co_sum(c_loc(a_descriptor),result_image_, stat, errmsg, len(errmsg))

  end subroutine

  subroutine co_sum_c_int(a,result_image,stat,errmsg)
    integer(c_int), intent(inout), volatile, target, contiguous :: a(..)
    integer(c_int), intent(in), optional :: result_image
    integer(c_int), intent(out), optional:: stat
    character(kind=1,len=*), intent(out), optional :: errmsg
    ! Local variables and constants:
    integer(c_int), parameter :: default_result_image=0
    type(gfc_descriptor_t), target :: a_descriptor
    integer(c_int) :: result_image_ ! Local replacement for the corresponding intent(in) dummy argument

    a_descriptor = gfc_descriptor(a)
    result_image_ = merge(result_image,default_result_image,present(result_image))
    call opencoarrays_co_sum(c_loc(a_descriptor),result_image_, stat, errmsg, len(errmsg))

  end subroutine

  ! Return the image number (MPI rank + 1)
  function this_image()  result(image_num)
#ifdef MPI_WORKING_MODULE
    use mpi, only : MPI_Comm_rank
#endif
    integer(c_int) :: image_num,ierr
   !image_num = opencoarrays_this_image(unused)
    call MPI_Comm_rank(CAF_COMM_WORLD,image_num,ierr)
    if (ierr/=0) call error_stop
    image_num = image_num + 1
  end function

  ! Return the total number of images
  function num_images()  result(num_images_)
#ifdef MPI_WORKING_MODULE
    use mpi, only : MPI_Comm_size
#endif
    integer(c_int) :: num_images_,ierr
   !num_images_ = opencoarrays_num_images(unused_coarray,unused_scalar)
    call MPI_Comm_size(CAF_COMM_WORLD,num_images_,ierr)
    if (ierr/=0) call error_stop
  end function

  ! Halt the execution of all images
  subroutine error_stop(stop_code)
    integer(c_int32_t), intent(in), optional :: stop_code
    integer(c_int32_t), parameter :: default_code=-1_c_int32_t
    integer(c_int32_t) :: code
    code = merge(stop_code,default_code,present(stop_code))
    call opencoarrays_error_stop(code)
  end subroutine

  ! Impose a global execution barrier
  subroutine sync_all(stat,errmsg,unused)
    integer(c_int), intent(out), optional :: stat,unused
    character(c_char), intent(out), optional :: errmsg
    call opencoarrays_sync_all(stat,errmsg,unused)
  end subroutine

#ifdef COMPILER_SUPPORTS_ATOMICS
   ! Proposed Fortran 2015 event_post procedure
   subroutine event_post(this)
     class(event_type), intent(inout) ::  this
     if (.not.allocated(this%atom)) this%atom=0
     call atomic_define ( this%atom, this%atom + 1_atomic_int_kind )
   end subroutine
#endif

end module

! Check that after an image has failed a get to other images is still possible.
! Image two is to fail, all others to continue.

program image_fail_and_get_test_1
  use iso_fortran_env , only : STAT_FAILED_IMAGE
  implicit none
  integer :: i, stat
  integer, save :: share[*]

  associate(np => num_images(), me => this_image())
    if (np < 3) error stop "I need at least 3 images to function."
    
    share = 37

    sync all
    if (me == 2) fail image
    sync all (STAT=stat)

    print *, "Checking shared value."
    do i= 1, np
      if (i /= 2 .AND. i /= me) then
        if (share[i, STAT=stat] /= 37) error stop "Expected to get value from images alive."
        print *, me, "Stat of #", i, " is:", stat
      end if
    end do

    sync all(STAT=stat)
    if (me == 1) print *,"Test passed."
  end associate

end program image_fail_and_get_test_1

! Fortran 2015 feature support for Fortran 2008 compilers
!
! Copyright (c) 2015-2016, Sourcery, Inc.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of the Sourcery, Inc., nor the
!       names of its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE FOR ANY
! DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
module opencoarrays
#ifdef COMPILER_SUPPORTS_ATOMICS
  use iso_fortran_env, only : atomic_int_kind
#endif
  use iso_c_binding, only : c_int,c_char,c_ptr,c_loc,c_double,c_int32_t,c_ptrdiff_t,c_sizeof,c_bool,c_funloc
  implicit none

#ifndef MPI_WORKING_MODULE
  include 'mpif.h'
#endif

  private
  public :: co_reduce
  public :: co_broadcast
  public :: co_sum
  public :: co_min
  public :: co_max
  public :: this_image
  public :: num_images
  public :: error_stop
  public :: sync_all
  public :: team_number
#ifdef HAVE_MPI
  public :: get_communicator
#endif
#ifdef COMPILER_SUPPORTS_ATOMICS
  public :: event_type
  public :: event_post

  type event_type
    private
    integer(atomic_int_kind), allocatable :: atom[:]
  end type
#endif
#ifdef EXPOSE_INIT_FINALIZE
  public :: caf_init
  public :: caf_finalize
#endif

  ! Generic interface to co_broadcast with implementations for various types, kinds, and ranks
  interface co_reduce
     module procedure co_reduce_c_int,co_reduce_c_double,co_reduce_logical
  end interface

  ! Generic interface to co_broadcast with implementations for various types, kinds, and ranks
  interface co_broadcast
     module procedure co_broadcast_c_int,co_broadcast_c_double,co_broadcast_c_char
  end interface

  ! Generic interface to co_sum with implementations for various types, kinds, and ranks
  interface co_sum
     module procedure co_sum_c_int,co_sum_c_double
  end interface

  ! Generic interface to co_sum with implementations for various types, kinds, and ranks
  interface co_min
     module procedure co_min_c_int,co_min_c_double
  end interface

  ! Generic interface to co_sum with implementations for various types, kinds, and ranks
  interface co_max
     module procedure co_max_c_int,co_max_c_double
  end interface

  abstract interface
     pure function c_int_operator(lhs,rhs) result(lhs_op_rhs)
       import c_int
       integer(c_int), intent(in) :: lhs,rhs
       integer(c_int) :: lhs_op_rhs
     end function
     pure function c_double_operator(lhs,rhs) result(lhs_op_rhs)
       import c_double
       real(c_double), intent(in) :: lhs,rhs
       real(c_double) :: lhs_op_rhs
     end function
     pure function logical_operator(lhs,rhs) result(lhs_op_rhs)
       logical, intent(in) :: lhs,rhs
       logical :: lhs_op_rhs
     end function
  end interface

  interface
#ifdef COMPILER_SUPPORTS_CAF_INTRINSICS
    function team_number(team_type_ptr) result(my_team_number) bind(C,name="_caf_extensions_team_number")
#else
    function team_number(team_type_ptr) result(my_team_number) bind(C,name="_gfortran_caf_team_number")
#endif
       use iso_c_binding, only : c_int,c_ptr
       implicit none
       type(c_ptr), optional :: team_type_ptr
       integer(c_int) :: my_team_number
    end function

#ifdef COMPILER_SUPPORTS_CAF_INTRINSICS
    function get_communicator(team_type_ptr) result(my_team) bind(C,name="_caf_extensions_get_communicator")
#else
    function get_communicator(team_type_ptr) result(my_team) bind(C,name="_gfortran_caf_get_communicator")
#endif
       use iso_c_binding, only : c_int,c_ptr
       implicit none
       type(c_ptr), optional :: team_type_ptr
       integer(c_int) :: my_team
    end function
  end interface


  ! __________ End Public Interface _____________


  ! __________ Begin Private Implementation _____

  ! Enumeration from ../libcaf-gfortran-descriptor.h:
  !  enum
  !{ BT_UNKNOWN = 0, BT_INTEGER, BT_LOGICAL, BT_REAL, BT_COMPLEX,
  !  BT_DERIVED, BT_CHARACTER, BT_CLASS, BT_PROCEDURE, BT_HOLLERITH, BT_VOID,
  !  BT_ASSUMED
  !};

  enum ,bind(C)
    enumerator :: &
     BT_UNKNOWN = 0, BT_INTEGER, BT_LOGICAL, BT_REAL, BT_COMPLEX, &
     BT_DERIVED, BT_CHARACTER, BT_CLASS, BT_PROCEDURE, BT_HOLLERITH, BT_VOID, &
     BT_ASSUMED
  end enum

  ! Type definition from ../libcaf-gfortran-descriptor.h:
  !typedef struct descriptor_dimension
  !{
  !  ptrdiff_t _stride;
  !  ptrdiff_t lower_bound;
  !  ptrdiff_t _ubound;
  !}
  !descriptor_dimension;

  ! Fortran derived type interoperable with like-named C type:
  type, bind(C) :: descriptor_dimension
     integer(c_ptrdiff_t) :: stride
     integer(c_ptrdiff_t) :: lower_bound
     integer(c_ptrdiff_t) :: ubound_
  end type

  ! Type definition from ../libcaf-gfortran-descriptor.h:
  !typedef struct gfc_descriptor_t {
  !  void *base_addr;
  !  size_t offset;
  !  ptrdiff_t dtype;
  !  descriptor_dimension dim[];
  !} gfc_descriptor_t;

  integer, parameter :: max_dimensions=15

  ! Fortran derived type interoperable with like-named C type:
  type, bind(C) :: gfc_descriptor_t
    type(c_ptr) :: base_addr
    integer(c_ptrdiff_t) :: offset
    integer(c_ptrdiff_t) :: dtype
    type(descriptor_dimension) :: dim_(max_dimensions)
  end type

  ! C comment and source from ../libcaf.h
  ! /* When there is a vector subscript in this dimension, nvec == 0, otherwise,
  ! lower_bound, upper_bound, stride contains the bounds relative to the declared
  ! bounds; kind denotes the integer kind of the elements of vector[].  */
  ! type, bind(C) :: caf_vector_t {
  !   size_t nvec;
  !   union {
  !     struct {
  !       void *vector;
  !       int kind;
  !     } v;
  !     struct {
  !       ptrdiff_t lower_bound, upper_bound, stride;
  !     } triplet;
  !   } u;
  ! }
  ! caf_vector_t;

  type, bind(C) :: v_t
    type(c_ptr) :: vector
    integer(c_int) :: kind_
  end type

  type, bind(C) :: triplet_t
    integer(c_ptrdiff_t) :: lower_bound, upper_bound, stride
  end type

  type, bind(C) :: u_t
     type(v_t) :: v
     type(triplet_t) :: triplet
  end type

  type, bind(C) :: caf_vector_t
    integer(c_ptrdiff_t) :: nvec
    type(u_t) :: u
  end type

  ! --------------------

  integer(c_int), save, volatile, bind(C,name="CAF_COMM_WORLD") :: CAF_COMM_WORLD
  integer(c_int32_t), parameter  :: bytes_per_word=4_c_int32_t

  interface gfc_descriptor
    module procedure gfc_descriptor_c_int,gfc_descriptor_c_double,gfc_descriptor_logical
  end interface

  ! Bindings for OpenCoarrays C procedures
  interface

    ! C function signature from ../mpi/mpi_caf.c:
    ! void
    ! PREFIX (init) (int *argc, char ***argv)
#ifdef COMPILER_SUPPORTS_CAF_INTRINSICS
    subroutine caf_init(argc,argv) bind(C,name="_caf_extensions_init")
#else
    subroutine caf_init(argc,argv) bind(C,name="_gfortran_caf_init")
#endif
      import :: c_int,c_ptr
      type(c_ptr), value :: argc
      type(c_ptr), value :: argv
    end subroutine

    ! C function signature from ../mpi/mpi_caf.c:
    ! void
    ! PREFIX (finalize) (void)
#ifdef COMPILER_SUPPORTS_CAF_INTRINSICS
    subroutine caf_finalize() bind(C,name="_caf_extensions_finalize")
#else
    subroutine caf_finalize() bind(C,name="_gfortran_caf_finalize")
#endif
    end subroutine

    ! C function signature from ../mpi/mpi_caf.c:
    ! void
    ! PREFIX (co_min) (gfc_descriptor_t *a, int result_image, int *stat, char *errmsg,
    !                  int src_len, int errmsg_len)
#ifdef COMPILER_SUPPORTS_CAF_INTRINSICS
    subroutine opencoarrays_co_min(a,result_image, stat, errmsg, unused , errmsg_len) bind(C,name="_caf_extensions_co_min")
#else
    subroutine opencoarrays_co_min(a,result_image, stat, errmsg, unused, errmsg_len) bind(C,name="_gfortran_caf_co_min")
#endif
      import :: c_int,c_char,c_ptr
      type(c_ptr), intent(in), value :: a
      integer(c_int), intent(in),  value :: result_image,errmsg_len,unused
      integer(c_int), intent(out), optional, volatile :: stat
      character(kind=c_char), intent(out), optional, volatile :: errmsg(*)
    end subroutine

    ! C function signature from ../mpi/mpi_caf.c
    ! void
    ! PREFIX (co_reduce) (gfc_descriptor_t *a, void *(*opr) (void *, void *), int opr_flags,
    !                     int result_image, int *stat, char *errmsg, int a_len, int errmsg_len)
    subroutine opencoarrays_co_reduce(a, opr, opr_flags, result_image, stat, errmsg, a_len, errmsg_len) &
#ifdef COMPILER_SUPPORTS_CAF_INTRINSICS
      bind(C,name="_caf_extensions_co_reduce")
#else
      bind(C,name="_gfortran_caf_co_reduce")
#endif
      use iso_c_binding, only : c_ptr,c_funptr,c_int,c_char
      type(c_ptr), intent(in), value :: a
      type(c_funptr), intent(in), value :: opr
      integer(c_int), intent(in), value :: opr_flags,result_image
      integer(c_int), intent(out) :: stat
      character(kind=c_char), intent(out), optional, volatile :: errmsg(*)
      integer(c_int), intent(in), value :: a_len
      integer(c_int), intent(in), value :: errmsg_len
    end subroutine

    ! C function signature from ../mpi/mpi_caf.c:
    ! void
    ! PREFIX (get) (caf_token_t token, size_t offset,
    !              int image_index,
    !              gfc_descriptor_t *src ,
    !              caf_vector_t *src_vector __attribute__ ((unused)),
    !              gfc_descriptor_t *dest, int src_kind, int dst_kind,
    !              bool mrt)
    subroutine opencoarrays_get(token, offset, image_index_, src, src_vector_unused, dest, src_kind, dst_kind, mrt) &
#ifdef COMPILER_SUPPORTS_CAF_INTRINSICS
      bind(C,name="_caf_extensions_get")
#else
      bind(C,name="_gfortran_caf_get")
#endif
      import c_ptrdiff_t,c_int,gfc_descriptor_t,c_bool,caf_vector_t,c_ptr
      type(c_ptr), value :: token
      integer(c_ptrdiff_t), value :: offset
      integer(c_int), value :: image_index_
      type(gfc_descriptor_t) :: src
      type(caf_vector_t) :: src_vector_unused
      type(gfc_descriptor_t) :: dest
      integer(c_int), value :: src_kind
      integer(c_int), value :: dst_kind
      logical(c_bool), value :: mrt
    end subroutine

    ! C function signature from ../mpi/mpi_caf.c:
    ! void
    ! PREFIX (co_max) (gfc_descriptor_t *a, int result_image, int *stat,
    !                  char *errmsg, int src_len, int errmsg_len)
#ifdef COMPILER_SUPPORTS_CAF_INTRINSICS
    subroutine opencoarrays_co_max(a,result_image, stat, errmsg, unused, errmsg_len) bind(C,name="_caf_extensions_co_max")
#else
    subroutine opencoarrays_co_max(a,result_image, stat, errmsg, unused, errmsg_len) bind(C,name="_gfortran_caf_co_max")
#endif
      import :: c_int,c_char,c_ptr
      type(c_ptr), intent(in), value :: a
      integer(c_int), intent(in),  value :: result_image,errmsg_len,unused
      integer(c_int), intent(out), optional :: stat
      character(kind=c_char), intent(out), optional :: errmsg(*)
    end subroutine

    ! C function signature from ../mpi/mpi_caf.c:
    ! void
    ! PREFIX (co_sum) (gfc_descriptor_t *a, int result_image, int *stat, char *errmsg,
    !                  int errmsg_len)
#ifdef COMPILER_SUPPORTS_CAF_INTRINSICS
    subroutine opencoarrays_co_sum(a, result_image, stat, errmsg, errmsg_len) bind(C,name="_caf_extensions_co_sum")
#else
    subroutine opencoarrays_co_sum(a, result_image, stat, errmsg, errmsg_len) bind(C,name="_gfortran_caf_co_sum")
#endif
      import :: c_int,c_char,c_ptr
      type(c_ptr), intent(in), value :: a
      integer(c_int), intent(in),  value :: result_image,errmsg_len
      integer(c_int), intent(out), optional :: stat
      character(kind=c_char), intent(out), optional :: errmsg(*)
    end subroutine

    ! C function signature from ../mpi/mpi_caf.c
    ! void
    ! PREFIX (co_broadcast) (gfc_descriptor_t *a, int source_image, int *stat, char *errmsg,
    !                  int errmsg_len)
#ifdef COMPILER_SUPPORTS_CAF_INTRINSICS
    subroutine opencoarrays_co_broadcast(a,source_image, stat, errmsg, errmsg_len) bind(C,name="_caf_extensions_co_broadcast")
#else
    subroutine opencoarrays_co_broadcast(a,source_image, stat, errmsg, errmsg_len) bind(C,name="_gfortran_caf_co_broadcast")
#endif
      import :: c_int,c_char,c_ptr
      type(c_ptr), intent(in), value :: a
      integer(c_int), intent(in),  value :: source_image,errmsg_len
      integer(c_int), intent(out), optional :: stat
      character(kind=c_char), intent(out), optional :: errmsg(*)
    end subroutine

    ! C function signature from ../mpi/mpi_caf.c:
    ! int PREFIX (this_image) (int);
    function opencoarrays_this_image(coarray) bind(C,name="_gfortran_caf_this_image") result(image_num)
      import :: c_int
      integer(c_int), value, intent(in) :: coarray
      integer(c_int)  :: image_num
    end function

    ! C function signature from ../mpi/mpi_caf.c:
    ! int PREFIX (num_images) (int, int);
    function opencoarrays_num_images(coarray,dim_) bind(C,name="_gfortran_caf_num_images") result(num_images_)
      import :: c_int
      integer(c_int), value, intent(in) :: coarray,dim_
      integer(c_int) :: num_images_
    end function

    ! C function signature from ../mpi_caf.c
    ! void PREFIX (error_stop) (int32_t) __attribute__ ((noreturn));
#ifdef COMPILER_SUPPORTS_CAF_INTRINSICS
    subroutine opencoarrays_error_stop(stop_code) bind(C,name="_caf_extensions_error_stop")
#else
    subroutine opencoarrays_error_stop(stop_code) bind(C,name="_gfortran_caf_error_stop")
#endif
      import :: c_int32_t
      integer(c_int32_t), value, intent(in) :: stop_code
    end subroutine

    ! C function signature from ../mpi_caf.c
    ! void PREFIX (sync_all) (int *, char *, int);
#ifdef COMPILER_SUPPORTS_CAF_INTRINSICS
    subroutine opencoarrays_sync_all(stat,errmsg,unused) bind(C,name="_caf_extensions_sync_all")
#else
    subroutine opencoarrays_sync_all(stat,errmsg,unused) bind(C,name="_gfortran_caf_sync_all")
#endif
      import :: c_int,c_char
      integer(c_int), intent(out) :: stat,unused
      character(c_char), intent(out) :: errmsg(*)
    end subroutine

  end interface


contains

  ! __________ Descriptor constructors for for each supported type and kind ____________
  ! ____________________________________________________________________________________

  function my_dtype(type_,kind_,rank_) result(dtype_)
    integer,parameter :: GFC_DTYPE_SIZE_SHIFT = 8, GFC_DTYPE_TYPE_SHIFT=3
    integer(c_int32_t), intent(in) :: type_,kind_,rank_
    integer(c_int32_t) :: dtype_

    ! SIZE Type Rank
    ! 0000  000  000

    ! Rank is represented in the 3 least significant bits
    dtype_ = ior(0_c_int32_t,rank_)
    ! The next three bits represent the type id as expressed in libcaf-gfortran-descriptor.h
    dtype_ = ior(dtype_,ishft(type_,GFC_DTYPE_TYPE_SHIFT))
    ! The most significant bits represent the size of a the type (single or double precision).
    ! We can express the precision in terms of 32-bit words: 1 for single, 2 for double.
    dtype_ = ior(dtype_,ishft(kind_,GFC_DTYPE_SIZE_SHIFT))

  end function

  function gfc_descriptor_c_int(a) result(a_descriptor)
    integer(c_int), intent(in), target, contiguous :: a(..)
    type(gfc_descriptor_t) :: a_descriptor
    integer(c_int), parameter :: unit_stride=1,scalar_offset=-1
    integer(c_int) :: i

    a_descriptor%dtype = my_dtype(type_=BT_INTEGER,kind_=int(c_sizeof(a)/bytes_per_word,c_int32_t),rank_=rank(a))
    a_descriptor%offset = scalar_offset
    a_descriptor%base_addr = c_loc(a) ! data
    do concurrent(i=1:rank(a))
      a_descriptor%dim_(i)%stride  = unit_stride
      a_descriptor%dim_(i)%lower_bound = lbound(a,i)
      a_descriptor%dim_(i)%ubound_ = ubound(a,i)
    end do

  end function

  function gfc_descriptor_logical(a) result(a_descriptor)
    logical, intent(in), target, contiguous :: a(..)
    type(gfc_descriptor_t) :: a_descriptor
    integer(c_int), parameter :: unit_stride=1,scalar_offset=-1,words=1
    integer(c_int) :: i

    a_descriptor%dtype = my_dtype(type_=BT_LOGICAL,kind_=words,rank_=rank(a))
    a_descriptor%offset = scalar_offset
    a_descriptor%base_addr = c_loc(a) ! data
    do concurrent(i=1:rank(a))
      a_descriptor%dim_(i)%stride  = unit_stride
      a_descriptor%dim_(i)%lower_bound = lbound(a,i)
      a_descriptor%dim_(i)%ubound_ = ubound(a,i)
    end do

  end function

  function gfc_descriptor_c_double(a) result(a_descriptor)
    real(c_double), intent(in), target, contiguous :: a(..)
    type(gfc_descriptor_t) :: a_descriptor
    integer(c_int), parameter :: unit_stride=1,scalar_offset=-1
    integer(c_int) :: i

    a_descriptor%dtype = my_dtype(type_=BT_REAL,kind_=int(c_sizeof(a)/bytes_per_word,c_int32_t),rank_=rank(a))
    a_descriptor%offset = scalar_offset
    a_descriptor%base_addr = c_loc(a) ! data
    do concurrent(i=1:rank(a))
      a_descriptor%dim_(i)%stride  = unit_stride
      a_descriptor%dim_(i)%lower_bound = lbound(a,i)
      a_descriptor%dim_(i)%ubound_ = ubound(a,i)
    end do

  end function

 ! This version should work for any rank but causes an ICE with gfortran 4.9.2
 !
 !function gfc_descriptor_c_char(a) result(a_descriptor)
 !  character(c_char), intent(in), target, contiguous :: a(..)
 !  type(gfc_descriptor_t) :: a_descriptor
 !  integer(c_int), parameter :: unit_stride=1,scalar_offset=-1
 !  integer(c_int) :: i

 !  a_descriptor%dtype = my_dtype(type_=BT_CHARACTER,kind_=int(c_sizeof(a)/bytes_per_word,c_int32_t),rank_=rank(a))
 !  a_descriptor%offset = scalar_offset
 !  a_descriptor%base_addr = c_loc(a) ! data
 !  do concurrent(i=1:rank(a))
 !    a_descriptor%dim_(i)%stride  = unit_stride
 !    a_descriptor%dim_(i)%lower_bound = lbound(a,i)
 !    a_descriptor%dim_(i)%ubound_ = ubound(a,i)
 !  end do

 !end function

  ! ______ Assumed-rank co_reduce wrappers for each supported type and kind _________
  ! _________________________________________________________________________________

    subroutine co_reduce_c_int(a, opr, result_image, stat, errmsg)
      ! Dummy variables
      integer(c_int), intent(inout), volatile, contiguous :: a(..)
      procedure(c_int_operator) :: opr
      integer(c_int), intent(in), optional :: result_image
      integer(c_int), intent(out), optional, volatile :: stat
      character(kind=c_char), intent(out), optional, volatile :: errmsg(*)
      ! Local variables
      integer(c_int), volatile :: opr_flags_unused,a_len_unused,errmsg_len
      type(gfc_descriptor_t), target :: a_descriptor
      integer(c_int), parameter :: default_result_image=0
      integer(c_int) :: result_image_

      result_image_ = merge(result_image,default_result_image,present(result_image))
      a_descriptor = gfc_descriptor(a)
      call opencoarrays_co_reduce( &
        c_loc(a_descriptor), c_funloc(opr), opr_flags_unused, result_image_, stat, errmsg, a_len_unused, errmsg_len &
      )
    end subroutine

    subroutine co_reduce_logical(a, opr, result_image, stat, errmsg)
      ! Dummy variables
      logical, intent(inout), volatile, contiguous :: a(..)
      procedure(logical_operator) :: opr
      integer(c_int), intent(in), optional :: result_image
      integer(c_int), intent(out),optional , volatile :: stat
      character(kind=c_char), intent(out), optional, volatile :: errmsg(*)
      ! Local variables
      integer(c_int), volatile :: opr_flags_unused,a_len_unused,errmsg_len
      type(gfc_descriptor_t), target :: a_descriptor
      integer(c_int), parameter :: default_result_image=0
      integer(c_int) :: result_image_

      result_image_ = merge(result_image,default_result_image,present(result_image))
      a_descriptor = gfc_descriptor(a)
      call opencoarrays_co_reduce( &
        c_loc(a_descriptor), c_funloc(opr), opr_flags_unused, result_image_, stat, errmsg, a_len_unused, errmsg_len &
      )
    end subroutine

    subroutine co_reduce_c_double(a, opr, result_image, stat, errmsg)
      ! Dummy variables
      real(c_double), intent(inout), volatile, contiguous :: a(..)
      procedure(c_double_operator) :: opr
      integer(c_int), intent(in), optional :: result_image
      integer(c_int), intent(out), optional, volatile :: stat
      character(kind=c_char), intent(out), optional, volatile :: errmsg(*)
      ! Local variables
      integer(c_int), volatile :: opr_flags_unused,a_len_unused,errmsg_len
      type(gfc_descriptor_t), target :: a_descriptor
      integer(c_int), parameter :: default_result_image=0
      integer(c_int) :: result_image_

      result_image_ = merge(result_image,default_result_image,present(result_image))
      a_descriptor = gfc_descriptor(a)
      call opencoarrays_co_reduce( &
        c_loc(a_descriptor), c_funloc(opr), opr_flags_unused, result_image_, stat, errmsg, a_len_unused, errmsg_len &
      )
    end subroutine

  ! ______ Assumed-rank co_broadcast wrappers for each supported type and kind _________
  ! ____________________________________________________________________________________

  ! This provisional implementation incurs some overhead by converting the character argument
  ! to an integer(c_int) array, invoking co_broadcast_c_int and then convering the received
  ! message back from the integer(c_int) array to a character variable.
  !
  ! Replace this implementation with one that avoids the conversions and the associated copies
  ! once the compiler provides support for co_broadcast with scalar arguments.
  !
  subroutine co_broadcast_c_char(a,source_image,stat,errmsg)
    character(kind=c_char,len=*), intent(inout), volatile, target :: a
    integer(c_int), intent(in), optional :: source_image
    integer(c_int), intent(out), optional:: stat
    character(kind=1,len=*), intent(out), optional :: errmsg
    ! Local variables and constants:
    integer(c_int), allocatable :: a_cast_to_integer_array(:)
    character(len=len(a)) :: dummy

    ! Convert "a" to an integer(c_int) array where each 32-bit integer element holds four 1-byte characters
    a_cast_to_integer_array = transfer(a,[0_c_int])
    ! Broadcast the integer(c_int) array
    call co_broadcast_c_int(a_cast_to_integer_array,source_image, stat, errmsg)
    ! Recover the characters from the broadcasted integer(c_int) array
    dummy = ' '
    a = transfer(a_cast_to_integer_array,dummy)

  end subroutine

  subroutine co_broadcast_c_double(a,source_image,stat,errmsg)
    real(c_double), intent(inout), volatile, target, contiguous :: a(..)
    integer(c_int), intent(in), optional :: source_image
    integer(c_int), intent(out), optional:: stat
    character(kind=1,len=*), intent(out), optional :: errmsg
    ! Local variables and constants
    integer(c_int), parameter :: default_source_image=0
    integer(c_int) :: source_image_ ! Local replacement for the corresponding intent(in) dummy argument
    type(gfc_descriptor_t), target :: a_descriptor

    source_image_ = merge(source_image,default_source_image,present(source_image))
    a_descriptor = gfc_descriptor(a)
    call opencoarrays_co_broadcast(c_loc(a_descriptor),source_image_, stat, errmsg, len(errmsg))

  end subroutine

  subroutine co_broadcast_c_int(a,source_image,stat,errmsg)
    integer(c_int), intent(inout), volatile, target, contiguous :: a(..)
    integer(c_int), intent(in), optional :: source_image
    integer(c_int), intent(out), optional:: stat
    character(kind=1,len=*), intent(out), optional :: errmsg
    ! Local variables and constants:
    integer(c_int), parameter :: default_source_image=0
    integer(c_int) :: source_image_ ! Local replacement for the corresponding intent(in) dummy argument
    type(gfc_descriptor_t), target :: a_descriptor

    source_image_ = merge(source_image,default_source_image,present(source_image))
    a_descriptor = gfc_descriptor(a)
    call opencoarrays_co_broadcast(c_loc(a_descriptor),source_image_, stat, errmsg, len(errmsg))

  end subroutine

  ! ________ Assumed-rank get wrappers for each supported type and kind ________________
  ! ________ (Incomplete, private and unsupported) _____________________________________
  ! ____________________________________________________________________________________

  subroutine get_c_int(src , dest, image_index_, offset, mrt)
    use iso_fortran_env, only : error_unit
    ! Dummy arguments:
    integer(c_int), intent(in), target, contiguous :: src(..)
    integer(c_int), intent(out), target, contiguous, volatile :: dest(..)
    integer(c_int), intent(in) :: image_index_
    integer(c_ptrdiff_t), intent(in) :: offset
    logical(c_bool), intent(in) :: mrt
    ! Local variables:
    type(gfc_descriptor_t), target, volatile ::  dest_descriptor
    type(gfc_descriptor_t), target :: src_descriptor
    type(caf_vector_t) :: src_vector_unused
    type(c_ptr) :: token

    write(error_unit,*) "Remote access of coarrays not yet supported"
    call error_stop

    src_descriptor = gfc_descriptor(src)
    dest_descriptor = gfc_descriptor(dest)
    call opencoarrays_get( &
     token, offset, image_index_, src_descriptor, src_vector_unused, dest_descriptor, kind(src), kind(dest), mrt &
    )
  end subroutine

  ! ________ Assumed-rank co_min wrappers for each supported type and kind _____________
  ! ____________________________________________________________________________________

  subroutine co_min_c_int(a,result_image,stat,errmsg)
    integer(c_int), intent(inout), volatile, target, contiguous :: a(..)
    integer(c_int), intent(in), optional :: result_image
    integer(c_int), intent(out), optional:: stat
    character(kind=1,len=*), intent(out), optional :: errmsg
    ! Local variables and constants:
    type(gfc_descriptor_t), target :: a_descriptor
    integer(c_int), parameter :: default_result_image=0
    integer(c_int) :: unused, result_image_ ! Local replacement for the corresponding intent(in) dummy argument

    a_descriptor = gfc_descriptor(a)
    result_image_ = merge(result_image,default_result_image,present(result_image))
    call opencoarrays_co_min(c_loc(a_descriptor),result_image_, stat, errmsg, unused, len(errmsg))

  end subroutine

  subroutine co_min_c_double(a,result_image,stat,errmsg)
    real(c_double), intent(inout), volatile, target, contiguous :: a(..)
    integer(c_int), intent(in), optional :: result_image
    integer(c_int), intent(out), optional:: stat
    character(kind=1,len=*), intent(out), optional :: errmsg
    ! Local variables and constants:
    type(gfc_descriptor_t), target :: a_descriptor
    integer(c_int), parameter :: default_result_image=0
    integer(c_int) :: unused, result_image_ ! Local replacement for the corresponding intent(in) dummy argument

    a_descriptor = gfc_descriptor(a)
    result_image_ = merge(result_image,default_result_image,present(result_image))
    call opencoarrays_co_min(c_loc(a_descriptor),result_image_, stat, errmsg, unused, len(errmsg))

  end subroutine


  ! ________ Assumed-rank co_max wrappers for each supported type and kind _____________
  ! ____________________________________________________________________________________

  subroutine co_max_c_int(a,result_image,stat,errmsg)
    integer(c_int), intent(inout), volatile, target, contiguous :: a(..)
    integer(c_int), intent(in), optional :: result_image
    integer(c_int), intent(out), optional:: stat
    character(kind=1,len=*), intent(out), optional :: errmsg
    ! Local variables and constants:
    type(gfc_descriptor_t), target :: a_descriptor
    integer(c_int), parameter :: default_result_image=0
    integer(c_int) :: unused, result_image_ ! Local replacement for the corresponding intent(in) dummy argument

    a_descriptor = gfc_descriptor(a)
    result_image_ = merge(result_image,default_result_image,present(result_image))
    call opencoarrays_co_max(c_loc(a_descriptor),result_image_, stat, errmsg, unused, len(errmsg))

  end subroutine

  subroutine co_max_c_double(a,result_image,stat,errmsg)
    real(c_double), intent(inout), volatile, target, contiguous :: a(..)
    integer(c_int), intent(in), optional :: result_image
    integer(c_int), intent(out), optional:: stat
    character(kind=1,len=*), intent(out), optional :: errmsg
    ! Local variables and constants:
    type(gfc_descriptor_t), target :: a_descriptor
    integer(c_int), parameter :: default_result_image=0
    integer(c_int) :: unused, result_image_ ! Local replacement for the corresponding intent(in) dummy argument

    a_descriptor = gfc_descriptor(a)
    result_image_ = merge(result_image,default_result_image,present(result_image))
    call opencoarrays_co_max(c_loc(a_descriptor),result_image_, stat, errmsg, unused, len(errmsg))

  end subroutine

  ! ________ Assumed-rank co_sum wrappers for each supported type and kind _____________
  ! ____________________________________________________________________________________

  subroutine co_sum_c_double(a,result_image,stat,errmsg)
    real(c_double), intent(inout), volatile, target, contiguous :: a(..)
    integer(c_int), intent(in), optional :: result_image
    integer(c_int), intent(out), optional:: stat
    character(kind=1,len=*), intent(out), optional :: errmsg
    ! Local variables and constants:
    type(gfc_descriptor_t), target :: a_descriptor
    integer(c_int), parameter :: default_result_image=0
    integer(c_int) :: result_image_ ! Local replacement for the corresponding intent(in) dummy argument

    a_descriptor = gfc_descriptor(a)
    result_image_ = merge(result_image,default_result_image,present(result_image))
    call opencoarrays_co_sum(c_loc(a_descriptor),result_image_, stat, errmsg, len(errmsg))

  end subroutine

  subroutine co_sum_c_int(a,result_image,stat,errmsg)
    integer(c_int), intent(inout), volatile, target, contiguous :: a(..)
    integer(c_int), intent(in), optional :: result_image
    integer(c_int), intent(out), optional:: stat
    character(kind=1,len=*), intent(out), optional :: errmsg
    ! Local variables and constants:
    integer(c_int), parameter :: default_result_image=0
    type(gfc_descriptor_t), target :: a_descriptor
    integer(c_int) :: result_image_ ! Local replacement for the corresponding intent(in) dummy argument

    a_descriptor = gfc_descriptor(a)
    result_image_ = merge(result_image,default_result_image,present(result_image))
    call opencoarrays_co_sum(c_loc(a_descriptor),result_image_, stat, errmsg, len(errmsg))

  end subroutine

  ! Return the image number (MPI rank + 1)
  function this_image()  result(image_num)
#ifdef MPI_WORKING_MODULE
    use mpi, only : MPI_Comm_rank
#endif
    integer(c_int) :: image_num,ierr
   !image_num = opencoarrays_this_image(unused)
    call MPI_Comm_rank(CAF_COMM_WORLD,image_num,ierr)
    if (ierr/=0) call error_stop
    image_num = image_num + 1
  end function

  ! Return the total number of images
  function num_images()  result(num_images_)
#ifdef MPI_WORKING_MODULE
    use mpi, only : MPI_Comm_size
#endif
    integer(c_int) :: num_images_,ierr
   !num_images_ = opencoarrays_num_images(unused_coarray,unused_scalar)
    call MPI_Comm_size(CAF_COMM_WORLD,num_images_,ierr)
    if (ierr/=0) call error_stop
  end function

  ! Halt the execution of all images
  subroutine error_stop(stop_code)
    integer(c_int32_t), intent(in), optional :: stop_code
    integer(c_int32_t), parameter :: default_code=-1_c_int32_t
    integer(c_int32_t) :: code
    code = merge(stop_code,default_code,present(stop_code))
    call opencoarrays_error_stop(code)
  end subroutine

  ! Impose a global execution barrier
  subroutine sync_all(stat,errmsg,unused)
    integer(c_int), intent(out), optional :: stat,unused
    character(c_char), intent(out), optional :: errmsg
    call opencoarrays_sync_all(stat,errmsg,unused)
  end subroutine

#ifdef COMPILER_SUPPORTS_ATOMICS
   ! Proposed Fortran 2015 event_post procedure
   subroutine event_post(this)
     class(event_type), intent(inout) ::  this
     if (.not.allocated(this%atom)) this%atom=0
     call atomic_define ( this%atom, this%atom + 1_atomic_int_kind )
   end subroutine
#endif

end module

! test1caf test
!
! Copyright (c) 2012-2014, Sourcery, Inc.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of the Sourcery, Inc., nor the
!       names of its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE FOR ANY
! DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
!

program test1caf
  implicit none
  integer, parameter :: num_local_elems=3,a_initial=1,b_initial=2
  integer :: a(num_local_elems)[*]=a_initial,b(num_local_elems)[*]=b_initial
  integer :: i,me,np,left,right

  me = this_image()
  np = num_images()

  left  = merge(np,me-1,me==1)
  right = merge(1,me+1,me==np)

  if (mod(me,2).eq.0) then
     a(:)[right] = a(:)[right]+me
  else
     b(:)[left] = b(:)[left]+me
  end if

  if(me==1) then
     write(*,*) me, a, b
  else
     sync images(me-1)
     write(*,*) me, a, b
  end if

  if(me < np) sync images(me+1)

  if (mod(me,2).eq.0) then
    if ( any(a(:)[right]/=a_initial+me)) error stop "Test failed."
  else
    if ( any(b(:)[left]/=b_initial+me)) error stop "Test failed."
  end if

  if (me==1) print *,"Test passed."

end program test1caf

!! Thoroughly test get, i.e. foo = bar [N] in all variants
!!
!! Do simple tests for get(). These test comprise
!!
!! FOO = BAR [N]
!!
!! where
!!
!!  FOO                BAR                 images
!! character(len=20) character(len=10)   N == me
!!  kind == 1         kind == 1
!!  kind == 1         kind == 4
!!  kind == 4         kind == 1
!!  kind == 4         kind == 4
!!
!! character         character
!!   (1:4, len == 5)  (1:4, len == 5)
!!  kind == 1         kind == 1
!!  kind == 1         kind == 4
!!  kind == 4         kind == 1
!!  kind == 4         kind == 4
!!
!! all of the above but for              N != me
!!
!! And may be some other, I've forgotten.
!!
!! Author: Andre Vehreschild, 2017



program get_convert_char_array

  implicit none

  character(kind=1, len=10), codimension[*] :: co_str_k1_scal
  character(kind=1, len=20)                 :: str_k1_scal
  character(kind=4, len=10), codimension[*] :: co_str_k4_scal
  character(kind=4, len=20)                 :: str_k4_scal

  character(kind=1, len=5), codimension[*] :: co_str_k1_arr(1:4)
  character(kind=1, len=5)                 :: str_k1_arr(1:4)
  character(kind=4, len=5), codimension[*] :: co_str_k4_arr(1:4)
  character(kind=4, len=5)                 :: str_k4_arr(1:4)
  logical :: error_printed=.false.

  associate(me => this_image(), np => num_images())
    if (np < 2) error stop 'Can not run with less than 2 images.'

    co_str_k1_scal = 'abcdefghij'
    co_str_k4_scal = 4_'abcdefghij'

    co_str_k1_arr(:) = ['abc', 'EFG', 'klm', 'NOP']
    co_str_k4_arr(:) = [4_'abc', 4_'EFG', 4_'klm', 4_'NOP']

    ! First check get/copy to self
    if (me == 1) then
      str_k1_scal = co_str_k1_scal[1]
      print *, '#' // str_k1_scal // '#, len:', len(str_k1_scal)
      if (co_str_k1_scal /= str_k1_scal // '          ') call print_and_register( 'get scalar kind=1 to kind=1 self failed.')

      str_k4_scal = co_str_k4_scal[1]
      print *, 4_'#' // str_k4_scal // 4_'#, len:', len(str_k4_scal)
      if (co_str_k4_scal /= str_k4_scal // 4_'          ') call print_and_register( 'get scalar kind=4 to kind=4 self failed.')

      str_k4_scal = co_str_k1_scal[1]
      print *, 4_'#' // str_k4_scal // 4_'#, len:', len(str_k4_scal)
      if (co_str_k4_scal /= str_k4_scal // 4_'          ') call print_and_register( 'get scalar kind=1 to kind=4 self failed.')

      str_k1_scal = co_str_k4_scal[1]
      print *, '#' // str_k1_scal // '#, len:', len(str_k1_scal)
      if (co_str_k1_scal /= str_k1_scal // '          ') call print_and_register( 'get scalar kind=4 to kind=1 self failed.')
    end if

    ! Do the same for arrays but on image 2
    if (me == 2) then
      str_k1_arr(:) = co_str_k1_arr(:)[2]
      print *, '#' // str_k1_arr(:) // '#, len:', len(str_k1_arr(1))
      if (any(str_k1_arr /= ['abc  ', 'EFG  ', 'klm  ', 'NOP  '])) &
        call print_and_register( 'get array kind=1 to kind=1 self failed.')

      print *, str_k4_arr
      str_k4_arr(:) = co_str_k4_arr(:)[2]
      print *, 4_'#' // str_k4_arr(:) // 4_'#, len:', len(str_k4_arr(1))
      if (any(str_k4_arr /= [4_'abc  ', 4_'EFG  ', 4_'klm  ', 4_'NOP  '])) &
        call print_and_register( 'get array kind=4 to kind=4 self failed.')

      str_k4_arr(:) = co_str_k1_arr(:)[2]
      print *, 4_'#' // str_k4_arr(:) // 4_'#, len:', len(str_k4_arr(1))
      if (any(str_k4_arr /= [ 4_'abc  ', 4_'EFG  ', 4_'klm  ', 4_'NOP  '])) &
        call print_and_register( 'get array kind=1 to kind=4 self failed.')

      str_k1_arr(:) = co_str_k4_arr(:)[2]
      print *, '#' // str_k1_arr(:) // '#, len:', len(str_k1_arr(1))
      if (any(str_k1_arr /= ['abc  ', 'EFG  ', 'klm  ', 'NOP  '])) &
        call print_and_register( 'get array kind=4 to kind=1 self failed.')
    end if

    sync all
    if (me == 1) then
      str_k1_scal = co_str_k1_scal[2]
      print *, '#' // str_k1_scal // '#, len:', len(str_k1_scal)
      if (co_str_k1_scal /= str_k1_scal // '          ') call print_and_register( 'get kind=1 to kind=1 image 2 failed.')

      str_k4_scal = co_str_k4_scal[2]
      print *, 4_'#' // str_k4_scal // 4_'#, len:', len(str_k4_scal)
      if (co_str_k4_scal /= str_k4_scal // 4_'          ') call print_and_register( 'get kind=4 to kind=4 image 2 failed.')
    else if (me == 2) then
      str_k4_scal = co_str_k1_scal[1]
      print *, 4_'#' // str_k4_scal // 4_'#, len:', len(str_k4_scal)
      if (co_str_k4_scal /= str_k4_scal // 4_'          ') call print_and_register( 'get kind=1 to kind=4 from image 1 failed.')

      str_k1_scal = co_str_k4_scal[1]
      print *, '#' // str_k1_scal // '#, len:', len(str_k1_scal)
      if (co_str_k1_scal /= str_k1_scal // '          ') call print_and_register( 'get kind=4 to kind=1 from image 1 failed.')
    end if

    str_k1_arr(:) = '#####'
    str_k4_arr(:) = 4_'#####'

    sync all

    if (me == 1) then
      str_k1_arr(1:2) = co_str_k1_arr(::2)[2]
      print *, str_k1_arr
      if (any(str_k1_arr /= ['abc  ', 'klm  ', '#####', '#####'])) &
        & call print_and_register( "strided get char arr kind 1 to kind 1 failed.")

      str_k4_arr(1:2) = co_str_k4_arr(::2)[2]
      print *, str_k4_arr
      if (any(str_k4_arr /= [4_'abc  ', 4_'klm  ', 4_'#####', 4_'#####'] )) &
        & call print_and_register( "strided get char arr kind 4 to kind 4 failed.")
    end if

    select case(me)
     case(1)
       if (error_printed) error stop
       sync images(2)
       print *, 'Test passed.'
     case(2)
       if (error_printed) error stop
       sync images(1)
    end select

  end associate

contains

  subroutine print_and_register(error_message)
    use iso_fortran_env, only : error_unit
    character(len=*), intent(in) :: error_message
    write(error_unit,*) error_message
    error_printed=.true.
  end subroutine

end program get_convert_char_array

! vim:ts=2:sts=2:sw=2:

! MoFo library: co_object_interface
!
! Copyright (c) 2012-2014, Sourcery, Inc.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of the Sourcery, Inc., nor the
!       names of its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE FOR ANY
! DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS

module co_object_interface
  implicit none
  private
  public :: co_object

  ! Define an abstract base class to ensure basic functionality expected to be provided by all concrete Morfeus classes.
  ! Each concrete class provides the functionality by extending this class and implementing its deferred binding(s).  This
  ! class resembles java's Object class in the sense that it is intended to be the ultimate ancester of every other class.
  type, abstract :: co_object
    private
    logical :: defined=.false. ! Mark all co_objects as not-yet user-defined by default
    real, allocatable :: dummy_to_facilitate_extension[:]
  contains
    procedure :: mark_as_defined
    procedure :: user_defined
    procedure(formatted_output_interface), deferred :: output
   !generic :: write(unformatted) => output  ! Derived-type I/O not yet supported by most compilers
  end type

  ! Require child classes to write an "output" procedure that prints to the passed file unit
  abstract interface
    subroutine formatted_output_interface(this,unit,iotype,v_list,iostat,iomsg)
      import co_object
      class(co_object), intent(in) :: this
      integer, intent(in) :: unit ! Unit on which output happens (negative for internal file)
      character(*), intent(in) :: iotype ! Allowable values: ’LISTDIRECTED’,’NAMELIST’, or ’DT’
      integer, intent(in) :: v_list(:)
      integer, intent(out) :: iostat
      character(*), intent(inout) :: iomsg
    end subroutine
  end interface

contains

  ! Mark the co_object as user-defined
  pure subroutine mark_as_defined(this)
    class(co_object), intent(inout) :: this
    this%defined=.true.
  end subroutine

  ! Return a boolean result indicating whether this co_object has been initialized since its declaration
  logical pure function user_defined(this)
    class(co_object), intent(in) :: this
    user_defined = this%defined
  end function

end module

! MoFo library: parse_command_line
!
! Copyright (c) 2012-2014, Sourcery, Inc.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of the Sourcery, Inc., nor the
!       names of its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE FOR ANY
! DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS

module parse_command_line
  ! Utility for returning key-value pairs passed at the command line in the format
  ! command key1=value1  key2=value2 ...
  implicit none
  private
  public :: get_keyword_values

contains

  subroutine assert(test_passes)
    logical, intent(in) :: test_passes
    if (.not. test_passes) stop "assertion failed"
  end subroutine

  ! Return the command-line values associated with the passed keys.
  ! Arguments and result variables:
  ! keys = array of keywords
  ! default_values = values returned for like-positioned keyword if no command-line value specified
  ! actual_values = values returned for like-positioned keys
  ! Each elment in the keys and default_values arrays must be padded with trailing blanks if necessary to give the elements
  ! a uniform length.  The actual_values elements are similarly padded if necessary to give them a uniform length.
  function get_keyword_values(keys,default_values) result(actual_values)
    character(len=*), dimension(:), intent(in) :: keys
    character(len=*), dimension(:), intent(in) :: default_values
    character(len=:), dimension(:), allocatable :: actual_values
    character(len=:), allocatable :: key_value_pair,trimmed_argument,trimmed_value
    character(len=1), parameter :: divider="="
    integer divider_position,error_flag,i,j

    ! Requires
    call assert(size(keys)==size(default_values))

    actual_values=default_values
    allocate(key_value_pair,source=repeat(" ",ncopies=max_argument_length()) )
    ! Read the text of the arguments passed on the command line
    do i=1,command_argument_count()
      call get_command_argument(i,key_value_pair,status=error_flag)
      call check(error_flag)
      divider_position = scan(key_value_pair,divider)
      if (divider_position==0) stop "Invalid argument format (expected: 'argument=value')."
      trimmed_argument = trim(key_value_pair(1:divider_position-1))
      trimmed_value = trim(key_value_pair(divider_position+1:))
      if (len(trimmed_value)==0) stop "Invalid value format (expected: 'argument=value')."
      do j=1,size(keys)
        if (trim(keys(j))==trimmed_argument) actual_values(j)=trimmed_value
      end do
    end do

    ! Ensures
    call assert(size(actual_values)==size(keys))
  contains
    function max_argument_length()
      integer max_argument_length,n,length_of_argument_n
      max_argument_length=0
      do n=1,command_argument_count()
        call get_command_argument(n,key_value_pair,status=error_flag,length=length_of_argument_n)
        call check(error_flag)
        if (length_of_argument_n>max_argument_length) max_argument_length = length_of_argument_n
      end do
    end function
    subroutine check(flag)
      integer, intent(in) :: flag
      select case(flag)
        case(-1)
          ! this should never occur because key_value_pair is dynamically sized to match the length of the longest argument
          print *,"main: argument ",i,"exceeds maximum length of ",max_argument_length()
          stop
        case(1:)
          print *,"main: error in reading the argument name (status=",flag,")"
          stop
        case(0)
          ! argument_text read successfully
        case default
          stop "main: invalid status (compiler error)"
      end select
    end subroutine
  end function
end module

! caf -o bcast bcast.f90
! cafrun -np 2 ./bcast
! mwe for issue github.com/sourceryinstitute/OpenCoarrays/issues/503

program main
   real, allocatable, dimension(:, :, :) :: arr1, arr2
   integer :: i, me, nimg
   real :: red1, sum1, red2, sum2
   
   allocate(arr1(10, 20, 8))
   allocate(arr2(10, 20, 30))

   me = this_image()
   nimg = num_images()

   if (me == 1) then
      arr1 = reshape([(i, i=1, size(arr1))], shape(arr1))
      arr2 = reshape([(i, i=1, size(arr2))], shape(arr2))
   end if

   call co_broadcast(arr1, source_image=1)
   call co_broadcast(arr2, source_image=1)

   sum1 = sum(arr1)
   sum2 = sum(arr2)

   red1 = sum1
   red2 = sum2

   call co_sum(red1)
   call co_sum(red2)

   sync all
   print *, me, ' sum1=', sum1, ' red1=', red1
   print *, me, ' sum2=', sum2, ' red2=', red2

   if (abs(red1 - nimg * sum1) > epsilon(0.) .or. abs(red2 - nimg * sum2) > epsilon(0.)) then
      write(*,*) 'Test failed!'
      error stop 5
   else
      write(*,*) 'Test passed.'
   end if
   deallocate(arr1, arr2)
end program

module local_field_module
   use iso_fortran_env, only : real64,int64
   use ForTrilinos_assertion_utility, only : assert,error_message
   use object_interface, only : object
   implicit none
   private
   public :: local_field

   type, extends(object) :: local_field
     private
     real(real64), allocatable :: values(:)
   contains
     procedure :: state
     procedure, private, pass(rhs) :: multiply
     procedure, private :: subtract
     procedure, private :: assign_array
     generic :: operator(-)=>subtract
     generic :: operator(*)=>multiply
     generic :: assignment(=)=>assign_array
     procedure :: output
   end type

contains

  pure subroutine assign_array(lhs,rhs)
    class(local_field), intent(inout) :: lhs
    real(real64), intent(in) :: rhs(:)
    lhs%values = rhs
    ! Ensures
    call lhs%mark_as_defined
  end subroutine

  pure function subtract(lhs,rhs) result(difference)
    class(local_field), intent(in) :: lhs,rhs
    type(local_field) :: difference
    !Requires
    if (lhs%user_defined() .and. rhs%user_defined()) then
      difference%values = lhs%values - rhs%values
      ! Ensures
      call difference%mark_as_defined
    end if
  end function

  pure function multiply(lhs,rhs) result(product_)
    class(local_field), intent(in) :: rhs
    type(local_field) :: product_
    real(real64), intent(in) :: lhs
    if (rhs%user_defined()) then
      product_%values = lhs*rhs%values
      ! Ensures
      call product_%mark_as_defined
    end if
  end function

  pure function state(this) result(this_values)
    class(local_field), intent(in) :: this
    real(real64), allocatable :: this_values(:)
    this_values = this%values
  end function

  subroutine output(this,unit,iotype,v_list,iostat,iomsg)
    class(local_field), intent(in) :: this
    integer, intent(in) :: unit
    character(len=*), intent(in) :: iotype
    integer, intent(in) :: v_list(:)
    integer, intent(out) :: iostat
    character(len=*), intent(inout) :: iomsg
    integer(int64) :: i
    ! Requires
    call assert(this%user_defined(),error_message("local_field%output received uninitialized object"))
    do i=1,size(this%values)
      write(unit,iostat=iostat) (this_image()-1)*size(this%values) + i, this%values(i)
    end do
  end subroutine

end module

!! Thoroughly test send, i.e. foo[N].comp = bar in all variants
!!
!! Do simple tests for send(). These test comprise
!!
!! FOO[N].COMP = BAR
!!
!! where
!!
!!  FOO                BAR              images
!! scalar            scalar            N == me
!!  int(k e [1,4])    int(k e [1,4])
!!  real(k e [4,8])   real(k e [4,8])
!!  int(k e [1,4])    real(k e [4,8])
!!  real(k e [4,8])   int(k e [1,4])
!!
!! array(1:5)        scalar
!!  int(k e [1,4])    int(k e [1,4])
!!  real(k e [4,8])   real(k e [4,8])
!!  int(k e [1,4])    real(k e [4,8])
!!  real(k e [4,8])   int(k e [1,4])
!!
!! array(1:5)        array(1:5)
!!  int(k e [1,4])    int(k e [1,4])
!!  real(k e [4,8])   real(k e [4,8])
!!  int(k e [1,4])    real(k e [4,8])
!!  real(k e [4,8])   int(k e [1,4])
!!
!! array(1:3)       array(::2)
!!  int(k e [1,4])    int(k e [1,4])
!!  real(k e [4,8])   real(k e [4,8])
!!  int(k e [1,4])    real(k e [4,8])
!!  real(k e [4,8])   int(k e [1,4])
!!
!! array(4:5)       array(2::2)
!!  int(k e [1,4])    int(k e [1,4])
!!  real(k e [4,8])   real(k e [4,8])
!!  int(k e [1,4])    real(k e [4,8])
!!  real(k e [4,8])   int(k e [1,4])
!!
!! array(1:3)      array(3:1:-1)
!!  int(k e [1,4])    int(k e [1,4])
!!  real(k e [4,8])   real(k e [4,8])
!!  int(k e [1,4])    real(k e [4,8])
!!  real(k e [4,8])   int(k e [1,4])
!!
!! all of the above but for            N != me
!!
!! And may be some other, I've forgotten.
!!
!! Author: Andre Vehreschild, 2017

program alloc_comp_send_convert_nums

  implicit none

  real(kind=4), parameter :: tolerance4 = 1.0e-4
  real(kind=8), parameter :: tolerance4to8 = 1.0E-4
  real(kind=8), parameter :: tolerance8 = 1.0E-6

  type t
    integer(kind=1), allocatable :: int_scal_k1
    integer(kind=4), allocatable :: int_scal_k4
    real(kind=4)   , allocatable :: real_scal_k4
    real(kind=8)   , allocatable :: real_scal_k8
    integer(kind=1), allocatable, dimension(:) :: int_k1
    integer(kind=4), allocatable, dimension(:) :: int_k4
    real(kind=4)   , allocatable, dimension(:) :: real_k4
    real(kind=8)   , allocatable, dimension(:) :: real_k8
  end type t

  integer(kind=1)                              :: int_scal_k1
  integer(kind=4)                              :: int_scal_k4
  real(kind=4)                                 :: real_scal_k4
  real(kind=8)                                 :: real_scal_k8

  integer(kind=1), dimension(1:5)                            :: int_k1
  integer(kind=4), dimension(1:5)                            :: int_k4
  real(kind=4)   , dimension(1:5)                            :: real_k4
  real(kind=8)   , dimension(1:5)                            :: real_k8

  type(t), save, codimension[*] :: obj

  logical :: error_printed=.false.

  associate(me => this_image(), np => num_images())
    if (np < 2) error stop 'Cannot run with less than 2 images.'

    int_scal_k1 = INT(42, 1)
    int_scal_k4 = 42
    int_k1 = INT([5, 4, 3, 2, 1], 1)
    int_k4 = [5, 4, 3, 2, 1]
    allocate(obj%int_scal_k1, obj%int_scal_k4, obj%int_k1(5), obj%int_k4(5)) ! allocate syncs here

    real_scal_k4 = 37.042
    real_scal_k8 = REAL(37.042, 8)
    real_k4 = [ 5.1, 4.2, 3.3, 2.4, 1.5]
    real_k8 = REAL([ 5.1, 4.2, 3.3, 2.4, 1.5], 8)
    allocate(obj%real_scal_k4, obj%real_scal_k8, obj%real_k4(1:5), obj%real_k8(1:5)) ! allocate syncs here
    ! First check send/copy to self
    if (me == 1) then
      obj[1]%int_scal_k1 = int_scal_k1
      print *, obj%int_scal_k1
      if (obj%int_scal_k1 /= int_scal_k1) error stop 'send scalar int kind=1 to kind=1 self failed.'

      obj[1]%int_scal_k4 = int_scal_k4
      print *, obj%int_scal_k4
      if (obj%int_scal_k4 /= int_scal_k4) call print_and_register( 'send scalar int kind=4 to kind=4 self failed.')

      obj[1]%int_scal_k4 = int_scal_k1
      print *, obj%int_scal_k4
      if (obj%int_scal_k4 /= int_scal_k4) call print_and_register( 'send scalar int kind=1 to kind=4 self failed.')

      obj[1]%int_scal_k1 = int_scal_k4
      print *, obj%int_scal_k1
      if (obj%int_scal_k1 /= int_scal_k1) call print_and_register( 'send scalar int kind=4 to kind=1 self failed.')

      obj[1]%int_k1(:) = int_k1
      print *, obj%int_k1
      if (any(obj%int_k1 /= int_k1)) call print_and_register( 'send int kind=1 to kind=1 self failed.')

      obj[1]%int_k4(:) = int_k4
      print *, obj%int_k4
      if (any(obj%int_k4 /= int_k4)) call print_and_register( 'send int kind=4 to kind=4 self failed.')

      obj[1]%int_k4(:) = int_k1
      print *, obj%int_k4
      if (any(obj%int_k4 /= int_k4)) call print_and_register( 'send int kind=1 to kind=4 self failed.')

      obj[1]%int_k1(:) = int_k4
      print *, obj%int_k1
      if (any(obj%int_k1 /= int_k1)) call print_and_register( 'send int kind=4 to kind=1 self failed.')
    else if (me == 2) then ! Do the real copy to self checks on image 2
      obj[2]%real_scal_k4 = real_scal_k4
      print *, obj%real_scal_k4
      if (abs(obj%real_scal_k4 - real_scal_k4) > tolerance4) &
        call print_and_register( 'send scalar real kind=4 to kind=4 self failed.')

      obj[2]%real_scal_k8 = real_scal_k8
      print *, obj%real_scal_k8
      if (abs(obj%real_scal_k8 - real_scal_k8) > tolerance8) &
        call print_and_register( 'send scalar real kind=8 to kind=8 self failed.')

      obj[2]%real_scal_k8 = real_scal_k4
      print *, obj%real_scal_k8
      if (abs(obj%real_scal_k8 - real_scal_k8) > tolerance4to8) &
        call print_and_register( 'send scalar real kind=4 to kind=8 self failed.')

      obj[2]%real_scal_k4 = real_scal_k8
      print *, obj%real_scal_k4
      if (abs(obj%real_scal_k4 - real_scal_k4) > tolerance4) &
        call print_and_register( 'send scalar real kind=8 to kind=4 self failed.')

      obj[2]%real_k4(:) = real_k4
      print *, obj%real_k4
      if (any(abs(obj%real_k4 - real_k4) > tolerance4)) call print_and_register( 'send real kind=4 to kind=4 self failed.')

      obj[2]%real_k8(:) = real_k8
      print *, obj%real_k8
      if (any(abs(obj%real_k8 - real_k8) > tolerance8)) call print_and_register( 'send real kind=8 to kind=8 self failed.')

      obj[2]%real_k8(:) = real_k4
      print *, obj%real_k8
      if (any(abs(obj%real_k8 - real_k8) > tolerance4to8)) call print_and_register( 'send real kind=4 to kind=8 self failed.')

      obj[2]%real_k4(:) = real_k8
      print *, obj%real_k4
      if (any(abs(obj%real_k4 - real_k4) > tolerance4)) call print_and_register( 'send real kind=8 to kind=4 self failed.')
    end if

    sync all
    if (me == 1) then
      obj[2]%int_scal_k1 = int_scal_k1

      obj[2]%int_scal_k4 = int_scal_k4

      obj[2]%int_k1(:) = int_k1

      obj[2]%int_k4(:) = int_k4

      obj[2]%real_scal_k4 = real_scal_k4

      obj[2]%real_scal_k8 = real_scal_k8

      obj[2]%real_k4(:) = real_k4

      obj[2]%real_k8(:) = real_k8
    end if

    sync all
    if (me == 2) then
      print *, obj%int_scal_k1
      if (obj%int_scal_k1 /= int_scal_k1) call print_and_register( 'send scalar int kind=1 to kind=1 to image 2 failed.')

      print *, obj%int_scal_k4
      if (obj%int_scal_k4 /= int_scal_k4) call print_and_register( 'send scalar int kind=4 to kind=4 to image 2 failed.')

      print *, obj%int_k1
      if (any(obj%int_k1 /= int_k1)) call print_and_register( 'send int kind=1 to kind=1 to image 2 failed.')

      print *, obj%int_k4
      if (any(obj%int_k4 /= int_k4)) call print_and_register( 'send int kind=4 to kind=4 to image 2 failed.')

      print *, obj%real_scal_k4
      if (abs(obj%real_scal_k4 - real_scal_k4) > tolerance4) &
        call print_and_register( 'send scalar real kind=4 to kind=4 to image 2 failed.')

      print *, obj%real_scal_k8
      if (abs(obj%real_scal_k8 - real_scal_k8) > tolerance8) &
        call print_and_register( 'send scalar real kind=8 to kind=8 to image 2 failed.')

      print *, obj%real_k4
      if (any(abs(obj%real_k4 - real_k4) > tolerance4)) &
        call print_and_register( 'send real kind=4 to kind=4 to image 2 failed.')

      print *, obj%real_k8
      if (any(abs(obj%real_k8 - real_k8) > tolerance8)) &
        call print_and_register( 'send real kind=8 to kind=8 to image 2 failed.')
    end if

    sync all
    if (me == 1) then
      obj[2]%int_scal_k4 = int_scal_k1

      obj[2]%int_scal_k1 = int_scal_k4

      obj[2]%int_k4(:) = int_k1

      obj[2]%int_k1(:) = int_k4

      obj[2]%real_scal_k8 = real_scal_k4

      obj[2]%real_scal_k4 = real_scal_k8

      obj[2]%real_k8(:) = real_k4

      obj[2]%real_k4(:) = real_k8
    end if

    sync all
    if (me == 2) then
      print *, obj%int_scal_k4
      if (obj%int_scal_k4 /= int_scal_k4) call print_and_register( 'send scalar int kind=1 to kind=4 to image 2 failed.')

      print *, obj%int_scal_k1
      if (obj%int_scal_k1 /= int_scal_k1) call print_and_register( 'send scalar int kind=4 to kind=1 to image 2 failed.')

      print *, obj%int_k4
      if (any(obj%int_k4 /= int_k4)) call print_and_register( 'send int kind=1 to kind=4 to image 2 failed.')

      print *, obj%int_k1
      if (any(obj%int_k1 /= int_k1)) call print_and_register( 'send int kind=4 to kind=1 to image 2 failed.')

      print *, obj%real_scal_k8
      if (abs(obj%real_scal_k8 - real_scal_k8) > tolerance4to8) &
        call print_and_register( 'send scalar real kind=4 to kind=8 to image 2 failed.')

      print *, obj%real_scal_k4
      if (abs(obj%real_scal_k4 - real_scal_k4) > tolerance4) &
        call print_and_register( 'send scalar real kind=8 to kind=4 to image 2 failed')

      print *, obj%real_k8
      if (any(abs(obj%real_k8 - real_k8) > tolerance4to8)) &
        call print_and_register( 'send real kind=4 to kind=8 to image 2 failed')

      print *, obj%real_k4
      if (any(abs(obj%real_k4 - real_k4) > tolerance4)) call print_and_register( 'send real kind=8 to kind=4 to image 2 failed')
    end if

    ! Scalar to array replication
    sync all
    if (me == 1) then
      obj[2]%int_k4(:) = int_scal_k4

      obj[2]%int_k1(:) = int_scal_k1

      obj[2]%real_k8(:) = real_scal_k8

      obj[2]%real_k4(:) = real_scal_k4
    end if

    sync all
    if (me == 2) then
      print *, obj%int_k4
      if (any(obj%int_k4 /= int_scal_k4)) call print_and_register( 'send int scal kind=4 to array kind=4 to image 2 failed')

      print *, obj%int_k1
      if (any(obj%int_k1 /= int_scal_k1)) call print_and_register( 'send int scal kind=1 to array kind=1 to image 2 failed')

      print *, obj%real_k8
      if (any(abs(obj%real_k8 - real_scal_k8) > tolerance8)) &
        call print_and_register( 'send real kind=8 to array kind=8 to image 2 failed')

      print *, obj%real_k4
      if (any(abs(obj%real_k4 - real_scal_k4) > tolerance4)) &
        call print_and_register( 'send real kind=4 to array kind=4 to image 2 failed')
    end if

    ! and with kind conversion
    sync all
    if (me == 1) then
      obj[2]%int_k4(:) = int_scal_k1

      obj[2]%int_k1(:) = int_scal_k4

      obj[2]%real_k8(:) = real_scal_k4

      obj[2]%real_k4(:) = real_scal_k8
    end if

    sync all
    if (me == 2) then
      print *, obj%int_k4
      if (any(obj%int_k4 /= int_scal_k4)) call print_and_register( 'send int scal kind=1 to array kind=4 to image 2 failed')

      print *, obj%int_k1
      if (any(obj%int_k1 /= int_scal_k1)) call print_and_register( 'send int scal kind=4 to array kind=1 to image 2 failed')

      print *, obj%real_k8
      if (any(abs(obj%real_k8 - real_scal_k8) > tolerance8)) &
        call print_and_register( 'send real kind=4 to array kind=8 to image 2 failed')

      print *, obj%real_k4
      if (any(abs(obj%real_k4 - real_scal_k4) > tolerance4)) &
        call print_and_register( 'send real kind=8 to array kind=4 to image 2 failed')
    end if
    ! and with type conversion
    sync all
    if (me == 1) then
      obj[2]%int_k4(:) = real_scal_k4

      obj[2]%int_k1(:) = real_scal_k4

      obj[2]%real_k8(:) = int_scal_k4

      obj[2]%real_k4(:) = int_scal_k4
    end if

    sync all
    if (me == 2) then
      print *, obj%int_k4
      if (any(obj%int_k4 /= INT(real_scal_k4, 4))) &
        call print_and_register( 'send real scal kind=4 to int array kind=4 to image 2 failed')

      print *, obj%int_k1
      if (any(obj%int_k1 /= INT(real_scal_k4, 1))) &
        call print_and_register( 'send real scal kind=1 to int array kind=1 to image 2 failed')

      print *, obj%real_k8
      if (any(abs(obj%real_k8 - int_scal_k4) > tolerance4to8)) &
        call print_and_register( 'send int kind=4 to real array kind=8 to image 2 failed')

      print *, obj%real_k4
      if (any(abs(obj%real_k4 - int_scal_k4) > tolerance4)) &
        call print_and_register( 'send int kind=4 to real array kind=4 to image 2 failed')
    end if

    ! Now with strides
    ! First check send/copy to self
    if (me == 1) then
      obj%int_k1 = -1
      obj[1]%int_k1(::2) = int_k1(1:3)
      print *, obj%int_k1
      if (any(obj%int_k1 /= [int_k1(1), INT(-1, 1), int_k1(2), INT(-1, 1), int_k1(3)])) &
        & call print_and_register( 'send strided int kind=1 to kind=1 self failed')

      obj%int_k4 = -1
      obj[1]%int_k4(::2) = int_k4
      print *, obj%int_k4
      if (any(obj%int_k4 /= [int_k4(1), -1, int_k4(2), -1, int_k4(3)])) &
        call print_and_register( 'send strided int kind=4 to kind=4 self failed')

      obj%int_k4 = -2
      obj[1]%int_k4(2::2) = int_k1(4:5)
      print *, obj%int_k4
      if (any(obj%int_k4 /= [-2, int_k4(4), -2, int_k4(5), -2])) &
        call print_and_register( 'send strided int kind=1 to kind=4 self failed')

      obj%int_k1 = -2
      obj[1]%int_k1(2::2) = int_k4(4:5)
      print *, obj%int_k1
      if (any(obj%int_k1 /= [INT(-2, 1), int_k1(4), INT(-2, 1), int_k1(5), INT(-2, 1)])) &
        & call print_and_register( 'send strided int kind=4 to kind=1 self failed')

    else if (me == 2) then ! Do the real copy to self checks on image 2
      obj%real_k4 = -1.0
      obj[2]%real_k4(::2) = real_k4(1:3)
      print *, obj%real_k4
      if (any(abs(obj%real_k4 - [real_k4(1), -1.0, real_k4(2), -1.0, real_k4(3)]) > tolerance4)) &
        & call print_and_register( 'send strided real kind=4 to kind=4 self failed')

      obj%real_k8 = -1.0
      obj[2]%real_k8(::2) = real_k8(1:3)
      print *, obj%real_k8
      if (any(abs(obj%real_k8 - [real_k8(1), REAL(-1.0, 8), real_k8(2), REAL(-1.0, 8), real_k8(3)]) > tolerance8)) &
        & call print_and_register( 'send strided real kind=8 to kind=8 self failed')

      obj%real_k8 = -2.0
      obj[2]%real_k8(2::2) = real_k4(4:5)
      print *, obj%real_k8(1:5), lbound(real_k8, 1)
      if (any(abs(obj%real_k8 - [REAL(-2.0, 8), real_k8(4), REAL(-2.0, 8), real_k8(5), REAL(-2.0, 8)]) > tolerance4to8)) &
        & call print_and_register( 'send strided real kind=4 to kind=8 self failed')

      obj%real_k4 = -2.0
      obj[2]%real_k4(2::2) = real_k8(1:2)
      print *, obj%real_k4
      if (any(abs(obj%real_k4 - [-2.0, real_k4(1), -2.0, real_k4(2), -2.0]) > tolerance4)) &
        & call print_and_register( 'send strided real kind=8 to kind=4 self failed')

    end if

    ! Transfer to other image now.
    sync all
    obj%int_k4 = -1
    obj%int_k1 = INT(-1, 1)
    obj%real_k8 = -1.0
    obj%real_k4 = REAL(-1.0, 4)
    sync all
    if (me == 1) then
      obj[2]%int_k4(::2) = [ 15, 13, 11]

      obj[2]%int_k1(::2) = [INT(-15, 1), INT(-13, 1), INT(-11, 1)]

      obj[2]%real_k8(::2) = [REAL(1.3, 8), REAL(1.5, 8), REAL(1.7, 8)]

      obj[2]%real_k4(::2) = [REAL(1.3, 4), REAL(1.5, 4), REAL(1.7, 4)]
    end if

    sync all
    if (me == 2) then
      print *, obj%int_k4
      if (any(obj%int_k4 /= [15, -1, 13, -1, 11])) &
        call print_and_register( 'strided send int kind=4 to kind=4 to image 2 failed')

      print *, obj%int_k1
      if (any(obj%int_k1 /= [INT(-15, 1), INT(-1, 1), INT(-13, 1), INT(-1, 1), INT(-11, 1)])) &
        call print_and_register( 'strided send int kind=1 to kind=1 to image 2 failed')

      print *, obj%real_k8
      if (any(abs(obj%real_k8 - [1.3, -1.0, 1.5, -1.0, 1.7]) > tolerance8)) &
        call print_and_register( 'strided send real kind=8 to kind=8 to image 2 failed')

      print *, obj%real_k4
      if (any(abs(obj%real_k4 - [REAL(1.3, 4), REAL(-1.0, 4), REAL(1.5, 4), REAL(-1.0, 4), REAL(1.7, 4)]) > tolerance4)) &
        call print_and_register( 'strided send real kind=4 to kind=4 to image 2 failed')
    end if

    ! now with strides and kind conversion
    sync all
    obj%int_k4 = -1
    obj%int_k1 = INT(-1, 1)
    obj%real_k8 = -1.0
    obj%real_k4 = REAL(-1.0, 4)
    sync all
    if (me == 1) then
      obj[2]%int_k4(::2) = [INT(15, 1), INT(13, 1), INT(11, 1)]

      obj[2]%int_k1(::2) = [-15, -13, -11]

      obj[2]%real_k8(::2) = [REAL(1.3, 4), REAL(1.5, 4), REAL(1.7, 4)]

      obj[2]%real_k4(::2) = [REAL(1.3, 8), REAL(1.5, 8), REAL(1.7, 8)]
    end if

    sync all
    if (me == 2) then
      print *, obj%int_k4
      if (any(obj%int_k4 /= [15, -1, 13, -1, 11])) call print_and_register( 'strided send int kind=1 to kind=4 to image 2 failed')

      print *, obj%int_k1
      if (any(obj%int_k1 /= [INT(-15, 1), INT(-1, 1), INT(-13, 1), INT(-1, 1), INT(-11, 1)])) &
        & call print_and_register( 'strided send int kind=4 to kind=1 to image 2 failed')

      print *, obj%real_k8
      if (any(abs(obj%real_k8 - [1.3, -1.0, 1.5, -1.0, 1.7]) > tolerance8)) &
        & call print_and_register( 'strided send real kind=4 to kind=8 to image 2 failed')

      print *, obj%real_k4
      if (any(abs(obj%real_k4 - [REAL(1.3, 4), REAL(-1.0, 4), REAL(1.5, 4), REAL(-1.0, 4), REAL(1.7, 4)]) > tolerance4)) &
        & call print_and_register( 'strided send real kind=8 to kind=4 to image 2 failed')
    end if

    ! now with strides and type conversion
    sync all
    obj%int_k4 = -1
    obj%int_k1 = INT(-1, 1)
    obj%real_k8 = -1.0
    obj%real_k4 = REAL(-1.0, 4)
    sync all
    if (me == 1) then
      obj[2]%int_k4(::2) = [15.0, 13.0, 11.0]

      obj[2]%int_k1(::2) = [-15.0, -13.0, -11.0]

      obj[2]%real_k8(::2) = [13, 15, 17]

      obj[2]%real_k4(::2) = [23, 25, 27]
    end if

    sync all
    if (me == 2) then
      print *, obj%int_k4
      if (any(obj%int_k4 /= [15, -1, 13, -1, 11])) &
        call print_and_register( 'strided send real kind=4 to int kind=4 to image 2 failed')

      print *, obj%int_k1
      if (any(obj%int_k1 /= [INT(-15, 1), INT(-1, 1), INT(-13, 1), INT(-1, 1), INT(-11, 1)])) &
          call print_and_register( 'strided send real kind=4 to int kind=1 to image 2 failed')

      print *, obj%real_k8
      if (any(abs(obj%real_k8 - [13.0, -1.0, 15.0, -1.0, 17.0]) > tolerance8)) &
          call print_and_register( 'strided send int kind=4 to real kind=8 to image 2 failed')

      print *, obj%real_k4
      if (any(abs(obj%real_k4 - [REAL(23, 4), REAL(-1.0, 4), REAL(25, 4), REAL(-1.0, 4), REAL(27, 4)]) > tolerance4)) &
          call print_and_register( 'strided send int kind=4 to real kind=4 to image 2 failed')
    end if

    select case(me)
      case(1)
         if (error_printed) error stop
         sync images(2)
         print *, "Test passed."
      case(2)
         if (error_printed) error stop
        sync images(1)
    end select
  end associate

contains

  subroutine print_and_register(error_message)
    use iso_fortran_env, only : error_unit
    character(len=*), intent(in) :: error_message
    write(error_unit,*) error_message
    error_printed=.true.
  end subroutine

end program alloc_comp_send_convert_nums

! vim:ts=2:sts=2:sw=2:

program get_with_1d_vector_index
  use iso_fortran_env
  implicit none
  integer, parameter :: nloc=8, nhl=2, ivsize=nloc+2*nhl
  real    :: xv(ivsize)[*]
  real, allocatable :: expected(:)
  integer :: rmt_idx(2), loc_idx(2)
  integer, allocatable :: xchg(:)
  integer :: nrcv, me, np, nxch, i, iv
  character(len=120) :: fmt

  me = this_image()
  np = num_images()

  if (np==1) then
    xchg = [ integer :: ]

  else if (me == 1) then
    xchg = [me+1]
  else if (me == np) then
    xchg = [me-1]
  else
    xchg = [me-1, me+1]
  end if
  nxch = size(xchg)
  nrcv = nxch * nhl

  allocate(expected(nxch))
  xv(1:nloc) = [(i,i=(me-1)*nloc+1,me*nloc)]
  iv = nloc + 1
  loc_idx(1:nhl) = [ (i,i=iv,iv+nhl-1) ]
  rmt_idx(1:nhl) = [ (i,i=1,nhl) ]

  sync images(xchg)
  iv = nloc + 1

  xv(iv:iv+nhl-1) = xv(rmt_idx(1:nhl))[xchg(1)]
  print *, me, ":", xv
  iv = iv + nhl
  if (me == 1) then
    expected(:) = nloc + rmt_idx(1:nhl)
  else
    expected(:) = ((me - 2) * nloc) + rmt_idx(1:nhl)
  end if

  sync all
  if (any(xv(loc_idx(1:nhl)) /= expected(:))) then
    write(fmt,*) '( i0,a,',nhl,'(f5.0,1x),a,',nhl,'(f5.0,1x) )'
    write(*,fmt) me,': is:',xv(loc_idx(1:nhl)),', exp:',expected(1:nhl)

    error stop 'Test failed.'
  end if

  sync all
  if (me == 1) print *, 'Test passed.'
end program get_with_1d_vector_index

! This test checks if allocate on coarray variables acts as a barrier.

program alloc_as_barrier
  implicit none

  integer :: me[*]
  integer,allocatable :: a(:)[:]

  me = this_image()

  if(me == 1) call sleep(1)

  allocate(a(10)[*])

  if(me > 1) then
    a = me[me-1]
    if(any(a /= me-1)) then
      write(*,*) "Test failed."
    else
      write(*,*) "Test passed."
    endif
  endif

end program

! Fortran 2015 feature support for Fortran 2008 compilers
!
! Copyright (c) 2015-2022, Sourcery Institute
! Copyright (c) 2015-2022, Archaeologic Inc.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of the Sourcery, Inc., nor the
!       names of its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE FOR ANY
! DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
module opencoarrays
  implicit none

  private
  public :: team_number
  public :: get_communicator

  interface

    function team_number(team_type_ptr) result(my_team_number) bind(C,name="_gfortran_caf_team_number")
       use iso_c_binding, only : c_int,c_ptr
       implicit none
       type(c_ptr), optional :: team_type_ptr
       integer(c_int) :: my_team_number
    end function

    function get_communicator(team_type_ptr) result(my_team) bind(C,name="_gfortran_caf_get_communicator")
       use iso_c_binding, only : c_int,c_ptr
       implicit none
       type(c_ptr), optional :: team_type_ptr
       integer(c_int) :: my_team
    end function

  end interface

end module

program co_reduce_res_im
  !! author: Daniel Topa & Izaak Beekman
  !! category: unit test
  !!
  !! This test is derived from
  !! [issue #172](https://github.com/sourceryinstitute/opencoarrays/issues/172)
  !! but tweaks the binary operator's (pure function) arguments have
  !! `intent(in)` which results in a working/passing test

  implicit none
  integer :: value[ * ] !! Each image stores their image number here
  integer :: k
  value = this_image ( )
#if defined(__GNUC__) && __GNUC__ < 12
  call co_reduce ( value, result_image = 1, operator = myProd )
#else
  call co_reduce ( value, result_image = 1, operation = myProd )
#endif
  !! value[k /= 1] undefined, value[ k == 1 ] should equal $n!$ where $n$ is `num_images()`
  if ( this_image ( ) == 1 ) then
     write ( * , '( "Number of images = ", g0 )' ) num_images ( )
     do k = 1, num_images ( )
        write ( * , '( 2( a, i0 ) )' ) 'value [ ', k, ' ] is ', value [ k ]
        write ( * , '(a)' ) 'since RESULT_IMAGE is present, value on other images is undefined by the standard'
     end do
     write ( * , '( "Product  value = ", g0 )' ) value  !! should print num_images() factorial
     if ( value == factorial( num_images() ) ) then
        write ( * , '(a)' ) 'Test passed.'
     else
        write ( * , '(a, I0)') 'Answer should have been num_images()! = ', factorial( num_images() )
        error stop 'Wrong answer for n! using co_reduce'
     end if
  end if


contains

  pure function myProd ( a, b ) result ( rslt )
    !! Product function to be used in `co_reduce` reduction for
    !! computing factorials. When `intent(in)` attribute is changed
    !! to `value` tests fail
    integer, intent(in) :: a, b
    !! multiply two inputs together.  If we change `intent(in)` to
    !! `value` the test fails despite being correct according to C1276
    !! of F2008:
    !!
    !! > C1276 The specification-part of a pure function subprogram
    !! > shall specify that all its nonpointer dummy data objects have
    !! > the INTENT (IN) or the VALUE attribute.
    !!
    !! Thanks to @LadaF for pointing this out.
    integer        :: rslt !! product of a*b
    rslt = a * b
  end function

  pure function factorial ( n ) result ( rslt )
    !! Compute $n!$
    integer, intent(in) :: n
    integer :: rslt
    integer :: i
    rslt = 1
    do i = 1, n
      rslt = rslt*i
   end do
 end function
end program

program mod_vecsub_01
  !! Issue #322 reported by @reinh-bader
  !! https://github.com/sourceryinstitute/OpenCoarrays/issues/322
  !! Related to other vector indexing issues
  implicit none
  integer, parameter :: ndim = 5, vdim = 2
  real :: vec(ndim), res(ndim)[*]
  integer :: idx(vdim)
  integer :: i, me
  logical :: ok[*]

  res = [ (real(i), i=1, ndim) ]
  vec = 0.0
  idx = [ ndim, 1 ]
  ok = .true.
  sync all
  me = this_image()
  vec(idx) = res(1:2)[1]
  if (vec(1) /= 2.0 .or. vec(5) /= 1.0) then
    critical
      ok[1] = .false.
      write(*, *) 'FAIL on image ',me,vec(idx)
    end critical
  end if
  if (me == 1) then
     if (ok) then
       write(*, *) 'Test passed.'
     else
        error stop 1
     end if
  end if
end program

! Check transfering data from one to a different remote image works.

program test_sendget_by_ref
  implicit none
  type :: rank1_type
    integer, allocatable :: A(:)
  end type
  type :: rank2_type
    integer, allocatable :: A(:,:)
  end type
  type(rank1_type) :: R_get[*]
  type(rank2_type) :: R_send[*]
  integer :: i, j
  logical :: res = .True.

  allocate(R_get%A(this_image()), source=-1)
  R_get%A(this_image()) = this_image()

  allocate(R_send%A(num_images(),num_images()), source=-2)

  sync all

  ! Send data from image j to image i's j-th column.
  ! This ensures that sendget_by_ref works as expected.
  do i = 1, num_images()
    do j = 1, num_images()
      R_send[i]%A(j,this_image()) = R_get[j]%A(j)
    end do
  end do

  sync all

  ! Check that each image has the correct data in its R_send array,
  ! which in fact is the receiver here.
  do i = 1, num_images()
    if (any(R_send%A(:,i) /= (/(j, j = 1, num_images())/))) res = .False.
  end do

  ! Reduce the result. both() is just a logical scalar and, because there
  ! is no predefined operator for this.
  call co_reduce(res, both)
  write(*,*) this_image(), ':', R_get%A, '|', R_send%A

  if (this_image() == 1) then
    if (res) then
      write(*,*) "Test passed."
    else
      write(*,*) "Test failed."
    end if
  end if
contains

  pure function both(lhs, rhs) result(res)
    logical, intent(in) :: lhs, rhs
    logical :: res
    res = lhs .AND. rhs
  end function
end program test_sendget_by_ref

! SYNC IMAGES(*) with the STAT=STAT_STOPPED_IMAGE specifier
! Based on a test taken from UH caf-testsuite

program sync_images_stat
  use, intrinsic:: iso_fortran_env
  implicit none

  integer :: stat_var = 0, me

  me = this_image()

  if (me /= 1 ) then
     sync images(*,STAT=stat_var)
     if ( stat_var /= STAT_STOPPED_IMAGE) then
        print *, "Error:stat_var /= STAT_STOPPED_IMAGE: ", me
        ERROR STOP 1
     end if
     if(me == 2) print *, 'Test passed.'
  end if

  ! Image 1 implicitly synchronizes as part of normal termination
end program sync_images_stat

! async_comp_alloc.f90 

! Unit test for register procedure and remote allocated test:
! Test that scalar allocatable component in a derived typed coarray is
! registered correctly, its allocation is deferred until the program
! allocates it specifically, and it is deregisterable. The component 
! allocation checks are done on remote images.
!
! Copyright (c) 2012-2016, Sourcery, Inc.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of the Sourcery, Inc., nor the
!       names of its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE FOR ANY
! DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

program async_comp_alloc
  implicit none

  type dt
    integer, allocatable :: i
  end type dt
  type(dt), allocatable :: obj[:]
    !! Container object for testing component allocation status

  logical, parameter :: verbose=.true. 
    !! Toggle verbose output for debugging purposes

  integer :: allocation_status
  integer, parameter :: success=0
    !! Successful allocation status value


  associate(me=>this_image(),np=>num_images())
    !! Make me & np locally immutable by associating them with function results

    call assert( np > 1, "num_images()>1")
      !! Ensure at least two images to simplify the test 

    allocate(obj[*],stat=allocation_status)
      !! Allocate only the container. obj%i must not be allocated hereafter.

    call assert(allocation_status == success, "allocated(obj)")
    call assert(.not. allocated(obj%i)      , ".not. allocated(obj%i)")

    block 
      integer :: allocating_image, test_image
      character(len=20) :: image_number

      loop_over_all_image_numbers: do allocating_image = 1, np
        !! Check that all allocations have been performed up to allocating_image and
        !! that no other allocations have been performed
  
        if (verbose) print *, me, "/", np, ": allocating_image=", allocating_image
  
        if (allocating_image /= me) then
          sync all
           !! Order allocations sequentially by image number: arrival of image 'allocating_image' 
           !! at the sync all in the alternate branch launches the following test loop.
          test_allocation_status: do test_image = 1, np
            if (verbose) print *, me, "/", np, ": Checking", test_image, " for allocation status."
            write(image_number,*) test_image
            if (test_image <= allocating_image) then
              call assert(allocated(obj[test_image]%i), " allocated(obj["//image_number//"]%i)" )
                !! Enforce that image numbers up to mine have allocated their components
            else
              call assert(.not. allocated(obj[test_image]%i), ".not. allocated(obj["//image_number//"]%i) on image ")
                !! Enforce that image numbers higher than 'image' should not have allocated their components yet
            end if
          end do test_allocation_status 
        else
          if (verbose) print *, me, "/", np, ": allocating..."
          allocate(obj%i, source = me)
            !! TODO: should we also ensure that implicit (re)allocation upon assignment works here?
          if (verbose) print *, me, "/", np, ": allocated"
          ! Enforce that object has been allocated and obj%i is this_image():
          call assert( allocated(obj)  , "allocated(obj)")
          call assert( allocated(obj%i), "allocated(obj%i)")
          call assert( obj%i == me     , "obj%i == this_image()")
          sync all
        end if
        sync all
      end do loop_over_all_image_numbers
    end block
    if (me == 1) print *, "Test passed."
  end associate
contains
  subroutine assert(assertion,description,stat)
    logical, intent(in) :: assertion 
    character(len=*), intent(in) :: description
    integer, intent(out), optional:: stat
    integer, parameter :: failure=1
    if (assertion) then
       if (present(stat)) stat=success
    else
      if (present(stat)) then
        stat=failure
      else
        error stop "Assertion "// description //" failed."
      end if
    end if
  end subroutine
end program

program whole_array_get
  implicit none

  integer,allocatable :: x1(:)[:],y1(:)
  integer,allocatable :: x2(:,:)[:],y2(:,:)
  integer,allocatable :: x3(:,:,:)[:],y3(:,:,:)
  integer,parameter   :: n = 10
  integer :: me,np,i,j,k

  me = this_image()
  np = num_images()

  allocate(x1(n)[*],y1(n))

  x1 = me
  y1 = 0

  sync all

  if(me == 1) then
     y1 = x1(:)[me+1]
     if(any(y1 /= 2)) then
        write(*,*) 'Test 1 fails'
        call abort()
     end if
  end if

  deallocate(x1)
  allocate(x2(1:n,0:n-1)[*],y2(n,n))

  x2 = me
  y1 = 0; y2 = 0

  sync all
  if(me == 1) then
     y2 = x2(:,:)[np]
     if(any(y2 /= np)) then
        write(*,*) 'Test 2 fails'
        call abort()
     end if
  end if

  sync all

  x2(:,n/2) = x2(:,n/2) + n/2

  sync all

  if(me == 1) then
     y1 = x2(:,n/2)[me+1]
     if(any(y1 /= 2+n/2)) then
        write(*,*) 'Test 3 fails'
        call abort()
     end if
  end if

  deallocate(y1,x2,y2)
  allocate(x3(0:n-1,1:n,-1:n-2)[*],y3(n,n,n))

  x3 = me; y3 = 0

  sync all

  if(me == 1) then
     y3 = x3(:,:,:)[me+1]
     if(any(y3 /= me+1)) then
        write(*,*) 'Test 4 fails'
        call abort()
     end if
  endif

  sync all

  x3(:,:,n/2) = me + n/2
  y3 = 0

  sync all

  if(me == 1) then
     y3(:,n/2,:) = x3(:,:,n/2)[me+1]
     if(any(y3(:,n/2,:) /= me+1+n/2)) then
        write(*,*) 'Test 5 fails'
        call abort()
     end if
  endif

  if(me == 1) write(*,*) 'Test passed.'

end program whole_array_get

module object_interface
  implicit none
  private
  public :: object

  type object
    private
    integer :: foo=0
    logical :: bar=.false.
  contains
    procedure :: initialize
    procedure :: co_broadcast_me
    procedure :: not_equal
    procedure :: copy
    generic :: operator(/=)=>not_equal
    generic :: assignment(=)=>copy
  end type

  interface
    elemental impure module subroutine initialize(this,foo_,bar_)
      implicit none
      class(object), intent(out) :: this
      integer, intent(in) :: foo_
      logical, intent(in) :: bar_
    end subroutine

    elemental impure module subroutine co_broadcast_me(this,source_image)
      implicit none
      class(object), intent(inout) :: this
      integer, intent(in) :: source_image
    end subroutine

    elemental module function not_equal(lhs,rhs) result(lhs_ne_rhs)
      implicit none
      class(object), intent(in) :: lhs,rhs
      logical lhs_ne_rhs
    end function

    elemental impure module subroutine copy(lhs,rhs)
      implicit none
      class(object), intent(inout) :: lhs
      class(object), intent(in) :: rhs
    end subroutine
  end interface

end module

submodule(object_interface) object_implementation
  implicit none
contains
    module procedure co_broadcast_me
      call co_broadcast(this%foo,source_image)
      call co_broadcast(this%bar,source_image)
    end procedure

    module procedure initialize
      this%foo = foo_
      this%bar = bar_
    end procedure

    module procedure not_equal
      lhs_ne_rhs = (lhs%foo /= rhs%foo) .or. (lhs%bar .neqv. rhs%bar)
    end procedure

    module procedure copy
       lhs%foo = rhs%foo
       lhs%bar = rhs%bar
    end procedure
end submodule

program main
  use object_interface, only : object
  implicit none
  type(object) message

  call message%initialize(foo_=1,bar_=.true.)

  emulate_co_broadcast: block
    type(object) foobar
    if (this_image()==1) foobar = message
    call foobar%co_broadcast_me(source_image=1)
    if ( foobar /= message ) error stop "Test failed."
  end block emulate_co_broadcast

  desired_co_broadcast: block
    type(object) barfoo
    if (this_image()==1) barfoo = message
    call co_broadcast(barfoo,source_image=1)  ! OpenCoarrays terminates here with the message "Unsupported data type"
    if ( barfoo /= message ) error stop "Test failed."
  end block desired_co_broadcast

  sync all  ! Wait for each image to pass the test
  if (this_image()==1) print *,"Test passed."

end program main

program teams_coarray_send
  use, intrinsic :: iso_fortran_env, only: team_type
  implicit none
  type(team_type) :: team
  integer, allocatable :: R(:)[:]
  integer :: extent, i, my_team, initial_team_this_image, odd

  ! if odd number of images, even images have R(extent) == 0
  extent = num_images()/2+mod(num_images(),2)
  allocate(R(extent)[*], source=0) 

  initial_team_this_image = this_image()
  my_team = mod(this_image()-1,2)+1

  form team (my_team, team)

  change team (team)
    do i = 1, num_images()
      R(this_image())[i] = initial_team_this_image
    end do
  end team

  if (any(R /= [(mod(i, num_images()+1), i=my_team, 2*extent, 2)])) error stop 'Test failed.'

  sync all

  if (this_image() == 1) write(*,*) 'Test passed.'
end program teams_coarray_send

program main
  !! author: Damian Rouson
  !!
  !! Test co_broadcast with derived-type actual arguments
  implicit none

  integer, parameter :: sender=1 !! co_broadcast source_image
  character(len=*), parameter :: text="text" !! character message data

  interface
     function f(x) result(y)
       real x, y
     end function
  end interface

  type parent
    integer :: heritable=0
  end type

  type component
    integer :: subcomponent=0
  end type

  type, extends(parent) :: child

    ! Scalar and array derived-type components
    type(component) a, b(1,2,1, 1,1,1, 1)

    ! Scalar and array intrinsic-type components
    character(len=len(text)) :: c="", z(0)
    complex :: i=(0.,0.), j(1)=(0.,0.)
    integer :: k=0,       l(2,3)=0
    logical :: r=.false., s(1,2,3, 1,2,3, 1)=.false.
    real    :: t=0.,      u(3,2,1)=0.

    ! Scalar and array pointer components
    character(len=len(text)), pointer :: &
                        char_ptr=>null(), char_ptr_maxdim(:,:,:, :,:,:, :)=>null()
    complex, pointer :: cplx_ptr=>null(), cplx_ptr_maxdim(:,:,:, :,:,:, :)=>null()
    integer, pointer :: int_ptr =>null(), int_ptr_maxdim (:,:,:, :,:,:, :)=>null()
    logical, pointer :: bool_ptr=>null(), bool_ptr_maxdim(:,:,:, :,:,:, :)=>null()
    real, pointer    :: real_ptr=>null(), real_ptr_maxdim(:,:,:, :,:,:, :)=>null()
    procedure(f), pointer :: procedure_pointer=>null()
  end type

  type(child) message
  type(child) :: content = child( & ! define content using the insrinsic structure constructor
    parent=parent(heritable=-4),                                                                           & ! parent
    a=component(-3), b=reshape([component(-2),component(-1)], [1,2,1, 1,1,1, 1]),        & ! derived types
    c=text, z=[character(len=len(text))::], i=(0.,1.), j=(2.,3.), k=4, l=5, r=.true., s=.true., t=7., u=8. & ! intrinsic types
  )

  associate(me=>this_image())

    if (me==sender) then
      message = content
      allocate(message%char_ptr, message%char_ptr_maxdim(1,1,2, 1,1,1, 1), source=text   )
      allocate(message%cplx_ptr, message%cplx_ptr_maxdim(1,1,1, 1,1,2, 1), source=(0.,1.))
      allocate(message%int_ptr , message%int_ptr_maxdim (1,1,1, 1,1,1, 1), source=2      )
      allocate(message%bool_ptr, message%bool_ptr_maxdim(1,1,1, 1,2,1, 1), source=.true. )
      allocate(message%real_ptr, message%real_ptr_maxdim(1,1,1, 1,1,1, 1), source=3.     )
    end if

    call co_broadcast(message,source_image=sender)

    if (me==sender) then
      deallocate(message%char_ptr, message%char_ptr_maxdim)
      deallocate(message%cplx_ptr, message%cplx_ptr_maxdim)
      deallocate(message%int_ptr , message%int_ptr_maxdim )
      deallocate(message%bool_ptr, message%bool_ptr_maxdim)
      deallocate(message%real_ptr, message%real_ptr_maxdim)
    end if

    !! Verify correct broadcast of all non-pointer components (pointers become undefined on the receiving image).
    associate( failures => [                                &
      message%parent%heritable /= content%parent%heritable, &
      message%a%subcomponent /= content%a%subcomponent,     &
      message%c /= content%c,                               &
      message%z /= content%z,                               &
      message%i /= content%i,                               &
      message%j /= content%j,                               &
      message%k /= content%k,                               &
      message%l /= content%l,                               &
      message%r .neqv. content%r,                           &
      message%s .neqv. content%s,                           &
      message%t /= content%t,                               &
      any( message%u /= content%u )                         &
    ] )

      if ( any(failures) ) error stop "Test failed. "

    end associate

    sync all  ! Wait for each image to pass the test
    if (me==sender) print *,"Test passed."

  end associate

end program main

! Copyright (c) 2012-2016, Sourcery, Inc.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of Sourcery, Inc., nor the
!       names of any other contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

! Unit tests for co_broadcast and co_sum
program main
  use iso_fortran_env, only : error_unit
  use iso_c_binding, only : c_int,c_double,c_char
#ifdef USE_EXTENSIONS
  use opencoarrays
#endif
  implicit none
  integer(c_int) :: me
  ! Set test failure as the default result
  logical :: c_char_test_passes=.false.,c_int_test_passes=.false.,c_double_test_passes=.false.

  ! Store the executing image number
  me=this_image()

#ifdef USE_EXTENSIONS
  if (me==1) print *,"Using the extensions from the opencoarrays module."
#endif

  ! Verify broadcasting of character data from image 1
  c_char_co_broadcast: block
    character(kind=c_char,len=14), save :: string_received[*]
    character(kind=c_char,len=*), parameter :: string_sent=c_char_"Hello, world!"! Character test message
    if (me==1) string_received=string_sent
    sync all
    call co_broadcast(string_received,source_image=1)
    if (string_received/=string_sent) then
      write(error_unit,*) "Incorrect co_broadcast(",string_received,") on image",me
    else
      c_char_test_passes=.true.
    end if
  end block c_char_co_broadcast

  ! Verify broadcasting of integer data from image 1
  c_int_co_broadcast: block
    integer(c_int), save :: integer_received[*]
    integer(c_int), parameter :: integer_sent=12345_c_int ! Integer test message
    if (me==1) integer_received=integer_sent
    sync all
    call co_broadcast(integer_received,source_image=1)
    if (integer_received/=integer_sent) then
      write(error_unit,*) "Incorrect co_broadcast(",integer_received,") on image",me
    else
      c_int_test_passes=.true.
    end if
  end block c_int_co_broadcast

  ! Verify broadcasting of real data from image 1
  c_double_co_broadcast: block
    real(c_double), save :: real_received[*]
    real(c_double), parameter :: real_sent=2.7182818459045_c_double ! Real test message
    if (me==1) real_received=real_sent
    sync all
    call co_broadcast(real_received,source_image=1)
    if (real_received/=real_sent) then
      write(error_unit,*) "Incorrect co_broadcast(",real_received,") on image",me
    else
      c_double_test_passes=.true.
    end if
  end block c_double_co_broadcast


  if (.not.all([c_char_test_passes,c_int_test_passes,c_double_test_passes])) error stop
  ! Wait for everyone to pass the tests
  sync all
  if (me==1) print *, "Test passed."
end program

program co_broadcast_derived_with_allocs_test
!! author: Brad Richardson & Andre Vehreschild
!! category: regression
!!
!! [issue #727](https://github.com/sourceryinstitute/opencoarrays/issues/727)
!! broadcasting derived types with a mixture of scalar and allocatable
!! scalars or arrays lead to unexpected results

implicit none

type nsas_t
  integer :: i
  integer, allocatable :: j
end type

type asas_t
  integer, allocatable :: i
  integer, allocatable :: j
end type

type nsaa_t
  integer :: i
  integer, allocatable :: j(:)
end type

type naaa_t
  integer :: i(3)
  integer, allocatable :: j(:)
end type

type(nsas_t) nsas
type(asas_t) asas
type(nsaa_t) nsaa
type(naaa_t) naaa

integer, parameter :: source_image = 1

if (this_image() == source_image)  then
  nsas = nsas_t(2, 3)

  asas = asas_t(4, 5)

  nsaa = nsaa_t(6, (/ 7, 8 /))

  naaa = naaa_t((/ 9,10,11 /), (/ 12,13,14,15 /))
else
  allocate(nsas%j)

  allocate(asas%i); allocate(asas%j)

  allocate(nsaa%j(2))

  allocate(naaa%j(4))
end if

print *, "nsas"
call co_broadcast(nsas, source_image)
if (nsas%i /= 2 .or. nsas%j /= 3)  error stop "Test failed at 1."

print *, "asas"
call co_broadcast(asas, source_image)
if (asas%i /= 4 .or. asas%j /= 5)  error stop "Test failed at 2."

print *, "nsaa"
call co_broadcast(nsaa, source_image)
if (nsaa%i /= 6 .or. any(nsaa%j(:) /= (/ 7, 8 /)))  error stop "Test failed at 3."

print *, "naaa"
call co_broadcast(naaa, source_image)
if (any(naaa%i(:) /= (/ 9,10,11 /)) .or. any(naaa%j(:) /= (/ 12,13,14,15 /))) then
  error stop "Test failed at 3."
end if

sync all

print *, "Test passed."

end

! Check that after an image has failed a sync all ends correctly.
! Image two is to fail, all others to continue.

program image_fail_and_sync_test_1
  use iso_fortran_env , only : STAT_FAILED_IMAGE
  implicit none
  integer :: i, syncAllStat

  associate(np => num_images(), me => this_image())
    if (np < 3) error stop "I need at least 3 images to function."
    do i= 1, np
      if (image_status(i) /= 0) error stop "image_status(i) should not fail"
    end do

    ! Need a sync here to make sure all images are started and to prevent image fail
    ! is not already detected in above image_status(i).
    sync all
    if (me == 2) fail image
    sync all (STAT=syncAllStat)
    ! Check that all images returning from the sync report the failure of an image
    if (syncAllStat /= STAT_FAILED_IMAGE) error stop "Expected sync all (STAT == STAT_FAILED_IMAGE)."

    if (me == 1) print *,"Test passed."
  end associate

end program image_fail_and_sync_test_1

program atomic
use iso_fortran_env
implicit none

integer :: me,np,res
integer(atomic_int_kind) :: atom[*]

me = this_image()
np = num_images()

call atomic_define(atom[1],0)

sync all

call ATOMIC_ADD (atom[1], me)

sync all

if(me == 1) then
  call atomic_ref(res,atom[1])
  if(res /= (np*(np+1))/2) then
    write(*,*) 'res',res
    error stop "Atomic ref failed"
  endif
  write(*,*) 'OK'
endif

sync all

if (me == 1) then
   write(*,*) "Test passed"
end if

end program

! MPI Distributed Transpose Test
!
! Copyright (c) 2012-2014, Sourcery, Inc.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of the Sourcery, Inc., nor the
!       names of its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE FOR ANY
! DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

! Robodoc header:
!****m* dist_transpose/mpi_run_size
! NAME
!   mpi_run_size
! SYNOPSIS
!   Encapsulate the problem state, wall-clock timer interface, integer broadcasts, and a data copy
!   for a distributed tranpsose kernel extracted from a program for the Fourier-spectral simulation
!   of statistically homogeneous.
!******
!==================  test transposes with integer x,y,z values  ===============================
module mpi_run_size
    use iso_fortran_env
#ifndef HAVE_WALLTIME
    use MPI, only : WALLTIME=>MPI_WTIME
#endif
    implicit none
        integer(int64) :: nx, ny, nz
        integer(int64) :: my, mx, first_y, last_y, first_x, last_x
        integer(int64) :: my_node, num_nodes
        real(real64) :: tran_time

#ifdef HAVE_WALLTIME
interface
   function WALLTIME() bind(C, name = "WALLTIME")
   use iso_fortran_env
       real(real64) :: WALLTIME
   end function WALLTIME
end interface
#endif

contains

subroutine mpi_copy3( A,B, n1, sA1, sB1, n2, sA2, sB2, n3, sA3, sB3 )
  use iso_fortran_env
  implicit none
  complex, intent(in)  :: A(0:*)
  complex, intent(out) :: B(0:*)
  integer(int64), intent(in) :: n1, sA1, sB1
  integer(int64), intent(in) :: n2, sA2, sB2
  integer(int64), intent(in) :: n3, sA3, sB3
  integer(int64) i,j,k

  do k=0,n3-1
     do j=0,n2-1
        do i=0,n1-1
           B(i*sB1+j*sB2+k*sB3) = A(i*sA1+j*sA2+k*sA3)
        end do
     end do
  end do
end subroutine mpi_copy3

end module mpi_run_size

!****e* dist_transose/mpi_distributed_transpose
! NAME
!   mpi_distributed_transpose
! SYNOPSIS
!   This program is the MPI analogue of coarray_distributed_transpose. It tests the transpose routines used
!   in Fourier-spectral simulations of homogeneous turbulence.
!******

program mpi_distributed_transpose
  !(***********************************************************************************************************
  !                   m a i n   p r o g r a m
  !***********************************************************************************************************)
      use mpi_run_size
      implicit none
      include 'mpif.h'

      complex, allocatable ::  u(:,:,:,:)    ! u(nz,4,first_x:last_x,ny)    !(*-- ny = my * num_nodes --*)
      complex, allocatable ::  ur(:,:,:,:)   !ur(nz,4,first_y:last_y,nx/2)  !(*-- nx/2 = mx * num_nodes --*)
      complex, allocatable :: bufr(:)

      integer(int64) :: x, y, z, msg_size, iter
      integer(int64) :: ierror

  call MPI_INIT(ierror)
  call MPI_COMM_RANK(MPI_COMM_WORLD, my_node, ierror)
  call MPI_COMM_SIZE(MPI_COMM_WORLD, num_nodes, ierror)

      if( my_node == 0 ) then
       !write(6,fmt="(A)") "nx,ny,nz : "
       !read(5,*) nx, ny, nz
       nx=32; ny=32; nz=32
      end if

        call MPI_BARRIER(MPI_COMM_WORLD, ierror)  !-- other nodes wait for broadcast!
        call MPI_BCAST( nx, 1, MPI_INT, 0,MPI_COMM_WORLD, ierror )
        call MPI_BCAST( ny, 1, MPI_INT, 0,MPI_COMM_WORLD, ierror )
        call MPI_BCAST( nz, 1, MPI_INT, 0,MPI_COMM_WORLD, ierror )


 	  if ( mod(ny,num_nodes) == 0)  then;   my = ny / num_nodes
                                    else;   write(6,*) "node ", my_node, " ny not multiple of num_nodes";     stop
      end if

      if ( mod(nx/2,num_nodes) == 0)  then;   mx = nx/2 / num_nodes
                                    else;   write(6,*) "node ", my_node, "nx/2 not multiple of num_nodes";    stop
      end if

      first_y = my_node*my + 1;   last_y  = my_node*my + my
      first_x = my_node*mx + 1;   last_x  = my_node*mx + mx

      msg_size = nz*4*mx*my     !-- message size (complex data items

      allocate (  u(nz , 4 , first_x:last_x , ny)   )   !(*-- y-z planes --*)
      allocate ( ur(nz , 4 , first_y:last_y , nx/2) )   !(*-- x-z planes --*)
      allocate ( bufr(msg_size) )


!---------  initialize data u (mx y-z planes per image) ----------

        do x = first_x, last_x
            do y = 1, ny
                do z = 1, nz
                    u(z,1,x,y) = x
                    u(z,2,x,y) = y
                    u(z,3,x,y) = z
                end do
            end do
        end do

    tran_time = 0
    do iter = 1, 2  !--- 2 transform pairs per second-order time step

!---------  transpose data u -> ur (mx y-z planes to my x-z planes per image)  --------

      ur = 0
      call transpose_X_Y

!--------- test data ur (my x-z planes per image) ----------

         do x = 1, nx/2
            do y = first_y, last_y
                do z = 1, nz
                    if ( real(ur(z,1,y,x)) /= x .or. real(ur(z,2,y,x)) /= y .or. real(ur(z,3,y,x)) /= z )then
                         write(6,fmt="(A,i3,3(6X,A,f7.3,i4))") "transpose_X_Y failed:  image ", my_node &
                            , " X ",real(ur(z,1,y,x)),x, "  Y ",real(ur(z,2,y,x)),y, "  Z ", real(ur(z,3,y,x)),z
                        stop
                    end if
                end do
            end do
        end do

!---------  transpose data ur -> u (my x-z planes to mx y-z planes per image)  --------

      u = 0
      call transpose_Y_X

!--------- test data u (mx y-z planes per image) ----------

         do x = first_x, last_x
            do y = 1, ny
                do z = 1, nz
                    if ( real(u(z,1,x,y)) /= x .or. real(u(z,2,x,y)) /= y .or. real(u(z,3,x,y)) /= z )then
                         write(6,fmt="(A,i3,3(6X,A,f7.3,i4))") "transpose_Y_X failed:  image ", my_node &
                            , " X ",real(u(z,1,y,x)),x, "  Y ",real(u(z,2,y,x)),y, "  Z ", real(u(z,3,y,x)),z
                        stop
                    end if
                end do
            end do
        end do
    end do

call MPI_BARRIER(MPI_COMM_WORLD, ierror)

        if( my_node == 0 )  write(6,fmt="(A,f8.3)")  "test passed:  tran_time ", tran_time

    deallocate ( bufr, ur, u)

!=========================   end of main executable  =============================

contains

!-------------   out-of-place transpose data_s --> data_r  ----------------------------

 subroutine transpose_X_Y

    use mpi_run_size
    implicit none

    integer(int64) :: to, from, send_tag, recv_tag
    integer :: stage, idr(0:num_nodes-1), ids(0:num_nodes-1)
    integer(int64) :: send_status(MPI_STATUS_SIZE), recv_status(MPI_STATUS_SIZE)
    character*(MPI_MAX_ERROR_STRING) errs

    call MPI_BARRIER(MPI_COMM_WORLD, ierror)   !--  wait for other nodes to finish compute
    tran_time = tran_time - WALLTIME()

!--------------   transpose my image's block (no communication needed)  ------------------

    call mpi_copy3 (    u(1,1,first_x,1+my_node*my) &                   !-- intra-node transpose
                ,  ur(1,1,first_y,1+my_node*mx) &                   !-- no inter-node transpose needed
                ,   nz*3, 1_8, 1_8        &                                 !-- note: only 3 of 4 words needed
                ,   mx, nz*4, nz*4*my &
                ,   my, nz*4*mx, nz*4 )

#define RECEIVE
#ifdef RECEIVE

!--------------   issue all block sends ... tags = 256*dst_image+src_image  ------------------

    do stage = 1, num_nodes-1
        to = mod( my_node+stage, num_nodes )
        send_tag = 256*to + my_node
        call MPI_ISSEND ( u(1,1,first_x,1+to*my) &
                        ,   msg_size*2,  MPI_REAL,  to, send_tag,  MPI_COMM_WORLD,  ids(stage),  ierror)
    end do

!--------------   receive and transpose other image's block  ------------------

    do stage = 1, num_nodes-1   !-- process receives in order
        from = mod( my_node+stage, num_nodes )
        recv_tag = 256*my_node + from
        call MPI_RECV  ( bufr &
                        ,   msg_size*2,  MPI_REAL,  from, recv_tag,  MPI_COMM_WORLD,  recv_status,  ierror)

        call mpi_copy3 ( bufr, ur(1,1,first_y,1+from*mx)  &                !-- intra-node transpose from buffer
                        ,   nz*3, 1_8, 1_8        &                             !-- note: only 3 of 4 words needed
                        ,   mx, nz*4, nz*4*my &
                        ,   my, nz*4*mx, nz*4 )
    end do

#else

!--------------   issue all block receives ... tags = 256*dst_image+src_image  ------------------

    do stage = 1, num_nodes-1
        from = mod( my_node+stage, num_nodes )
        recv_tag = 256*my_node + from
        call MPI_IRECV  ( ur(1,1,first_y,1+from*mx) &
                        ,   msg_size*2,  MPI_REAL,  from, recv_tag,  MPI_COMM_WORLD,  idr(stage),  ierror)
    end do

!--------------   issue all block sends ... tags = 256*dst_image+src_image  ------------------


    do stage = 1, num_nodes-1   !-- process sends in order
        to = mod( my_node+stage, num_nodes )
        send_tag = 256*to + my_node
        call mpi_copy3 ( u(1,1,first_x,1+to*my), bufr &                !-- intra-node transpose from buffer
                ,   nz*3, 1_8, 1_8        &                             !-- note: only 3 of 4 words needed
                ,   mx, nz*4, nz*4*my &
                ,   my, nz*4*mx, nz*4 )

        call MPI_SEND ( bufr &
                        ,   msg_size*2,  MPI_REAL,  to, send_tag,  MPI_COMM_WORLD,  ierror)
    end do

!--------------   wait on receives   ------------------

    do stage = 1, num_nodes-1
        call MPI_WAIT( idr(stage),  recv_status,  ierror )
    end do

#endif

call MPI_BARRIER(MPI_COMM_WORLD, ierror)     !--  wait for other nodes to finish transpose
    tran_time = tran_time + WALLTIME()

! deallocate(ids,idr)

 end  subroutine transpose_X_Y

!-------------   out-of-place transpose data_r --> data_s  ----------------------------

 subroutine transpose_Y_X

    use mpi_run_size
    implicit none

    integer(int64) :: to, from, send_tag, recv_tag
    integer :: stage, idr(0:num_nodes-1), ids(0:num_nodes-1)
    character*(MPI_MAX_ERROR_STRING) errs
    integer(int64) :: send_status(MPI_STATUS_SIZE), recv_status(MPI_STATUS_SIZE)

    call MPI_BARRIER(MPI_COMM_WORLD, ierror)   !--  wait for other nodes to finish compute
    tran_time = tran_time - WALLTIME()

!--------------   transpose my image's block (no communication needed)  ------------------

    call mpi_copy3 (   ur(1,1,first_y,1+my_node*mx) &                   !-- intra-node transpose
                ,   u(1,1,first_x,1+my_node*my) &                   !-- no inter-node transpose needed
                ,   nz*4, 1_8, 1_8        &                                 !-- note: all 4 words needed
                ,   my, nz*4, nz*4*mx &
                ,   mx, nz*4*my, nz*4 )

#define RECEIVE
#ifdef RECEIVE

!--------------   issue all block sends ... tags = 256*dst_image+src_image  ------------------

    do stage = 1, num_nodes-1
        to = mod( my_node+stage, num_nodes )
        send_tag = 256*to + my_node
        call MPI_ISSEND ( ur(1,1,first_y,1+to*mx)    &
                        ,   msg_size*2,  MPI_REAL,  to, send_tag,  MPI_COMM_WORLD,  ids(stage),  ierror)

    end do

!--------------   transpose other image's block (get block then transpose it)  ------------------

    do stage = 1, num_nodes-1   !-- process receives in order
        from = mod( my_node+stage, num_nodes )
        recv_tag = 256*my_node + from
        call MPI_RECV  ( bufr  &
                        ,   msg_size*2,  MPI_REAL,  from, recv_tag,  MPI_COMM_WORLD,  recv_status,  ierror)

        call mpi_copy3 ( bufr, u(1,1,first_x,1+from*my)  &                 !-- intra-node transpose from buffer
                    ,   nz*4, 1_8, 1_8        &
                    ,   my, nz*4, nz*4*mx &
                    ,   mx, nz*4*my, nz*4 )
    end do

#else

!--------------   issue all block receives ... tags = 256*dst_image+src_image  ------------------

    do stage = 1, num_nodes-1
        from = mod( my_node+stage, num_nodes )
        recv_tag = 256*my_node + from
        call MPI_IRECV  ( u(1,1,first_x,1+from*my) &
                        ,   msg_size*2,  MPI_REAL,  from, recv_tag,  MPI_COMM_WORLD,  idr(stage),  ierror)
    end do

!--------------   issue all block sends ... tags = 256*dst_image+src_image  ------------------


    do stage = 1, num_nodes-1   !-- process sends in order
        to = mod( my_node+stage, num_nodes )
        send_tag = 256*to + my_node
        call mpi_copy3 ( ur(1,1,first_y,1+to*mx), bufr &                !-- intra-node transpose from buffer
                ,   nz*4, 1_8, 1_8        &                                 !-- note: all 4 words needed
                ,   my, nz*4, nz*4*mx &
                ,   mx, nz*4*my, nz*4 )

        call MPI_SEND ( bufr &
                        ,   msg_size*2,  MPI_REAL,  to, send_tag,  MPI_COMM_WORLD,  ierror)
    end do

!--------------   wait on receives   ------------------

    do stage = 1, num_nodes-1
        call MPI_WAIT( idr(stage),  recv_status,  ierror )
    end do

#endif

    call MPI_BARRIER(MPI_COMM_WORLD, ierror)     !--  wait for other nodes to finish transpose
    tran_time = tran_time + WALLTIME()
 !   deallocate(ids,idr)
 end  subroutine transpose_Y_X

end program mpi_distributed_transpose

!! Thoroughly test send, i.e. foo [N] = bar in all variants
!!
!! Do simple tests for send(). These test comprise
!!
!! FOO [N] = BAR
!!
!! where
!!
!!  FOO                BAR                 images
!! character(len=20) character(len=10)   N == me
!!  kind == 1         kind == 1
!!  kind == 1         kind == 4
!!  kind == 4         kind == 1
!!  kind == 4         kind == 4
!!
!! character         character
!!   (1:4, len == 5)  (1:4, len == 5)
!!  kind == 1         kind == 1
!!  kind == 1         kind == 4
!!  kind == 4         kind == 1
!!  kind == 4         kind == 4
!!
!! all of the above but for              N != me
!!
!! And may be some other, I've forgotten.
!!
!! Author: Andre Vehreschild, 2017



program send_convert_char_array

  implicit none

  character(kind=1, len=:), allocatable, codimension[:] :: co_str_k1_scal
  character(kind=1, len=:), allocatable :: str_k1_scal
  character(kind=4, len=:), allocatable, codimension[:] :: co_str_k4_scal
  character(kind=4, len=:), allocatable :: str_k4_scal

  character(kind=1, len=:), allocatable, codimension[:] :: co_str_k1_arr(:)
  character(kind=1, len=:), allocatable :: str_k1_arr(:)
  character(kind=4, len=:), allocatable, codimension[:] :: co_str_k4_arr(:)
  character(kind=4, len=:), allocatable :: str_k4_arr(:)

  logical ::  error_printed=.false.

  associate(me => this_image(), np => num_images())
    if (np < 2) error stop 'Can not run with less than 2 images.'

    allocate(str_k1_scal, SOURCE='abcdefghij')
    allocate(str_k4_scal, SOURCE=4_'abcdefghij')
    allocate(character(len=20)::co_str_k1_scal[*]) ! allocate syncs here
    allocate(character(kind=4, len=20)::co_str_k4_scal[*]) ! allocate syncs here

    allocate(str_k1_arr(1:4), SOURCE=['abc', 'EFG', 'klm', 'NOP'])
    allocate(str_k4_arr(1:4), SOURCE=[4_'abc', 4_'EFG', 4_'klm', 4_'NOP'])
    allocate(character(len=5)::co_str_k1_arr(4)[*])
    allocate(character(kind=4, len=5)::co_str_k4_arr(4)[*])

    ! First check send/copy to self
    if (me == 1) then
      co_str_k1_scal[1] = str_k1_scal
      print *, '#' // co_str_k1_scal // '#, len:', len(co_str_k1_scal)
      if (co_str_k1_scal /= str_k1_scal // '          ') call print_and_register( 'send scalar kind=1 to kind=1 self failed.')

      co_str_k4_scal[1] = str_k4_scal
      print *, 4_'#' // co_str_k4_scal // 4_'#, len:', len(co_str_k4_scal)
      if (co_str_k4_scal /= str_k4_scal // 4_'          ') call print_and_register( 'send scalar kind=4 to kind=4 self failed.')

      co_str_k4_scal[1] = str_k1_scal
      print *, 4_'#' // co_str_k4_scal // 4_'#, len:', len(co_str_k4_scal)
      if (co_str_k4_scal /= str_k4_scal // 4_'          ') call print_and_register( 'send scalar kind=1 to kind=4 self failed.')

      co_str_k1_scal[1] = str_k4_scal
      print *, '#' // co_str_k1_scal // '#, len:', len(co_str_k1_scal)
      if (co_str_k1_scal /= str_k1_scal // '          ') call print_and_register( 'send scalar kind=4 to kind=1 self failed.')
    end if

    ! Do the same for arrays but on image 2
    if (me == 2) then
      co_str_k1_arr(:)[2] = str_k1_arr
      print *, '#' // co_str_k1_arr(:) // '#, len:', len(co_str_k1_arr(1))
      if (any(co_str_k1_arr /= ['abc  ', 'EFG  ', 'klm  ', 'NOP  '])) &
        call print_and_register( 'send array kind=1 to kind=1 self failed.')

      print *, str_k4_arr
      co_str_k4_arr(:)[2] = [4_'abc', 4_'EFG', 4_'klm', 4_'NOP']! str_k4_arr
      print *, 4_'#' // co_str_k4_arr(:) // 4_'#, len:', len(co_str_k4_arr(1))
      if (any(co_str_k4_arr /= [4_'abc  ', 4_'EFG  ', 4_'klm  ', 4_'NOP  '])) &
        call print_and_register( 'send array kind=4 to kind=4 self failed.')

      co_str_k4_arr(:)[2] = str_k1_arr
      print *, 4_'#' // co_str_k4_arr(:) // 4_'#, len:', len(co_str_k4_arr(1))
      if (any(co_str_k4_arr /= [ 4_'abc  ', 4_'EFG  ', 4_'klm  ', 4_'NOP  '])) &
        call print_and_register( 'send array kind=1 to kind=4 self failed.')

      co_str_k1_arr(:)[2] = str_k4_arr
      print *, '#' // co_str_k1_arr(:) // '#, len:', len(co_str_k1_arr(1))
      if (any(co_str_k1_arr /= ['abc  ', 'EFG  ', 'klm  ', 'NOP  '])) &
        call print_and_register( 'send array kind=4 to kind=1 self failed.')
    end if

    sync all
    if (me == 1) then
      co_str_k1_scal[2] = str_k1_scal

      co_str_k4_scal[2] = str_k4_scal
    end if

    sync all
    if (me == 2) then
      print *, '#' // co_str_k1_scal // '#, len:', len(co_str_k1_scal)
      if (co_str_k1_scal /= str_k1_scal // '          ') call print_and_register( 'send kind=1 to kind=1 image 2 failed.')

      print *, 4_'#' // co_str_k4_scal // 4_'#, len:', len(co_str_k4_scal)
      if (co_str_k4_scal /= str_k4_scal // 4_'          ') call print_and_register( 'send kind=4 to kind=4 image 2 failed.')
    end if

    sync all
    if (me == 1) then
      co_str_k4_scal[2] = str_k1_scal

      co_str_k1_scal[2] = str_k4_scal
    end if

    sync all
    if (me == 2) then
      print *, 4_'#' // co_str_k4_scal // 4_'#, len:', len(co_str_k4_scal)
      if (co_str_k4_scal /= str_k4_scal // 4_'          ') call print_and_register( 'send kind=1 to kind=4 to image 2 failed.')

      print *, '#' // co_str_k1_scal // '#, len:', len(co_str_k1_scal)
      if (co_str_k1_scal /= str_k1_scal // '          ') call print_and_register( 'send kind=4 to kind=1 to image 2 failed.')
    end if

    co_str_k1_arr(:) = '#####'
    co_str_k4_arr(:) = 4_'#####'

    sync all

    if (me == 1) then
      co_str_k1_arr(::2)[2] = 'foo'
      co_str_k4_arr(::2)[2] = ['bar', 'baz']
    end if

    sync all
    if (me == 2) then
      print *, co_str_k1_arr
      if (any(co_str_k1_arr /= ['foo  ', '#####', 'foo  ', '#####'])) &
        & call print_and_register( "strided send char arr kind 1 to kind 1 failed.")
      print *, co_str_k4_arr
      if (any(co_str_k4_arr /= [4_'bar  ', 4_'#####', 4_'baz  ', 4_'#####'] )) &
        & call print_and_register( "strided send char arr kind 1 to kind 4 failed.")
    end if

    select case(me)
      case(1)
        if (error_printed) error stop
        sync images(2)
        print *, 'Test passed.'
      case(2)
        if (error_printed) error stop
        sync images(1)
    end select

  end associate

contains

  subroutine print_and_register(error_message)
    use iso_fortran_env, only : error_unit
    character(len=*), intent(in) :: error_message
    write(error_unit,*) error_message
    error_printed=.true.
  end subroutine

end program send_convert_char_array

! vim:ts=2:sts=2:sw=2:

! Coarray 1D Heat Equation Solver Test: main
!
! Copyright (c) 2012-2014, Sourcery, Inc.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of the Sourcery, Inc., nor the
!       names of its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE FOR ANY
! DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
!

program main
  use IEEE_arithmetic, only : IEEE_is_NaN
  use global_field_module, only : global_field
  implicit none
  type(global_field) :: T,laplacian_T,T_half
  real, parameter :: alpha=1.,dt=0.0001,final_time=1.,tolerance=1.E-3
  real :: time=0.
  call T%global_field_(internal_values=0.,boundary_values=[1.,0.],domain=[0.,1.],num_global_points=32)
  call T_half%global_field_()
  do while(time<final_time)
    T_half = T + (.laplacian.T)*(alpha*dt/2.)
    T      = T + (.laplacian.T_half)*(alpha*dt)
    time = time + dt
  end do
  call laplacian_T%global_field_()
  laplacian_T = .laplacian.T
  block 
    real, allocatable :: residual(:)
    residual = laplacian_T%state()
    if ( any(residual>tolerance) .or. any(IEEE_is_NaN(residual)) .or. any(residual<0) ) error stop "Test failed."
  end block
  if (this_image()==1) print *,"Test passed."
end program

! Unit test for register and allocated procedure.
!
! Test that vector valued allocatable components in a derived typed coarray is
! registered correctly, delayed allocatable and deregisterable. The checks
! whether a component is allocated are done on this_image only.
!
! Copyright (c) 2012-2016, Sourcery, Inc.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of the Sourcery, Inc., nor the
!       names of its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE FOR ANY
! DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

program register_alloc_comp_2
  implicit none

  type dt
    integer, allocatable, dimension(:) :: v
  end type dt

  integer :: np = -2
  type(dt), allocatable :: obj[:]

  np = num_images()

  ! Allocate only the container. obj%v must not be allocated hereafter.
  allocate(obj[*])
  if (.not. allocated(obj)) error stop "Test failed. 'obj' not allocated."
  if (allocated(obj%v)) error stop "Test failed. 'obj%v' is allocated."

  ! Allocate the component and initialize it with this_image()
  allocate(obj%v(5), source=this_image())

  ! Now both objects have to be allocated and obj%v(1:5) set to this_image()
  if (.not. allocated(obj)) error stop "Test failed. 'obj' not allocated."
  if (.not. allocated(obj%v)) error stop "Test failed. 'obj%v' not allocated."
  if (any (obj%v(:) /= this_image())) error stop "Test failed. obj%v(:) /= this_image()."

  ! Deallocate the component.
  deallocate(obj%v)

  ! and test, that only the component is deallocated, but not the container.
  if (allocated(obj%v)) error stop "Test failed. 'obj%v' still allocated."
  if (.not. allocated(obj)) error stop "Test failed. 'obj' no longer allocated."

  ! Now deallocate the container, too.
  deallocate(obj)

  ! and check, that it worked.
  if (allocated(obj)) error stop "Test failed. 'obj' still allocated."

  ! Failing tests would make whole program error out.  Therefore it is save
  ! to print the pass message on image one, only.
  if (this_image() == 1) print *, "Test passed."
end program

!*********************************************************************
! ForTrilinos: Object-Oriented Fortran 2003 interface to Trilinos
!                Copyright 2010 Sandia Corporation
!
! Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
! the U.S. Government retains certain rights in this software.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! 1. Redistributions of source code must retain the above copyright
!    notice, this list of conditions and the following disclaimer.
!
! 2. Redistributions in binary form must reproduce the above copyright
!    notice, this list of conditions and the following disclaimer in the
!    documentation and/or other materials provided with the distribution.
!
! 3. Neither the name of the Corporation nor the names of the
!    contributors may be used to endorse or promote products derived from
!    this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY SANDIA CORPORATION "AS IS" AND ANY
! EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
! PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SANDIA CORPORATION OR THE
! CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
! Questions? Contact Karla Morris  (knmorri@sandia.gov) or
!                    Damian Rouson (rouson@sandia.gov)
!*********************************************************************

module ForTrilinos_error
#include "compiler_capabilities.txt"
  implicit none
  private
  public :: error

#ifdef ForTrilinos_DISABLE_DEFERRED_LENGTH_CHARACTERS
  integer ,parameter :: max_string_length=256
#endif /* ForTrilinos_DISABLE_DEFERRED_LENGTH_CHARACTERS */

  type :: error
    private
    integer code
    class(*), allocatable :: data_(:)
#ifdef ForTrilinos_DISABLE_DEFERRED_LENGTH_CHARACTERS
    character(len=max_string_length) message ! gfortran 4.7.0 workaround
#else
    character(:) ,allocatable :: message
#endif /* ForTrilinos_DISABLE_DEFERRED_LENGTH_CHARACTERS */
  contains
    procedure :: error_code
    procedure :: define_error
    generic :: error=>define_error
  end type

contains

  subroutine define_error(this,new_code,new_message,new_data)
    class(error), intent(out) :: this
    integer ,intent(in) :: new_code
    character(len=*) ,intent(in) :: new_message
    class(*) ,intent(in), optional :: new_data(:)
    this%code = new_code
    this%message = new_message
    if (present(new_data)) allocate(this%data_(lbound(new_data,1):ubound(new_data,1)),source=new_data)
  end subroutine

  integer function error_code(this)
    class(error) ,intent(in) :: this
    error_code = this%code
  end function

  function error_message(this)
    class(error) ,intent(in) :: this
    character(:), allocatable :: error_message
    error_message = this%message
  end function

end module ForTrilinos_error

!*********************************************************************
! ForTrilinos: Object-Oriented Fortran 2003 interface to Trilinos
!     Copyright 2010 Sandia Corporation
!
! Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
! the U.S. Government retains certain rights in this software.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! 1. Redistributions of source code must retain the above copyright
!    notice, this list of conditions and the following disclaimer.
!
! 2. Redistributions in binary form must reproduce the above copyright
!    notice, this list of conditions and the following disclaimer in the
!    documentation and/or other materials provided with the distribution.
!
! 3. Neither the name of the Corporation nor the names of the
!    contributors may be used to endorse or promote products derived from
!    this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY SANDIA CORPORATION "AS IS" AND ANY
! EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
! PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SANDIA CORPORATION OR THE
! CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
! Questions? Contact Karla Morris  (knmorri@sandia.gov)
!                    Damian Rouson (rouson@sandia.gov)
!*********************************************************************

module ForTrilinos_assertion_utility
#include "compiler_capabilities.txt"
  use iso_fortran_env ,only : error_unit
  use object_interface, only : object
  implicit none
  !> @cond Private
  private
  !> @endcond
  public :: error_message,assert,assert_identical

!> @cond Do not show max_string_length
#ifdef ForTrilinos_DISABLE_DEFERRED_LENGTH_CHARACTERS
  integer ,parameter :: max_string_length=256
#endif /* ForTrilinos_DISABLE_DEFERRED_LENGTH_CHARACTERS */
!> @endcond
  type error_message
    private
#ifdef ForTrilinos_DISABLE_DEFERRED_LENGTH_CHARACTERS
    character(len=max_string_length) :: string ! gfortran 4.7.0 workaround
#else
    character(:) ,allocatable :: string
#endif /* ForTrilinos_DISABLE_DEFERRED_LENGTH_CHARACTERS */
    integer, allocatable :: idata(:)
    real, allocatable :: rdata(:)
    complex, allocatable :: cdata(:)
    character, allocatable :: chdata(:)
    logical, allocatable :: ldata(:)
    class(object), allocatable :: odata
  end type

  !> @cond Interface
  interface error_message ! constructor
    module procedure new_message
  end interface

  interface assert
    module procedure scalar_assert,vector_assert
  end interface
  !> @endcond

contains

  type(error_message) function new_message(message,message_data)
    use object_interface, only : object
    character(len=*), intent(in) :: message
    class(*), intent(in), optional :: message_data
    new_message%string = message
    if (present(message_data)) then
      select type(message_data)
        type is (character(len=*))
          new_message%chdata = message_data
        type is (real)
          new_message%rdata = message_data
        type is (integer)
          new_message%idata = message_data
        type is (logical)
          new_message%ldata = message_data
        type is (complex)
          new_message%cdata = message_data
        class is (object)
          allocate(new_message%odata,source = message_data)
        class default
#ifndef COMPILER_LACKS_ERROR_STOP
          error  &
#endif
          stop "error_message constructor: unrecognized message_data type"
      end select
    end if
  end function

  subroutine scalar_assert(assertion,message)
    logical ,intent(in) :: assertion
    type(error_message) ,intent(in) :: message
    integer io_status
    character(len=132) io_message
    if (.not. assertion) then
      write(error_unit,fmt='(31a)',advance="no") 'Assertion failed with message: '
#ifndef ForTrilinos_DISABLE_DEFERRED_LENGTH_CHARACTERS
      if (allocated(message%string)) then
#endif
        write(error_unit,*) message%string
#ifndef ForTrilinos_DISABLE_DEFERRED_LENGTH_CHARACTERS
      else
        write(error_unit,*) '(no message provided).'
      end if
#endif
      if (allocated(message%idata)) write(error_unit,*) 'Integer test data: ',message%idata
      if (allocated(message%rdata)) write(error_unit,*) 'Real test data: ',message%rdata
      if (allocated(message%odata)) then
#ifdef COMPILER_LACKS_DERIVED_TYPE_IO
        call message%odata%output(error_unit,v_list=[10,3],iotype='DT',iostat=io_status,iomsg=io_message)
#else
        write(error_unit,fmt="(dt(10,3))",iostat=io_status,iomsg=io_message)  message%odata
#endif /* COMPILER_LACKS_DERIVED_TYPE_IO */
      end if

      stop "scalar_assert: assertion failure"
    end if
  end subroutine

  subroutine vector_assert(assertion,text)
    logical ,dimension(:) ,intent(in) :: assertion
    type(error_message) ,dimension(:) ,intent(in) :: text
    integer :: i
    logical :: any_failures
    call assert_identical( [size(assertion),size(text)] )
    any_failures=.false.
    do i=1,size(assertion)
      if (.not. assertion(i)) then
        any_failures=.true.
        write(error_unit,fmt='(31a)',advance="no") 'Assertion failed with message: '
       !if (allocated(text(i)%string)) then
          write(error_unit,*) text(i)%string
       !else
       !  write(error_unit,*) '(no message provided).'
       !end if
      end if
    end do
    if (any_failures) stop 'Execution halted on failed assertion(s)!'
  end subroutine


  subroutine assert_identical(integers)
    integer ,dimension(:) ,intent(in) :: integers
    integer :: i
    logical :: any_mismatches
    any_mismatches = .false.
    do i=2,size(integers)
      if (integers(i) /= integers(1)) then
        any_mismatches = .true.
        write(error_unit,*) &
        'Value ',i,' does not match expected value ',integers(1)
      end if
    end do
    if (any_mismatches) stop 'Execution halted on failed assertion!'
  end subroutine
end module

! test1caf test
!
! Copyright (c) 2012-2014, Sourcery, Inc.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of the Sourcery, Inc., nor the
!       names of its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE FOR ANY
! DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
!

program test1caf
  implicit none
  integer, parameter :: num_local_elems=3,a_initial=1,b_initial=2
  integer :: a(num_local_elems)[*]=a_initial,b(num_local_elems)[*]=b_initial
  integer :: i,me,np,left,right

  me = this_image()
  np = num_images()

  left  = merge(np,me-1,me==1)
  right = merge(1,me+1,me==np)

  if (mod(me,2).eq.0) then
     a(:)[right] = a(:)[right]+me
  else
     b(:)[left] = b(:)[left]+me
  end if

  if(me==1) then
     write(*,*) me, a, b
  else
     sync images(me-1)
     write(*,*) me, a, b
  end if

  if(me < np) sync images(me+1)

  sync all

  if (mod(me,2).eq.0) then
    if ( any(a(:)[right]/=a_initial+me)) error stop "Test failed."
  else
    if ( any(b(:)[left]/=b_initial+me)) error stop "Test failed."
  end if

  sync all

  if (me==1) print *,"Test passed."

end program test1caf

! This program tests the capability of copying data on the
! same memory location and within the same image from
! different memory locations.
program sameloc
  implicit none

  integer,codimension[*] :: a
  integer,dimension(10),codimension[*] :: b,c
  integer,dimension(9,10),codimension[*] :: m
  integer,dimension(10) :: t
  integer :: i,j
  logical :: tests_passed

  tests_passed = .true.

  a = 10
  b(1:5) = 1
  b(6:10) = -1
  c(1:5) = 1
  c(6:10) = -1

  t(:) = b(:)
  t(1:5) = b(2:6)

  do i=1,9
    m(i,:) = (/ (j, j = 1, 10) /)
  enddo

  sync all

  a = a[1]
  if (this_image() == 1) write(*,*) 'OK',a

  t = (/ (j, j = 1, 10) /)

  if(this_image() == 1) then
    c = m(1,:)[1]
    if(any(c(:) /= t(:))) then
      tests_passed = .false.
      error stop "get row failed"
    else
     tests_passed = tests_passed .and. .true.
     write(*,*) 'ok get row'
    endif
  endif

  sync all

  if(this_image() == 1) then
    do i=1,10
      if(m(9,i)[1] /= t(i)) then
	write(*,*) 'pos',i,'value get',m(9,i)[1],'value t',t(i)
        tests_passed = .false.
        error stop "get element from matrix failed"
      else
        tests_passed = tests_passed .and. .true.
      endif
    enddo
  endif

  if (this_image() == 1) write(*,*) 'Ok get element from matrix'

  sync all

  m(9,:) = 1

  if(this_image() == 1) then
    do i=1,10
      m(9,i)[1] = i
      if(m(9,i)[1] /= t(i)) then
        write(*,*) 'pos',i,'value get',m(9,i)[1],'value t',t(i)
        tests_passed = .false.
        error stop "put element from matrix failed"
      else
        tests_passed = tests_passed .and. .true.
      endif
    enddo
  endif

  if (this_image() == 1) write(*,*) 'Ok put element from matrix'

  t(:) = b(:)
  t(1:5) = b(2:6)

  c(1:5) = 1
  c(6:10) = -1

  sync all

  if(this_image() == 1) then
    b(1:5)[1] = b(2:6)
    if(any(b(:) /= t(:))) then
      tests_passed = .false.
      error stop "put overlapped failed"
    else
      tests_passed = tests_passed .and. .true.
      write(*,*) 'OK put overlapped'
    endif
  endif

  b(1:5) = 1
  b(6:10) = -1

  sync all

  if(this_image() == 1) then
    b(1:5)[1] = b(2:6)[1]
    if(any(b(:) /= t(:))) then
      tests_passed = .false.
      error stop "putget overlapped failed"
    else
      tests_passed = tests_passed .and. .true.
      write(*,*) 'OK putget overlapped'
    endif
  endif

  t(:) = c(:)
  t(10:1:-1) = t(:)

  sync all

  if(this_image() == 1) then
    c(10:1:-1)[1] = c(:)
    if(any(t(:) /= c(:))) then
      tests_passed = .false.
      write(*,*) 'Error in put reversed'
      write(*,*) c
      write(*,*) t
      error stop "put reversed failed"
    else
      tests_passed = tests_passed .and. .true.
      write(*,*) 'OK put reversed'
    endif
  endif

  c(1:5) = 1
  c(6:10) = -1

  t(:) = c(:)
  t(10:1:-1) = t(:)

  if(this_image() == 1) then
    c(:) = c(10:1:-1)[1]
    if(any(t(:) /= c(:))) then
      tests_passed = .false.
      write(*,*) c
      write(*,*) t
      error stop "get reversed failed"
    else
      tests_passed = tests_passed .and. .true.
      write(*,*) 'OK get reversed'
    endif
  endif

  if ( .not. tests_passed ) then
     error stop "Test failures exist!"
  end if

  sync all

  if ( tests_passed ) then
    if (this_image() == 1) write(*,*) 'Test passed'
  end if

end program

! MPI 1D Burgers equation solver test: mpi_share
!
! Copyright (c) 2012-2014, Sourcery, Inc.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of the Sourcery, Inc., nor the
!       names of its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE FOR ANY
! DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS

module mpi_share
  !module exclusively for initiating and sharing an mpi_object
  use mpi_module, only :mpi_class
  type (mpi_class) :: mpi_object
end module

! Copyright (c) 2012-2016, Sourcery, Inc.
! All rights reserved.
!
! Unit tests for co_min: verify parallel, collective minimum
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of Sourcery, Inc., nor the
!       names of any other contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

program main
  use iso_fortran_env, only : error_unit
  use iso_c_binding, only : c_int,c_double
#ifdef USE_EXTENSIONS
  use opencoarrays
#endif
  implicit none
  logical :: co_min_c_int_verified=.false.,co_min_c_double_verified=.false.

#ifdef USE_EXTENSIONS
  if (this_image()==1) print *,"Using the extensions from the opencoarrays module."
#endif

  ! Verify that 1 is the lowest image number
  c_int_co_min: block
    integer(c_int) :: me
    me=this_image()
    sync all
    call co_min(me)
    if (me==1) then
      co_min_c_int_verified=.true.
    else
      write(error_unit,"(2(a,i2))") "co_min fails for integer(c_int) argument with result (",me,") on image",this_image()
    end if
  end block c_int_co_min

  ! Verify that 1.0 is the minimum real conversion of an image number
  c_double_co_min: block
    real(c_double) :: me
    me=real(this_image(),c_double)
    sync all
    call co_min(me)
    if (me==1._c_double) then
      co_min_c_double_verified=.true.
    else
      write(error_unit,"(2(a,i2))") "co_min fails for integer(c_double) argument with result (",me,") on image",this_image()
    end if
  end block c_double_co_min

  if (.not. all([co_min_c_int_verified,co_min_c_double_verified])) error stop
  ! Wait for all images to pass the tests
  sync all
  if (this_image()==1) print *, "Test passed."
end program

program teams_subset
  !! author: Nathan Weeks
  !!
  !! Regression test for prior potential deadlock in change team/end team
  use iso_fortran_env, only : team_type
  use oc_assertions_interface, only : assert
  implicit none

  type(team_type) team

  associate( initial_team_image => this_image())
  associate( myteam => merge(1,2,any(initial_team_image==[1,num_images()])) )

    form team (myteam, team)

    if (myteam == 1) then
      block
        integer max_image(2), min_image(2)
        change team(team)
          max_image = [initial_team_image, this_image()]
          call co_max(max_image)
          min_image = [initial_team_image, this_image()]
          call co_min(min_image)
        end team
        call assert( all(min_image==1), "minimum image number in team 1 is 1" )
        call assert( all(max_image==[num_images(), 2]), "maximum image numbers on team 1 is num_images() or 2")
      end block
    end if

    sync all

    if (initial_team_image == 1) print *,"Test passed."

  end associate; end associate

end program

! Coarray 1D Heat Equation Solver Test: local_field_module
!
! Copyright (c) 2012-2014, Sourcery, Inc.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of the Sourcery, Inc., nor the
!       names of its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE FOR ANY
! DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
!
module local_field_module
  implicit none
  private
  public :: local_field

  type local_field
    private
    real, allocatable :: values(:)
  contains
    procedure, private :: multiply
    generic :: operator(*)=>multiply
    procedure :: state
    procedure, private :: assign_array
    generic :: assignment(=)=>assign_array
  end type

contains

  pure function multiply(lhs,rhs) result(product_)
    class(local_field), intent(in) :: lhs
    type(local_field) :: product_
    real, intent(in) :: rhs
    product_%values = lhs%values*rhs
  end function

  pure function state(this) result(this_values)
    class(local_field), intent(in) :: this
    real :: this_values(size(this%values))
    this_values = this%values
  end function

  pure subroutine assign_array(lhs,rhs)
    class(local_field), intent(inout) :: lhs
    real, intent(in) :: rhs(:)
    lhs%values = rhs
  end subroutine

end module

program get_offset_1d
  implicit none

  integer,allocatable :: a(:)[:],b(:)
  integer :: me,np,i

  me = this_image()
  np = num_images()

  allocate(a(100)[*],b(10))

  a = (/ (i, i=1,100) /)

  do i=1,100
    a(i) = a(i) + me
  enddo

  sync all

  if(me < np) then
    b(:) = a(21:30)[me+1]
  endif

  if(me == 1) then
    do i=1,10
      if(b(i) /= 20+i+me+1) error stop "get offset 1d failed"
    enddo
  endif
  sync all
  if(me ==1) write(*,*) 'Test passed.'
end program

! BSD 3-Clause License
!
! Copyright (c) 2016, Sourcery Institute
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

! Comments preceded by "!!" are formatted for the FORD docoumentation generator
program allocatable_p2p_event_post
  !! author: Andre Vehreschild
  !! date: 2017-08-05
  !! category: unit-test
  !! Basic events test testing receipt of event post from one image to another
  use iso_fortran_env, only: event_type
  implicit none

  type(event_type), allocatable :: snd_copied(:)[:]

  if (num_images() < 4) error stop "num_images() >= 4 required for even_post_1 test"
  associate(me => this_image(), np => num_images())
    allocate(snd_copied(np)[*])
    if (me == 2) print*,'I am  image 2, I am posting to 4'
    if (me == 2) event post(snd_copied(2)[4])
    if (me == 2) print*,' I am image 2, I have posted to 4'
    if (me == 4) then
      event wait(snd_copied(2))
      sync all ! sync not required, but *may* expose cleanup issues/segfaults etc.
      print *, 'Test passed.'
    end if
    if (me /= 4) then
      sync all
      print *, 'I am', me, 'and image 4 told me it received the event'
    end if
    if (allocated(snd_copied)) deallocate(snd_copied)
  end associate
end program
! vim:ts=2:sts=2:sw=2:

! Coarray 3D Navier-Stokes Solver Test
!
! Copyright (c) 2012-2014, Sourcery, Inc.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of Sourcery, Inc., nor the
!       names of its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE FOR ANY
! DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!

!(*----------------------------------------------------------------------------------------------------------------------
!         basic in-core shear code ( 7 words/node, not threaded, in-core, no file read/write )
!------------------------------------------------------------------------------------------------------------------------*)

! Define universal constants:
! In the case of exactly representable numbers, the definitions are useful
! to ensure subprogram argument type/kind/rank matching without having to
! repeat kind specifiers everywhere.
module constants_module
  use iso_fortran_env, only : int64
  implicit none
  private
  public :: one,zero
  integer(int64), parameter :: one=1_int64,zero=0_int64
end module

! Initialize the random seed with a varying seed to ensure a different
! random number sequence for each invocation of subroutine, e.g. for
! invocations on different images of a coarray parallel program.
! Setting any seed values to zero is deprecated because it can result
! in low-quality random number sequences.
! (Source: https://gcc.gnu.org/onlinedocs/gfortran/RANDOM_005fSEED.html)
module random_module
  implicit none
  private
  public :: init_random_seed
contains
  subroutine init_random_seed()
            use iso_fortran_env, only: int64
            implicit none
            integer, allocatable :: seed(:)
            integer :: i, n, un, istat, dt(8), pid
            integer(int64) :: t

            call random_seed(size = n)
            allocate(seed(n))
            ! First try if the OS provides a random number generator
            open(newunit=un, file="/dev/urandom", access="stream", &
                 form="unformatted", action="read", status="old", iostat=istat)
            if (istat == 0) then
               if (this_image()==1) print *,"OS provides random number generator"
               read(un) seed
               close(un)
            else
               if (this_image()==1) print *,"OS does not provide random number generator"
               ! Fallback to XOR:ing the current time and pid. The PID is
               ! useful in case one launches multiple instances of the same
               ! program in parallel.
               call system_clock(t)
               if (t == 0) then
                  call date_and_time(values=dt)
                  t = (dt(1) - 1970) * 365_int64 * 24 * 60 * 60 * 1000 &
                       + dt(2) * 31_int64 * 24 * 60 * 60 * 1000 &
                       + dt(3) * 24_int64 * 60 * 60 * 1000 &
                       + dt(5) * 60 * 60 * 1000 &
                       + dt(6) * 60 * 1000 + dt(7) * 1000 &
                       + dt(8)
               end if
               pid = getpid()
               t = ieor(t, int(pid, kind(t)))
               do i = 1, n
                  seed(i) = lcg(t)
               end do
            end if
            call random_seed(put=seed)
          contains
            ! This simple PRNG might not be good enough for real work, but is
            ! sufficient for seeding a better PRNG.
            function lcg(s)
              integer :: lcg
              integer(int64) :: s
              if (s == 0) then
                 s = 104729
              else
                 s = mod(s, 4294967296_int64)
              end if
              s = mod(s * 279470273_int64, 4294967291_int64)
              lcg = int(mod(s, int(huge(0), int64)), kind(0))
            end function lcg
          end subroutine init_random_seed
end module random_module

module run_size
    use iso_fortran_env, only : int64,real64 ! 64-bit integer and real kind parameters
    use constants_module, only : one         ! 64-bit unit to ensure argument kind match
#ifndef HAVE_WALLTIME
#  ifdef MPI_WORKING_MODULE
     use MPI, only : WALLTIME=>MPI_WTIME
     implicit none
#  else
     implicit none
     include 'mpif.h'
#    define WALLTIME MPI_WTIME
#  endif
#else
  implicit none
#endif
        real, codimension[*] ::  viscos, shear, b11, b22, b33, b12, velmax
        integer(int64), codimension[*] ::  nx, ny, nz, nsteps, output_step
        integer(int64), codimension[*] :: my, mx, first_y, last_y, first_x, last_x
        real(real64), codimension[*] :: cpu_time_, tran_time, sync_time, total_time
        real(real64), codimension[*] :: max_cpu_time, max_tran_time, max_sync_time, max_total_time
        real(real64), codimension[*] :: min_cpu_time, min_tran_time, min_sync_time, min_total_time

        real ::  time, cfl, dt
        integer(int64) :: my_node, num_nodes
        real, parameter :: pi = 3.141592653589793

contains

    subroutine max_velmax()
        integer(int64) :: i

        ! sync all
        ! if( my_node == 1) then
        !     do i = 2, num_nodes;     velmax = max( velmax, velmax[i] );    end do
        ! end if
        ! sync all
        call co_max(velmax,1)
        if (my_node>1) velmax = velmax[1]
        sync all
    end subroutine max_velmax

    subroutine global_times()
        integer(int64) :: i, stage

        max_cpu_time = cpu_time_
        max_tran_time = tran_time
        max_total_time = sync_time
        max_total_time = total_time
        min_cpu_time = cpu_time_
        min_tran_time = tran_time
        min_total_time = sync_time
        min_total_time = total_time

        do stage = 1, num_nodes-1
            i = 1 + mod( my_node-1+stage, num_nodes )
            max_cpu_time = max( max_cpu_time, cpu_time_[i] )
            min_cpu_time = min( min_cpu_time, cpu_time_[i] )
            max_tran_time = max( max_tran_time, tran_time[i] )
            min_tran_time = min( min_tran_time, tran_time[i] )
            max_sync_time = max( max_sync_time, sync_time[i] )
            min_sync_time = min( min_sync_time, sync_time[i] )
            max_total_time = max( max_total_time, total_time[i] )
            min_total_time = min( min_total_time, total_time[i] )
        end do
        sync all
    end subroutine global_times

subroutine copy3( A,B, n1, sA1, sB1, n2, sA2, sB2, n3, sA3, sB3 )
  implicit none
  complex, intent(in)  :: A(0:*)
  complex, intent(out) :: B(0:*)
  integer(int64), intent(in) :: n1, sA1, sB1
  integer(int64), intent(in) :: n2, sA2, sB2
  integer(int64), intent(in) :: n3, sA3, sB3
  integer(int64) i,j,k

  do k=0,n3-1
     do j=0,n2-1
        do i=0,n1-1
           B(i*sB1+j*sB2+k*sB3) = A(i*sA1+j*sA2+k*sA3)
        end do
     end do
  end do
end subroutine copy3

end module run_size

program cshear

  !(***********************************************************************************************************
  !                   m a i n   p r o g r a m
  !***********************************************************************************************************)
      use iso_fortran_env, only : int64,real64 ! 64-bit integer and real kind parameters
      use run_size
      implicit none

      interface
        subroutine solve_navier_stokes
        end subroutine solve_navier_stokes
      end interface

      num_nodes = num_images()
      my_node = this_image()

      nx=128; ny=128; nz=128
      viscos=0.; shear=0.
      b11=1.; b22=1.; b33=1.; b12=0.
      nsteps=5; output_step=1

      if( my_node == 1 ) then

       !write(6,*) "nx,ny,nz : ";               read(5,*) nx, ny, nz
        if ( mod(nx/2,num_nodes) /= 0) then;    write(6,*) "nx/2 not multiple of num_nodes";    stop;   end if
        if ( mod(ny,num_nodes) /= 0) then;      write(6,*) " ny not multiple of num_nodes";     stop;   end if

       !write(6,*) "viscos, shear : ";          read(5,*) viscos, shear
       !write(6,*) "b11 b22 b33 b12 : ";        read(5,*) b11, b22, b33, b12
       !write(6,*) "nsteps, output_step : ";    read(5,*) nsteps, output_step

        write(6,fmt="(3(A,i4))") "nx =",nx,   "   ny =",ny,   "   nz =",nz
        write(6,fmt="(2(A,f7.3))") "viscos = ", viscos, "      shear = ", shear
        write(6,fmt="(A,4f7.3)") "b11 b22 b33 b12 = ", b11, b22, b33, b12
        write(6,fmt="(2(A,i6))") "nsteps = ", nsteps, "       output_step = ", output_step

        write(6,fmt="(A,i4,A)") "----------------- running on ", num_nodes, " images -------------------"

      end if

      sync all  !--- images > 1 wait on inputs from image = 1 !

      if( my_node > 1 ) then
        nx = nx[1];     ny = ny[1];     nz = nz[1]
        viscos = viscos[1];     shear = shear[1]
        b11 = b11[1];   b22 = b22[1];   b33 = b33[1];   b12 = b12[1]
        nsteps = nsteps[1];     output_step = output_step[1]
      end if

        mx = nx/2 / num_nodes;  first_x = (my_node-1)*mx + 1;   last_x  = (my_node-1)*mx + mx
        my = ny / num_nodes;    first_y = (my_node-1)*my + 1;   last_y  = (my_node-1)*my + my

      if(my_node == 1 ) write(6,fmt="(A, f6.2)") "message size (MB) = ", real(nz*4*mx*my*8)/real(1024*1024)

    call solve_navier_stokes

    if (this_image()==1) print *,"Test passed."

end program cshear

!  (***********************************************************************************************************
!             n a v i e r - s t o k e s   s o l v e r
!  ************************************************************************************************************)

  subroutine solve_navier_stokes
      use run_size
      implicit none

  !(*****************************   declarations     ****************************************)

       integer(int64) ::  stop, rflag, oflag, step, rkstep, nshells
       real ::  k1(nx/2), k2(ny), k3(nz), mk1(nx/2), mk2(ny), mk3(nz) &
              , kx(nx/2), ky_(nx/2,ny), ky(nx/2,ny), kz(nz)
       complex :: sx(nx/2,3), sy(ny,3), sz(nz,3)
       integer(int64) :: trigx, trigy, trigz, trigxy

       complex, allocatable ::  u(:,:,:,:)[:]    ! u(nz,4,first_x:last_x,ny)[*]    !(*-- x-y planes --*)
       complex, allocatable ::  ur(:,:,:,:)[:]   !ur(nz,4,first_y:last_y,nx/2)[*]  !(*-- x-z planes --*)
       complex, allocatable ::  un(:,:,:,:)      !un(nz,3,first_x:last_x,ny)[*]    !(*-- x-y planes --*)
       complex, allocatable :: bufr_X_Y(:,:,:,:)
       complex, allocatable :: bufr_Y_X(:,:,:,:)
       real :: t_start,t_end

interface
!--------    note: integer(int64)'s required for FFT's and other assembly-coded externals   ------

   function ctrig( len ) bind(C)               !(*-- define complex FFT trig table --*)
        import int64
        integer(int64), value, intent(in) :: len
        integer(int64) :: ctrig     !-- C pointer!
   end function ctrig

   function rtrig( len ) bind(C)              !(*-- define real FFT trig table --*)
        import int64
        integer(int64), value, intent(in):: len
        integer(int64) :: rtrig     !-- C pointer!
   end function rtrig

   subroutine cfft( len, lot, data, inc, jmp, ctrig, isign ) bind(C)    !(*-- complex FFT --*)
        import int64
        integer(int64), value, intent(in) :: len, lot, inc, jmp, ctrig, isign
        complex, dimension(0:0), intent(in) :: data
   end subroutine cfft

   subroutine rfft( len, lot, data, inc, jmp, rtrig, isign ) bind(C)   !(*-- real FFT --*)
        import int64
        integer(int64), value, intent(in) :: len, lot, inc, jmp, rtrig, isign
        complex, dimension(0:0), intent(in) :: data
   end subroutine rfft

#ifdef HAVE_WALLTIME
   function WALLTIME() bind(C, name = "WALLTIME")
       import real64
       real(real64) :: WALLTIME
   end function WALLTIME
#endif


end interface

       trigx = rtrig( nx )
       trigy = ctrig( ny )
       trigz = ctrig( nz )
       trigxy = ctrig( nx+ny )

       allocate (  u(nz , 4 , first_x:last_x , ny)[*] )     !(*-- y-z planes --*)
       allocate ( ur(nz , 4 , first_y:last_y , nx/2)[*] )   !(*-- x-z planes --*)
       allocate ( un(nz , 3 , first_x:last_x , ny) )        !(*-- y-z planes --*)
       allocate ( bufr_X_Y(nz,4,mx,my) )
       allocate ( bufr_Y_X(nz,4,my,mx) )


       stop = 0;   step = 0;  rkstep = 2;  rflag = 0;  cfl = 1;   dt = 0
       nshells = max( nx,ny,nz )

                        call define_kspace
                        call define_field
                        call enforce_conjugate_symmetry
                        call copy_n_s
                        call define_shifts

       total_time =  -WALLTIME()      !-- start the clock
       tran_time = 0;       cpu_time_ = -WALLTIME()

  !(*********************************   begin execution loop   *****************************************)

       do while (stop == 0)

                        call phase1
            rkstep = 1
                        call transpose_X_Y
                        call phase2
                        call transpose_Y_X
                        call define_step
                        call define_shifts
                        call phase3
                        call pressure
        if (oflag /= 0) call spectra
                        call advance
                        call phase1
            rkstep = 2
                        call transpose_X_Y
                        call phase2
                        call transpose_Y_X
                        call phase3
                        call advance
                        call pressure
        if (rflag /= 0) call remesh
                        call copy_s_n

                        step = step + 1
                        time = time + dt
       end do

  !(*********************************   end execution loop   ***********************************************)

       deallocate ( u, ur, un )
       deallocate ( bufr_X_Y );    deallocate ( bufr_Y_X )
       sync all     !-- wait for all images to finish!

       total_time =  total_time + WALLTIME()    !-- stop the clock
       cpu_time_ =  cpu_time_ + WALLTIME()    !-- stop the clock
       call global_times

       if (my_node == 1 )   write(6,fmt="(3(10X,A,2f7.2))")  &
                              "total_time ", min_total_time/step, max_total_time/step &
                            , "cpu_time_ ", min_cpu_time/step, max_cpu_time/step &
                            , "tran_time ", min_tran_time/step, max_tran_time/step


       write(6,fmt="(A,i4,3f7.2)")  "image ", my_node, total_time/step, cpu_time_/step, tran_time/step


contains

 !(***********************************************************************************************************
 !                          transpose the Y and Z planes
 !***********************************************************************************************************)

!-----                   u(nz,4,mx,my*num_nodes) [num_nodes]
!-----                  ur(nz,4,my,mx*num_nodes) [num_nodes]
!-----                bufr(nz,4,my,mx) or bufr(nz,4,mx,my)

!-------------   out-of-place transpose data_s --> data_r  ----------------------------

 subroutine transpose_X_Y

    use constants_module, only : one
    use run_size
    implicit none

    integer(int64) :: i,stage
    real :: t_start,t_end

    cpu_time_ = cpu_time_ + WALLTIME()
    sync all   !--  wait for other nodes to finish compute
    tran_time = tran_time - WALLTIME()

    call copy3 (    u(1,1,first_x,1+(my_node-1)*my) &                   !-- intra-node transpose
                ,  ur(1,1,first_y,1+(my_node-1)*mx) &                   !-- no inter-node transpose needed
                ,   nz*3, one, one        &                                 !-- note: only 3 of 4 words needed
                ,   mx, nz*4, nz*4*my &
                ,   my, nz*4*mx, nz*4 )

    do stage = 1, num_nodes-1
        i = 1 + mod( my_node-1+stage, num_nodes )
        bufr_X_Y(:,:,:,:) = u(:,:,:,1+(my_node-1)*my:my_node*my)[i]         !-- inter-node transpose to buffer
        call copy3 ( bufr_X_Y, ur(1,1,first_y,1+(i-1)*mx)  &                !-- intra-node transpose from buffer
                        ,   nz*3, one, one        &                             !-- note: only 3 of 4 words needed
                        ,   mx, nz*4, nz*4*my &
                        ,   my, nz*4*mx, nz*4 )
    end do

    sync all     !--  wait for other nodes to finish transpose
    tran_time = tran_time + WALLTIME()
    cpu_time_ = cpu_time_ - WALLTIME()

 end  subroutine transpose_X_Y

!-------------   out-of-place transpose data_r --> data_s  ----------------------------

subroutine transpose_Y_X
    use run_size
    implicit none

    integer(int64) :: i, stage

    cpu_time_ = cpu_time_ + WALLTIME()
    sync all   !--  wait for other nodes to finish compute
    tran_time = tran_time - WALLTIME()

    call copy3 (   ur(1,1,first_y,1+(my_node-1)*mx) &                   !-- intra-node transpose
                ,   u(1,1,first_x,1+(my_node-1)*my) &                   !-- no inter-node transpose needed
                ,   nz*4, one, one        &                                 !-- note: all 4 words needed
                ,   my, nz*4, nz*4*mx &
                ,   mx, nz*4*my, nz*4 )

    do stage = 1, num_nodes-1
        i = 1 + mod( my_node-1+stage, num_nodes )
        bufr_Y_X(:,:,:,:) = ur(:,:,:,1+(my_node-1)*mx:my_node*mx)[i]        !-- inter-node transpose to buffer
        call copy3 ( bufr_Y_X, u(1,1,first_x,1+(i-1)*my)  &                 !-- intra-node transpose from buffer
                    ,   nz*4, one, one        &
                    ,   my, nz*4, nz*4*mx &
                    ,   mx, nz*4*my, nz*4 )
    end do

    sync all     !--  wait for other nodes to finish transpose
    tran_time = tran_time + WALLTIME()
    cpu_time_ = cpu_time_ - WALLTIME()

 end  subroutine transpose_Y_X


!(*************************************************************************************************************
!           enforce conjugate symmetry for plane kx=0 of wavespace  (half of this plane is redundant)
!***************************************************************************************************************)

  subroutine enforce_conjugate_symmetry

    integer(int64) ::  i, x, y, z

!(*------------------------- un( K ) = conjg( un( -K ) ) ---------------------*)

    if (my_node == 1 ) then     !-- x=1 is in node=1
        x = 1
        do i = 1, 3
            z = 1;              y = 1;              un(z,i,x,y) = 0
            z = 1;              do y = 2, ny/2;     un(z,i,x,y) = conjg( un(z,i,x,ny+2-y) );        end do
            do z = 2, nz/2;     y = 1;              un(z,i,x,y) = conjg( un(nz+2-z,i,x,y) );        end do
            do z = 2, nz/2;     do y = 2, ny;       un(z,i,x,y) = conjg( un(nz+2-z,i,x,ny+2-y) );   end do; end do
        end do
    end if
end  subroutine enforce_conjugate_symmetry

 !(***********************************************************************************************************
 !                spectra :  accumulate spectra and other statistics over flow field
 !***********************************************************************************************************)

 subroutine  spectra

      use run_size
     implicit none

    integer(int64) :: k, x, y, z
    real :: kk, ww, uw, uu, uv, duu, factor   &
          , ek(nshells), dk(nshells), hk(nshells), tk(nshells), sample(nshells)
    real, save, codimension[*] ::  sum_ek, sum_dk, sum_hk, sum_tk
    real, save ::  sum_ek_initial, sum_dk_initial, sum_hk_initial, sum_tk_initial
    logical, save :: first_call=.true.
    real, parameter :: tolerance=0.01,negligible=0.001

      total_time =  total_time + WALLTIME()     !-- stop the clock!  time/step does not include spectra time

      oflag = 0
      ek = 0;       dk = 0;       hk = 0;     tk = 0;   sample = 0

 !(*---------------------   three dimensional spectra  -----------------------*)

      do x = first_x, last_x;   do y = 1, ny;      do  z = 1, nz

            if( mk1(x)+mk2(y)+mk3(z) > 2./9. ) &
                              then;   factor = 0
            else if (x == 1)  then;   factor = 1
                              else;   factor = 2
            end if

            kk = kx(x)**2 + ky(x,y)**2 + kz(z)**2
            k = 1 + int( sqrt( kk ) + 0.5 )

              uu = factor * real( un(z,1,x,y) * conjg( un(z,1,x,y) ) &
                                + un(z,2,x,y) * conjg( un(z,2,x,y) ) &
                                + un(z,3,x,y) * conjg( un(z,3,x,y) ) )
              ww = kk * uu
              uv = factor * real( un(z,1,x,y) * conjg( un(z,2,x,y) ) )

              uw = factor * 2 * aimag( kx(x) *   un(z,2,x,y) * conjg( un(z,3,x,y) ) &
                                     + ky(x,y) * un(z,3,x,y) * conjg( un(z,1,x,y) ) &
                                     + kz(z) *   un(z,1,x,y) * conjg( un(z,2,x,y) ) )

              duu = factor * real( un(z,1,x,y) * conjg( u(z,1,x,y) ) &
                                 + un(z,2,x,y) * conjg( u(z,2,x,y) ) &
                                 + un(z,3,x,y) * conjg( u(z,3,x,y) ) ) / (dt/2) + shear * uv

              sample(k) = sample(k) + factor        !(*-- shell sample --*)
              ek(k) = ek(k) + uu                    !(*-- 2 * energy sum --*)
              dk(k) = dk(k) + ww                    !(*-- enstrophy sum --*)
              hk(k) = hk(k) + uw                    !(*-- helicity sum --*)
              tk(k) = tk(k) + duu                   !(*-- transfer sum --*)

      end do;   end do;  end do

 !(************************     finished accumulation :  compute final statistics     *************************)

    sum_ek = 0;     sum_dk = 0;     sum_hk = 0;     sum_tk = 0
    do k = nshells, 1, -1
        sum_ek  = sum_ek + ek(k)
        sum_dk  = sum_dk + dk(k)
        sum_hk  = sum_hk + hk(k)
        sum_tk  = sum_tk + tk(k)
    end do

    sync all
    call co_sum(sum_ek,1)
    call co_sum(sum_dk,1)
    call co_sum(sum_hk,1)
    call co_sum(sum_tk,1)
    if (my_node == 1)  then
        ! do k = 2, num_nodes
        !     sum_ek = sum_ek + sum_ek[k]
        !     sum_dk = sum_dk + sum_dk[k]
        !     sum_hk = sum_hk + sum_hk[k]
        !     sum_tk = sum_tk + sum_tk[k]
        ! end do

        if (step == 0)   write(6,*) "step   time     energy    enstrophy   helicity   transfer"
        write(6,fmt="(i3, 5e11.3)")  step,  time,    sum_ek,   sum_dk,     sum_hk,    sum_tk
        if (first_call) then
          first_call = .false.
          sum_ek_initial = sum_ek
          sum_dk_initial = sum_dk
          sum_hk_initial = sum_hk
          sum_tk_initial = sum_tk
        else
          if (abs((sum_ek_initial-sum_ek)/sum_ek)>tolerance) error stop "Test failed"
          if (abs((sum_dk_initial-sum_dk)/sum_dk)>tolerance) error stop "Test failed"
          if (abs((sum_hk_initial-sum_hk)/sum_hk)>tolerance) error stop "Test failed"
          if (abs((sum_tk_initial-sum_tk)/sum_ek)>negligible) error stop "Test failed"
        end if
    end if

     total_time =  total_time - WALLTIME()     !-- restart the clock!
 end  subroutine  spectra

  !(************************************************************************************************************
  !        define_field  :   define initial flow field from scratch
  !************************************************************************************************************)

 subroutine define_field

    use constants_module, only : zero
    use run_size
    use random_module
    implicit none

    real ::     k, k12, f, phi, theta1, theta2
    complex ::  alpha, beta
    integer(int64) ::  x, y, z
    real, parameter :: klo=8, khi=16

   call init_random_seed !(* seed a different pseudo-random number sequence for each image *)
   time = 0

   do x = first_x, last_x
       do  y = 1, ny
            do z = 1, nz
                 call random_number(theta1 )
                 call random_number(theta2 )
                 call random_number(phi    )
                 k   = sqrt( kx(x)**2 + ky(x,y)**2 + kz(z)**2 )
                 k12 = sqrt( kx(x)**2 + ky(x,y)**2 )

                 if ( k == 0  .or.  mk1(x)+mk2(y)+mk3(z)>2./9.  .or.  k < klo  .or.  k > khi ) &
                     then;   f = 0
                     else;   f = sqrt( 1./(2*pi) ) / k
                 end if

                 alpha = f * exp( (0,2) * pi * theta1 ) * cos( 2*pi * phi )
                 beta  = f * exp( (0,2) * pi * theta2 ) * sin( 2*pi * phi )

                 if (k12 == 0) &
                 then; un(z,1,x,y) = alpha
                       un(z,2,x,y) = beta
                       un(z,3,x,y) = 0

                 else; un(z,1,x,y) = ( beta * kz(z) * kx(x)   + alpha * k * ky(x,y) ) / ( k * k12 )
                       un(z,2,x,y) = ( beta * kz(z) * ky(x,y) - alpha * k * kx(x)   ) / ( k * k12 )
                       un(z,3,x,y) = - beta * k12 / k
                 end if

   end do;  end do; end do
 end  subroutine define_field

 !(***********************************************************************************************************
 !          define_shifts  :    define coordinate shifts for control of 1-d alias errors
 ! ***********************************************************************************************************)

    subroutine  define_shifts
    use constants_module, only : zero
    use run_size
    implicit none

           integer(int64) ::  x, y, z
           integer(int64), save ::  init = 0
           real :: delta_x, delta_y, delta_z
           integer :: i,seed_size

           if (init == 0) &     !-- Note: delta's not carried over from previous run
           then;
                init = 1
                call random_seed(size=seed_size)
                call random_seed(put=[(1234567,i=1,seed_size)])!(* same random numbers for each image! *)
                do  x = 1, nx/2;  sx(x,3) = exp (  (0,1) * ( pi / nx ) * k1(x) ); end do
                do  y = 1, ny  ;  sy(y,3) = exp (  (0,1) * ( pi / ny ) * k2(y) ); end do
                do  z = 1, nz  ;  sz(z,3) = exp (  (0,1) * ( pi / nz ) * k3(z) ); end do
            else;
                call random_number(delta_x); delta_x = 2*pi / nx * delta_x
                do  x = 1, nx/2;  sx(x,1) = sx(x,3)
                                  sx(x,2) = exp (  (0,1) * delta_x * k1(x) )
                                  sx(x,3) = exp (  (0,1) * ( delta_x + pi / nx ) * k1(x) ); end do

                call random_number(delta_y); delta_y = 2*pi / ny * delta_y
                do  y = 1, ny  ;  sy(y,1) = sy(y,3)
                                  sy(y,2) = exp (  (0,1) * delta_y * k2(y) )
                                  sy(y,3) = exp (  (0,1) * ( delta_y + pi / ny ) * k2(y) ); end do

                call random_number(delta_z); delta_z = 2*pi / nz * delta_z
                do  z = 1, nz  ;  sz(z,1) = sz(z,3)
                                  sz(z,2) = exp (  (0,1) * delta_z * k3(z) )
                                  sz(z,3) = exp (  (0,1) * ( delta_z + pi / nz ) * k3(z) ); end do
           end if

 end  subroutine  define_shifts

  !(***********************************************************************************************************
  !       define_step  :   update time, metric, shifts for the next step
  !**********************************************************************************************************)

  subroutine  define_step
      use run_size
      implicit none

    sync all

    if (cfl /= 0) then
cpu_time_ = cpu_time_ + WALLTIME()
        call max_velmax
cpu_time_ = cpu_time_ - WALLTIME()
        dt = cfl / velmax
    end if

    if (        shear > 0               &
        .and.  .01*b11*shear*dt < b12   &
        .and.  b12 <= b11*shear*dt )    then
            dt = b12 / ( b11 * shear )          !(* limit dt, hit the orthognal mesh *)
            oflag = 1
    else if ( mod (step,output_step) == 0 ) then
            oflag = 1
    end if

    b12 = b12 - b11 * shear * dt

    if ( b12 < -b22/2 )     rflag = 1                                   !(* remesh at the end of the step? *)
    if ( step == nsteps )   stop = 1                                    !(* last step? *)

 end   subroutine    define_step

   !(***********************************************************************************************************
   !      define_kspace  :   define physical wavespace from computational wavespace and metric
   !**********************************************************************************************************)

  subroutine    define_kspace
    use run_size
    implicit none

     integer(int64) ::  x, y, z

       do  x = 1, nx/2   ;   k1(x) = x - 1;     end do
       do  y = 1, ny/2+1 ;   k2(y) = y - 1;     end do
       do  z = 1, nz/2+1 ;   k3(z) = z - 1;     end do

       do  y = ny/2+2, ny;   k2(y) = y - 1 - ny;    end do
       do  z = nz/2+2, nz;   k3(z) = z - 1 - nz;    end do

       do  x = 1, nx/2 ;     mk1(x) = (k1(x)/nx)**2;    kx(x) =   b11 * k1(x);  end do
       do  z = 1, nz   ;     mk3(z) = (k3(z)/nz)**2;    kz(z) =   b33 * k3(z);  end do
       do  y = 1, ny   ;     mk2(y) = (k2(y)/ny)**2
                             do  x = 1, nx/2 ;    ky(x,y) = b22 * k2(y) + b12 * k1(x);  end do; end do

end   subroutine    define_kspace

  !(***********************************************************************************************************
  !   phase 1 :  on entry, data-plane contains velocity in wave space.  interpolate database, shifted mesh,
  !              and proceed to physical y space .
  !************************************************************************************************************)

  subroutine  phase1

      use run_size
      implicit none

    complex :: shift
    integer(int64) :: i, x, y, z

        do  x = first_x, last_x

          do  y = 1, ny;    do  z = 1, nz
             shift = sz(z,rkstep+1) * sy(y,rkstep+1) * sx(x,rkstep+1)
             u(z,1,x,y) = shift * u(z,1,x,y)
             u(z,2,x,y) = shift * u(z,2,x,y)
             u(z,3,x,y) = shift * u(z,3,x,y)
        end do; end do

!(*---------------------------   LEAVING FOURIER WAVE SPACE  --------------------------*)

        do i = 1, 3
            call cfft ( ny, nz, u(1,i,x,1), nz*4*mx, one, trigy, one );    end do
        end do

 end   subroutine  phase1

 !(**********************************************************************************************************
 !     phase 2 :  on entry, data-plane contains velocity in physical y space, and wave x,z space on shifted
 !                mesh.  Proceed to physical x,z space,  form nonlinear terms, and return to wave x,z space.
 !***********************************************************************************************************)

 subroutine  phase2

     use run_size
     implicit none

     complex :: s2(nz,nx/2), vs(nz,nx/2)
     integer(int64) ::  i, x, y, z
     real :: v2r, v2i, s2r, s2i, u1r, u1i, u2r, u2i, u3r, u3i, u4r, u4i

  velmax = 0

  do  y = first_y, last_y

      do  x = 1, nx/2 ;  do  z = 1, nz ;   vs(z,x) = ur(z,2,y,x);    end do; end do

      do  i = 1, 3
           call cfft ( nz, nx/2, ur(1,i,y,1), one, nz*4*my, trigz, one )
           call rfft ( nx, nz,   ur(1,i,y,1), nz*4*my, one, trigx, one )
      end do

!(*----------------------------  WELCOME TO PHYSICAL SPACE  --------------------------*)

      do  x = 1, nx/2;  do  z = 1, nz
           u1r = real(ur(z,1,y,x));  u1i = aimag(ur(z,1,y,x))
           u2r = real(ur(z,2,y,x));  u2i = aimag(ur(z,2,y,x))
           u3r = real(ur(z,3,y,x));  u3i = aimag(ur(z,3,y,x))

      if ( rkstep == 1 ) velmax = max( velmax &
                                     , b11*nx*abs(u1r) + b22*ny*abs(u2r) + b33*nz*abs(u3r) &
                                     , b11*nx*abs(u1i) + b22*ny*abs(u2i) + b33*nz*abs(u3i) )

           v2r = u2r * u2r;             v2i = u2i * u2i
           s2r = u1r * u3r;             s2i = u1i * u3i
           u4r = u2r * u3r;             u4i = u2i * u3i
           u3r = u3r * u3r  -  v2r;     u3i = u3i * u3i  -  v2i
           u2r = u1r * u2r;             u2i = u1i * u2i
           u1r = u1r * u1r  -  v2r;     u1i = u1i * u1i  -  v2i

           s2(z,x)     = cmplx(s2r, s2i)
           ur(z,1,y,x) = cmplx(u1r, u1i)
           ur(z,2,y,x) = cmplx(u2r, u2i)
           ur(z,3,y,x) = cmplx(u3r, u3i)
           ur(z,4,y,x) = cmplx(u4r, u4i)
      end do;   end do

!(*----------------------------  LEAVING PHYSICAL SPACE  --------------------------*)

      do  i = 1,  4
           call rfft ( nx, nz,   ur(1,i,y,1), nz*4*my, one, trigx, -one )
           do  z = 1, nz ;   ur(z,i,y,1) = cmplx(real(ur(z,i,y,1)),0);   end do
           call cfft ( nz, nx/2, ur(1,i,y,1), one, nz*4*my, trigz, -one )
      end do

      call rfft ( nx, nz, s2, nz, one, trigx, -one )
      do  z = 1, nz ;   s2(z,1) = cmplx(real(s2(z,1)),0);    end do
      call cfft ( nz, nx/2, s2, one, nz, trigz, -one )

      do  x = 1, nx/2;  do  z = 1, nz
          ur(z,1,y,x) = kx(x) * ur(z,1,y,x) + kz(z) * s2(z,x)   - (0,1) * 2*nx*nz*shear * vs(z,x)
          ur(z,3,y,x) = kx(x) * s2(z,x)     + kz(z) * ur(z,3,y,x)
      end do;   end do
  end do

 end  subroutine  phase2

  !(***********************************************************************************************************
  !     phase 3 :  on entry, the data-plane contains the four stresses on a shifted mesh in physical y space,
  !                wave x,z space.   Return to y  wave space on unshifted mesh and complete time derivative of
  !                velocity ( not divergence free yet )
  !***********************************************************************************************************)

  subroutine  phase3

      use run_size
      implicit none

    integer(int64) :: i, x, y, z
    complex :: shift

    do  x = first_x, last_x

       do i = 1, 4
           call cfft ( ny, nz, u(1,i,x,1), nz*4*mx, one, trigy, -one )
       end do

!(*---------------------------   WELCOME TO FOURIER WAVE SPACE  --------------------------*)

       do  y = 1, ny ;   do  z = 1, nz
               shift = -dt / (4*nx*ny*nz) * (0,1)*conjg( sy(y,rkstep) * sz(z,rkstep) * sx(x,rkstep) )
               u(z,1,x,y) = shift * (         u(z,1,x,y) + ky(x,y) * u(z,2,x,y) )
               u(z,2,x,y) = shift * ( kx(x) * u(z,2,x,y) + kz(z)   * u(z,4,x,y) )
               u(z,3,x,y) = shift * (         u(z,3,x,y) + ky(x,y) * u(z,4,x,y) )
       end do;  end do
    end do

 end   subroutine  phase3

  !(***********************************************************************************************************
  !   pressure :  add the gradient of a scalar, enforce continuity ( zero divergence )
  !***********************************************************************************************************)

  subroutine  pressure

      use run_size
      implicit none

     complex :: psi
     integer(int64) :: x, y, z

      do x = first_x, last_x ;     do  y = 1, ny

            if ( x /= 1 )  then
                  do  z = 1, nz
                        psi = ( kx(x) * u(z,1,x,y) + ky(x,y) * u(z,2,x,y) + kz(z) * u(z,3,x,y) ) &
                              / ( kx(x)**2 + ky(x,y)**2 + kz(z)**2 )
                        u(z,1,x,y) = u(z,1,x,y) - kx(x) * psi
                        u(z,2,x,y) = u(z,2,x,y) - ky(x,y) * psi
                        u(z,3,x,y) = u(z,3,x,y) - kz(z) * psi
                   end do
            else if ( y /= 1 )  then
                  do  z = 1, nz
                        psi = ( ky(1,y) * u(z,2,1,y) + kz(z) * u(z,3,1,y) ) &
                              / ( ky(1,y)**2 + kz(z)**2 )
                        u(z,2,1,y) = u(z,2,1,y) - ky(1,y) * psi
                        u(z,3,1,y) = u(z,3,1,y) - kz(z) * psi
                  end do
            else
                  do  z = 1, nz ;    u(z,3,1,1) = 0;     end do
            end if
      end do;    end do

end   subroutine  pressure

!(*****************************************************************************************************************
!                                remesh  :  remesh the sheared coordinate system
!*****************************************************************************************************************)

subroutine   remesh

    use constants_module, only : one
    use run_size
    implicit none

    complex :: u2(nx+ny,nz), shift(nx+ny)
    integer(int64) :: i, x, y, z

    write(6,fmt="(A,i4)") "remesh image ", my_node

    total_time =  total_time + WALLTIME()     !-- stop the clock!

    do x = first_x, last_x

        do  y = 1, nx+ny ;   shift(y) =  exp( (0,-2) * pi / (nx+ny) * k1(x) * (y - 1) ) / (nx+ny);    end do

        do  i = 1,  3
            do  z = 1, nz
                do  y = 1, ny/2           ;   u2(y,z) = u(z,i,x,y);     end do
                do  y = ny/2+1, nx+ny/2+1 ;   u2(y,z) = 0;              end do
                do  y = nx+ny/2+2, nx+ny  ;   u2(y,z) = u(z,i,x,y-nx);  end do
            end do

            call cfft ( nx+ny, nz, u2, one , nx+ny, trigxy, one )

            do  z = 1, nz ;  do  y = 1, nx+ny ;     u2(y,z) = u2(y,z) * shift(y);  end do;  end do

            call cfft ( nx+ny, nz, u2, one, nx+ny, trigxy, -one )

            do  z = 1, nz
                do  y = 1, ny/2
                    if (mk1(x)+mk2(y)+mk3(z) > 2./9.) &
                        then;  u(z,i,x,y) = 0
                        else;  u(z,i,x,y) = u2(y,z)
                    end if
                end do
                do  y = ny/2+1, ny
                    if (mk1(x)+mk2(y)+mk3(z) > 2./9.) &
                        then;  u(z,i,x,y) = 0
                        else;  u(z,i,x,y) = u2(y+nx,z)
                    end if
                end do
            end do
        end do

        do  y = 1, ny ;    ky(x,y) = ky(x,y) + b22 * k1(x);     end do           !(* update ky for this x *)

    end do

    b12 = b12 + b22;     rflag = 0                                               !(*   update metric, account for remesh    *)

    total_time =  total_time - WALLTIME()     !-- restart the clock!
 end subroutine   remesh

 !(***********************************************************************************************************
 !         copy_n_s,   copy_s_n :  copy data between data_s and data_n
 !***********************************************************************************************************)

 subroutine  copy_n_s

     use run_size
     implicit none

     integer(int64) ::  x, y, z

     do y = 1, ny;    do x = first_x, last_x;   do z = 1, nz
        u(z,1,x,y) = un(z,1,x,y)
        u(z,2,x,y) = un(z,2,x,y)
        u(z,3,x,y) = un(z,3,x,y)
     end do; end do; end do
 end  subroutine  copy_n_s

 subroutine  copy_s_n

     use run_size
     implicit none

     integer(int64) ::  x, y, z

     do y = 1, ny; do x = first_x, last_x;     do z = 1, nz
       un(z,1,x,y) = u(z,1,x,y)
       un(z,2,x,y) = u(z,2,x,y)
       un(z,3,x,y) = u(z,3,x,y)
    end do; end do; end do

 end  subroutine  copy_s_n

 !(***********************************************************************************************************
 !                         advance :     second-order runge-kutta time step algorithm
 !***********************************************************************************************************)

 subroutine  advance

     use run_size
     implicit none

    integer(int64) ::  x, y, z
    real :: factor, xyfac, zfac(nz)  !(* viscous integrating factors *)

    if (rkstep == 1) then
        do z = 1, nz;     zfac(z) = exp( - viscos * dt * kz(z)**2 ); end do

        do x = first_x, last_x
            do  y = 1, ny
                ky_(x,y) = ky(x,y)
                ky(x,y) = b22 * k2(y) + b12 * k1(x)

                do z = 1, nz
                    if (mk1(x)+mk2(y)+mk3(z) > 2./9.) then
                        u(z,1,x,y) = 0;     u(z,2,x,y) = 0;     u(z,3,x,y) = 0
                    else
                        factor = zfac(z) * exp( - viscos * dt * ( kx(x)**2 + ( ky_(x,y)**2 + ky_(x,y)*ky(x,y) + ky(x,y)**2 )/3 ) )

                        un(z,1,x,y) = factor * ( un(z,1,x,y) + u(z,1,x,y) )
                        u(z,1,x,y)  = un(z,1,x,y) + factor * u(z,1,x,y)

                        un(z,2,x,y) = factor * ( un(z,2,x,y) + u(z,2,x,y) )
                        u(z,2,x,y)  = un(z,2,x,y) + factor * u(z,2,x,y)

                        un(z,3,x,y) = factor * ( un(z,3,x,y) + u(z,3,x,y) )
                        u(z,3,x,y)  = un(z,3,x,y) + factor * u(z,3,x,y)
                    end if
        end do;  end do; end do

    else if (rkstep == 2) then

        do x = first_x, last_x
            do  y = 1, ny
                do z = 1, nz
                    if (mk1(x)+mk2(y)+mk3(z) > 2./9.) then
                        u(z,1,x,y) = 0;     u(z,2,x,y) = 0;     u(z,3,x,y) = 0
                    else
                        u(z,1,x,y) = un(z,1,x,y) + u(z,1,x,y)
                        u(z,2,x,y) = un(z,2,x,y) + u(z,2,x,y)
                        u(z,3,x,y) = un(z,3,x,y) + u(z,3,x,y)
                    end if
        end do; end do; end do

    end if

 end  subroutine  advance

 end   subroutine solve_navier_stokes

program strided_get
  use iso_c_binding, only : DPC=>c_double
  implicit none

  integer :: i,me,np
  integer,allocatable :: a(:,:,:,:)[:],b(:,:,:,:)
  complex(kind=DPC),allocatable :: ac(:,:,:,:)[:],bc(:,:,:,:)

  me = this_image()
  np = num_images()

  allocate(ac(0:11,-10:-5,-1:0,-1:5)[*],bc(6,6,2,7))

  ac = me
  bc = me

  sync all

  if(me == 2) then
    bc(1:2,:,:,:) = ac(0:1,:,:,:)[me-1]
    if(any(bc(1:2,:,:,:) /= 1)) error stop "strided get test failed"
  endif

  sync all

  if (me == 2) write(*,*) 'Test passed.'
end program

program teams_coarray_sendget
  use, intrinsic :: iso_fortran_env, only: team_type
  implicit none
  type(team_type) :: team
  integer, allocatable :: R_send(:,:)[:]
  integer :: extent, i, j, my_team, team_num_images, R_get[*]

  ! if there are an odd number of images, then even images have R(:,extent) == 0
  extent = num_images()/2+mod(num_images(),2)
  allocate(R_send(extent, extent)[*], source=0)

  my_team = mod(this_image()-1,2)+1

  form team (my_team, team)

  R_get = this_image()

  change team (team)
    team_num_images = num_images()
    do concurrent (i = 1:num_images(), j = 1:num_images())
      R_send(this_image(),j)[i] = R_get[j]
    end do
  end team

  if (any(R_send /= reshape([((merge(i,0,i<=num_images() .and. j <= team_num_images), &
                              i=my_team,2*extent,2),j=1,extent)], &
                            shape=[extent,extent], order=[2,1]))) error stop 'Test failed.'

  sync all

  if (this_image() == 1) write(*,*) 'Test passed.'
end program teams_coarray_sendget

program comp_allocated_1

    implicit none
    integer, parameter :: success = 0
    type :: subType
        real, allocatable :: r_comp
    end type

    type :: T
        type(subType), dimension(:), allocatable :: arr
    end type

    type(T), codimension[*] :: obj

    call assert(num_images() .GE. 2, 'Need at least two images.')

    associate(me => this_image())
        if (me == 1) then
            call assert(.NOT. allocated(obj[2]%arr), 'obj%arr on image 2 allocated.')
        end if

        sync all

        if (me == 2) then
            allocate(obj%arr(3))
            allocate(obj%arr(2)%r_comp, source=13.7)
            print *, 'Image 2: memory allocated.'
        end if

        sync all

        if (me == 1) then
            call assert(allocated(obj[2]%arr), 'obj%arr on image 2 not allocated.')
            call assert(.NOT. allocated(obj[2]%arr(1)%r_comp), 'obj%arr(1)%r_comp should not be allocated')
            call assert(allocated(obj[2]%arr(2)%r_comp), 'obj%arr(2)%r_comp should be allocated')
            call assert(.NOT. allocated(obj[2]%arr(3)%r_comp), 'obj%arr(3)%r_comp should not be allocated')
            print *,'Test passed.'
        end if
        sync all
    end associate
contains
  subroutine assert(assertion,description,stat)
    logical, intent(in) :: assertion
    character(len=*), intent(in) :: description
    integer, intent(out), optional:: stat
    integer, parameter :: failure=1
    if (assertion) then
       if (present(stat)) stat=success
    else
      if (present(stat)) then
        stat=failure
      else
        error stop "Assertion "// description //" failed."
      end if
    end if
  end subroutine
end program

! vim:sw=4:ts=4:sts=4:

!! Thoroughly test get, i.e. foo = bar[N] in all variants
!!
!! Do simple tests for get(). These test comprise
!!
!! FOO = BAR [N]
!!
!! where
!!
!!  FOO                BAR              images
!! scalar            scalar            N == me
!!  int(k e [1,4])    int(k e [1,4])
!!  real(k e [4,8])   real(k e [4,8])
!!  int(k e [1,4])    real(k e [4,8])
!!  real(k e [4,8])   int(k e [1,4])
!!
!! array(1:5)        scalar
!!  int(k e [1,4])    int(k e [1,4])
!!  real(k e [4,8])   real(k e [4,8])
!!  int(k e [1,4])    real(k e [4,8])
!!  real(k e [4,8])   int(k e [1,4])
!!
!! array(1:5)        array(1:5)
!!  int(k e [1,4])    int(k e [1,4])
!!  real(k e [4,8])   real(k e [4,8])
!!  int(k e [1,4])    real(k e [4,8])
!!  real(k e [4,8])   int(k e [1,4])
!!
!! array(1:3)       array(::2)
!!  int(k e [1,4])    int(k e [1,4])
!!  real(k e [4,8])   real(k e [4,8])
!!  int(k e [1,4])    real(k e [4,8])
!!  real(k e [4,8])   int(k e [1,4])
!!
!! array(4:5)       array(2::2)
!!  int(k e [1,4])    int(k e [1,4])
!!  real(k e [4,8])   real(k e [4,8])
!!  int(k e [1,4])    real(k e [4,8])
!!  real(k e [4,8])   int(k e [1,4])
!!
!! array(1:3)      array(3:1:-1)
!!  int(k e [1,4])    int(k e [1,4])
!!  real(k e [4,8])   real(k e [4,8])
!!  int(k e [1,4])    real(k e [4,8])
!!  real(k e [4,8])   int(k e [1,4])
!!
!! all of the above but for            N != me
!!
!! And may be some other, I've forgotten.
!!
!! Author: Andre Vehreschild, 2017

program get_convert_nums

  implicit none

  real(kind=4), parameter :: tolerance4 = 1.0e-4
  real(kind=8), parameter :: tolerance4to8 = 1.0E-4
  real(kind=8), parameter :: tolerance8 = 1.0E-6

  integer(kind=1), allocatable, codimension[:] :: co_int_scal_k1
  integer(kind=1)                              :: int_scal_k1
  integer(kind=4), allocatable, codimension[:] :: co_int_scal_k4
  integer(kind=4)                              :: int_scal_k4
  real(kind=4)   , allocatable, codimension[:] :: co_real_scal_k4
  real(kind=4)                                 :: real_scal_k4
  real(kind=8)   , allocatable, codimension[:] :: co_real_scal_k8
  real(kind=8)                                 :: real_scal_k8

  integer(kind=1), allocatable, dimension(:), codimension[:] :: co_int_k1
  integer(kind=1), dimension(1:5)                            :: int_k1
  integer(kind=4), allocatable, dimension(:), codimension[:] :: co_int_k4
  integer(kind=4), dimension(1:5)                            :: int_k4
  real(kind=4)   , allocatable, dimension(:), codimension[:] :: co_real_k4
  real(kind=4)   , dimension(1:5)                            :: real_k4
  real(kind=8)   , allocatable, dimension(:), codimension[:] :: co_real_k8
  real(kind=8)   , dimension(1:5)                            :: real_k8
  logical :: error_printed=.false.

  associate(me => this_image(), np => num_images())
    if (np < 2) error stop 'Can not run with less than 2 images.'

    allocate(co_int_scal_k1[*], SOURCE=INT(42, 1)) ! allocate syncs here
    allocate(co_int_scal_k4[*], SOURCE=42) ! allocate syncs here
    allocate(co_int_k1(5)[*], SOURCE=INT([ 5, 4, 3, 2, 1], 1)) ! allocate syncs here
    allocate(co_int_k4(5)[*], SOURCE=[ 5, 4, 3, 2, 1]) ! allocate syncs here

    allocate(co_real_scal_k4[*], SOURCE=37.042) ! allocate syncs here
    allocate(co_real_scal_k8[*], SOURCE=REAL(37.042, 8)) ! allocate syncs here
    allocate(co_real_k4(1:5)[*], SOURCE=[ 5.1, 4.2, 3.3, 2.4, 1.5]) ! allocate syncs here
    allocate(co_real_k8(1:5)[*], SOURCE=REAL([ 5.1, 4.2, 3.3, 2.4, 1.5], 8)) ! allocate syncs here

    ! First check send/copy to self
    if (me == 1) then
      int_scal_k1 = co_int_scal_k1[1]
      print *, int_scal_k1
      if (co_int_scal_k1 /= int_scal_k1) call print_and_register( 'get scalar int kind=1 from kind=1 self failed.')

      int_scal_k4 = co_int_scal_k4[1]
      print *, int_scal_k4
      if (co_int_scal_k4 /= int_scal_k4) call print_and_register( 'get scalar int kind=4 to kind=4 self failed.')

      int_scal_k4 = co_int_scal_k1[1]
      print *, int_scal_k4
      if (co_int_scal_k4 /= int_scal_k4) call print_and_register( 'get scalar int kind=1 to kind=4 self failed.')

      int_scal_k1 = co_int_scal_k4[1]
      print *, int_scal_k1
      if (co_int_scal_k1 /= int_scal_k1) call print_and_register( 'get scalar int kind=4 to kind=1 self failed.')

      int_k1(:) = co_int_k1(:)[1]
      print *, int_k1
      if (any(co_int_k1 /= int_k1)) call print_and_register( 'get int kind=1 to kind=1 self failed.')

      int_k4(:) = co_int_k4(:)[1]
      print *, int_k4
      if (any(co_int_k4 /= int_k4)) call print_and_register( 'get int kind=4 to kind=4 self failed.')

      int_k4(:) = co_int_k1(:)[1]
      print *, int_k4
      if (any(co_int_k4 /= int_k4)) call print_and_register( 'get int kind=1 to kind=4 self failed.')

      int_k1(:) = co_int_k4(:)[1]
      print *, int_k1
      if (any(co_int_k1 /= int_k1)) call print_and_register( 'get int kind=4 to kind=1 self failed.')
    else if (me == 2) then ! Do the real copy to self checks on image 2
      real_scal_k4 = co_real_scal_k4[2]
      print *, real_scal_k4
      if (abs(co_real_scal_k4 - real_scal_k4) > tolerance4) &
        call print_and_register( 'get scalar real kind=4 to kind=4 self failed.')

      real_scal_k8 = co_real_scal_k8[2]
      print *, real_scal_k8
      if (abs(co_real_scal_k8 - real_scal_k8) > tolerance8) &
        call print_and_register( 'get scalar real kind=8 to kind=8 self failed.')

      real_scal_k8 = co_real_scal_k4[2]
      print *, real_scal_k8
      if (abs(co_real_scal_k8 - real_scal_k8) > tolerance4to8) &
        call print_and_register( 'get scalar real kind=4 to kind=8 self failed.')

      real_scal_k4 = co_real_scal_k8[2]
      print *, real_scal_k4
      if (abs(co_real_scal_k4 - real_scal_k4) > tolerance4) &
       call print_and_register( 'get scalar real kind=8 to kind=4 self failed.')

      real_k4(:) = co_real_k4(:)[2]
      print *, real_k4
      if (any(abs(co_real_k4 - real_k4) > tolerance4)) call print_and_register( 'get real kind=4 to kind=4 self failed.')

      real_k8(:) = co_real_k8(:)[2]
      print *, real_k8
      if (any(abs(co_real_k8 - real_k8) > tolerance8)) call print_and_register( 'get real kind=8 to kind=8 self failed.')

      real_k8(:) = co_real_k4(:)[2]
      print *, real_k8
      if (any(abs(co_real_k8 - real_k8) > tolerance4to8)) call print_and_register( 'get real kind=4 to kind=8 self failed.')

      real_k4(:) = co_real_k8(:)[2]
      print *, real_k4
      if (any(abs(co_real_k4 - real_k4) > tolerance4)) call print_and_register( 'get real kind=8 to kind=4 self failed.')
    end if

    sync all
    if (me == 1) then
      int_scal_k1 = co_int_scal_k1[2]
      print *, int_scal_k1
      if (co_int_scal_k1 /= int_scal_k1) call print_and_register( 'get scalar int kind=1 to kind=1 to image 2 failed.')

      int_scal_k4 = co_int_scal_k4[2]
      print *, int_scal_k4
      if (co_int_scal_k4 /= int_scal_k4) call print_and_register( 'get scalar int kind=4 to kind=4 to image 2 failed.')

      int_k1(:) = co_int_k1(:)[2]
      print *, int_k1
      if (any(co_int_k1 /= int_k1)) call print_and_register( 'get int kind=1 to kind=1 to image 2 failed.')

      int_k4(:) = co_int_k4(:)[2]
      print *, int_k4
      if (any(co_int_k4 /= int_k4)) call print_and_register( 'get int kind=4 to kind=4 to image 2 failed.')

    else if (me == 2) then
      real_scal_k4 = co_real_scal_k4[1]
      print *, real_scal_k4
      if (abs(co_real_scal_k4 - real_scal_k4) > tolerance4) &
        call print_and_register( 'get scalar real kind=4 to kind=4 to image 2 failed.')

      real_scal_k8 = co_real_scal_k8[1]
      print *, real_scal_k8
      if (abs(co_real_scal_k8 - real_scal_k8) > tolerance8) &
        call print_and_register( 'get scalar real kind=8 to kind=8 to image 2 failed.')

      real_k4(:) = co_real_k4(:)[1]
      print *, real_k4
      if (any(abs(co_real_k4 - real_k4) > tolerance4)) call print_and_register( 'get real kind=4 to kind=4 to image 2 failed.')

      real_k8(:) = co_real_k8(:)[1]
      print *, real_k8
      if (any(abs(co_real_k8 - real_k8) > tolerance8)) call print_and_register( 'get real kind=8 to kind=8 to image 2 failed.')
    end if

    sync all

    if (me == 1) then

      int_scal_k4 = co_int_scal_k1[2]
      print *, int_scal_k4
      if (co_int_scal_k4 /= int_scal_k4) call print_and_register( 'get scalar int kind=1 to kind=4 to image 2 failed.')

      int_scal_k1 = co_int_scal_k4[2]
      print *, int_scal_k1
      if (co_int_scal_k1 /= int_scal_k1) call print_and_register( 'get scalar int kind=4 to kind=1 to image 2 failed.')

      int_k4(:) = co_int_k1(:)[2]
      print *, int_k4
      if (any(co_int_k4 /= int_k4)) call print_and_register( 'get int kind=1 to kind=4 to image 2 failed.')

      int_k1(:) = co_int_k4(:)[2]
      print *, int_k1
      if (any(co_int_k1 /= int_k1)) call print_and_register( 'get int kind=4 to kind=1 to image 2 failed.')

    elseif (me == 2) then
      real_scal_k8 = co_real_scal_k4[1]
      print *, real_scal_k8
      if (abs(co_real_scal_k8 - real_scal_k8) > tolerance4to8) &
        call print_and_register( 'get scalar real kind=4 to kind=8 to image 2 failed.')

      real_scal_k4 = co_real_scal_k8[1]
      print *, real_scal_k4
      if (abs(co_real_scal_k4 - real_scal_k4) > tolerance4) &
        call print_and_register( 'get scalar real kind=8 to kind=4 to image 2 failed.')

      real_k8(:) = co_real_k4(:)[1]
      print *, real_k8
      if (any(abs(co_real_k8 - real_k8) > tolerance4to8)) &
        call print_and_register( 'get real kind=4 to kind=8 to image 2 failed.')

      real_k4(:) = co_real_k8(:)[1]

      print *, real_k4
      if (any(abs(co_real_k4 - real_k4) > tolerance4)) call print_and_register( 'get real kind=8 to kind=4 to image 2 failed.')

    end if


    ! Scalar to array replication
    sync all
    if (me == 1) then
      int_k4(:) = co_int_scal_k4[2]
      print *, int_k4
      if (any(co_int_scal_k4 /= int_k4)) call print_and_register( 'get int scal kind=4 to array kind=4 to image 2 failed.')

      int_k1(:) = co_int_scal_k1[2]
      print *, int_k1
      if (any(co_int_scal_k1 /= int_k1)) call print_and_register( 'get int scal kind=1 to array kind=1 to image 2 failed.')

    else if (me == 2) then
      real_k8(:) = co_real_scal_k8[1]
      print *, real_k8
      if (any(abs(co_real_scal_k8 - real_k8) > tolerance8)) &
        call print_and_register( 'get real kind=8 to array kind=8 to image 2 failed.')

      real_k4(:) = co_real_scal_k4[1]
      print *, real_k4
      if (any(abs(co_real_scal_k4 - real_k4) > tolerance4)) &
        call print_and_register( 'get real kind=4 to array kind=4 to image 2 failed.')
    end if

    ! and with kind conversion
    sync all
    if (me == 1) then
      int_k4(:) = co_int_scal_k1[2]
      print *, int_k4
      if (any(co_int_scal_k4 /= int_k4)) call print_and_register( 'get int scal kind=1 to array kind=4 to image 2 failed.')

      int_k1(:) = co_int_scal_k4[2]
      print *, int_k1
      if (any(co_int_scal_k1 /= int_k1)) call print_and_register( 'get int scal kind=4 to array kind=1 to image 2 failed.')

    else if (me == 2) then
      real_k8(:) = co_real_scal_k4[1]
      print *, real_k8
      if (any(abs(co_real_scal_k8 - real_k8) > tolerance8)) &
        call print_and_register( 'get real kind=4 to array kind=8 to image 2 failed.')

      real_k4(:) = co_real_scal_k8[1]
      print *, real_k4
      if (any(abs(co_real_scal_k4 - real_k4) > tolerance4)) &
        call print_and_register( 'get real kind=8 to array kind=4 to image 2 failed.')
    end if


    ! and with type conversion
    sync all
    if (me == 1) then
      int_k4(:) = co_real_scal_k4[2]
      print *, int_k4
      if (any(int_k4 /= INT(co_real_scal_k4, 4))) &
        call print_and_register( 'get real scal kind=4 to int array kind=4 to image 2 failed.')

      int_k1(:) = co_real_scal_k4[2]
      print *, int_k1
      if (any(int_k1 /= INT(co_real_scal_k4, 1))) &
        call print_and_register( 'get real scal kind=1 to int array kind=1 to image 2 failed.')

    else if (me == 2) then
      real_k8(:) = co_int_scal_k4[1]
      print *, real_k8
      if (any(abs(real_k8 - co_int_scal_k4) > tolerance4to8)) &
        call print_and_register( 'get int kind=4 to real array kind=8 to image 2 failed.')

      real_k4(:) = co_int_scal_k4[1]
      print *, real_k4
      if (any(abs(real_k4 - co_int_scal_k4) > tolerance4)) &
        call print_and_register( 'get int kind=4 to real array kind=4 to image 2 failed.')
    end if

    sync all

    ! Now with strides

    ! Get from other image now.
    sync all
    int_k4 = -1
    int_k1 = INT(-1, 1)
    real_k8 = -1.0
    real_k4 = REAL(-1.0, 4)
    sync all
    if (me == 1) then
      int_k4(1:3) = co_int_k4(::2)[2]
      print *, int_k4
      if (any(int_k4 /= [co_int_k4(1), co_int_k4(3), co_int_k4(5), -1, -1])) &
        & call print_and_register( 'strided send int kind=4 to kind=4 to image 2 failed.')

      int_k1(3:5) = co_int_k1(::2)[2]
      print *, int_k1
      if (any(int_k1 /= [INT(-1, 1), INT(-1, 1), co_int_k1(1), co_int_k1(3), co_int_k1(5)])) &
        & call print_and_register( 'strided send int kind=1 to kind=1 to image 2 failed.')

      real_k8(1:3) = co_real_k8(::2)[2]
      print *, real_k8
      if (any(abs(real_k8 - [co_real_k8(1), co_real_k8(3), co_real_k8(5), REAL(-1.0, 8), REAL(-1.0, 8)]) > tolerance8)) &
        & call print_and_register( 'strided send real kind=8 to kind=8 to image 2 failed.')

      real_k4(3:5) = co_real_k4(::2)[2]
      print *, real_k4
      if (any(abs(real_k4 - [-1.0, -1.0, co_real_k4(1), co_real_k4(3), co_real_k4(5)]) > tolerance4)) &
        & call print_and_register( 'strided send real kind=4 to kind=4 to image 2 failed.')
    end if

    ! now with strides and kind conversion
    sync all
    int_k4 = -1
    int_k1 = -1
    real_k4 = -1.0
    real_k8 = -1.0
    co_int_k4 = [105, 104, 103, 102, 101]
    co_int_k1 = INT([15, 14, 13, 12, 11], 1)
    co_real_k8 = [5.1, 4.2, 3.3, 2.4, 1.5]
    co_real_k4 = REAL([-5.1, -4.2, -3.3, -2.4, -1.5], 4)
    sync all
    if (me == 1) then
      int_k4(1:3) = co_int_k1(::2)[2]
      print *, int_k4
      if (any(int_k4 /= [15, 13, 11, -1, -1])) call print_and_register( 'strided get int kind=1 to kind=4 to image 2 failed.')

      int_k1(1:3) = co_int_k4(::2)[2]
      print *, int_k1
      if (any(int_k1 /= INT([105, 103, 101, -1, -1], 1))) &
        & call print_and_register( 'strided get int kind=4 to kind=1 to image 2 failed.')

      real_k8(1:3) = co_real_k4(::2)[2]
      print *, real_k8
      if (any(abs(real_k8 - [-5.1, -3.3, -1.5, -1.0, -1.0]) > tolerance8)) &
        & call print_and_register( 'strided get real kind=4 to kind=8 to image 2 failed.')

      real_k4(1:3) = co_real_k8(::2)[2]
      print *, real_k4
      if (any(abs(real_k4 - REAL([5.1, 3.3, 1.5, -1.0, -1.0], 4)) > tolerance4)) &
        & call print_and_register( 'strided get real kind=8 to kind=4 to image 2 failed.')

    else if (me == 2) then
      ! now with strides and type conversion
      int_k4(1:3) = co_real_k8(::2)[2]
      print *, int_k4
      if (any(int_k4 /= [5, 3, 1, -1, -1])) call print_and_register( 'strided get real kind=4 to int kind=4 to image 2 failed.')

      int_k1(1:3) = co_real_k4(::2)[2]
      print *, int_k1
      if (any(int_k1 /= INT([-5, -3, -1, -1, -1], 1))) &
        & call print_and_register( 'strided get real kind=4 to int kind=1 to image 2 failed.')

      real_k8(1:3) = co_int_k4(::2)[2]
      print *, real_k8
      if (any(abs(real_k8 - [105.0, 103.0, 101.0, -1.0, -1.0]) > tolerance8)) &
        & call print_and_register( 'strided get int kind=4 to real kind=8 to image 2 failed.')

      real_k4(1:3) = co_int_k1(::2)[2]
      print *, real_k4
      if (any(abs(real_k4 - [15.0, 13.0, 11.0, -1.0, -1.0]) > tolerance4)) &
        & call print_and_register( 'strided get int kind=1 to real kind=4 to image 2 failed.')
    end if

    select case(me)
      case(1)
        if (error_printed) error stop
        sync images(2)
        print *, "Test passed."
      case(2)
        if (error_printed) error stop
        sync images(1)
    end select

  end associate

contains

  subroutine print_and_register(error_message)
    use iso_fortran_env, only : error_unit
    character(len=*), intent(in) :: error_message
    write(error_unit,*) error_message
    error_printed=.true.
  end subroutine

end program get_convert_nums

! vim:ts=2:sts=2:sw=2:

! MPI 1D Burgers equation solver test: mpi_module
!
! Copyright (c) 2012-2014, Sourcery, Inc.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of the Sourcery, Inc., nor the
!       names of its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE FOR ANY
! DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS

module mpi_module
!declare what other modules are being used
use kind_parameters, only: rkind, ikind
use object_interface, only : object
use ForTrilinos_assertion_utility, only : assert,error_message
use shared

implicit none
!everything in this module aside from mpi_class is private
private
public ::mpi_class
integer(ikind) :: program_status=0 !integer for keeping track of whether mpi has

!started or not
!extend object class so can make use of assertions
type, extends(object) :: mpi_class

contains
procedure :: output !mandatory extension of object
procedure, nopass :: mpi_begin ! initiate mpi
procedure, nopass :: mpi_end ! end mpi
procedure, nopass :: barrier
procedure, nopass :: oned_message !communicate with neighboors for a 1d pde
end type

contains

  subroutine output(this,unit,iotype,v_list,iostat,iomsg)
    class(mpi_class), intent(in) :: this
    integer, intent(in) :: unit ! Unit on which output happens (negative for internal file)
    character(*), intent(in) :: iotype ! Allowable values: ’LISTDIRECTED’,’NAMELIST’, or ’DT’
    integer, intent(in) :: v_list(:)
    integer, intent(out) :: iostat
    character(*), intent(inout) :: iomsg
    integer(ikind) i
    ! Requires
    call assert(this%user_defined(),error_message("mpi_object%output recieved unitialized object."))
      write (unit=unit,iostat=iostat,fmt="(i8,3(f12.4,2x))")
   end subroutine

  subroutine mpi_begin
  integer :: dims(1), periods(1), reorder
   if (program_status .eq. 0) then !prevent accidentally starting mpi when
   !already has been initiated
    call MPI_INIT(ierr) !initiate MPI
    call MPI_COMM_SIZE(MPI_COMM_WORLD, num_procs, ierr) !retrieve processer count
    call MPI_COMM_RANK(MPI_COMM_WORLD, my_id, ierr) !retrive processor rank
    dims = num_procs
    reorder = 1
    periods = 1
    call MPI_CART_CREATE(MPI_COMM_WORLD, 1, dims, periods, reorder, MPI_COMM_CART, ierr)
    call MPI_COMM_RANK(MPI_COMM_CART, my_id, ierr)
    call MPI_CART_SHIFT(MPI_COMM_CART, 0, 1, left_id, right_id, ierr)
    program_status=1
   endif
  end subroutine

  subroutine mpi_end
    if(program_status==1) then !prevent ending mpi if it is not running
     call MPI_FINALIZE(ierr)
     program_status=0
     endif
  end subroutine

  subroutine barrier
    call mpi_barrier(mpi_comm_world, ierr)
  end subroutine

  subroutine oned_message(periodic,local_grid_resolution,left_sub,right_sub)
  integer (ikind), intent(in)  :: local_grid_resolution
  real (rkind), intent(in), dimension(:) :: periodic ! keep track of global f
  real (rkind), intent(inout) ::left_sub,right_sub !images from nearby processors
  DOUBLE PRECISION left,right  !intermediate variable for storing messages
  !  assertions to ensure that proper input provided to subroutine
    call assert(size(periodic)>= local_grid_resolution,error_message("size of local function too small."))
    call assert(local_grid_resolution>0,error_message("invalid local grid spacing."))

    if (num_procs >1) then !no need to communicate if only 1 processor
      call MPI_SENDRECV(periodic(1),1,MPI_DOUBLE_PRECISION,left_id,0, &
                      right,1,MPI_DOUBLE_PRECISION,right_id,0,MPI_COMM_CART,status,ierr)
      call MPI_SENDRECV(periodic(local_grid_resolution),1,MPI_DOUBLE_PRECISION,right_id,0, &
                      left,1,MPI_DOUBLE_PRECISION,left_id,0,MPI_COMM_CART,status,ierr)
      left_sub = left
      right_sub = right
    else!incase only one processor
      left_sub = periodic(local_grid_resolution)
      right_sub = periodic(1)
    endif

end subroutine

end module

! BSD 3-Clause License
!
! Copyright (c) 2018-2019, Sourcery Institute
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
program main
  !! summary: Test team_number intrinsic function
  use iso_fortran_env, only : team_type
  use iso_c_binding, only : c_loc
  use oc_assertions_interface, only : assert

  implicit none

  integer, parameter :: standard_initial_value=-1

  type(team_type) :: parent, child

  if (num_images() < 8) error stop "I need at least 8 images to function."

  call assert(team_number()==standard_initial_value,"initial team number conforms with Fortran standard before 'change team'")

 !call assert(
 !  team_number(c_loc(home))==standard_initial_value,"initial team number conforms with Fortran standard before 'change team'"
 !)
   !! TODO: uncomment the above assertion after implementing support for team_number's optional argument:

  after_change_team: block
    associate(parent_team_number => 100 + (num_images()-1)/4, child_team_number => 1000 + mod(num_images()-1,4)/2)
      !! Prepare for forming two teams: my_team = 1 for even image numbers in the initial team; 2 for odd image numbers
      form team(parent_team_number,parent)
      change team(parent)
        call assert(team_number()==parent_team_number,"team number conforms with Fortran standard after 'change team'")
        form team (child_team_number, child)
        change team(child)
          call assert(team_number()==child_team_number,"team number conforms with Fortran standard after 'change team'")
          call assert(team_number(child)==child_team_number,"team_number(child) conforms with Fortran standard after 'change team'")
          call assert(team_number(parent)==parent_team_number,"team_number(parent) conforms with Fortran standard")
        end team
      end team
      call assert(team_number()==standard_initial_value,"initial team number conforms with Fortran standard")
    end associate
  end block after_change_team

  sync all
  if (this_image()==1) print *,"Test passed."

end program

program main
  !! author: Damian Rouson
  !!
  !! Test co_broadcast with derived-type actual arguments
  implicit none

  integer, parameter :: sender=1 !! co_broadcast source_image
  character(len=*), parameter :: text="text" !! character message data

  type dynamic
    character(len=:), allocatable :: string
    character(len=len(text)), allocatable :: string_array(:)
    complex, allocatable :: scalar
    integer, allocatable :: vector(:)
    logical, allocatable :: matrix(:,:)
    real, allocatable ::  superstring(:,:,:, :,:,:, :,:,:, :,:,:, :,:,: )
  end type

  type(dynamic) alloc_message, alloc_content

  associate(me=>this_image())

    alloc_content = dynamic(                                               &
      string=text,                                                         &
      string_array=[text],                                                 &
      scalar=(0.,1.),                                                      &
      vector=reshape( [integer::], [0]),                                   &
      matrix=reshape( [.true.], [1,1]),                                    &
      superstring=reshape([1,2,3,4], [2,1,2, 1,1,1, 1,1,1, 1,1,1, 1,1,1 ]) &
      )

    alloc_message = alloc_content

    if(me /= sender) then
       alloc_message%vector = 0
       alloc_message%matrix = .false.
       alloc_message%superstring = 0
    endif

    sync all

   call co_broadcast(alloc_message,source_image=sender)

   associate( failures => [                                    &
     alloc_message%string /= alloc_content%string,             &
     alloc_message%string_array /= alloc_content%string_array, &
     alloc_message%scalar /= alloc_content%scalar,             &
     alloc_message%vector /= alloc_content%vector,             &
     alloc_message%matrix .neqv. alloc_content%matrix,         &
     alloc_message%superstring /= alloc_content%superstring    &
   ] )

      if ( any(failures) ) error stop "Test failed."

    end associate

    sync all  ! Wait for each image to pass the test
    if (me==sender) print *,"Test passed."

  end associate

end program main

! Coarray "Hello, world!" test program
!
! Copyright (c) 2012-2014, Sourcery, Inc.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of the Sourcery, Inc., nor the
!       names of its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE FOR ANY
! DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

! Robodoc header:
!****e* tests/coarrayHelloWorld/hello_multiverse.F90
! NAME
!   hello_multiverse
! SYNOPSIS
!   Demonstrate coarray communication via a scalar character coarray.
! INPUTS
!   None.
! OUTPUTS
!   Test pass or failure.
!******

program hello_multiverse
  implicit none
  integer, parameter :: MAX_STRING=100
  character(len=MAX_STRING) :: greeting[*] ! Scalar coarray
  integer image
  write(greeting,"(2(a,i2))") "Greetings from image ",this_image()," of ",num_images()
  sync all ! Barrier
  if (this_image()==1) then
    do concurrent (image=1:num_images())
      print *,greeting[image]
    end do
    block
      integer, parameter :: expected_location=23,max_single_digit=9
      do image=2,min(num_images(),max_single_digit)
        ! Verify that the greetings of images 1-9 have their image number at the expected location:
        if (scan(greeting[image],set="123456789")/=expected_location) error stop "Test failed."
      end do
    end block
    print *,"Test passed."
  end if
end program

! Copyright (c) 2012-2016, Sourcery, Inc.
! All rights reserved.
!
! Unit tests for co_min: verify parallel, collective minimum
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of Sourcery, Inc., nor the
!       names of any other contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

module co_intrinsics_module
#ifdef USE_EXTENSIONS
  use opencoarrays
#endif
  implicit none

  private
  public :: co_all
  public :: co_product

  interface co_all
    module procedure co_all_logical
  end interface

  interface co_product
    module procedure co_product_c_int,co_product_c_double
  end interface

contains

  subroutine co_all_logical(a)
    logical, intent(inout) :: a(:)
    call co_reduce(a,and)
  contains
    pure function and(lhs,rhs) result(lhs_and_rhs) bind(C,name="and")
      logical, intent(in) :: lhs,rhs
      logical :: lhs_and_rhs
      lhs_and_rhs = lhs .and. rhs
    end function
  end subroutine

  subroutine co_product_c_int(a)
    use iso_c_binding, only : c_int
    integer(c_int), intent(inout) :: a
    call co_reduce(a,product_)
  contains
    pure function product_(lhs,rhs) result(lhs_x_rhs) bind(C,name="product_")
      integer(c_int), intent(in) :: lhs,rhs
      integer(c_int) :: lhs_x_rhs
      lhs_x_rhs = lhs * rhs
    end function
  end subroutine

  subroutine co_product_c_double(a)
    use iso_c_binding, only : c_double
    real(c_double), intent(inout) :: a
    call co_reduce(a,product_)
  contains
    pure function product_(lhs,rhs) result(lhs_x_rhs)
      real(c_double), intent(in) :: lhs,rhs
      real(c_double) :: lhs_x_rhs
      lhs_x_rhs = lhs * rhs
    end function
  end subroutine

end module

program main
  use iso_fortran_env, only : error_unit
  use iso_c_binding, only : c_int,c_double
  use co_intrinsics_module, only : co_all,co_product
#ifdef USE_EXTENSIONS
  use opencoarrays
#endif
  implicit none
  logical :: logical_passes=.false.,c_int_passes=.false.

#ifdef USE_EXTENSIONS
  if (this_image()==1) print *,"Using the extensions from the opencoarrays module."
#endif

  ! Verify that every image has a "true" variable with the value .true.
  verify_co_reduce_logical: block
    logical,dimension(10) :: true=.true.
    sync all
    call co_all(true)
    if (all(true .eqv. .true.)) then
      logical_passes=.true.
    else
      write(error_unit,"(2(a,i2))") "co_reduce fails for logical argument with result (",true,") on image",this_image()
    end if
  end block verify_co_reduce_logical

  ! Verify the product of image number
  verify_co_reduce_c_int: block
    integer(c_int) :: me,i
    me=this_image()
    sync all
    call co_product(me)
    if (me==product(int([(i,i=1,num_images())],c_int))) then
      c_int_passes=.true.
    else
      write(error_unit,"(2(a,i2))") "co_reduce fails integer(c_int) argument with result (",me,") on image",this_image()
    end if
  end block verify_co_reduce_c_int

  ! Verify that this image's tests passed
  if (.not.all([logical_passes,c_int_passes])) error stop

  ! Wait for verification that all images to pass the tests
  sync all
  if (this_image()==1) print *, "Test passed."
end program

program main
  use iso_fortran_env, only : real64,int64,compiler_version,compiler_options
  use ieee_arithmetic, only : ieee_is_nan
  use global_field_module, only : global_field,initial_condition
  use ForTrilinos_assertion_utility, only : assert,error_message
  implicit none
  type(global_field) :: u,u_half,half_uu
  real(real64), parameter :: nu=1.,final_time=0.6_real64,tolerance=1.E-3_real64,safety_factor=0.1_real64
  real(real64) :: time=0.,dt,dx
  integer, parameter :: nodes=16
  procedure(initial_condition), pointer :: initial_u=>null()

  initial_u => ten_sin

#ifdef TAU
  call TAU_PROFILE_SET_NODE(this_image()-1) ! Start TAU (Cray or GNU compiler)
#else
#ifdef TAU_INTEL
  call TAU_PROFILE_SET_NODE(this_image())   ! Start TAU (Intel compiler)
#endif
#endif

  call u%set(initial_u,num_points=nodes)
  dx = u%grid_spacing()
  dt = safety_factor*diffusion_stability_limit(nu,dx,order_of_accuracy=2)
  do while(time<final_time)
    half_uu = 0.5_real64*(u*u)
    u_half = u + (dt/2._real64)*(nu*u%xx() - half_uu%x())
    half_uu = 0.5_real64*(u_half*u_half)
    u      = u + dt*(nu*u_half%xx() - half_uu%x())
    time = time + dt
  end do
  if (this_image()==1) print *,"Time =",time
  print *,"On image ",this_image(),"u =",u%state()
  call test(u)
  sync all
  if (this_image()==1) print *,"Test passed."

contains
  subroutine test(burgers_solution)
    type(global_field), intent(in) :: burgers_solution
    call assert(.not.any(ieee_is_nan(u%state())),error_message("Test failed: u is not a number."))
    call assert(sinusoid(u),error_message("Test failed: improper shape."))
  end subroutine

  function sinusoid(u_solution) result(is_sinusoid)
    type(global_field), intent(in) :: u_solution
    type(global_field) :: u_xx
    logical :: is_sinusoid
    real(real64), parameter :: threshold=-0.001,cap=0.001
    real(real64), allocatable :: u_xx_state(:)
    u_xx = u_solution%xx()
    u_xx_state = u_xx%state()
    if (num_images()/=1) then
      ! Ensure that the global midpoint is a local endpoint for whatever image contains the midpoint:
      call assert(mod(num_images(),2)==0,error_message("Test failed: uneven number of images."))
      ! Ensure that the left and right halves of the solution are concave down and up, respectively:
      if (this_image()<=num_images()/2) then
        call assert(all(u_xx_state<cap),error_message("Test failed: right half not concave up."))
      else
        call assert(all(u_xx_state>threshold),error_message("Test failed: left half not concave down."))
      end if
    else
      block
        integer :: size_u_xx
        size_u_xx = size(u_xx_state)
        call assert(all(u_xx_state(1:size_u_xx/2)<cap),error_message("Test failed: left half not concave down."))
        call assert(all(u_xx_state(size_u_xx/2+1:size_u_xx)>threshold),error_message("Test failed: right half not concave up."))
      end block
    end if
    is_sinusoid=.true.
  end function

  pure function diffusion_stability_limit(diffusivity,delta_x,order_of_accuracy)  result(stable_time_step)
    real(real64), intent(in) :: diffusivity,delta_x
    integer, intent(in) :: order_of_accuracy
    real(real64) :: stable_time_step
    real(real64), parameter, dimension(*) :: stability_limit=[2.,2.,2.5,2.79] ! third value needs to be checked
    ! See Moin, P. (2010) Fundamentals of Engineering Numerical Analysis, 2nd ed., pp. 111-116.
    stable_time_step = safety_factor*stability_limit(order_of_accuracy)*(delta_x**2)/(4._real64*diffusivity)
  end function

  pure function ten_sin(x) result(ten_sin_x)
    real(real64), intent(in) :: x
    real(real64) :: ten_sin_x
    ten_sin_x = 10._real64*sin(x)
  end function
end program

#ifndef USE_ASSERTIONS
# define USE_ASSERTIONS .false.
#endif
module oc_assertions_interface
  !! author: Damian Rouson
  !!
  !! Utility for runtime checking of logical assertions.
  !!
  !! Instructions
  !! ------------
  !! Compile with -DUSE_ASSERTIONS=.false. to define the logical parameter named "assertions" and to thereby
  !! facilitate the elimination of assertions during the dead-code removal phase of optimizing compilers:
  !!
  !!    gfortran -cpp -DUSE_ASSERTIONS=.false. -c assertions_interface.f90
  !!
  !! or set the corresponding NO_ASSERTIONS variable defined in this directory's CMakeLists.txt:
  !!
  !!    FC=caf cmake <opencoarrays-source-path> -DNO_ASSERTIONS=ON
  !!
  !! Conditioning assertion calls on the "assertions" compile-time constant enables optimizing compilers
  !! to eliminate assertion calls via dead-code-removal optimiztion.
  !!
  !! Use case 1
  !! ----------
  !!    Pass the optional success argument & check for false return value as an indication of assertion failure:
  !!
  !!    use opencoarrays_assertions_interface, only : assert, assertions
  !!    if (assertions) call assert( 2 > 1, "always true inequality", success)
  !!    if (error_code/=0) call my_error_handler()
  !!
  !! Use case 2
  !! ----------
  !!    Error-terminate if the assertion fails:
  !!
  !!    use opencoarrays_assertions_interface, only : assert,assertions
  !!    if (assertions) call assert( 2 > 1, "always true inequality")
  !!
  implicit none
  private
  public :: assert
  public :: assertions

  logical, parameter :: assertions=USE_ASSERTIONS

  interface
#ifdef HAVE_ERROR_STOP_IN_PURE
    pure &
#endif
    module subroutine assert(assertion,description,diagnostic_data,success,error_message)
      !! On false assertion, error-terminate or, if present(success), copy assertion into success
      implicit none
      logical, intent(in) :: assertion
        !! Most assertions will be expressions, e.g., call assert( i>0, "positive i")
      character(len=*), intent(in) :: description
        !! Brief statement of what is being asserted
      class(*), intent(in), optional :: diagnostic_data
        !! Optional data to printed or added to error_message assertion evaluates to .false.
      logical, intent(out), optional :: success
        !! Optional copy of the assertion dummy argument
      character(len=:), intent(out), optional, allocatable :: error_message
        !! Optional informational message allocated only if assertion==.false. .and. present(success)
    end subroutine
  end interface
end module oc_assertions_interface

! Unit test for register and allocated procedure.
!
! Test that matrix valued allocatable components in a derived typed coarray is
! registered correctly, delayed allocatable and deregisterable. The checks
! whether a component is allocated are done on this_image only.
!
! Copyright (c) 2012-2016, Sourcery, Inc.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of the Sourcery, Inc., nor the
!       names of its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE FOR ANY
! DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

program register_alloc_comp_3
  implicit none

  type dt
    integer, allocatable, dimension(:,:) :: m
  end type dt

  integer :: np = -2
  type(dt), allocatable :: obj[:]

  np = num_images()

  ! Allocate only the container. obj%i must not be allocated hereafter.
  allocate(obj[*])
  if (.not. allocated(obj)) error stop "Test failed. 'obj' not allocated."
  if (allocated(obj%m)) error stop "Test failed. 'obj%m' is allocated."
 
  ! Allocate the component.
  allocate(obj%m(3,6), source=this_image())

  ! Now both objects have to be allocated and obj%m(1:3,1:6) set to this_image()
  if (.not. allocated(obj)) error stop "Test failed. 'obj' not allocated."
  if (.not. allocated(obj%m)) error stop "Test failed. 'obj%m' not allocated."
  if (any( ubound(obj%m) /= [3, 6])) error stop "Test failed. ubound(obj%m) /= [3, 6]."
  if (any (obj%m(:,:) /= this_image())) error stop "Test failed. obj%m(:) /= this_image()."

  ! Deallocate the component.
  deallocate(obj%m)

  ! and test, that only the component is deallocated, but not the container.
  if (allocated(obj%m)) error stop "Test failed. 'obj%m' still allocated."
  if (.not. allocated(obj)) error stop "Test failed. 'obj' no longer allocated."

  ! Now deallocate the container, too.
  deallocate(obj)

  ! and check, that it worked.
  if (allocated(obj)) error stop "Test failed. 'obj' still allocated."

  ! Failing tests would make whole program error out.  Therefore it is save
  ! to print the pass message on image one, only.
  if (this_image() == 1) print *, "Test passed."
end program

!
! This program does a correctness check for
! ... = ARRAY[idx] and ... = SCALAR[idx]
!
program main
  implicit none
  integer, parameter :: n = 3
  integer, parameter :: m = 4

  logical :: error_printed=.false.

  ! Allocatable coarrays
  call one(-5, 1)
  call one(0, 0)
  call one(1, -5)
  call one(0, -11)

  ! Static coarrays
  call two()
  call three()

  if (error_printed)  error stop
  sync all

  if (this_image()==1) print *,'Test passed.'
contains
  subroutine one(lb1, lb2)
    integer, value :: lb1, lb2

    integer :: i_sgn1, i_sgn2, i, i_e, i_s, j, j_e, j_s
    integer, allocatable :: caf(:,:)[:]
    integer, allocatable :: a(:,:), b(:,:), c(:,:)

    allocate(caf(lb1:n+lb1-1, lb2:m+lb2-1)[*], &
         a(lb1:n+lb1-1, lb2:m+lb2-1), &
         b(lb1:n+lb1-1, lb2:m+lb2-1), &
         c(lb1:n+lb1-1, lb2:m+lb2-1))

    b = reshape([(i*33, i = 1, size(b))], shape(b))

    ! Whole array: ARRAY = SCALAR
    a = b
    caf = -42
    c = caf
    sync all
    if(this_image() == 1) then
       a(:,:) = caf(lb1,lb2)[num_images()]
    end if
    sync all
    if(this_image()==1) then
       if(any (a /= c)) call print_and_register( "ARRAY = SCALAR failed in get_array_test")
    endif

    ! Whole array: ARRAY = ARRAY
    caf = -42
    a = b
    c = caf
    if (this_image() == 1) then
       a(:,:) = caf(:,:)[num_images()]
    endif
    sync all
    if(this_image()==1) then
       if (any (a /= c)) then
          print *, 'RES 1:', any (a /= c)
          print *, a
          print *, c
          ! FIXME: Without the print lines above, it always fails. Why?
          call print_and_register( "ARRAY = ARRAY failed in get_array_test")
       end if
    endif

    ! Scalar assignment
    a = -42
    caf = -42
    c = caf
    sync all
    do j = lb2, m+lb2-1
       do i = n+lb1-1, lb1, -2
          a(i,j) = b(i,j)
       end do
    end do
    do j = lb2, m+lb2-1
       do i = lb1, n+lb1-1, 2
          a(i,j) = b(i,j)
       end do
    end do
    sync all
    if(this_image() == 1) then
       do j = lb2, m+lb2-1
          do i = n+lb1-1, lb1, -2
             a(i,j) = caf(i,j)[num_images()]
          end do
       end do
       do j = lb2, m+lb2-1
          do i = lb1, n+lb1-1, 2
             a(i,j) = caf(i,j)[num_images()]
          end do
       end do
    endif
    sync all
    if(this_image() == 1) then
       if (any (a /= c)) then
          print *, 'RES 2:', any (a /= c)
          print *, this_image(), ': ', a
          print *, this_image(), ': ', c
          ! FIXME: Without the print lines above, it always fails. Why?
          call print_and_register( "scalar assignment failed in get_array_test")
       end if
    endif
    ! Array sections with different ranges and pos/neg strides
    do i_sgn1 = -1, 1, 2
       do i_sgn2 = -1, 1, 2
          do i=lb1, n+lb1-1
             do i_e=lb1, n+lb1-1
                do i_s=1, n
                   do j=lb2, m+lb2-1
                      do j_e=lb2, m+lb2-1
                         do j_s=1, m
                            ! ARRAY = SCALAR
                            a = -42
                            caf = -42
                            c = a
                            a(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2) = b(lb1, lb2)
                            sync all
                            if (this_image() == 1) then
                               a(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2) = caf(lb1,lb2)[num_images()]
                            end if
                            sync all
                            if (this_image() == 1) then
                               if (any (a /= c)) then
                                  print '(*(g0))', "bounds: ", lb1,":",n+lb1-1,", ", &
                                       lb2,":",m+lb2-1
                                  print '(*(g0))', "section: ", i,":",i_e,":",i_s*i_sgn1, &
                                       ", ", j,":",j_e,":",j_s*i_sgn2
                                  print *, i
                                  print *, a
                                  print *, c
                                  print *, a-c
                                  call print_and_register( "array sections with ranges and strides failed in get_array_test")
                               endif
                            end if
                            ! ARRAY = ARRAY
                            caf = -42
                            a = -42
                            c = a
                            a(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2) &
                                 = b(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2)
                            sync all
                            if (this_image() == 1) then
                               a(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2) = caf(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2)[num_images()]
                            end if
                            sync all

                            if (this_image() == 1) then
                               if (any (a /= c)) then
                                  print '(*(g0))', "bounds: ", lb1,":",n+lb1-1,", ", &
                                       lb2,":",m+lb2-1
                                  print '(*(g0))', "section: ", i,":",i_e,":",i_s*i_sgn1, &
                                       ", ", j,":",j_e,":",j_s*i_sgn2
                                  print *, i
                                  print *, a
                                  print *, c
                                  print *, a-c
                                  call print_and_register( "array sections with ranges and strides failed in get_array_test")
                               endif
                            end if
                         end do
                      end do
                   end do
                end do
             end do
          end do
       end do
    end do
  end subroutine one

  subroutine two()
    integer, parameter :: lb1 = -5, lb2 = 1

    integer :: i_sgn1, i_sgn2, i, i_e, i_s, j, j_e, j_s
    integer, save :: caf(lb1:n+lb1-1, lb2:m+lb2-1)[*]
    integer, save :: a(lb1:n+lb1-1, lb2:m+lb2-1)
    integer, save :: b(lb1:n+lb1-1, lb2:m+lb2-1)

    b = reshape([(i*33, i = 1, size(b))], shape(b))

    ! Whole array: ARRAY = SCALAR
    caf = -42
    a = -42
    a(:,:) = b(lb1, lb2)
    sync all
    if (this_image() == 1) then
      caf(:,:)[num_images()] = b(lb1, lb2)
    end if
    sync all
    if (this_image() == num_images()) then
      if (any (a /= caf)) &
           call print_and_register( "Array = scalar failed in subroutine two get_array_test")
    end if

    ! Whole array: ARRAY = ARRAY
    caf = -42
    a = -42
    a(:,:) = b(:, :)
    sync all
    if (this_image() == 1) then
      caf(:,:)[num_images()] = b(:, :)
    end if
    sync all
    if (this_image() == num_images()) then
      if (any (a /= caf)) &
           call print_and_register( "Array = array failed in subroutine two get_array_test")
    end if

    ! Scalar assignment
    caf = -42
    a = -42
    do j = lb2, m+lb2-1
      do i = n+lb1-1, 1, -2
        a(i,j) = b(i,j)
      end do
    end do
    do j = lb2, m+lb2-1
      do i = 1, n+lb1-1, 2
        a(i,j) = b(i,j)
      end do
    end do
    sync all
    if (this_image() == 1) then
      do j = lb2, m+lb2-1
        do i = n+lb1-1, 1, -2
          caf(i,j)[num_images()] = b(i, j)
        end do
      end do
      do j = lb2, m+lb2-1
        do i = 1, n+lb1-1, 2
          caf(i,j)[num_images()] = b(i, j)
        end do
      end do
    end if
    sync all
    if (this_image() == num_images()) then
      if (any (a /= caf)) &
           call print_and_register( "scalar assignment failed in subroutine two get_array_test")
    end if

    ! Array sections with different ranges and pos/neg strides
    do i_sgn1 = -1, 1, 2
      do i_sgn2 = -1, 1, 2
        do i=lb1, n+lb1-1
          do i_e=lb1, n+lb1-1
            do i_s=1, n
              do j=lb2, m+lb2-1
                do j_e=lb2, m+lb2-1
                  do j_s=1, m
                    ! ARRAY = SCALAR
                    caf = -42
                    a = -42
                    a(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2) = b(lb1, lb2)
                    sync all
                    if (this_image() == 1) then
                      caf(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2)[num_images()] &
                           = b(lb1, lb2)
                    end if
                    sync all

                    ! ARRAY = ARRAY
                    caf = -42
                    a = -42
                    a(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2) &
                         = b(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2)
                    sync all
                    if (this_image() == 1) then
                      caf(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2)[num_images()] &
                           = b(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2)
                    end if
                    sync all

                    if (this_image() == num_images()) then
                      if (any (a /= caf)) then
                        print '(*(g0))', "bounds: ", lb1,":",n+lb1-1,", ", &
                             lb2,":",m+lb2-1
                        print '(*(g0))', "section: ", i,":",i_e,":",i_s*i_sgn1, &
                             ", ", j,":",j_e,":",j_s*i_sgn2
                        print *, i
                        print *, a
                        print *, caf
                        print *, a-caf
                        call print_and_register( "arrays with ranges and strides failed sub. two get_array_test failed")
                      endif
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      end do
    end do
  end subroutine two

  subroutine three()
    integer, parameter :: lb1 = 0, lb2 = 0

    integer :: i_sgn1, i_sgn2, i, i_e, i_s, j, j_e, j_s
    integer, save :: caf(lb1:n+lb1-1, lb2:m+lb2-1)[*]
    integer, save :: a(lb1:n+lb1-1, lb2:m+lb2-1)
    integer, save :: b(lb1:n+lb1-1, lb2:m+lb2-1)

    b = reshape([(i*33, i = 1, size(b))], shape(b))

    ! Whole array: ARRAY = SCALAR
    caf = -42
    a = -42
    a(:,:) = b(lb1, lb2)
    sync all
    if (this_image() == 1) then
      caf(:,:)[num_images()] = b(lb1, lb2)
    end if
    sync all
    if (this_image() == num_images()) then
      if (any (a /= caf)) &
           call print_and_register( "Array = scalar subroutine three get_array_test failed")
    end if

    ! Whole array: ARRAY = ARRAY
    caf = -42
    a = -42
    a(:,:) = b(:, :)
    sync all
    if (this_image() == 1) then
      caf(:,:)[num_images()] = b(:, :)
    end if
    sync all
    if (this_image() == num_images()) then
      if (any (a /= caf)) &
           call print_and_register( "Array = array subroutine three get_array_test failed")
    end if

    ! Scalar assignment
    caf = -42
    a = -42
    do j = lb2, m+lb2-1
      do i = n+lb1-1, 1, -2
        a(i,j) = b(i,j)
      end do
    end do
    do j = lb2, m+lb2-1
      do i = 1, n+lb1-1, 2
        a(i,j) = b(i,j)
      end do
    end do
    sync all
    if (this_image() == 1) then
      do j = lb2, m+lb2-1
        do i = n+lb1-1, 1, -2
          caf(i,j)[num_images()] = b(i, j)
        end do
      end do
      do j = lb2, m+lb2-1
        do i = 1, n+lb1-1, 2
          caf(i,j)[num_images()] = b(i, j)
        end do
      end do
    end if
    sync all
    if (this_image() == num_images()) then
      if (any (a /= caf)) &
           call print_and_register( "scalar assignment subroutine three get_array_test failed")
    end if

    ! Array sections with different ranges and pos/neg strides
    do i_sgn1 = -1, 1, 2
      do i_sgn2 = -1, 1, 2
        do i=lb1, n+lb1-1
          do i_e=lb1, n+lb1-1
            do i_s=1, n
              do j=lb2, m+lb2-1
                do j_e=lb2, m+lb2-1
                  do j_s=1, m
                    ! ARRAY = SCALAR
                    caf = -42
                    a = -42
                    a(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2) = b(lb1, lb2)
                    sync all
                    if (this_image() == 1) then
                      caf(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2)[num_images()] &
                           = b(lb1, lb2)
                    end if
                    sync all

                    ! ARRAY = ARRAY
                    caf = -42
                    a = -42
                    a(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2) &
                         = b(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2)
                    sync all
                    if (this_image() == 1) then
                      caf(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2)[num_images()] &
                           = b(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2)
                    end if
                    sync all

                    if (this_image() == num_images()) then
                      if (any (a /= caf)) then
                        print '(*(g0))', "bounds: ", lb1,":",n+lb1-1,", ", &
                             lb2,":",m+lb2-1
                        print '(*(g0))', "section: ", i,":",i_e,":",i_s*i_sgn1, &
                             ", ", j,":",j_e,":",j_s*i_sgn2
                        print *, i
                        print *, a
                        print *, caf
                        print *, a-caf
                        call print_and_register( "range stride in subroutine three get_array_test failed")
                      endif
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      end do
    end do
  end subroutine three

  subroutine print_and_register(error_message)
    use iso_fortran_env, only : error_unit
    character(len=*), intent(in) :: error_message
    write(error_unit,*) error_message
    error_printed=.true.
  end subroutine

end program main

module object_interface
#include "compiler_capabilities.txt"
  implicit none
  private
  public :: object

  ! Define an abstract parent type to ensure basic functionality expected to be provided by all non-abstract types.
  ! Each non-abstract type provides the functionality by extending this type and implementing its deferred binding(s).  This
  ! type resembles java's Object class in the sense that it is intended to be the ultimate ancester of every other type.
  type, abstract :: object
    private
    logical :: defined=.false. ! Mark all objects as not-yet user-defined by default
  contains
    procedure :: mark_as_defined
    procedure :: user_defined
    procedure(output_interface), deferred :: output
#ifndef COMPILER_LACKS_DERIVED_TYPE_IO
    generic :: write(formatted) => output  ! Derived-type I/O
#endif /* COMPILER_LACKS_DERIVED_TYPE_IO */
  end type

  ! Require child classes to write an "output" procedure that prints to the passed file unit
  abstract interface

    subroutine output_interface(this,unit,iotype,v_list,iostat,iomsg)
      import object
      class(object), intent(in) :: this
      integer, intent(in) :: unit
      character(len=*), intent(in) :: iotype
      integer, intent(in) :: v_list(:)
      integer, intent(out) :: iostat
      character(len=*), intent(inout) :: iomsg
    end subroutine

  end interface

contains

  ! Mark the object as user-defined
  pure subroutine mark_as_defined(this)
    class(object), intent(inout) :: this
    this%defined=.true.
  end subroutine

  ! Return a boolean result indicating whether this object has been initialized since its declaration
  logical pure function user_defined(this)
    class(object), intent(in) :: this
    user_defined = this%defined
  end function

end module

program whole_array_get
  implicit none

  integer,allocatable :: x1(:)[:],y1(:)
  integer,allocatable :: x2(:,:)[:],y2(:,:)
  integer,allocatable :: x3(:,:,:)[:],y3(:,:,:)
  integer,parameter   :: n = 10
  integer :: me,np,i,j,k

  me = this_image()
  np = num_images()

  allocate(x1(n)[*],y1(n))

  x1 = me
  y1 = 0

  sync all

  if(me == 1) then
     y1 = x1(:)[me+1]
     if(any(y1 /= 2)) then
        error stop 'Test 1 fails'
     end if
  end if

  deallocate(x1)
  allocate(x2(1:n,0:n-1)[*],y2(n,n))

  x2 = me
  y1 = 0; y2 = 0

  sync all
  if(me == 1) then
     y2 = x2(:,:)[np]
     if(any(y2 /= np)) then
        error stop 'Test 2 fails'
     end if
  end if

  sync all

  x2(:,n/2) = x2(:,n/2) + n/2

  sync all

  if(me == 1) then
     y1 = x2(:,n/2)[me+1]
     if(any(y1 /= 2+n/2)) then
        error stop 'Test 3 fails'
     end if
  end if

  deallocate(y1,x2,y2)
  allocate(x3(0:n-1,1:n,-1:n-2)[*],y3(n,n,n))

  x3 = me; y3 = 0

  sync all

  if(me == 1) then
     y3 = x3(:,:,:)[me+1]
     if(any(y3 /= me+1)) then
        error stop 'Test 4 fails'
     end if
  endif

  sync all

  x3(:,:,n/2) = me + n/2
  y3 = 0

  sync all

  if(me == 1) then
     y3(:,n/2,:) = x3(:,:,n/2)[me+1]
     if(any(y3(:,n/2,:) /= me+1+n/2)) then
        error stop 'Test 5 fails'
     end if
  endif

  if(me == 1) write(*,*) 'Test passed.'

end program whole_array_get

! Check the status of all images. Error only, when one unexpectedly failed.

program test_image_status_1
  use iso_fortran_env , only : STAT_STOPPED_IMAGE
  implicit none
  integer :: i

  associate(np => num_images(), me => this_image())
    do i= 1, np
      if (image_status(i) /= 0) error stop "image_status(i) should not fail"
    end do

    sync all
    if (me == 1) print *,"Test passed."
  end associate

end program test_image_status_1

program teams_coarray_get_by_ref
  use, intrinsic :: iso_fortran_env, only: team_type
  implicit none
  type(team_type) :: team
  type :: allocatable_array_t
    integer, allocatable :: A(:)
  end type
  type(allocatable_array_t) :: R[*]
  integer :: i, my_team, initial_team_this_image

  ! handle odd or even number of images
  allocate(R%A(num_images()/2+mod(num_images(),2)*mod(this_image(),2)), source=0)

  initial_team_this_image = this_image()
  my_team = mod(this_image()-1,2)+1

  form team (my_team, team)

  change team (team)
    do i = 1, num_images()
       R[i]%A(this_image()) = initial_team_this_image
    end do
  end team

  if (any(R%A /= [(i, i=my_team, num_images(), 2)])) error stop 'Test failed.'

  sync all

  if (this_image() == 1) write(*,*) 'Test passed.'
end program teams_coarray_get_by_ref

program main
   implicit none

   type co_obj ! the test does not fail with pure coarrays, only when using coarrays in derived types
      real, allocatable, dimension(:, :, :) :: a[:], b, c, d, e
   end type

   type(co_obj) :: co
   integer :: me, remote, nimg, i, j, k, ni, nj, nk
   logical :: fail

   me = this_image()
   nimg = num_images()
   remote = merge(2, 1, me == 1)

   if (nimg /= 2) error stop 1

   ni = 2
   nj = 8
   nk = 4
   allocate(co % a(ni, nj, nk)[*])
   allocate(co % b(ni, nj, nk))
   allocate(co % c, co % d, co % e, mold=co % b)
   call random_number(co % b) ! the answer is a random array
   
   sync all
   co % a = co % b

   sync all
   co % c(1, :, :) = co % a(1, :, :)[remote] ! getter

   sync all
   co % e(1, :, :) = dble(111111111111111_8 * me) / 10**8
   co % a(1, :, :) = co % e(1, :, :)

   sync all
   ! singleton on the 1st dimension (delta == 1), triggers the bug

   ! FIXME: NOK, test FAILS
   ! co % a(1, :, :)[remote] = co % b(1, :, :) ! setter, (CAF_ARR_REF_SINGLE, CAF_ARR_REF_FULL, CAF_ARR_REF_FULL)

   ! OK, test pass, with patch
   co % a(1:1, :, :)[remote] = co % b(1:1, :, :) ! setter, (CAF_ARR_REF_RANGE, CAF_ARR_REF_FULL, CAF_ARR_REF_FULL)

   ! OK, test pass, without patch
   ! co % a(:, :, :)[remote] = co % b(:, :, :) ! setter, (CAF_ARR_REF_FULL,) * 3

   sync all
   co % d(1, :, :) = co % a(1, :, :)[remote] ! check

   sync all
   ! sequential flush (more readable)
   if (me == 2) sync images(1)
   write(*, *) ': : (set from remote on myself) : :', me
   do j = 1, nj; write(*, *) co % a(1, j, :); end do
   write(*, *) ': : (neighbor answer) : :', me
   do j = 1, nj; write(*, *) co % c(1, j, :); end do
   write(*, *) ': : (my answer) : :', me
   do j = 1, nj; write(*, *) co % b(1, j, :); end do
   write(*, *) ': : (what I see on remote) : :', me
   do j = 1, nj; write(*, *) co % d(1, j, :); end do
   write(*, *) ': : (initial local coarray) : :', me
   do j = 1, nj; write(*, *) co % e(1, j, :); end do
   write(*, *) ': : : :', me
   if (me == 1) sync images(2)
   
   sync all
   
   fail = any(abs(co % b(1, :, :) - co % d(1, :, :)) > epsilon(0.))
   
   if (fail) then
      write(*, *) 'Test failed!'
      error stop 5
   else
      write(*, *) 'Test passed.'
   end if

end program

!! Thoroughly test send, i.e. foo[N].comp = bar in all variants
!!
!! Do simple tests for send(). These test comprise
!!
!! FOO[N].COMP = BAR
!!
!! where
!!
!!  FOO                BAR              images
!! scalar            scalar            N == me
!!  int(k e [1,4])    int(k e [1,4])
!!  real(k e [4,8])   real(k e [4,8])
!!  int(k e [1,4])    real(k e [4,8])
!!  real(k e [4,8])   int(k e [1,4])
!!
!! array(1:5)        scalar
!!  int(k e [1,4])    int(k e [1,4])
!!  real(k e [4,8])   real(k e [4,8])
!!  int(k e [1,4])    real(k e [4,8])
!!  real(k e [4,8])   int(k e [1,4])
!!
!! array(1:5)        array(1:5)
!!  int(k e [1,4])    int(k e [1,4])
!!  real(k e [4,8])   real(k e [4,8])
!!  int(k e [1,4])    real(k e [4,8])
!!  real(k e [4,8])   int(k e [1,4])
!!
!! array(1:3)       array(::2)
!!  int(k e [1,4])    int(k e [1,4])
!!  real(k e [4,8])   real(k e [4,8])
!!  int(k e [1,4])    real(k e [4,8])
!!  real(k e [4,8])   int(k e [1,4])
!!
!! array(4:5)       array(2::2)
!!  int(k e [1,4])    int(k e [1,4])
!!  real(k e [4,8])   real(k e [4,8])
!!  int(k e [1,4])    real(k e [4,8])
!!  real(k e [4,8])   int(k e [1,4])
!!
!! array(1:3)      array(3:1:-1)
!!  int(k e [1,4])    int(k e [1,4])
!!  real(k e [4,8])   real(k e [4,8])
!!  int(k e [1,4])    real(k e [4,8])
!!  real(k e [4,8])   int(k e [1,4])
!!
!! all of the above but for            N != me
!!
!! And may be some other, I've forgotten.
!!
!! Author: Andre Vehreschild, 2017

program alloc_comp_send_convert_nums
  use iso_fortran_env, only : int8,int32,real32,real64

  implicit none

  real(kind=real32), parameter :: tolerance4 = 1.0e-4_real32
  real(kind=real64), parameter :: tolerance4to8 = 1.0E-4_real64
  real(kind=real64), parameter :: tolerance8 = 1.0E-6_real64

  type t
    integer(kind=int8), allocatable :: int_scal_k1
    integer(kind=int32), allocatable :: int_scal_k4
    real(kind=real32)   , allocatable :: real_scal_k4
    real(kind=real64)   , allocatable :: real_scal_k8
    integer(kind=int8), allocatable, dimension(:) :: int_k1
    integer(kind=int32), allocatable, dimension(:) :: int_k4
    real(kind=real32)   , allocatable, dimension(:) :: real_k4
    real(kind=real64)   , allocatable, dimension(:) :: real_k8
  end type t

  integer(kind=int8)                              :: int_scal_k1
  integer(kind=int32)                              :: int_scal_k4
  real(kind=real32)                                 :: real_scal_k4
  real(kind=real64)                                 :: real_scal_k8

  integer(kind=int8), dimension(1:5)                            :: int_k1
  integer(kind=int32), dimension(1:5)                            :: int_k4
  real(kind=real32)   , dimension(1:5)                            :: real_k4
  real(kind=real64)   , dimension(1:5)                            :: real_k8

  type(t), save, codimension[*] :: obj

  logical :: error_printed=.false.

  associate(me => this_image(), np => num_images())
    if (np < 2) error stop 'Cannot run with less than 2 images.'

    int_scal_k1 = INT(42, kind(int_scal_k1))
    int_scal_k4 = 42
    int_k1 = INT([5, 4, 3, 2, 1], kind(int_scal_k4))
    int_k4 = [5, 4, 3, 2, 1]
    allocate(obj%int_scal_k1, obj%int_scal_k4, obj%int_k1(5), obj%int_k4(5)) ! allocate syncs here

    real_scal_k4 = 37.042
    real_scal_k8 = REAL(37.042, kind(real_scal_k8))
    real_k4 = [ 5.1, 4.2, 3.3, 2.4, 1.5]
    real_k8 = REAL([ 5.1, 4.2, 3.3, 2.4, 1.5], kind(real_k8))
    allocate(obj%real_scal_k4, obj%real_scal_k8, obj%real_k4(1:5), obj%real_k8(1:5)) ! allocate syncs here

    ! Now with strides
    ! First check send/copy to self
    if (me == 1) then

      obj%int_k1(1:5) = int_k1(5:1:-1)
      obj[1]%int_k1(::2) = obj%int_k1(3:1:-1)
      print *, obj%int_k1
      ! Note, indezes two times reversed!
      if (any(obj%int_k1 /= [int_k1(3), int_k1(4), int_k1(4), int_k1(2), int_k1(5)])) &
        & call print_and_register( 'send strided with temp int kind=int8 to kind=1 self failed')

       obj%int_k4(1:5) = int_k4(5:1:-1)
       obj[1]%int_k4(::2) = obj%int_k4(3:1:-1)
       print *, obj%int_k4
       if (any(obj%int_k4 /= [int_k4(3), int_k4(4), int_k4(4), int_k4(2), int_k4(5)])) &
        & call print_and_register( 'send strided with temp int kind=4 to kind=4 self failed')
    else if (me == 2) then ! Do the real copy to self checks on image 2

       obj%real_k4(1:5) = real_k4(5:1:-1)
       obj[2]%real_k4(::2) = obj%real_k4(3:1:-1)
       print *, obj%real_k4
       if (any(abs(obj%real_k4 - [real_k4(3), real_k4(4), real_k4(4), real_k4(2), real_k4(5)]) > tolerance4)) &
         & call print_and_register( 'send strided with temp real kind=4 to kind=4 self failed')

       obj%real_k8(1:5) = real_k8(5:1:-1)
       obj[2]%real_k8(::2) = obj%real_k8(3:1:-1)
       print *, obj%real_k8
       if (any(abs(obj%real_k8 - [real_k8(3), real_k8(4), real_k8(4), real_k8(2), real_k8(5)]) > tolerance8)) &
         & call print_and_register( 'send strided with temp real kind=real64 to kind=8 self failed')
    end if

    select case(me)
      case(1)
         sync images(2) ! wait for image 2 to finish all checks
         if (error_printed) error stop
         sync images(2) ! wait for image 2 to get past its conditional error termination
         print *, "Test passed."
      case(2)
         sync images(1) ! wait for image 1 to finish all checks
         if (error_printed) error stop
        sync images(1)
    end select
  end associate

contains

  subroutine print_and_register(error_message)
    use iso_fortran_env, only : error_unit
    character(len=*), intent(in) :: error_message
    write(error_unit,*) error_message
    error_printed=.true.
  end subroutine

end program alloc_comp_send_convert_nums

! vim:ts=2:sts=2:sw=2:

! BSD 3-Clause License
!
! Copyright (c) 2018, Sourcery Institute
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
program main
  !! summary: Test get_commiunicator function, an OpenCoarrays-specific language extension
  use opencoarrays, only : get_communicator
  use oc_assertions_interface, only : assert

  implicit none

#ifndef MPI_WORKING_MODULE
  include 'mpif.h'
#endif

  call mpi_matches_caf(get_communicator())
    !! verify # ranks = # images and image number = rank + 1

  block
    use iso_fortran_env, only : team_type
    use opencoarrays, only : get_communicator, team_number !! TODO: remove team_number once gfortran supports it

    type(team_type) :: league
    integer, parameter :: num_teams=2
      !! number of child teams to form from the parent initial team

    associate(initial_image=>this_image(), initial_num_images=>num_images(), chosen_team=>destination_team(this_image(),num_teams))

      form team(chosen_team,league)
        !! map images to num_teams teams

      change team(league)
        !! join my destination team

        call mpi_matches_caf(get_communicator())
          !! verify new # ranks = new # images and new image number = new rank + 1

        associate(my_team=>team_number())
          call assert(my_team==chosen_team,"assigned team matches chosen team")
          associate(new_num_images=>initial_num_images/num_teams+merge(1,0,my_team<=mod(initial_num_images,num_teams)))
           call assert(num_images()==new_num_images,"block distribution of images")
          end associate
        end associate

      end team

      call assert( initial_image==this_image(),"correctly remapped to original image number")
      call assert( initial_num_images==num_images(),"correctly remapped to original number of images")

    end associate

  end block

  sync all
  if (this_image()==1) print *,"Test passed."

contains

   pure function destination_team(image,numTeams) result(team)
     integer, intent(in) ::image, numTeams
     integer ::team
     team = mod(image+1,numTeams)+1
   end function

subroutine mpi_matches_caf(comm)
#ifdef MPI_WORKING_MODULE
    use mpi
#endif
    use iso_c_binding, only : c_int
    integer(c_int), intent(in) :: comm
      !! MPI communicator
    integer(c_int) :: isize,ierror,irank

    call MPI_COMM_SIZE(comm, isize, ierror)
    call assert( ierror==0 , "successful call MPI_COMM_SIZE" )
    call assert( isize==num_images(), "num MPI ranks = num CAF images " )

    call MPI_COMM_RANK(comm, irank, ierror)
    call assert( ierror==0 , "successful call MPI_COMM_RANK" )
    call assert( irank==this_image()-1 , "correct rank/image-number correspondence" )

  end subroutine

end program

! syncimages test
!
! Copyright (c) 2012-2014, Sourcery, Inc.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of the Sourcery, Inc., nor the
!       names of its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE FOR ANY
! DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
!
program duplicate_syncimages
  implicit none

  integer :: me,i,array(4)
  integer :: stat = 0

  me = this_image()

  if(me == 1) then
     array(1) = 5; array(2) = 6; array(3) = 7; array(4) = 5
     sync images(array,stat=stat)
     if(stat == 3) then
        print *,"Test passed."
     else
        print *,"Test failed."
     endif
  endif

  sync all

end program

  implicit none

  type package
    integer, allocatable :: surface_fluxes(:)
  end type

  type outbox
    type(package), allocatable :: block_surfaces(:)
  end type

  type(outbox), save :: halo[*]

  integer, parameter :: source_image = 1
  integer, parameter :: message(1)=[99]

  associate (me => this_image())
    if (me == source_image) then
      allocate(halo%block_surfaces(1))
      allocate(halo%block_surfaces(1)%surface_fluxes, source = message)
    end if

    sync all

    if (me /= source_image) then
      allocate(halo%block_surfaces(1))
      allocate(halo%block_surfaces(1)%surface_fluxes, mold = halo[source_image]%block_surfaces(1)%surface_fluxes)
      halo%block_surfaces(1)%surface_fluxes(1) = halo[source_image]%block_surfaces(1)%surface_fluxes(1)

      if (me == source_image + 1) then
        if (halo%block_surfaces(1)%surface_fluxes(1) == 99) then
          write(*,*) 'Test passed.'
        end if
      end if
    end if

  end associate
end

! BSD 3-Clause License
!
! Copyright (c) 2016, Sourcery Institute
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

! Comments preceded by "!!" are formatted for the FORD docoumentation generator
program static_event_post_issue_293
  !! author: Damian Rouson
  !! date: 2016-12-22
  !! category: regression
  !! Test posting a static event_type coarray
  !! OpenCoarrays issue [#293](https://github.com/sourceryinstitute/opencoarrays/issues/293)
  use iso_fortran_env, only : event_type
  implicit none
  type(event_type) :: test_post[*]

  if (num_images()<3) error stop "exposing issue 293 requires num_images() >= 3"
  event post(test_post)
  if (this_image()==1) print *,"Test passed."

end program

! Check that failing an image works.
! Image two is to fail, all others to continue.

program image_fail_test_1
  use iso_fortran_env , only : STAT_FAILED_IMAGE
  implicit none
  integer :: i, syncAllStat

  associate(np => num_images(), me => this_image())
    if (np < 3) error stop "I need at least 3 images to function."

    if (me == 2) fail image

    if (me == 2) print *, "Test failed."

    sync all (STAT=syncAllStat)
    if (me == 1) print *, "Test passed."
  end associate

end program image_fail_test_1

! MPI Distributed Transpose Test
!
! Copyright (c) 2012-2014, Sourcery, Inc.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of the Sourcery, Inc., nor the
!       names of its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE FOR ANY
! DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

! Robodoc header:
!****m* dist_transpose/mpi_run_size
! NAME
!   mpi_run_size
! SYNOPSIS
!   Encapsulate the problem state, wall-clock timer interface, integer broadcasts, and a data copy
!   for a distributed tranpsose kernel extracted from a program for the Fourier-spectral simulation
!   of statistically homogeneous.
!******
!==================  test transposes with integer x,y,z values  ===============================
module mpi_run_size
    use iso_fortran_env
#ifndef HAVE_WALLTIME
#  ifdef MPI_WORKING_MODULE
     use MPI, only : WALLTIME=>MPI_WTIME
     implicit none
#  else
     implicit none
     include 'mpif.h'
#    define WALLTIME MPI_WTIME
#  endif
#else
  implicit none
#endif
        integer(int64) :: nx, ny, nz
        integer(int64) :: my, mx, first_y, last_y, first_x, last_x
        integer(int64) :: my_node, num_nodes
        real(real64) :: tran_time

#ifdef HAVE_WALLTIME
interface
   function WALLTIME() bind(C, name = "WALLTIME")
   use iso_fortran_env
       real(real64) :: WALLTIME
   end function WALLTIME
end interface
#endif

contains

subroutine mpi_copy3( A,B, n1, sA1, sB1, n2, sA2, sB2, n3, sA3, sB3 )
  use iso_fortran_env
  implicit none
  complex, intent(in)  :: A(0:*)
  complex, intent(out) :: B(0:*)
  integer(int64), intent(in) :: n1, sA1, sB1
  integer(int64), intent(in) :: n2, sA2, sB2
  integer(int64), intent(in) :: n3, sA3, sB3
  integer(int64) i,j,k

  do k=0,n3-1
     do j=0,n2-1
        do i=0,n1-1
           B(i*sB1+j*sB2+k*sB3) = A(i*sA1+j*sA2+k*sA3)
        end do
     end do
  end do
end subroutine mpi_copy3

end module mpi_run_size

!****e* dist_transose/mpi_distributed_transpose
! NAME
!   mpi_distributed_transpose
! SYNOPSIS
!   This program is the MPI analogue of coarray_distributed_transpose. It tests the transpose routines used
!   in Fourier-spectral simulations of homogeneous turbulence.
!******

program mpi_distributed_transpose
  !(***********************************************************************************************************
  !                   m a i n   p r o g r a m
  !***********************************************************************************************************)
      use mpi_run_size
      implicit none
      include 'mpif.h'

      complex, allocatable ::  u(:,:,:,:)    ! u(nz,4,first_x:last_x,ny)    !(*-- ny = my * num_nodes --*)
      complex, allocatable ::  ur(:,:,:,:)   !ur(nz,4,first_y:last_y,nx/2)  !(*-- nx/2 = mx * num_nodes --*)
      complex, allocatable :: bufr(:)

      integer(int64) :: x, y, z, msg_size, iter
      integer(int64) :: ierror

  call MPI_INIT(ierror)
  call MPI_COMM_RANK(MPI_COMM_WORLD, my_node, ierror)
  call MPI_COMM_SIZE(MPI_COMM_WORLD, num_nodes, ierror)

      if( my_node == 0 ) then
       !write(6,fmt="(A)") "nx,ny,nz : "
       !read(5,*) nx, ny, nz
       nx=32; ny=32; nz=32
      end if

        call MPI_BARRIER(MPI_COMM_WORLD, ierror)  !-- other nodes wait for broadcast!
        call MPI_BCAST( nx, 1, MPI_INT, 0,MPI_COMM_WORLD, ierror )
        call MPI_BCAST( ny, 1, MPI_INT, 0,MPI_COMM_WORLD, ierror )
        call MPI_BCAST( nz, 1, MPI_INT, 0,MPI_COMM_WORLD, ierror )


 	  if ( mod(ny,num_nodes) == 0)  then;   my = ny / num_nodes
                                    else;   write(6,*) "node ", my_node, " ny not multiple of num_nodes";     stop
      end if

      if ( mod(nx/2,num_nodes) == 0)  then;   mx = nx/2 / num_nodes
                                    else;   write(6,*) "node ", my_node, "nx/2 not multiple of num_nodes";    stop
      end if

      first_y = my_node*my + 1;   last_y  = my_node*my + my
      first_x = my_node*mx + 1;   last_x  = my_node*mx + mx

      msg_size = nz*4*mx*my     !-- message size (complex data items

      allocate (  u(nz , 4 , first_x:last_x , ny)   )   !(*-- y-z planes --*)
      allocate ( ur(nz , 4 , first_y:last_y , nx/2) )   !(*-- x-z planes --*)
      allocate ( bufr(msg_size) )


!---------  initialize data u (mx y-z planes per image) ----------

        do x = first_x, last_x
            do y = 1, ny
                do z = 1, nz
                    u(z,1,x,y) = x
                    u(z,2,x,y) = y
                    u(z,3,x,y) = z
                end do
            end do
        end do

    tran_time = 0
    do iter = 1, 2  !--- 2 transform pairs per second-order time step

!---------  transpose data u -> ur (mx y-z planes to my x-z planes per image)  --------

      ur = 0
      call transpose_X_Y

!--------- test data ur (my x-z planes per image) ----------

         do x = 1, nx/2
            do y = first_y, last_y
                do z = 1, nz
                    if ( real(ur(z,1,y,x)) /= x .or. real(ur(z,2,y,x)) /= y .or. real(ur(z,3,y,x)) /= z )then
                         write(6,fmt="(A,i3,3(6X,A,f7.3,i4))") "transpose_X_Y failed:  image ", my_node &
                            , " X ",real(ur(z,1,y,x)),x, "  Y ",real(ur(z,2,y,x)),y, "  Z ", real(ur(z,3,y,x)),z
                        stop
                    end if
                end do
            end do
        end do

!---------  transpose data ur -> u (my x-z planes to mx y-z planes per image)  --------

      u = 0
      call transpose_Y_X

!--------- test data u (mx y-z planes per image) ----------

         do x = first_x, last_x
            do y = 1, ny
                do z = 1, nz
                    if ( real(u(z,1,x,y)) /= x .or. real(u(z,2,x,y)) /= y .or. real(u(z,3,x,y)) /= z )then
                         write(6,fmt="(A,i3,3(6X,A,f7.3,i4))") "transpose_Y_X failed:  image ", my_node &
                            , " X ",real(u(z,1,y,x)),x, "  Y ",real(u(z,2,y,x)),y, "  Z ", real(u(z,3,y,x)),z
                        stop
                    end if
                end do
            end do
        end do
    end do

call MPI_BARRIER(MPI_COMM_WORLD, ierror)

        if( my_node == 0 )  write(6,fmt="(A,f8.3)")  "test passed:  tran_time ", tran_time

    deallocate ( bufr, ur, u)

!=========================   end of main executable  =============================

contains

!-------------   out-of-place transpose data_s --> data_r  ----------------------------

 subroutine transpose_X_Y

    use mpi_run_size
    implicit none

    integer(int64) :: to, from, send_tag, recv_tag
    integer :: stage, idr(0:num_nodes-1), ids(0:num_nodes-1)
    integer(int64) :: send_status(MPI_STATUS_SIZE), recv_status(MPI_STATUS_SIZE)
    character*(MPI_MAX_ERROR_STRING) errs

    call MPI_BARRIER(MPI_COMM_WORLD, ierror)   !--  wait for other nodes to finish compute
    tran_time = tran_time - WALLTIME()

!--------------   transpose my image's block (no communication needed)  ------------------

    call mpi_copy3 (    u(1,1,first_x,1+my_node*my) &                   !-- intra-node transpose
                ,  ur(1,1,first_y,1+my_node*mx) &                   !-- no inter-node transpose needed
                ,   nz*3, 1_8, 1_8        &                                 !-- note: only 3 of 4 words needed
                ,   mx, nz*4, nz*4*my &
                ,   my, nz*4*mx, nz*4 )

#define RECEIVE
#ifdef RECEIVE

!--------------   issue all block sends ... tags = 256*dst_image+src_image  ------------------

    do stage = 1, num_nodes-1
        to = mod( my_node+stage, num_nodes )
        send_tag = 256*to + my_node
        call MPI_ISSEND ( u(1,1,first_x,1+to*my) &
                        ,   msg_size*2,  MPI_REAL,  to, send_tag,  MPI_COMM_WORLD,  ids(stage),  ierror)
    end do

!--------------   receive and transpose other image's block  ------------------

    do stage = 1, num_nodes-1   !-- process receives in order
        from = mod( my_node+stage, num_nodes )
        recv_tag = 256*my_node + from
        call MPI_RECV  ( bufr &
                        ,   msg_size*2,  MPI_REAL,  from, recv_tag,  MPI_COMM_WORLD,  recv_status,  ierror)

        call mpi_copy3 ( bufr, ur(1,1,first_y,1+from*mx)  &                !-- intra-node transpose from buffer
                        ,   nz*3, 1_8, 1_8        &                             !-- note: only 3 of 4 words needed
                        ,   mx, nz*4, nz*4*my &
                        ,   my, nz*4*mx, nz*4 )
    end do

#else

!--------------   issue all block receives ... tags = 256*dst_image+src_image  ------------------

    do stage = 1, num_nodes-1
        from = mod( my_node+stage, num_nodes )
        recv_tag = 256*my_node + from
        call MPI_IRECV  ( ur(1,1,first_y,1+from*mx) &
                        ,   msg_size*2,  MPI_REAL,  from, recv_tag,  MPI_COMM_WORLD,  idr(stage),  ierror)
    end do

!--------------   issue all block sends ... tags = 256*dst_image+src_image  ------------------


    do stage = 1, num_nodes-1   !-- process sends in order
        to = mod( my_node+stage, num_nodes )
        send_tag = 256*to + my_node
        call mpi_copy3 ( u(1,1,first_x,1+to*my), bufr &                !-- intra-node transpose from buffer
                ,   nz*3, 1_8, 1_8        &                             !-- note: only 3 of 4 words needed
                ,   mx, nz*4, nz*4*my &
                ,   my, nz*4*mx, nz*4 )

        call MPI_SEND ( bufr &
                        ,   msg_size*2,  MPI_REAL,  to, send_tag,  MPI_COMM_WORLD,  ierror)
    end do

!--------------   wait on receives   ------------------

    do stage = 1, num_nodes-1
        call MPI_WAIT( idr(stage),  recv_status,  ierror )
    end do

#endif

call MPI_BARRIER(MPI_COMM_WORLD, ierror)     !--  wait for other nodes to finish transpose
    tran_time = tran_time + WALLTIME()

! deallocate(ids,idr)

 end  subroutine transpose_X_Y

!-------------   out-of-place transpose data_r --> data_s  ----------------------------

 subroutine transpose_Y_X

    use mpi_run_size
    implicit none

    integer(int64) :: to, from, send_tag, recv_tag
    integer :: stage, idr(0:num_nodes-1), ids(0:num_nodes-1)
    character*(MPI_MAX_ERROR_STRING) errs
    integer(int64) :: send_status(MPI_STATUS_SIZE), recv_status(MPI_STATUS_SIZE)

    call MPI_BARRIER(MPI_COMM_WORLD, ierror)   !--  wait for other nodes to finish compute
    tran_time = tran_time - WALLTIME()

!--------------   transpose my image's block (no communication needed)  ------------------

    call mpi_copy3 (   ur(1,1,first_y,1+my_node*mx) &                   !-- intra-node transpose
                ,   u(1,1,first_x,1+my_node*my) &                   !-- no inter-node transpose needed
                ,   nz*4, 1_8, 1_8        &                                 !-- note: all 4 words needed
                ,   my, nz*4, nz*4*mx &
                ,   mx, nz*4*my, nz*4 )

#define RECEIVE
#ifdef RECEIVE

!--------------   issue all block sends ... tags = 256*dst_image+src_image  ------------------

    do stage = 1, num_nodes-1
        to = mod( my_node+stage, num_nodes )
        send_tag = 256*to + my_node
        call MPI_ISSEND ( ur(1,1,first_y,1+to*mx)    &
                        ,   msg_size*2,  MPI_REAL,  to, send_tag,  MPI_COMM_WORLD,  ids(stage),  ierror)

    end do

!--------------   transpose other image's block (get block then transpose it)  ------------------

    do stage = 1, num_nodes-1   !-- process receives in order
        from = mod( my_node+stage, num_nodes )
        recv_tag = 256*my_node + from
        call MPI_RECV  ( bufr  &
                        ,   msg_size*2,  MPI_REAL,  from, recv_tag,  MPI_COMM_WORLD,  recv_status,  ierror)

        call mpi_copy3 ( bufr, u(1,1,first_x,1+from*my)  &                 !-- intra-node transpose from buffer
                    ,   nz*4, 1_8, 1_8        &
                    ,   my, nz*4, nz*4*mx &
                    ,   mx, nz*4*my, nz*4 )
    end do

#else

!--------------   issue all block receives ... tags = 256*dst_image+src_image  ------------------

    do stage = 1, num_nodes-1
        from = mod( my_node+stage, num_nodes )
        recv_tag = 256*my_node + from
        call MPI_IRECV  ( u(1,1,first_x,1+from*my) &
                        ,   msg_size*2,  MPI_REAL,  from, recv_tag,  MPI_COMM_WORLD,  idr(stage),  ierror)
    end do

!--------------   issue all block sends ... tags = 256*dst_image+src_image  ------------------


    do stage = 1, num_nodes-1   !-- process sends in order
        to = mod( my_node+stage, num_nodes )
        send_tag = 256*to + my_node
        call mpi_copy3 ( ur(1,1,first_y,1+to*mx), bufr &                !-- intra-node transpose from buffer
                ,   nz*4, 1_8, 1_8        &                                 !-- note: all 4 words needed
                ,   my, nz*4, nz*4*mx &
                ,   mx, nz*4*my, nz*4 )

        call MPI_SEND ( bufr &
                        ,   msg_size*2,  MPI_REAL,  to, send_tag,  MPI_COMM_WORLD,  ierror)
    end do

!--------------   wait on receives   ------------------

    do stage = 1, num_nodes-1
        call MPI_WAIT( idr(stage),  recv_status,  ierror )
    end do

#endif

    call MPI_BARRIER(MPI_COMM_WORLD, ierror)     !--  wait for other nodes to finish transpose
    tran_time = tran_time + WALLTIME()
 !   deallocate(ids,idr)
 end  subroutine transpose_Y_X

end program mpi_distributed_transpose

! Test that sendget with strides on either side (of the assignment) works
! as expected.
!
! This test needs at least three images, because sendget has the potential
! to check whether on image used in the communication is the current one.
! More than three images do not pay, because there is no general code in
! this test.
!
! Written by Andre Vehreschild

program stridedsendgettest

  implicit none

  integer, parameter :: src_image = 2, dst_image = 3, master_image = 1
  integer, save, dimension(4,6) :: srcmat[*], dstmat[*]
  integer, save, dimension(6) :: srcvec[*], dstvec[*]
  integer :: i
  logical :: test_passed = .true.

  ! Make sure that enough images are available for this test.
  ! Everything less than dst_image == 3 may make sendget use an
  ! optimized version saving a part of the communication, which is
  ! not what the test should test.
  if (num_images() < dst_image) then
     print*, "Pretend that the test was run and passed, even though there are too few images to perform test:"
     print*, "Test passed"
     error stop "Need at least three images."
  end if

  ! On the src_image, set some defined values, to be able to distinguish
  ! strides going wrong.
  if (this_image() == src_image) then
    srcvec = [(2 * i, i = 1, 6)]
    srcmat = reshape([(i * 2, i = 1, 4*6)], [4,6])
  ! On the dst_image set values that enable to recognize unset values.
  elseif (this_image() == dst_image) then
    dstmat = -1
    dstvec = -2
  end if

  ! Make sure data is valid on all images.
  sync all

  ! master_image is the controller in this communication and therefore needs
  ! to initiate the communication.
  if (this_image() == master_image) then
    ! Transfer data from the src-vector to the dst-vector on image
    ! dst_image.  This is a transfer of a contingous block of data and here for
    ! completeness only.
    dstvec(:)[dst_image] = srcvec(:)[src_image]
    ! This statement uses a stride in the send phase of the communication.
    dstmat(3,:)[dst_image] = srcvec(:)[src_image]
  end if

  ! Make sure the communication has completed.
  sync all

  ! Check the result of communication on the dst_image.
  if (this_image() == dst_image) then
    ! Check that transfering to the vector has succeeded.
    if (any(dstvec /= [2, 4, 6, 8, 10, 12])) error stop "SendGet vec/vec does not match."

    ! Check that transfering a vector into a matrix changes only the
    ! values desired.
    if (any(dstmat /= reshape([-1, -1,  2, -1, &
                               -1, -1,  4, -1, &
                               -1, -1,  6, -1, &
                               -1, -1,  8, -1, &
                               -1, -1, 10, -1, &
                               -1, -1, 12, -1], [4, 6]))) then
      error stop "SendGet matrow/vec does not match."
    end if
    ! Reset the dst-buffers to enable new test.
    dstvec = -2
    dstmat = -1
  end if

  ! Wait for dst having done its tests.
  sync all
  if (this_image() == master_image) then
    ! Execute strided get in sendget and store in a vector to just
    ! test the get.
    dstvec(:)[dst_image] = srcmat(2,:)[src_image]
    ! Test both strided get and strided send at once.
    dstmat(3,:)[dst_image] = srcmat(2,:)[src_image]
  end if

  ! Ensure that the communication is all done.
  sync all
  if (this_image() == dst_image) then
    ! Check, that the strided get has the expected result.
    if (any(dstvec /= [4, 12, 20, 28, 36, 44])) error stop "SendGet vec/matrow does not match."

    ! And that both communications with stride work as expected.
    if (any(dstmat /= reshape([-1, -1,  4, -1, &
                               -1, -1, 12, -1, &
                               -1, -1, 20, -1, &
                               -1, -1, 28, -1, &
                               -1, -1, 36, -1, &
                               -1, -1, 44, -1], [4, 6]))) then
      error stop "SendGet matrow/matrow does not match."
    end if

    ! Above checks would stop with an error on failure, so its save
    ! to unguardedly print here, when all tests pass.
    print *, "Test passed"
  end if
end program

program async_comp_alloc_2
  !! Author: Izaak Beekman, Andre Vehreschild
  !! Category: Regression
  !! Regression test for issue [#399](https://github.com/sourceryinstitute/OpenCoarrays/issues/399)
  implicit none
  type :: nonsymmetric
     real, dimension(:), allocatable :: arr
  end type

  type(nonsymmetric), codimension[*] :: parent_obj

  sync all

  if ( num_images() < 2 ) error stop "Test async_comp_alloc_2 requires at least 2 images to run"

  associate(me => this_image())
    if (me == 2) then
      allocate(parent_obj%arr(3))
      print *, 'Image 2: memory allocated.'
    end if

    sync all

    if (me == 1) then
      print *, 'Alloc status on [2]: ', allocated(parent_obj[2]%arr)
      print *, 'Image 2 has size ', size(parent_obj[2]%arr), ' asymmetric allocation'
      if (size(parent_obj[2]%arr) /= 3) error stop 'Test failed.'
      sync all
      print *, 'Test passed.'
    else
      sync all
    end if
  end associate
end program

submodule(oc_assertions_interface) oc_assertions_implementation
  !! Define the assert procedure

  implicit none

contains

  module procedure assert

    character(len=:), allocatable :: message

    if (present(success)) success=assertion

    if (.not.assertion) then

      call set(message)
      if (present(error_message)) error_message = message

      if (.not. present(success)) then
#ifdef HAVE_VARIABLE_STOP_CODE
        error stop message
#else
        error stop "Assertion failed."
#endif
      end if
    end if

  contains

    pure subroutine set(msg)

      use opencoarrays_object_interface, only : object
        !! import abstract type with generic binding supporting user-defined derived type output

      character(len=:), intent(out),  allocatable :: msg
      integer, parameter :: max_image_num_digits=12, max_diagnostic_length=1024
      integer, parameter :: msg_len = max_diagnostic_length + max_diagnostic_length

      associate( base_msg_len=> len("Assertion '") +len_trim(adjustl(description)) +len("' failed on image ") +max_image_num_digits)
        allocate( character(len=msg_len) :: msg )
        write(msg,*) "Assertion '",trim(adjustl(description)),"' failed on image ",this_image()
      end associate

      if (present(diagnostic_data)) then
        block
          !! append diagnostic string
          character(len=max_diagnostic_length) diagnostic_string

          select type(diagnostic_data)
            type is(character(len=*))
              diagnostic_string = diagnostic_data
            type is(real)
              write(diagnostic_string,*) diagnostic_data
            type is(integer)
              write(diagnostic_string,*) diagnostic_data
            class is(object)
              write(diagnostic_string,*) diagnostic_data
            class default
              diagnostic_string = "of unrecognized type"
          end select

          msg = trim(adjustl(msg)) // " with diagnostic data " // trim(adjustl(diagnostic_string))
        end block
      end if

    end subroutine

  end procedure

end submodule oc_assertions_implementation

! Check that letting images exit the stopped_images function returns the
! correct indices.
! Image two is to stop, all others to continue.

program image_fail_and_stopped_images_test_1
  implicit none
  integer :: i, stat
  integer, allocatable :: simages(:)

  associate(np => num_images(), me => this_image())
    if (np < 3) error stop "I need at least 3 images to function."

    ! Need a sync here to make sure all images are started and to prevent image fail
    ! is not already detected in above image_status(i).
    sync all
    if (me == 2) stop 0
    sync all (STAT=stat)

    simages = stopped_images()
    if (size(simages) /= 1) error stop "stopped_images()'s size should be one."
    if (simages(1) /= 2) then
            print *, me, "stopped image: ", simages(1)
            error stop "The second image should have stopped."
    end if

    if (me == 1) print *,"Test passed."
  end associate

end program image_fail_and_stopped_images_test_1

! Implement a usecase for co_reduce on char arrays.
!
! Copyright (c) 2012-2017, Sourcery, Inc.
! All rights reserved.
!
! Unit tests for co_min: verify parallel, collective minimum
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of Sourcery, Inc., nor the
!       names of any other contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

program co_reduce_strings
 
  implicit none

  integer, parameter :: numstrings = 10, strlen = 6
  character(len=strlen), dimension(:), allocatable :: strarr[:]
  character(len=strlen) :: expect
  integer :: i

  ! Construct the strings by postfixing foo by a number.
  associate (me => this_image())
    allocate(strarr(numstrings)[*])
    do i = 1, numstrings
      write(strarr(i), "('foo'I02)") i * me
    end do
    ! Collectively reduce the maximum string.
    call co_reduce(strarr, strmax)
  end associate

  ! No sync should be needed here, because the collective (reduce_all)
  ! implicitly synchronizes.
  associate (np => num_images())
    do i = 1, np
      write (expect, "('foo'I02)") i * np
      if (strarr(i) /= expect) then
        ! On errror print what we got and what we expected.
        print *, "Got: ", strarr(i), ", expected: ", expect
        error stop "Didn't get expected string."
      end if
    end do
  end associate
  sync all
  if (this_image() == 1) print *, "Test passed."
contains

  !! Compare two strings and return the maximum one. In a co_reduce no deferred-
  !! length strings are allowed, therefore fixed length had to be used.
  !! For identical strings the LHS is returned.
  pure function strmax(lhs, rhs) result(maxstr) bind(C,name="strmax")
    character(len=strlen), intent(in) :: lhs,rhs
    character(len=strlen) :: maxstr

    if (lhs > rhs) then
      maxstr = lhs 
    else 
      maxstr = rhs
    end if
  end function

end program co_reduce_strings

!! Thoroughly test sendget, i.e. foo [M] = bar[N] in all variants
!!
!! Do simple tests for sendget(). These test comprise
!!
!! FOO [M] = BAR [N]
!!
!! where
!!
!!  FOO                BAR                images
!! scalar            scalar              N == M == me
!!  int(k e [1,4])    int(k e [1,4])
!!  real(k e [4,8])   real(k e [4,8])
!!  int(k e [1,4])    real(k e [4,8])
!!  real(k e [4,8])   int(k e [1,4])
!!
!! array(1:5)        scalar
!!  int(k e [1,4])    int(k e [1,4])
!!  real(k e [4,8])   real(k e [4,8])
!!  int(k e [1,4])    real(k e [4,8])
!!  real(k e [4,8])   int(k e [1,4])
!!
!! array(1:5)        array(1:5)
!!  int(k e [1,4])    int(k e [1,4])
!!  real(k e [4,8])   real(k e [4,8])
!!  int(k e [1,4])    real(k e [4,8])
!!  real(k e [4,8])   int(k e [1,4])
!!
!! array(1:3)       array(::2)
!!  int(k e [1,4])    int(k e [1,4])
!!  real(k e [4,8])   real(k e [4,8])
!!  int(k e [1,4])    real(k e [4,8])
!!  real(k e [4,8])   int(k e [1,4])
!!
!! array(4:5)       array(2::2)
!!  int(k e [1,4])    int(k e [1,4])
!!  real(k e [4,8])   real(k e [4,8])
!!  int(k e [1,4])    real(k e [4,8])
!!  real(k e [4,8])   int(k e [1,4])
!!
!! array(1:3)      array(3:1:-1)
!!  int(k e [1,4])    int(k e [1,4])
!!  real(k e [4,8])   real(k e [4,8])
!!  int(k e [1,4])    real(k e [4,8])
!!  real(k e [4,8])   int(k e [1,4])
!!
!! all of the above but for             N != M != me
!!
!! And may be some other, I've forgotten.
!!
!! Author: Andre Vehreschild, 2017

program sendget_convert_nums

  implicit none

  real(kind=4), parameter :: tolerance4 = 1.0e-4
  real(kind=8), parameter :: tolerance4to8 = 1.0E-4
  real(kind=8), parameter :: tolerance8 = 1.0E-6

  integer(kind=1), codimension[*] :: co_int_scal_src_k1, co_int_scal_dst_k1
  integer(kind=4), codimension[*] :: co_int_scal_src_k4, co_int_scal_dst_k4
  real(kind=4)   , codimension[*] :: co_real_scal_src_k4, co_real_scal_dst_k4
  real(kind=8)   , codimension[*] :: co_real_scal_src_k8, co_real_scal_dst_k8

  integer(kind=1), dimension(1:5), codimension[*] :: co_int_src_k1, co_int_dst_k1
  integer(kind=4), dimension(1:5), codimension[*] :: co_int_src_k4, co_int_dst_k4
  real(kind=4)   , dimension(1:5), codimension[*] :: co_real_src_k4, co_real_dst_k4
  real(kind=8)   , dimension(1:5), codimension[*] :: co_real_src_k8, co_real_dst_k8

  logical :: error_printed=.false.

  associate(me => this_image(), np => num_images())
    if (np < 3) error stop 'Can not run with less than 3 images.'

    co_int_scal_src_k1 = 42
    co_int_scal_dst_k1 = -1
    co_int_scal_src_k4 = 42
    co_int_scal_dst_k4 = -1
    co_int_src_k1 = INT([ 5, 4, 3, 2, 1], 1)
    co_int_dst_k1 = -1
    co_int_src_k4 = [ 5, 4, 3, 2, 1]
    co_int_dst_k4 = -1

    co_real_scal_src_k4 = 37.042
    co_real_scal_src_k8 = REAL(37.042, 8)
    co_real_scal_dst_k4 = -1.0
    co_real_scal_dst_k8 = -1.0
    co_real_src_k4 = [ 5.1, 4.2, 3.3, 2.4, 1.5]
    co_real_src_k8 = REAL([ 5.1, 4.2, 3.3, 2.4, 1.5], 8)
    co_real_dst_k4 = -1.0
    co_real_dst_k8 = -1.0
    ! First check send/copy to self
    if (me == 1) then
      co_int_scal_dst_k1[1] = co_int_scal_src_k1[1]
      print *, co_int_scal_dst_k1
      if (co_int_scal_dst_k1 /= co_int_scal_src_k1) &
        call print_and_register( 'sendgetget scalar int kind=1 to kind=1 self failed.')

      co_int_scal_dst_k4[1] = co_int_scal_src_k4[1]
      print *, co_int_scal_dst_k4
      if (co_int_scal_dst_k4 /= co_int_scal_src_k4) &
        call print_and_register( 'sendgetget scalar int kind=4 to kind=4 self failed.')

      co_int_scal_dst_k4[1] = co_int_scal_src_k1[1]
      print *, co_int_scal_dst_k4
      if (co_int_scal_dst_k4 /= co_int_scal_src_k4) call print_and_register( 'sendget scalar int kind=1 to kind=4 self failed.')

      co_int_scal_dst_k1[1] = co_int_scal_src_k4[1]
      print *, co_int_scal_src_k1
      if (co_int_scal_dst_k1 /= co_int_scal_src_k1) call print_and_register( 'sendget scalar int kind=4 to kind=1 self failed.')

      co_int_dst_k1(:)[1] = co_int_src_k1(:)[1]
      print *, co_int_dst_k1
      if (any(co_int_dst_k1 /= co_int_src_k1)) call print_and_register( 'sendget int kind=1 to kind=1 self failed.')

      co_int_dst_k4(:)[1] = co_int_src_k4(:)[1]
      print *, co_int_dst_k4
      if (any(co_int_dst_k4 /= co_int_src_k4)) call print_and_register( 'sendget int kind=4 to kind=4 self failed.')

      co_int_dst_k4(:)[1] = co_int_src_k1(:)[1]
      print *, co_int_dst_k4
      if (any(co_int_dst_k4 /= co_int_src_k4)) call print_and_register( 'sendget int kind=1 to kind=4 self failed.')

      co_int_dst_k1(:)[1] = co_int_src_k4(:)[1]
      print *, co_int_dst_k1
      if (any(co_int_dst_k1 /= co_int_src_k1)) call print_and_register( 'sendget int kind=4 to kind=1 self failed.')
    else if (me == 2) then ! Do the real copy to self checks on image 2
      co_real_scal_dst_k4[2] = co_real_scal_src_k4[2]
      print *, co_real_scal_dst_k4
      if (abs(co_real_scal_dst_k4 - co_real_scal_src_k4) > tolerance4) &
        & call print_and_register( 'sendget scalar real kind=4 to kind=4 self failed.')

      co_real_scal_dst_k8[2] = co_real_scal_src_k8[2]
      print *, co_real_scal_dst_k8
      if (abs(co_real_scal_dst_k8 - co_real_scal_src_k8) > tolerance8) &
        & call print_and_register( 'sendget scalar real kind=8 to kind=8 self failed.')

      co_real_scal_dst_k8[2] = co_real_scal_src_k4[2]
      print *, co_real_scal_dst_k8
      if (abs(co_real_scal_dst_k8 - co_real_scal_src_k8) > tolerance4to8) &
        & call print_and_register( 'sendget scalar real kind=4 to kind=8 self failed.')

      co_real_scal_dst_k4[2] = co_real_scal_src_k8[2]
      print *, co_real_scal_dst_k4
      if (abs(co_real_scal_dst_k4 - co_real_scal_src_k4) > tolerance4) &
        & call print_and_register( 'sendget scalar real kind=8 to kind=4 self failed.')

      co_real_dst_k4(:)[2] = co_real_src_k4(:)[2]
      print *, co_real_dst_k4
      if (any(abs(co_real_dst_k4 - co_real_src_k4) > tolerance4)) &
        call print_and_register( 'sendget real kind=4 to kind=4 self failed.')

      co_real_dst_k8(:)[2] = co_real_src_k8(:)[2]
      print *, co_real_dst_k8
      if (any(abs(co_real_dst_k8 - co_real_src_k8) > tolerance8)) &
        call print_and_register( 'sendget real kind=8 to kind=8 self failed.')

      co_real_dst_k8(:)[2] = co_real_src_k4(:)[2]
      print *, co_real_dst_k8
      if (any(abs(co_real_dst_k8 - co_real_src_k8) > tolerance4to8)) &
        call print_and_register( 'sendget real kind=4 to kind=8 self failed.')

      co_real_dst_k4(:)[2] = co_real_src_k8(:)[2]
      print *, co_real_dst_k4
      if (any(abs(co_real_dst_k4 - co_real_src_k4) > tolerance4)) &
        call print_and_register( 'sendget real kind=8 to kind=4 self failed.')
    end if

    sync all
    if (me == 2) then
      co_int_scal_dst_k1[1] = co_int_scal_src_k1[3]

      co_int_scal_dst_k4[1] = co_int_scal_src_k4[3]

      co_int_dst_k1(:)[1] = co_int_src_k1(:)[3]

      co_int_dst_k4(:)[1] = co_int_src_k4(:)[3]

      co_real_scal_dst_k4[1] = co_real_scal_src_k4[3]

      co_real_scal_dst_k8[1] = co_real_scal_src_k8[3]

      co_real_dst_k4(:)[1] = co_real_src_k4(:)[3]

      co_real_dst_k8(:)[1] = co_real_src_k8(:)[3]
    end if

    sync all
    if (me == 1) then
      print *, co_int_scal_dst_k1
      if (co_int_scal_dst_k1 /= co_int_scal_src_k1) &
        call print_and_register( 'sendget scalar int kind=1 to kind=1 to image 2 failed.')

      print *, co_int_scal_dst_k4
      if (co_int_scal_dst_k4 /= co_int_scal_src_k4) &
        call print_and_register( 'sendget scalar int kind=4 to kind=4 to image 2 failed.')

      print *, co_int_dst_k1
      if (any(co_int_dst_k1 /= co_int_src_k1)) call print_and_register( 'sendget int kind=1 to kind=1 to image 2 failed.')

      print *, co_int_dst_k4
      if (any(co_int_dst_k4 /= co_int_src_k4)) call print_and_register( 'sendget int kind=4 to kind=4 to image 2 failed.')

      print *, co_real_scal_dst_k4
      if (abs(co_real_scal_dst_k4 - co_real_scal_src_k4) > tolerance4) &
        & call print_and_register( 'sendget scalar real kind=4 to kind=4 to image 2 failed.')

      print *, co_real_scal_dst_k8
      if (abs(co_real_scal_dst_k8 - co_real_scal_src_k8) > tolerance8) &
        & call print_and_register( 'sendget scalar real kind=8 to kind=8 to image 2 failed.')

      print *, co_real_dst_k4
      if (any(abs(co_real_dst_k4 - co_real_src_k4) > tolerance4)) &
        call print_and_register( 'sendget real kind=4 to kind=4 to image 2 failed.')

      print *, co_real_dst_k8
      if (any(abs(co_real_dst_k8 - co_real_src_k8) > tolerance8)) &
        call print_and_register( 'sendget real kind=8 to kind=8 to image 2 failed.')
    end if

    sync all
    if (me == 2) then
      co_int_scal_dst_k4[1] = co_int_scal_src_k1[3]

      co_int_scal_dst_k1[1] = co_int_scal_src_k4[3]

      co_int_dst_k4(:)[1] = co_int_src_k1(:)[3]

      co_int_dst_k1(:)[1] = co_int_src_k4(:)[3]

      co_real_scal_dst_k8[1] = co_real_scal_src_k4[3]

      co_real_scal_dst_k4[1] = co_real_scal_src_k8[3]

      co_real_dst_k8(:)[1] = co_real_src_k4(:)[3]

      co_real_dst_k4(:)[1] = co_real_src_k8(:)[3]
    end if

    sync all
    if (me == 1) then
      print *, co_int_scal_dst_k4
      if (co_int_scal_dst_k4 /= co_int_scal_src_k4) &
        call print_and_register( 'sendget scalar int kind=1 to kind=4 to image 2 failed.')

      print *, co_int_scal_dst_k1
      if (co_int_scal_dst_k1 /= co_int_scal_src_k1) &
        call print_and_register( 'sendget scalar int kind=4 to kind=1 to image 2 failed.')

      print *, co_int_dst_k4
      if (any(co_int_dst_k4 /= co_int_src_k4)) call print_and_register( 'sendget int kind=1 to kind=4 to image 2 failed.')

      print *, co_int_dst_k1
      if (any(co_int_dst_k1 /= co_int_src_k1)) call print_and_register( 'sendget int kind=4 to kind=1 to image 2 failed.')

      print *, co_real_scal_dst_k8
      if (abs(co_real_scal_dst_k8 - co_real_scal_src_k8) > tolerance4to8) &
        & call print_and_register( 'sendget scalar real kind=4 to kind=8 to image 2 failed.')

      print *, co_real_scal_dst_k4
      if (abs(co_real_scal_dst_k4 - co_real_scal_src_k4) > tolerance4) &
        & call print_and_register( 'sendget scalar real kind=8 to kind=4 to image 2 failed.')

      print *, co_real_dst_k8
      if (any(abs(co_real_dst_k8 - co_real_src_k8) > tolerance4to8)) &
        call print_and_register( 'sendget real kind=4 to kind=8 to image 2 failed.')

      print *, co_real_dst_k4
      if (any(abs(co_real_dst_k4 - co_real_src_k4) > tolerance4)) &
        call print_and_register( 'sendget real kind=8 to kind=4 to image 2 failed.')
    end if

    ! Scalar to array replication
    sync all
    if (me == 2) then
      co_int_dst_k4(:)[1] = co_int_scal_src_k4[3]

      co_int_dst_k1(:)[1] = co_int_scal_src_k1[3]

      co_real_dst_k8(:)[1] = co_real_scal_src_k8[3]

      co_real_dst_k4(:)[1] = co_real_scal_src_k4[3]
    end if

    sync all
    if (me == 1) then
      print *, co_int_dst_k4
      if (any(co_int_dst_k4 /= co_int_scal_src_k4)) &
        call print_and_register( 'sendget int scal kind=4 to array kind=4 to image 2 failed.')

      print *, co_int_dst_k1
      if (any(co_int_dst_k1 /= co_int_scal_src_k1)) &
        call print_and_register( 'sendget int scal kind=1 to array kind=1 to image 2 failed.')

      print *, co_real_dst_k8
      if (any(abs(co_real_dst_k8 - co_real_scal_src_k8) > tolerance8)) &
        & call print_and_register( 'sendget real kind=8 to array kind=8 to image 2 failed.')

      print *, co_real_dst_k4
      if (any(abs(co_real_dst_k4 - co_real_scal_src_k4) > tolerance4)) &
        & call print_and_register( 'sendget real kind=4 to array kind=4 to image 2 failed.')
    end if

    ! and with kind conversion
    sync all
    if (me == 2) then
      co_int_dst_k4(:)[1] = co_int_scal_src_k1[3]

      co_int_dst_k1(:)[1] = co_int_scal_src_k4[3]
      co_real_dst_k8(:)[1] = co_real_scal_src_k4[3]

      co_real_dst_k4(:)[1] = co_real_scal_src_k8[3]
    end if

    sync all
    if (me == 1) then
      print *, co_int_dst_k4
      if (any(co_int_dst_k4 /= co_int_scal_src_k4)) &
        call print_and_register( 'sendget int scal kind=1 to array kind=4 to image 2 failed.')

      print *, co_int_dst_k1
      if (any(co_int_dst_k1 /= co_int_scal_src_k1)) &
        call print_and_register( 'sendget int scal kind=4 to array kind=1 to image 2 failed.')

      print *, co_real_dst_k8
      if (any(abs(co_real_dst_k8 - co_real_scal_src_k8) > tolerance8)) &
        & call print_and_register( 'sendget real kind=4 to array kind=8 to image 2 failed.')

      print *, co_real_dst_k4
      if (any(abs(co_real_dst_k4 - co_real_scal_src_k4) > tolerance4)) &
        & call print_and_register( 'sendget real kind=8 to array kind=4 to image 2 failed.')
    end if
    ! and with type conversion
    sync all
    if (me == 2) then
      co_int_dst_k4(:)[1] = co_real_scal_src_k4[3]

      co_int_dst_k1(:)[1] = co_real_scal_src_k4[3]

      co_real_dst_k8(:)[1] = co_int_scal_src_k4[3]

      co_real_dst_k4(:)[1] = co_int_scal_src_k4[3]
    end if

    sync all
    if (me == 1) then
      print *, co_int_dst_k4
      if (any(co_int_dst_k4 /= INT(co_real_scal_src_k4, 4))) &
        & call print_and_register( 'sendget real scal kind=4 to int array kind=4 to image 2 failed.')

      print *, co_int_dst_k1
      if (any(co_int_dst_k1 /= INT(co_real_scal_src_k4, 1))) &
        & call print_and_register( 'sendget real scal kind=1 to int array kind=1 to image 2 failed.')

      print *, co_real_dst_k8
      if (any(abs(co_real_dst_k8 - co_int_scal_src_k4) > tolerance4to8)) &
        & call print_and_register( 'sendget int kind=4 to real array kind=8 to image 2 failed.')

      print *, co_real_dst_k4
      if (any(abs(co_real_dst_k4 - co_int_scal_src_k4) > tolerance4)) &
        & call print_and_register( 'sendget int kind=4 to real array kind=4 to image 2 failed.')
    end if

    ! Now with strides
    ! First check send/copy to self
    if (me == 1) then
      co_int_dst_k1 = -1
      co_int_dst_k1(::2)[1] = co_int_src_k1(1:3)[1]
      print *, co_int_dst_k1
      if (any(co_int_dst_k1 /= [co_int_src_k1(1), INT(-1, 1), co_int_src_k1(2), INT(-1, 1), co_int_src_k1(3)])) &
        & call print_and_register( 'sendget strided int kind=1 to kind=1 self failed.')

      co_int_dst_k4 = -1
      co_int_dst_k4(::2)[1] = co_int_src_k4(1:3)[1]
      print *, co_int_dst_k4
      if (any(co_int_dst_k4 /= [co_int_src_k4(1), -1, co_int_src_k4(2), -1, co_int_src_k4(3)])) &
        & call print_and_register( 'sendget strided int kind=4 to kind=4 self failed.')

      co_int_dst_k4 = -2
      co_int_dst_k4(2::2)[1] = co_int_src_k1(4:5)[1]
      print *, co_int_dst_k4
      if (any(co_int_dst_k4 /= [-2, co_int_src_k4(4), -2, co_int_src_k4(5), -2])) &
        & call print_and_register( 'sendget strided int kind=1 to kind=4 self failed.')

      co_int_dst_k1 = -2
      co_int_dst_k1(2::2)[1] = co_int_src_k4(4:5)[1]
      print *, co_int_dst_k1
      if (any(co_int_dst_k1 /= [INT(-2, 1), co_int_src_k1(4), INT(-2, 1), co_int_src_k1(5), INT(-2, 1)])) &
        & call print_and_register( 'sendget strided int kind=4 to kind=1 self failed.')

      co_int_dst_k1(1:5) = co_int_src_k1(5:1:-1)
      co_int_dst_k1(::2)[1] = co_int_dst_k1(3:1:-1)[1]
      print *, co_int_dst_k1
      ! Note, indezes two times reversed!
      if (any(co_int_dst_k1 /= [co_int_src_k1(3), co_int_src_k1(4), co_int_src_k1(4), co_int_src_k1(2), co_int_src_k1(5)])) &
        & call print_and_register( 'sendget strided with temp int kind=1 to kind=1 self failed.')

      co_int_dst_k4(1:5) = co_int_src_k4(5:1:-1)
      co_int_dst_k4(::2)[1] = co_int_dst_k4(3:1:-1)[1]
      print *, co_int_dst_k4
      if (any(co_int_dst_k4 /= [co_int_src_k4(3), co_int_src_k4(4), co_int_src_k4(4), co_int_src_k4(2), co_int_src_k4(5)])) &
       & call print_and_register( 'sendget strided with temp int kind=4 to kind=4 self failed.')
    else if (me == 2) then ! Do the real copy to self checks on image 2
      co_real_dst_k4 = -1.0
      co_real_dst_k4(::2)[2] = co_real_src_k4(1:3)[2]
      print *, co_real_dst_k4
      if (any(abs(co_real_dst_k4 - [co_real_src_k4(1), -1.0, co_real_src_k4(2), -1.0, co_real_src_k4(3)]) > tolerance4)) &
        & call print_and_register( 'sendget strided real kind=4 to kind=4 self failed.')

      co_real_dst_k8 = -1.0
      co_real_dst_k8(::2)[2] = co_real_src_k8(1:3)[2]
      print *, co_real_dst_k8
      if (any(abs(co_real_dst_k8 - [co_real_src_k8(1), REAL(-1.0, 8), co_real_src_k8(2), REAL(-1.0, 8), co_real_src_k8(3)]) &
        & > tolerance8)) call print_and_register( 'sendget strided real kind=8 to kind=8 self failed.')

      co_real_dst_k8 = -2.0
      co_real_dst_k8(2::2)[2] = co_real_src_k4(4:5)[2]
      print *, co_real_dst_k8(1:5), lbound(co_real_dst_k8, 1)
      if (any(abs(co_real_dst_k8 - [REAL(-2.0, 8), co_real_src_k8(4), REAL(-2.0, 8), co_real_src_k8(5), REAL(-2.0, 8)]) &
        & > tolerance4to8)) call print_and_register( 'sendget strided real kind=4 to kind=8 self failed.')

      co_real_dst_k4 = -2.0
      co_real_dst_k4(2::2)[2] = co_real_src_k8(1:2)[2]
      print *, co_real_dst_k4
      if (any(abs(co_real_dst_k4 - [-2.0, co_real_src_k4(1), -2.0, co_real_src_k4(2), -2.0]) > tolerance4)) &
        & call print_and_register( 'sendget strided real kind=8 to kind=4 self failed.')

      co_real_dst_k4(1:5) = co_real_src_k4(5:1:-1)
      co_real_dst_k4(::2)[2] = co_real_dst_k4(3:1:-1)[2]
      print *, co_real_dst_k4
      if (any(abs(co_real_dst_k4 - [co_real_src_k4(3), co_real_src_k4(4), co_real_src_k4(4), co_real_src_k4(2), &
        & co_real_src_k4(5)]) > tolerance4)) &
        & call print_and_register( 'sendget strided with temp real kind=4 to kind=4 self failed.')

      co_real_dst_k8(1:5) = co_real_src_k8(5:1:-1)
      co_real_dst_k8(::2)[2] = co_real_dst_k8(3:1:-1)[2]
      print *, co_real_dst_k8
      if (any(abs(co_real_dst_k8 - [co_real_src_k8(3), co_real_src_k8(4), co_real_src_k8(4), co_real_src_k8(2), &
        & co_real_src_k8(5)]) > tolerance8)) &
        & call print_and_register( 'sendget strided with temp real kind=8 to kind=8 self failed.')
    end if

    ! Transfer to other image now.
    sync all
    co_int_dst_k4 = -1
    co_int_dst_k1 = INT(-1, 1)
    co_real_dst_k8 = -1.0
    co_real_dst_k4 = REAL(-1.0, 4)
    sync all
    if (me == 2) then
      co_int_dst_k4(::2)[1] = co_int_src_k4(1:3)[3]

      co_int_dst_k1(::2)[1] = co_int_src_k1(1:3)[3]

      co_real_dst_k8(::2)[1] = co_real_src_k8(1:3)[3]

      co_real_dst_k4(::2)[1] = co_real_src_k4(1:3)[3]
    end if

    sync all
    if (me == 1) then
      print *, co_int_dst_k4
      if (any(co_int_dst_k4 /= [co_int_src_k4(1), -1, co_int_src_k4(2), -1, co_int_src_k4(3)])) &
        & call print_and_register( 'strided sendget int kind=4 to kind=4 from image 3 to image 1 failed.')

      print *, co_int_dst_k1
      if (any(co_int_dst_k1 /= [co_int_src_k1(1), INT(-1, 1), co_int_src_k1(2), INT(-1, 1), co_int_src_k1(3)])) &
        & call print_and_register( 'strided sendget int kind=1 to kind=1 from image 3 to image 1 failed.')

      print *, co_real_dst_k8
      if (any(abs(co_real_dst_k8 - [co_real_src_k8(1), REAL(-1.0, 8), co_real_src_k8(2), REAL(-1.0, 8), &
        & co_real_src_k8(3)]) > tolerance8)) &
        & call print_and_register( 'strided sendget real kind=8 to kind=8 from image 3 to image 1 failed.')

      print *, co_real_dst_k4
      if (any(abs(co_real_dst_k4 - [co_real_src_k4(1), REAL(-1.0, 4), co_real_src_k4(2), REAL(-1.0, 4), &
        & co_real_src_k4(3)]) > tolerance4)) &
        & call print_and_register( 'strided sendget real kind=4 to kind=4 from image 3 to image 1 failed.')
    end if

    ! now with strides and kind conversion
    sync all
    co_int_dst_k4 = -1
    co_int_dst_k1 = INT(-1, 1)
    co_real_dst_k8 = -1.0
    co_real_dst_k4 = REAL(-1.0, 4)
    sync all
    if (me == 2) then
      co_int_dst_k4(::2)[1] = co_int_src_k1(3:5)[3]

      co_int_dst_k1(::2)[1] = co_int_src_k4(3:5)[3]

      co_real_dst_k8(::2)[1] = co_real_src_k4(3:5)[3]

      co_real_dst_k4(::2)[1] = co_real_src_k8(3:5)[3]
    end if

    sync all
    if (me == 1) then
      print *, co_int_dst_k4
      if (any(co_int_dst_k4 /= [co_int_src_k4(3), -1, co_int_src_k4(4), -1, co_int_src_k4(5)])) &
        & call print_and_register( 'strided sendget int kind=1 to kind=4 from image 3 to image 1 failed.')

      print *, co_int_dst_k1
      if (any(co_int_dst_k1 /= [co_int_src_k1(3), INT(-1, 1), co_int_src_k1(4), INT(-1, 1), co_int_src_k1(5)])) &
        & call print_and_register( 'strided sendget int kind=4 to kind=1 from image 3 to image 1 failed.')

      print *, co_real_dst_k8
      if (any(abs(co_real_dst_k8 - [co_real_src_k8(3), REAL(-1.0, 8), co_real_src_k8(4), REAL(-1.0, 8), &
        & co_real_src_k8(5)]) > tolerance8)) &
        & call print_and_register( 'strided sendget real kind=4 to kind=8 from image 3 to image 1 failed.')

      print *, co_real_dst_k4
      if (any(abs(co_real_dst_k4 - [co_real_src_k4(3), REAL(-1.0, 4), co_real_src_k4(4), REAL(-1.0, 4), &
        & co_real_src_k4(5)]) > tolerance4)) &
        & call print_and_register( 'strided sendget real kind=8 to kind=4 from image 3 to image 1 failed.')
    end if

    ! now with strides and type conversion
    sync all
    co_int_dst_k4 = -1
    co_int_dst_k1 = INT(-1, 1)
    co_real_dst_k8 = -1.0
    co_real_dst_k4 = REAL(-1.0, 4)
    sync all
    if (me == 2) then
      co_int_dst_k4(::2)[1] = co_real_src_k8(1:3)[3]

      co_int_dst_k1(::2)[1] = co_real_src_k4(1:3)[3]

      co_real_dst_k8(::2)[1] = co_int_src_k4(3:5)[3]

      co_real_dst_k4(::2)[1] = co_int_src_k1(3:5)[3]
    end if

    sync all
    if (me == 1) then
      print *, co_int_dst_k4
      if (any(co_int_dst_k4 /= [5, -1, 4, -1, 3])) &
        & call print_and_register( 'strided sendget real kind=4 to int kind=4 from image 3 to image 1 failed.')

      print *, co_int_dst_k1
      if (any(co_int_dst_k1 /= [INT(5, 1), INT(-1, 1), INT(4, 1), INT(-1, 1), INT(3, 1)])) &
        & call print_and_register( 'strided sendget int real kind=4 to int kind=1 from image 3 to image 1 failed.')

      print *, co_real_dst_k8
      if (any(abs(co_real_dst_k8 - [3.0, -1.0, 2.0, -1.0, 1.0]) > tolerance8)) &
        & call print_and_register( 'strided sendget int kind=4 to real kind=8 from image 3 to image 1 failed.')

      print *, co_real_dst_k4
      if (any(abs(co_real_dst_k4 - [REAL(3, 4), REAL(-1.0, 4), REAL(2, 4), REAL(-1.0, 4), REAL(1, 4)]) > tolerance4)) &
        & call print_and_register( 'strided sendget int kind=4 to real kind=4 from image 3 to image 1 failed.')
    end if

    select case(me)
     case(1)
       if (error_printed) error stop
       sync images([2,3])
       print *, "Test passed."
     case(2)
       if (error_printed) error stop
       sync images(1)
     case(3)
       if (error_printed) error stop
       sync images(1)
    end select

  end associate

contains

  subroutine print_and_register(error_message)
    use iso_fortran_env, only : error_unit
    character(len=*), intent(in) :: error_message
    write(error_unit,*) error_message
    error_printed=.true.
  end subroutine

end program sendget_convert_nums

! vim:ts=2:sts=2:sw=2:

program get_with_vector_index
  use iso_fortran_env
  implicit none
  integer, parameter :: nloc=8, nhl=2, ivsize=nloc+2*nhl
  real    :: xv(ivsize)[*]
  real, allocatable :: expected(:,:)
  integer :: rmt_idx(2,2), loc_idx(2,2)
  integer, allocatable :: xchg(:)
  integer :: nrcv, me, np, nxch, i, ip, iv
  character(len=120) :: fmt

  me = this_image()
  np = num_images()
  
  if (np==1) then
    !    allocate(xchg(0))
    xchg = [ integer :: ]
    
  else if (me == 1) then
    xchg = [me+1]
  else if (me == np) then
    xchg = [me-1]
  else
    xchg = [me-1, me+1]
  end if
  nxch = size(xchg)
  nrcv = nxch * nhl 

  allocate(expected(nxch, nhl))
  xv(1:nloc) = [(i,i=(me-1)*nloc+1,me*nloc)]
  iv = nloc + 1
  do ip=1, nxch
    loc_idx(1:nhl,ip) = [ (i,i=iv,iv+nhl-1) ]
    if (xchg(ip) == me-1) then
      rmt_idx(1:nhl,ip) = [ (i,i=nloc-nhl+1,nloc) ]
    else
      rmt_idx(1:nhl,ip) = [ (i,i=1,nhl) ]
    end if
    iv = iv + nhl
  end do

  sync images(xchg)
  iv = nloc + 1
  do ip=1, nxch
    !    xv(loc_idx(1:nhl,ip)) = xv(rmt_idx(1:nhl,ip))[xchg(ip)]
    write(*,*) me,': Reading from :',xchg(ip),' :',rmt_idx(1:nhl,ip),' :',loc_idx(1:nhl,ip)
          
    xv(iv:iv+nhl-1) = xv(rmt_idx(1:nhl,ip))[xchg(ip)]
    iv = iv + nhl
  end do
  if (me == 1) then
    expected(1,:) = nloc + rmt_idx(1:nhl, 1)
  else if (me == np) then
    expected(1,:) = ((np - 2) * nloc) + rmt_idx(1:nhl, 1)
  else
    expected(1,:) = ((me - 2) * nloc) + rmt_idx(1:nhl, 1)
    expected(2,:) = ( me      * nloc) + rmt_idx(1:nhl, 2)
  end if

 
  sync all 
  do ip=1, nxch
    write(fmt,*) '( i0,a,',nloc,'(f5.0,1x),a,',nrcv,'(f5.0,1x) )'
    write(*,fmt) me,': From halo exchange :',xv(1:nloc),':',xv(nloc+1:nloc+nrcv)
    if (any(xv(loc_idx(1:nhl, ip)) /= expected(ip,:))) error stop 'Test failed.'
  end do

  sync all
  if (me == 1) print *, 'Test passed.'
end program get_with_vector_index

module opencoarrays_object_interface
  !! Object pattern abstract type to provide a universal interface to a userd-defined derived type ouptput
  !! capability specified in a generic binding
  implicit none

  type, abstract :: object
  contains
    procedure(write_formatted_interface), deferred :: write_formatted
    generic :: write(formatted) => write_formatted
  end type

  abstract interface
    subroutine write_formatted_interface(this,unit,iotype,vlist,iostat,iomsg)
      import object
      class(object), intent(in) :: this
      integer, intent(in) :: unit
      character (len=*), intent(in) :: iotype
      integer, intent(in) :: vlist(:)
      integer, intent(out) :: iostat
      character (len=*), intent(inout) :: iomsg
    end subroutine
  end interface

end module

! async-hello-2015.f90
!
! -- A Parallel "Hello World" program in Fortran 2015: 
!    Image 1 asynchronously gets and prints greetings defined by every image.
!
! The program uses event post, query, and wait defined by a  Fortarn 2015.
program main
  use iso_fortran_env, only : event_type,output_unit
  implicit none

  character(len=48) :: greeting[*]
  type(event_type), allocatable :: greeting_ready(:)[:]
  type(event_type) :: ok_to_overwrite[*]
  integer :: step
  integer, parameter :: nsteps=4

  associate( me=>this_image(), ni=>num_images() )

    allocate(greeting_ready(ni)[*])

    do step=1,nsteps

      if (me/=1) then
        ! Wait for image 1 signal that it has the previous greeting 
        if (step>1) event wait( ok_to_overwrite ) ! Atomically decrements my ok-to-write counter
        write(greeting,"(3(a,i2))") "Greetings from image ",me," of ",ni," on step ",step
        ! Signal image 1 that a new greeting is ready for pickup:
        event post(greeting_ready(me)[1])              ! Atomically increments my event greeting-ready counter on image 1

      else

        write(greeting,"(3(a,i2))") "Greetings from image ",me," of ",ni," on step ",step

        spin_query_work: block
          integer :: image,ready_count
          integer, save, allocatable :: previous_count(:)
          logical, dimension(2:ni) :: greeting_not_printed
          integer, parameter :: max_single_digit=9

          if (.not. allocated(previous_count)) allocate(previous_count(2:ni),source=0)
 
          greeting_not_printed=.true. 

          spin: do while( any( greeting_not_printed  ) ) ! Loop until all greetings have been printed
            query: do image=2,min(ni,max_single_digit)   ! Atomically access each event's counter 
              if (greeting_not_printed(image)) then      ! Print greetings that have not been printed during this step
                call event_query( greeting_ready(image), ready_count)
                work_if_ready: select case(ready_count-previous_count(image))
                  case(0) ! keep spinning until greeting is ready
                  case(1) ! event posted so get and print greeting
                    write(greeting,"(a)") greeting[image]
                    associate(expected_location=>23)
                      ! Verify that the greetings of images 1-9 have their image number at the expected location:
                      if (scan(greeting,set="123456789")/=expected_location) error stop "Test failed."
                    end associate
                    event post(ok_to_overwrite[image])  
                    greeting_not_printed(image)=.false. 
                    previous_count(image)=ready_count
                  case default
                    if (ready_count<0) error stop "compiler bug: negative event_query count"
                    error stop "multiple events happened since last the last event query"
                end select work_if_ready
              end if
            end do query
          end do spin

        end block spin_query_work
      end if
    end do

    sync all
    if (me==1) print *,"Test passed."

  end associate


end program

! Unit test for initializion of MPI by LIBCAF_MPI.
!
! Copyright (c) 2012-2014, Sourcery, Inc.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of the Sourcery, Inc., nor the
!       names of its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE FOR ANY
! DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
program initialize_mpi
#ifdef MPI_WORKING_MODULE
  use mpi, only : MPI_COMM_SIZE,MPI_COMM_WORLD
  implicit none
#else
  implicit none
  include 'mpif.h'
  interface
     subroutine MPI_COMM_SIZE(mpi_comm,nranks,ierr)
       integer, intent(in)  :: mpi_comm
       integer, intent(out) :: nranks, ierr
     end subroutine
  end interface
#endif

  ! Set invalid default image number and number of ranks
  integer :: me=-1,np=-1,ierr

  ! Get image number
  me = this_image()

  ! Get number of ranks (np)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,np,ierr)

  ! Everybody verifies that they have a valid image number and rank
  if(me < 1 .or. np < 1 .or. me > np) error stop "Test failed."

  sync all

  ! Image 1 reports test success
  if(me==1) print *,"Test passed."
end program

! Coarray 1D Heat Equation Solver Test: global_field_module
!
! Copyright (c) 2012-2014, Sourcery, Inc.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of the Sourcery, Inc., nor the
!       names of its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE FOR ANY
! DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
!
module global_field_module
  use local_field_module, only : local_field
  implicit none
  private
  public :: global_field

  type global_field
    private
    real, allocatable :: values(:)[:]
  contains
    procedure :: set
    procedure :: only_allocate
    generic :: global_field_=>set,only_allocate
    procedure, private :: laplacian
    generic :: operator(.laplacian.) => laplacian
    procedure, private :: add_local_field
    generic :: operator(+) => add_local_field
    procedure, private :: assign_local_field
    generic :: assignment(=) => assign_local_field
    procedure :: state
  end type

  real :: dx
  integer, allocatable :: num_local_points
  integer, parameter:: num_end_points=2
  real :: boundary_vals(num_end_points)

contains

  subroutine only_allocate(this)
    class(global_field), intent(inout) :: this
    if (.not.allocated(num_local_points)) error stop "global_field: no value established for memory allocation yet."
    allocate(this%values(num_local_points)[*]) ! Implicit synchronization point
  end subroutine

  subroutine set(this,internal_values,boundary_values,domain,num_global_points)
    class(global_field), intent(inout) :: this
    integer, intent(in) :: num_global_points
    real, intent(in) :: internal_values,domain(num_end_points),boundary_values(num_end_points)
    if (mod(num_global_points,num_images())/=0) error stop "set: num_global_points not evenly divisible by num_images()"
    if (this_image()==1 .or. this_image()==num_images()) boundary_vals = boundary_values
    if (.not.allocated(num_local_points)) num_local_points=num_global_points/num_images()
    dx=(domain(2)-domain(1))/num_global_points
    allocate(this%values(num_local_points)[*])
    associate(west=>1,east=>2)
      this%values(1) = merge(boundary_values(west),internal_values,this_image()==1)
      this%values(2:num_local_points-1) = internal_values
      this%values(num_local_points) = merge(boundary_values(east),internal_values,this_image()==num_images())
    end associate
    call synchronize()
  end subroutine

  subroutine synchronize()
    if (num_images()>1) then
      associate(me=>this_image())
        if (me==1) then
          sync images(me+1)
        else if (me==num_images()) then
          sync images(me-1)
        else
          sync images([me-1,me+1])
        end if
      end associate
    end if
  end subroutine

  pure function laplacian(rhs) result(laplacian_rhs)
    class(global_field), intent(in) :: rhs
    type(local_field) :: laplacian_rhs
    real :: local_laplacian(num_local_points)
    integer :: i
    associate(N=>num_local_points,me=>this_image())
      if (me==1) then
        local_laplacian(1) = 0.
      else
        local_laplacian(1)=(rhs%values(2)-2.*rhs%values(1)+rhs%values(N)[me-1])/dx**2
      end if
      do concurrent(i=2:N-1)
        local_laplacian(i)=(rhs%values(i+1)-2.*rhs%values(i)+rhs%values(i-1))/dx**2
      end do
      if (me==num_images()) then
        local_laplacian(N) = 0.
      else
        local_laplacian(N)=(rhs%values(1)[me+1]-2.*rhs%values(N)+rhs%values(N-1))/dx**2
      end if
    end associate
    laplacian_rhs = local_laplacian
  end function

  pure function add_local_field(lhs,rhs) result(total)
    class(global_field), intent(in) :: lhs
    type(local_field), intent(in) :: rhs
    type(local_field) :: total
    total = lhs%values + rhs%state()
  end function

  subroutine assign_local_field(lhs,rhs)
    class(global_field), intent(inout) :: lhs
    class(local_field), intent(in) :: rhs
    lhs%values(:) = rhs%state()
    call synchronize()
  end subroutine

  pure function state(this) result(this_values)
    class(global_field), intent(in) :: this
    real :: this_values(size(this%values(:)))
    this_values = this%values
  end function

end module

! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
! FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

! Comments preceded by "!!" are formatted for the FOR_codim1 docoumentation generator
program alloc_comp_multidim_shape
  !! summary: Test shape of multidimensional allocatable array coarray components of a
  !!          derived type shape(object%comp(:,:)[1])
  !! author: _codim1amian Rouson , 2018
  !! date: 2018-03-08
  !!
  !! [OpenCoarrays issue #511](https://github.com/sourceryinstitute/opencoarrays/issues/511)

  implicit none

  ! TO_DO: add tests for other types and kinds, including integer, logical, character, and derived types

  type reals
    ! Array coarray component with rank + corank = 2
    real, allocatable :: dim01_codim01(:)[:]
    ! Array coarray components with rank + corank = 3
    real, allocatable :: dim01_codim02(:)[:,:]
    real, allocatable :: dim02_codim01(:,:)[:]
    ! Array coarray components with rank + corank = 4
    real, allocatable :: dim01_codim03(:)[:,:,:]
    real, allocatable :: dim02_codim02(:,:)[:,:]
    real, allocatable :: dim03_codim01(:,:,:)[:]
    ! Array coarray components with rank + corank = 5
    real, allocatable :: dim01_codim04(:)[:,:,:,:]
    real, allocatable :: dim02_codim03(:,:)[:,:,:]
    real, allocatable :: dim03_codim02(:,:,:)[:,:]
    real, allocatable :: dim04_codim01(:,:,:,:)[:]
    ! Array coarray components with rank + corank = 6
    real, allocatable :: dim01_codim05(:)[:,:,:,:,:]
    real, allocatable :: dim02_codim04(:,:)[:,:,:,:]
    real, allocatable :: dim03_codim03(:,:,:)[:,:,:]
    real, allocatable :: dim04_codim02(:,:,:,:)[:,:]
    real, allocatable :: dim05_codim01(:,:,:,:,:)[:]
    ! Array coarray components with rank + corank = 7
    real, allocatable :: dim01_codim06(:)[:,:,:,:,:,:]
    real, allocatable :: dim02_codim05(:,:)[:,:,:,:,:]
    real, allocatable :: dim03_codim04(:,:,:)[:,:,:,:]
    real, allocatable :: dim04_codim03(:,:,:,:)[:,:,:]
    real, allocatable :: dim05_codim02(:,:,:,:,:)[:,:]
    real, allocatable :: dim06_codim01(:,:,:,:,:,:)[:]
#ifdef GCC_GE_8
    ! Array coarray components with rank + corank = 8
    real, allocatable :: dim01_codim07(:)[:,:,:,:,:,:,:]
    real, allocatable :: dim02_codim06(:,:)[:,:,:,:,:,:]
    real, allocatable :: dim03_codim05(:,:,:)[:,:,:,:,:]
    real, allocatable :: dim04_codim04(:,:,:,:)[:,:,:,:]
    real, allocatable :: dim05_codim03(:,:,:,:,:)[:,:,:]
    real, allocatable :: dim06_codim02(:,:,:,:,:,:)[:,:]
    real, allocatable :: dim07_codim01(:,:,:,:,:,:,:)[:]
    ! Array coarray components with rank + corank = 9
    real, allocatable :: dim01_codim08(:)[:,:,:,:,:,:,:,:]
    real, allocatable :: dim02_codim07(:,:)[:,:,:,:,:,:,:]
    real, allocatable :: dim03_codim06(:,:,:)[:,:,:,:,:,:]
    real, allocatable :: dim04_codim05(:,:,:,:)[:,:,:,:,:]
    real, allocatable :: dim05_codim04(:,:,:,:,:)[:,:,:,:]
    real, allocatable :: dim06_codim03(:,:,:,:,:,:)[:,:,:]
    real, allocatable :: dim07_codim02(:,:,:,:,:,:,:)[:,:]
    real, allocatable :: dim08_codim01(:,:,:,:,:,:,:,:)[:]
    ! Array coarray components with rank + corank = 10
    real, allocatable :: dim01_codim09(:)[:,:,:,:,:,:,:,:,:]
    real, allocatable :: dim02_codim08(:,:)[:,:,:,:,:,:,:,:]
    real, allocatable :: dim03_codim07(:,:,:)[:,:,:,:,:,:,:]
    real, allocatable :: dim04_codim06(:,:,:,:)[:,:,:,:,:,:]
    real, allocatable :: dim05_codim05(:,:,:,:,:)[:,:,:,:,:]
    real, allocatable :: dim06_codim04(:,:,:,:,:,:)[:,:,:,:]
    real, allocatable :: dim07_codim03(:,:,:,:,:,:,:)[:,:,:]
    real, allocatable :: dim08_codim02(:,:,:,:,:,:,:,:)[:,:]
    real, allocatable :: dim09_codim01(:,:,:,:,:,:,:,:,:)[:]
    ! Array coarray components with rank + corank = 11
    real, allocatable :: dim01_codim10(:)[:,:,:,:,:,:,:,:,:,:]
    real, allocatable :: dim02_codim09(:,:)[:,:,:,:,:,:,:,:,:]
    real, allocatable :: dim03_codim08(:,:,:)[:,:,:,:,:,:,:,:]
    real, allocatable :: dim04_codim07(:,:,:,:)[:,:,:,:,:,:,:]
    real, allocatable :: dim05_codim06(:,:,:,:,:)[:,:,:,:,:,:]
    real, allocatable :: dim06_codim05(:,:,:,:,:,:)[:,:,:,:,:]
    real, allocatable :: dim07_codim04(:,:,:,:,:,:,:)[:,:,:,:]
    real, allocatable :: dim08_codim03(:,:,:,:,:,:,:,:)[:,:,:]
    real, allocatable :: dim09_codim02(:,:,:,:,:,:,:,:,:)[:,:]
    real, allocatable :: dim10_codim01(:,:,:,:,:,:,:,:,:,:)[:]
    ! Array coarray components with rank + corank = 12
    real, allocatable :: dim01_codim11(:)[:,:,:,:,:,:,:,:,:,:,:]
    real, allocatable :: dim02_codim10(:,:)[:,:,:,:,:,:,:,:,:,:]
    real, allocatable :: dim03_codim09(:,:,:)[:,:,:,:,:,:,:,:,:]
    real, allocatable :: dim04_codim08(:,:,:,:)[:,:,:,:,:,:,:,:]
    real, allocatable :: dim05_codim07(:,:,:,:,:)[:,:,:,:,:,:,:]
    real, allocatable :: dim06_codim06(:,:,:,:,:,:)[:,:,:,:,:,:]
    real, allocatable :: dim07_codim05(:,:,:,:,:,:,:)[:,:,:,:,:]
    real, allocatable :: dim08_codim04(:,:,:,:,:,:,:,:)[:,:,:,:]
    real, allocatable :: dim09_codim03(:,:,:,:,:,:,:,:,:)[:,:,:]
    real, allocatable :: dim10_codim02(:,:,:,:,:,:,:,:,:,:)[:,:]
    real, allocatable :: dim11_codim01(:,:,:,:,:,:,:,:,:,:,:)[:]
    ! Array coarray components with rank + corank = 13
    real, allocatable :: dim01_codim12(:)[:,:,:,:,:,:,:,:,:,:,:,:]
    real, allocatable :: dim02_codim11(:,:)[:,:,:,:,:,:,:,:,:,:,:]
    real, allocatable :: dim03_codim10(:,:,:)[:,:,:,:,:,:,:,:,:,:]
    real, allocatable :: dim04_codim09(:,:,:,:)[:,:,:,:,:,:,:,:,:]
    real, allocatable :: dim05_codim08(:,:,:,:,:)[:,:,:,:,:,:,:,:]
    real, allocatable :: dim06_codim07(:,:,:,:,:,:)[:,:,:,:,:,:,:]
    real, allocatable :: dim07_codim06(:,:,:,:,:,:,:)[:,:,:,:,:,:]
    real, allocatable :: dim08_codim05(:,:,:,:,:,:,:,:)[:,:,:,:,:]
    real, allocatable :: dim09_codim04(:,:,:,:,:,:,:,:,:)[:,:,:,:]
    real, allocatable :: dim10_codim03(:,:,:,:,:,:,:,:,:,:)[:,:,:]
    real, allocatable :: dim11_codim02(:,:,:,:,:,:,:,:,:,:,:)[:,:]
    real, allocatable :: dim12_codim01(:,:,:,:,:,:,:,:,:,:,:,:)[:]
    ! Array coarray components with rank + corank = 14
    real, allocatable :: dim01_codim13(:)[:,:,:,:,:,:,:,:,:,:,:,:,:]
    real, allocatable :: dim02_codim12(:,:)[:,:,:,:,:,:,:,:,:,:,:,:]
    real, allocatable :: dim03_codim11(:,:,:)[:,:,:,:,:,:,:,:,:,:,:]
    real, allocatable :: dim04_codim10(:,:,:,:)[:,:,:,:,:,:,:,:,:,:]
    real, allocatable :: dim05_codim09(:,:,:,:,:)[:,:,:,:,:,:,:,:,:]
    real, allocatable :: dim06_codim08(:,:,:,:,:,:)[:,:,:,:,:,:,:,:]
    real, allocatable :: dim07_codim07(:,:,:,:,:,:,:)[:,:,:,:,:,:,:]
    real, allocatable :: dim08_codim06(:,:,:,:,:,:,:,:)[:,:,:,:,:,:]
    real, allocatable :: dim09_codim05(:,:,:,:,:,:,:,:,:)[:,:,:,:,:]
    real, allocatable :: dim10_codim04(:,:,:,:,:,:,:,:,:,:)[:,:,:,:]
    real, allocatable :: dim11_codim03(:,:,:,:,:,:,:,:,:,:,:)[:,:,:]
    real, allocatable :: dim12_codim02(:,:,:,:,:,:,:,:,:,:,:,:)[:,:]
    real, allocatable :: dim13_codim01(:,:,:,:,:,:,:,:,:,:,:,:,:)[:]
    ! Array coarray components with rank + corank = 15
    real, allocatable :: dim01_codim14(:)[:,:,:,:,:,:,:,:,:,:,:,:,:,:]
    real, allocatable :: dim02_codim13(:,:)[:,:,:,:,:,:,:,:,:,:,:,:,:]
    real, allocatable :: dim03_codim12(:,:,:)[:,:,:,:,:,:,:,:,:,:,:,:]
    real, allocatable :: dim04_codim11(:,:,:,:)[:,:,:,:,:,:,:,:,:,:,:]
    real, allocatable :: dim05_codim10(:,:,:,:,:)[:,:,:,:,:,:,:,:,:,:]
    real, allocatable :: dim06_codim09(:,:,:,:,:,:)[:,:,:,:,:,:,:,:,:]
    real, allocatable :: dim07_codim08(:,:,:,:,:,:,:)[:,:,:,:,:,:,:,:]
    real, allocatable :: dim08_codim07(:,:,:,:,:,:,:,:)[:,:,:,:,:,:,:]
    real, allocatable :: dim09_codim06(:,:,:,:,:,:,:,:,:)[:,:,:,:,:,:]
    real, allocatable :: dim10_codim05(:,:,:,:,:,:,:,:,:,:)[:,:,:,:,:]
    real, allocatable :: dim11_codim04(:,:,:,:,:,:,:,:,:,:,:)[:,:,:,:]
    real, allocatable :: dim12_codim03(:,:,:,:,:,:,:,:,:,:,:,:)[:,:,:]
    real, allocatable :: dim13_codim02(:,:,:,:,:,:,:,:,:,:,:,:,:)[:,:]
    real, allocatable :: dim14_codim01(:,:,:,:,:,:,:,:,:,:,:,:,:,:)[:]
#endif
  end type

  type(reals), save :: object

  logical :: error_printed=.false.

  integer, parameter :: shape01D(*)=[2]
  integer, parameter :: shape02D(*)=[2,2]
  integer, parameter :: shape03D(*)=[2,2,2]
  integer, parameter :: shape04D(*)=[2,2,2,2]
  integer, parameter :: shape05D(*)=[2,2,2,2,2]
  integer, parameter :: shape06D(*)=[2,2,2,2,2,2]
  integer, parameter :: shape07D(*)=[2,2,2,2,2,2,2]
  integer, parameter :: shape08D(*)=[2,2,2,2,2,2,2,2]
  integer, parameter :: shape09D(*)=[2,2,2,2,2,2,2,2,2]
  integer, parameter :: shape10D(*)=[2,2,2,2,2,2,2,2,2,2]
  integer, parameter :: shape11D(*)=[2,2,2,2,2,2,2,2,2,2,2]
  integer, parameter :: shape12D(*)=[2,2,2,2,2,2,2,2,2,2,2,2]
  integer, parameter :: shape13D(*)=[2,2,2,2,2,2,2,2,2,2,2,2,2]
  integer, parameter :: shape14D(*)=[2,2,2,2,2,2,2,2,2,2,2,2,2,2]

  associate(me => this_image(), np => num_images())

  ! Array coarray component with rank + corank = 2
  allocate(object%dim01_codim01(2)[*])
  if (any( shape(object%dim01_codim01(:)[1]) /= [2] )) call print_log('misshapen dim01_codim01')

  ! Array coarray components with rank + corank = 3
  allocate(object%dim01_codim02(2)[1,*])
  allocate(object%dim02_codim01(2,2)[*])
  if (any( shape(object%dim01_codim02(:)[1,1]) /= shape01D )) call print_log('misshapen dim01_codim02')
  if (any( shape(object%dim02_codim01(:,:)[1]) /= shape02D )) call print_log('misshapen dim02_codim01')

  ! Array coarray components with rank + corank = 4
  allocate(object%dim01_codim03(2)[1,1,*])
  allocate(object%dim02_codim02(2,2)[1,*])
  allocate(object%dim03_codim01(2,2,2)[*])
  if (any( shape(object%dim01_codim03(:)[1,1,1]) /= shape01D )) call print_log('misshapen dim01_codim03')
  if (any( shape(object%dim02_codim02(:,:)[1,1]) /= shape02D )) call print_log('misshapen dim02_codim02')
  if (any( shape(object%dim03_codim01(:,:,:)[1]) /= shape03D )) call print_log('misshapen dim03_codim01')

  ! Array coarray components with rank + corank = 5
  allocate(object%dim01_codim04(2)[1,1,1,*])
  allocate(object%dim02_codim03(2,2)[1,1,*])
  allocate(object%dim03_codim02(2,2,2)[1,*])
  allocate(object%dim04_codim01(2,2,2,2)[*])
  if (any( shape(object%dim01_codim04(:)[1,1,1,1]) /= shape01D )) call print_log('misshapen dim01_codim04')
  if (any( shape(object%dim02_codim03(:,:)[1,1,1]) /= shape02D )) call print_log('misshapen dim02_codim03')
  if (any( shape(object%dim03_codim02(:,:,:)[1,1]) /= shape03D )) call print_log('misshapen dim03_codim02')
  if (any( shape(object%dim04_codim01(:,:,:,:)[1]) /= shape04D )) call print_log('misshapen dim04_codim01')

  ! Array coarray components with rank + corank = 6
  allocate(object%dim01_codim05(2)[1,1,1,1,*])
  allocate(object%dim02_codim04(2,2)[1,1,1,*])
  allocate(object%dim03_codim03(2,2,2)[1,1,*])
  allocate(object%dim04_codim02(2,2,2,2)[1,*])
  allocate(object%dim05_codim01(2,2,2,2,2)[*])
  if (any( shape(object%dim01_codim05(:)[1,1,1,1,1]) /= shape01D )) call print_log('misshapen dim01_codim05')
  if (any( shape(object%dim02_codim04(:,:)[1,1,1,1]) /= shape02D )) call print_log('misshapen dim02_codim04')
  if (any( shape(object%dim03_codim03(:,:,:)[1,1,1]) /= shape03D )) call print_log('misshapen dim03_codim03')
  if (any( shape(object%dim04_codim02(:,:,:,:)[1,1]) /= shape04D )) call print_log('misshapen dim04_codim02')
  if (any( shape(object%dim05_codim01(:,:,:,:,:)[1]) /= shape05D )) call print_log('misshapen dim05_codim01')

  ! Array coarray components with rank + corank = 7
  allocate(object%dim01_codim06(2)[1,1,1,1,1,*])
  allocate(object%dim02_codim05(2,2)[1,1,1,1,*])
  allocate(object%dim03_codim04(2,2,2)[1,1,1,*])
  allocate(object%dim04_codim03(2,2,2,2)[1,1,*])
  allocate(object%dim05_codim02(2,2,2,2,2)[1,*])
  allocate(object%dim06_codim01(2,2,2,2,2,2)[*])
  if (any( shape(object%dim01_codim06(:)[1,1,1,1,1,1]) /= shape01D )) call print_log('misshapen dim01_codim06')
  if (any( shape(object%dim02_codim05(:,:)[1,1,1,1,1]) /= shape02D )) call print_log('misshapen dim02_codim05')
  if (any( shape(object%dim03_codim04(:,:,:)[1,1,1,1]) /= shape03D )) call print_log('misshapen dim03_codim04')
  if (any( shape(object%dim04_codim03(:,:,:,:)[1,1,1]) /= shape04D )) call print_log('misshapen dim04_codim03')
  if (any( shape(object%dim05_codim02(:,:,:,:,:)[1,1]) /= shape05D )) call print_log('misshapen dim05_codim02')
  if (any( shape(object%dim06_codim01(:,:,:,:,:,:)[1]) /= shape06D )) call print_log('misshapen dim06_codim01')

#ifdef GCC_GE_8

  ! Array coarray components with rank + corank = 8
  allocate(object%dim01_codim07(2)[1,1,1,1,1,1,*])
  allocate(object%dim02_codim06(2,2)[1,1,1,1,1,*])
  allocate(object%dim03_codim05(2,2,2)[1,1,1,1,*])
  allocate(object%dim04_codim04(2,2,2,2)[1,1,1,*])
  allocate(object%dim05_codim03(2,2,2,2,2)[1,1,*])
  allocate(object%dim06_codim02(2,2,2,2,2,2)[1,*])
  allocate(object%dim07_codim01(2,2,2,2,2,2,2)[*])
  if (any( shape(object%dim01_codim07(:)[1,1,1,1,1,1,1]) /= shape01D )) call print_log('misshapen dim01_codim07')
  if (any( shape(object%dim02_codim06(:,:)[1,1,1,1,1,1]) /= shape02D )) call print_log('misshapen dim02_codim06')
  if (any( shape(object%dim03_codim05(:,:,:)[1,1,1,1,1]) /= shape03D )) call print_log('misshapen dim03_codim05')
  if (any( shape(object%dim04_codim04(:,:,:,:)[1,1,1,1]) /= shape04D )) call print_log('misshapen dim04_codim04')
  if (any( shape(object%dim05_codim03(:,:,:,:,:)[1,1,1]) /= shape05D )) call print_log('misshapen dim05_codim03')
  if (any( shape(object%dim06_codim02(:,:,:,:,:,:)[1,1]) /= shape06D )) call print_log('misshapen dim06_codim02')
  if (any( shape(object%dim07_codim01(:,:,:,:,:,:,:)[1]) /= shape07D )) call print_log('misshapen dim07_codim01')

  ! Array coarray components with rank + corank = 9
  allocate(object%dim01_codim08(2)[1,1,1,1,1,1,1,*])
  allocate(object%dim02_codim07(2,2)[1,1,1,1,1,1,*])
  allocate(object%dim03_codim06(2,2,2)[1,1,1,1,1,*])
  allocate(object%dim04_codim05(2,2,2,2)[1,1,1,1,*])
  allocate(object%dim05_codim04(2,2,2,2,2)[1,1,1,*])
  allocate(object%dim06_codim03(2,2,2,2,2,2)[1,1,*])
  allocate(object%dim07_codim02(2,2,2,2,2,2,2)[1,*])
  allocate(object%dim08_codim01(2,2,2,2,2,2,2,2)[*])
  if (any(shape(object%dim01_codim08(:)[1,1,1,1,1,1,1,1]) /= shape01D )) call print_log('misshapen dim01_codim08')
  if (any(shape(object%dim02_codim07(:,:)[1,1,1,1,1,1,1]) /= shape02D )) call print_log('misshapen dim02_codim07')
  if (any(shape(object%dim03_codim06(:,:,:)[1,1,1,1,1,1]) /= shape03D )) call print_log('misshapen dim03_codim06')
  if (any(shape(object%dim04_codim05(:,:,:,:)[1,1,1,1,1]) /= shape04D )) call print_log('misshapen dim04_codim05')
  if (any(shape(object%dim05_codim04(:,:,:,:,:)[1,1,1,1]) /= shape05D )) call print_log('misshapen dim05_codim04')
  if (any(shape(object%dim06_codim03(:,:,:,:,:,:)[1,1,1]) /= shape06D )) call print_log('misshapen dim06_codim03')
  if (any(shape(object%dim07_codim02(:,:,:,:,:,:,:)[1,1]) /= shape07D )) call print_log('misshapen dim07_codim02')
  if (any(shape(object%dim08_codim01(:,:,:,:,:,:,:,:)[1]) /= shape08D )) call print_log('misshapen dim08_codim01')

  ! Array coarray components with rank + corank = 10
  allocate(object%dim01_codim09(2)[1,1,1,1,1,1,1,1,*])
  allocate(object%dim02_codim08(2,2)[1,1,1,1,1,1,1,*])
  allocate(object%dim03_codim07(2,2,2)[1,1,1,1,1,1,*])
  allocate(object%dim04_codim06(2,2,2,2)[1,1,1,1,1,*])
  allocate(object%dim05_codim05(2,2,2,2,2)[1,1,1,1,*])
  allocate(object%dim06_codim04(2,2,2,2,2,2)[1,1,1,*])
  allocate(object%dim07_codim03(2,2,2,2,2,2,2)[1,1,*])
  allocate(object%dim08_codim02(2,2,2,2,2,2,2,2)[1,*])
  allocate(object%dim09_codim01(2,2,2,2,2,2,2,2,2)[*])
  if (any( shape(object%dim01_codim09(:)[1,1,1,1,1,1,1,1,1]) /= shape01D )) call print_log('misshapen dim01_codim09')
  if (any( shape(object%dim02_codim08(:,:)[1,1,1,1,1,1,1,1]) /= shape02D )) call print_log('misshapen dim02_codim08')
  if (any( shape(object%dim03_codim07(:,:,:)[1,1,1,1,1,1,1]) /= shape03D )) call print_log('misshapen dim03_codim07')
  if (any( shape(object%dim04_codim06(:,:,:,:)[1,1,1,1,1,1]) /= shape04D )) call print_log('misshapen dim04_codim06')
  if (any( shape(object%dim05_codim05(:,:,:,:,:)[1,1,1,1,1]) /= shape05D )) call print_log('misshapen dim05_codim05')
  if (any( shape(object%dim06_codim04(:,:,:,:,:,:)[1,1,1,1]) /= shape06D )) call print_log('misshapen dim06_codim04')
  if (any( shape(object%dim07_codim03(:,:,:,:,:,:,:)[1,1,1]) /= shape07D )) call print_log('misshapen dim07_codim03')
  if (any( shape(object%dim08_codim02(:,:,:,:,:,:,:,:)[1,1]) /= shape08D )) call print_log('misshapen dim08_codim02')
  if (any( shape(object%dim09_codim01(:,:,:,:,:,:,:,:,:)[1]) /= shape09D )) call print_log('misshapen dim09_codim01')

  ! Array coarray components with rank + corank = 11
  allocate(object%dim01_codim10(2)[1,1,1,1,1,1,1,1,1,*])
  allocate(object%dim02_codim09(2,2)[1,1,1,1,1,1,1,1,*])
  allocate(object%dim03_codim08(2,2,2)[1,1,1,1,1,1,1,*])
  allocate(object%dim04_codim07(2,2,2,2)[1,1,1,1,1,1,*])
  allocate(object%dim05_codim06(2,2,2,2,2)[1,1,1,1,1,*])
  allocate(object%dim06_codim05(2,2,2,2,2,2)[1,1,1,1,*])
  allocate(object%dim07_codim04(2,2,2,2,2,2,2)[1,1,1,*])
  allocate(object%dim08_codim03(2,2,2,2,2,2,2,2)[1,1,*])
  allocate(object%dim09_codim02(2,2,2,2,2,2,2,2,2)[1,*])
  allocate(object%dim10_codim01(2,2,2,2,2,2,2,2,2,2)[*])
  if (any( shape(object%dim01_codim10(:)[1,1,1,1,1,1,1,1,1,1]) /= shape01D )) call print_log('misshapen dim01_codim10')
  if (any( shape(object%dim02_codim09(:,:)[1,1,1,1,1,1,1,1,1]) /= shape02D )) call print_log('misshapen dim02_codim09')
  if (any( shape(object%dim03_codim08(:,:,:)[1,1,1,1,1,1,1,1]) /= shape03D )) call print_log('misshapen dim03_codim08')
  if (any( shape(object%dim04_codim07(:,:,:,:)[1,1,1,1,1,1,1]) /= shape04D )) call print_log('misshapen dim04_codim07')
  if (any( shape(object%dim05_codim06(:,:,:,:,:)[1,1,1,1,1,1]) /= shape05D )) call print_log('misshapen dim05_codim06')
  if (any( shape(object%dim06_codim05(:,:,:,:,:,:)[1,1,1,1,1]) /= shape06D )) call print_log('misshapen dim06_codim05')
  if (any( shape(object%dim07_codim04(:,:,:,:,:,:,:)[1,1,1,1]) /= shape07D )) call print_log('misshapen dim07_codim04')
  if (any( shape(object%dim08_codim03(:,:,:,:,:,:,:,:)[1,1,1]) /= shape08D )) call print_log('misshapen dim08_codim03')
  if (any( shape(object%dim09_codim02(:,:,:,:,:,:,:,:,:)[1,1]) /= shape09D )) call print_log('misshapen dim09_codim02')
  if (any( shape(object%dim10_codim01(:,:,:,:,:,:,:,:,:,:)[1]) /= shape10D )) call print_log('misshapen dim10_codim01')

  ! Array coarray components with rank + corank = 12
  allocate(object%dim01_codim11(2)[1,1,1,1,1,1,1,1,1,1,*])
  allocate(object%dim02_codim10(2,2)[1,1,1,1,1,1,1,1,1,*])
  allocate(object%dim03_codim09(2,2,2)[1,1,1,1,1,1,1,1,*])
  allocate(object%dim04_codim08(2,2,2,2)[1,1,1,1,1,1,1,*])
  allocate(object%dim05_codim07(2,2,2,2,2)[1,1,1,1,1,1,*])
  allocate(object%dim06_codim06(2,2,2,2,2,2)[1,1,1,1,1,*])
  allocate(object%dim07_codim05(2,2,2,2,2,2,2)[1,1,1,1,*])
  allocate(object%dim08_codim04(2,2,2,2,2,2,2,2)[1,1,1,*])
  allocate(object%dim09_codim03(2,2,2,2,2,2,2,2,2)[1,1,*])
  allocate(object%dim10_codim02(2,2,2,2,2,2,2,2,2,2)[1,*])
  allocate(object%dim11_codim01(2,2,2,2,2,2,2,2,2,2,2)[*])
  if (any( shape(object%dim01_codim11(:)[1,1,1,1,1,1,1,1,1,1,1]) /= shape01D )) call print_log('misshapen dim01_codim11')
  if (any( shape(object%dim02_codim10(:,:)[1,1,1,1,1,1,1,1,1,1]) /= shape02D )) call print_log('misshapen dim02_codim10')
  if (any( shape(object%dim03_codim09(:,:,:)[1,1,1,1,1,1,1,1,1]) /= shape03D )) call print_log('misshapen dim03_codim09')
  if (any( shape(object%dim04_codim08(:,:,:,:)[1,1,1,1,1,1,1,1]) /= shape04D )) call print_log('misshapen dim04_codim08')
  if (any( shape(object%dim05_codim07(:,:,:,:,:)[1,1,1,1,1,1,1]) /= shape05D )) call print_log('misshapen dim05_codim07')
  if (any( shape(object%dim06_codim06(:,:,:,:,:,:)[1,1,1,1,1,1]) /= shape06D )) call print_log('misshapen dim06_codim06')
  if (any( shape(object%dim07_codim05(:,:,:,:,:,:,:)[1,1,1,1,1]) /= shape07D )) call print_log('misshapen dim07_codim05')
  if (any( shape(object%dim08_codim04(:,:,:,:,:,:,:,:)[1,1,1,1]) /= shape08D )) call print_log('misshapen dim08_codim04')
  if (any( shape(object%dim09_codim03(:,:,:,:,:,:,:,:,:)[1,1,1]) /= shape09D )) call print_log('misshapen dim09_codim03')
  if (any( shape(object%dim10_codim02(:,:,:,:,:,:,:,:,:,:)[1,1]) /= shape10D )) call print_log('misshapen dim10_codim02')
  if (any( shape(object%dim11_codim01(:,:,:,:,:,:,:,:,:,:,:)[1]) /= shape11D )) call print_log('misshapen dim11_codim01')

  ! Array coarray components with rank + corank = 13
  allocate(object%dim01_codim12(2)[1,1,1,1,1,1,1,1,1,1,1,*])
  allocate(object%dim02_codim11(2,2)[1,1,1,1,1,1,1,1,1,1,*])
  allocate(object%dim03_codim10(2,2,2)[1,1,1,1,1,1,1,1,1,*])
  allocate(object%dim04_codim09(2,2,2,2)[1,1,1,1,1,1,1,1,*])
  allocate(object%dim05_codim08(2,2,2,2,2)[1,1,1,1,1,1,1,*])
  allocate(object%dim06_codim07(2,2,2,2,2,2)[1,1,1,1,1,1,*])
  allocate(object%dim07_codim06(2,2,2,2,2,2,2)[1,1,1,1,1,*])
  allocate(object%dim08_codim05(2,2,2,2,2,2,2,2)[1,1,1,1,*])
  allocate(object%dim09_codim04(2,2,2,2,2,2,2,2,2)[1,1,1,*])
  allocate(object%dim10_codim03(2,2,2,2,2,2,2,2,2,2)[1,1,*])
  allocate(object%dim11_codim02(2,2,2,2,2,2,2,2,2,2,2)[1,*])
  allocate(object%dim12_codim01(2,2,2,2,2,2,2,2,2,2,2,2)[*])
  if (any( shape(object%dim01_codim12(:)[1,1,1,1,1,1,1,1,1,1,1,1]) /= shape01D )) call print_log('misshapen dim01_codim12')
  if (any( shape(object%dim02_codim11(:,:)[1,1,1,1,1,1,1,1,1,1,1]) /= shape02D )) call print_log('misshapen dim02_codim11')
  if (any( shape(object%dim03_codim10(:,:,:)[1,1,1,1,1,1,1,1,1,1]) /= shape03D )) call print_log('misshapen dim03_codim10')
  if (any( shape(object%dim04_codim09(:,:,:,:)[1,1,1,1,1,1,1,1,1]) /= shape04D )) call print_log('misshapen dim04_codim09')
  if (any( shape(object%dim05_codim08(:,:,:,:,:)[1,1,1,1,1,1,1,1]) /= shape05D )) call print_log('misshapen dim05_codim08')
  if (any( shape(object%dim06_codim07(:,:,:,:,:,:)[1,1,1,1,1,1,1]) /= shape06D )) call print_log('misshapen dim06_codim07')
  if (any( shape(object%dim07_codim06(:,:,:,:,:,:,:)[1,1,1,1,1,1]) /= shape07D )) call print_log('misshapen dim07_codim06')
  if (any( shape(object%dim08_codim05(:,:,:,:,:,:,:,:)[1,1,1,1,1]) /= shape08D )) call print_log('misshapen dim08_codim05')
  if (any( shape(object%dim09_codim04(:,:,:,:,:,:,:,:,:)[1,1,1,1]) /= shape09D )) call print_log('misshapen dim09_codim04')
  if (any( shape(object%dim10_codim03(:,:,:,:,:,:,:,:,:,:)[1,1,1]) /= shape10D )) call print_log('misshapen dim10_codim03')
  if (any( shape(object%dim11_codim02(:,:,:,:,:,:,:,:,:,:,:)[1,1]) /= shape11D )) call print_log('misshapen dim11_codim02')
  if (any( shape(object%dim12_codim01(:,:,:,:,:,:,:,:,:,:,:,:)[1]) /= shape12D )) call print_log('misshapen dim12_codim01')

  ! Array coarray components with rank + corank = 14
  allocate(object%dim01_codim13(2)[1,1,1,1,1,1,1,1,1,1,1,1,*])
  allocate(object%dim02_codim12(2,2)[1,1,1,1,1,1,1,1,1,1,1,*])
  allocate(object%dim03_codim11(2,2,2)[1,1,1,1,1,1,1,1,1,1,*])
  allocate(object%dim04_codim10(2,2,2,2)[1,1,1,1,1,1,1,1,1,*])
  allocate(object%dim05_codim09(2,2,2,2,2)[1,1,1,1,1,1,1,1,*])
  allocate(object%dim06_codim08(2,2,2,2,2,2)[1,1,1,1,1,1,1,*])
  allocate(object%dim07_codim07(2,2,2,2,2,2,2)[1,1,1,1,1,1,*])
  allocate(object%dim08_codim06(2,2,2,2,2,2,2,2)[1,1,1,1,1,*])
  allocate(object%dim09_codim05(2,2,2,2,2,2,2,2,2)[1,1,1,1,*])
  allocate(object%dim10_codim04(2,2,2,2,2,2,2,2,2,2)[1,1,1,*])
  allocate(object%dim11_codim03(2,2,2,2,2,2,2,2,2,2,2)[1,1,*])
  allocate(object%dim12_codim02(2,2,2,2,2,2,2,2,2,2,2,2)[1,*])
  allocate(object%dim13_codim01(2,2,2,2,2,2,2,2,2,2,2,2,2)[*])
  if (any( shape(object%dim01_codim13(:)[1,1,1,1,1,1,1,1,1,1,1,1,1]) /= shape01D )) call print_log('misshapen dim01_codim13')
  if (any( shape(object%dim02_codim12(:,:)[1,1,1,1,1,1,1,1,1,1,1,1]) /= shape02D )) call print_log('misshapen dim02_codim12')
  if (any( shape(object%dim03_codim11(:,:,:)[1,1,1,1,1,1,1,1,1,1,1]) /= shape03D )) call print_log('misshapen dim03_codim11')
  if (any( shape(object%dim04_codim10(:,:,:,:)[1,1,1,1,1,1,1,1,1,1]) /= shape04D )) call print_log('misshapen dim04_codim10')
  if (any( shape(object%dim05_codim09(:,:,:,:,:)[1,1,1,1,1,1,1,1,1]) /= shape05D )) call print_log('misshapen dim05_codim09')
  if (any( shape(object%dim06_codim08(:,:,:,:,:,:)[1,1,1,1,1,1,1,1]) /= shape06D )) call print_log('misshapen dim06_codim08')
  if (any( shape(object%dim07_codim07(:,:,:,:,:,:,:)[1,1,1,1,1,1,1]) /= shape07D )) call print_log('misshapen dim07_codim07')
  if (any( shape(object%dim08_codim06(:,:,:,:,:,:,:,:)[1,1,1,1,1,1]) /= shape08D )) call print_log('misshapen dim08_codim06')
  if (any( shape(object%dim09_codim05(:,:,:,:,:,:,:,:,:)[1,1,1,1,1]) /= shape09D )) call print_log('misshapen dim09_codim05')
  if (any( shape(object%dim10_codim04(:,:,:,:,:,:,:,:,:,:)[1,1,1,1]) /= shape10D )) call print_log('misshapen dim10_codim04')
  if (any( shape(object%dim11_codim03(:,:,:,:,:,:,:,:,:,:,:)[1,1,1]) /= shape11D )) call print_log('misshapen dim11_codim03')
  if (any( shape(object%dim12_codim02(:,:,:,:,:,:,:,:,:,:,:,:)[1,1]) /= shape12D )) call print_log('misshapen dim12_codim02')
  if (any( shape(object%dim13_codim01(:,:,:,:,:,:,:,:,:,:,:,:,:)[1]) /= shape13D )) call print_log('misshapen dim13_codim01')

  ! Array coarray components with rank + corank = 15
  allocate(object%dim01_codim14(2)[1,1,1,1,1,1,1,1,1,1,1,1,1,*])
  allocate(object%dim02_codim13(2,2)[1,1,1,1,1,1,1,1,1,1,1,1,*])
  allocate(object%dim03_codim12(2,2,2)[1,1,1,1,1,1,1,1,1,1,1,*])
  allocate(object%dim04_codim11(2,2,2,2)[1,1,1,1,1,1,1,1,1,1,*])
  allocate(object%dim05_codim10(2,2,2,2,2)[1,1,1,1,1,1,1,1,1,*])
  allocate(object%dim06_codim09(2,2,2,2,2,2)[1,1,1,1,1,1,1,1,*])
  allocate(object%dim07_codim08(2,2,2,2,2,2,2)[1,1,1,1,1,1,1,*])
  allocate(object%dim08_codim07(2,2,2,2,2,2,2,2)[1,1,1,1,1,1,*])
  allocate(object%dim09_codim06(2,2,2,2,2,2,2,2,2)[1,1,1,1,1,*])
  allocate(object%dim10_codim05(2,2,2,2,2,2,2,2,2,2)[1,1,1,1,*])
  allocate(object%dim11_codim04(2,2,2,2,2,2,2,2,2,2,2)[1,1,1,*])
  allocate(object%dim12_codim03(2,2,2,2,2,2,2,2,2,2,2,2)[1,1,*])
  allocate(object%dim13_codim02(2,2,2,2,2,2,2,2,2,2,2,2,2)[1,*])
  allocate(object%dim14_codim01(2,2,2,2,2,2,2,2,2,2,2,2,2,2)[*])
  if (any( shape(object%dim01_codim14(:)[1,1,1,1,1,1,1,1,1,1,1,1,1,1]) /= shape01D )) call print_log('misshapen dim01_codim14')
  if (any( shape(object%dim02_codim13(:,:)[1,1,1,1,1,1,1,1,1,1,1,1,1]) /= shape02D )) call print_log('misshapen dim02_codim13')
  if (any( shape(object%dim03_codim12(:,:,:)[1,1,1,1,1,1,1,1,1,1,1,1]) /= shape03D )) call print_log('misshapen dim03_codim12')
  if (any( shape(object%dim04_codim11(:,:,:,:)[1,1,1,1,1,1,1,1,1,1,1]) /= shape04D )) call print_log('misshapen dim04_codim11')
  if (any( shape(object%dim05_codim10(:,:,:,:,:)[1,1,1,1,1,1,1,1,1,1]) /= shape05D )) call print_log('misshapen dim05_codim10')
  if (any( shape(object%dim06_codim09(:,:,:,:,:,:)[1,1,1,1,1,1,1,1,1]) /= shape06D )) call print_log('misshapen dim06_codim09')
  if (any( shape(object%dim07_codim08(:,:,:,:,:,:,:)[1,1,1,1,1,1,1,1]) /= shape07D )) call print_log('misshapen dim07_codim08')
  if (any( shape(object%dim08_codim07(:,:,:,:,:,:,:,:)[1,1,1,1,1,1,1]) /= shape08D )) call print_log('misshapen dim08_codim07')
  if (any( shape(object%dim09_codim06(:,:,:,:,:,:,:,:,:)[1,1,1,1,1,1]) /= shape09D )) call print_log('misshapen dim09_codim06')
  if (any( shape(object%dim10_codim05(:,:,:,:,:,:,:,:,:,:)[1,1,1,1,1]) /= shape10D )) call print_log('misshapen dim10_codim05')
  if (any( shape(object%dim11_codim04(:,:,:,:,:,:,:,:,:,:,:)[1,1,1,1]) /= shape11D )) call print_log('misshapen dim01_codim04')
  if (any( shape(object%dim12_codim03(:,:,:,:,:,:,:,:,:,:,:,:)[1,1,1]) /= shape12D )) call print_log('misshapen dim12_codim03')
  if (any( shape(object%dim13_codim02(:,:,:,:,:,:,:,:,:,:,:,:,:)[1,1]) /= shape13D )) call print_log('misshapen dim13_codim02')
  if (any( shape(object%dim14_codim01(:,:,:,:,:,:,:,:,:,:,:,:,:,:)[1]) /= shape14D )) call print_log('misshapen dim14_codim01')

#endif

    check_global_success: block

      logical :: no_error_printed

      no_error_printed = .not. error_printed
      call co_all(no_error_printed,result_image=1)

      if (me==1) then
         if (no_error_printed) then
          print *,"Test passed."
        else
          error stop "Errors encountered in alloc_comp_multidim_shape"
        end if
      end if

    end block check_global_success

  end associate

contains

  subroutine print_log(error_message)
    use iso_fortran_env, only : error_unit
    character(len=*), intent(in) :: error_message
    write(error_unit,*) error_message
    error_printed=.true.
  end subroutine

  pure function both(lhs,rhs) RESULT(lhs_and_rhs)
    logical, intent(in) :: lhs,rhs
    logical :: lhs_and_rhs
    lhs_and_rhs = lhs .and. rhs
  end function

  subroutine co_all(boolean,result_image)
    logical, intent(inout) :: boolean
    integer, intent(in) :: result_image
    call co_reduce(boolean,both,result_image=result_image)
  end subroutine

end program alloc_comp_multidim_shape

!
! This program does a correctness check for
! ARRAY = SCALAR and ARRAY = ARRAY
!
program main
  implicit none
  integer, parameter :: n = 3
  integer, parameter :: m = 4

  ! Allocatable coarrays
  call one(-5, 1)
  call one(0, 0)
  call one(1, -5)
  call one(0, -11)

  ! Static coarrays
  call two()
  call three()
  write(*,*) 'Test passed'
contains
  subroutine one(lb1, lb2)
    integer, value :: lb1, lb2

    integer :: i_sgn1, i_sgn2, i, i_e, i_s, j, j_e, j_s
    integer, allocatable :: caf(:,:)[:]
    integer, allocatable :: a(:,:), b(:,:)

    allocate(caf(lb1:n+lb1-1, lb2:m+lb2-1)[*], &
         a(lb1:n+lb1-1, lb2:m+lb2-1), &
         b(lb1:n+lb1-1, lb2:m+lb2-1))

    b = reshape([(i*33, i = 1, size(b))], shape(b))

    ! Whole array: ARRAY = SCALAR
    a = -42
    caf = -42
    if(this_image() == num_images()) then
       caf = b
    endif
    sync all
    if (this_image() == 1) then
      a(:,:) = caf(lb1,lb2)[num_images()]
      print *, this_image(), '//', a, '//', b(lb1,lb2)
      print *, '>>>', any(a /= b(lb1,lb2))
      if (any (a /= b(lb1,lb2))) then
! FIXME: ABORTS UNLESS THERE IS SOME OTHER CODE
print *, 'HELLO!!!!!!!!!!!!!!!!!'
        error stop
      end if
    end if

    ! Whole array: ARRAY = ARRAY
    a = -42
    caf = -42
    if(this_image() == num_images()) then
       caf = b
    endif
    sync all
    if (this_image() == 1) then
      a(:,:) = caf(:,:)[num_images()]
      if (any (a /= b)) &
!FIXME
        print *, a
        print *, b
        print *, 'WRONG:', any (a /= b)
        error stop
      end if
    end if

    ! Array sections with different ranges and pos/neg strides
    do i_sgn1 = -1, 1, 2
      do i_sgn2 = -1, 1, 2
        do i=lb1, n+lb1-1
          do i_e=lb1, n+lb1-1
            do i_s=1, n
              do j=lb2, m+lb2-1
                do j_e=lb2, m+lb2-1
                  do j_s=1, m
                    ! ARRAY = SCALAR
                    a = -12
       		    caf = -42
    		    if(this_image() == num_images()) then
       		       caf = b
    		    endif
                    sync all
                    if (this_image() == 1) then
		      b(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2) &
			   = caf(lb1, lb2)[num_images()]
                    end if
                    sync all

                    ! ARRAY = ARRAY
                    a = -12
		    b = -32
                    if(this_image() == num_images()) then
               	       caf = a
              	     else
                       caf = -42
               	    endif
                    sync all
                    if (this_image() == 1) then
!		      b(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2) &
!			   = caf(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2)[num_images()]
                    end if
                    sync all

                    if (this_image() == 1) then
 !                     if (any (a /= b)) then
 !                       print '(*(g0))', "bounds: ", lb1,":",n+lb1-1,", ", &
 !                            lb2,":",m+lb2-1
 !                       print '(*(g0))', "section: ", i,":",i_e,":",i_s*i_sgn1, &
 !                            ", ", j,":",j_e,":",j_s*i_sgn2
 !                       print *, i
 !                       print *, a
 !                       print *, caf
 !                       print *, a-caf
 !                       error stop
 !                     endif
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      end do
    end do
  end subroutine one

  subroutine two()
    integer, parameter :: lb1 = -5, lb2 = 1

    integer :: i_sgn1, i_sgn2, i, i_e, i_s, j, j_e, j_s
    integer, save :: caf(lb1:n+lb1-1, lb2:m+lb2-1)[*]
    integer, save :: a(lb1:n+lb1-1, lb2:m+lb2-1)
    integer, save :: b(lb1:n+lb1-1, lb2:m+lb2-1)

    b = reshape([(i*33, i = 1, size(b))], shape(b))

    ! Whole array: ARRAY = SCALAR
    a = -12
    b = -32
    if(this_image() == num_images()) then
      caf = a
    else
      caf = -42
    endif
    sync all
    if (this_image() == 1) then
      b(:,:) = caf(lb1,lb2)[num_images()]
    end if
    sync all
    if (this_image() == 1) then
      if (any (a /= b)) &
           error stop
    end if

    ! Whole array: ARRAY = ARRAY
    a = -12
    b = -32
    if(this_image() == num_images()) then
      caf = a
    else
      caf = -42
    endif
    sync all
    if (this_image() == 1) then
      b(:,:) = caf(:,:)[num_images()]
    end if
    sync all
    if (this_image() == 1) then
      if (any (a /= b)) &
           error stop
    end if

    ! Array sections with different ranges and pos/neg strides
    do i_sgn1 = -1, 1, 2
      do i_sgn2 = -1, 1, 2
        do i=lb1, n+lb1-1
          do i_e=lb1, n+lb1-1
            do i_s=1, n
              do j=lb2, m+lb2-1
                do j_e=lb2, m+lb2-1
                  do j_s=1, m
                    ! ARRAY = SCALAR
                     a = -12
                     b = -32
                     if(this_image() == num_images()) then
                        caf = a
                     else
                        caf = -42
                     endif
                    sync all
                    if (this_image() == 1) then
                       b(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2) = caf(lb1,lb2)[num_images()]
                    end if
                    sync all

                    ! ARRAY = ARRAY
                    b = -32
                    a = -12
                    if(this_image() == num_images()) then
                       caf = a
                    else
                       caf = -42
                    endif
                    sync all
                    if (this_image() == 1) then
!                       b(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2) &
!                            =caf(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2)[num_images()]
                    end if
                    sync all

                    if (this_image() == 1) then
 !                     if (any (a /= b)) then
 !                       print '(*(g0))', "bounds: ", lb1,":",n+lb1-1,", ", &
 !                            lb2,":",m+lb2-1
 !                       print '(*(g0))', "section: ", i,":",i_e,":",i_s*i_sgn1, &
 !                            ", ", j,":",j_e,":",j_s*i_sgn2
 !                       print *, i
 !                       print *, a
 !                       print *, caf
 !                       print *, a-caf
 !                       error stop
 !                     endif
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      end do
    end do
  end subroutine two

  subroutine three()
    integer, parameter :: lb1 = 0, lb2 = 0

    integer :: i_sgn1, i_sgn2, i, i_e, i_s, j, j_e, j_s
    integer, save :: caf(lb1:n+lb1-1, lb2:m+lb2-1)[*]
    integer, save :: a(lb1:n+lb1-1, lb2:m+lb2-1)
    integer, save :: b(lb1:n+lb1-1, lb2:m+lb2-1)

    b = reshape([(i*33, i = 1, size(b))], shape(b))

    ! Whole array: ARRAY = SCALAR
    a = -12
    b = -32
    if(this_image() == num_images()) then
      caf = a
    else
      caf = -42
    endif
    sync all
    if (this_image() == 1) then
       b(:,:) = caf(lb1,lb2)[num_images()]
    end if
    sync all
    if (this_image() == 1) then
      if (any (a /= b)) &
           error stop
    end if

    ! Whole array: ARRAY = ARRAY
    a = -12
    b = -32
    if(this_image() == num_images()) then
      caf = a
    else
      caf = -42
    endif
    sync all
    if (this_image() == 1) then
       b(:,:) = caf(:,:)[num_images()]
    end if
    sync all
    if (this_image() == 1) then
      if (any (a /= b)) &
           error stop
    end if

    ! Array sections with different ranges and pos/neg strides
    do i_sgn1 = -1, 1, 2
      do i_sgn2 = -1, 1, 2
        do i=lb1, n+lb1-1
          do i_e=lb1, n+lb1-1
            do i_s=1, n
              do j=lb2, m+lb2-1
                do j_e=lb2, m+lb2-1
                  do j_s=1, m
                    ! ARRAY = SCALAR
                     a = -12
                     b = -32
                     if(this_image() == num_images()) then
                        caf = a
                     else
                        caf = -42
                     endif
                    sync all
                    if (this_image() == 1) then
                       b(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2) &
                            = caf(lb1,lb2)[num_images()]
                    end if
                    sync all

                    ! ARRAY = ARRAY
                     a = -12
                     b = -32
                     if(this_image() == num_images()) then
                        caf = a
                     else
                        caf = -42
                     endif
                     sync all
                    if (this_image() == 1) then
!                       b(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2) &
!                            = caf(i:i_e:i_s*i_sgn1, j:j_e:j_s*i_sgn2)[num_images()]
                    end if
                    sync all

                    if (this_image() == 1) then
!                      if (any (a /= b)) then
!                        print '(*(g0))', "bounds: ", lb1,":",n+lb1-1,", ", &
!                             lb2,":",m+lb2-1
!                        print '(*(g0))', "section: ", i,":",i_e,":",i_s*i_sgn1, &
!                             ", ", j,":",j_e,":",j_s*i_sgn2
!                        print *, i
!                        print *, a
!                        print *, caf
!                        print *, a-caf
!                        error stop
!                      endif
                    end if
                  end do
                end do
              end do
            end do
          end do
        end do
      end do
    end do
  end subroutine three
end program main

! MPI 1D Burgers equation solver test: shared
!
! Copyright (c) 2012-2014, Sourcery, Inc.
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!     * Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!     * Neither the name of the Sourcery, Inc., nor the
!       names of its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
! ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
! DISCLAIMED. IN NO EVENT SHALL SOURCERY, INC., BE LIABLE FOR ANY
! DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
! (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
! ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS

module shared
  !module for sharing mpi functionality/variables with other modules/main
#ifdef MPI_WORKING_MODULE
  use mpi !non-native mpi functionality
#else
  include 'mpif.h'
#endif
  integer :: tag, status(MPI_STATUS_SIZE)
  integer :: MPI_COMM_CART
  integer :: my_id, num_procs, ierr, local_grid_resolution, left_id, right_id
  integer, parameter :: send_data_tag = 2001, return_data_tag = 2002 !tags for sending information
  integer, parameter :: root_process = 0
  integer, parameter :: max_local_resolution = 10000
end module

! Check that the status of a failed image is retrieved correctly.
! Image two is to fail, all others to continue.

program image_fail_and_status_test_1
  use iso_fortran_env , only : STAT_FAILED_IMAGE, STAT_STOPPED_IMAGE
  implicit none
  integer :: i, stat

  associate(np => num_images(), me => this_image())
    if (np < 3) error stop "I need at least 3 images to function."
    do i= 1, np
      if (image_status(i) /= 0) error stop "image_status(i) should not fail"
    end do

    ! Need to sync here or above image_status might catch a fail already.
    sync all
    if (me == 2) fail image
    sync all (STAT=stat)
    ! Check that all images returning from the sync report the failure of an image
    print *,"sync all (STAT=", stat, ")"
    if (stat /= STAT_FAILED_IMAGE) error stop "Expected sync all (STAT == STAT_FAILED_IMAGE)."

    do i= 1, np
      stat = image_status(i)
      if (i /= 2 .AND. stat /= 0 .AND. stat /= STAT_STOPPED_IMAGE) error stop "image_status(i) should not fail"
      if (i == 2 .AND. stat /= STAT_FAILED_IMAGE) error stop "image_status(2) should report fail"
    end do

    if (me == 1) print *,"Test passed."
  end associate

end program image_fail_and_status_test_1

# Unpack if the unpacked tar ball is not in the present working directory
# shellcheck disable=SC2154
unpack_if_necessary()
{
  if [[ "${fetch}" == "svn" || "${fetch}" == "git" ]]; then
    package_source_directory="${version_to_build}"
  else
    info "Unpacking ${url_tail}."
    info "pushd ${download_path}"
    pushd "${download_path}"
    info "Unpack command: tar xf ${url_tail}"
    tar xf "${url_tail}"
    info "popd"
    popd
    # shellcheck disable=SC2034
    package_source_directory="${package_name}-${version_to_build}"
  fi
}

#!/usr/bin/env bash
#
# installation-scripts.sh
#
# -- This script tests the bash scripts that install OpenCoarrays and its prerequisites.
#
# OpenCoarrays is distributed under the OSI-approved BSD 3-clause License:
# Copyright (c) 2015-2016, Sourcery, Inc.
# Copyright (c) 2015-2016, Sourcery Institute
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without modification,
# are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice, this
#    list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright notice, this
#    list of conditions and the following disclaimer in the documentation and/or
#    other materials provided with the distribution.
# 3. Neither the names of the copyright holders nor the names of their contributors
#    may be used to endorse or promote products derived from this software without
#    specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
# Portions of this script derive from BASH3 Boilerplate and are distributed under
# the following license:
#
# The MIT License (MIT)
#
# Copyright (c) 2014 Kevin van Zonneveld
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
#
#
#  - https://github.com/kvz/bash3boilerplate
#  - http://kvz.io/blog/2013/02/26/introducing-bash3boilerplate/
#
# Version: 2.0.0
#
# Authors:
#
#  - Kevin van Zonneveld (http://kvz.io)
#  - Izaak Beekman (https://izaakbeekman.com/)
#  - Alexander Rathai (Alexander.Rathai@gmail.com)
#  - Dr. Damian Rouson (http://www.sourceryinstitute.org/) (documentation)
#
# Licensed under MIT
# Copyright (c) 2013 Kevin van Zonneveld (http://kvz.io)

# The invocation of bootstrap.sh below performs the following tasks:
# (1) Import several bash3boilerplate helper functions & default settings.
# (2) Set several variables describing the current file and its usage page.
# (3) Parse the usage information (default usage file name: current file's name with -usage appended).
# (4) Parse the command line using the usage information.

set -o errtrace

if [[ "${BASH_SOURCE[0]}" != "${0}" ]]; then
  # shellcheck disable=SC2154
  if [[ "${__usage+x}" ]]; then
    __b3bp_tmp_source_idx=1
  fi
fi

# Set magic variables for current file, directory, os, etc.
__dir="$(cd "$(dirname "${BASH_SOURCE[${__b3bp_tmp_source_idx:-0}]}")" && pwd)"
__file="${__dir}/$(basename "${BASH_SOURCE[${__b3bp_tmp_source_idx:-0}]}")"

# requires `set -o errtrace`
__b3bp_err_report() {
  local error_code
  error_code=${?}
  error "Error in ${__file} in function ${1} on line ${2}"
  exit ${error_code}
}
# Uncomment the following line for always providing an error backtrace
trap '__b3bp_err_report "${FUNCNAME:-.}" ${LINENO}' ERR

### Start of boilerplate -- do not edit this block #######################
export OPENCOARRAYS_SRC_DIR="${OPENCOARRAYS_SRC_DIR:-${PWD%/}/../../..}"
if [[ ! -f "${OPENCOARRAYS_SRC_DIR}/src/libcaf.h" ]]; then
  echo "Please run this script inside the OpenCoarrays source sudirectory src/tests/instsallation"
  echo "or set OPENCOARRAYS_SRC_DIR to the OpenCoarrays source directory path."
  exit 1
fi
export B3B_USE_CASE="${B3B_USE_CASE:-${OPENCOARRAYS_SRC_DIR}/prerequisites/use-case}"
if [[ ! -f "${B3B_USE_CASE:-}/bootstrap.sh" ]]; then
  echo "Please set B3B_USE_CASE to the bash3boilerplate use-case directory path."
  exit 2
else
  # shellcheck source=../../../prerequisites/use-case/bootstrap.sh
  source "${B3B_USE_CASE}/bootstrap.sh" "$@"
fi
### End of boilerplate -- start user edits below #########################

# Set expected value of present flags that take no arguments
export __flag_present=1

# Set up a function to call when receiving an EXIT signal to do some cleanup. Remove if
# not needed. Other signals can be trapped too, like SIGINT and SIGTERM.
function cleanup_before_exit() {
  info "Cleaning up. Done"
}
trap cleanup_before_exit EXIT # The signal is specified here. Could be SIGINT, SIGTERM etc.

pushd "${OPENCOARRAYS_SRC_DIR}"/src/tests/installation

# shellcheck source=../../../prerequisites/stack.sh
source "${OPENCOARRAYS_SRC_DIR}"/prerequisites/stack.sh
source test-stack.sh
test_stack

popd

install_or_skip()
{
  SUDO=${1}
  install_path="${2}"
  package_to_install="${3}"
  download_path="${4}"
  if [[ -d "${install_path}/${package_to_install}" ]]; then
    info "The following installation path exists:"
    info "${install_path}/${package_to_install}"
    info "If you want to replace it, please remove it and restart this script."
    info "Skipping ${package_to_install} installation."
  else
    info "Installing ${package_to_install} with the following command:"
    info "${SUDO} mv ${download_path}/${package_to_install} ${install_path}"
    ${SUDO:-} mv "${download_path}/${package_to_install}" "${install_path}"
    if [[ -x "${install_path}/${package_to_install}"  ]]; then
      info "Installation complete for ${package_to_install} in the following location:"
      info "${install_path}/${package_to_install}"
    else
      info "Something went wrong.  Either ${package_to_install} is not in the following expected location"
      info "or the user lacks executable permissions for the directory:"
      emergency "${install_path}/${package_to_install}"
    fi
  fi
}

function move_binaries_to_install_path()
{
  info "Installation package names: ${install_names}"
  package_to_install="${install_names%%,*}" # remove longest back-end match for ,*
  remaining_packages="${install_names#*,}"  # remove shortest front-end match for *,
  if [[ ! -d "${install_path}" ]]; then
    ${SUDO:-} mkdir -p "${install_path}"
  fi
  while [[ "${package_to_install}" != "${remaining_packages}" ]]; do
    install_or_skip  "${SUDO:-}" "${install_path}" "${package_to_install}" "${download_path}"
    info "Remaining installation package names:  ${remaining_packages}"
    install_names="${remaining_packages}"
    package_to_install="${install_names%%,*}" # remove longest back-end match for ,*
    remaining_packages="${install_names#*,}"  # remove shortest front-end for *,
    info "Installing ${package_to_install} binary with the following command:"
  done
  install_or_skip  "${SUDO:-}" "${install_path}" "${package_to_install}" "${download_path}"
}

#!/usr/bin/env bash
#
# installation-scripts.sh
#
# -- This script tests the bash scripts that install OpenCoarrays and its prerequisites.
#
# OpenCoarrays is distributed under the OSI-approved BSD 3-clause License:
# Copyright (c) 2015-2016, Sourcery, Inc.
# Copyright (c) 2015-2016, Sourcery Institute
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without modification,
# are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice, this
#    list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright notice, this
#    list of conditions and the following disclaimer in the documentation and/or
#    other materials provided with the distribution.
# 3. Neither the names of the copyright holders nor the names of their contributors
#    may be used to endorse or promote products derived from this software without
#    specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
# Portions of this script derive from BASH3 Boilerplate and are distributed under
# the following license:
#
# The MIT License (MIT)
#
# Copyright (c) 2014 Kevin van Zonneveld
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
#
#
#  - https://github.com/kvz/bash3boilerplate
#  - http://kvz.io/blog/2013/02/26/introducing-bash3boilerplate/
#
# Version: 2.0.0
#
# Authors:
#
#  - Kevin van Zonneveld (http://kvz.io)
#  - Izaak Beekman (https://izaakbeekman.com/)
#  - Alexander Rathai (Alexander.Rathai@gmail.com)
#  - Dr. Damian Rouson (http://www.sourceryinstitute.org/) (documentation)
#
# Licensed under MIT
# Copyright (c) 2013 Kevin van Zonneveld (http://kvz.io)

# The invocation of bootstrap.sh below performs the following tasks:
# (1) Import several bash3boilerplate helper functions & default settings.
# (2) Set several variables describing the current file and its usage page.
# (3) Parse the usage information (default usage file name: current file's name with -usage appended).
# (4) Parse the command line using the usage information.

set -o errtrace

if [[ "${BASH_SOURCE[0]}" != "${0}" ]]; then
  # shellcheck disable=SC2154
  if [[ "${__usage+x}" ]]; then
    __b3bp_tmp_source_idx=1
  fi
fi

# Set magic variables for current file, directory, os, etc.
__dir="$(cd "$(dirname "${BASH_SOURCE[${__b3bp_tmp_source_idx:-0}]}")" && pwd)"
__file="${__dir}/$(basename "${BASH_SOURCE[${__b3bp_tmp_source_idx:-0}]}")"

# requires `set -o errtrace`
__b3bp_err_report() {
  local error_code
  error_code=${?}
  error "Error in ${__file} in function ${1} on line ${2}"
  exit ${error_code}
}
# Uncomment the following line for always providing an error backtrace
trap '__b3bp_err_report "${FUNCNAME:-.}" ${LINENO}' ERR

### Start of boilerplate -- do not edit this block #######################
export OPENCOARRAYS_SRC_DIR="${OPENCOARRAYS_SRC_DIR:-${PWD%/}/../../..}"
if [[ ! -f "${OPENCOARRAYS_SRC_DIR}/src/runtime-libraries/mpi/mpi_caf.c" ]]; then
  echo "Please run this script inside the OpenCoarrays source subdirectory src/tests/instsallation"
  echo "or set OPENCOARRAYS_SRC_DIR to the OpenCoarrays source directory path."
  exit 1
fi
export B3B_USE_CASE="${B3B_USE_CASE:-${OPENCOARRAYS_SRC_DIR}/prerequisites/use-case}"
if [[ ! -f "${B3B_USE_CASE:-}/bootstrap.sh" ]]; then
  echo "Please set B3B_USE_CASE to the bash3boilerplate use-case directory path."
  exit 2
else
  # shellcheck source=../../../prerequisites/use-case/bootstrap.sh
  source "${B3B_USE_CASE}/bootstrap.sh" "$@"
fi
### End of boilerplate -- start user edits below #########################

# Set expected value of present flags that take no arguments
export __flag_present=1

# Set up a function to call when receiving an EXIT signal to do some cleanup. Remove if
# not needed. Other signals can be trapped too, like SIGINT and SIGTERM.
function cleanup_before_exit() {
  info "Cleaning up. Done"
}
trap cleanup_before_exit EXIT # The signal is specified here. Could be SIGINT, SIGTERM etc.

pushd "${OPENCOARRAYS_SRC_DIR}"/src/tests/installation || exit 1

# shellcheck source=../../../prerequisites/stack.sh
source "${OPENCOARRAYS_SRC_DIR}"/prerequisites/stack.sh
source test-stack.sh
test_stack

popd || exit 1

# Make the build directory, configure, and build
# shellcheck disable=SC2154
build_and_install()
{
  num_threads=${arg_j}
  build_path="${OPENCOARRAYS_SRC_DIR}/prerequisites/builds/${package_to_build}-${version_to_build}"

  info "Building ${package_to_build} ${version_to_build}"
  info "Build path: ${build_path}"
  info "Installation path: ${install_path}"

  set_SUDO_if_needed_to_write_to_directory "${build_path}"
  set_SUDO_if_needed_to_write_to_directory "${install_path}"
  mkdir -p "${build_path}"
  info "pushd ${build_path}"
  pushd "${build_path}"
  if [[ "${package_to_build}" == "gcc" ]]; then
    info "pushd ${download_path}/${package_source_directory} "
    pushd "${download_path}/${package_source_directory}"
    "${PWD}"/contrib/download_prerequisites
    info "popd"
    popd
    info "Configuring gcc/g++/gfortran builds with the following command:"
    info "${download_path}/${package_source_directory}/configure --prefix=${install_path} --enable-languages=c,c++,fortran,lto --disable-multilib --disable-werror"
    "${download_path}/${package_source_directory}/configure" --prefix="${install_path}" --enable-languages=c,c++,fortran,lto --disable-multilib --disable-werror
    info "Building with the following command: 'make -j${num_threads} bootstrap'"
    make "-j${num_threads}" bootstrap
    if [[ ! -z "${SUDO:-}" ]]; then
      info "You do not have write permissions to the installation path ${install_path}"
      info "If you have administrative privileges, enter your password to install ${package_to_build}"
    fi
    info "Installing with the following command: ${SUDO:-} make install"
    ${SUDO:-} make install
  else
    info "Configuring ${package_to_build} ${version_to_build} with the following command:"
    info "FC=\"${FC:-'gfortran'}\" CC=\"${CC:-'gcc'}\" CXX=\"${CXX:-'g++'}\" \"${download_path}/${package_source_directory}\"/configure --prefix=\"${install_path}\""
    FC="${FC:-'gfortran'}" CC="${CC:-'gcc'}" CXX="${CXX:-'g++'}" "${download_path}/${package_source_directory}"/configure --prefix="${install_path}"
    info "Building with the following command:"
    info "FC=\"${FC:-'gfortran'}\" CC=\"${CC:-'gcc'}\" CXX=\"${CXX:-'g++'}\" make -j\"${num_threads}\""
    FC="${FC:-'gfortran'}" CC="${CC:-'gcc'}" CXX="${CXX:-'g++'}" make "-j${num_threads}"
    info "Installing ${package_to_build} in ${install_path}"
    if [[ ! -z "${SUDO:-}" ]]; then
      info "You do not have write permissions to the installation path ${install_path}"
      info "If you have administrative privileges, enter your password to install ${package_to_build}"
    fi
    info "Installing with the following command: ${SUDO:-} make install"
    ${SUDO:-} make install
  fi
  info "popd"
  popd
}

# shellcheck disable=SC2154
replace_wget()
{
  # Define a file extension for the download_prerequisites backup
  backup_extension=".original"
  backup_file="${download_prereqs_file}${backup_extension}"
  if [[ -f ${backup_file}  ]]; then
    # Prevent overwriting an existing backup:
    backup_extension=""
  fi

  if [[ "${gcc_prereqs_fetch}" == "ftp_url" ]]; then
    # Insert a new line after line 2 to include ftp_url.sh as a download option
    sed -i${backup_extension} -e '2 a\'$'\n'". ${OPENCOARRAYS_SRC_DIR}/prerequisites/build-functions/ftp_url.sh"$'\n' "${download_prereqs_file}"
  fi

  arg_string="${gcc_prereqs_fetch_args[*]:-}"

  info "Using the following command to replace wget in the GCC download_prerequisites file:"
  info "sed -i${backup_extension} s/\"${wget_command}\"/\"${gcc_prereqs_fetch} ${arg_string} \"/ \"${download_prereqs_file}\""
  if [[ "${__operating_system}" == "Linux" ]]; then
    sed -i"${backup_extension}" s/wget/"${gcc_prereqs_fetch} ${arg_string} "/ "${download_prereqs_file}"
  else
    sed -i "${backup_extension}" s/wget/"${gcc_prereqs_fetch} ${arg_string} "/ "${download_prereqs_file}"
  fi
}

edit_GCC_download_prereqs_file_if_necessary()
{
  __operating_system=$(uname)
  download_prereqs_file="${PWD}/contrib/download_prerequisites"

  # Grab the line with the first occurence of 'wget'
  wget_line=$(grep wget "${download_prereqs_file}" | head -1) || true
  wget_command="${wget_line%%ftp*}" # grab everything before ftp

  # Check for wget format used before GCC 7
  if [[ ! -z "${wget_command}" ]]; then
    # Check whether wget is available on this system
    if ! type wget &> /dev/null; then
      replace_wget
    fi
  fi
}

#!/bin/bash
#
# check_version.sh
#
# -- Verify whether an OpenCoarrays prerequisite meets the required minimum version number.
#
# OpenCoarrays is distributed under the OSI-approved BSD 3-clause License:
# Copyright (c) 2015-2016, Sourcery, Inc.
# Copyright (c) 2015-2016, Sourcery Institute
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without modification,
# are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice, this
#    list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright notice, this
#    list of conditions and the following disclaimer in the documentation and/or
#    other materials provided with the distribution.
# 3. Neither the names of the copyright holders nor the names of their contributors
#    may be used to endorse or promote products derived from this software without
#    specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.

# Interpret the first argument as the package executable name
package="$1"
# Interpret the second argument as the minimimum acceptable package version number
minimum_version="$2"
# Interpret the third argument as indicating the desired verbosity
verbose=$3

this_script=$(basename "$0")

usage()
{
    echo ""
    echo " $this_script - Bash script for verifyin minimum version numbers for OpenCoarrays prerequisites"
    echo ""
    echo " Usage (optional arguments in square brackets): "
    echo "      $this_script [<option>]"
    echo "      $this_script  <package-name> <minimum-version-number> [--verbose]"
    echo ""
    echo " Options:"
    echo "   --help, -h           Show this help message"
    echo "   --list , -l          List the packages whose versions this script can verify"
    echo ""
    echo " Examples:"
    echo ""
    echo "   $this_script cmake 3.4.0"
    echo "   $this_script flex 2.6.0 --verbose"
    echo "   $this_script flex $(./build.sh -V flex )"
    echo "   $this_script --help"
    echo "   $this_script --list"
    echo ""
    echo "[exit 10]"
    exit 10
}

# Print usage information and exit if script is invoked without arguments or with --help or -h as the first argument
if [ $# == 0 ]; then
  usage | less
  exit 20

elif [[ $1 == '--help' || $1 == '-h' ]]; then
  usage | less
  exit 0

elif [[ $1 == '--list' || $1 == '-l' ]]; then
 echo "$this_script currently verifies minimum version numbers for the following OpenCoarrays prerequisites:"
 echo "   cmake, flex, bison, m4"
 exit 40

elif [[ $1 == '-v' || $1 == '-V' || $1 == '--version' ]]; then
  # Print script copyright if invoked with -v, -V, or --version argument
  cmake_project_line=$(grep project ../CMakeLists.txt | grep VERSION)
  text_after_version_keyword="${cmake_project_line##*VERSION}"
  text_before_language_keyword="${text_after_version_keyword%%LANGUAGES*}"
  opencoarrays_version=$text_before_language_keyword
  echo "opencoarrays $opencoarrays_version"
  echo ""
  echo "OpenCoarrays prerequisite version verifier"
  echo "Copyright (C) 2015-2016 Sourcery, Inc."
  echo "Copyright (C) 2015-2016 Sourcery Institute"
  echo ""
  echo "OpenCoarrays comes with NO WARRANTY, to the extent permitted by law."
  echo "You may redistribute copies of $this_script under the terms of the"
  echo "BSD 3-Clause License.  For more information about these matters, see"
  echo "http://www.sourceryinstitute.org/license.html"
  echo ""
fi

package_version_header=$($package --version | head -1)
if [[ "$verbose" == "--verbose" ]]; then
  echo "$package_version_header"
fi

# Extract the text after the final space:
version=${package_version_header##* }
major=${version%%.*}
minor_patch=${version#*.}
minor=${minor_patch%%.*}
patch=${version##*.}
if [[ "$verbose" == "--verbose" ]]; then
  echo "$version = $major . $minor . $patch"
fi

# Extract the text after the final space:
min_major=${minimum_version%%.*}
min_minor_patch=${minimum_version#*.}
min_minor=${min_minor_patch%%.*}
min_patch=${minimum_version##*.}
if [[ "$verbose" == "--verbose" ]]; then
  echo "$minimum_version = $min_major . $min_minor . $min_patch"
fi

if [ "$(( major < min_major ))" -ne 0 ]; then
  if [[ $verbose == "--verbose" ]]; then
    echo "$major < $min_major"
  fi
  exit 10
elif [[ $verbose == "--verbose" ]]; then
  echo "$major >= $min_major"
fi

if [ "$(( minor < min_minor ))" -ne 0 ]; then
  if [[ $verbose == "--verbose" ]]; then
    echo "$minor < $min_minor"
  fi
  exit 20
elif [[ $verbose == "--verbose" ]]; then
  echo "$minor >= $min_minor"
fi

if [ "$(( patch < min_patch ))" -ne 0 ]; then
  if [[ $verbose == "--verbose" ]]; then
    echo "$patch < $min_patch"
  fi
  exit 30
elif [[ $verbose == "--verbose" ]]; then
  echo "$patch >= $min_patch"
fi
exit 0

# Build the Open Fortran Parser parse table
# shellcheck disable=SC2154
function build_parse_table()
{
  info "Building parse table"
  pushd "${install_path}/ofp-sdf/fortran/syntax"
  info "Build command: make SDF2_PATH=\"${SDF2_PATH}\" ST_PATH=\"${ST_PATH}\" DYLD_LIBRARY_PATH=\"${DYLD_LIBRARY_PATH}\""
  make SDF2_PATH="${SDF2_PATH}" ST_PATH="${ST_PATH}" DYLD_LIBRARY_PATH="${DYLD_LIBRARY_PATH}"
  popd
  pushd "${install_path}/ofp-sdf/fortran/trans"
  make
  popd
}

#!/usr/bin/env bash
#
# install.sh
#
# -- This script installs OpenCoarrays and its prerequisites.
#
# OpenCoarrays is distributed under the OSI-approved BSD 3-clause License:
# Copyright (c) 2015-2016, Sourcery, Inc.
# Copyright (c) 2015-2016, Sourcery Institute
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without modification,
# are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice, this
#    list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright notice, this
#    list of conditions and the following disclaimer in the documentation and/or
#    other materials provided with the distribution.
# 3. Neither the names of the copyright holders nor the names of their contributors
#    may be used to endorse or promote products derived from this software without
#    specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
# Portions of this script derive from BASH3 Boilerplate and are distributed under
# the following license:
#
# The MIT License (MIT)
#
# Copyright (c) 2014 Kevin van Zonneveld
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
#
#
#  - https://github.com/kvz/bash3boilerplate
#  - http://kvz.io/blog/2013/02/26/introducing-bash3boilerplate/
#
# Version: 2.0.0
#
# Authors:
#
#  - Kevin van Zonneveld (http://kvz.io)
#  - Izaak Beekman (https://izaakbeekman.com/)
#  - Alexander Rathai (Alexander.Rathai@gmail.com)
#  - Dr. Damian Rouson (http://www.sourceryinstitute.org/) (documentation)
#
# Licensed under MIT
# Copyright (c) 2013 Kevin van Zonneveld (http://kvz.io)

# The invocation of bootstrap.sh below performs the following tasks:
# (1) Import several bash3boilerplate helper functions & default settings.
# (2) Set several variables describing the current file and its usage page.
# (3) Parse the usage information (default usage file name: current file's name with -usage appended).
# (4) Parse the command line using the usage information.

### Start of boilerplate -- do not edit this block #######################
export OPENCOARRAYS_SRC_DIR="${OPENCOARRAYS_SRC_DIR:-${PWD%/}}"
if [[ ! -f "${OPENCOARRAYS_SRC_DIR}/src/libcaf.h" ]]; then
  echo "Please run this script inside the top-level OpenCoarrays source directory or "
  echo "set OPENCOARRAYS_SRC_DIR to the OpenCoarrays source directory path."
  exit 1
fi
export B3B_USE_CASE="${B3B_USE_CASE:-${OPENCOARRAYS_SRC_DIR}/prerequisites/use-case}"
if [[ ! -f "${B3B_USE_CASE:-}/bootstrap.sh" ]]; then
  echo "Please set B3B_USE_CASE to the bash3boilerplate use-case directory path."
  exit 2
else
    # shellcheck source=./prerequisites/use-case/bootstrap.sh
    source "${B3B_USE_CASE}/bootstrap.sh" "$@"
fi
### End of boilerplate -- start user edits below #########################

# Set expected value of present flags that take no arguments
export __flag_present=1

# Set up a function to call when receiving an EXIT signal to do some cleanup. Remove if
# not needed. Other signals can be trapped too, like SIGINT and SIGTERM.
function cleanup_before_exit () {
  info "Cleaning up. Done"
}
trap cleanup_before_exit EXIT # The signal is specified here. Could be SIGINT, SIGTERM etc.


### Validation (decide what's required for running your script and error out)
#####################################################################

[ -z "${LOG_LEVEL:-}" ] && emergency "Cannot continue without LOG_LEVEL. "

# shellcheck disable=SC2154
if [[ "${arg_v}" == "${__flag_present}" || "${arg_l}" == "${__flag_present}" || ! -z "${arg_P:-${arg_U:-${arg_V:-${arg_D}}}}" ]]; then
   print_debug_only=7
   if [ "$(( LOG_LEVEL < print_debug_only ))" -ne 0 ]; then
     debug "Supressing info and debug messages: one of {-l, -v, -P, -U, -V, -D} present."
     suppress_info_debug_messages
   fi
fi

[ ! -z "${arg_D}" ] && [ ! -z "${arg_P:-${arg_U:-${arg_V}}}" ] &&
  emergency "Please pass only one of {-B, -D, -p, -P, -U, -V} or a longer equivalent (multiple detected). [exit 101]"

[ ! -z "${arg_P}" ] && [ ! -z "${arg_U:-${arg_V}}" ] &&
  emergency "Please pass only one of {-B, -D, -p, -P, -U, -V} or a longer equivalent (multiple detected). [exit 102]"

[ ! -z "${arg_U}" ] && [ ! -z "${arg_V}" ] &&
  emergency "Please pass only one of {-B, -D, -p, -P, -U, -V} or a longer equivalent (multiple detected). [exit 103]"

### Print bootstrapped magic variables to STDERR when LOG_LEVEL
### is at the default value (6) or above.
#####################################################################
# shellcheck disable=SC2154
{
info "__file: ${__file}"
info "__dir: ${__dir}"
info "__base: ${__base}"
info "__os: ${__os}"
info "__usage: ${__usage}"
info "LOG_LEVEL: ${LOG_LEVEL}"

info  "-b (--install-branch):   ${arg_b}"
info  "-c (--with-c):           ${arg_c}"
info  "-C (--with-cxx):         ${arg_C}"
info  "-d (--debug):            ${arg_d}"
info  "-D (--print-downloader): ${arg_D}"
info  "-e (--verbose):          ${arg_e}"
info  "-f (--with-fortran):     ${arg_f}"
info  "-h (--help):             ${arg_h}"
info  "-i (--install-prefix):   ${arg_i}"
info  "-I (--install-version):  ${arg_I}"
info  "-j (--num-threads):      ${arg_j}"
info  "-l (--list-packages):    ${arg_l}"
info  "-m (--with-cmake):       ${arg_m}"
info  "-M (--with-mpi):         ${arg_M}"
info  "-n (--no-color):         ${arg_n}"
info  "-o (--only-download):    ${arg_o}"
info  "-p (--package):          ${arg_p}"
info  "-P (--print-path):       ${arg_P}"
info  "-r (--prefix-root):      ${arg_r}"
info  "-u (--from-url):         ${arg_u}"
info  "-U (--print-url):        ${arg_U}"
info  "-v (--version):          ${arg_v}"
info  "-V (--print-version):    ${arg_V}"
info  "-y (--yes-to-all):       ${arg_y}"
info  "-Z (--bootstrap):        ${arg_Z}"
}
# This file is organized into three sections:
# 1. Command-line argument and environment variable processing.
# 2. Function definitions.
# 3. Main body.
# The script depends on several external programs, including a second script that
# builds prerequisite software.  Building prerequisites requires network access
# unless tar balls of the prerequisites are present.

# TODO:
# 1. Collapse the body of the main conditional branches in the find_or_install function
#    into one new function.
# 2. Verify that script-installed packages meet the minimum version number.
# 3. Add a script_transfer function to collapse the stack_pop x; stack_push z y
#    pattern into one statement
# 4. Consider adding mpich and cmake to the dependency stack before passing them to
#    find_or_install to make the blocks inside find_or_install more uniform.
#    Alternatively, check the dependency stacks for the package before entering the
#    main conditional blocks in find_or_install.
#


# __________ Process command-line arguments and environment variables _____________

this_script="$(basename "$0")"
export this_script

export install_path=${arg_i%/}
export prefix_root="${arg_r:-}"

export num_threads="${arg_j}"
info "num_threads=\"${arg_j}\""

export opencoarrays_src_dir="${OPENCOARRAYS_SRC_DIR}"
info "opencoarrays_src_dir=${OPENCOARRAYS_SRC_DIR}"

export build_path="${opencoarrays_src_dir}"/prerequisites/builds
info "build_path=\"${opencoarrays_src_dir}\"/prerequisites/builds"

export build_script="${opencoarrays_src_dir}"/prerequisites/build.sh
info "build_script=\"${opencoarrays_src_dir}\"/prerequisites/build.sh"

# ___________________ Define functions for use in the Main Body ___________________

# Include stack management functions
#. ./prerequisites/stack.sh
# shellcheck source=./prerequisites/stack.sh
source $opencoarrays_src_dir/prerequisites/stack.sh
stack_new dependency_pkg
stack_new dependency_exe
stack_new dependency_path
stack_new script_installed

# shellcheck source=./prerequisites/install-functions/find_or_install.sh
source $opencoarrays_src_dir/prerequisites/install-functions/find_or_install.sh

# shellcheck source=./prerequisites/install-functions/print_header.sh
source $opencoarrays_src_dir/prerequisites/install-functions/print_header.sh

# shellcheck source=./prerequisites/install-functions/build_opencoarrays.sh
source $opencoarrays_src_dir/prerequisites/install-functions/build_opencoarrays.sh

# shellcheck source=./prerequisites/install-functions/report_results.sh
source $opencoarrays_src_dir/prerequisites/install-functions/report_results.sh

# shellcheck source=./prerequisites/install-functions/install-xcode-clt.sh
source "${opencoarrays_src_dir}/prerequisites/install-functions/install-xcode-clt.sh"

# ___________________ End of function definitions for use in the Main Body __________________


# ________________________________ Start of the Main Body ___________________________________

if [[ "${arg_v}" == "${__flag_present}" || "${arg_V}" == "opencoarrays" ]]; then

  # Print script copyright & version if invoked with -v, -V, or
  # --version argument git attributes handle .VERSION, making it more
  # robust, but fallback version is still manually included. Search
  # for the first version string we encounter and extract it using sed:
  opencoarrays_version=$(sed -n '/[0-9]\{1,\}\(\.[0-9]\{1,\}\)\{1,\}/{s/^\([^.]*\)\([0-9]\{1,\}\(\.[0-9]\{1,\}\)\{1,\}\)\(.*\)/\2/p;q;}' "${opencoarrays_src_dir%/}/.VERSION")
  if [[ "${arg_v}" == "${__flag_present}" ]]; then
    echo "OpenCoarrays ${opencoarrays_version}"
    echo ""
    echo "OpenCoarrays installer"
    echo "Copyright (C) 2015-2016 Sourcery, Inc."
    echo "Copyright (C) 2015-2016 Sourcery Institute"
    echo ""
    echo "OpenCoarrays comes with NO WARRANTY, to the extent permitted by law."
    echo "You may redistribute copies of ${this_script} under the terms of the"
    echo "BSD 3-Clause License.  For more information about these matters, see"
    echo "http://www.sourceryinstitute.org/license.html"
    echo ""
  elif [[ "${arg_V}" == "opencoarrays" ]]; then
    echo "${opencoarrays_version//[[:space:]]/}"
  fi

elif [[ ! -z "${arg_D:-${arg_P:-${arg_U:-${arg_V}}}}" ||  "${arg_l}" == "${__flag_present}" ]]; then

  # Delegate to build.sh for the packages it builds
  build_arg=${arg_D:-${arg_P:-${arg_U:-${arg_V:-${arg_p}}}}}
  [ ! -z "${arg_D}" ] && build_flag="-D"
  [ ! -z "${arg_P}" ] && build_flag="-P"
  [ ! -z "${arg_U}" ] && build_flag="-U"
  [ ! -z "${arg_V}" ] && build_flag="-V"
  [ "${arg_l}" == "${__flag_present}" ] && build_flag="-l"

  if [[ "${arg_P}" == "opencoarrays" ]]; then

    version="$("${opencoarrays_src_dir}/install.sh" -V opencoarrays)"
    echo "${install_path%/}/opencoarrays/${version}"

  else

    info "Invoking build script with the following command:"
    info "\"${opencoarrays_src_dir}\"/prerequisites/build.sh \"${build_flag}\" \"${build_arg}\""
    "${opencoarrays_src_dir}"/prerequisites/build.sh "${build_flag}" "${build_arg}"

    # Add lines other packages the current script builds
    if [[ "${arg_l}" == "${__flag_present}" ]]; then
      echo "opencoarrays (version $("${opencoarrays_src_dir}/install.sh" -V opencoarrays))"
      echo "ofp (version: ofp-sdf for OS X )"
    fi
  fi

elif [[ "${arg_p:-}" == "opencoarrays" ]]; then

  if [[ "${arg_o}" == "${__flag_present}" ]]; then

    # Download all prerequisites and exit
    info "source ${OPENCOARRAYS_SRC_DIR}/prerequisites/install-functions/download-all-prerequisites.sh"
    source "${OPENCOARRAYS_SRC_DIR}/prerequisites/install-functions/download-all-prerequisites.sh"
    info "download_all_prerequisites"
    download_all_prerequisites

  else

    # Install Xcode command line tools (CLT) if on macOS and if needed
    maybe_install_xcodeCLT
    # Install OpenCoarrays

    cd prerequisites || exit 1
    installation_record=install-opencoarrays.log
    # shellcheck source=./prerequisites/build-functions/set_SUDO_if_needed_to_write_to_directory.sh
    source "${OPENCOARRAYS_SRC_DIR:-}/prerequisites/build-functions/set_SUDO_if_needed_to_write_to_directory.sh"
    version="$("${opencoarrays_src_dir}/install.sh" -V opencoarrays)"

    if [[ -z "${prefix_root:-}" ]]; then
      set_SUDO_if_needed_to_write_to_directory "${install_path}"
    else
      set_SUDO_if_needed_to_write_to_directory "${prefix_root}"
    fi

    if grep -s -q Microsoft /proc/version  ; then
      info "Windows Subsystem for Linux detected.  Invoking windows-install.sh with the following command:"
      info "\"${opencoarrays_src_dir}\"/prerequisites/install-functions/windows-install.sh \"$@\""
      "${opencoarrays_src_dir}"/prerequisites/install-functions/windows-install.sh "$@"
    else
      # Using process substitution "> >(...) -" instead of piping to tee via "2>&1 |" ensures that
      # report_results gets the FC value set in build_opencoarrays
      # Source: http://stackoverflow.com/questions/8221227/bash-variable-losing-its-value-strange
      build_opencoarrays > >( tee ../"${installation_record}" ) -
      report_results 2>&1 | tee -a ../"${installation_record}"
    fi
  fi

elif [[ "${arg_p:-}" == "ofp" ]]; then

  # Install Xcode command line tools (CLT) if on macOS and if needed
  maybe_install_xcodeCLT

  info "Invoking Open Fortran Parser build script with the following command:"
  info "\"${opencoarrays_src_dir}\"/prerequisites/install-ofp.sh"
  "${opencoarrays_src_dir}"/prerequisites/install-ofp.sh

elif [[ ! -z "${arg_p:-}" ]]; then

  # Install Xcode command line tools (CLT) if on macOS and if needed
  maybe_install_xcodeCLT

  info "Invoking build script with the following command:"
  info "\"${opencoarrays_src_dir}\"/prerequisites/build.sh ${*:-}"
  "${opencoarrays_src_dir}"/prerequisites/build.sh "${@:-}"

fi
# ____________________________________ End of Main Body ____________________________________________

#!/usr/bin/env bash
# BASH3 Boilerplate
#
# install-binary.sh
#
#  - Build OpenCoarrays prerequisite packages and their prerequisites
#
# Usage: LOG_LEVEL=7 B3B_USE_CASE=/opt/bash3boilerplate/src/use-case ./my-script.sh -f script_input.txt
#
# More info:
#
#  - https://github.com/kvz/bash3boilerplate
#  - http://kvz.io/blog/2013/02/26/introducing-bash3boilerplate/
#
# Version: 2.0.0
#
# Authors:
#
#  - Kevin van Zonneveld (http://kvz.io)
#  - Izaak Beekman (https://izaakbeekman.com/)
#  - Alexander Rathai (Alexander.Rathai@gmail.com)
#  - Dr. Damian Rouson (http://www.sourceryinstitute.org/) (documentation)
#
# Licensed under MIT
# Copyright (c) 2013 Kevin van Zonneveld (http://kvz.io)

# The invocation of bootstrap.sh below performs the following tasks:
# (1) Import several bash3boilerplate helper functions & default settings.
# (2) Set several variables describing the current file and its usage page.
# (3) Parse the usage information (default usage file name: current file's name with -usage appended).
# (4) Parse the command line using the usage information.


### Start of boilerplate -- do not edit this block #######################
export OPENCOARRAYS_SRC_DIR="${OPENCOARRAYS_SRC_DIR:-${PWD}/../}"
if [[ ! -f "${OPENCOARRAYS_SRC_DIR}/src/libcaf.h" ]]; then
  echo "Please run this script inside the top-level OpenCoarrays source \"prerequisites\" "
  echo "subdirectory or set OPENCOARRAYS_SRC_DIR to the OpenCoarrays source directory path."
  exit 1
fi
export __usage="${OPENCOARRAYS_SRC_DIR}/prerequisites/install-binary.sh-usage"
export B3B_USE_CASE="${B3B_USE_CASE:-${OPENCOARRAYS_SRC_DIR}/prerequisites/use-case}"
if [[ ! -f "${B3B_USE_CASE:-}/bootstrap.sh" ]]; then
  echo "Please set B3B_USE_CASE to the bash3boilerplate use-case directory path."
  exit 2
else
    # shellcheck source=./prerequisites/use-case/bootstrap.sh
    source "${B3B_USE_CASE}/bootstrap.sh" "$@"
fi
### End of boilerplate -- start user edits below #########################


# Set up a function to call when receiving an EXIT signal to do some cleanup. Remove if
# not needed. Other signals can be trapped too, like SIGINT and SIGTERM.
function cleanup_before_exit () {
  info "Cleaning up. Done"
}
trap cleanup_before_exit EXIT # The signal is specified here. Could be SIGINT, SIGTERM etc.

### Validation (decide what's required for running your script and error out)
#####################################################################

export __flag_present=1
# shellcheck disable=SC2154
if [[ "${arg_l}" != "${__flag_present}" && "${arg_N}" != "${__flag_present}" &&
      "${arg_v}" != "${__flag_present}" && "${arg_h}" != "${__flag_present}" &&
      -z "${arg_D:-${arg_p:-${arg_P:-${arg_U:-${arg_V}}}}}" ]]; then
  help "${__base}: Insufficient arguments. Please pass either -D, -h, -N, -l, -p, -P, -U, -v, -V, or a longer equivalent."
fi

# Suppress info and debug messages if -l, -P, -U, -V, -D, or their longer equivalent is present:
[[ "${arg_l}" == "${__flag_present}" || ! -z "${arg_P:-${arg_U:-${arg_V:-${arg_D}}}}" ]] && suppress_info_debug_messages

[ -z "${LOG_LEVEL:-}" ] && emergency "Cannot continue without LOG_LEVEL. "

### Enforce mutual exclusivity of arguments that print single-line output
[ ! -z "${arg_P:-}" ] && [ ! -z "${arg_V:-}" ] && emergency "Only specify one of -P, -U, -V, or their long-form equivalents."
[ ! -z "${arg_P:-}" ] && [ ! -z "${arg_U:-}" ] && emergency "Only specify one of -P, -U, -V, or their long-form equivalents."
[ ! -z "${arg_U:-}" ] && [ ! -z "${arg_V:-}" ] && emergency "Only specify one of -P, -U, -V, or their long-form equivalents."

### Print bootstrapped magic variables to STDERR when LOG_LEVEL
### is at the default value (6) or above.
#####################################################################
# shellcheck disable=SC2154
{
info "__file: ${__file}"
info "__dir: ${__dir}"
info "__base: ${__base}"
info "__os: ${__os}"
info "__usage: ${__usage}"
info "LOG_LEVEL: ${LOG_LEVEL}"

info "-d (--debug):            ${arg_d} "
info "-D (--print-downloader): ${arg_D} "
info "-e (--verbose):          ${arg_e} "
info "-h (--help):             ${arg_h} "
info "-i (--install-dir):      ${arg_i} "
info "-I (--install-version):  ${arg_I} "
info "-l (--list-packages):    ${arg_l} "
info "-n (--no-color):         ${arg_n} "
info "-p (--package):          ${arg_p}"
info "-P (--print-path):       ${arg_P} "
info "-U (--print-url):        ${arg_U} "
info "-v (--version):          ${arg_v} "
info "-V (--print-version):    ${arg_V} "
}
# shellcheck source=./install-binary-functions/set_or_print_default_version.sh
source "${OPENCOARRAYS_SRC_DIR:-}/prerequisites/install-binary-functions/set_or_print_default_version.sh"
set_or_print_default_version
export version_to_build="${arg_I:-${default_version}}"

# shellcheck source=./install-binary-functions/set_or_print_downloader.sh
source "${OPENCOARRAYS_SRC_DIR:-}/prerequisites/install-binary-functions/set_or_print_downloader.sh"
set_or_print_downloader

# shellcheck source=./install-binary-functions/set_or_print_url.sh
source "${OPENCOARRAYS_SRC_DIR:-}/prerequisites/install-binary-functions/set_or_print_url.sh"
set_or_print_url

# shellcheck source=./build-functions/set_or_print_installation_path.sh
source "${OPENCOARRAYS_SRC_DIR:-}/prerequisites/build-functions/set_or_print_installation_path.sh"
set_or_print_installation_path

# shellcheck source=./build-functions/download_if_necessary.sh
source "${OPENCOARRAYS_SRC_DIR:-}/prerequisites/build-functions/download_if_necessary.sh"
download_if_necessary

# shellcheck source=./build-functions/unpack_if_necessary.sh
source "${OPENCOARRAYS_SRC_DIR:-}/prerequisites/build-functions/unpack_if_necessary.sh"
unpack_if_necessary

# shellcheck source=./install-binary-functions/set_or_print_csv_binary_names.sh
source "${OPENCOARRAYS_SRC_DIR:-}/prerequisites/install-binary-functions/set_or_print_csv_binary_names.sh"
set_or_print_csv_binary_names

# shellcheck source=./build-functions/set_SUDO_if_needed_to_write_to_directory.sh
source "${OPENCOARRAYS_SRC_DIR:-}/prerequisites/build-functions/set_SUDO_if_needed_to_write_to_directory.sh"
set_SUDO_if_needed_to_write_to_directory "${arg_i}"

# shellcheck source=./install-binary-functions/move_binaries_to_install_path.sh
source "${OPENCOARRAYS_SRC_DIR:-}/prerequisites/install-binary-functions/move_binaries_to_install_path.sh"
move_binaries_to_install_path

#!/usr/bin/env bash
#
# install.sh
#
# -- This script installs OpenCoarrays and its prerequisites.
#
# OpenCoarrays is distributed under the OSI-approved BSD 3-clause License:
# Copyright (c) 2015-2022, Sourcery Institute
# Copyright (c) 2015-2022, Archaeologic Inc.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without modification,
# are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice, this
#    list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright notice, this
#    list of conditions and the following disclaimer in the documentation and/or
#    other materials provided with the distribution.
# 3. Neither the names of the copyright holders nor the names of their contributors
#    may be used to endorse or promote products derived from this software without
#    specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
# Portions of this script derive from BASH3 Boilerplate and are distributed under
# the following license:
#
# The MIT License (MIT)
#
# Copyright (c) 2014 Kevin van Zonneveld
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
#
#
#  - https://github.com/kvz/bash3boilerplate
#  - http://kvz.io/blog/2013/02/26/introducing-bash3boilerplate/
#
# Version: 2.0.0
#
# Authors:
#
#  - Kevin van Zonneveld (http://kvz.io)
#  - Izaak Beekman (https://izaakbeekman.com/)
#  - Alexander Rathai (Alexander.Rathai@gmail.com)
#  - Dr. Damian Rouson (http://www.sourceryinstitute.org/) (documentation)
#
# Licensed under MIT
# Copyright (c) 2013 Kevin van Zonneveld (http://kvz.io)

# The invocation of bootstrap.sh below performs the following tasks:
# (1) Import several bash3boilerplate helper functions & default settings.
# (2) Set several variables describing the current file and its usage page.
# (3) Parse the usage information (default usage file name: current file's name with -usage appended).
# (4) Parse the command line using the usage information.

### Start of boilerplate -- do not edit this block #######################
export OPENCOARRAYS_SRC_DIR="${OPENCOARRAYS_SRC_DIR:-${PWD%/}}"
if [[ ! -f "${OPENCOARRAYS_SRC_DIR}/src/runtime-libraries/mpi/mpi_caf.c" ]]; then
  echo "Please run this script inside the top-level OpenCoarrays source directory or "
  echo "set OPENCOARRAYS_SRC_DIR to the OpenCoarrays source directory path."
  exit 1
fi
export B3B_USE_CASE="${B3B_USE_CASE:-${OPENCOARRAYS_SRC_DIR}/prerequisites/use-case}"
if [[ ! -f "${B3B_USE_CASE:-}/bootstrap.sh" ]]; then
  echo "Please set B3B_USE_CASE to the bash3boilerplate use-case directory path."
  exit 2
else
    # shellcheck source=./prerequisites/use-case/bootstrap.sh
    source "${B3B_USE_CASE}/bootstrap.sh" "$@"
fi
### End of boilerplate -- start user edits below #########################

# Set expected value of present flags that take no arguments
export __flag_present=1

# Set up a function to call when receiving an EXIT signal to do some cleanup. Remove if
# not needed. Other signals can be trapped too, like SIGINT and SIGTERM.
function cleanup_before_exit () {
  info "Cleaning up. Done"
}
trap cleanup_before_exit EXIT # The signal is specified here. Could be SIGINT, SIGTERM etc.


### Validation (decide what's required for running your script and error out)
#####################################################################

[ -z "${LOG_LEVEL:-}" ] && emergency "Cannot continue without LOG_LEVEL. "

# shellcheck disable=SC2154
if [[ "${arg_v}" == "${__flag_present}" || "${arg_l}" == "${__flag_present}" || ! -z "${arg_P:-${arg_U:-${arg_V:-${arg_D}}}}" ]]; then
   print_debug_only=7
   if [ "$(( LOG_LEVEL < print_debug_only ))" -ne 0 ]; then
     debug "Supressing info and debug messages: one of {-l, -v, -P, -U, -V, -D} present."
     suppress_info_debug_messages
   fi
fi

[ ! -z "${arg_D}" ] && [ ! -z "${arg_P:-${arg_U:-${arg_V}}}" ] &&
  emergency "Please pass only one of {-B, -D, -p, -P, -U, -V} or a longer equivalent (multiple detected). [exit 101]"

[ ! -z "${arg_P}" ] && [ ! -z "${arg_U:-${arg_V}}" ] &&
  emergency "Please pass only one of {-B, -D, -p, -P, -U, -V} or a longer equivalent (multiple detected). [exit 102]"

[ ! -z "${arg_U}" ] && [ ! -z "${arg_V}" ] &&
  emergency "Please pass only one of {-B, -D, -p, -P, -U, -V} or a longer equivalent (multiple detected). [exit 103]"

### Print bootstrapped magic variables to STDERR when LOG_LEVEL
### is at the default value (6) or above.
#####################################################################
# shellcheck disable=SC2154
{
info "__file: ${__file}"
info "__dir: ${__dir}"
info "__base: ${__base}"
info "__os: ${__os}"
info "__usage: ${__usage}"
info "LOG_LEVEL: ${LOG_LEVEL}"

info  "-b (--install-branch):   ${arg_b}"
info  "-c (--with-c):           ${arg_c}"
info  "-C (--with-cxx):         ${arg_C}"
info  "-d (--debug):            ${arg_d}"
info  "-D (--print-downloader): ${arg_D}"
info  "-e (--verbose):          ${arg_e}"
info  "-f (--with-fortran):     ${arg_f}"
info  "-h (--help):             ${arg_h}"
info  "-i (--install-prefix):   ${arg_i}"
info  "-I (--install-version):  ${arg_I}"
info  "-j (--num-threads):      ${arg_j}"
info  "-l (--list-packages):    ${arg_l}"
info  "-m (--with-cmake):       ${arg_m}"
info  "-M (--with-mpi):         ${arg_M}"
info  "-n (--no-color):         ${arg_n}"
info  "-o (--only-download):    ${arg_o}"
info  "-p (--package):          ${arg_p}"
info  "-P (--print-path):       ${arg_P}"
info  "-r (--prefix-root):      ${arg_r}"
info  "-u (--from-url):         ${arg_u}"
info  "-U (--print-url):        ${arg_U}"
info  "-v (--version):          ${arg_v}"
info  "-V (--print-version):    ${arg_V}"
info  "-y (--yes-to-all):       ${arg_y}"
info  "-Z (--bootstrap):        ${arg_Z}"
}
# This file is organized into three sections:
# 1. Command-line argument and environment variable processing.
# 2. Function definitions.
# 3. Main body.
# The script depends on several external programs, including a second script that
# builds prerequisite software.  Building prerequisites requires network access
# unless tar balls of the prerequisites are present.

# TODO:
# 1. Collapse the body of the main conditional branches in the find_or_install function
#    into one new function.
# 2. Verify that script-installed packages meet the minimum version number.
# 3. Add a script_transfer function to collapse the stack_pop x; stack_push z y
#    pattern into one statement
# 4. Consider adding mpich and cmake to the dependency stack before passing them to
#    find_or_install to make the blocks inside find_or_install more uniform.
#    Alternatively, check the dependency stacks for the package before entering the
#    main conditional blocks in find_or_install.
#


# __________ Process command-line arguments and environment variables _____________

this_script="$(basename "$0")"
export this_script

export install_path=${arg_i%/}
export prefix_root="${arg_r:-}"

export num_threads="${arg_j}"
info "num_threads=\"${arg_j}\""

export opencoarrays_src_dir="${OPENCOARRAYS_SRC_DIR}"
info "opencoarrays_src_dir=${OPENCOARRAYS_SRC_DIR}"

export build_path="${opencoarrays_src_dir}"/prerequisites/builds
info "build_path=\"${opencoarrays_src_dir}\"/prerequisites/builds"

export build_script="${opencoarrays_src_dir}"/prerequisites/build.sh
info "build_script=\"${opencoarrays_src_dir}\"/prerequisites/build.sh"

# ___________________ Define functions for use in the Main Body ___________________

# Include stack management functions
#. ./prerequisites/stack.sh
# shellcheck source=./prerequisites/stack.sh
source $opencoarrays_src_dir/prerequisites/stack.sh
stack_new dependency_pkg
stack_new dependency_exe
stack_new dependency_path
stack_new script_installed

# shellcheck source=./prerequisites/install-functions/find_or_install.sh
source $opencoarrays_src_dir/prerequisites/install-functions/find_or_install.sh

# shellcheck source=./prerequisites/install-functions/print_header.sh
source $opencoarrays_src_dir/prerequisites/install-functions/print_header.sh

# shellcheck source=./prerequisites/install-functions/build_opencoarrays.sh
source $opencoarrays_src_dir/prerequisites/install-functions/build_opencoarrays.sh

# shellcheck source=./prerequisites/install-functions/report_results.sh
source $opencoarrays_src_dir/prerequisites/install-functions/report_results.sh

# shellcheck source=./prerequisites/install-functions/install-xcode-clt.sh
source "${opencoarrays_src_dir}/prerequisites/install-functions/install-xcode-clt.sh"

# ___________________ End of function definitions for use in the Main Body __________________


# ________________________________ Start of the Main Body ___________________________________

if [[ "${arg_v}" == "${__flag_present}" || "${arg_V}" == "opencoarrays" ]]; then

  # Print script copyright & version if invoked with -v, -V, or
  # --version argument git attributes handle .VERSION, making it more
  # robust, but fallback version is still manually included. Search
  # for the first version string we encounter and extract it using sed:
  opencoarrays_version=$(sed -n '/[0-9]\{1,\}\(\.[0-9]\{1,\}\)\{1,\}/{s/^\([^.]*\)\([0-9]\{1,\}\(\.[0-9]\{1,\}\)\{1,\}\)\(.*\)/\2/p;q;}' "${opencoarrays_src_dir%/}/.VERSION")
  if [[ "${arg_v}" == "${__flag_present}" ]]; then
    echo "OpenCoarrays ${opencoarrays_version}"
    echo ""
    echo "OpenCoarrays installer"
    echo "Copyright (C) 2015-2022 Sourcery Institute"
    echo "Copyright (C) 2015-2022 Archaeologic Inc."
    echo ""
    echo "OpenCoarrays comes with NO WARRANTY, to the extent permitted by law."
    echo "You may redistribute copies of ${this_script} under the terms of the"
    echo "BSD 3-Clause License.  For more information about these matters, see"
    echo "http://www.sourceryinstitute.org/license.html"
    echo ""
  elif [[ "${arg_V}" == "opencoarrays" ]]; then
    echo "${opencoarrays_version//[[:space:]]/}"
  fi

elif [[ ! -z "${arg_D:-${arg_P:-${arg_U:-${arg_V}}}}" ||  "${arg_l}" == "${__flag_present}" ]]; then

  # Delegate to build.sh for the packages it builds
  build_arg=${arg_D:-${arg_P:-${arg_U:-${arg_V:-${arg_p}}}}}
  [ ! -z "${arg_D}" ] && build_flag="-D"
  [ ! -z "${arg_P}" ] && build_flag="-P"
  [ ! -z "${arg_U}" ] && build_flag="-U"
  [ ! -z "${arg_V}" ] && build_flag="-V"
  [ "${arg_l}" == "${__flag_present}" ] && build_flag="-l"

  if [[ "${arg_P}" == "opencoarrays" ]]; then

    version="$("${opencoarrays_src_dir}/install.sh" -V opencoarrays)"
    echo "${install_path%/}/opencoarrays/${version}"

  else

    info "Invoking build script with the following command:"
    info "\"${opencoarrays_src_dir}\"/prerequisites/build.sh \"${build_flag}\" \"${build_arg}\""
    "${opencoarrays_src_dir}"/prerequisites/build.sh "${build_flag}" "${build_arg}"

    # Add lines other packages the current script builds
    if [[ "${arg_l}" == "${__flag_present}" ]]; then
      echo "opencoarrays (version $("${opencoarrays_src_dir}/install.sh" -V opencoarrays))"
      echo "ofp (version: ofp-sdf for OS X )"
    fi
  fi

elif [[ "${arg_p:-}" == "opencoarrays" ]]; then

  if [[ "${arg_o}" == "${__flag_present}" ]]; then

    # Download all prerequisites and exit
    info "source ${OPENCOARRAYS_SRC_DIR}/prerequisites/install-functions/download-all-prerequisites.sh"
    source "${OPENCOARRAYS_SRC_DIR}/prerequisites/install-functions/download-all-prerequisites.sh"
    info "download_all_prerequisites"
    download_all_prerequisites

  else

    # Install Xcode command line tools (CLT) if on macOS and if needed
    maybe_install_xcodeCLT
    # Install OpenCoarrays

    cd prerequisites || exit 1
    installation_record=install-opencoarrays.log
    # shellcheck source=./prerequisites/build-functions/set_SUDO_if_needed_to_write_to_directory.sh
    source "${OPENCOARRAYS_SRC_DIR:-}/prerequisites/build-functions/set_SUDO_if_needed_to_write_to_directory.sh"
    version="$("${opencoarrays_src_dir}/install.sh" -V opencoarrays)"

    if [[ -z "${prefix_root:-}" ]]; then
      set_SUDO_if_needed_to_write_to_directory "${install_path}"
    else
      set_SUDO_if_needed_to_write_to_directory "${prefix_root}"
    fi

    if grep -s -q Microsoft /proc/version  ; then
      info "Windows Subsystem for Linux detected.  Invoking windows-install.sh with the following command:"
      info "\"${opencoarrays_src_dir}\"/prerequisites/install-functions/windows-install.sh \"$@\""
      "${opencoarrays_src_dir}"/prerequisites/install-functions/windows-install.sh "$@"
    else
      # Using process substitution "> >(...) -" instead of piping to tee via "2>&1 |" ensures that
      # report_results gets the FC value set in build_opencoarrays
      # Source: http://stackoverflow.com/questions/8221227/bash-variable-losing-its-value-strange
      build_opencoarrays > >( tee ../"${installation_record}" ) -
      report_results 2>&1 | tee -a ../"${installation_record}"
    fi
  fi


elif [[ "${arg_p:-}" == "ofp" ]]; then

  # Install Xcode command line tools (CLT) if on macOS and if needed
  maybe_install_xcodeCLT

  info "Invoking Open Fortran Parser build script with the following command:"
  info "\"${opencoarrays_src_dir}\"/prerequisites/install-ofp.sh"
  "${opencoarrays_src_dir}"/prerequisites/install-ofp.sh

elif [[ ! -z "${arg_p:-}" ]]; then

  # Install Xcode command line tools (CLT) if on macOS and if needed
  maybe_install_xcodeCLT

  info "Invoking build script with the following command:"
  info "\"${opencoarrays_src_dir}\"/prerequisites/build.sh ${*:-}"
  "${opencoarrays_src_dir}"/prerequisites/build.sh "${@:-}"

fi
# ____________________________________ End of Main Body ____________________________________________

# Unpack if the unpacked tar ball is not in the present working directory
# shellcheck disable=SC2154
unpack_if_necessary()
{
  if [[ "${fetch}" == "git" ]]; then
    package_source_directory="${package_name}"
  else
    if [[ "${url_tail}" == *tar.gz || "${url_tail}" == *tar.bz2 || "${url_tail}" == *.tar.xz ]]; then
      info "Unpacking ${url_tail}."
      info "pushd ${download_path}"
      pushd "${download_path}"
      info "Unpack command: tar xf ${url_tail}"
      tar xf "${url_tail}"
      info "popd"
      popd
    else
      info "Skipping unpacking because ${url_tail} is not a compressed archive (matching one of *.tar.{gz,bz2,xz}). "
    fi
    # shellcheck disable=SC2034
    package_source_directory="${package_name}-${version_to_build}"
  fi
}

# shellcheck source=./ftp-url.sh
source "${OPENCOARRAYS_SRC_DIR}/prerequisites/build-functions/ftp-url.sh"
# shellcheck source=./set_SUDO_if_needed_to_write_to_directory.sh
source "${OPENCOARRAYS_SRC_DIR}/prerequisites/build-functions/set_SUDO_if_needed_to_write_to_directory.sh"

# Download package if the tar ball is not already in the present working directory
# shellcheck disable=SC2154
download_if_necessary()
{
  download_path="${OPENCOARRAYS_SRC_DIR}/prerequisites/downloads"
  set_SUDO_if_needed_to_write_to_directory "${download_path}"
  if  [[ -f "${download_path}/${url_tail}" || -d "${download_path}/${url_tail}" ]] ; then
    info "Found '${url_tail}' in ${download_path}."
    info "If it resulted from an incomplete download, building ${package_name} could fail."
    info "Would you like to proceed anyway? (Y/n)"
    read -r proceed
    if [[ "${proceed}" == "n" || "${proceed}" == "N" || "${proceed}" == "no"  ]]; then
      info "n"
      info "Please remove $url_tail and restart the installation to to ensure a fresh download." 1>&2
      emergency "Aborting. [exit 80]"
    else
      info "y"
    fi
  elif ! type "${fetch}" &> /dev/null; then
    # The download mechanism is missing
    info "The default download mechanism for ${package_name} is ${fetch}."
    info "Please either ensure that ${fetch} is installed and in your PATH"
    info "or download the ${package_name} source from "
    info "${package_url}"
    info "Place the downloaded file in ${download_path} and restart this script."
    emergency "Aborting [exit 90]"
  else
    # The download mechanism is in the path.
    if [[ "${fetch}" == "svn" ]]; then
      if [[ ${version_to_build} == '--avail' || ${version_to_build} == '-a' ]]; then
        args="ls"
      else
        args="checkout"
      fi
    elif [[ "${fetch}" == "wget" ]]; then
      args="--no-check-certificate"
    elif [[ "${fetch}" == "ftp-url" ]]; then
      args="-n"
    elif [[ "${fetch}" == "git" ]]; then
      args="clone"
    elif [[ "${fetch}" == "curl" ]]; then
      first_three_characters=$(echo "${package_url}" | cut -c1-3)
      if [[ "${first_three_characters}" == "ftp"  ]]; then 
        args="-LO -u anonymous:"
      elif [[ "${first_three_characters}" == "htt"  ]]; then 
        args="-LO"
      else
        emergency "download_if_necessary.sh: Unrecognized URL."
      fi
    fi

    if [[ "${fetch}" == "svn" || "${fetch}" == "git" ]]; then
      package_source_directory="${url_tail}"
    else
      package_source_directory="${package_name}-${version_to_build}"
    fi
    info "Downloading ${package_name} ${version_to_build} to the following location:"
    info "${download_path}/${package_source_directory}"
    info "Download command: \"${fetch}\" ${args:-} ${package_url}"
    info "Depending on the file size and network bandwidth, this could take several minutes or longer."
    pushd "${download_path}"
    "${fetch}" ${args:-} ${package_url}
    popd
    if [[ "${version_to_build}" == '--avail' || "${version_to_build}" == '-a' ]]; then
      # In this case, args="ls" and the list of available versions has been printed so we can move on.
      exit 1
    fi
    if [[ "${fetch}" == "svn" ]]; then
      search_path="${download_path}/${version_to_build}"
    else
      search_path="${download_path}/${url_tail}"
    fi
    if [ -f "${search_path}" ] || [ -d "${search_path}" ]; then
      info "Download succeeded. The ${package_name} source is in the following location:"
      info "${search_path}"
    else
      info "Download failed. The ${package_name} source is not in the following, expected location:"
      info "${search_path}"
      emergency "Aborting. [exit 110]"
    fi
  fi
}

#!/bin/sh
echo "Building the code:"
export TAU_MAKEFILE=/opt/paratools/tau/x86_64/lib/Makefile.tau-mpi-pdt
export TAU_OPTIONS="-optVerbose -optCompInst"
make clean
make -f Makefile.inst

# Specify TAU parameters here:
export TAU_CALLPATH=1
export TAU_CALLPATH_DEPTH=100
#export TAU_SAMPLING=1

echo "Running the code:"
mpiexec -np 4 ./burgers

echo "Running the pprof command:"
pprof
echo "Running the TAU paraprof analyzer command:"
paraprof &

# shellcheck shell=bash
# Make the build directory, configure, and build
# shellcheck disable=SC2154

# shellcheck source=prerequisites/build-functions/edit_GCC_download_prereqs_file_if_necessary.sh
source "${OPENCOARRAYS_SRC_DIR}/prerequisites/build-functions/edit_GCC_download_prereqs_file_if_necessary.sh"

build_and_install()
{
  num_threads=${arg_j}
  build_path="${OPENCOARRAYS_SRC_DIR}/prerequisites/builds/${package_to_build}-${version_to_build}"

  info "Building ${package_to_build} ${version_to_build}"
  info "Build path: ${build_path}"
  info "Installation path: ${install_path}"

  set_SUDO_if_needed_to_write_to_directory "${build_path}"
  set_SUDO_if_needed_to_write_to_directory "${install_path}"
  if [[ -d "${build_path}" ]]; then
    rm -rf "${build_path}"
  fi
  mkdir -p "${build_path}"
  info "pushd ${build_path}"
  pushd "${build_path}"

  if [[ "${package_to_build}" != "gcc" ]]; then

    if [[ "${package_to_build}" == "mpich" && "${version_to_build}" == "3.2" ]]; then
      info "Patching MPICH 3.2 on Mac OS due to segfault bug (see http://lists.mpich.org/pipermail/discuss/2016-May/004764.html)."
      sed 's/} MPID_Request ATTRIBUTE((__aligned__(32)));/} ATTRIBUTE((__aligned__(32))) MPID_Request;/g' \
        "${download_path}/${package_source_directory}/src/include/mpiimpl.h" > "${download_path}/${package_source_directory}/src/include/mpiimpl.h.patched"
      cp "${download_path}/${package_source_directory}/src/include/mpiimpl.h.patched" "${download_path}/${package_source_directory}/src/include/mpiimpl.h"
    fi

    if [[ "${package_to_build}" == "cmake"  && $(uname) == "Linux" ]]; then

      export cmake_binary_installer="${download_path}/cmake-${version_to_build}-Linux-x86_64.sh"
      ${SUDO:-} mkdir -p "$install_path"
      chmod u+x "${cmake_binary_installer}"
      info "Installing Cmake with the following command: "
      info "\"${cmake_binary_installer}\" --prefix=\"$install_path\" --exclude-subdir"
      "${cmake_binary_installer}" --prefix="$install_path" --exclude-subdir

    else # build from source

      info "Configuring ${package_to_build} ${version_to_build} with the following command:"
      info "FC=\"${FC:-'gfortran'}\" CC=\"${CC:-'gcc'}\" CXX=\"${CXX:-'g++'}\" \"${download_path}/${package_source_directory}\"/configure --prefix=\"${install_path}\""
      FC="${FC:-'gfortran'}" CC="${CC:-'gcc'}" CXX="${CXX:-'g++'}" "${download_path}/${package_source_directory}"/configure --prefix="${install_path}"
      info "Building with the following command:"
      info "FC=\"${FC:-'gfortran'}\" CC=\"${CC:-'gcc'}\" CXX=\"${CXX:-'g++'}\" make -j\"${num_threads}\""
      FC="${FC:-'gfortran'}" CC="${CC:-'gcc'}" CXX="${CXX:-'g++'}" make "-j${num_threads}"
      info "Installing ${package_to_build} in ${install_path}"
      if [[ ! -z "${SUDO:-}" ]]; then
        info "You do not have write permissions to the installation path ${install_path}"
        info "If you have administrative privileges, enter your password to install ${package_to_build}"
      fi
      info "Installing with the following command: ${SUDO:-} make install"
      ${SUDO:-} make install

    fi

  elif [[ ${package_to_build} == "gcc" ]]; then

    info "pushd ${download_path}/${package_source_directory} "
    pushd "${download_path}/${package_source_directory}"

    # Patch gfortran if necessary
    export patches_dir="${OPENCOARRAYS_SRC_DIR}/prerequisites/build-functions/patches/${package_to_build}/${version_to_build}"
    if [[ -d "${patches_dir:-}" ]]; then
      for patch in "${patches_dir%/}"/*.diff ; do
	info "Applying patch ${patch##*/} to $package_to_build ${version_to_build}."
	patch -p1 < "$patch"
      done
    fi

    # Use GCC's contrib/download_prerequisites script after modifying it, if necessary, to use the
    # the preferred download mechanism set in prerequisites/build-functions/set_or_print_downloader.sh

    # Switch download mechanism if wget is not available
    edit_GCC_download_prereqs_file_if_necessary

    # Download GCC prerequisities
    "${PWD}"/contrib/download_prerequisites

    info "popd"
    popd
    info "Configuring gcc/g++/gfortran builds with the following command:"
    info "${download_path}/${package_source_directory}/configure --prefix=${install_path} --enable-languages=c,c++,fortran,lto --disable-multilib --disable-werror ${bootstrap_configure}"
    "${download_path}/${package_source_directory}/configure" --prefix="${install_path}" --enable-languages=c,c++,fortran,lto --disable-multilib --disable-werror ${bootstrap_configure}
    info "Building with the following command: 'make -j${num_threads} ${bootstrap_build}'"
    make "-j${num_threads}" ${bootstrap_build}
    if [[ ! -z "${SUDO:-}" ]]; then
      info "You do not have write permissions to the installation path ${install_path}"
      info "If you have administrative privileges, enter your password to install ${package_to_build}"
    fi
    info "Installing with the following command: ${SUDO:-} make install"
    ${SUDO:-} make install

  else
     emergency "This branch should never be reached."
  fi # end if [[ "${package_to_build}" != "gcc"  && "${package_to_build}" != "cmake"  ]]; then


  info "popd"
  popd
}

# shellcheck disable=SC2154,SC2129
report_results()
{
  # Report installation success or failure:
  if [[ -x "$install_path/bin/caf" && -x "$install_path/bin/cafrun" ]]; then

    # Installation succeeded
    echo "$this_script: Done."
    echo ""
    echo "*** The OpenCoarrays compiler wrapper (caf) and program  ***"
    echo "*** launcher (cafrun) are in the following directory:    ***"
    echo ""
    echo "$install_path/bin."
    echo ""
    if [[ -f setup.sh ]]; then
      ${SUDO:-} rm setup.sh
    fi
    if [[ -f setup.csh ]]; then
      ${SUDO:-} rm setup.csh
    fi
    # Prepend the OpenCoarrays license to the setup.sh script:
    while IFS='' read -r line || [[ -n "$line" ]]; do
        echo "# $line" >> setup.sh
    done < "${opencoarrays_src_dir}/LICENSE"
    while IFS='' read -r line || [[ -n "$line" ]]; do
        echo "# $line" >> setup.csh
    done < "${opencoarrays_src_dir}/LICENSE"
    echo "#                                                                      " | tee -a setup.csh setup.sh
    echo "# Execute this script via the following command:                       " | tee -a setup.csh setup.sh
    echo "# source $install_path/setup.sh                                        " | tee -a setup.csh setup.sh
    echo "                                                                       " | tee -a setup.csh setup.sh
    gcc_install_path=$("${build_script}" -P gcc)
    if [[ -x "$gcc_install_path/bin/gfortran" ]]; then
      echo "if [[ -z \"\$PATH\" ]]; then                                         " >> setup.sh
      echo "  export PATH=\"$gcc_install_path/bin\"                              " >> setup.sh
      echo "else                                                                 " >> setup.sh
      echo "  export PATH=\"$gcc_install_path/bin:\$PATH\"                       " >> setup.sh
      echo "fi                                                                   " >> setup.sh
      echo "set path = (\"$gcc_install_path\"/bin "\$path")                      " >> setup.csh
    fi
    if [[ -d "$gcc_install_path/lib" || -d "$gcc_install_path/lib64" ]]; then
      gfortran_lib_paths="$gcc_install_path/lib64/:$gcc_install_path/lib"
      echo "if [[ -z \"\$LD_LIBRARY_PATH\" ]]; then                              " >> setup.sh
      echo "  export LD_LIBRARY_PATH=\"$gfortran_lib_paths\"                     " >> setup.sh
      echo "else                                                                 " >> setup.sh
      echo "  export LD_LIBRARY_PATH=\"$gfortran_lib_paths:\$LD_LIBRARY_PATH\"   " >> setup.sh
      echo "fi                                                                   " >> setup.sh
      echo "set LD_LIBRARY_PATH = (\"$gfortran_lib_paths\"/bin "\$LD_LIBRARY_PATH")                      " >> setup.csh
    fi
    echo "                                                                       " >> setup.sh
    mpich_install_path=$("${build_script}" -P mpich)
    if [[ -x "$mpich_install_path/bin/mpif90" ]]; then
      echo "if [[ -z \"\$PATH\" ]]; then                                         " >> setup.sh
      echo "  export PATH=\"$mpich_install_path/bin\"                            " >> setup.sh
      echo "else                                                                 " >> setup.sh
      echo "  export PATH=\"$mpich_install_path/bin\":\$PATH                     " >> setup.sh
      echo "fi                                                                   " >> setup.sh
      echo "set path = (\"$mpich_install_path\"/bin "\$path")                      " >> setup.csh
    fi
    cmake_install_path=$("${build_script}" -P cmake)
    if [[ -x "$cmake_install_path/bin/cmake" ]]; then
      echo "if [[ -z \"\$PATH\" ]]; then                                         " >> setup.sh
      echo "  export PATH=\"$cmake_install_path/bin\"                            " >> setup.sh
      echo "else                                                                 " >> setup.sh
      echo "  export PATH=\"$cmake_install_path/bin\":\$PATH                     " >> setup.sh
      echo "fi                                                                   " >> setup.sh
      echo "set path = (\"$cmake_install_path\"/bin "\$path")                      " >> setup.csh
    fi
    flex_install_path=$("${build_script}" -P flex)
    if [[ -x "$flex_install_path/bin/flex" ]]; then
      echo "if [[ -z \"\$PATH\" ]]; then                                         " >> setup.sh
      echo "  export PATH=\"$flex_install_path/bin\"                             " >> setup.sh
      echo "else                                                                 " >> setup.sh
      echo "  export PATH=\"$flex_install_path/bin\":\$PATH                      " >> setup.sh
      echo "set path = (\"$flex_install_path\"/bin "\$path")                      " >> setup.csh
      echo "fi                                                                   " >> setup.sh
    fi
    bison_install_path=$("${build_script}" -P bison)
    if [[ -x "$bison_install_path/bin/yacc" ]]; then
      echo "if [[ -z \"\$PATH\" ]]; then                                         " >> setup.sh
      echo "  export PATH=\"$bison_install_path/bin\"                            " >> setup.sh
      echo "else                                                                 " >> setup.sh
      echo "  export PATH=\"$bison_install_path/bin\":\$PATH                     " >> setup.sh
      echo "fi                                                                   " >> setup.sh
      echo "set path = (\"$bison_install_path\"/bin "\$path")                      " >> setup.csh
    fi
    m4_install_path=$("${build_script}" -P m4)
    if [[ -x "$m4_install_path/bin/m4" ]]; then
      echo "if [[ -z \"\$PATH\" ]]; then                                         " >> setup.sh
      echo "  export PATH=\"$m4_install_path/bin\"                               " >> setup.sh
      echo "else                                                                 " >> setup.sh
      echo "  export PATH=\"$m4_install_path/bin\":\$PATH                        " >> setup.sh
      echo "fi                                                                   " >> setup.sh
      echo "set path = (\"$m4_install_path\"/bin "\$path")                      " >> setup.csh
    fi
    opencoarrays_install_path="${install_path}"
    if [[ -x "$opencoarrays_install_path/bin/caf" ]]; then
      echo "if [[ -z \"\$PATH\" ]]; then                                         " >> setup.sh
      echo "  export PATH=\"$opencoarrays_install_path/bin\"                     " >> setup.sh
      echo "else                                                                 " >> setup.sh
      echo "  export PATH=\"$opencoarrays_install_path/bin\":\$PATH              " >> setup.sh
      echo "fi                                                                   " >> setup.sh
      echo "set path = (\"$opencoarrays_install_path\"/bin "\$path")                      " >> setup.csh
    fi
    if ${SUDO:-} mv setup.sh "$opencoarrays_install_path"; then
       setup_sh_location=$opencoarrays_install_path
    else
       setup_sh_location=${PWD}
    fi
    if ${SUDO:-} mv setup.csh "$opencoarrays_install_path"; then
       setup_csh_location=$opencoarrays_install_path
    else
       setup_csh_location=${PWD}
    fi
    echo "*** To set up your environment for using caf and cafrun, please   ***"
    echo "*** source the installed setup.sh file in a bash shell  setup.csh ***"
    echo "*** if you use a C-shell as follows (or add one of the following  ***"
    echo "*** statements to your login file:                                 ***"
    echo ""
    echo " source $setup_sh_location/setup.sh"
    echo " source $setup_csh_location/setup.csh"
    echo ""
    echo "*** Installation complete.                                                   ***"

  else # Installation failed

    echo "Something went wrong. Either the user lacks executable permissions for the"
    echo "OpenCoarrays compiler wrapper (caf), program launcher (cafrun), or prerequisite"
    echo "package installer (build), or these programs are not in the following, expected"
    echo "location:"
    echo "$install_path/bin."
    echo "Please review the following file for more information:"
    echo "$install_path/$installation_record"
    echo "and submit an bug report at https://github.com/sourceryinstitute/opencoarrays/issues"
    echo "[exit 100]"
    exit 100

  fi # Ending check for caf, cafrun, build not in expected path
}

# shellcheck shell=bash
# Make the build directory, configure, and build
# shellcheck disable=SC2154

# shellcheck source=prerequisites/build-functions/edit_GCC_download_prereqs_file_if_necessary.sh
source "${OPENCOARRAYS_SRC_DIR}/prerequisites/build-functions/edit_GCC_download_prereqs_file_if_necessary.sh"

function version { echo "$@" | awk -F. '{ printf("%d%03d%03d%03d\n", $1,$2,$3,$4); }'; }

build_and_install()
{
  num_threads=${arg_j}
  build_path="${OPENCOARRAYS_SRC_DIR}/prerequisites/builds/${package_to_build}-${version_to_build}"

  info "Building ${package_to_build} ${version_to_build}"
  info "Build path: ${build_path}"
  info "Installation path: ${install_path}"

  set_SUDO_if_needed_to_write_to_directory "${build_path}"
  set_SUDO_if_needed_to_write_to_directory "${install_path}"
  if [[ -d "${build_path}" ]]; then
    rm -rf "${build_path}"
  fi
  mkdir -p "${build_path}"
  info "pushd ${build_path}"
  pushd "${build_path}" || emergency "build_and_install.sh: pushd failed"

  if [[ "${package_to_build}" != "gcc" ]]; then

    if [[ "${package_to_build}" == "mpich" ]]; then
      if [[ "${version_to_build}" == "3.2" ]]; then
        info "Patching MPICH 3.2 on Mac OS due to segfault bug (see http://lists.mpich.org/pipermail/discuss/2016-May/004764.html)."
        sed 's/} MPID_Request ATTRIBUTE((__aligned__(32)));/} ATTRIBUTE((__aligned__(32))) MPID_Request;/g' \
          "${download_path}/${package_source_directory}/src/include/mpiimpl.h" > "${download_path}/${package_source_directory}/src/include/mpiimpl.h.patched"
        cp "${download_path}/${package_source_directory}/src/include/mpiimpl.h.patched" "${download_path}/${package_source_directory}/src/include/mpiimpl.h"
      fi

      FC_version=$($FC --version)
      text_before_dot="${FC_version%%.*}" # grab text before first dot
      major_version="${text_before_dot##* }" # grab text after final space
      if (( ${major_version} >= 10 )); then
       export FFLAGS="-w -fallow-argument-mismatch"
      fi
    fi

    if [[ "${package_to_build}" == "cmake"  && $(uname) == "Linux" ]]; then

      export cmake_binary_installer="${download_path}/cmake-${version_to_build}-Linux-x86_64.sh"
      ${SUDO:-} mkdir -p "$install_path"
      chmod u+x "${cmake_binary_installer}"
      if [[ -n "${SUDO:-}" ]]; then
        info "You do not have write permissions to the installation path ${install_path}"
        info "If you have administrative privileges, enter your password to install ${package_to_build}"
      fi
      info "Installing Cmake with the following command: "
      info "${SUDO:-} \"${cmake_binary_installer}\" --prefix=\"$install_path\" --exclude-subdir"
      ${SUDO:-} "${cmake_binary_installer}" --prefix="$install_path" --exclude-subdir

    else # build from source

      info "Configuring ${package_to_build} ${version_to_build} with the following command:"
      info "FFLAGS=${FFLAGS:-} FC=\"${FC:-'gfortran'}\" CC=\"${CC:-'gcc'}\" CXX=\"${CXX:-'g++'}\" \"${download_path}/${package_source_directory}\"/configure --prefix=\"${install_path}\""
      FFLAGS=${FFLAGS:-} FC="${FC:-'gfortran'}" CC="${CC:-'gcc'}" CXX="${CXX:-'g++'}" "${download_path}/${package_source_directory}"/configure --prefix="${install_path}"
      info "Building with the following command:"
      info "FC=\"${FC:-'gfortran'}\" CC=\"${CC:-'gcc'}\" CXX=\"${CXX:-'g++'}\" make -j\"${num_threads}\""
      FC="${FC:-'gfortran'}" CC="${CC:-'gcc'}" CXX="${CXX:-'g++'}" make "-j${num_threads}"
      info "Installing ${package_to_build} in ${install_path}"
      if [[ -n "${SUDO:-}" ]]; then
        info "You do not have write permissions to the installation path ${install_path}"
        info "If you have administrative privileges, enter your password to install ${package_to_build}"
      fi
      info "Installing with the following command: ${SUDO:-} make install"
      ${SUDO:-} make install

    fi

  elif [[ ${package_to_build} == "gcc" ]]; then

    # Warn about header prerequisite on macOS Mojave or subsequent versions
    if [[ $(uname) == "Darwin" ]]; then
      export kernel=$(uname -r)
      export Mojave="18.0.0"
      export Catalina="19.0.0"
      if [ $(version $kernel) -ge $(version $Mojave) ]; then
        if [ $(version $kernel) -ge $(version $Catalina) ]; then
          export with_sysroot="--with-sysroot=/Library/Developer/CommandLineTools/SDKs/MacOSX.sdk"
        else
          info ""
          info "______________________________________________________________________________"
          info "Detected Darwin $kernel (Mojave).  If $package_to_build build fails due to a"
          info "missing header (*.h) file, please try something like the following bash command:"
          info "open /Library/Developer/CommandLineTools/Packages/macOS_SDK_headers_for_macOS_10.14.pkg"
          info "Follow the prompts to install the missing headers. Then restart this $this_script."
          info "See https://bit.ly/build-gcc-on-mojave for more details."
          if [[ "${arg_y}" == "${__flag_present}" ]]; then
            info "-y or --yes-to-all flag present. Proceeding with non-interactive build."
          else
            info "Would you like to proceed anyway? (Y/n)"
            read -r proceed
            if [[ "${proceed}" == "n" || "${proceed}" == "N" || "${proceed}" == "no"  ]]; then
              info "n"
              emergency "Aborting. [exit 80]"
            else
              info "y"
            fi
          fi
        fi
      fi
    fi

    info "pushd ${download_path}/${package_source_directory} "
    pushd "${download_path}/${package_source_directory}" || emergency "build_and_install.sh: pushd failed"

    # Patch gfortran if necessary
    export patches_dir="${OPENCOARRAYS_SRC_DIR}/prerequisites/build-functions/patches/${package_to_build}/${version_to_build}"
    if [[ -d "${patches_dir:-}" ]]; then
      for patch in "${patches_dir%/}"/*.diff ; do
	info "Applying patch ${patch##*/} to $package_to_build ${version_to_build}."
	patch -p1 < "$patch"
      done
    fi

    # Use GCC's contrib/download_prerequisites script after modifying it, if necessary, to use the
    # the preferred download mechanism set in prerequisites/build-functions/set_or_print_downloader.sh

    # Switch download mechanism if wget is not available
    edit_GCC_download_prereqs_file_if_necessary

    # Download GCC prerequisities
    "${PWD}"/contrib/download_prerequisites

    info "popd"
    popd || emergency "build_and_install.sh: popd failed"
    info "Configuring gcc/g++/gfortran builds with the following command:"
    info "${download_path}/${package_source_directory}/configure --prefix=${install_path} --enable-languages=c,c++,fortran,lto --disable-multilib --disable-werror ${bootstrap_configure} ${with_sysroot:-}"
    "${download_path}/${package_source_directory}/configure" --prefix="${install_path}" --enable-languages=c,c++,fortran,lto --disable-multilib --disable-werror "${bootstrap_configure}" "${with_sysroot:-}"
    info "Building with the following command: make -j ${num_threads} ${bootstrap_build}"
    make -j ${num_threads} ${bootstrap_build:-}
    if [[ -n "${SUDO:-}" ]]; then
      info "You do not have write permissions to the installation path ${install_path}"
      info "If you have administrative privileges, enter your password to install ${package_to_build}"
    fi
    info "Installing with the following command: ${SUDO:-} make install"
    ${SUDO:-} make install

  else
     emergency "This branch should never be reached."
  fi # end if [[ "${package_to_build}" != "gcc"  && "${package_to_build}" != "cmake"  ]]; then


  info "popd"
  popd || emergency "build_and_install.sh: popd failed"
}

# shellcheck shell=bash disable=SC2154,SC2129,SC2148
report_results()
{
  # Report installation success or failure:
  if [[ -x "$install_path/bin/caf" && -x "$install_path/bin/cafrun" ]]; then

    # Installation succeeded
    echo "$this_script: Done."
    echo ""
    echo "*** The OpenCoarrays compiler wrapper (caf) and program  ***"
    echo "*** launcher (cafrun) are in the following directory:    ***"
    echo ""
    echo "$install_path/bin."
    echo ""
    if [[ -f setup.sh ]]; then
      ${SUDO:-} rm setup.sh
    fi
    if [[ -f setup.csh ]]; then
      ${SUDO:-} rm setup.csh
    fi
    # Prepend the OpenCoarrays license to the setup.sh script:
    while IFS='' read -r line || [[ -n "$line" ]]; do
        echo "# $line" >> setup.sh
    done < "${opencoarrays_src_dir}/LICENSE"
    while IFS='' read -r line || [[ -n "$line" ]]; do
        echo "# $line" >> setup.csh
    done < "${opencoarrays_src_dir}/LICENSE"
    echo "#                                                                      " | tee -a setup.csh setup.sh
    echo "# Execute this script via the following command:                       " | tee -a setup.csh setup.sh
    echo "# source $install_path/setup.sh                                        " | tee -a setup.csh setup.sh
    echo "                                                                       " | tee -a setup.csh setup.sh
    gcc_install_path=$("${build_script}" -P gcc)
    if [[ -x "$gcc_install_path/bin/gfortran" ]]; then
      echo "if [[ -z \"\$PATH\" ]]; then                                         " >> setup.sh
      echo "  export PATH=\"$gcc_install_path/bin\"                              " >> setup.sh
      echo "else                                                                 " >> setup.sh
      echo "  export PATH=\"$gcc_install_path/bin:\$PATH\"                       " >> setup.sh
      echo "fi                                                                   " >> setup.sh
      echo "set path = (\"$gcc_install_path\"/bin \"\$path\")                    " >> setup.csh
    fi
    if [[ -d "$gcc_install_path/lib" || -d "$gcc_install_path/lib64" ]]; then
      gfortran_lib_paths="$gcc_install_path/lib64/:$gcc_install_path/lib"
      echo "if [[ -z \"\$LD_LIBRARY_PATH\" ]]; then                              " >> setup.sh
      echo "  export LD_LIBRARY_PATH=\"$gfortran_lib_paths\"                     " >> setup.sh
      echo "else                                                                 " >> setup.sh
      echo "  export LD_LIBRARY_PATH=\"$gfortran_lib_paths:\$LD_LIBRARY_PATH\"   " >> setup.sh
      echo "fi                                                                   " >> setup.sh
      echo "set LD_LIBRARY_PATH = (\"$gfortran_lib_paths\"/bin \"\$LD_LIBRARY_PATH\")                      " >> setup.csh
    fi
    echo "                                                                       " >> setup.sh
    mpich_install_path=$("${build_script}" -P mpich)
    if [[ -x "$mpich_install_path/bin/mpif90" ]]; then
      echo "if [[ -z \"\$PATH\" ]]; then                                         " >> setup.sh
      echo "  export PATH=\"$mpich_install_path/bin\"                            " >> setup.sh
      echo "else                                                                 " >> setup.sh
      echo "  export PATH=\"$mpich_install_path/bin\":\$PATH                     " >> setup.sh
      echo "fi                                                                   " >> setup.sh
      echo "set path = (\"$mpich_install_path\"/bin \"\$path\")                      " >> setup.csh
    fi
    cmake_install_path=$("${build_script}" -P cmake)
    if [[ -x "$cmake_install_path/bin/cmake" ]]; then
      echo "if [[ -z \"\$PATH\" ]]; then                                         " >> setup.sh
      echo "  export PATH=\"$cmake_install_path/bin\"                            " >> setup.sh
      echo "else                                                                 " >> setup.sh
      echo "  export PATH=\"$cmake_install_path/bin\":\$PATH                     " >> setup.sh
      echo "fi                                                                   " >> setup.sh
      echo "set path = (\"$cmake_install_path\"/bin \"\$path\")                      " >> setup.csh
    fi
    flex_install_path=$("${build_script}" -P flex)
    if [[ -x "$flex_install_path/bin/flex" ]]; then
      echo "if [[ -z \"\$PATH\" ]]; then                                         " >> setup.sh
      echo "  export PATH=\"$flex_install_path/bin\"                             " >> setup.sh
      echo "else                                                                 " >> setup.sh
      echo "  export PATH=\"$flex_install_path/bin\":\$PATH                      " >> setup.sh
      echo "set path = (\"$flex_install_path\"/bin \"\$path\")                      " >> setup.csh
      echo "fi                                                                   " >> setup.sh
    fi
    bison_install_path=$("${build_script}" -P bison)
    if [[ -x "$bison_install_path/bin/yacc" ]]; then
      echo "if [[ -z \"\$PATH\" ]]; then                                         " >> setup.sh
      echo "  export PATH=\"$bison_install_path/bin\"                            " >> setup.sh
      echo "else                                                                 " >> setup.sh
      echo "  export PATH=\"$bison_install_path/bin\":\$PATH                     " >> setup.sh
      echo "fi                                                                   " >> setup.sh
      echo "set path = (\"$bison_install_path\"/bin \"\$path\")                      " >> setup.csh
    fi
    m4_install_path=$("${build_script}" -P m4)
    if [[ -x "$m4_install_path/bin/m4" ]]; then
      echo "if [[ -z \"\$PATH\" ]]; then                                         " >> setup.sh
      echo "  export PATH=\"$m4_install_path/bin\"                               " >> setup.sh
      echo "else                                                                 " >> setup.sh
      echo "  export PATH=\"$m4_install_path/bin\":\$PATH                        " >> setup.sh
      echo "fi                                                                   " >> setup.sh
      echo "set path = (\"$m4_install_path\"/bin \"\$path\")                      " >> setup.csh
    fi
    opencoarrays_install_path="${install_path}"
    if [[ -x "$opencoarrays_install_path/bin/caf" ]]; then
      echo "if [[ -z \"\$PATH\" ]]; then                                         " >> setup.sh
      echo "  export PATH=\"$opencoarrays_install_path/bin\"                     " >> setup.sh
      echo "else                                                                 " >> setup.sh
      echo "  export PATH=\"$opencoarrays_install_path/bin\":\$PATH              " >> setup.sh
      echo "fi                                                                   " >> setup.sh
      echo "set path = (\"$opencoarrays_install_path\"/bin \"\$path\")                      " >> setup.csh
    fi
    if ${SUDO:-} mv setup.sh "$opencoarrays_install_path"; then
       setup_sh_location=$opencoarrays_install_path
    else
       setup_sh_location=${PWD}
    fi
    if ${SUDO:-} mv setup.csh "$opencoarrays_install_path"; then
       setup_csh_location=$opencoarrays_install_path
    else
       setup_csh_location=${PWD}
    fi
    echo "*** To set up your environment for using caf and cafrun, please   ***"
    echo "*** source the installed setup.sh file in a bash shell or source  ***"
    echo "*** setup.csh in a C-shell or add one of the following statements ***"
    echo "*** to your login file:                                           ***"
    echo ""
    echo " source $setup_sh_location/setup.sh"
    echo " source $setup_csh_location/setup.csh"
    echo ""
    echo "*** Installation complete.                                        ***"

  else # Installation failed

    echo "Something went wrong. Either the user lacks executable permissions for the"
    echo "OpenCoarrays compiler wrapper (caf), program launcher (cafrun), or prerequisite"
    echo "package installer (build), or these programs are not in the following, expected"
    echo "location:"
    echo "$install_path/bin."
    echo "Please review the following file for more information:"
    echo "$install_path/$installation_record"
    echo "and submit an bug report at https://github.com/sourceryinstitute/opencoarrays/issues"
    echo "[exit 100]"
    exit 100

  fi # Ending check for caf, cafrun, build not in expected path
}

# BASH3 Boilerplate
#
#  set_magic_variables.sh
#
#  - Sets the variables __dir, __file, __filename, __base, and __os
#  - Defines a function containing commands extracted from the bash3boilerplate
#    main.sh as part of a refactoring to facilitate wholesale reuse of main.sh's
#    contents of without modification.
#
#  Usage (as invoked in bootstrap.sh):
#
#    source set_magic_variables.sh "$(caller 0)"
#
# More info:
#
#  - https://github.com/kvz/bash3boilerplate
#  - http://kvz.io/blog/2013/02/26/introducing-bash3boilerplate/
#
# Version: 2.1.0
#
# Authors:
#
#  - Kevin van Zonneveld (http://kvz.io)
#  - Izaak Beekman (https://izaakbeekman.com/)
#  - Alexander Rathai (Alexander.Rathai@gmail.com)
#  - Dr. Damian Rouson (http://www.sourceryinstitute.org/) (documentation)
#
# Licensed under MIT
# Copyright (c) 2013 Kevin van Zonneveld (http://kvz.io)

# shellcheck disable=SC2016
[ -z "${1}" ] && echo 'Usage: source set_magic_variables.sh "$(caller 0)"'
# shellcheck disable=SC2034
function set_magic_variables(){
  text_after_final_space="${1##* }"
  __dir="$(cd "$(dirname "${text_after_final_space}")" && pwd)"
  __file="${__dir}/$(basename "${text_after_final_space}")"
  __filename="$(basename "${text_after_final_space}")"
  __base="$(basename "${__file}" .sh)"
  __os="Linux"
  if [[ "${OSTYPE:-}" == "darwin"* ]]; then
    __os="OSX"
  fi
  __usage="${__usage:-${__file}-usage}"
}
set_magic_variables "${@}"

#!/bin/bash
#
# gitkeep.sh
#

description=\
'bash script for adding empty ".gitkeep" files at the branch ends of empty directory trees'

use_case=\
"Use case:

    Force git to track otherwise empty directories such as doc/dependency_tree/opencoarrays,
    which exists solely for purposes of displaying the OpenCoarrays dependency tree via the
    command 'tree opencoarrays'."
#
# OpenCoarrays is distributed under the OSI-approved BSD 3-clause License:
# Copyright (c) 2015, 2016, Sourcery, Inc.
# Copyright (c) 2015, 2016, Sourcery Institute
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without modification,
# are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice, this
#    list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright notice, this
#    list of conditions and the following disclaimer in the documentation and/or
#    other materials provided with the distribution.
# 3. Neither the names of the copyright holders nor the names of their contributors
#    may be used to endorse or promote products derived from this software without
#    specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
this_script=`basename $0`

usage()
{
    echo ""
    echo " $this_script - $description"
    echo ""
    echo " Usage: "
    echo "      $this_script <path-to-modify>"
    echo ""
    echo " Examples:"
    echo ""
    echo "   $this_script ."
    echo ""
    printf "$use_case"
    exit 1
}

# If this script is invoked without arguements, print usage information
# and terminate execution of the script.
if [[ $# == 0 || "$1" == "-h" || "$1" == "--help" ]]; then
  usage | less
  exit 1
fi

# Interpret the first argument as the name of the directory tree to fill
export path_to_modify=$1

# Create an empty ".gitkeep" file in all empty subdirectories
find $path_to_modify -type d -empty -exec touch {}/.gitkeep \;

# shellcheck shell=bash disable=SC2154,SC2148
need_xcodeCLT() {
  if [[ "${OSTYPE}" != [Dd][Aa][Rr][Ww][Ii][Nn]* ]]; then
    echo "false"
  else
    local xcode_dir
    xcode_dir="$(/usr/bin/xcode-select -print-path 2>/dev/null)" || true
    if [[ ! -d "${xcode_dir}" || ! -x "${xcode_dir}/usr/bin/make" ]]; then
      echo "true"
    else
      echo "false"
    fi
  fi
}

xcode_clt_install () {
  app_store_label="$(softwareupdate -l | grep -B 1 -E "Command Line (Developer|Tools)" | awk -F"*" '/^ +\\*/ {print $2}' | sed 's/^ *//' | tail -n1)" || return 0
  if [[ "${arg_y}" == "${__flag_present}" ]]; then
    info "-y or --yes-to-all flag present. Proceeding with non-interactive download and install."
  else
    info "If you proceed with the Xcode-CLT installation you may be prompted for your password."
    printf "Ready to install %s? (Y/n)" "${app_store_label}"
    read -r install_xcodeclt
    printf '%s\n' "${install_xcodeclt}"
    if [[ "${install_xcodeclt}" == [nN]* ]]; then
      emergency "${this_script}: Aborting: cannot proceed without XCode CLT."
    fi
  fi
  info "install.sh will attempt to download and install XCode CLT for you now."
  info "Note: sudo privileges required. Please enter your password if prompted."
  place_holder="/tmp/.com.apple.dt.CommandLineTools.installondemand.in-progress"
  sudo /usr/bin/touch "${place_holder}" || true
  sudo /usr/sbin/softwareupdate -i app_store_label || return 0
  sudo /bin/rm -f "${place_holder}" || true
  sudo /usr/bin/xcode-select --switch "/Library/Developer/CommandLineTools" || return 1
}

headless_xcode_clt_install () {
  # Fallback here if headless install/upgrade failed. This is the usual path through this code.
  if [[ "${arg_y}" == "${__flag_present}" ]]; then
    info "-y or --yes-to-all flag present. Proceeding with non-interactive download and install."
  else
    info "If you proceed with the Xcode-CLT installation you may be prompted for your password."
    printf "Ready to install Xcode-CLT using xcode-select? (Y/n)"
    read -r install_xcodeclt
    printf '%s\n' "${install_xcodeclt}"
    if [[ "${install_xcodeclt}" == [nN]* ]]; then
      emergency "${this_script}: Aborting: cannot proceed without XCode CLT."
    fi
  fi
  info "Installing Xcode Command Line Tools (CLT), using \`xcode-select --install\`."
  info "Note: sudo privileges required. Please enter your password if prompted."
  sudo /usr/bin/xcode-select --install || emergency "${this_script}: unable to run \`sudo xcode-select --install\`"
  printf "Please press <enter> once installation of Xcode command line tools has completed."
  read -r
  sudo /usr/bin/xcode-select --switch "/Library/Developer/CommandLineTools" || \
    emergency "${this_script}: Xcode-CLT installation and activation failed, unable to continue"
}

maybe_install_xcodeCLT () {
  if [[ "$(need_xcodeCLT)" == "true" ]]; then
    info "It appears that you are on Mac OS and do not have the Xcode command line tools (CLT) installed,"
    info "or they need to be upgraded.install.sh will now attempt to install/upgrade the Xcode-CLT using \`softwareupdate\`"
    info "This may take some time, please be patient."
    xcode_clt_install || true # This usually fails since `softwareupdate -i` doesn't return CLTs needing update
  fi
  if [[ "$(need_xcodeCLT)" == "true" ]]; then
    info "\`softwareupdate\` installation/upgrade failed. This is normal. Now trying with \`xcode-select --install\`"
    headless_xcode_clt_install || emergency "${this_script}: Could not install Xcode command line tools, unable to proceed. Please install them via the app store before retrying this installation."
  fi

  clang_output="$(/usr/bin/xzrun clang 2>&1)" || true
  if [[ "${clang_output}" =~ license ]]; then
    emergency "${this_script}: It appears you have not agreed to the Xcode license. Please do so before attempting to run this script again. This may be achieved by opening Xcode.app or running \`sudo xcodebuild -license\`"
  fi
}

#!/usr/bin/env bash
# BASH3 Boilerplate
#
# install-ofp.sh
#
#  - Build the Open Fortran Parser
#
# Usage: ./install-ofp.sh -i /opt
#
# More info:
#
#  - https://github.com/kvz/bash3boilerplate
#  - http://kvz.io/blog/2013/02/26/introducing-bash3boilerplate/
#
# Version: 2.0.0
#
# Authors:
#
#  - Kevin van Zonneveld (http://kvz.io)
#  - Izaak Beekman (https://izaakbeekman.com/)
#  - Alexander Rathai (Alexander.Rathai@gmail.com)
#  - Dr. Damian Rouson (http://www.sourceryinstitute.org/) (documentation)
#
# Licensed under MIT
# Copyright (c) 2013 Kevin van Zonneveld (http://kvz.io)

# The invocation of bootstrap.sh below performs the following tasks:
# (1) Import several bash3boilerplate helper functions & default settings.
# (2) Set several variables describing the current file and its usage page.
# (3) Parse the usage information (default usage file name: current file's name with -usage appended).
# (4) Parse the command line using the usage information.

export OPENCOARRAYS_SRC_DIR="${OPENCOARRAYS_SRC_DIR:-${PWD}/..}"
if [[ ! -f "${OPENCOARRAYS_SRC_DIR}/src/libcaf.h" ]]; then
  echo "Please run this script inside the OpenCoarrays source \"prerequisites\" subdirectory"
  echo "or set OPENCOARRAYS_SRC_DIR to the top-level OpenCoarrays source directory path."
  exit 1
fi
export __usage="${OPENCOARRAYS_SRC_DIR}/prerequisites/install-ofp.sh-usage"
export B3B_USE_CASE="${B3B_USE_CASE:-${OPENCOARRAYS_SRC_DIR}/prerequisites/use-case}"
if [[ ! -f "${B3B_USE_CASE:-}/bootstrap.sh" ]]; then
  echo "Please set B3B_USE_CASE to the bash3boilerplate use-case directory path."
  exit 2
fi
# shellcheck source=./use-case/bootstrap.sh
source "${B3B_USE_CASE}/bootstrap.sh" "$@"

# Set up a function to call when receiving an EXIT signal to do some cleanup. Remove if
# not needed. Other signals can be trapped too, like SIGINT and SIGTERM.
function cleanup_before_exit () {
  info "Cleaning up. Done"
}
trap cleanup_before_exit EXIT # The signal is specified here. Could be SIGINT, SIGTERM etc.

export __flag_present=1

# Verify requirements

[ -z "${LOG_LEVEL:-}" ] && emergency "Cannot continue without LOG_LEVEL. "

# shellcheck disable=SC2154
if [[ "${__os}" != "OSX" ]]; then
   info      "${__base} currently installs binaries that work only on OS X"
   emergency "To request other platforms, please submit an issue at http://github.com/sourceryinstitute/opencoarrays/issues"
fi

if [[ $(uname) == "Darwin"  ]]; then
  default_ofp_downloader=curl
  args="-LO"
else
  default_ofp_downloader=wget
  args="--no-check-certificate"
fi

# If -D is passed, print the download programs used for OFP and its prerequisites.
# Then exit with normal status.
# shellcheck  disable=SC2154
if [[ "${arg_D}" == "${__flag_present}" ]]; then
  echo "strategoxt-superbundle downloader: $("${OPENCOARRAYS_SRC_DIR}/prerequisites/install-binary.sh" -D strategoxt-superbundle)"
  echo "ofp-sdf default downloader: ${default_ofp_downloader}"
  exit 0
fi

# If -P is passed, print the default installation paths for OFP and its prerequisites.
# Then exit with normal status.
install_path="${arg_i}"
strategoxt_superbundle_install_path=`${OPENCOARRAYS_SRC_DIR}/prerequisites/install-binary.sh -P strategoxt-superbundle`
# shellcheck disable=SC2154
if [[ "${arg_P}" == "${__flag_present}" ]]; then
  echo "strategoxt-superbundle default installation path: ${strategoxt_superbundle_install_path}"
  echo "ofp default installation path: ${install_path}"
  exit 0
fi

# If -V is passed, print the default versions of OFP and its prerequisites.
# Then exit with normal status.
default_ofp_version=sdf
# shellcheck disable=SC2154
if [[ "${arg_V}" == "${__flag_present}" ]]; then
  echo "strategoxt-superbundle default version: $("${OPENCOARRAYS_SRC_DIR}/prerequisites/install-binary.sh" -V strategoxt-superbundle)"
  echo "ofp default version: ${default_ofp_version}"
  exit 0
fi

# If -U is passed, print the URLs for OFP and its prerequisites.
# Then exit with normal status.
ofp_url_head="https://github.com/sourceryinstitute/opencoarrays/files/213108/"
ofp_url_tail="ofp-sdf.tar.gz"
# shellcheck disable=SC2154
if [[ "${arg_U}" == "${__flag_present}" ]]; then
  echo "strategoxt-superbundle URL: $("${OPENCOARRAYS_SRC_DIR}/prerequisites/install-binary.sh" -U strategoxt-superbundle)"
  echo "ofp URL: ${ofp_url_head}${ofp_url_tail}"
  exit 0
fi

### Print bootstrapped magic variables to STDERR when LOG_LEVEL
### is at the default value (6) or above.
#####################################################################
# shellcheck disable=SC2154
{
info "__file: ${__file}"
info "__dir: ${__dir}"
info "__base: ${__base}"
info "__os: ${__os}"
info "__usage: ${__usage}"
info "LOG_LEVEL: ${LOG_LEVEL}"

info "-d (--debug):            ${arg_d}"
info "-D (--print-downloader): ${arg_D}"
info "-e (--verbose):          ${arg_e}"
info "-h (--help):             ${arg_h}"
info "-i (--install-dir):      ${arg_i}"
info "-I (--install-version):  ${arg_i}"
info "-j (--num-threads):      ${arg_j}"
info "-n (--no-color):         ${arg_n}"
info "-P (--print-path):       ${arg_P}"
info "-U (--print-url):        ${arg_U}"
info "-V (--print-version):    ${arg_V}"
}
# Set OFP installation path to the value of the -i argument if present.
# Otherwise, install OFP in the OpenCoarrays prerequisites/installations directory.
opencoarrays_prerequisites_dir="${OPENCOARRAYS_SRC_DIR}"/prerequisites/
if [[ "${arg_i}" == "${__flag_present}" ]]; then
  install_path="${arg_i}"
else
  install_path="${opencoarrays_prerequisites_dir}"/installations
fi

ofp_prereqs_install_dir="/opt"
# Change present working directory to installation directory
if [[ ! -d "${install_path}" ]]; then
  # shellcheck source=./build-functions/set_SUDO_if_needed_to_write_to_directory.sh
  source "${opencoarrays_prerequisites_dir}/build-functions/set_SUDO_if_needed_to_write_to_directory.sh"
  set_SUDO_if_needed_to_write_to_directory "${install_path}"
  ${SUDO:-} mkdir -p "${install_path}"
fi

# Install OFP prerequisites to /opt (currently the only option)
"${opencoarrays_prerequisites_dir}"/install-binary.sh -p strategoxt-superbundle -i "${strategoxt_superbundle_install_path}"

# Downlaod OFP
pushd "${install_path}"
info "OFP Download command: ${default_ofp_downloader} ${args:-} \"${ofp_url_head}${ofp_url_tail}\""
${default_ofp_downloader} ${args:-} "${ofp_url_head}${ofp_url_tail}" 


# Uncompress OFP
tar xf ofp-sdf.tar.gz
# Return to the original working directory
popd

export SDF2_PATH="${ofp_prereqs_install_dir}"/sdf2-bundle/v2.4/bin
export ST_PATH="${ofp_prereqs_install_dir}"/strategoxt/v0.17/bin
export DYLD_LIBRARY_PATH="${ofp_prereqs_install_dir}"/strategoxt/v0.17/lib:/opt/aterm/v2.5/lib

export OFP_HOME="${install_path}"/ofp-sdf
# shellcheck source=./install-binary-functions/build_parse_table.sh
source "${opencoarrays_prerequisites_dir}"/install-binary-functions/build_parse_table.sh
build_parse_table

# Set CC, CXX, and FC
# shellcheck disable=SC2154
set_compilers()
{
  # If FC is already set, use the set value.
  # Else if FC is empty, use the value specified via the -f or --with-fortran command-line arguments.
  # Else use the default specifed in ../build.sh-usage.
  FC=${FC:-${arg_f}}
  info "Fortran compiler: ${FC}"

  if [[ $(uname) == "Darwin" && "${package_to_build}" == "cmake"  ]]; then
    if [[ -x "/usr/bin/gcc" ]]; then
      [ ! -z "${CC:-}" ] && info "Overriding CC: cmake build requires Apple LLVM gcc, which XCode command-line tools puts in /usr/bin"
      CC=/usr/bin/gcc
    else
      info      "OS X detected.  Please install XCode command-line tools and "
      emergency "ensure that /usr/bin/gcc exists and is executable. Aborting."
    fi
  else
    # If CC is already set, use the set value.
    # Else if CC is empty, use the value specified via the -c or --with-c command-line arguments.
    # Else use the default specifed in ../build.sh-usage.
    CC=${CC:-${arg_c}}
  fi
  info "C compiler: ${CC}"

  if [[ $(uname) == "Darwin" && ${package_to_build} == "cmake"  ]]; then
    if [[ -x "/usr/bin/g++" ]]; then
      [ ! -z "${CXX:-}" ] && info "Overriding CXX: cmake build requires Apple LLVM g++, which XCode command-line tools puts in /usr/bin"
      CXX=/usr/bin/g++
    else
      info      "OS X detected.  Please install XCode command-line tools and "
      emergency "ensure that /usr/bin/g++ exists and is executable. Aborting."
    fi
  else
    # If CXX is already set, use the set value.
    # Else if CXX is empty, use the value specified via the -C or --with-cxx command-line arguments.
    # Else use the default specifed in ../build.sh-usage.
    CXX=${CXX:-${arg_C}}
  fi
  info "C++ compiler: ${CXX}"
}

#!/bin/sh
echo "Building the code:"
export TAU_MAKEFILE=/opt/paratools/tau/x86_64/lib/Makefile.tau-mpi-pdt
export TAU_OPTIONS="-optVerbose -optCompInst"
make clean
make -f Makefile.inst

# Specify TAU parameters here:
export TAU_CALLPATH=1
export TAU_CALLPATH_DEPTH=100
#export TAU_SAMPLING=1

for i in 1 2 4
do
  echo "Running the code:"
  mpiexec -np ${i} ./burgers
  paraprof --pack ${i}p.ppk
  taudb_loadtrial -a fireworks -x experiment -n ${i} ${i}p.ppk
done

echo "Running the pprof command:"
pprof
echo "Running the TAU paraprof analyzer command:"
paraprof &

# If -p, -P, -U, or -V specifies a package, set fetch variable
# If -D specifies a package, print "${fetch}" and exit with normal status
# If -l is present, list all packages and versions and exit with normal status
# shellcheck disable=SC2154
set_or_print_downloader()
{
  # Verify requirements
  if [[ ! -z "${arg_D}" ]]; then
    if  [[ "${arg_N:-}" == "${__flag_present}" || ! -z "${arg_p:-${arg_P:-${arg_U:-${arg_V}}}}" ]]; then
      emergency "Please pass only one of {-D, -N, -p, -P, -U, -V} or a longer equivalent (multiple detected)."
    fi
  fi
  package_name="${arg_D:-${arg_p:-${arg_P:-${arg_U:-${arg_V}}}}}"
  if [[ $(uname) == "Darwin" ]]; then
    wget_or_curl=curl
  else
    wget_or_curl=wget
  fi  
  # This is a bash 3 hack standing in for a bash 4 hash (bash 3 is the lowest common
  # denominator because, for licensing reasons, OS X only has bash 3 by default.)
  # See http://stackoverflow.com/questions/1494178/how-to-define-hash-tables-in-bash
  package_fetch=(
    "strategoxt-superbundle:${wget_or_curl}"
  )
  for package in "${package_fetch[@]}" ; do
     KEY="${package%%:*}"
     VALUE="${package##*:}"
     if [[ "${package_name}" == "${KEY}" ]]; then
       # We recognize the package name so we set the download mechanism:
       fetch=${VALUE}
       # If a printout of the download mechanism was requested, then print it and exit with normal status
       [[ ! -z "${arg_D}" ]] && printf "%s\n" "${fetch}" && exit 0
       break # exit the for loop
     fi
  done
  if [[ -z "${fetch:-}" ]]; then
    emergency "Package ${package_name:-} not recognized.  Use -l or --list-packages to list the allowable names."
  fi
}

#!/bin/bash
#
# check_version.sh
#
# -- Verify whether an OpenCoarrays prerequisite meets the required minimum version number.
#
# OpenCoarrays is distributed under the OSI-approved BSD 3-clause License:
# Copyright (c) 2015-2022, Sourcery Institute
# Copyright (c) 2015-2022, Archaeologic Inc.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without modification,
# are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice, this
#    list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright notice, this
#    list of conditions and the following disclaimer in the documentation and/or
#    other materials provided with the distribution.
# 3. Neither the names of the copyright holders nor the names of their contributors
#    may be used to endorse or promote products derived from this software without
#    specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.

# Interpret the first argument as the package executable name
package="$1"
# Interpret the second argument as the minimimum acceptable package version number
minimum_version="$2"
# Interpret the third argument as indicating the desired verbosity
verbose=$3

this_script=$(basename "$0")

usage()
{
    echo ""
    echo " $this_script - Bash script for verifying minimum version numbers for OpenCoarrays prerequisites"
    echo ""
    echo " Usage (optional arguments in square brackets): "
    echo "      $this_script [<option>]"
    echo "      $this_script  <package-name> <minimum-version-number> [--verbose]"
    echo ""
    echo " Options:"
    echo "   --help, -h           Show this help message"
    echo "   --list , -l          List the packages whose versions this script can verify"
    echo ""
    echo " Examples:"
    echo ""
    echo "   $this_script cmake 3.4.0"
    echo "   $this_script flex 2.6.0 --verbose"
    echo "   $this_script flex $(./build.sh -V flex )"
    echo "   $this_script --help"
    echo "   $this_script --list"
    echo ""
    echo "[exit 10]"
    exit 10
}

# Print usage information and exit if script is invoked without arguments or with --help or -h as the first argument
if [ $# == 0 ]; then
  usage | less
  exit 20

elif [[ $1 == '--help' || $1 == '-h' ]]; then
  usage | less
  exit 0

elif [[ $1 == '--list' || $1 == '-l' ]]; then
 echo "$this_script currently verifies minimum version numbers for the following OpenCoarrays prerequisites:"
 echo "   cmake, flex, bison, m4"
 exit 40

elif [[ $1 == '-v' || $1 == '-V' || $1 == '--version' ]]; then
  # Print script copyright if invoked with -v, -V, or --version
  # argument Extract version from .VERSION file. Git automatically
  # inserts various things when performing git archive, so ensure we
  # extract just the first version string
  opencoarrays_version=$(sed -n '/[0-9]\{1,\}\(\.[0-9]\{1,\}\)\{1,\}/{s/^\([^.]*\)\([0-9]\{1,\}\(\.[0-9]\{1,\}\)\{1,\}\)\(.*\)/\2/p;q;}' ../.VERSION)
  echo "opencoarrays $opencoarrays_version"
  echo ""
  echo "OpenCoarrays prerequisite version verifier"
  echo "Copyright (C) 2015-2016 Sourcery, Inc."
  echo "Copyright (C) 2015-2016 Sourcery Institute"
  echo ""
  echo "OpenCoarrays comes with NO WARRANTY, to the extent permitted by law."
  echo "You may redistribute copies of $this_script under the terms of the"
  echo "BSD 3-Clause License.  For more information about these matters, see"
  echo "http://www.sourceryinstitute.org/license.html"
  echo ""
fi

package_version_header=$($package --version | head -1)
if [[ "$verbose" == "--verbose" ]]; then
  echo "$package_version_header"
fi

before_first_dot="${package_version_header%%.*}"
major="${before_first_dot##* }" # grab text after final space in remaining string

after_first_dot="${package_version_header#*.}"
minor="${after_first_dot%%.*}"

after_final_dot="${package_version_header##*.}" # grab text after final dot
if [[ "$after_final_dot" == "$after_first_dot" ]]; then
  patch=""
else
  patch="${after_final_dot%% *}"
fi

if [[ "$verbose" == "--verbose" ]]; then
  echo "$major . $minor . $patch"
fi

min_major=${minimum_version%%.*}
min_minor_patch=${minimum_version#*.}
min_minor=${min_minor_patch%%.*}
min_patch=${minimum_version##*.}

if [[ "$verbose" == "--verbose" ]]; then
  echo "$minimum_version = $min_major . $min_minor . $min_patch"
fi

if [ "$(( major < min_major ))" -ne 0 ]; then
  if [[ $verbose == "--verbose" ]]; then
    echo "$major < $min_major"
  fi
  exit 10
elif [[ $verbose == "--verbose" ]]; then
  echo "$major >= $min_major"
fi

if [ "$(( minor < min_minor ))" -ne 0 ]; then
  if [[ $verbose == "--verbose" ]]; then
    echo "$minor < $min_minor"
  fi
  exit 20
elif [[ $verbose == "--verbose" ]]; then
  echo "$minor >= $min_minor"
fi

if [ "$(( patch < min_patch ))" -ne 0 ]; then
  if [[ $verbose == "--verbose" ]]; then
    echo "$patch < $min_patch"
  fi
  exit 30
elif [[ $verbose == "--verbose" ]]; then
  echo "$patch >= $min_patch"
fi
exit 0

# If -p, -D, -P, or -U specifies a package, set default_version
# If -V specifies a package, print the default_version and exit with normal status
# If -l is present, list all packages and versions and exit with normal status
# shellcheck disable=SC2154
set_or_print_default_version()
{
  # Verify requirements
  [ "${arg_l}" == "${__flag_present}" ] && [ ! -z "${arg_D:-${arg_p:-${arg_P:-${arg_U:-${arg_V}}}}}" ] &&
    emergency "Please pass only one of {-l, -D, -p, -P, -U, -V} or a longer equivalent (multiple detected)."

  if [[ "${arg_l}" == "${__flag_present}" ]]; then
    echo "This script can build the following packages:"
  fi
  # Get package name from argument passed with -p, -V, -D, or -U
  package_name="${arg_p:-${arg_D:-${arg_P:-${arg_U:-${arg_V}}}}}" # not needed for -l

  if [[ "${package_name}" == "ofp" ]]; then
    ${OPENCOARRAYS_SRC_DIR}/prerequisites/install-ofp.sh "${@}"
    exit 0
  fi 

  [ "${package_name}" == "opencoarrays" ] && 
    emergency "Please use this script with a previously downloaded opencoarrays source archive. This script does not download opencoarrays "
  # This is a bash 3 hack standing in for a bash 4 hash (bash 3 is the lowest common
  # denominator because, for licensing reasons, OS X only has bash 3 by default.)
  # See http://stackoverflow.com/questions/1494178/how-to-define-hash-tables-in-bash
  package_version=(
    "cmake:3.4.0"
    "gcc:6.1.0"
    "mpich:3.1.4"
    "wget:1.16.3"
    "flex:2.6.0"
    "bison:3.0.4"
    "pkg-config:0.28"
    "make:4.1"
    "m4:1.4.17"
    "subversion:1.9.4"
    "ofp:sdf"
  )
  for package in "${package_version[@]}" ; do
     KEY="${package%%:*}"
     VALUE="${package##*:}"
     if [[  "${arg_l}" == "${__flag_present}" ]]; then
       # If the list was requested, print the current element of the name:version list.
       printf "%s (default version %s)\n" "${KEY}" "${VALUE}"
     elif [[ "${package_name}" == "${KEY}" ]]; then
       # We recognize the package name so we set the default version:
       default_version=${VALUE}
       # If a printout of the default version number was requested, then print it and exit with normal status
       [[ ! -z "${arg_V}" ]] && printf "%s\n" "${default_version}" && exit 0
       break # exit the for loop
     fi
  done

 # Exit with normal status (package/version has been printed).
 [ "${arg_l}" == "${__flag_present}" ] && exit 0

 # Exit with error status and diagnostic output if empty default_version
 if [[ -z "${default_version:-}" ]]; then
    emergency "Package ${package_name:-} not recognized.  Use --l or --list-packages to list the allowable names."
 fi
}

# shellcheck disable=SC2154
build_opencoarrays()
{
  print_header
  info "Invoking find_or_install mpich"
  find_or_install mpich
  info "Invoking find_or_install cmake"
  find_or_install cmake
  build_path="${build_path}"/opencoarrays/$("${opencoarrays_src_dir}"/install.sh -V opencoarrays)
  mkdir -p "$build_path"
  pushd "$build_path"
  if [[ -z "${MPICC:-}" || -z "${MPIFC:-}" || -z "${CMAKE:-}" ]]; then
    emergency "Empty MPICC=$MPICC or MPIFC=$MPIFC or CMAKE=$CMAKE [exit 90]"
  else
    info "Configuring OpenCoarrays in ${PWD} with the command:"
    info "CC=\"${MPICC}\" FC=\"${MPIFC}\" $CMAKE \"${opencoarrays_src_dir}\" -DCMAKE_INSTALL_PREFIX=\"${install_path}\""
    CC="${MPICC}" FC="${MPIFC}" $CMAKE "${opencoarrays_src_dir}" -DCMAKE_INSTALL_PREFIX="${install_path}"
    info "Building OpenCoarrays in ${PWD} with the command make -j${num_threads}"
    make "-j${num_threads}"
    if [[ ! -z ${SUDO:-} ]]; then
      printf "\nThe chosen installation path requires sudo privileges. Please enter password if prompted.\n"
    fi
    info "Installing OpenCoarrays in ${install_path} with the command ${SUDO:-} make install"
    ${SUDO:-} make install
  fi
}

# Download a file from an anonymous ftp site
#
# Usage:
#    ftp-url  <ftp-mode>  <ftp-site-address>:/<path-to-file>/<file-name>
#
# Example:
#    ftp-url -n ftp.gnu.org:/gnu/m4/m4-1.4.17.tar.bz2
ftp-url()
{
  ftp_mode="${1}"
  url="${2}"

  text_before_colon="${url%%:*}"
  FTP_SERVER="${text_before_colon}"

  text_after_colon="${url##*:}"
  text_after_final_slash="${text_after_colon##*/}"
  FILE_NAME="${text_after_final_slash}"

  text_before_final_slash="${text_after_colon%/*}"
  FILE_PATH="${text_before_final_slash}"

  USERNAME=anonymous
  PASSWORD=""
  info "starting anonymous download: ftp ${ftp_mode} ${FTP_SERVER}... cd ${FILE_PATH}... get ${FILE_NAME}"

ftp "${ftp_mode}" "${FTP_SERVER}" <<Done-ftp
user "${USERNAME}" "${PASSWORD}"
cd "${FILE_PATH}"
passive
binary
get "${FILE_NAME}"
bye
Done-ftp

info "finished anonymous ftp"
}

# If -P specifies a package, print the installation path and exit with normal status
# Otherwise, set install_path
# shellcheck disable=SC2154
set_or_print_installation_path()
{
  # Verify requirements
  [ ! -z "${arg_P}" ] && [ ! -z "${arg_p:-${arg_D:-${arg_U:-${arg_V}}}}" ] &&
    emergency "Please pass only one of {-D, -p, -P, -U, -V} or a longer equivalent (multiple detected)."

  install_path="${arg_i%/}/${arg_p:-${arg_D:-${arg_P:-${arg_U:-${arg_V}}}}}/${version_to_build}"

  # If -P is present, print ${install_path} and exit with normal status
  if [[ ! -z "${arg_P:-}" ]]; then
    printf "%s\n" "${install_path}"
    exit 0
  fi

  info "${package_name} ${version_to_build} installation path: ${install_path}"
}

#!/usr/bin/env bash
# BASH3 Boilerplate
#
#  bootstrap.sh
#
#  - Exports bash3boilerplate features and variables to the invoking script
#  - Invokes functions containing commands extracted from the bash3boilerplate
#    main.sh as part of a refactoring to facilitate wholesale reuse of main.sh's
#    contents of without modification.
#
# Usage (as invoked in my-script.sh):
#
#   source bootstrap.sh "${@}"
#
# More info:
#
#  - https://github.com/kvz/bash3boilerplate
#  - http://kvz.io/blog/2013/02/26/introducing-bash3boilerplate/
#
# Version: 2.1.0
#
# Authors:
#
#  - Kevin van Zonneveld (http://kvz.io)
#  - Izaak Beekman (https://izaakbeekman.com/)
#  - Alexander Rathai (Alexander.Rathai@gmail.com)
#  - Dr. Damian Rouson (http://www.sourceryinstitute.org/) (documentation)
#
# Licensed under MIT
# Copyright (c) 2013 Kevin van Zonneveld (http://kvz.io)

# shellcheck source=./set_environment_and_color.sh
source "${B3B_USE_CASE}"/set_environment_and_color.sh         # turn on errexit, nounset, pipefail, default log level
# shellcheck source=./set_magic_variables.sh
source "${B3B_USE_CASE}"/set_magic_variables.sh "$(caller 0)" # set __dir, __file, __filename, __base, __os
# shellcheck source=./define_functions.sh
source "${B3B_USE_CASE}"/define_functions.sh                  # help/usage function and debug/info output functions
# shellcheck source=./parse_command_line.sh
source "${B3B_USE_CASE}"/parse_command_line.sh "${@:-}"       # parse the command line
# shellcheck source=./set_common_switches.sh
source "${B3B_USE_CASE}"/set_common_switches.sh               # provide defaults for -h, -V, and -d

# BASH3 Boilerplate
#
#  define_functions.sh
#
#  - Defines helper functions containing commands extracted from the
#    bash3boilerplate main.sh as part of a refactoring to facilitate
#    wholesale reuse of main.sh's contents of without modification.
#
# Usage (as invoked in bootstrap.sh):
#
#   source define_functions.sh
#
# More info:
#
#  - https://github.com/kvz/bash3boilerplate
#  - http://kvz.io/blog/2013/02/26/introducing-bash3boilerplate/
#
# Version: 2.0.0
#
# Authors:
#
#  - Kevin van Zonneveld (http://kvz.io)
#  - Izaak Beekman (https://izaakbeekman.com/)
#  - Alexander Rathai (Alexander.Rathai@gmail.com)
#  - Dr. Damian Rouson (http://www.sourceryinstitute.org/) (documentation)
#
#
# Licensed under MIT
# Copyright (c) 2013 Kevin van Zonneveld (http://kvz.io)

### Functions
#####################################################################

# shellcheck disable=SC2034
function _fmt ()      {
  local color_debug="\x1b[35m"
  local color_info="\x1b[32m"
  local color_notice="\x1b[34m"
  local color_warning="\x1b[33m"
  local color_error="\x1b[31m"
  local color_critical="\x1b[1;31m"
  local color_alert="\x1b[1;33;41m"
  local color_emergency="\x1b[1;4;5;33;41m"
  local colorvar=color_$1

  local color="${!colorvar:-$color_error}"
  local color_reset="\x1b[0m"
  if [ "${NO_COLOR}" = "true" ] || [[ "${TERM:-}" != "xterm"* ]] || [ -t 1 ]; then
    # Don't use colors on pipes or non-recognized terminals
    color=""; color_reset=""
  fi
  echo -e "$(date -u +"%Y-%m-%d %H:%M:%S UTC") ${color}$(printf "[%9s]" "${1}")${color_reset}";
}

# The block of single-line functions below all print to STDERR,
# leaving STDOUT for piping machine readable information to other
# software. Above each such function is a commented demonstration
# of its usage.  Execution continues after an invocation of each
# function, except the "emergency" function, which causes
# termination with a non-zero exit status.

# shellcheck disable=SC2015
{
# emergency "A \"panic\" condition usually affecting multiple apps/servers/sites. At this level it would usually notify all tech staff on call."
function emergency () {                             echo "$(_fmt emergency) ${*}" 1>&2 || true; exit 1; }
# alert "Should be corrected immediately, therefore notify staff who can fix the problem. An example would be the loss of a primary ISP connection."
function alert ()     { [ "${LOG_LEVEL}" -ge 1 ] && echo "$(_fmt alert) ${*}" 1>&2 || true; }
# critical "Should be corrected immediately, but indicates failure in a primary system, an example is a loss of a backup ISP connection."
function critical ()  { [ "${LOG_LEVEL}" -ge 2 ] && echo "$(_fmt critical) ${*}" 1>&2 || true; }
# error "Non-urgent failures, these should be relayed to developers or admins; each item must be resolved within a given time."
function error ()     { [ "${LOG_LEVEL}" -ge 3 ] && echo "$(_fmt error) ${*}" 1>&2 || true; }
# warning "Warning messages, not an error, but indication that an error will occur if action is not taken, e.g. file system 85% full - each item must be resolved within a given time. This is a debug message"
function warning ()   { [ "${LOG_LEVEL}" -ge 4 ] && echo "$(_fmt warning) ${*}" 1>&2 || true; }
# notice "Events that are unusual but not error conditions - might be summarized in an email to developers or admins to spot potential problems - no immediate action required."
function notice ()    { [ "${LOG_LEVEL}" -ge 5 ] && echo "$(_fmt notice) ${*}" 1>&2 || true; }
# info "Normal operational messages - may be harvested for reporting, measuring throughput, etc. - no action required."
function info ()      { [ "${LOG_LEVEL}" -ge 6 ] && echo "$(_fmt info) ${*}" 1>&2 || true; }
# debug "Info useful to developers for debugging the application, not useful during operations."
function debug ()     { [ "${LOG_LEVEL}" -ge 7 ] && echo "$(_fmt debug) ${*}" 1>&2 || true; }
}
function suppress_debug_messages() { export LOG_LEVEL=6; }
function suppress_info_debug_messages () { export LOG_LEVEL=5; }
function suppress_notice_info_debug_messages () { export LOG_LEVEL=4; }

function help () {
  echo "" 1>&2
  echo " ${*}" 1>&2
  echo "" 1>&2
  # shellcheck disable=SC2154
  cat "${__usage}" 1>&2
  echo "" 1>&2
  exit 1
}
export -f help
export -f emergency
export -f alert
export -f critical
export -f error
export -f warning
export -f notice
export -f info
export -f debug
export suppress_debug_messages
export suppress_info_debug_messages
export suppress_notice_info_debug_messages

#!/usr/bin/env bash
# BASH3 Boilerplate
#
# build.sh
#
#  - Build OpenCoarrays prerequisite packages and their prerequisites
#
# Usage: LOG_LEVEL=7 B3B_USE_CASE=/opt/bash3boilerplate/src/use-case ./my-script.sh -f script_input.txt
#
# More info:
#
#  - https://github.com/kvz/bash3boilerplate
#  - http://kvz.io/blog/2013/02/26/introducing-bash3boilerplate/
#
# Version: 2.0.0
#
# Authors:
#
#  - Kevin van Zonneveld (http://kvz.io)
#  - Izaak Beekman (https://izaakbeekman.com/)
#  - Alexander Rathai (Alexander.Rathai@gmail.com)
#  - Dr. Damian Rouson (http://www.sourceryinstitute.org/) (documentation)
#
# Licensed under MIT
# Copyright (c) 2013 Kevin van Zonneveld (http://kvz.io)

# The invocation of bootstrap.sh below performs the following tasks:
# (1) Import several bash3boilerplate helper functions & default settings.
# (2) Set several variables describing the current file and its usage page.
# (3) Parse the usage information (default usage file name: current file's name with -usage appended).
# (4) Parse the command line using the usage information.

export OPENCOARRAYS_SRC_DIR="${OPENCOARRAYS_SRC_DIR:-${PWD%prerequisites*}}"
export __usage=${OPENCOARRAYS_SRC_DIR}/prerequisites/build.sh-usage
if [[ ! -f "${OPENCOARRAYS_SRC_DIR}/src/runtime-libraries/mpi/mpi_caf.c" ]]; then
  echo "Please run this script inside the OpenCoarrays source \"prerequisites\" subdirectory"
  echo "or set OPENCOARRAYS_SRC_DIR to the top-level OpenCoarrays source directory path."
  exit 1
fi
export B3B_USE_CASE="${B3B_USE_CASE:-${OPENCOARRAYS_SRC_DIR}/prerequisites/use-case}"
if [[ ! -f "${B3B_USE_CASE:-}/bootstrap.sh" ]]; then
  echo "Please set B3B_USE_CASE to the bash3boilerplate use-case directory path."
  exit 2
fi
# shellcheck source=./use-case/bootstrap.sh
source "${B3B_USE_CASE}/bootstrap.sh" "$@"

# Set up a function to call when receiving an EXIT signal to do some cleanup. Remove if
# not needed. Other signals can be trapped too, like SIGINT and SIGTERM.
function cleanup_before_exit () {
  info "Cleaning up. Done"
}
trap cleanup_before_exit EXIT # The signal is specified here. Could be SIGINT, SIGTERM etc.

### Validation (decide what's required for running your script and error out)
#####################################################################

export __flag_present=1

# shellcheck disable=SC2154
if [[ "${arg_l}" != "${__flag_present}" &&
      "${arg_v}" != "${__flag_present}" &&
      "${arg_h}" != "${__flag_present}" &&
      -z "${arg_D:-${arg_p:-${arg_P:-${arg_U:-${arg_V}}}}}" ]]; then
  help "${__base}: Insufficient arguments. Please pass either -B, -D, -h, -l, -L, -p, -P, -U, -v, -V, or a longer equivalent."
fi

# Suppress info and debug messages if -B, -l, -P, -U, -V, -D, or their longer equivalent is present:
 [[ "${arg_l}" == "${__flag_present}" || ! -z "${arg_P:-${arg_U:-${arg_V:-${arg_D}}}}" ]] && suppress_info_debug_messages

[ -z "${LOG_LEVEL:-}" ] && emergency "Cannot continue without LOG_LEVEL. "

### Enforce mutual exclusivity of arguments that print single-line output
[ ! -z "${arg_P:-}" ] && [ ! -z "${arg_V:-}" ] && emergency "Only specify one of -P, -U, -V, or their long-form equivalents."
[ ! -z "${arg_P:-}" ] && [ ! -z "${arg_U:-}" ] && emergency "Only specify one of -P, -U, -V, or their long-form equivalents."
[ ! -z "${arg_U:-}" ] && [ ! -z "${arg_V:-}" ] && emergency "Only specify one of -P, -U, -V, or their long-form equivalents."

### Print bootstrapped magic variables to STDERR when LOG_LEVEL
### is at the default value (6) or above.
#####################################################################
# shellcheck disable=SC2154
{
info "__file: ${__file}"
info "__dir: ${__dir}"
info "__base: ${__base}"
info "__os: ${__os}"
info "__usage: ${__usage}"
info "LOG_LEVEL: ${LOG_LEVEL}"

info "-b (--install-branch):   ${arg_b} "
info "-c (--with-c):           ${arg_c} "
info "-C (--with-cxx):         ${arg_C} "
info "-d (--debug):            ${arg_d} "
info "-D (--print-downloader): ${arg_D} "
info "-e (--verbose):          ${arg_e} "
info "-f (--with-fortran):     ${arg_f} "
info "-h (--help):             ${arg_h} "
info "-i (--install-prefix):   ${arg_i} "
info "-I (--install-version):  ${arg_I} "
info "-j (--num-threads):      ${arg_j} "
info "-l (--list-packages):    ${arg_l} "
info "-m (--with-cmake):       ${arg_m} "
info "-M (--with-mpi):         ${arg_M} "
info "-n (--no-color):         ${arg_n} "
info "-o (--only-download):    ${arg_o} "
info "-p (--package):          ${arg_p} "
info "-P (--print-path):       ${arg_P} "
info "-r (--prefix-root):      ${arg_r} "
info "-u (--from-url):         ${arg_u} "
info "-U (--print-url):        ${arg_U} "
info "-v (--version):          ${arg_v} "
info "-V (--print-version):    ${arg_V} "
info "-y (--yes-to-all):       ${arg_y} "
info "-Z (--bootstrap):        ${arg_Z} "
}

# shellcheck source=./build-functions/set_or_print_default_version.sh
source "${OPENCOARRAYS_SRC_DIR:-}/prerequisites/build-functions/set_or_print_default_version.sh"
# shellcheck disable=SC2119
set_or_print_default_version
export version_to_build="${arg_I:-${arg_b:-${default_version}}}"

# shellcheck source=./build-functions/set_or_print_downloader.sh
source "${OPENCOARRAYS_SRC_DIR:-}/prerequisites/build-functions/set_or_print_downloader.sh"
# shellcheck disable=SC2119
set_or_print_downloader $@

# shellcheck source=./build-functions/set_or_print_url.sh
source "${OPENCOARRAYS_SRC_DIR:-}/prerequisites/build-functions/set_or_print_url.sh"
set_or_print_url

# shellcheck source=./build-functions/set_or_print_installation_path.sh
source "${OPENCOARRAYS_SRC_DIR:-}/prerequisites/build-functions/set_or_print_installation_path.sh"

set_or_print_installation_path

# shellcheck source=./build-functions/download_if_necessary.sh
source "${OPENCOARRAYS_SRC_DIR:-}/prerequisites/build-functions/download_if_necessary.sh"
download_if_necessary

# Exit if -o or --only-download was specified when invoking this script
if [[ ${arg_o:-} == "${__flag_present}" ]]; then
   info "No installation to perform: -o or --only-download specified.  Exiting."
   exit 0
fi

# If -Z or --bootstrap was specified, enable bootstrap configure & build
if [[ ${arg_Z:-} != "${__flag_present}" ]]; then
   info "Disabling bootstrap. If the gcc/g++/gfortran build fails, try './install.sh --bootstrap'."
   export bootstrap_configure="--disable-bootstrap"
   export bootstrap_build=""
else
   export bootstrap_configure=""
   export bootstrap_build="bootstrap"
fi

# shellcheck source=./build-functions/unpack_if_necessary.sh
source "${OPENCOARRAYS_SRC_DIR:-}/prerequisites/build-functions/unpack_if_necessary.sh"
unpack_if_necessary

# shellcheck source=./build-functions/set_compilers.sh
source "${OPENCOARRAYS_SRC_DIR:-}/prerequisites/build-functions/set_compilers.sh"
set_compilers

# shellcheck source=./build-functions/build_and_install.sh
source "${OPENCOARRAYS_SRC_DIR:-}/prerequisites/build-functions/build_and_install.sh"
build_and_install

# shellcheck shell=bash disable=SC2148
# shellcheck source=./ftp_url.sh
source "${OPENCOARRAYS_SRC_DIR}/prerequisites/build-functions/ftp_url.sh"
# shellcheck source=./set_SUDO_if_needed_to_write_to_directory.sh
source "${OPENCOARRAYS_SRC_DIR}/prerequisites/build-functions/set_SUDO_if_needed_to_write_to_directory.sh"

# Download package if the tar ball is not already in the present working directory
# shellcheck disable=SC2154
download_if_necessary()
{
  download_path="${OPENCOARRAYS_SRC_DIR}/prerequisites/downloads"
  set_SUDO_if_needed_to_write_to_directory "${download_path}"

  # We set args regardless of whether this function performs a download because
  # GCC builds will need this to modify GCC's contrib/download_prerequisites script

  case "${fetch}" in
    "wget" )
      args=("--no-check-certificate")
      ;;
    "ftp_url" )
      args=("-n")
      ;;
    "git" )
      args=("clone" "-b" "${arg_b}")
      ;;
    "curl" )
      first_three_characters=$(echo "${package_url}" | cut -c1-3)
      case "${first_three_characters}" in
        "ftp"  )
           args=("-LO" "-u" "anonymous: ")
        ;;
        "htt"  )
           args=("-LO")
        ;;
        *)
          emergency "download_if_necessary.sh: Unrecognized URL."
        ;;
      esac
      ;;
    *)
      emergency "download_if_necessary.sh: Unrecognized \${fetch}=${fetch}."
      ;;
  esac

  case "${gcc_prereqs_fetch}" in
    "wget" )
      gcc_prereqs_fetch_args=("--no-check-certificate")
      ;;
    "ftp_url" )
      gcc_prereqs_fetch_args=("-n")
      ;;
    "curl" )
      gcc_prereqs_fetch_args=("-LO" "-u" "anonymous: ")
      ;;
    *)
      emergency "download_if_necessary.sh: Unrecognized \${gcc_prereqs_fetch}=${gcc_prereqs_fetch}."
      ;;
   esac

  if  [[ -f "${download_path}/${url_tail}" || -d "${download_path}/${url_tail}" ]]; then
    info "Found '${url_tail##*branches/}' in ${download_path}."
    info "If it resulted from an incomplete download, building ${package_name} could fail."
    if [[ "${arg_y}" == "${__flag_present}" ]]; then
      info "-y or --yes-to-all flag present. Proceeding with non-interactive build."
    else
      info "Would you like to proceed anyway? (Y/n)"
      read -r proceed
      if [[ "${proceed}" == "n" || "${proceed}" == "N" || "${proceed}" == "no"  ]]; then
        info "n"
        info "Please remove ${url_tail##*branches/} and restart the installation to to ensure a fresh download." 1>&2
        emergency "Aborting. [exit 80]"
      else
        info "y"
      fi
    fi
  elif ! type "${fetch}" &> /dev/null; then
    # The download mechanism is missing
    info "The default download mechanism for ${package_name} is ${fetch}."
    info "Please either ensure that ${fetch} is installed and in your PATH"
    info "or download the ${package_name} source from "
    info "${package_url}"
    info "Place the downloaded file in ${download_path} and restart this script."
    emergency "Aborting [exit 90]"
  else

    if [[ "${fetch}" == "git" ]]; then
      package_source_directory="${package_name}"
    else
      package_source_directory="${package_name}-${version_to_build}"
    fi
    info "Downloading ${package_name} ${version_to_build-} to the following location:"
    info "${download_path}/${package_source_directory}"
    info "Download command: \"${fetch}\" ${args[@]:-} ${package_url}"
    info "Depending on the file size and network bandwidth, this could take several minutes or longer."
    pushd "${download_path}"
    "${fetch}" ${args[@]:-} "${package_url}"
    popd
    if [[ "${fetch}" == "git" ]]; then
      search_path="${download_path}/${package_name}"
    else
      search_path="${download_path}/${url_tail}"
    fi
    if [[ -f "${search_path}" || -d "${search_path}" ]]; then
      info "Download succeeded. The ${package_name} source is in the following location:"
      info "${search_path}"
    else
      info "Download failed. The ${package_name} source is not in the following, expected location:"
      info "${search_path}"
      emergency "Aborting. [exit 110]"
    fi
  fi
}

function download_all_prerequisites() 
{
  pushd ${OPENCOARRAYS_SRC_DIR}

  download_list=( "m4" "bison" "flex" "mpich" "cmake" )

  for package_to_download in "${download_list[@]}" ;
  do
    ./install.sh --package ${package_to_download} --only-download
  done
  
  if [[ ! -z ${arg_b:-}  ]]; then
    ./install.sh --package gcc  --only-download --install-branch "${arg_b}"
    cd prerequisites/downloads/${arg_b:-}
  else  # Download default version
    ./install.sh --package gcc  --only-download
    gcc_version=$(./install.sh -V gcc)
    cd prerequisites/downloads/
    tar xf gcc-${gcc_version}.tar.[bg]z* || emergency "tar didn't work"
    listing=$(ls -lt)
    cd gcc-${gcc_version}
  fi

  source ${OPENCOARRAYS_SRC_DIR}/prerequisites/build-functions/set_or_print_downloader.sh
  set_or_print_downloader
  
  source ${OPENCOARRAYS_SRC_DIR}/prerequisites/build-functions/edit_GCC_download_prereqs_file_if_necessary.sh
  edit_GCC_download_prereqs_file_if_necessary
  
  ./contrib/download_prerequisites
  
  popd
}

# shellcheck disable=SC2154,SC2034
find_or_install()
{
  package="$1"
  # This is a bash 3 hack standing in for a bash 4 hash (bash 3 is the lowest common
  # denominator because, for licensing reasons, OS X only has bash 3 by default.)
  # See http://stackoverflow.com/questions/1494178/how-to-define-hash-tables-in-bash
  package_executable_array=(
    "gcc:gfortran"
    "cmake:cmake"
    "mpich:mpif90"
    "flex:flex"
    "bison:yacc"
    "m4:m4"
    "_unknown:0"
  )
  for element in "${package_executable_array[@]}" ; do
     KEY="${element%%:*}"
     VALUE="${element##*:}"
     if [[ "$KEY" == "_unknown" ]]; then
       # No recognizeable argument passed so print usage information and exit:
       printf "%s: Package name (%s) not recognized in find_or_install function [exit 40].\n" "$this_script" "$package"
       exit 40
     elif [[ $package == "$KEY" ]]; then
       executable=$VALUE
       break
     fi
  done

  if [[ "$package" == "$executable" ]]; then
    printf "$this_script: Checking whether $executable is in the PATH..."
  else
    printf "$this_script: Checking whether $package executable $executable is in the PATH..."
  fi
  if type "$executable" >& /dev/null; then
    printf "yes.\n"
    package_in_path=true
    package_version_in_path=$("$executable" --version|head -1)
  else
    printf "no.\n"
    package_in_path=false
  fi

  package_install_path=$(./build.sh -P "$package")

  printf "Checking whether $executable is in $package_install_path..."
  if [[ -x "$package_install_path/bin/$executable" ]]; then
    printf "yes.\n"
    script_installed_package=true
    stack_push script_installed "$package" "$executable"
  else
    script_installed_package=false
    printf "no.\n"
  fi

  minimum_version=$(./build.sh -V "$package")

  if [[ "$package" == "cmake" ]]; then

    # We arrive here only by the explicit, direct call 'find_or_install cmake' inside
    # the build_opencoarrays function. Because there is no possibility of arriving here
    # by recursion (no packages depend on cmake except OpenCoarrays, which gets built
    # after all dependencies have been found or installed), cmake must add itself to
    # the dependency stack if no acceptable cmake is found.

    # Every branch that discovers an acceptable pre-existing installation must set the
    # CMAKE environment variable. Every branch must also manage the dependency stack.

    if [[ "$script_installed_package" == true ]]; then
      echo -e "$this_script: Using the $package installed by $this_script\n"
      export CMAKE=$package_install_path/bin/$executable
      stack_push dependency_pkg "none"
      stack_push dependency_exe "none"
      stack_push dependency_path "none"

    elif [[ "$package_in_path" == "true" ]]; then
      echo -e "$this_script: Checking whether $package in PATH is version < $minimum_version... "

      if ! ./check_version.sh "$package" "$(./build.sh -V "$package")"; then
        printf "yes.\n"
        # Here we place $package on the dependency stack to trigger the build of the above file:
        stack_push dependency_pkg "$package" "none"
        stack_push dependency_exe "$package" "none"
        stack_push dependency_path "$(./build.sh -P cmake)" "none"

      else
        printf "no.\n"
        echo -e "$this_script: Using the $executable found in the PATH.\n"
        export CMAKE=$executable
        # Prevent recursion
        stack_push dependency_pkg "none"
        stack_push dependency_exe "none"
        stack_push dependency_path "none"
      fi

    else # Build package ($package has no prerequisites)
      stack_push dependency_pkg "$package" "none"
      stack_push dependency_exe "$package" "none"
      stack_push dependency_path "$(./build.sh -P "$package")" "none"
    fi

  elif [[ $package == "mpich" ]]; then

    # We arrive here only by the explicit, direct call 'find_or_install mpich' inside
    # the build_opencoarrays function. Because there is no possibility of arriving here
    # by recursion (no packages depend on mpich except OpenCoarrays, which gets built
    # after all dependencies have been found or installed), mpich must add itself to
    # the dependency stack if no acceptable mpich is found.

    # Every branch that discovers an acceptable pre-existing installation must set the
    # MPIFC, MPICC, and MPICXX environment variables. Every branch must also manage the
    # dependency stack.
   
    # If the user specified a Fortran compiler, verify that mpif90 wraps the specified compiler
    if [[ ! -z "${arg_M:-}" ]]; then

      echo -e "$this_script: Using the $package specified by -M or --with-mpi: ${arg_M}\n"
      export MPIFC="${arg_M}"/bin/mpif90
      export MPICC="${arg_M}"/bin/mpicc
      export MPICXX="${arg_M}"/bin/mpicxx
      # Halt the recursion
      stack_push dependency_pkg "none"
      stack_push dependency_exe "none"
      stack_push dependency_path "none"

      if [[ ! -z "${arg_f:-}" ]]; then
        # -f or --with-fortran argument specifies a compiler, which we use if mpif90
        # invokes the specified compiler.  Otherwise, we halt and print an error message.
        MPIFC_wraps=$(${MPIFC} --version)
        compiler=$(${arg_f} --version)
        if [[ "${MPIFC_wraps}" != "${compiler}"   ]]; then
          emergency "Specified MPI ${MPIFC_wraps} wraps a compiler other than the specified Fortran compiler ${compiler}"
        fi
      fi

    elif [[ "$script_installed_package" == true ]]; then

      echo -e "$this_script: Using the $package installed by $this_script\n"
      export MPIFC=$package_install_path/bin/mpif90
      export MPICC=$package_install_path/bin/mpicc
      export MPICXX=$package_install_path/bin/mpicxx
      # Halt the recursion
      stack_push dependency_pkg "none"
      stack_push dependency_exe "none"
      stack_push dependency_path "none"

    elif [[ "$package_in_path" == "true" ]]; then

      echo -e "$this_script: Checking whether $executable in PATH wraps gfortran... "
      mpif90_version_header=$(mpif90 --version | head -1)
      first_three_characters=$(echo "$mpif90_version_header" | cut -c1-3)
      if [[ "$first_three_characters" != "GNU" ]]; then
        printf "no.\n"
        # Trigger 'find_or_install gcc' and subsequent build of $package
        stack_push dependency_pkg "none" "$package" "gcc"
        stack_push dependency_exe "none" "$executable" "gfortran"
        stack_push dependency_path "none" "$(./build.sh -P "$package")" "$(./build.sh -P gcc)"
      else
        printf "yes.\n"

        if [[ ! -z "${arg_f:-}" ]]; then
          
          info "-f (or --with-fortran) argument detected with value ${arg_f}"
          printf "yes.\n $this_script: Using the specified $executable.\n"
          export MPIFC=mpif90
          export MPICC=mpicc
          export MPICXX=mpicxx
  
          # Halt the recursion
          stack_push dependency_pkg "none"
          stack_push dependency_exe "none"
          stack_push dependency_path "none"

        else

          echo -e "$this_script: Checking whether $executable in PATH wraps gfortran version `./build.sh -V gcc` or later... "
          $executable acceptable_compiler.f90 -o acceptable_compiler
          $executable print_true.f90 -o print_true
          acceptable=$(./acceptable_compiler)
          is_true=$(./print_true)
          rm acceptable_compiler print_true
         
          if [[ "$acceptable" == "$is_true" ]]; then
            printf "yes.\n $this_script: Using the $executable found in the PATH.\n"
            export MPIFC=mpif90
            export MPICC=mpicc
            export MPICXX=mpicxx
  
            # Halt the recursion
            stack_push dependency_pkg "none"
            stack_push dependency_exe "none"
            stack_push dependency_path "none"
          else
            printf "no\n"
            # Trigger 'find_or_install gcc' and subsequent build of $package
            stack_push dependency_pkg "none" "$package" "gcc"
            stack_push dependency_exe "none" "$executable" "gfortran"
            stack_push dependency_path "none" "$(./build.sh -P "$package")" "$(./build.sh -P gcc)"
          fi
        fi
      fi

    else # $package not in PATH and not yet installed by this script
      # Trigger 'find_or_install gcc' and subsequent build of $package
      stack_push dependency_pkg  "none" "$package" "gcc"
      stack_push dependency_exe  "none" "$executable" "gfortran"
      stack_push dependency_path "none" "$(./build.sh -P "$package")" "$(./build.sh -P gcc)"
    fi

  elif [[ $package == "gcc" ]]; then

    # We arrive here when the 'elif [[ $package == "mpich" ]]' block pushes "gcc" onto the
    # the dependency_pkg stack, resulting in the recursive call 'find_or_install gcc'

    # Every branch that discovers an acceptable pre-existing installation must set the
    # FC, CC, and CXX environment variables. Every branch must also manage the dependency stack.

    if [[ ! -z "${arg_f:-}" ]]; then

      info "-f (or --with-fortran) argument detected with value ${arg_f}"
      [ -z "${arg_c:-}" ] && emergency "-f (--with-fortran) specifies Fortran compiler; Please also specify C/C++ compilers"
      [ -z "${arg_C:-}" ] && emergency "-f (--with-fortran) specifies Fortran compiler; Please also specify C/C++ compilers"

      export FC="${arg_f}"
      export CC="${arg_c}"
      export CXX="${arg_C}"

      # Remove $package from the dependency stack
      stack_pop dependency_pkg package_done
      stack_pop dependency_exe executable_done
      stack_pop dependency_path package_done_path
      # Halt the recursion and signal that none of $package's prerequisites need to be built
      stack_push dependency_pkg "none"
      stack_push dependency_exe "none"
      stack_push dependency_path "none"

    elif [[ "$script_installed_package" == true ]]; then
      echo -e "$this_script: Using the $package executable $executable installed by $this_script\n"
      export FC=$package_install_path/bin/gfortran
      export CC=$package_install_path/bin/gcc
      export CXX=$package_install_path/bin/g++
      gfortran_lib_paths="$package_install_path/lib64/:$package_install_path/lib"
      if [[ -z "${LD_LIBRARY_PATH:-}" ]]; then
        echo "$this_script: export LD_LIBRARY_PATH=\"$gfortran_lib_paths\""
                            export LD_LIBRARY_PATH="$gfortran_lib_paths"
      else
        echo "$this_script: export LD_LIBRARY_PATH=\"$gfortran_lib_paths:$LD_LIBRARY_PATH\""
                            export LD_LIBRARY_PATH="$gfortran_lib_paths:$LD_LIBRARY_PATH"
      fi
      # Remove $package from the dependency stack
      stack_pop dependency_pkg package_done
      stack_pop dependency_exe executable_done
      stack_pop dependency_path package_done_path
      # Put $package onto the script_installed log
      stack_push script_installed package_done
      stack_push script_installed executable_done
      stack_push script_installed package_done_path
      # Halt the recursion and signal that none of $package's prerequisites need to be built
      stack_push dependency_pkg "none"
      stack_push dependency_exe "none"
      stack_push dependency_path "none"

    elif [[ "$package_in_path" == "true" ]]; then
      echo -e "$this_script: Checking whether $executable in PATH is version `./build.sh -V gcc` or later..."
      $executable -o acceptable_compiler acceptable_compiler.f90
      $executable -o print_true print_true.f90
      is_true=$(./print_true)
      acceptable=$(./acceptable_compiler)
      rm acceptable_compiler print_true
      if [[ "$acceptable" == "$is_true" ]]; then
        printf "yes.\n"
        echo -e "$this_script: Using the $executable found in the PATH.\n"
        export FC=gfortran
        export CC=gcc
        export CXX=g++
        # Remove $package from the dependency stack
        stack_pop dependency_pkg package_done
        stack_pop dependency_exe executable_done
        stack_pop dependency_path package_done_path
        # Put $package onto the script_installed log
        stack_push script_installed package_done
        stack_push script_installed executable_done
        stack_push script_installed package_done_path
        # Halt the recursion and signal that none of $package's prerequisites need to be built
        stack_push dependency_pkg "none"
        stack_push dependency_exe "none"
        stack_push dependency_path "none"
      else
        printf "no.\n"
        # Trigger 'find_or_install flex' and subsequent build of $package
        stack_push dependency_pkg "flex"
        stack_push dependency_exe "flex"
        stack_push dependency_path "$(./build.sh -P flex)"
      fi

    else # $package is not in PATH and not yet installed by this script
      # Trigger 'find_or_install flex' and subsequent build of $package
      stack_push dependency_pkg "flex"
      stack_push dependency_exe "flex"
      stack_push dependency_path "$(./build.sh -P flex)"
    fi

  elif [[ $package == "flex" ]]; then

    # We arrive here only if the 'elif [[ $package == "gcc" ]]' block has pushed "flex"
    # onto the dependency_pkg stack, resulting in the recursive call 'find_or_install flex'.
    # flex therefore does not need to add itself to the stack.

    # Every branch that discovers an acceptable pre-existing installation must set the
    # FLEX environment variable. Every branch must also manage the dependency stack.

    if [[ "$script_installed_package" == true ]]; then
      echo -e "$this_script: Using the $executable installed by $this_script\n"
      export FLEX=$package_install_path/bin/$executable
      # Remove flex from the dependency stack
      stack_pop dependency_pkg package_done
      stack_pop dependency_exe executable_done
      stack_pop dependency_path package_done_path
      # Put $package onto the script_installed log
      stack_push script_installed package_done
      stack_push script_installed executable_done
      stack_push script_installed package_done_path
      # Halt the recursion and signal that no prerequisites need to be built
      stack_push dependency_pkg "none"
      stack_push dependency_exe "none"
      stack_push dependency_path "none"

    elif [[ "$package_in_path" == "true" ]]; then

      echo -e "$this_script: Checking whether $package in PATH is version < $minimum_version... "
      if ! ./check_version.sh "$package" "$(./build.sh -V "$package")"; then
        printf "yes\n"

        export FLEX="$package_install_path/bin/$executable"
        # Trigger 'find_or_install bison' and subsequent build of $package
        stack_push dependency_pkg "bison"
        stack_push dependency_exe "yacc"
        stack_push dependency_path "$(./build.sh -P bison)"
      else
        printf "no.\n"
        echo -e "$this_script: Using the $executable found in the PATH.\n"
        export FLEX=$executable
        # Remove $package from the dependency stack
        stack_pop dependency_pkg package_done
        stack_pop dependency_exe executable_done
        stack_pop dependency_path package_done_path
        # Put $package onto the script_installed log
        stack_push script_installed package_done
        stack_push script_installed executable_done
        stack_push script_installed package_done_path
        # Halt the recursion and signal that none of $package's prerequisites need to be built
        stack_push dependency_pkg "none"
        stack_push dependency_exe "none"
        stack_push dependency_path "none"
      fi

    else  # $package is not in the PATH and not yet installed by $this_script
      # Trigger 'find_or_install bison' and subsequent build of $package
      stack_push dependency_pkg "bison"
      stack_push dependency_exe "yacc"
      stack_push dependency_path "$(./build.sh -P bison)"
    fi

  elif [[ $package == "bison" ]]; then

    # We arrive when the 'elif [[ $package == "flex" ]]' block pushes "bison" onto the
    # the dependency_pkg stack, resulting in the recursive call 'find_or_install bison'

    # Every branch that discovers an acceptable pre-existing installation must set the
    # YACC environment variable. Every branch must also manage the dependency stack.

    if [[ "$script_installed_package" == true ]]; then
      echo -e "$this_script: Using the $package executable $executable installed by $this_script\n"
      export YACC=$package_install_path/bin/yacc
      # Remove bison from the dependency stack
      stack_pop dependency_pkg package_done
      stack_pop dependency_exe executable_done
      stack_pop dependency_path package_done_path
      # Put $package onto the script_installed log
      stack_push script_installed package_done
      stack_push script_installed executable_done
      stack_push script_installed package_done_path
      # Halt the recursion and signal that there are no prerequisites to build
      stack_push dependency_pkg "none"
      stack_push dependency_exe "none"
      stack_push dependency_path "none"

    elif [[ "$package_in_path" == "true" ]]; then
      echo -e "$this_script: Checking whether $package executable $executable in PATH is version < $minimum_version... "
      if ! ./check_version.sh "$package" "$(./build.sh -V "$package")"; then
        printf "yes.\n"
        export YACC="$package_install_path/bin/$executable"
        # Trigger 'find_or_install m4' and subsequent build of $package
        stack_push dependency_pkg "m4"
        stack_push dependency_exe "m4"
        stack_push dependency_path "$(./build.sh -P m4)"
      else
        printf "no.\n"
        echo -e "$this_script: Using the $package executable $executable found in the PATH.\n"
        YACC=yacc
        # Remove bison from the dependency stack
        stack_pop dependency_pkg package_done
        stack_pop dependency_exe executable_done
        stack_pop dependency_path package_done_path
        # Put $package onto the script_installed log
        stack_push script_installed package_done
        stack_push script_installed executable_done
        stack_push script_installed package_done_path
        # Halt the recursion and signal that there are no prerequisites to build
        stack_push dependency_pkg "none"
        stack_push dependency_exe "none"
        stack_push dependency_path "none"
      fi

    else # $package not in PATH and not yet installed by this script
      # Trigger 'find_or_install m4' and subsequent build of $package
      stack_push dependency_pkg "m4"
      stack_push dependency_exe "m4"
      stack_push dependency_path "$(./build.sh -P m4)"
    fi

  elif [[ $package == "m4" ]]; then

    # We arrive when the 'elif [[ $package == "bison" ]]' block pushes "m4" onto the
    # the dependency_pkg stack, resulting in the recursive call 'find_or_install m4'

    # Every branch that discovers an acceptable pre-existing installation must set the
    # M4 environment variable. Every branch must also manage the dependency stack.

    if [[ "$script_installed_package" == true ]]; then
      echo -e "$this_script: Using the $package executable $executable installed by $this_script\n"
      export M4=$package_install_path/bin/m4
      # Remove m4 from the dependency stack
      stack_pop dependency_pkg package_done
      stack_pop dependency_exe executable_done
      stack_pop dependency_path package_done_path
      # Put $package onto the script_installed log
      stack_push script_installed package_done
      stack_push script_installed executable_done
      stack_push script_installed package_done_path
      # Halt the recursion and signal that there are no prerequisites to build
      stack_push dependency_pkg "none"
      stack_push dependency_exe "none"
      stack_push dependency_path "none"

    elif [[ "$package_in_path" == "true" ]]; then
      echo -e "$this_script: Checking whether $package executable $executable in PATH is version < $minimum_version... "
      if ! ./check_version.sh "$package" "$(./build.sh -V "$package")"; then
        printf "yes.\n"
        export M4="$package_install_path/bin/m4"
        # Halt the recursion and signal that there are no prerequisites to build
        stack_push dependency_pkg "none"
        stack_push dependency_exe "none"
        stack_push dependency_path "none"
      else
        printf "no.\n"
        echo -e "$this_script: Using the $package executable $executable found in the PATH.\n"
        M4=m4
        # Remove m4 from the dependency stack
        stack_pop dependency_pkg package_done
        stack_pop dependency_exe executable_done
        stack_pop dependency_path package_done_path
        # Put $package onto the script_installed log
        stack_push script_installed package_done
        stack_push script_installed executable_done
        stack_push script_installed package_done_path
        # Halt the recursion and signal that there are no prerequisites to build
        stack_push dependency_pkg "none"
        stack_push dependency_exe "none"
        stack_push dependency_path "none"
      fi

    else # $package not in PATH and not yet installed by this script
      # Halt the recursion and signal that there are no prerequisites to build
      export M4="$package_install_path/bin/m4"
      stack_push dependency_pkg  "none"
      stack_push dependency_exe  "none"
      stack_push dependency_path "none"
    fi

  else
    if [[ -z "${package:-}" ]]; then
      echo -e "$this_script: empty package name passed to find_or_install function. [exit 50]\n"
      exit 50
    else
      echo -e "$this_script: unknown package name ($package) passed to find_or_install function. [exit 55]\n"
      exit 55
    fi
  fi

  echo "$this_script: Updated dependency stack (top to bottom = left to right):"
  stack_print dependency_pkg

  stack_size dependency_pkg num_stacked
  (( num_dependencies=num_stacked-1 )) || true

  if [[ $num_dependencies -lt 0 ]]; then
    emergency "The procedure named in the external call to find_or_install is not on the dependency stack. [exit 60]\n"

  elif [[ $num_dependencies -gt 0 ]]; then
    stack_pop  dependency_pkg  prerequisite_pkg
    stack_pop  dependency_exe  prerequisite_exe
    stack_pop  dependency_path prerequisite_path

    if [[ $prerequisite_pkg != "none" ]]; then
      stack_push dependency_pkg  "$prerequisite_pkg"
      stack_push dependency_exe  "$prerequisite_exe"
      stack_push dependency_path "$prerequisite_path"
      echo -e "$this_script: Building $package from source requires $prerequisite_pkg.\n"
      find_or_install "$prerequisite_pkg"
    fi
  fi

  echo "$this_script: Remaining $package dependency stack (top to bottom = left to right):"
  stack_print dependency_pkg

  stack_pop dependency_pkg package
  stack_pop dependency_exe executable
  stack_pop dependency_path package_install_path

  if [[ $package != "none" ]]; then

    if [[ "$package" == "$executable" ]]; then
      echo "$this_script: Ready to install $executable in $package_install_path"
    else
      echo "$this_script: Ready to install $package executable $executable in $package_install_path"
    fi

    echo -e "$this_script: Ok to download (if necessary), build, and install $package from source? (Y/n) "
    read -r proceed_with_build

    if [[ "$proceed_with_build" == "n" || "$proceed_with_build" == "no" ]]; then
      printf "n\n"
      echo -e "$this_script: OpenCoarrays installation requires $package. Aborting. [exit 70]\n"
      exit 70

    else # permission granted to build
      printf "Y\n"

      # On OS X, CMake must be built with Apple LLVM gcc, which XCode command-line tools puts in /usr/bin
      if [[ $(uname) == "Darwin" && $package == "cmake"  ]]; then
        if [[ -x "/usr/bin/gcc" ]]; then
          CC=/usr/bin/gcc
        else
          echo -e "$this_script: OS X detected.  Please install XCode command-line tools and \n"
          echo -e "$this_script: ensure that /usr/bin/gcc exists and is executable. Aborting. [exit 75]\n"
          exit 75
        fi
      # Otherwise, if no CC has been defined yet, use the gcc in the user's PATH
      elif [[ -z "${CC:-}" ]]; then
        CC=gcc
      fi

      # On OS X, CMake must be built with Apple LLVM g++, which XCode command-line tools puts in /usr/bin
      if [[ $(uname) == "Darwin" && $package == "cmake"  ]]; then
        if [[ -x "/usr/bin/g++" ]]; then
          CXX=/usr/bin/g++
        else
          echo -e "$this_script: OS X detected.  Please install XCode command-line tools \n"
          echo -e "$this_script: and ensure that /usr/bin/g++ exists and is executable. Aborting. [exit 76]\n"
          exit 76
        fi
      # Otherwise, if no CXX has been defined yet, use the g++ in the user's PATH
      elif [[ -z "${CXX:-}" ]]; then
        CXX=g++
      fi

      # If no FC has been defined yet, use the gfortran in the user's PATH
      if [[ -z "${FC:-}" ]]; then
        FC=gfortran
      fi


      # Strip trailing package name and version number, if present, from installation path
      default_package_version=$(./build.sh -V ${package})
      package_install_prefix="${package_install_path%${package}/${arg_I:-${default_package_version}}*}" 

      echo -e "$this_script: Downloading, building, and installing $package \n"
      echo "$this_script: Build command: FC=$FC CC=$CC CXX=$CXX ./build.sh -p $package -i $package_install_prefix -j $num_threads"
      FC="$FC" CC="$CC" CXX="$CXX" ./build.sh -p "$package" -i "$package_install_prefix" -j "$num_threads"

      if [[ -x "$package_install_path/bin/$executable" ]]; then
        echo -e "$this_script: Installation successful.\n"
        if [[ "$package" == "$executable" ]]; then
          echo -e "$this_script: $executable is in $package_install_path/bin \n"
        else
          echo -e "$this_script: $package executable $executable is in $package_install_path/bin \n"
        fi
       # TODO Merge all applicable branches under one 'if [[ $package == $executable ]]; then'
        if [[ $package == "cmake" ]]; then
          echo "$this_script: export CMAKE=$package_install_path/bin/$executable"
                              export CMAKE="$package_install_path/bin/$executable"
        elif [[ $package == "bison" ]]; then
          echo "$this_script: export YACC=$package_install_path/bin/$executable"
                              export YACC="$package_install_path/bin/$executable"
        elif [[ $package == "flex" ]]; then
          echo "$this_script: export FLEX=$package_install_path/bin/$executable"
                              export FLEX="$package_install_path/bin/$executable"
        elif [[ $package == "m4" ]]; then
          echo "$this_script: export M4=$package_install_path/bin/$executable"
                              export M4="$package_install_path/bin/$executable"
        elif [[ $package == "gcc" ]]; then
          echo "$this_script: export FC=$package_install_path/bin/gfortran"
                              export FC="$package_install_path/bin/gfortran"
          echo "$this_script: export CC=$package_install_path/bin/gcc"
                              export CC="$package_install_path/bin/gcc"
          echo "$this_script: export CXX=$package_install_path/bin/g++"
                              export CXX="$package_install_path/bin/g++"
          gfortran_lib_paths="$package_install_path/lib64/:$package_install_path/lib"
          if [[ -z "${LD_LIBRARY_PATH:-}" ]]; then
            export LD_LIBRARY_PATH="$gfortran_lib_paths"
          else
            export LD_LIBRARY_PATH="$gfortran_lib_paths:$LD_LIBRARY_PATH"
          fi
        elif [[ $package == "mpich" ]]; then
          echo "$this_script: export MPIFC=$package_install_path/bin/mpif90"
                              export MPIFC="$package_install_path/bin/mpif90"
          echo "$this_script: export MPICC= $package_install_path/bin/mpicc"
                              export MPICC="$package_install_path/bin/mpicc"
          echo "$this_script: export MPICXX=$package_install_path/bin/mpicxx"
                              export MPICXX="$package_install_path/bin/mpicxx"
        else
          echo -e "$this_script: WARNING: $package executable $executable installed correctly but the \n"
          echo -e "$this_script:          corresponding environment variable(s) have not been set. This \n"
          echo -e "$this_script:          could prevent a complete build of OpenCoarrays. Please report this\n"
          echo -e "$this_script:          issue at https://github.com/sourceryinstitute/opencoarrays/issues\n"
        fi
        if [[ -z "${PATH:-}" ]]; then
          export PATH="$package_install_path/bin"
        else
          export PATH="$package_install_path/bin:$PATH"
        fi
      else
        echo -e "$this_script: Installation unsuccessful. "
        echo -e "$executable is not in the following expected path or the user lacks executable permission for it:\n"
        echo -e "$package_install_path/bin \n"
        printf "Aborting. [exit 80]"
        exit 80
      fi # End 'if [[ -x "$package_install_path/bin/$executable" ]]'

    fi # End 'if [[ "$proceed_with_build" == "y" ]]; then'

  fi # End 'if [[ "$package" != "none" ]]; then'
}

# shellcheck shell=bash disable=SC2154,SC2129,SC2148
report_results()
{
  fully_qualified_FC="$(type -P "${FC}")"
  compiler_install_root="${fully_qualified_FC%bin/${FC}}"

  fully_qualified_MPIFC="$(type -P "${MPIFC}")"
  mpi_install_root="${fully_qualified_MPIFC%bin/mpifort*}"

  fully_qualified_CMAKE="$(type -P "${CMAKE}")"
  cmake_install_path="${fully_qualified_CMAKE%/cmake*}"

  # Report installation success or failure and record locations for software stack:
  if [[ -x "${install_path%/}/bin/caf" && -x "${install_path%/}/bin/cafrun" ]]; then

    # Installation succeeded
    info "$this_script: Done."
    info ""
    info "*** The OpenCoarrays compiler wrapper (caf) and program  ***"
    info "*** launcher (cafrun) are in the following directory:    ***"
    info ""
    info "${install_path%/}/bin."
    info ""
    if [[ -f setup.sh ]]; then
      ${SUDO:-} rm setup.sh
    fi
    if [[ -f setup.csh ]]; then
      ${SUDO:-} rm setup.csh
    fi
    # Prepend the OpenCoarrays license to the setup.sh script:
    while IFS='' read -r line || [[ -n "${line}" ]]; do
        echo "# ${line}" >> setup.sh
    done < "${OPENCOARRAYS_SRC_DIR}/LICENSE"
    while IFS='' read -r line || [[ -n "${line}" ]]; do
        echo "# ${line}" >> setup.csh
    done < "${OPENCOARRAYS_SRC_DIR}/LICENSE"
    echo "#                                                                               " | tee -a setup.csh setup.sh
    echo "# Execute this script via the following command:                                " | tee -a setup.csh setup.sh
    echo "# source ${install_path%/}/setup.sh                                             " | tee -a setup.csh setup.sh
    echo "                                                                                " | tee -a setup.csh setup.sh
    if [[ -x "${cmake_install_path}/cmake" ]]; then
      echo "# Prepend the CMake path to the PATH environment variable:" | tee -a setup.sh setup.csh
      echo "if [[ -z \"\${PATH}\" ]]; then                                       " >> setup.sh
      echo "  export PATH=\"${cmake_install_path%/}\"                            " >> setup.sh
      echo "else                                                                 " >> setup.sh
      echo "  if ! [[ \"\${PATH}\" =~ \"${cmake_install_path}\" ]] ; then        " >> setup.sh
      echo "    export PATH=\"${cmake_install_path%/}\":\${PATH}                 " >> setup.sh
      echo "  fi                                                                 " >> setup.sh
      echo "fi                                                                   " >> setup.sh
      echo "set path = (\"${cmake_install_path%/}\" \$path)                      " >> setup.csh
    fi
    if [[ -x "${fully_qualified_FC}" ]]; then
      echo "# Prepend the compiler path to the PATH environment variable:" | tee -a setup.sh setup.csh
      echo "if [[ -z \"\${PATH}\" ]]; then                                                " >> setup.sh
      echo "  export PATH=\"${compiler_install_root%/}/bin\"                              " >> setup.sh
      echo "else                                                                          " >> setup.sh
      echo "  export PATH=\"${compiler_install_root%/}/bin:\${PATH}\"                     " >> setup.sh
      echo "fi                                                                            " >> setup.sh
      echo "set path = (\"${compiler_install_root%/}\"/bin \$path)                        " >> setup.csh
    fi
    LD_LIB_P_VAR=LD_LIBRARY_PATH
    if [[ "${OSTYPE:-}" =~ [Dd]arwin ]]; then
      LD_LIB_P_VAR=DYLD_LIBRARY_PATH
    fi
    if [[ -d "${compiler_install_root%/}/lib" || -d "${compiler_install_root%/}/lib64" ]]; then
      echo "# Prepend the compiler library paths to the ${LD_LIB_P_VAR} environment variable:" | tee -a setup.sh setup.csh
      compiler_lib_paths="${compiler_install_root%/}/lib64/:${compiler_install_root%/}/lib"
      echo "if [[ -z \"\${${LD_LIB_P_VAR}}\" ]]; then                                    " >> setup.sh
      echo "  export ${LD_LIB_P_VAR}=\"${compiler_lib_paths%/}\"                          " >> setup.sh
      echo "else                                                                          " >> setup.sh
      echo "  export ${LD_LIB_P_VAR}=\"${compiler_lib_paths%/}:\${${LD_LIB_P_VAR}}\"     " >> setup.sh
      echo "fi                                                                            " >> setup.sh
      echo "setenv LD_LIBRARY_PATH \"${compiler_lib_paths%/}:\${LD_LIBRARY_PATH}\"        " >> setup.csh
    fi
    echo "                                                                                " >> setup.sh
    if [[ -x "${mpi_install_root}/bin/mpifort" ]]; then
      echo "# Prepend the MPI path to the PATH environment variable:" | tee -a setup.sh setup.csh
      echo "if [[ -z \"\${PATH}\" ]]; then                                       " >> setup.sh
      echo "  export PATH=\"${mpi_install_root%/}/bin\"                          " >> setup.sh
      echo "else                                                                 " >> setup.sh
      echo "  export PATH=\"${mpi_install_root%/}/bin\":\${PATH}                 " >> setup.sh
      echo "fi                                                                   " >> setup.sh
      echo "set path = (\"${mpi_install_root%/}/bin\" \$path)                    " >> setup.csh
    fi
    # In all likelihood, the following paths are only needed if OpenCoarrays built them,
    # In by far the most common such use case, they would have been built in a recursive
    # build of all the OpenCoarrays dependency tree (rather than built indvidually via
    # ./install --package) so we only need check the default location in which OpenCoarrays
    # would install them.  If they are not there, then it is very likely the case that the
    # the system versions of these packages are present and in the user's path or that the
    # user doesn't need them at all (e.g. there was no need to build gfortran from source).
    flex_install_path=$("${build_script}" -P flex)
    if [[ -x "${flex_install_path}/bin/flex" ]]; then
      echo "# Prepend the flex path to the PATH environment variable:" | tee -a setup.sh setup.csh
      echo "if [[ -z \"\${PATH}\" ]]; then                                         " >> setup.sh
      echo "  export PATH=\"${flex_install_path}/bin\"                             " >> setup.sh
      echo "else                                                                 " >> setup.sh
      echo "  export PATH=\"${flex_install_path}/bin\":\${PATH}                      " >> setup.sh
      echo "set path = (\"$flex_install_path\"/bin \$path)                      " >> setup.csh
      echo "fi                                                                   " >> setup.sh
    fi
    bison_install_path=$("${build_script}" -P bison)
    if [[ -x "${bison_install_path}/bin/yacc" ]]; then
      echo "# Prepend the bison path to the PATH environment variable:" | tee -a setup.sh setup.csh
      echo "if [[ -z \"\${PATH}\" ]]; then                                         " >> setup.sh
      echo "  export PATH=\"${bison_install_path}/bin\"                            " >> setup.sh
      echo "else                                                                 " >> setup.sh
      echo "  export PATH=\"${bison_install_path}/bin\":\${PATH}                     " >> setup.sh
      echo "fi                                                                   " >> setup.sh
      echo "set path = (\"$bison_install_path\"/bin \$path)                      " >> setup.csh
    fi
    m4_install_path=$("${build_script}" -P m4)
    if [[ -x "${m4_install_path}/bin/m4" ]]; then
      echo "# Prepend the m4 path to the PATH environment variable:" | tee -a setup.sh setup.csh
      echo "if [[ -z \"\${PATH}\" ]]; then                                         " >> setup.sh
      echo "  export PATH=\"${m4_install_path}/bin\"                               " >> setup.sh
      echo "else                                                                 " >> setup.sh
      echo "  export PATH=\"${m4_install_path}/bin\":\${PATH}                        " >> setup.sh
      echo "fi                                                                   " >> setup.sh
      echo "set path = (\"$m4_install_path\"/bin \$path)                      " >> setup.csh
    fi
    opencoarrays_install_path="${install_path}"
    if [[ -x "${opencoarrays_install_path}/bin/caf" ]]; then
      echo "# Prepend the OpenCoarrays path to the PATH environment variable:" | tee -a setup.sh setup.csh
      echo "if [[ -z \"\${PATH}\" ]]; then                                         " >> setup.sh
      echo "  export PATH=\"${opencoarrays_install_path%/}/bin\"                     " >> setup.sh
      echo "else                                                                 " >> setup.sh
      echo "  export PATH=\"${opencoarrays_install_path%/}/bin\":\${PATH}              " >> setup.sh
      echo "fi                                                                   " >> setup.sh
      echo "set path = (\"${opencoarrays_install_path%/}\"/bin \$path)                      " >> setup.csh
    fi
    if ${SUDO:-} mv setup.sh "${opencoarrays_install_path}"; then
       setup_sh_location=${opencoarrays_install_path}
    else
       setup_sh_location=${PWD}
    fi
    if ${SUDO:-} mv setup.csh "${opencoarrays_install_path}"; then
       setup_csh_location=${opencoarrays_install_path}
    else
       setup_csh_location=${PWD}
    fi
    echo "*** To set up your environment for using caf and cafrun, please ***"
    echo "*** source the installed setup.sh file in bash or Z shell or    ***"
    echo "*** source setup.csh in a C-shell or add one of the following   ***"
    echo "*** statements to your login file:                              ***"
    echo ""
    echo " source ${setup_sh_location%/}/setup.sh"
    echo " source ${setup_csh_location%/}/setup.csh"
    echo ""
    echo "*** Installation complete.                                        ***"

  else # Installation failed

    echo "Something went wrong. Either the user lacks executable permissions for the"
    echo "OpenCoarrays compiler wrapper (caf), program launcher (cafrun), or prerequisite"
    echo "package installer (build), or these programs are not in the following, expected"
    echo "location:"
    echo "${install_path}/bin."
    echo "Please review the following file for more information:"
    echo "${install_path}/${installation_record}"
    echo "and submit an bug report at https://github.com/sourceryinstitute/opencoarrays/issues/new"
    echo "[exit 100]"
    exit 100

  fi # Ending check for caf, cafrun, build not in expected path
}

# If -p, -D, -P, or -V specifies a package, set package_url
# If -U specifies a package, print the package_url and exit with normal status
# shellcheck disable=SC2154
set_or_print_url()
{
  # Verify requirements
  [ ! -z "${arg_U}" ] && [ ! -z "${arg_D:-${arg_p:-${arg_P:-${arg_V}}}}" ] &&
    emergency "Please pass only one of {-D, -p, -P, -U, -V} or a longer equivalent (multiple detected)."

  # Get package name from argument passed with  -p, -D, -P, -V, or -U
  package_to_build="${arg_p:-${arg_D:-${arg_P:-${arg_U:-${arg_V}}}}}"

  if [[ "${package_to_build}" == 'cmake' ]]; then
    major_minor="${version_to_build%.*}"
  elif [[ "${package_to_build}" == "gcc" && "${version_to_build}" != "trunk" ]]; then
    gcc_url_head="ftp.gnu.org:/gnu/gcc/gcc-${version_to_build}/"
  else
    gcc_url_head="svn://gcc.gnu.org/svn/gcc/"
  fi
  package_url_head=(
    "gcc;${gcc_url_head:-}"
    "wget;ftp.gnu.org:/gnu/wget/"
    "m4;ftp.gnu.org:/gnu/m4/"
    "pkg-config;http://pkgconfig.freedesktop.org/releases/"
    "mpich;http://www.mpich.org/static/downloads/${version_to_build}/"
    "flex;http://sourceforge.net/projects/flex/files/"
    "make;ftp://ftp.gnu.org/gnu/make/"
    "bison;ftp.gnu.org:/gnu/bison/"
    "cmake;http://www.cmake.org/files/v${major_minor-}/"
    "subversion;http://www.eu.apache.org/dist/subversion/"
  )
  for package in "${package_url_head[@]}" ; do
     KEY="${package%%;*}"
     VALUE="${package##*;}"
     if [[ "${package_to_build}" == "${KEY}" ]]; then
       # We recognize the package name so we set the URL head:
       url_head="${VALUE}"
       break
     fi
  done

  # Set differing tails for GCC trunk versus branches
  if [[ "${package_to_build}" == 'gcc' ]]; then
    if [[ "${fetch}" == 'svn' ]]; then
      gcc_tail="${version_to_build}"
    elif [[ "${version_to_build}" == '--avail' || "${version_to_build}" == '-a' ]]; then
      gcc_tail='branches'
    else
      gcc_tail="gcc-${version_to_build}.tar.bz2"
    fi
  fi
  package_url_tail=(
    "gcc;${gcc_tail:-}"
    "wget;wget-${version_to_build}.tar.gz"
    "m4;m4-${version_to_build}.tar.bz2"
    "pkg-config;pkg-config-${version_to_build}.tar.gz"
    "mpich;mpich-${version_to_build}.tar.gz"
    "flex;flex-${version_to_build}.tar.bz2"
    "bison;bison-${version_to_build}.tar.gz"
    "make;make-${version_to_build}.tar.bz2"
    "cmake;cmake-${version_to_build}.tar.gz"
    "subversion;subversion-${version_to_build}.tar.gz"
  )
  for package in "${package_url_tail[@]}" ; do
     KEY="${package%%;*}"
     VALUE="${package##*;}"
     if [[ "${package_to_build}" == "${KEY}" ]]; then
       # We recognize the package name so we set the URL tail:
       url_tail="${VALUE}"
       break
     fi
  done

  if [[ -z "${url_head:-}" || -z "${url_tail}" ]]; then
    emergency "Package ${package_name:-} not recognized.  Use --l or --list-packages to list the allowable names."
  fi

  package_url="${url_head}""${url_tail}"

  # If a printout of the package URL was requested, then print it and exit with normal status
  if [[ ! -z "${arg_U:-}" ]]; then
    printf "%s\n" "${package_url}"
    exit 0
  fi
}

# If -p, -D, -P, or -V specifies a package, set package_url
# If -U specifies a package, print the package_url and exit with normal status
# shellcheck disable=SC2154
set_or_print_url()
{
  # Verify requirements
  [ ! -z "${arg_U}" ] && [ ! -z "${arg_D:-${arg_p:-${arg_P:-${arg_V:-${arg_B}}}}}" ] &&
    emergency "Please pass only one of {-B, -D, -p, -P, -U, -V} or a longer equivalent (multiple detected)."

  # Get package name from argument passed with  -p, -D, -P, -V, or -U
  package_to_build="${arg_p:-${arg_D:-${arg_P:-${arg_U:-${arg_V:-${arg_B}}}}}}"

  if [[ "${package_to_build}" == 'cmake' ]]; then
    major_minor="${version_to_build%.*}"
  elif [[ "${package_to_build}" == "gcc" ]]; then
    if [[ -z "${arg_b:-${arg_B}}" ]]; then
      gcc_url_head="ftp://ftp.gnu.org:/gnu/gcc/gcc-${version_to_build}/"
    else
      gcc_url_head="svn://gcc.gnu.org/svn/gcc/"
    fi
  fi
  package_url_head=(
    "gcc;${gcc_url_head-}"
    "wget;ftp://ftp.gnu.org:/gnu/wget/"
    "m4;ftp://ftp.gnu.org:/gnu/m4/"
    "pkg-config;http://pkgconfig.freedesktop.org/releases/"
    "mpich;http://www.mpich.org/static/downloads/${version_to_build-}/"
    "flex;http://sourceforge.net/projects/flex/files/"
    "make;ftp://ftp.gnu.org/gnu/make/"
    "bison;ftp://ftp.gnu.org:/gnu/bison/"
    "cmake;http://www.cmake.org/files/v${major_minor-}/"
    "subversion;http://www.eu.apache.org/dist/subversion/"
  )
  for package in "${package_url_head[@]}" ; do
     KEY="${package%%;*}"
     VALUE="${package##*;}"
     info "KEY=${KEY}  VALUE=${VALUE}"
     
     if [[ "${package_to_build}" == "${KEY}" ]]; then
       # We recognize the package name so we set the URL head:
       url_head="${VALUE}"
       break
     fi
  done

  # Set differing tails for GCC release downloads versus development branch checkouts
  if [[ "${package_to_build}" == 'gcc' ]]; then
    if [[ "${fetch}" == 'svn' ]]; then
      gcc_tail=${version_to_build-branches}
    else
      gcc_tail="gcc-${version_to_build}.tar.bz2"
    fi
  fi
  package_url_tail=(
    "gcc;${gcc_tail-}"
    "wget;wget-${version_to_build-}.tar.gz"
    "m4;m4-${version_to_build-}.tar.bz2"
    "pkg-config;pkg-config-${version_to_build-}.tar.gz"
    "mpich;mpich-${version_to_build-}.tar.gz"
    "flex;flex-${version_to_build-}.tar.bz2"
    "bison;bison-${version_to_build-}.tar.gz"
    "make;make-${version_to_build-}.tar.bz2"
    "cmake;cmake-${version_to_build-}.tar.gz"
    "subversion;subversion-${version_to_build-}.tar.gz"
  )
  for package in "${package_url_tail[@]}" ; do
     KEY="${package%%;*}"
     VALUE="${package##*;}"
     if [[ "${package_to_build}" == "${KEY}" ]]; then
       # We recognize the package name so we set the URL tail:
       url_tail="${VALUE}"
       break
     fi
  done

  if [[ -z "${url_head:-}" || -z "${url_tail}" ]]; then
    emergency "Package ${package_name:-} not recognized.  Use --l or --list-packages to list the allowable names."
  fi

  package_url="${url_head}""${url_tail}"

  # If a printout of the package URL was requested, then print it and exit with normal status
  if [[ ! -z "${arg_U:-}" ]]; then
    printf "%s\n" "${package_url}"
    exit 0
  fi
}

# If -p, -D, -P, or -V specifies a package, set package_url
# If -U specifies a package, print the package_url and exit with normal status
# shellcheck disable=SC2154
set_or_print_url()
{
  # Verify requirements
  if [[ ! -z "${arg_U}" ]]; then
    if [[ "${arg_N:-}" == "${__flag_present}" || ! -z "${arg_D:-${arg_p:-${arg_P:-${arg_V}}}}" ]]; then
      emergency "Please pass only one of {-D, -N, -p, -P, -U, -V} or a longer equivalent (multiple detected)."
    fi
  fi
  # Get package name from argument passed with  -p, -D, -P, -V, or -U
  package_name="${arg_D:-${arg_p:-${arg_P:-${arg_U:-${arg_V}}}}}"

  package_url_head=(
    "strategoxt-superbundle;https://github.com/sourceryinstitute/opencoarrays/files/212509/"
  )
  for package in "${package_url_head[@]}" ; do
     KEY="${package%%;*}"
     VALUE="${package##*;}"
     if [[ "${package_name}" == "${KEY}" ]]; then
       # We recognize the package name so we set the URL head:
       url_head="${VALUE}"
       break
     fi
  done

  package_url_tail=(
    "strategoxt-superbundle;strategoxt-superbundle-${version_to_build}.tar.gz"
  )
  for package in "${package_url_tail[@]}" ; do
     KEY="${package%%;*}"
     VALUE="${package##*;}"
     if [[ "${package_name}" == "${KEY}" ]]; then
       # We recognize the package name so we set the URL tail:
       url_tail="${VALUE}"
       break
     fi
  done

  if [[ -z "${url_head:-}" || -z "${url_tail:-}" ]]; then
    emergency "Package ${package_name:-} not recognized.  Use -l or --list-packages to list the allowable names."
  fi

  package_url="${url_head}""${url_tail}"

  # If a printout of the package URL was requested, then print it and exit with normal status
  if [[ ! -z "${arg_U:-}" ]]; then
    printf "%s\n" "${package_url}"
    exit 0
  fi
}

# shellcheck disable=SC2154
print_header()
{
  clear
  echo ""
  echo "*** By default, building OpenCoarrays requires CMake 3.4.0 or later,      ***"
  echo "*** MPICH 3.1.4, and GCC Fortran (gfortran) 6.1.0 or later.  To see       ***"
  echo "*** options for forcing the use of older or alternative packages, execute ***"
  echo "*** this script with the -h flag.  This script will recursively traverse  ***"
  echo "*** the following dependency tree, asking permission to download, build,  ***"
  echo "*** and install any packages that are required for building another       ***"
  echo "*** package and are neither in your PATH nor in                           ***"
  echo "*** opencoarrays/prerequisites/installations:                             ***"
  echo ""
  # Move to a directory tree whose structure mirrors the dependency tree
  pushd "$opencoarrays_src_dir/doc/dependency_tree/" > /dev/null
  if type tree &> /dev/null; then
    # dynamically compute and print the tree, suppressing the final line
    tree opencoarrays  | sed '$d'
  else
    # print the most recently saved output of the above 'tree' command
    sed '$d' < opencoarrays-tree.txt
  fi
  popd > /dev/null
  echo ""
  printf "${arg_p} will be installed in ${install_path}\n"
  echo ""
  printf "Ready to rock and roll? (Y/n)"
  read -r install_now
  echo -e " $install_now\n"
  if [[ "$install_now" == "n" || "$install_now" == "no" ]]; then
    emergency "$this_script: Aborting. [exit 85]\n"
  fi
}

#!/usr/bin/env bash
# BASH3 Boilerplate
#
# install-ofp.sh
#
#  - Build the Open Fortran Parser
#
# Usage: ./install-ofp.sh -i /opt
#
# More info:
#
#  - https://github.com/kvz/bash3boilerplate
#  - http://kvz.io/blog/2013/02/26/introducing-bash3boilerplate/
#
# Version: 2.0.0
#
# Authors:
#
#  - Kevin van Zonneveld (http://kvz.io)
#  - Izaak Beekman (https://izaakbeekman.com/)
#  - Alexander Rathai (Alexander.Rathai@gmail.com)
#  - Dr. Damian Rouson (http://www.sourceryinstitute.org/) (documentation)
#
# Licensed under MIT
# Copyright (c) 2013 Kevin van Zonneveld (http://kvz.io)

# The invocation of bootstrap.sh below performs the following tasks:
# (1) Import several bash3boilerplate helper functions & default settings.
# (2) Set several variables describing the current file and its usage page.
# (3) Parse the usage information (default usage file name: current file's name with -usage appended).
# (4) Parse the command line using the usage information.

export OPENCOARRAYS_SRC_DIR="${OPENCOARRAYS_SRC_DIR:-${PWD}/..}"
if [[ ! -f "${OPENCOARRAYS_SRC_DIR}/src/libcaf.h" ]]; then
  echo "Please run this script inside the OpenCoarrays source \"prerequisites\" subdirectory"
  echo "or set OPENCOARRAYS_SRC_DIR to the top-level OpenCoarrays source directory path."
  exit 1
fi
export __usage="${OPENCOARRAYS_SRC_DIR}/prerequisites/install-ofp.sh-usage"
export B3B_USE_CASE="${B3B_USE_CASE:-${OPENCOARRAYS_SRC_DIR}/prerequisites/use-case}"
if [[ ! -f "${B3B_USE_CASE:-}/bootstrap.sh" ]]; then
  echo "Please set B3B_USE_CASE to the bash3boilerplate use-case directory path."
  exit 2
fi
# shellcheck source=./use-case/bootstrap.sh
source "${B3B_USE_CASE}/bootstrap.sh" "$@"

# Set up a function to call when receiving an EXIT signal to do some cleanup. Remove if
# not needed. Other signals can be trapped too, like SIGINT and SIGTERM.
function cleanup_before_exit () {
  info "Cleaning up. Done"
}
trap cleanup_before_exit EXIT # The signal is specified here. Could be SIGINT, SIGTERM etc.

export __flag_present=1

# Verify requirements

[ -z "${LOG_LEVEL:-}" ] && emergency "Cannot continue without LOG_LEVEL. "

# shellcheck disable=SC2154
if [[ "${__os}" != "OSX" ]]; then
   echo "Source tranlsation via OFP is currently supported only on OS X."
   echo "Please submit an issue at https://github.com/sourceryinstitute/opencoarrays/issues."
   emergency "${PWD}/install-ofp.sh: Aborting."
fi

if [[ $(uname) == "Darwin"  ]]; then
  default_ofp_downloader=curl
  args="-LO"
else
  default_ofp_downloader=wget
  args="--no-check-certificate"
fi

# If -D is passed, print the download programs used for OFP and its prerequisites.
# Then exit with normal status.
# shellcheck  disable=SC2154
if [[ "${arg_D}" == "${__flag_present}" ]]; then
  echo "strategoxt-superbundle downloader: $("${OPENCOARRAYS_SRC_DIR}/prerequisites/install-binary.sh" -D strategoxt-superbundle)"
  echo "ofp-sdf default downloader: ${default_ofp_downloader}"
  exit 0
fi

# If -P is passed, print the default installation paths for OFP and its prerequisites.
# Then exit with normal status.
# shellcheck disable=SC2154
install_path="${arg_i}"
strategoxt_superbundle_install_path=$("${OPENCOARRAYS_SRC_DIR}/prerequisites/install-binary.sh" -P strategoxt-superbundle)
# shellcheck disable=SC2154
if [[ "${arg_P}" == "${__flag_present}" ]]; then
  echo "strategoxt-superbundle default installation path: ${strategoxt_superbundle_install_path}"
  echo "ofp default installation path: ${install_path}"
  exit 0
fi

# If -V is passed, print the default versions of OFP and its prerequisites.
# Then exit with normal status.
default_ofp_version=sdf
# shellcheck disable=SC2154
if [[ "${arg_V}" == "${__flag_present}" ]]; then
  echo "strategoxt-superbundle default version: $("${OPENCOARRAYS_SRC_DIR}/prerequisites/install-binary.sh" -V strategoxt-superbundle)"
  echo "ofp default version: ${default_ofp_version}"
  exit 0
fi

# If -U is passed, print the URLs for OFP and its prerequisites.
# Then exit with normal status.
ofp_url_head="https://github.com/sourceryinstitute/opencoarrays/files/213108/"
ofp_url_tail="ofp-sdf.tar.gz"
# shellcheck disable=SC2154
if [[ "${arg_U}" == "${__flag_present}" ]]; then
  echo "strategoxt-superbundle URL: $("${OPENCOARRAYS_SRC_DIR}/prerequisites/install-binary.sh" -U strategoxt-superbundle)"
  echo "ofp URL: ${ofp_url_head}${ofp_url_tail}"
  exit 0
fi

### Print bootstrapped magic variables to STDERR when LOG_LEVEL
### is at the default value (6) or above.
#####################################################################
# shellcheck disable=SC2154
{
info "__file: ${__file}"
info "__dir: ${__dir}"
info "__base: ${__base}"
info "__os: ${__os}"
info "__usage: ${__usage}"
info "LOG_LEVEL: ${LOG_LEVEL}"

info "-d (--debug):            ${arg_d}"
info "-D (--print-downloader): ${arg_D}"
info "-e (--verbose):          ${arg_e}"
info "-h (--help):             ${arg_h}"
info "-i (--install-dir):      ${arg_i}"
info "-I (--install-version):  ${arg_i}"
info "-j (--num-threads):      ${arg_j}"
info "-n (--no-color):         ${arg_n}"
info "-P (--print-path):       ${arg_P}"
info "-U (--print-url):        ${arg_U}"
info "-V (--print-version):    ${arg_V}"
}
# Set OFP installation path to the value of the -i argument if present.
# Otherwise, install OFP in the OpenCoarrays prerequisites/installations directory.
opencoarrays_prerequisites_dir="${OPENCOARRAYS_SRC_DIR}"/prerequisites/
if [[ "${arg_i}" == "${__flag_present}" ]]; then
  install_path="${arg_i}"
else
  install_path="${opencoarrays_prerequisites_dir}"/installations
fi

ofp_prereqs_install_dir="/opt"
# Change present working directory to installation directory
if [[ ! -d "${install_path}" ]]; then
  # shellcheck source=./build-functions/set_SUDO_if_needed_to_write_to_directory.sh
  source "${opencoarrays_prerequisites_dir}/build-functions/set_SUDO_if_needed_to_write_to_directory.sh"
  set_SUDO_if_needed_to_write_to_directory "${install_path}"
  ${SUDO:-} mkdir -p "${install_path}"
fi

# Install OFP prerequisites to /opt (currently the only option)
"${opencoarrays_prerequisites_dir}"/install-binary.sh -p strategoxt-superbundle -i "${strategoxt_superbundle_install_path}"

# Downlaod OFP
pushd "${install_path}"
info "OFP Download command: ${default_ofp_downloader} ${args:-} \"${ofp_url_head}${ofp_url_tail}\""
${default_ofp_downloader} ${args:-} "${ofp_url_head}${ofp_url_tail}" 


# Uncompress OFP
tar xf ofp-sdf.tar.gz
# Return to the original working directory
popd

export SDF2_PATH="${ofp_prereqs_install_dir}"/sdf2-bundle/v2.4/bin
export ST_PATH="${ofp_prereqs_install_dir}"/strategoxt/v0.17/bin
export DYLD_LIBRARY_PATH="${ofp_prereqs_install_dir}"/strategoxt/v0.17/lib:/opt/aterm/v2.5/lib

export OFP_HOME="${install_path}"/ofp-sdf
# shellcheck source=./install-binary-functions/build_parse_table.sh
source "${opencoarrays_prerequisites_dir}"/install-binary-functions/build_parse_table.sh
build_parse_table

# shellcheck shell=bash disable=SC2148
# If -p, -P, -U, or -V specifies a package, set fetch variable
# If -D specifies a package, print "${fetch}" and exit with normal status
# If -l is present, list all packages and versions and exit with normal status
# shellcheck disable=SC2154
set_or_print_downloader()
{
  # Verify requirements
  [ ! -z "${arg_D}" ] && [ ! -z "${arg_p:-${arg_P:-${arg_U:-${arg_V}}}}" ] &&
    emergency "Please pass only one of {-D, -p, -P, -U, -V} or a longer equivalent (multiple detected)."

  package_name="${arg_p:-${arg_D:-${arg_P:-${arg_U:-${arg_V}}}}}"

  if [[ "${package_name}" == "ofp" ]]; then
    "${OPENCOARRAYS_SRC_DIR}/prerequisites/install-ofp.sh" "${@}"
    exit 0
  fi

  # Choose the first available download mechanism, prioritizing first any absolute requirement
  # (git for gcc) and second robustness:
  info "Checking available download mechanisms: ftp, wget, and curl."
  info "\${package_name}=${package_name}  \${arg_b:-}=${arg_b:-}"

  if type curl &> /dev/null; then
    gcc_prereqs_fetch=curl
  elif type wget &> /dev/null; then
    gcc_prereqs_fetch=wget
  elif type ftp &> /dev/null; then
    if [[ "${package_name}" == "wget" || "${package_name}" == "make" ||
          "${package_name}" == "bison" || "${package_name}" == "m4"   ]]; then
      gcc_prereqs_fetch=ftp_url
    fi
  else
    tried="curl, wget, and ftp"
  fi

  if [[ "${package_name}" == "gcc" && ! -z ${arg_b:-} ]]; then
    if type git &> /dev/null; then
      fetch=git
    else
      tried="git"
    fi
  else
    fetch=${gcc_prereqs_fetch}
  fi

  if [[ -z "${fetch:-}" ]]; then
    emergency "No available download mechanism. Option(s) tried: ${tried}"
  fi

  # If a printout of the download mechanism was requested, then print it and exit with normal status
  if [[ ! -z "${arg_D}" ]]; then
     printf "%s\n" "${fetch}"
     exit 0
  fi
}

# A stack, using bash arrays.
# ---------------------------------------------------------------------------
# This software is released under a BSD license, adapted from
# <http://opensource.org/licenses/bsd-license.php>
#
# Copyright &copy; 1989-2012 Brian M. Clapper.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# * Redistributions of source code must retain the above copyright notice,
#  this list of conditions and the following disclaimer.
#
# * Redistributions in binary form must reproduce the above copyright notice,
#  this list of conditions and the following disclaimer in the documentation
#  and/or other materials provided with the distribution.
#
# * Neither the name "clapper.org" nor the names of its contributors may be
#  used to endorse or promote products derived from this software without
#  specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#

# Source: http://brizzled.clapper.org/blog/2011/10/28/a-bash-stack/

# Destroy a stack
#
# Usage: stack_destroy name
function stack_destroy
{
    : "${1?'Missing stack name'}"

    if no_such_stack "$1"
    then
        echo "No such stack -- $1" >&2
        return 1
    fi

    eval "unset _stack_$1 _stack_$1_i"
    return 0
}

# Push one or more items onto a stack.
#
# Usage: stack_push stack item ...
function stack_push
{
    : "${1?'Missing stack name'}"
    : "${2?'Missing variable name in stack_push'}"

    if no_such_stack "$1"
    then
        echo "No such stack -- $1" >&2
        return 1
    fi

    stack=$1
    shift 1

    while (( $# > 0 ))
    do
        eval '_i=$'"_stack_${stack}_i"
        eval "_stack_${stack}[$_i]='$1'"
        eval "let _stack_${stack}_i+=1"
        shift 1
    done

    unset _i
    return 0
}


# Get the size of a stack
#
# Usage: stack_size name var
#
# Example:
#    stack_size mystack n
#    echo "Size is $n"
function stack_size
{
    : "${1?'Missing stack name'}"
    : "${2?'Missing name of variable for stack size result'}"
    if no_such_stack "$1"
    then
        echo "No such stack -- $1" >&2
        return 1
    fi
    # TODO: revise the eval below to eliminate the need for this pop/push
    # sequene, which is a workaround to prevent an error that occurs with
    # if the stack is new and has not been the target of a stack_push.
    stack_push $1 __push_junk
    stack_pop $1 __pop_trash
    eval "$2"='$'"{#_stack_$1[*]}"
}

function no_such_stack
{
    : "${1?'Missing stack name'}"
    stack_exists "$1"
    ret=$?
    declare -i x
    let x="1-$ret" || true
    return $x
}

#### Functions modified by Damian Rouson

# These functions were modified to work with the shell settings in bash3boilerplate
# (https://github.com/zbeekman/bash3boilerplate), primarily the "set -o unset" and
# "set -o pipefail" settings.  The required modifications are described below.
#

# Pop the top element from the stack.
#
# Usage: stack_pop name var
#
# Example:
#    stack_pop mystack top
#    echo "Got $top"
#
# Modification for use with bash3boilerplate:
#    replaced "let _i-=1" with  "(( _i-=1 )) || true"

function stack_pop
{
    : "${1?'Missing stack name'}"
    : "${2?'Missing variable name in stack_pop'}"

    if no_such_stack "$1"
    then
        echo "No such stack -- $1" >&2
        return 1
    fi

    eval 'let _i=$'"_stack_$1_i"

    if [[ "$_i" -eq 0 ]]
    then
        echo "Empty stack -- $1" >&2
        return 1
    fi

   (( _i-=1 )) || true
    eval "$2"='$'"{_stack_$1[$_i]}"
    eval "unset _stack_$1[$_i]"
    eval "_stack_$1_i=$_i"
    unset _i
    return 0
}

# Print a stack to stdout.
#
# Usage: stack_print name
#
# Modification for use with bash3boilerplate:
#    replaced "let _i=${_i}-1" with "(( _i=${_i}-1 )) || true" to support execution with "set -o nounset"

function stack_print
{
    : "${1?'Missing stack name'}"

    if no_such_stack "$1"
    then
        echo "No such stack -- $1" >&2
        return 1
    fi

    tmp=""
    eval 'let _i=$'"_stack_$1_i"

    while (( _i > 0 ))
    do
        eval 'e=$'"{_stack_$1[$((--_i))]}" # pre-decrement
	# shellcheck  disable=SC2154
        tmp="$tmp $e"
    done
    # shellcheck  disable=SC2086
    echo "(" $tmp ")"
}

# Create a new stack.
#
# Usage: stack_new name
#
# Example: stack_new x
#
# Modification for use with bash3boilerplate:
#    added "|| true" to allow execution with "set -o nounset" on OS X

function stack_new
{
    : "${1?'Missing stack name'}"
    if stack_exists "$1"
    then
        echo "Stack already exists -- $1" >&2
        return 1
    fi

    eval "_stack_$1=()"
    eval "_stack_$1_i=0"

    variableName="_stack_$1_i"
    variableVal="0"
    eval "${variableName}"="$(echo -ne \""${variableVal}"\")"

    return 0
}

# Verify stack existence.
#
# Usage: stack_exists name
#
# Example: stack_new x
#
# Modification for use with bash3boilerplate:
#    added curly braces in eval statement to allow execution with "set -o nounset"

function stack_exists
{
    : "${1?'Missing stack name'}"

    eval '_i=$'"{_stack_$1_i:-}"
    if [[ -z "${_i:-}" ]]
    then
        return 1
    else
        return 0
    fi
}

#### Functions added by Damian Rouson

# Get the top element from the stack and return the stack
# to its state before invocation of the function.
#
# Usage: stack_peek name var
#
# Example:
#    stack_peek mystack top
#    echo "Got $top"
function stack_peek
{
  : "${1?'Missing stack name'}"
  : "${2?'Missing variable name in stack_peek'}"

  if no_such_stack "$1"
  then
      echo "No such stack -- $1" >&2
      return 1
  fi

  stack_pop "$1" "$2"
  eval argument_name="\$$2"
  # shellcheck disable=SC2154
  stack_push "$1" "$argument_name"
}

# BASH3 Boilerplate
#
#  set_common_switches.sh
#
#  - Sets variables that are useful in conjunction with other bash3boilerplate features
#  - Contains commands extracted from the bash3boilerplate main.sh as part of a refactoring
#    to facilitate wholesale reuse of main.sh's contents of without modification.
#
# Usage (as invoked in bootstrap.sh):
#
#  source set_common_switches.sh
#
# More info:
#
#  - https://github.com/kvz/bash3boilerplate
#  - http://kvz.io/blog/2013/02/26/introducing-bash3boilerplate/
#
# Version: 2.0.0
#
# Authors:
#
#  - Kevin van Zonneveld (http://kvz.io)
#  - Izaak Beekman (https://izaakbeekman.com/)
#  - Alexander Rathai (Alexander.Rathai@gmail.com)
#  - Dr. Damian Rouson (http://www.sourceryinstitute.org/) (documentation)
#
# Licensed under MIT
# Copyright (c) 2013 Kevin van Zonneveld (http://kvz.io)

### Switches (like -d for debugmode, -h for showing helppage)
#####################################################################

# shellcheck disable=SC2154
{
# debug mode
if [ "${arg_d}" = "1" ]; then
  set -o xtrace
  LOG_LEVEL="7"
  export LOG_LEVEL
fi

# verbose mode
if [ "${arg_e}" = "1" ]; then
  set -o verbose
fi

# help mode
if [ "${arg_h}" = "1" ]; then
  # Help exists with code 1
  help "Help using ${0}"
fi
}

# If -P specifies a package, print the installation path and exit with normal status
# Otherwise, set install_path
# shellcheck disable=SC2154
set_or_print_installation_path()
{
  # Verify requirements
  [ ! -z "${arg_P}" ] && [ ! -z "${arg_p:-${arg_D:-${arg_U:-${arg_V}}}}" ] &&
    emergency "Please pass only one of {-D, -p, -P, -U, -V} or a longer equivalent (multiple detected)."

  arg_i_default="${OPENCOARRAYS_SRC_DIR}/prerequisites/installations/"
  if [[ "${arg_i:-}" ==  "${arg_i_default}" ]]; then
    install_path="${arg_i%/}/${arg_p:-${arg_D:-${arg_P:-${arg_U:-${arg_V}}}}}/${version_to_build}"
  else
    install_path="${arg_i%/}"
  fi

  # If -P is present, print ${install_path} and exit with normal status
  if [[ ! -z "${arg_P:-}" ]]; then
    printf "%s\n" "${install_path}"
    exit 0
  fi

  info "${package_name} ${version_to_build} installation path: ${install_path}"
}

# Define the sudo command to be used if the installation path requires administrative permissions
set_SUDO_if_needed_to_write_to_directory()
{
  if [[ $# != "1" ]]; then
    emergency "set_SUDO_if_needed_to_write_to_directory takes exactly one argument"
  else
    directory_to_create=$1
  fi
  if [[ -z "${LD_LIBRARY_PATH:-}" ]]; then
     info "\${LD_LIBRARY_PATH} is empty. Try setting it if the compiler encounters linking problems."
  fi
  SUDO_COMMAND="sudo env LD_LIBRARY_PATH=${LD_LIBRARY_PATH:-} PATH=${PATH:-}"
  info "Checking whether the directory ${directory_to_create} exists... "
  if [[ -d "${directory_to_create}" ]]; then
    info "yes"
    info "Checking whether I have write permissions to ${directory_to_create} ... "
    if [[ -w "${directory_to_create}" ]]; then
      info "yes"
    else
      info "no"
      SUDO="${SUDO_COMMAND}"
    fi
  else
    info "no"
    info "Checking whether I can create ${directory_to_create} ... "
    if mkdir -p "${directory_to_create}" >& /dev/null; then
      info "yes."
    else
      info "no."
      # shellcheck disable=SC2034
      SUDO="${SUDO_COMMAND}"
    fi
  fi
}

# shellcheck shell=bash disable=SC2148
# If -p, -D, -P, or -U specifies a package, set default_version
# If -V specifies a package, print the default_version and exit with normal status
# If -l is present, list all packages and versions and exit with normal status
# shellcheck disable=SC2154
set_or_print_default_version()
{
  # Verify requirements
  [ "${arg_l}" == "${__flag_present}" ] && [ ! -z "${arg_D:-${arg_p:-${arg_P:-${arg_U:-${arg_V}}}}}" ] &&
    emergency "Please pass only one of {-l, -D, -p, -P, -U, -V} or a longer equivalent (multiple detected)."

  if [[ "${arg_l}" == "${__flag_present}" ]]; then
    echo "This script can build the following packages:"
  fi
  # Get package name from argument passed with -p, -V, -D, or -U
  package_name="${arg_p:-${arg_D:-${arg_P:-${arg_U:-${arg_V}}}}}" # not needed for -l

  if [[ "${package_name}" == "ofp" ]]; then
    "${OPENCOARRAYS_SRC_DIR}/prerequisites/install-ofp.sh" "${@}"
    exit 0
  fi

  if [[ $(uname) == "Darwin" ]]; then
    apple_flex_version="2.5.35"
  fi

  [ "${package_name}" == "opencoarrays" ] &&
    emergency "Please use this script with a previously downloaded opencoarrays source archive. This script does not download opencoarrays "
  # This is a bash 3 hack standing in for a bash 4 hash (bash 3 is the lowest common
  # denominator because, for licensing reasons, OS X only has bash 3 by default.)
  # See http://stackoverflow.com/questions/1494178/how-to-define-hash-tables-in-bash
  package_version=(
    "cmake:3.10.0"
    "gcc:12.1.0"
    "mpich:3.2"
    "wget:1.16.3"
    "flex:${apple_flex_version:-2.6.0}"
    "bison:3.0.4"
    "pkg-config:0.28"
    "make:4.1"
    "m4:1.4.17"
    "subversion:1.9.4"
    "ofp:sdf"
  )
  for package in "${package_version[@]}" ; do
     KEY="${package%%:*}"
     VALUE="${package##*:}"
     if [[  "${arg_l}" == "${__flag_present}" ]]; then
       # If the list was requested, print the current element of the name:version list.
       printf "%s (default version %s)\n" "${KEY}" "${VALUE}"
     elif [[ "${package_name}" == "${KEY}" ]]; then
       # We recognize the package name so we set the default version:
       default_version=${VALUE}
       # If a printout of the default version number was requested, then print it and exit with normal status
       [[ ! -z "${arg_V}" ]] && printf "%s\n" "${default_version}" && exit 0
       break # exit the for loop
     fi
  done

 # Exit with normal status (package/version has been printed).
 [ "${arg_l}" == "${__flag_present}" ] && exit 0

 # Exit with error status and diagnostic output if empty default_version
 if [[ -z "${default_version:-}" ]]; then
    emergency "set_or_print_default.sh: Package ${package_name:-} not recognized.  Use --l or --list-packages to list the allowable names."
 fi
}

# BASH3 Boilerplate
#
#  parse_command_line.sh
#
#  - Uses usage information defined in "${__usage}" to parse the command line.
#  - Defines a function containing commands extracted from the bash3boilerplate
#    main.sh as part of a refactoring to facilitate wholesale reuse of main.sh's
#    contents of without modification.
#
# More info:
#
#  - https://github.com/kvz/bash3boilerplate
#  - http://kvz.io/blog/2013/02/26/introducing-bash3boilerplate/
#
# Version: 2.0.0
#
# Authors:
#
#  - Kevin van Zonneveld (http://kvz.io)
#  - Izaak Beekman (https://izaakbeekman.com/)
#  - Alexander Rathai (Alexander.Rathai@gmail.com)
#  - Dr. Damian Rouson (http://www.sourceryinstitute.org/) (documentation)
#
# Usage (as invoked in bootstraph.sh):
#
#   source parse_command_line.sh
#   parse_command_line ${@:2}
#
# Licensed under MIT
# Copyright (c) 2013 Kevin van Zonneveld (http://kvz.io)

### Parse commandline options
#####################################################################
function parse_command_line(){
# source this script and pass $@ as the argument

# Translate usage string -> getopts arguments, and set $arg_<flag> defaults
# shellcheck disable=SC2154
while read -r line; do
  # fetch single character version of option string
  opt="$(echo "${line}" |awk '{print $1}' |sed -e 's#^-##')"

  # fetch long version if present
  long_opt="$(echo "${line}" |awk '/\-\-/ {print $2}' |sed -e 's#^--##')"
  long_opt_mangled="$(sed 's#-#_#g' <<< "$long_opt")"

  # map long name back to short name
  varname="short_opt_${long_opt_mangled}"
  eval "${varname}=\"${opt}\""

  # check if option takes an argument
  varname="has_arg_${opt}"
  if ! echo "${line}" |egrep '\[.*\]' >/dev/null 2>&1; then
    init="0" # it's a flag. init with 0
    eval "${varname}=0"
  else
    opt="${opt}:" # add : if opt has arg
    init=""  # it has an arg. init with ""
    eval "${varname}=1"
  fi
  opts="${opts:-}${opt}"

  varname="arg_${opt:0:1}"
  if ! echo "${line}" |egrep '\. Default=' >/dev/null 2>&1; then
    eval "${varname}=\"${init}\""
  else
    match="$(sed 's#^.*Default=\(\)#\1#g' <<< "${line}")"
    eval "${varname}=\"${match}\""
  fi
done < "${__usage}"


# Allow long options like --this
opts="${opts}-:"

# Reset in case getopts has been used previously in the shell.
OPTIND=1

# start parsing command line
set +o nounset # unexpected arguments will cause unbound variables
               # to be dereferenced
# Overwrite $arg_<flag> defaults with the actual CLI options
while getopts "${opts}" opt; do
  [ "${opt}" = "?" ] && help "Invalid use of script: ${*} "

  if [ "${opt}" = "-" ]; then
    # OPTARG is long-option-name or long-option=value
    if [[ "${OPTARG}" =~ .*=.* ]]; then
      # --key=value format
      long=${OPTARG/=*/}
      long_mangled="$(sed 's#-#_#g' <<< "$long")"
      # Set opt to the short option corresponding to the long option
      eval "opt=\"\${short_opt_${long_mangled}}\""
      OPTARG=${OPTARG#*=}
    else
      # --key value format
      # Map long name to short version of option
      long_mangled="$(sed 's#-#_#g' <<< "$OPTARG")"
      eval "opt=\"\${short_opt_${long_mangled}}\""
      # Only assign OPTARG if option takes an argument
      eval "OPTARG=\"\${@:OPTIND:\${has_arg_${opt}}}\""
      # shift over the argument if argument is expected
      ((OPTIND+=has_arg_${opt}))
    fi
    # we have set opt/OPTARG to the short value and the argument as OPTARG if it exists
  fi
  varname="arg_${opt:0:1}"
  default="${!varname}"

  value="${OPTARG}"
  if [ -z "${OPTARG}" ] && [ "${default}" = "0" ]; then
    value="1"
  fi

  eval "${varname}=\"${value}\""
  debug "cli arg ${varname} = ($default) -> ${!varname}"
done

set -o nounset # no more unbound variable references expected

shift $((OPTIND-1))

# shellcheck disable=SC2015
[ "${1:-}" = "--" ] && shift || true
}
export -f parse_command_line # make function available to subshells
parse_command_line "${@:-}"  # invoke parsing function and allow for empty argument list

#shellcheck shell=bash
# shellcheck disable=SC2154
build_opencoarrays()
{
  print_header
  info "Invoking find_or_install mpich"
  find_or_install mpich
  info "Invoking find_or_install cmake"
  find_or_install cmake
  build_path="${build_path}"/opencoarrays/$("${OPENCOARRAYS_SRC_DIR}"/install.sh -V opencoarrays)
  if [[ -d "${build_path}" ]]; then
    rm -rf "${build_path}"
  fi
  mkdir -p "$build_path"
  pushd "$build_path"
  if [[ -z ${MPIFC:-} || -z ${MPICC:-} ]]; then
    emergency "build_opencoarrays.sh: empty \${MPIFC}=${MPIFC:-} or \${MPICC}=${MPICC:-}"
  fi
  MPIFC_show=($("$MPIFC" -show))
  MPICC_show=($("$MPICC" -show))
  if [[ "${MPIFC_show[0]}" != *gfortran* ]]; then
    export fortran_compiler_identity="$(${MPIFC_show[0]} --version)"
    if [[ $fortran_compiler_identity != "GNU Fortran"* ]]; then
      emergency "build_opencoarrays.sh: MPI doesn't wrap gfortran/gcc: \${MPIFC_show}=${MPIFC_show[*]}"
    fi
  fi
  if [[ -z "${OPENCOARRAYS_DEVELOPER:-}" ]]; then
      # We should examine the value too, but CMake has many ways of saying "true"
      WDEVFLAG=-Wno-dev
  else
      WDEVFLAG=-Wdev
  fi
    # Set FC to the MPI implementation's gfortran command with any preceding path but without any subsequent arguments:
  FC="${MPIFC_show[0]}"
  # Set CC to the MPI implementation's gcc command...
  CC="${MPICC_show[0]}"
  # try to find mpiexec
  MPI_BIN_DIR="$(type -P "${MPICC}")"
  MPIEXEC_CANDIDATES=($(find "${MPI_BIN_DIR%/*}" -name 'mpiexec' -o -name 'mpirun' -o -name 'lamexec' -o -name 'srun'))
  if ! ((${#MPIEXEC_CANDIDATES[@]} >= 1)); then
    emergency "Could not find a suitable \`mpiexec\` in directory containing mpi wrappers (${MPICC%/*})"
  else
    MPIEXEC="${MPIEXEC_CANDIDATES[0]}"
  fi

  source "${OPENCOARRAYS_SRC_DIR:-}/prerequisites/build-functions/set_or_print_installation_path.sh"
  set_or_print_installation_path

  info "Configuring OpenCoarrays in ${PWD} with the command:"
  info "CC=\"${CC}\" FC=\"${FC}\" $CMAKE \"${OPENCOARRAYS_SRC_DIR}\" \"${WDEVFLAG}\" -DCMAKE_INSTALL_PREFIX=\"${install_path}\" -DMPIEXEC=\"${MPIEXEC}\" -DMPI_C_COMPILER=\"${MPICC}\" -DMPI_Fortran_COMPILER=\"${MPIFC}\""
  CC="${CC}" FC="${FC}" $CMAKE "${OPENCOARRAYS_SRC_DIR}" "${WDEVFLAG}" -DCMAKE_INSTALL_PREFIX="${install_path}" -DMPIEXEC="${MPIEXEC}" -DMPI_C_COMPILER="${MPICC}" -DMPI_Fortran_COMPILER="${MPIFC}"
  info "Building OpenCoarrays in ${PWD} with the command make -j${num_threads}"
  make "-j${num_threads}"
  if [[ ! -z ${SUDO:-} ]]; then
    printf "\nThe chosen installation path requires sudo privileges. Please enter password if prompted.\n"
  fi
  info "Installing OpenCoarrays in ${install_path} with the command ${SUDO:-} make install"
  ${SUDO:-} make install
}

# BASH3 Boilerplate
#
#  set_environment_and_color.sh
#
#  - Sets variables that control the behavior of the invoking script.
#  - Contains commands extracted from the bash3boilerplate main.sh as
#    part of a refactoring to facilitate wholesale reuse of main.sh's
#    contents of without modification.
#
# Usage (as invoked in bootstrap.sh):
#
#  source set_environment_and_color.sh
#
# More info:
#
#  - https://github.com/kvz/bash3boilerplate
#  - http://kvz.io/blog/2013/02/26/introducing-bash3boilerplate/
#
# Version: 2.0.0
#
# Authors:
#
#  - Kevin van Zonneveld (http://kvz.io)
#  - Izaak Beekman (https://izaakbeekman.com/)
#  - Alexander Rathai (Alexander.Rathai@gmail.com)
#  - Dr. Damian Rouson (http://www.sourceryinstitute.org/) (documentation)
#
# Licensed under MIT
# Copyright (c) 2013 Kevin van Zonneveld (http://kvz.io)

# Exit on error. Append ||true if you expect an error.
# `set` is safer than relying on a shebang like `#!/bin/bash -e` because that is neutralized
# when someone runs your script as `bash yourscript.sh`
set -o errexit
set -o nounset

# Bash will remember & return the highest exitcode in a chain of pipes.
# This way you can catch the error in case mysqldump fails in `mysqldump |gzip`
set -o pipefail
# set -o xtrace

# Environment variables and their defaults
LOG_LEVEL="${LOG_LEVEL:-6}" # 7 = debug -> 0 = emergency
NO_COLOR="${NO_COLOR:-}"    # true = disable color. otherwise autodetected

# If -P specifies a package, print the installation path and exit with normal status
# Otherwise, set install_path
# shellcheck disable=SC2154
set_or_print_installation_path()
{
  # Verify requirements
  [ ! -z "${arg_P}" ] && [ ! -z "${arg_p:-${arg_D:-${arg_U:-${arg_V}}}}" ] &&
    emergency "Please pass only one of {-D, -p, -P, -U, -V} or a longer equivalent (multiple detected)."

  if [[ $arg_p == "opencoarrays" ]]; then
    export version_to_build=$(${OPENCOARRAYS_SRC_DIR}/install.sh -V opencoarrays)
    export package_name="opencoarrays"
  fi
  arg_i_default="${OPENCOARRAYS_SRC_DIR}/prerequisites/installations/"
  if [[ "${arg_i%/}" == "${arg_i_default}" ]]; then
    if [[ -z "${arg_r}" ]]; then
      export install_path="${arg_i%/}/${arg_p:-${arg_D:-${arg_P:-${arg_U:-${arg_V}}}}}/${version_to_build}"
    else
      export install_path="${arg_r%/}/${arg_p:-${arg_D:-${arg_P:-${arg_U:-${arg_V}}}}}/${version_to_build}"
    fi
  else
    if [[ ! "${arg_i%/}" != "${arg_r}" ]]; then
      emergency "Please pass only one of {-i,-r} or a longer equivalent (multiple detected). [exit 105]"
    fi
    install_path="${arg_i%/}"
  fi

  # If -P is present, print ${install_path} and exit with normal status
  if [[ ! -z "${arg_P:-}" ]]; then
    printf "%s\n" "${install_path}"
    exit 0
  fi

  info "${package_name} ${version_to_build} installation path: ${install_path}"
}

# shellcheck shell=bash disable=SC2154,SC2148
print_header() {
  pushd "${__dir}" >/dev/null
  local gccver mpichver cmakever flexver bisonver m4ver
  gccver="$("${__file}" -V gcc)"
  mpichver="$("${__file}" -V mpich)"
  cmakever="$("${__file}" -V cmake)"
  flexver="$("${__file}" -V flex)"
  bisonver="$("${__file}" -V bison)"
  m4ver="$("${__file}" -V m4)"
  popd >/dev/null
  clear
  echo ""
  echo "*** By default, building OpenCoarrays requires CMake ${cmakever} or later,      ***"
  echo "*** MPICH ${mpichver}, and GCC Fortran (gfortran) ${gccver} or later.  To see         ***"
  echo "*** options for forcing the use of older or alternative packages, execute ***"
  echo "*** this script with the -h flag.  This script will recursively traverse  ***"
  echo "*** the following dependency tree, asking permission to download, build,  ***"
  echo "*** and install any packages that are required for building another       ***"
  echo "*** package and are neither in your PATH nor in                           ***"
  echo "*** opencoarrays/prerequisites/installations:                             ***"
  echo ""
  # Generate the following text using the `tree` command w/ dummy directory structure
  cat <<-EOF
    opencoarrays
    ├── cmake-${cmakever}
    └── mpich-${mpichver}
        └── gcc-${gccver}
            ├── flex-${flexver}
            │   └── bison-${bisonver}
            │       └── m4-${m4ver}
            ├── gmp
            ├── mpc
            └── mpfr

EOF
  echo ""
  printf "%s will be installed in %s\n" "${arg_p}" "${install_path}"
  echo ""
  if [[ "${arg_y}" == "${__flag_present}" ]]; then
    info "-y or --yes-to-all flag present. Proceeding with non-interactive build."
  else
    printf "Ready to rock and roll? (Y/n)"
    read -r install_now
    printf '%s\n' "${install_now}"
    if [[ "${install_now}" == "n" || "${install_now}" == "no" ]]; then
      emergency "${this_script}: Aborting. [exit 85]"
    fi
  fi
}

# shellcheck shell=bash
functions_exist() {
  : "${1?'Missing function name list'}"

  for function_name; do
    if [[ "$(type -t "${function_name}")" != "function" ]]; then
      emergency "function ${function_name} does not exist"
    fi
  done
}

detect_missing_variable_name() {
  : "${1?'detect_missing_variable name: Missing function name'}"

  stack_new __dummy_stack

  for function_name; do
    expected_error="Missing variable name in ${function_name}"
    error_message="$(${function_name} _dummy_stack_name 2>&1 >/dev/null)" || true
    error_message="${error_message##*: }" # grab text after final colon/space sequence
    if [[ "${error_message}" != "${expected_error}" ]]; then
      emergency "${function_name} failed to detect '${expected_error}'"
    fi
  done
  stack_destroy __dummy_stack
}

detect_missing_stack_name() {
  : "${1?'detect_missing_name: Missing function name'}"

  expected_error="Missing stack name"
  debug "detect_missing_stack_name: \${expected_error}=${expected_error}"

  for function_name; do
    debug "detect_missing_stack_name: executing \"\$(${function_name} 2>&1 > /dev/null)\" || true"
    error_message="$(${function_name} 2>&1 >/dev/null)" || true
    error_message="${error_message##*: }" # grab text after final colon/space sequence
    debug "detect_missing_stack_name: \${error_message}=${error_message}"
    if [[ "${error_message}" != "${expected_error}" ]]; then
      emergency "${function_name} failed to detect '${expected_error}'"
    fi
  done
}

detect_no_such_stack() {
  : "${1?'detect_no_such_name: Missing function name'}"

  stack_name="__nonexistent_stack"
  expected_error="No such stack -- "
  debug "detect_no_such_stack: \${expected_error}=${expected_error}"

  # shellcheck disable=SC2034
  dummy_variable=""

  for function_name; do
    debug "detect_no_such_stack: executing \"\$(${function_name} ${stack_name} dummy_variable 2>&1 > /dev/null)\" || true"
    error_message="$(${function_name} ${stack_name} dummy_variable 2>&1 >/dev/null)" || true
    missing_stack="${error_message##${expected_error}}" # grab text after final colon/space sequence
    debug "detect_no_such_stack: \${missing_stack}=${missing_stack}"
    if [[ "${missing_stack}" != "${stack_name}" ]]; then
      emergency "${function_name} failed to detect missing '${stack_name}'"
    fi
  done
}

detect_duplicate_stack_creation() {
  : "${1?'detect_duplicate_stack_creation: Missing function name'}"

  stack_name="__dummy_stack"
  stack_new "${stack_name}"

  expected_error="Stack already exists -- "
  debug "detect_duplicate_stack_creation: \${expected_error}=${expected_error}"
  function_name="stack_new"

  debug "detect_duplicate_stack_creation: executing \"\$(${function_name} ${stack_name} 2>&1 > /dev/null)\" || true"
  error_message="$(${function_name} ${stack_name} dummy_variable 2>&1 >/dev/null)" || true
  duplicate_stack="${error_message##${expected_error}}" # grab text after final colon/space sequence
  debug "detect_no_such_stack: \${duplicate_stack}=${duplicate_stack}"
  if [[ "${duplicate_stack}" != "${stack_name}" ]]; then
    emergency "${function_name} failed to detect duplicate '${stack_name}'"
  fi
  stack_destroy ${stack_name}
}

verify_stack_size_changes() {
  stack_new foobar
  stack_size foobar __foobar_size
  expected_size=0
  # shellcheck disable=SC2154
  if [[ "${__foobar_size}" != "${expected_size}" ]]; then
    emergency "verify_stack_size_changes: size=${__foobar_size} (expected ${expected_size})"
  fi

  stack_push foobar kernel
  stack_size foobar __foobar_new_size
  ((expected_size += 1))
  # shellcheck disable=SC2154
  if [[ "${__foobar_new_size}" != "${expected_size}" ]]; then
    emergency "verify_stack_size_changes: size=${__foobar_new_size} (expected 1)"
  fi

  stack_peek foobar tmp
  # shellcheck disable=SC2154
  if [[ "${tmp}" != "kernel" ]]; then
    emergency "verify_stack_size_changes: peeked item ('${tmp}') mismatch with pushed item ('kernel')"
  fi

  stack_size foobar __should_be_unchanged
  # shellcheck disable=SC2154
  if [[ "${__should_be_unchanged}" != "${expected_size}" ]]; then
    emergency "verify_stack_size_changes: size=${__should_be_unchanged} (expected ${expected_size})"
  fi

  stack_pop foobar popped
  # shellcheck disable=SC2154
  if [[ "${popped}" != "kernel" ]]; then
    emergency "verify_stack_size_changes: popped item ('${popped}') mismatch with pushed item ('kernel')"
  fi
  ((expected_size -= 1)) || true

  stack_size foobar __final_size
  # shellcheck disable=SC2154
  if [[ "${__final_size}" != "${expected_size}" ]]; then
    emergency "verify_stack_size_changes: size=${__final_size} (expected ${expected_size})"
  fi
}

test_stack() {
  # Verify availability of expected functions:
  functions_exist \
    stack_new stack_exists stack_print stack_push stack_peek stack_pop stack_size stack_destroy

  # Verify that each named function detects missing stack-name arguments:
  detect_missing_stack_name \
    stack_new stack_exists stack_print stack_push stack_peek stack_pop stack_size stack_destroy

  # Verify that each named function detects missing names of the variable to push, pop, or peek:
  detect_missing_variable_name \
    stack_pop stack_push stack_peek

  # Verify that each named function detects non-existent stacks:
  detect_no_such_stack \
    stack_destroy stack_peek stack_print stack_pop stack_push stack_size

  # Verify that duplicate creation generates the expected error:
  detect_duplicate_stack_creation \
    stack_new

  # Verify that push, peek, and pop yield correct size changes or lack thereof:
  verify_stack_size_changes

  info "test-stack.sh: All tests passed."

}

#!/bin/bash
source /usr/local/packages/Modules/init/bash
module load intel/14.0
source /usr/local/packages/intel/14.0/bin/ifortvars.sh intel64
export TAU_MAKEFILE=/usr/local/packages/tau-2.22.2/x86_64/lib/Makefile.tau-coarray-icpc-mpi
export TAU_COMM_MATRIX=1
export PATH=/usr/local/packages/tau-2.22.2/x86_64/bin:$PATH
module load java
export PATH=/usr/local/packages/intel/14.0/mpirt/bin/intel64/:$PATH
#export FOR_COARRAY_NUM_IMAGES=1
echo "Using FOR_COARRAY_NUM_IMAGES = " $FOR_COARRAY_NUM_IMAGES
mpiexec --mca btl_tcp_if_include eth2 -np 16 ./burgers_caf
#./burgers_caf

# If -p, -D, -P, or -U specifies a package, set default_version
# If -V specifies a package, print the default_version and exit with normal status
# If -l is present, list all packages and versions and exit with normal status
# shellcheck disable=SC2154
set_or_print_default_version()
{
  # Verify requirements
  if [[ "${arg_l}" == "${__flag_present}" ]]; then
    if [[ "${arg_N:-}" == "${__flag_present}" || ! -z "${arg_D:-${arg_p:-${arg_P:-${arg_U:-${arg_V}}}}}" ]]; then
      emergency "Please pass only one of {-l, -D, -N, -p, -P, -U, -V} or a longer equivalent (multiple detected)."
    fi
  fi

  if [[ "${arg_l}" == "${__flag_present}" ]]; then
    echo "This script can install the following packages:"
  fi
  # Get package name from argument passed with -p, -V, -D, or -U
  package_name="${arg_D:-${arg_p:-${arg_P:-${arg_U:-${arg_V:-}}}}}" # not needed for -l
  # This is a bash 3 hack standing in for a bash 4 hash (bash 3 is the lowest common
  # denominator because, for licensing reasons, OS X only has bash 3 by default.)
  # See http://stackoverflow.com/questions/1494178/how-to-define-hash-tables-in-bash
  package_version=(
    "strategoxt-superbundle:0.17-macosx"
  )
  for package in "${package_version[@]}" ; do
     KEY="${package%%:*}"
     VALUE="${package##*:}"
     if [[  "${arg_l}" == "${__flag_present}" ]]; then
       # If the list was requested, print the current element of the name:version list.
       printf "%s (default version %s)\n" "${KEY}" "${VALUE}"
     elif [[ "${package_name}" == "${KEY}" ]]; then
       # We recognize the package name so we set the default version:
       default_version=${VALUE}
       # If a printout of the default version number was requested, then print it and exit with normal status
       [[ ! -z "${arg_V}" ]] && printf "%s\n" "${default_version}" && exit 0
       break # exit the for loop
     fi
  done

 # Exit with normal status (package/version has been printed).
 [ "${arg_l}" == "${__flag_present}" ] && exit 0

 # Exit with error status and diagnostic output if empty default_version
 if [[ -z "${default_version:-}" ]]; then
    emergency "Package ${package_name:-} not recognized.  Use -l or --list-packages to list the allowable names."
 fi
}

#! /bin/sh
# Download a file from an anonymous ftp site
#
# Usage:
#    ftp_url  <ftp-mode>  ftp://<fully-qualified-domain>:/<path-to-file>/<file-name>
#
# Example:
#    ftp_url -n ftp://ftp.gnu.org:/gnu/gcc/gcc-6.1.0/gcc-6.1.0.tar.bz2
ftp_url()
{
  ftp_mode="${1}"
  url="${2}"

  if [ "${ftp_mode}" != "-n" ]; then
    echo "Unexpected ftp mode received by ftp_url.sh: ${ftp_mode}"
  fi

  protocol="${url%%:*}" # grab text_before_first_colon
  if [ "${protocol}" != "ftp" ]; then
    echo "URL with unexpected protocol received by ftp_url.sh: ${text_before_first_colon}"
  fi

  text_after_double_slash="${url##*//}"
  FTP_SERVER="${text_after_double_slash%%/*}" # grab remaining text before first slash
  FILE_NAME="${url##*/}" # grab text after final slash

  text_after_final_colon="${url##*:}"
  FILE_PATH="${text_after_final_colon#*//}"
  FILE_PATH="${FILE_PATH#*/}" 
  FILE_PATH="${FILE_PATH%/*}" 

  USERNAME=anonymous
  PASSWORD="noone@nowhere.com"
  echo "starting anonymous download: ${protocol} ${ftp_mode} ${FTP_SERVER};... cd ${FILE_PATH}; ...; get ${FILE_NAME}"

ftp "${ftp_mode}" "${FTP_SERVER}" <<Done-ftp
user "${USERNAME}" "${PASSWORD}"
cd "${FILE_PATH}"
passive
binary
get "${FILE_NAME}"
bye
Done-ftp

echo "finished anonymous ftp"
}

#!/usr/bin/env bash
#
# windows-install.sh
#
# -- This script installs OpenCoarrays and its prerequisites.
#
# OpenCoarrays is distributed under the OSI-approved BSD 3-clause License:
# Copyright (c) 2015-2016, Sourcery, Inc.
# Copyright (c) 2015-2016, Sourcery Institute
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without modification,
# are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice, this
#    list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright notice, this
#    list of conditions and the following disclaimer in the documentation and/or
#    other materials provided with the distribution.
# 3. Neither the names of the copyright holders nor the names of their contributors
#    may be used to endorse or promote products derived from this software without
#    specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
# Portions of this script derive from BASH3 Boilerplate and are distributed under
# the following license:
#
# The MIT License (MIT)
#
# Copyright (c) 2014 Kevin van Zonneveld
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
#
#
#  - https://github.com/kvz/bash3boilerplate
#  - http://kvz.io/blog/2013/02/26/introducing-bash3boilerplate/
#
# Version: 2.0.0
#
# Authors:
#
#  - Kevin van Zonneveld (http://kvz.io)
#  - Izaak Beekman (https://izaakbeekman.com/)
#  - Alexander Rathai (Alexander.Rathai@gmail.com)
#  - Dr. Damian Rouson (http://www.sourceryinstitute.org/) (documentation)
#
# Licensed under MIT
# Copyright (c) 2013 Kevin van Zonneveld (http://kvz.io)

# The invocation of bootstrap.sh below performs the following tasks:
# (1) Import several bash3boilerplate helper functions & default settings.
# (2) Set several variables describing the current file and its usage page.
# (3) Parse the usage information (default usage file name: current file's name with -usage appended).
# (4) Parse the command line using the usage information.

### Start of boilerplate -- do not edit this block #######################
export OPENCOARRAYS_SRC_DIR="${OPENCOARRAYS_SRC_DIR:-${PWD%/}}"
if [[ ! -f "${OPENCOARRAYS_SRC_DIR}/src/libcaf.h" ]]; then
  echo "Please run this script inside the top-level OpenCoarrays source directory or "
  echo "set OPENCOARRAYS_SRC_DIR to the OpenCoarrays source directory path."
  exit 1
fi
export B3B_USE_CASE="${B3B_USE_CASE:-${OPENCOARRAYS_SRC_DIR}/prerequisites/use-case}"
if [[ ! -f "${B3B_USE_CASE:-}/bootstrap.sh" ]]; then
  echo "Please set B3B_USE_CASE to the bash3boilerplate use-case directory path."
  exit 2
else
    # shellcheck source=./prerequisites/use-case/bootstrap.sh
    source "${B3B_USE_CASE}/bootstrap.sh" "$@"
fi
### End of boilerplate -- start user edits below #########################

# Set expected value of present flags that take no arguments
export __flag_present=1

# Set up a function to call when receiving an EXIT signal to do some cleanup. Remove if
# not needed. Other signals can be trapped too, like SIGINT and SIGTERM.
function cleanup_before_exit () {
  info "Cleaning up. Done"
}
trap cleanup_before_exit EXIT # The signal is specified here. Could be SIGINT, SIGTERM etc.

### Validation (decide what's required for running your script and error out)
#####################################################################

[[ -z "${LOG_LEVEL:-}" ]] && emergency "Cannot continue without LOG_LEVEL. "

# shellcheck disable=SC2154
if [[ "${arg_d}" == "${__flag_present}" ]]; then
   print_debug_only=7
   if [[ "$(( LOG_LEVEL < print_debug_only ))" -ne 0 ]]; then
     debug "Supressing info and debug messages: one of {-l, -v, -P, -U, -V, -D} present."
     suppress_info_debug_messages
   fi
fi

# Get linux_distribution name
# shellcheck disable=SC2154
{
info "__file: ${__file}"
info "__dir: ${__dir}"
info "__base: ${__base}"
info "__os: ${__os}"
info "__usage: ${__usage}"
info "LOG_LEVEL: ${LOG_LEVEL}"

info  "-c (--with-c):     [arg] ${arg_c}"
info  "-C (--with-cxx):   [arg] ${arg_C}"
info  "-d (--debug):            ${arg_d}"
info  "-e (--verbose):          ${arg_e}"
info  "-f (--with-fortran):     ${arg_e}"
info  "-i (--install-prefix):   ${arg_i}"
info  "-j (--num-threads):      ${arg_j}"
info  "-m (--with-cmake): [arg] ${arg_m}"
info  "-n (--no-color):         ${arg_n}"
info  "-v (--version):          ${arg_v}"
info  "-V (--version-number):   ${arg_V}"
}

# __________ Process command-line arguments and environment variables _____________

this_script="$(basename "${0}")"
export this_script
debug "this_script=\"${this_script}\""

export install_prefix="${arg_i%/:-${PWD}/prerequisites/installations}"
info "install_prefix=\"${install_prefix}\""

export num_threads="${arg_j}"
info "num_threads=\"${arg_j}\""

opencoarrays_version=$(sed -n '/[0-9]\{1,\}\(\.[0-9]\{1,\}\)\{1,\}/{s/^\([^.]*\)\([0-9]\{1,\}\(\.[0-9]\{1,\}\)\{1,\}\)\(.*\)/\2/p;q;}' "${OPENCOARRAYS_SRC_DIR%/}/.VERSION")

export build_path="${OPENCOARRAYS_SRC_DIR%/}"/prerequisites/builds/opencoarrays/${opencoarrays_version}
info "build_path=\"${build_path}\""

export CMAKE="${arg_m:-cmake}"

verify_this_is_ubuntu()
{
  if [[ ${__os} != "Linux"  ]]; then
    emergency "${__os} not supported: this script is intended for use in Windows Subsystem for Linux "
  fi
  linux_standard_base_i=$(lsb_release -i)
  untrimmed_name=${linux_standard_base_i##*Distributor ID:}
  linux_distribution="${untrimmed_name//[[:space:]]/}"
  info "Linux distribution: ${linux_distribution}"
  if [[ "${linux_distribution:-}" != "Ubuntu" ]]; then
    info "Please run this script inside the Windows Subsystem for Linux (WSL) Ubuntu 16.04 or later,"
    info "which might require joining the Windows Insider Preview program and selecting 'Fast' updates."
    emergency "Error: see above."
  fi
}
verify_this_is_ubuntu

# Ubuntu 16.04 apt-get installs gfortran 5.4.0 or later, which is acceptable for many uses of OpenCoarrays
verify_acceptable_release_number()
{
  linux_standard_base_r=$(lsb_release -r)
  untrimmed_name=${linux_standard_base_r##*Release:}
  release_number="${untrimmed_name//[[:space:]]/}"
  major_release="${release_number%%.*}"
  minor_release="${release_number##*.}"
  info "Release: ${major_release}.${minor_release}"
  if [[ ${major_release} -lt 16  ]]; then
    emergency "Please upgrade to Windows Subsystem for Linux (WSL) Ubuntu 16.04 or later."
  elif [[ ${major_release} -eq 16  ]]; then
    if [[ ${minor_release} -lt "04"  ]]; then
      emergency "Please upgrade to Windows Subsystem for Linux (WSL) Ubuntu 16.04 or later."
    fi
  fi
}
verify_acceptable_release_number

if [[ "${arg_V}" == "${__flag_present}" ]]; then
    # Print just the version number
    info "${opencoarrays_version}"

elif [[ "${arg_v}" == "${__flag_present}" ]]; then

    # Print copyright info and version number
    info "OpenCoarrays ${opencoarrays_version}"
    info ""
    info "OpenCoarrays installer"
    info "Copyright (C) 2015-2017 Sourcery, Inc."
    echo "Copyright (C) 2015-2017 Sourcery Institute"
    info ""
    info "OpenCoarrays comes with NO WARRANTY, to the extent permitted by law."
    info "You may redistribute copies of ${this_script} under the terms of the"
    echo "BSD 3-Clause License.  For more information about these matters, see"
    info "http://www.sourceryinstitute.org/license.html"
    info ""
else

  export FC=${arg_f:-gfortran}
  export CC=${arg_c:-gcc}
  export CXX=${arg_C:-g++}

  # Check for and, if necessary, install OpenCoarrays prerequisites

  if ! type "${CMAKE}" >& /dev/null; then
    sudo apt-get install cmake
  fi
  if ! type "${CXX}" >& /dev/null; then
    sudo apt-get install g++
  fi
  if ! type "${FC}" >& /dev/null; then
    sudo apt-get install gfortran
  fi

  if ! type mpifort >& /dev/null; then
    sudo apt-get install mpich
  fi

  set_SUDO_if_needed_to_write_to_install_dir()
  {
    info "Checking whether the directory ${install_prefix} exists... "
    if [[ -d "${install_prefix}" ]]; then
      info "yes"
      info "Checking whether I have write permissions to ${install_prefix} ... "
      if [[ -w "${install_prefix}" ]]; then
        info "yes"
      else
        info "no"
        SUDO="sudo"
      fi
    else
      info "no"
      info "Checking whether I can create ${install_prefix} ... "
      if mkdir -p "${install_prefix}" >& /dev/null; then
        info "yes."
      else
        info "no."
        SUDO="sudo"
      fi
    fi
  }
  set_SUDO_if_needed_to_write_to_install_dir

  # Install OpenCoarrays

  if [[ -d "${build_path}" ]]; then
    rm -rf "${build_path}"
  fi
  mkdir -p "${build_path}"
  cd "${build_path}" || exit 25
  info "Configuring OpenCoarrays with the following command:"
  info "FC=\"${FC}\" CC=\"${CC}\"  \"${CMAKE}\" \"${OPENCOARRAYS_SRC_DIR}\" -DCMAKE_INSTALL_PREFIX=\"${install_prefix}\""
  FC="${FC}" CC="${CC}" "${CMAKE}" "${OPENCOARRAYS_SRC_DIR}" -DCMAKE_INSTALL_PREFIX="${install_prefix}"
  info "Building OpenCoarrays with the following command:"
  info "make -j ${arg_j}"
  make -j "${arg_j}"
  info "Installing OpenCoarrays with the following command:"
  info "${SUDO:-} make install"
  ${SUDO:-} make install
  if [[ -f "${install_prefix}"/lib/libcaf_mpi.a && -f "${install_prefix}/bin/caf"  && -f "${install_prefix}/bin/cafrun"  ]]; then
    info "OpenCoarrays has been installed in"
    info "${install_prefix}"
  else
    info "Something went wrong. OpenCoarrays is not in the expected location:"
    emergency "${install_prefix}"
  fi
  # See http://stackoverflow.com/questions/31057694/gethostbyname-fail-after-switching-internet-connections/31222970
  loopback_line=$(grep "${NAME}" /etc/hosts)
  if [[ -z "${loopback_line:-}" ]]; then
    info "To ensure the correct functioning of MPI, please add the following line to your /etc/hosts file:"
    info "127.0.0.1 ${NAME}"
  fi
fi

# shellcheck shell=bash disable=SC2154,SC2034,SC2148
find_or_install()
{
  package="$1"
  # This is a bash 3 hack standing in for a bash 4 hash (bash 3 is the lowest common
  # denominator because, for licensing reasons, OS X only has bash 3 by default.)
  # See http://stackoverflow.com/questions/1494178/how-to-define-hash-tables-in-bash
  package_executable_array=(
    "gcc:gfortran"
    "cmake:cmake"
    "mpich:mpifort"
    "flex:flex"
    "bison:yacc"
    "m4:m4"
    "_unknown:0"
  )
  for element in "${package_executable_array[@]}" ; do
     KEY="${element%%:*}"
     VALUE="${element##*:}"
     if [[ "$KEY" == "_unknown" ]]; then
       # No recognizeable argument passed so print usage information and exit:
       printf "%s: Package name (%s) not recognized in find_or_install function [exit 40].\n" "$this_script" "$package"
       exit 40
     elif [[ $package == "$KEY" ]]; then
       executable=$VALUE
       break
     fi
  done

  if [[ "$package" == "$executable" ]]; then
    printf "%s: Checking whether %s is in the PATH..." "$this_script" "$executable"
  else
    printf "%s: Checking whether %s executable $executable is in the PATH..." "$this_script" "$package"
  fi
  if type "$executable" >& /dev/null; then
    printf "yes.\n"
    package_in_path=true
    package_version_in_path=$( ("${executable}" --version 2>/dev/null || "${executable}" -V) | head -1)
  else
    printf "no.\n"
    package_in_path=false
  fi

  export default_package_install_path=$(./build.sh -P "$package")

  printf "Checking whether %s is in %s..." "$executable" "$default_package_install_path"
  if [[ -x "$default_package_install_path/bin/$executable" ]]; then
    printf "yes.\n"
    script_installed_package=true
    stack_push script_installed "$package" "$executable"
  else
    script_installed_package=false
    printf "no.\n"
  fi

  minimum_version=$(./build.sh -V "$package")

  if [[ "$package" == "cmake" ]]; then

    # We arrive here only by the explicit, direct call 'find_or_install cmake' inside
    # the build_opencoarrays function. Because there is no possibility of arriving here
    # by recursion (no packages depend on cmake except OpenCoarrays, which gets built
    # after all dependencies have been found or installed), cmake must add itself to
    # the dependency stack if no acceptable cmake is found.

    # Every branch that discovers an acceptable pre-existing installation must set the
    # CMAKE environment variable. Every branch must also manage the dependency stack.

    # If the user specified a CMake binary, use it
    if [[ ! -z "${arg_m:-}" ]]; then

      echo -e "$this_script: Using the $package specified by -m or --with-cmake: ${arg_m}\n"
      export CMAKE="${arg_m}"
      # Halt the recursion
      stack_push dependency_pkg "none"
      stack_push dependency_exe "none"
      stack_push dependency_path "none"

    elif [[ "$script_installed_package" == true ]]; then
      echo -e "$this_script: Using the $package installed by $this_script\n"
      export CMAKE=$default_package_install_path/bin/$executable
      stack_push dependency_pkg "none"
      stack_push dependency_exe "none"
      stack_push dependency_path "none"

    elif [[ "$package_in_path" == "true" ]]; then
      echo -e "$this_script: Checking whether $package in PATH is version < $minimum_version... "

      if ! ./check_version.sh "$package" "$(./build.sh -V "$package")"; then
        printf "yes.\n"
        # Here we place $package on the dependency stack to trigger the build of the above file:
        stack_push dependency_pkg "$package" "none"
        stack_push dependency_exe "$package" "none"
        stack_push dependency_path "$(./build.sh -P cmake)" "none"

      else
        printf "no.\n"
        echo -e "$this_script: Using the $executable found in the PATH.\n"
        export CMAKE=$executable
        # Prevent recursion
        stack_push dependency_pkg "none"
        stack_push dependency_exe "none"
        stack_push dependency_path "none"
      fi

    else # Build package ($package has no prerequisites)
      stack_push dependency_pkg "$package" "none"
      stack_push dependency_exe "$package" "none"
      stack_push dependency_path "$(./build.sh -P "$package")" "none"
    fi

  elif [[ $package == "mpich" ]]; then

    # We arrive here only by the explicit, direct call 'find_or_install mpich' inside
    # the build_opencoarrays function. Because there is no possibility of arriving here
    # by recursion (no packages depend on mpich except OpenCoarrays, which gets built
    # after all dependencies have been found or installed), mpich must add itself to
    # the dependency stack if no acceptable mpich is found.

    # Every branch that discovers an acceptable pre-existing installation must set the
    # MPIFC, MPICC, and MPICXX environment variables. Every branch must also manage the
    # dependency stack.

    # If the user specified a Fortran compiler, verify that mpifort wraps the specified compiler
    if [[ ! -z "${arg_M:-}" ]]; then

      echo -e "$this_script: Using the $package specified by -M or --with-mpi: ${arg_M}\n"
      export MPIFC="${arg_M}"/bin/mpifort
      export MPICC="${arg_M}"/bin/mpicc
      export MPICXX="${arg_M}"/bin/mpicxx
      # Halt the recursion
      stack_push dependency_pkg "none"
      stack_push dependency_exe "none"
      stack_push dependency_path "none"

    elif [[ "$script_installed_package" == true ]]; then

      echo -e "$this_script: Using the $package installed by $this_script\n"
      export MPIFC=$default_package_install_path/bin/mpifort
      export MPICC=$default_package_install_path/bin/mpicc
      export MPICXX=$default_package_install_path/bin/mpicxx
      # Halt the recursion
      stack_push dependency_pkg "none"
      stack_push dependency_exe "none"
      stack_push dependency_path "none"

    elif [[ "$package_in_path" == "true" ]]; then

      echo -e "$this_script: Checking whether $executable in PATH wraps gfortran... "
      mpifort_version_header=$(mpifort --version | head -1)
      first_three_characters=$(echo "$mpifort_version_header" | cut -c1-3)
      if [[ "$first_three_characters" != "GNU" ]]; then
        printf "no.\n"
        # Trigger 'find_or_install gcc' and subsequent build of $package
        stack_push dependency_pkg "none" "$package" "gcc"
        stack_push dependency_exe "none" "$executable" "gfortran"
        stack_push dependency_path "none" "$(./build.sh -P "$package")" "$(./build.sh -P gcc)"
      else
        printf "yes.\n"

        if [[ ! -z "${arg_f:-}" ]]; then

          info "-f (or --with-fortran) argument detected with value ${arg_f}"
          printf "yes.\n %s: Using the specified %s.\n" "$this_script" "$executable"
          export MPIFC=mpifort
          export MPICC=mpicc
          export MPICXX=mpicxx

          # Halt the recursion
          stack_push dependency_pkg "none"
          stack_push dependency_exe "none"
          stack_push dependency_path "none"

        else

          export minimum_compiler_version=$(./build.sh -V gcc)
          info "$this_script: Checking whether $executable in PATH wraps gfortran version >= $minimum_compiler_version... "
          $executable acceptable_compiler.f90 -o acceptable_compiler || true;
          $executable print_true.f90 -o print_true || true;
          if [[ -f ./acceptable_compiler && -f ./print_true ]]; then
            acceptable=$(./acceptable_compiler $minimum_compiler_version)
            is_true=$(./print_true)
            rm acceptable_compiler print_true
          else
            acceptable=false
          fi
          if [[ "$acceptable" == "${is_true:-}" ]]; then
            printf "yes.\n %s: Using the $executable found in the PATH.\n" "$this_script"
            export MPIFC=mpifort
            export MPICC=mpicc
            export MPICXX=mpicxx

            # Halt the recursion
            stack_push dependency_pkg "none"
            stack_push dependency_exe "none"
            stack_push dependency_path "none"
          else
            printf "no\n"
            # Trigger 'find_or_install gcc' and subsequent build of $package
            stack_push dependency_pkg "none" "$package" "gcc"
            stack_push dependency_exe "none" "$executable" "gfortran"
            stack_push dependency_path "none" "$(./build.sh -P "$package")" "$(./build.sh -P gcc)"
          fi
        fi
      fi

    else # $package not in PATH and not yet installed by this script
      # Trigger 'find_or_install gcc' and subsequent build of $package
      stack_push dependency_pkg  "none" "$package" "gcc"
      stack_push dependency_exe  "none" "$executable" "gfortran"
      stack_push dependency_path "none" "$(./build.sh -P "$package")" "$(./build.sh -P gcc)"
    fi

    # Check consistency of MPIFC, if set, and user-specified Fortran compiler
    if [[ ! -z ${MPIFC:-} && ! -z "${arg_f:-}" ]]; then
      MPIFC_wraps=$("${MPIFC}" --version)
      compiler=$(${arg_f} --version)
      if [[ "${MPIFC_wraps}" != "${compiler}"   ]]; then
        emergency "Specified MPI ${MPIFC_wraps} wraps a compiler other than the specified Fortran compiler ${compiler}"
      fi
    fi

  elif [[ $package == "gcc" ]]; then

    # We arrive here when the 'elif [[ $package == "mpich" ]]' block pushes "gcc" onto the
    # the dependency_pkg stack, resulting in the recursive call 'find_or_install gcc'

    # Every branch that discovers an acceptable pre-existing installation must set the
    # FC, CC, and CXX environment variables. Every branch must also manage the dependency stack.

    if [[ ! -z "${arg_f:-}" ]]; then

      info "-f (or --with-fortran) argument detected with value ${arg_f}"
      [ -z "${arg_c:-}" ] && emergency "-f (--with-fortran) specifies Fortran compiler; Please also specify C/C++ compilers"
      [ -z "${arg_C:-}" ] && emergency "-f (--with-fortran) specifies Fortran compiler; Please also specify C/C++ compilers"

      export FC="${arg_f}"
      export CC="${arg_c}"
      export CXX="${arg_C}"

      # Remove $package from the dependency stack
      stack_pop dependency_pkg package_done
      stack_pop dependency_exe executable_done
      stack_pop dependency_path package_done_path
      # Halt the recursion and signal that none of $package's prerequisites need to be built
      stack_push dependency_pkg "none"
      stack_push dependency_exe "none"
      stack_push dependency_path "none"

    elif [[ "$script_installed_package" == true ]]; then
      echo -e "$this_script: Using the $package executable $executable installed by $this_script\n"
      export FC=$default_package_install_path/bin/gfortran
      export CC=$default_package_install_path/bin/gcc
      export CXX=$default_package_install_path/bin/g++
      gfortran_lib_paths="$default_package_install_path/lib64/:$default_package_install_path/lib"
      if [[ -z "${LD_LIBRARY_PATH:-}" ]]; then
        echo "$this_script: export LD_LIBRARY_PATH=\"$gfortran_lib_paths\""
                            export LD_LIBRARY_PATH="$gfortran_lib_paths"
      else
        echo "$this_script: export LD_LIBRARY_PATH=\"$gfortran_lib_paths:$LD_LIBRARY_PATH\""
                            export LD_LIBRARY_PATH="$gfortran_lib_paths:$LD_LIBRARY_PATH"
      fi
      # Remove $package from the dependency stack
      stack_pop dependency_pkg package_done
      stack_pop dependency_exe executable_done
      stack_pop dependency_path package_done_path
      # Put $package onto the script_installed log
      stack_push script_installed package_done
      stack_push script_installed executable_done
      stack_push script_installed package_done_path
      # Halt the recursion and signal that none of $package's prerequisites need to be built
      stack_push dependency_pkg "none"
      stack_push dependency_exe "none"
      stack_push dependency_path "none"

    elif [[ "$package_in_path" == "true" ]]; then
      info "$this_script: Checking whether $executable in PATH is version $minimum_version or later..."
      $executable -o acceptable_compiler acceptable_compiler.f90 || true;
      $executable -o print_true print_true.f90 || true;
      if [[ -f ./acceptable_compiler && -f ./print_true ]]; then
        is_true=$(./print_true)
        info "Executing './acceptable_compiler $minimum_version'"
        acceptable=$(./acceptable_compiler $minimum_version)
        rm acceptable_compiler print_true
      else
        acceptable=false
      fi

      if [[ "$acceptable" == "${is_true:-}" ]]; then
        printf "yes.\n"
        echo -e "$this_script: Using the $executable found in the PATH.\n"
        export FC=gfortran
        export CC=gcc
        export CXX=g++
        # Remove $package from the dependency stack
        stack_pop dependency_pkg package_done
        stack_pop dependency_exe executable_done
        stack_pop dependency_path package_done_path
        # Put $package onto the script_installed log
        stack_push script_installed package_done
        stack_push script_installed executable_done
        stack_push script_installed package_done_path
        # Halt the recursion and signal that none of $package's prerequisites need to be built
        stack_push dependency_pkg "none"
        stack_push dependency_exe "none"
        stack_push dependency_path "none"
      else
        printf "no.\n"
        # Trigger 'find_or_install flex' and subsequent build of $package
        stack_push dependency_pkg "flex"
        stack_push dependency_exe "flex"
        stack_push dependency_path "$(./build.sh -P flex)"
      fi

    else # $package is not in PATH and not yet installed by this script
      # Trigger 'find_or_install flex' and subsequent build of $package
      stack_push dependency_pkg "flex"
      stack_push dependency_exe "flex"
      stack_push dependency_path "$(./build.sh -P flex)"
    fi

  elif [[ $package == "flex" ]]; then

    # We arrive here only if the 'elif [[ $package == "gcc" ]]' block has pushed "flex"
    # onto the dependency_pkg stack, resulting in the recursive call 'find_or_install flex'.
    # flex therefore does not need to add itself to the stack.

    # Every branch that discovers an acceptable pre-existing installation must set the
    # FLEX environment variable. Every branch must also manage the dependency stack.

    if [[ "$script_installed_package" == true ]]; then
      echo -e "$this_script: Using the $executable installed by $this_script\n"
      export FLEX=$default_package_install_path/bin/$executable
      # Remove flex from the dependency stack
      stack_pop dependency_pkg package_done
      stack_pop dependency_exe executable_done
      stack_pop dependency_path package_done_path
      # Put $package onto the script_installed log
      stack_push script_installed package_done
      stack_push script_installed executable_done
      stack_push script_installed package_done_path
      # Halt the recursion and signal that no prerequisites need to be built
      stack_push dependency_pkg "none"
      stack_push dependency_exe "none"
      stack_push dependency_path "none"

    elif [[ "$package_in_path" == "true" ]]; then

      echo -e "$this_script: Checking whether $package in PATH is version < $minimum_version... "
      if ! ./check_version.sh "$package" "$(./build.sh -V "$package")"; then
        printf "yes\n"

        export FLEX="$default_package_install_path/bin/$executable"
        # Trigger 'find_or_install bison' and subsequent build of $package
        stack_push dependency_pkg "bison"
        stack_push dependency_exe "yacc"
        stack_push dependency_path "$(./build.sh -P bison)"
      else
        printf "no.\n"
        echo -e "$this_script: Using the $executable found in the PATH.\n"
        export FLEX=$executable
        # Remove $package from the dependency stack
        stack_pop dependency_pkg package_done
        stack_pop dependency_exe executable_done
        stack_pop dependency_path package_done_path
        # Put $package onto the script_installed log
        stack_push script_installed package_done
        stack_push script_installed executable_done
        stack_push script_installed package_done_path
        # Halt the recursion and signal that none of $package's prerequisites need to be built
        stack_push dependency_pkg "none"
        stack_push dependency_exe "none"
        stack_push dependency_path "none"
      fi

    else  # $package is not in the PATH and not yet installed by $this_script
      # Trigger 'find_or_install bison' and subsequent build of $package
      stack_push dependency_pkg "bison"
      stack_push dependency_exe "yacc"
      stack_push dependency_path "$(./build.sh -P bison)"
    fi

  elif [[ $package == "bison" ]]; then

    # We arrive when the 'elif [[ $package == "flex" ]]' block pushes "bison" onto the
    # the dependency_pkg stack, resulting in the recursive call 'find_or_install bison'

    # Every branch that discovers an acceptable pre-existing installation must set the
    # YACC environment variable. Every branch must also manage the dependency stack.

    if [[ "$script_installed_package" == true ]]; then
      echo -e "$this_script: Using the $package executable $executable installed by $this_script\n"
      export YACC=$default_package_install_path/bin/yacc
      # Remove bison from the dependency stack
      stack_pop dependency_pkg package_done
      stack_pop dependency_exe executable_done
      stack_pop dependency_path package_done_path
      # Put $package onto the script_installed log
      stack_push script_installed package_done
      stack_push script_installed executable_done
      stack_push script_installed package_done_path
      # Halt the recursion and signal that there are no prerequisites to build
      stack_push dependency_pkg "none"
      stack_push dependency_exe "none"
      stack_push dependency_path "none"

    elif [[ "$package_in_path" == "true" ]]; then
      echo -e "$this_script: Checking whether $package executable $executable in PATH is version < $minimum_version... "
      if ! ./check_version.sh "$package" "$(./build.sh -V "$package")"; then
        printf "yes.\n"
        export YACC="$default_package_install_path/bin/$executable"
        # Trigger 'find_or_install m4' and subsequent build of $package
        stack_push dependency_pkg "m4"
        stack_push dependency_exe "m4"
        stack_push dependency_path "$(./build.sh -P m4)"
      else
        printf "no.\n"
        echo -e "$this_script: Using the $package executable $executable found in the PATH.\n"
        YACC=yacc
        # Remove bison from the dependency stack
        stack_pop dependency_pkg package_done
        stack_pop dependency_exe executable_done
        stack_pop dependency_path package_done_path
        # Put $package onto the script_installed log
        stack_push script_installed package_done
        stack_push script_installed executable_done
        stack_push script_installed package_done_path
        # Halt the recursion and signal that there are no prerequisites to build
        stack_push dependency_pkg "none"
        stack_push dependency_exe "none"
        stack_push dependency_path "none"
      fi

    else # $package not in PATH and not yet installed by this script
      # Trigger 'find_or_install m4' and subsequent build of $package
      stack_push dependency_pkg "m4"
      stack_push dependency_exe "m4"
      stack_push dependency_path "$(./build.sh -P m4)"
    fi

  elif [[ $package == "m4" ]]; then

    # We arrive when the 'elif [[ $package == "bison" ]]' block pushes "m4" onto the
    # the dependency_pkg stack, resulting in the recursive call 'find_or_install m4'

    # Every branch that discovers an acceptable pre-existing installation must set the
    # M4 environment variable. Every branch must also manage the dependency stack.

    if [[ "$script_installed_package" == true ]]; then
      echo -e "$this_script: Using the $package executable $executable installed by $this_script\n"
      export M4=$default_package_install_path/bin/m4
      # Remove m4 from the dependency stack
      stack_pop dependency_pkg package_done
      stack_pop dependency_exe executable_done
      stack_pop dependency_path package_done_path
      # Put $package onto the script_installed log
      stack_push script_installed package_done
      stack_push script_installed executable_done
      stack_push script_installed package_done_path
      # Halt the recursion and signal that there are no prerequisites to build
      stack_push dependency_pkg "none"
      stack_push dependency_exe "none"
      stack_push dependency_path "none"

    elif [[ "$package_in_path" == "true" ]]; then
      echo -e "$this_script: Checking whether $package executable $executable in PATH is version < $minimum_version... "
      if ! ./check_version.sh "$package" "$(./build.sh -V "$package")"; then
        printf "yes.\n"
        export M4="$default_package_install_path/bin/m4"
        # Halt the recursion and signal that there are no prerequisites to build
        stack_push dependency_pkg "none"
        stack_push dependency_exe "none"
        stack_push dependency_path "none"
      else
        printf "no.\n"
        echo -e "$this_script: Using the $package executable $executable found in the PATH.\n"
        M4=m4
        # Remove m4 from the dependency stack
        stack_pop dependency_pkg package_done
        stack_pop dependency_exe executable_done
        stack_pop dependency_path package_done_path
        # Put $package onto the script_installed log
        stack_push script_installed package_done
        stack_push script_installed executable_done
        stack_push script_installed package_done_path
        # Halt the recursion and signal that there are no prerequisites to build
        stack_push dependency_pkg "none"
        stack_push dependency_exe "none"
        stack_push dependency_path "none"
      fi

    else # $package not in PATH and not yet installed by this script
      # Halt the recursion and signal that there are no prerequisites to build
      export M4="$default_package_install_path/bin/m4"
      stack_push dependency_pkg  "none"
      stack_push dependency_exe  "none"
      stack_push dependency_path "none"
    fi

  else
    if [[ -z "${package:-}" ]]; then
      echo -e "$this_script: empty package name passed to find_or_install function. [exit 50]\n"
      exit 50
    else
      echo -e "$this_script: unknown package name ($package) passed to find_or_install function. [exit 55]\n"
      exit 55
    fi
  fi

  echo "$this_script: Updated dependency stack (top to bottom = left to right):"
  stack_print dependency_pkg

  stack_size dependency_pkg num_stacked
  (( num_dependencies=num_stacked-1 )) || true

  if [[ $num_dependencies -lt 0 ]]; then
    emergency "The procedure named in the external call to find_or_install is not on the dependency stack. [exit 60]\n"

  elif [[ $num_dependencies -gt 0 ]]; then
    stack_pop  dependency_pkg  prerequisite_pkg
    stack_pop  dependency_exe  prerequisite_exe
    stack_pop  dependency_path prerequisite_path

    if [[ $prerequisite_pkg != "none" ]]; then
      stack_push dependency_pkg  "$prerequisite_pkg"
      stack_push dependency_exe  "$prerequisite_exe"
      stack_push dependency_path "$prerequisite_path"
      echo -e "$this_script: Building $package from source requires $prerequisite_pkg.\n"
      find_or_install "$prerequisite_pkg"
    fi
  fi

  echo "$this_script: Remaining $package dependency stack (top to bottom = left to right):"
  stack_print dependency_pkg

  stack_pop dependency_pkg package
  stack_pop dependency_exe executable
  stack_pop dependency_path default_package_install_path

  if [[ $package != "none" ]]; then

    export default_package_version=$(./build.sh -V "${package}")
    export package_version_to_install=${arg_I:-${default_package_version}}

    prefix_root="${prefix_root:-${default_package_install_path%${package}/${package_version_to_install}}}"

    if [[ ${package} == "gcc" ]]; then
      export package_directory_name="gnu"
    else
      export package_directory_name=${package}
    fi

    package_install_prefix="${prefix_root}/${package_directory_name}/${package_version_to_install}"

    if [[ "$package" == "$executable" ]]; then
      echo "$this_script: Ready to install $executable in $package_install_prefix"
    else
      echo "$this_script: Ready to install $package executable $executable in $package_install_prefix"
    fi


    if [[ "${arg_y}" == "${__flag_present}" ]]; then
      info "-y or --yes-to-all flag present. Proceeding with non-interactive build."
    else
      echo -e "$this_script: Ok to download (if necessary), build, and install $package from source? (Y/n) "
      read -r proceed_with_build

      if [[ "$proceed_with_build" == "n" || "$proceed_with_build" == "no" ]]; then
        printf "n\n"
        echo -e "$this_script: OpenCoarrays installation requires $package. Aborting. [exit 70]\n"
        exit 70
      else # permission granted to build
        printf "Y\n"
      fi
    fi

    # On OS X, CMake must be built with Apple LLVM gcc, which XCode command-line tools puts in /usr/bin
    if [[ $(uname) == "Darwin" && $package == "cmake"  ]]; then
      if [[ -x "/usr/bin/gcc" ]]; then
        CC=/usr/bin/gcc
      else
        echo -e "$this_script: OS X detected.  Please install XCode command-line tools and \n"
        echo -e "$this_script: ensure that /usr/bin/gcc exists and is executable. Aborting. [exit 75]\n"
        exit 75
      fi
    # Otherwise, if no CC has been defined yet, use the gcc in the user's PATH
    elif [[ -z "${CC:-}" ]]; then
      CC=gcc
    fi

    # On OS X, CMake must be built with Apple LLVM g++, which XCode command-line tools puts in /usr/bin
    if [[ $(uname) == "Darwin" && $package == "cmake"  ]]; then
      if [[ -x "/usr/bin/g++" ]]; then
        CXX=/usr/bin/g++
      else
        echo -e "$this_script: OS X detected.  Please install XCode command-line tools \n"
        echo -e "$this_script: and ensure that /usr/bin/g++ exists and is executable. Aborting. [exit 76]\n"
        exit 76
      fi
    # Otherwise, if no CXX has been defined yet, use the g++ in the user's PATH
    elif [[ -z "${CXX:-}" ]]; then
      CXX=g++
    fi

    # If no FC has been defined yet, use the gfortran in the user's PATH
    if [[ -z "${FC:-}" ]]; then
      FC=gfortran
    fi

    if [[ "${arg_y}" == "${__flag_present}" ]]; then
      yes_to_all="-y"
    fi

    if [[ "${arg_Z}" == "${__flag_present}" ]]; then
      bootstrap="-Z"
    fi

    echo -e "$this_script: Downloading, building, and installing $package \n"
    echo "$this_script: Build command: FC=$FC CC=$CC CXX=$CXX ./build.sh -p $package -i $package_install_prefix -j $num_threads ${yes_to_all:-} ${bootstrap:-}"

    FC="$FC" CC="$CC" CXX="$CXX" ./build.sh -p "$package" -i "$package_install_prefix" -j "$num_threads" "${yes_to_all:-}" "${bootstrap:-}"

    if [[ ! -x "$package_install_prefix/bin/$executable" ]]; then

      echo -e "$this_script: Installation unsuccessful. "
      emergency "$executable is not in the path ($package_install_prefix/bin) or the user lacks executable permission."

    else
      echo -e "$this_script: Installation successful.\n"
      if [[ "$package" == "$executable" ]]; then
        echo -e "$this_script: $executable is in $package_install_prefix/bin \n"
      else
        echo -e "$this_script: $package executable $executable is in $package_install_prefix/bin \n"
      fi

      if [[ $package == "cmake" ]]; then
        echo "$this_script: export CMAKE=$package_install_prefix/bin/$executable"
                            export CMAKE="$package_install_prefix/bin/$executable"
      elif [[ $package == "bison" ]]; then
        echo "$this_script: export YACC=$package_install_prefix/bin/$executable"
                            export YACC="$package_install_prefix/bin/$executable"
      elif [[ $package == "flex" ]]; then
        echo "$this_script: export FLEX=$package_install_prefix/bin/$executable"
                            export FLEX="$package_install_prefix/bin/$executable"
      elif [[ $package == "m4" ]]; then
        echo "$this_script: export M4=$package_install_prefix/bin/$executable"
                            export M4="$package_install_prefix/bin/$executable"
      elif [[ $package == "gcc" ]]; then
        echo "$this_script: export FC=$package_install_prefix/bin/gfortran"
                            export FC="$package_install_prefix/bin/gfortran"
        echo "$this_script: export CC=$package_install_prefix/bin/gcc"
                            export CC="$package_install_prefix/bin/gcc"
        echo "$this_script: export CXX=$package_install_prefix/bin/g++"
                            export CXX="$package_install_prefix/bin/g++"
        gfortran_lib_paths="$package_install_prefix/lib64/:$package_install_prefix/lib"
        if [[ -z "${LD_LIBRARY_PATH:-}" ]]; then
          export LD_LIBRARY_PATH="$gfortran_lib_paths"
          else
            export LD_LIBRARY_PATH="$gfortran_lib_paths:$LD_LIBRARY_PATH"
          fi
        elif [[ $package == "mpich" ]]; then
          echo "$this_script: export MPIFC=$package_install_prefix/bin/mpifort"
                              export MPIFC="$package_install_prefix/bin/mpifort"
          echo "$this_script: export MPICC= $package_install_prefix/bin/mpicc"
                              export MPICC="$package_install_prefix/bin/mpicc"
          echo "$this_script: export MPICXX=$package_install_prefix/bin/mpicxx"
                              export MPICXX="$package_install_prefix/bin/mpicxx"
        else
          echo -e "$this_script: WARNING: $package executable $executable installed correctly but the \n"
          echo -e "$this_script:          corresponding environment variable(s) have not been set. This \n"
          echo -e "$this_script:          could prevent a complete build of OpenCoarrays. Please report this\n"
          echo -e "$this_script:          issue at https://github.com/sourceryinstitute/opencoarrays/issues\n"
        fi
        if [[ -z "${PATH:-}" ]]; then
          export PATH="$package_install_prefix/bin"
        else
          export PATH="$package_install_prefix/bin:$PATH"
        fi
      fi
    fi # End 'if [[ ! -x "$package_install_prefix/bin/$executable" ]]; then'
}

# shellcheck shell=bash
# If -p, -D, -P, or -V specifies a package, set package_url
# If -U specifies a package, print the package_url and exit with normal status
# shellcheck disable=SC2154
set_or_print_url()
{
  # Verify requirements
  [[ -n "${arg_U}" && -n "${arg_D:-${arg_p:-${arg_P:-${arg_V}}}}" ]] &&
    emergency "Please pass only one of {-B, -D, -p, -P, -U, -V} or a longer equivalent (multiple detected)."

  # Get package name from argument passed with  -p, -D, -P, -V, or -U
  package_to_build="${arg_p:-${arg_D:-${arg_P:-${arg_U:-${arg_V}}}}}"

if [[ -n "${arg_u:-}"  ]]; then
  # User specified a URL from which to download the package
  url_tail="${arg_u##*/}" # set url_tail to text_after_final_slash, greedy expansion needed
  url_head="${arg_u%${url_tail}}" # set url_head text before url_tail
else

  if [[ "${package_to_build}" == 'cmake' ]]; then
    major_minor="${version_to_build%.*}"
  fi
  package_url_head=(
    "gcc;https://ftp.gnu.org/gnu/gcc/gcc-${version_to_build-}/"
    "wget;https://ftpmirror.gnu.org/gnu/wget/"
    "m4;https://ftpmirror.gnu.org/gnu/m4/"
    "pkg-config;https://pkgconfig.freedesktop.org/releases/"
    "mpich;https://www.mpich.org/static/downloads/${version_to_build-}/"
    "flex;https://sourceforge.net/projects/flex/files/"
    "make;https://ftpmirror.gnu.org/gnu/make/"
    "bison;https://ftpmirror.gnu.org/gnu/bison/"
    "cmake;https://www.cmake.org/files/v${major_minor:-}/"
    "subversion;https://www.eu.apache.org/dist/subversion/"
  )
  for package in "${package_url_head[@]}" ; do
     KEY="${package%%;*}"
     VALUE="${package##*;}"
     info "KEY=${KEY}  VALUE=${VALUE}"

     if [[ "${package_to_build}" == "${KEY}" ]]; then
       # We recognize the package name so we set the URL head:
       url_head="${VALUE}"
       break
     fi
  done

  if [[ ! -z ${arg_b:-} && ${package_to_build} == 'gcc' ]]; then
    url_head="https://gcc.gnu.org/git/"
  fi

  # Set differing tails for GCC release downloads versus development branch checkouts
  package_url_tail=(
    "gcc;gcc-${version_to_build-}.tar.gz"
    "wget;wget-${version_to_build-}.tar.gz"
    "m4;m4-${version_to_build-}.tar.bz2"
    "pkg-config;pkg-config-${version_to_build-}.tar.gz"
    "mpich;mpich-${version_to_build-}.tar.gz"
    "flex;flex-${version_to_build-}.tar.bz2"
    "bison;bison-${version_to_build-}.tar.gz"
    "make;make-${version_to_build-}.tar.bz2"
    "subversion;subversion-${version_to_build-}.tar.gz"
  )
  if [[ $(uname) == "Linux" ]]; then
    package_url_tail+=("cmake;cmake-${version_to_build}-Linux-x86_64.sh")
  else
    package_url_tail+=("cmake;cmake-${version_to_build-}.tar.gz")
  fi
  for package in "${package_url_tail[@]}" ; do
     KEY="${package%%;*}"
     VALUE="${package##*;}"
     if [[ "${package_to_build}" == "${KEY}" ]]; then
       # We recognize the package name so we set the URL tail:
       url_tail="${VALUE}"
       break
     fi
  done

  if [[ ! -z ${arg_b:-} && ${package_to_build} == 'gcc' ]]; then
    url_tail="gcc"
  fi

  if [[ -z "${url_head:-}" || -z "${url_tail}" ]]; then
    emergency "Package ${package_name:-} not recognized.  Use --l or --list-packages to list the allowable names."
  fi

fi # end if [[ -n "${arg_u:-}"  ]]; then

  package_url="${url_head}""${url_tail}"

  # If a printout of the package URL was requested, then print it and exit with normal status
  if [[ -n "${arg_U:-}" ]]; then
    printf "%s\n" "${package_url}"
    exit 0
  fi
}

# shellcheck shell=bash disable=SC2154,SC2148
print_header() {
  pushd "${__dir}" >/dev/null
  local gccver mpichver cmakever flexver bisonver m4ver
  gccver="$("${__file}" -V gcc)"
  mpichver="$("${__file}" -V mpich)"
  cmakever="$("${__file}" -V cmake)"
  flexver="$("${__file}" -V flex)"
  bisonver="$("${__file}" -V bison)"
  m4ver="$("${__file}" -V m4)"
  popd >/dev/null
  clear
  echo "__________ Please read these instructions carefully before proceeding. ___________"
  echo "__________________________________________________________________________________"
  echo "*** Most end users will find it easier to install OpenCoarrays via the native  ***"
  echo "*** package manager for the target operating system.  Advanced developers will ***"
  echo "*** find it best to install via CMake.  Please see the OpenCoarrays README.md  ***"
  echo "*** for a list of supported package installers or for instructions on using    ***"
  echo "*** CMake to install.  The current script offers a fallback when other methods ***"
  echo "*** prove infeasible. This script builds any missing prerequisites from source ***"
  echo "*** and then builds OpenCoarrays from source.  The process might take a few    ***"
  echo "*** minutes if the script finds all prerequisites or several hours if the      ***"
  echo "*** script finds no prerequisites. (Run './install.sh --help' without quotes   ***"
  echo "*** to see the installation options.)  This script traverses the following     ***"
  echo "*** dependency tree and asks permission to install packages that are not in    ***"
  echo "*** your PATH, not in the prerequisites/installations subdirectory of the      ***"
  echo "*** OpenCoarrays source tree, or have insufficiently recent version numbers:   ***"
  echo ""
  # Generate the following text using the `tree` command w/ dummy directory structure
  cat <<-EOF
    opencoarrays
    |__ cmake-${cmakever}
    |__ mpich-${mpichver}
        |__ gcc-${gccver}
            |__ flex-${flexver}
            |   |__ bison-${bisonver}
            |       |__ m4-${m4ver}
            |__ gmp
            |__ mpc
            |__ mpfr

EOF
  echo "*** For a non-interactive installation, relaunch this script with the command  ***"
  echo "*** './install.sh --yes-to-all' without quotes to instruct the script to       ***"
  echo "*** assume affirmative answers to all user queries.                            ***"
  echo ""
  printf "%s will be installed in %s\n" "${arg_p}" "${prefix_root:-${install_path}}"
  echo ""
  if [[ "${arg_y}" == "${__flag_present}" ]]; then
    info "-y or --yes-to-all flag present. Proceeding with non-interactive build."
  else
    printf "Ready to rock and roll? (Y/n)"
    read -r install_now
    printf '%s\n' "${install_now}"
    if [[ "${install_now}" == "n" || "${install_now}" == "no" ]]; then
      emergency "${this_script}: Aborting. [exit 85]"
    fi
  fi
}

[This document is formatted with GitHub-Flavored Markdown.              ]:#
[For better viewing, including hyperlinks, read it online at            ]:#
[https://github.com/sourceryinstitute/OpenCoarrays/blob/master/CAF_API.md]:#

OpenCoarrays Application Binary Interface (ABI)
===============================================

[![Download as PDF][pdf img]](http://md2pdf.herokuapp.com/sourceryinstitute/OpenCoarrays/blob/master/CAF_ABI.pdf)

Download this file as a PDF document
[here](http://md2pdf.herokuapp.com/sourceryinstitute/OpenCoarrays/blob/master/CAF_ABI.pdf).

* [To Do](#to-do)
* [Implementation status](#implementation-status)
* [Definitions and types](#definitions-and-types)
* [Provided functions](#provided-functions)

This document describes the OpenCoarrays application binary interface (ABI) through
which a compiler accesses coarray functionality.  As such, the target audience for
this document is compiler developers.  Most application developers need only write
standard-conforming Fortran 2008 or 2015 and compile their code with the OpenCoarrays
`caf` compiler wrapper without knowledge of the ABI.

The actual function names in this document have a PREFIX in the source code to avoid
name clashes.  The prefix can be vendor-specific.

### Warning ###

*This document may be out of date.*

To Do
-----

* [ ] Discuss the current draft
* [ ] Add missing functions of the current gfortran implementation
* [ ] Address the TODO items
* [ ] Extend the functions to match a sensible set
* [ ] Update the implementation status, especially for the ARMCI library

Implementation status
---------------------

The library implementation in this directory should be ABI-compatible
with the wording below, except for some `int errmsg_len` vs. `size_t`
changes that have not yet been implemented.

Definitions and types
---------------------

### 2.1  `caf_token_t` ###

Typedef of type `void *` on the compiler side. Can be any data
type on the library side.

### 2.2  `caf_register_t` ###

Type indicating which kind of coarray variable should be registered.

```c
typedef enum caf_register_t {
  CAF_REGTYPE_COARRAY_STATIC,
  CAF_REGTYPE_COARRAY_ALLOC,
  CAF_REGTYPE_LOCK_STATIC,
  CAF_REGTYPE_LOCK_ALLOC,
  CAF_REGTYPE_CRITICAL,
  CAF_REGTYPE_EVENT_STATIC,
  CAF_REGTYPE_EVENT_ALLOC
  }
caf_register_t;
```

__TODO__:
  Check whether this set is complete and makes sense


### 2.3  `caf_token_t` ###

In terms of the processor, an opaque pointer, which is used to identify a
coarray.  The exact content is implementation-defined by the library.

### 2.4  Stat values ###

```c
#define STAT_UNLOCKED           0
#define STAT_LOCKED             1
#define STAT_LOCKED_OTHER_IMAGE 2
#define STAT_STOPPED_IMAGE      6000
```

__TODO__:
  Define more, allow room for lib-specific values, update for [TS18508].
  Do we need to take care of special vendor choices?

__Note__:
  Some values have to be such that they differ from certain other
  values.


Provided functions
------------------

### 3.1  Initialization function ###

```c
void caf_init (int *argc, char ***argv)
```

This function shall be called at startup of the program before the Fortran main
program.  It takes as arguments the command-line arguments of the program. It is
permitted to pass to NULL pointers as argument; if non-NULL, the library is
permitted to modify the arguments.

| Argument	| `intent`	| description	|
| ------	| ------	| ------	|
| `argc`	| `inout`	| An integer pointer with the number of arguments passed to the program or NULL.	|
| `argv`	| `inout`	| A pointer to an array of strings with the      command-line arguments or NULL.	|

__Note__:
  The function is modeled after the initialization function of the
  Message Passing Interface (MPI) specification.  Due to the way coarray
  registration (3.5) works, it might not be the first call to the libaray. If
  the main program is not written in Fortran and only a library uses coarrays,
  it can happen that this function is never called.  Therefore, it is
  recommended that the library does not rely on the passed arguments and whether
  the call has been done.

__GCC__:
  In gfortran, the function is generated when the Fortran main program is
  compiled with -fcoarray=lib; the call happens before the run-time library
  initialiation such that changes to the command-line arguments will be visible
  when the command-line intrinsics are invoked.


### 3.2  Finalization function ###

```c
void caf_finish (void)
```

This function shall be called at the end of the program to permit a graceful
shutdown.

__Note__:
  It is recommended to add this call at the end of the Fortran main program and
  when invoking `STOP`.  To ensure that the shutdown is also performed for
  programs where this function is not explicitly invoked, for instance
  non-Fortran programs or calls to the system's `exit()` function, the library can
  use a destructor function.  Note that programs can also be terminated using
  the `ERROR STOP` statement, which is handled via its own library call.

__GCC__:
  In gfortran, this function is called at the end of the Fortran main program and
  when before the program stops with a `STOP` command, the respective file has been
  compiled with the `-fcoarray=lib` option.


### 3.3 Querying the image number ###

```c
int caf_this_image (int distance)
```

This function returns the current image number, which is a positive number.

| Argument	| description	|
| ------	| ------	|
| `distance`	| As specified for the `this_image` intrinsic in [TS18508]. Shall be a nonnegative number.	|

__Note__:
  If the Fortran intrinsic `this_image()` is invoked without an argument, which is the only permitted form in Fortran 2008, the processor shall pass 0 as first argument.

__GCC__:
  (No special note.)



### 3.4 Querying the maximal number of images ###

```c
int caf_num_images (int distance, int failed)
```

This function returns the number of images in the current team, if distance is 0
or the number of images in the parent team at the specified distance. If failed
is -1, the function returns the number of all images at the specified
distance; if it is 0, the function returns the number of non-failed images, and
if it is 1, it returns the number of failed images.

| Argument	| description	|
| ------	| ------	|
| `distance`	| the distance from this image to the ancestor. Shall be positive.	|
| `failed`	| shall be -1, 0, or 1	|

__Note__:
  This function follows [TS18508]. If the `num_image` intrinsic has no arguments,
  the processor shall pass `distance = 0` and `failed = -1` to the function.

__GCC__:
  (No special note.)



### 3.5 Registering coarrays ###

```c
void *caf_register (size_t size, caf_register_t type, caf_token_t *token, int *stat, char *errmsg, int errmsg_len)
```

Allocates memory for a coarray and creates a token to identify the coarray. The
function is called for both coarrays with `SAVE` attribute and using an explicit
`ALLOCATE` statement. If an error occurs and `STAT` is a `NULL` pointer, the function
shall abort with printing an error message and starting the error termination.
If no error occurs and `STAT=` is present, it shall be set to zero. Otherwise, it
shall be set to a positive value and, if not-@code{NULL}, @var{ERRMSG} shall be
set to a string describing the failure.  The function returns a pointer to the
requested memory for the local image as a call to `malloc` would do.

For `CAF_REGTYPE_COARRAY_STATIC` and `CAF_REGTYPE_COARRAY_ALLOC`, the passed size is
the byte size requested. For `CAF_REGTYPE_LOCK_STATIC`, `CAF_REGTYPE_LOCK_ALLOC`
and `CAF_REGTYPE_CRITICAL` it is the array size or one for a scalar.

| Argument	| description	|
| ------	| ------	|
| `size`	| For normal coarrays, the byte size of the coarray to be allocated; for lock types, the number of elements.	|
| `type`	| one of the `caf_register_t` types. Possible values: `CAF_REGTYPE_COARRAY_STATIC` - for nonallocatable coarrays `CAF_REGTYPE_COARRAY_ALLOC` - for allocatable coarrays `CAF_REGTYPE_LOCK_STATIC` - for nonallocatable lock variables `CAF_REGTYPE_LOCK_ALLOC` - for allocatable lock variables `CAF_REGTYPE_CRITICAL` - for lock variables used for critical sections	|
| `token`	| `intent(out)` An opaque pointer identifying the coarray.	|
| `stat`	| `intent(out)` For allocatable coarrays, stores the `STAT=`; may be `NULL`	|
| `errmsg`	| intent(out) When an error occurs, this will be set to an error message; may be `NULL`	|
| `errmgs_len`	| the buffer size of errmsg.	|

__TODO__:

  - [ ] Check whether the locking should be handled like that and whether one needs
  more, e.g. for locking types in DT?
  - [ ] Check whether one needs an additional function for to register coarrays
  which are in static memory and used without memory allocation, i.e. just to
  register the address.
  - [ ] Check whether we need an explicit `SYNC ALL` at the beginning of the main
  program or whether we can do without.
  - [ ] Does [TS18508] require more for `SAVE` within teams or within blocks?

__Note__:
  Non-allocatable coarrays have to be registered prior use from remote images.
  In order to guarantee this, they have to be registered before the main
  program. This can be achieved by creating constructor functions.  When using
  `caf_register`, also non-allocatable coarrays the memory is allocated and no
  static memory is used.

  For normal coarrays, the returned pointer is used for accesses on the local
  image. For lock types, the value shall only used for checking the allocation
  status. Note that for critical blocks, the locking is only required on one
  image; in the locking statement, the processor shall always pass always an
  image index of one for critical-section lock variables (`CAF_REGTYPE_CRITICAL`).

__GCC__:
   (no special notes)

__TODO__:
   Change `errmsg_len` to `size_t`



### 3.6  Deregistering coarrays ###

```c
void caf_deregister (const caf_token_t *token, int *stat, char *errmsg, size_t errmsg_len)
```

Called to free the memory of a coarray; the processor calls this function for
automatic and explicit deallocation.  In case of an error, this function shall
fail with an error message, unless the `STAT=` variable is not null.

| Argument	| `intent`	| description	|
| ------	| ------	| -----	|
| `token`	| `inout`	| An opaque pointer identifying the coarray.	|
| `stat`	| `out`	| For allocatable coarrays, stores the `STAT=`; may be `NULL`	|
| `errmsg`	| `out`	| When an error occurs, this will be set to an error message, may be `NULL`	|
| `errmgs_len`	| | the buffersize of `errmsg`.	|

__Note__:
  The implementation is permitted to set the token to `NULL`. However, it is not required to do so.
  For nonalloatable coarrays this function is never called.  If a cleanup is required, it has to be handled via the finish, stop and error stop functions, and via destructors.

__GCC__:
   (no special notes)

__TODO__:
   Change `errmsg_len` to `size_t`


### 3.7  Sending data from a local image to a remote image ###

```c
void caf_send (caf_token_t token, size_t offset, int image_index,
               gfc_descriptor_t *dest, caf_vector_t *dst_vector,
               gfc_descriptor_t *src, int dst_kind, int src_kind)
```

Called to send a scalar, an array section or whole array from a local
to a remote image identified by the `image_index`.

| Argument	| description	|
| ------	| ------	|
| `token`	| `intent(in)`  An opaque pointer identifying the coarray.	|
| `offset`	| By which amount of bytes the actual data is shifted compared to the base address of the coarray.	|
| `image_index`	| The ID of the remote image; must be a positive number.	|
| `dest`	| `intent(in)` Array descriptor for the remote image for the bounds and the size. The `base_addr` shall not be accessed.	|
| `dst_vector`	| `intent(in)`  If not `NULL`, it contains the vector subscript of the destination array; the values are relative to the dimension triplet of the dest argument.	|
| `src`	| `intent(in)` Array descriptor of the local array to be transferred to the remote image	|
| `dst_kind`	| Kind of the destination argument	|
| `src_kind`	| Kind of the source argument	|

__Note__:
  It is permitted to have `image_id` equal the current image; the memory of the
  send-to and the send-from might (partially) overlap in that case. The
  implementation has to take care that it handles this case. Note that the
  assignment of a scalar to an array is permitted. In addition, the library has
  to handle numeric-type conversion and for strings, padding and different
  `character` kinds.

__GCC__:
  Currently, it uses gfortran's private array descriptor. A change to [TS29113]'s
  array descriptor is planned; when that's done, the additional kind arguments
  will be removed.
  Note that the kind arguments permit to distiniguish the `character` kinds and
  `real`/`complex` kinds 10 and 16, which have the same byte size.


__TODO__ `FOR SEND*`:

  - [ ] Wait is missing
  - [ ] Assignment to an address instead of using a token, to handle
    `caf[i]%allocatable%alloc_array(:,:) = ...`
    Or some other means to handle those.
  - [ ] Image index: How to handle references to other TEAMS?

__OTHER TODOs__:

- [ ] 3.x TODO: Handle `GET` and remote-to-remote communication
- [ ] 3.y TODO: Handle `ATOMIC`, `LOCK`, `CRITICAL`
- [ ] 3.z TODO Teams and error recovery

### 3.8  Getting data from a remote image ###

```c
void caf_get_desc (caf_token_t token, size_t offset,
                   int image_index, gfc_descriptor_t *src,
                   caf_vector_t *src_vector, gfc_descriptor_t *dest,
                   int src_kind, int dst_kind)
```

Called to get an array section or whole array from a a remote,
image identified by the `image_index`.

| Argument	| description	|
| ------	| ------	|
| `token`	| `intent(in)` An opaque pointer identifying the coarray.	|
| `offset`	| By which amount of bytes the actual data is shifted compared to the base address of the coarray.	|
| `image_index`	| The ID of the remote image; must be a positive number.	|
| `dest`	| `intent(out)` Array descriptor of the local array to which the data will be transferred	|
| `src`	| `intent(in)` Array descriptor for the remote image for the bounds and the size. The `base_addr` shall not be accessed.
| `src_vector`	| `intent(int)` If not `NULL`, it contains the vector subscript of the destination array; the values are relative to the dimension triplet of the dest argument.	|
| `dst_kind`	| Kind of the destination argument	|
| `src_kind`	| Kind of the source argument	|

__Note__:
  It is permitted to have `image_id` equal the current image; the memory of the
  send-to and the send-from might (partially) overlap in that case. The
  implementation has to take care that it handles this case. Note that the
  library has to handle numeric-type conversion and for strings, padding
  and different `character` kinds.

__GCC__:
  Currently, it uses gfortran's private array descriptor. A change to [TS29113]'s
  array descriptor is planned; when that's done, the additional kind arguments
  will be removed.
  Note that the kind arguments permit to distinguish the `character` kinds and
  `real`/`complex` kinds 10 and 16, which have the same byte size.


### 3.9  Sending data between remote images ###

```c
void caf_sendget (caf_token_t dst_token, size_t dst_offset,
                  int dst_image_index, gfc_descriptor_t *dest,
                  caf_vector_t *dst_vector, caf_token_t src_token,
                  size_t src_offset, int src_image_index,
                  gfc_descriptor_t *src, caf_vector_t *src_vector,
                  int dst_kind, int src_kind)
```

Called to send a scalar, an array section or whole array from a remote image
identified by the `src_image_index` to a remote image identified by the
`dst_image_index`.

| Argument	| description	|
| ------	| ------	|
| `dst_token`	| `intent(in)`  An opaque pointer identifying the destination coarray.	|
| `dst_offset`	| By which amount of bytes the actual data is shifted compared to the base address of the destination coarray.	|
| `dst_image_index`	| The ID of the destination remote image; must be a positive number.	|
| `dest`	| `intent(in)` Array descriptor for the destination remote image for the bounds and the size. The `base_addr` shall not be accessed.	|
| `dst_vector`	| `intent(int)`  If not NULL, it contains the vector subscript of the destination array; the values are relative to the dimension triplet of the dest argument.	|
| `src_token`	| `intent(in)` An opaque pointer identifying the source coarray.	|
| `src_offset`	| By which amount of bytes the actual data is shifted compared to the base address of the source coarray.	|
| `src_image_index`	| The ID of the source remote image; must be a positive number.	|
| `src`	| `intent(in)` Array descriptor of the local array to be transferred to the remote image	|
| `src_vector`	| `intent(in)` Array descriptor of the local array to be transferred to the remote image	|
| `dst_kind`	| Kind of the destination argument	|
| `src_kind`	| Kind of the source argument	|

__Note__:
  It is permitted to have `image_id` equal the current image; the memory of the
  send-to and the send-from might (partially) overlap in that case. The
  implementation has to take care that it handles this case. Note that the
  assignment of a scalar to an array is permitted. In addition, the library has
  to handle numeric-type conversion and for strings, padding and different
  `character` kinds.

__GCC__:
  Currently, it uses gfortran's private array descriptor. A change to [TS29113]'s
  array descriptor is planned; when that's done, the additional kind arguments
  will be removed.
  Note that the kind arguments permit to distinguish the `character` kinds and
  `real`/`complex` kinds 10 and 16, which have the same byte size.



### 3.10  Barriers ###

### 3.10.1  All-Image Barrier ###

```c
void caf_sync_all (int *stat, char *errmsg, size_t errmsg_len)
```

Barrier which waits for all other images, pending asynchronous communication
and other data transfer.

| Argument	| description	|
| ------	| ------	|
| `stat`	| Status variable, if `NULL`, failures are fatal. If non-null, assigned 0 on success, and a stat code (cf. 2.3) in case of an error.	|
| `errmsg`	| If not NULL: Ignored unless stat is present; unmodified when successful, otherwise, an error message is copied into the variable.	|
| `errmsg_len`	| Maximal length of the error string, which is not '\0' terminated. The string should be padded by blanks.	|

__Note__:
  For portability, consider only using 7bit ASCII characters in the error
  message.

__GCC__:
  Implemented in GCC 4.x using an int argument for the length.
  Currently, `size_t` is not implemented.



### 3.10.2  Barrier for Selected Images ###

```c
void sync_images (int count, int images[], int *stat,
                  char *errmsg, size_t errmsg_len)
```

| Argument	| description	|
| ------	| ------	|
| `count`	| Size of the array "images"; has value -1 for `sync images(*)` and value 0 for a zero-sized array.	|
| `image`	| list of images to be synced with.	|
| `stat`	| Status variable, if NULL, failures are fatal. If non-null, assigned 0 on success, and a stat code (cf. 2.3) in case of an error.	|
| `errmsg`	| If not `NULL`: Ignored unless stat is present; unmodified when successful, otherwise, an error message is copied into the variable.	|
| `errmsg_len`	| Maximal length of the error string, which is not `\0` terminated. The string should be padded by blanks.	|

__Note__:
  For portability, consider only using 7bit ASCII characters in the error
  message. Note that the list can contain also the ID of `this_image` or can be
  an empty set. Example use is that image 1 syncs with all others (i.e `sync images(*)`) and the others sync only with that image (`sync image(1)`). Or
  for point-to point communication (`sync image([left_image, right_image]`).

__GCC__:
  Implemented in GCC 4.x using an int argument for the error-string length.
  Currently, `size_t` is not implemented.

### 3.11  Error abort ###

```c
void error_stop_str (const char *string, int32_t str_len);
void error_stop (int32_t exit_error_code)
```

__TODO__

  - [ ] Fix this description by filling-in the missing bits
  - [ ] `STOP` vs `ERROR STOP` handling. Currently, `STOP` calls `finalize` and then the
    normal `STOP` while for `ERROR STOP` directly calls the library
  - [ ] F2008 requires that one prints the raised exceptions with `STOP` and `ERROR
    STOP`. libgfortran's `STOP` and `ERROR STOP` do so - the current implementation
    for `ERROR STOP` does not.


### 3.11  Locking and unlocking ###

#### 3.11.1  Locking a lock variable ####

```c
void caf_lock (caf_token_t token, size_t index, int image_index,
               int *aquired_lock, int *stat, char *errmsg,
               int errmsg_len)
```

Acquire a lock on the given image on a scalar locking variable or for the
given array element for an array-valued variable. If the `acquired_lock`
is `NULL`, the function return after having obtained the lock. If it is
non-null, the result is is assigned the value true (one) when the lock could be
obtained and false (zero) otherwise.  Locking a lock variable which has already
been locked by the same image is an error.

| Argument	| arguments	|
| ------	| ------	|
| `token`	| `intent(in)` An opaque pointer identifying the coarray.	|
| `index`	| Array index; first array index is 0. For scalars, it is always 0.	|
| `image_index`	| The ID of the remote image; must be a positive number.	|
| `aquired_lock`	| `intent(out)` If not NULL, it returns whether lock could be obtained	|
| `stat`	| `intent(out)` For allocatable coarrays, stores the `STAT=`; may be NULL	|
| `errmsg`	| intent(out) When an error occurs, this will be set to an error message; may be NULL	|
| `errmsg_len`	| the buffer size of errmsg.	|

__Note__:
  This function is also called for critical sections; for those, the array index
  is always zero and the image index is one.  Libraries are permitted to use other
  images for critical-section locking variables.

__GCC__:
   (no special notes)

__TODO__:
   Change `errmsg_len` to `size_t`


#### 3.11.2  Unlocking a lock variable ####

```c
void caf_unlock (caf_token_t token, size_t index, int image_index,
                 int *stat, char *errmsg, int errmsg_len)
```

Release a lock on the given image on a scalar locking variable or for the
given array element for an array-valued variable. Unlocking a lock variable
which is unlocked or has been locked by a different image is an error.

| Argument	| description	|
| ------	| ------	|
| `token`	| `intent(in)` An opaque pointer identifying the coarray.	|
| `index`	| Array index; first array index is 0. For scalars, it is always 0.	|
| `image_index`	| The ID of the remote image; must be a positive number.	|
| `stat`	| `intent(out)` For allocatable coarrays, stores the `STAT=`; may be `NULL`	|
| `errmsg`	| `intent(out)` When an error occurs, this will be set to an error message; may be `NULL`	|
| `errmsg_len`	| the buffer size of `errmsg`.	|

__Note__:
  This function is also called for critical sections; for those, the array index
  is always zero and the image index is one.  Libraries are permitted to use other
  images for critical-section locking variables.

__GCC__:
   (no special notes)

__TODO__:
   Change `errmsg_len` to `size_t`

---

[![GitHub forks](https://img.shields.io/github/forks/sourceryinstitute/OpenCoarrays.svg?style=social&label=Fork)](https://github.com/sourceryinstitute/OpenCoarrays/fork)
[![GitHub stars](https://img.shields.io/github/stars/sourceryinstitute/OpenCoarrays.svg?style=social&label=Star)](https://github.com/sourceryinstitute/OpenCoarrays)
[![GitHub watchers](https://img.shields.io/github/watchers/sourceryinstitute/OpenCoarrays.svg?style=social&label=Watch)](https://github.com/sourceryinstitute/OpenCoarrays)
[![Twitter URL](https://img.shields.io/twitter/url/http/shields.io.svg?style=social)](https://twitter.com/intent/tweet?hashtags=HPC,Fortran,PGAS&related=zbeekman,gnutools,HPCwire,HPC_Guru,hpcprogrammer,SciNetHPC,DegenerateConic,jeffdotscience,travisci&text=Stop%20programming%20w%2F%20the%20%23MPI%20docs%20in%20your%20lap%2C%20try%20Coarray%20Fortran%20w%2F%20OpenCoarrays%20%26%20GFortran!&url=https%3A//github.com/sourceryinstitute/OpenCoarrays)


[Hyperlinks]:#

[TS29113]: ftp://ftp.nag.co.uk/sc22wg5/n1901-n1950/n1942.pdf
[TS18508]: http://isotc.iso.org/livelink/livelink?func=ll&objId=17288706&objAction=Open
[To Do]: #to-do
[Implementation status]: #implementation-status
[Definitions and types]: #definitions-and-types
[Provided functions]: #provided-functions
[pdf img]: https://img.shields.io/badge/PDF-CAF_ABI.md-6C2DC7.svg?style=flat-square "Download as PDF"

<!-- Please fill out the pull request template included below, failure -->
<!-- to do so may result in immediate closure of your pull request. -->

<!-- Fill out all portions of this template that apply. Please delete -->
<!-- any unnecessary sections. -->

| Avg response time                 | coverage on master         |
| --------------------------------- | ---------------------------|
| ![Issue Stats][PR response img]   | ![Codecov branch][coverage]|

## Summary of changes ##

Summarize what you changed

## Rationale for changes ##

Why did you make these changes?

## Additional info and certifications ##

This pull request (PR) is a:
 - [ ] Bug fix
 - [ ] Feature addition
 - [ ] Other, Please describe:

I certify that:

 - [ ] I have reviewed the [contributing guidelines]
 - [ ] If this PR is a work in progress I have added `WIP:` to the
       beginning of the PR title
 - [ ] If this PR is problematic for any reason, I have added
       `DO NOT MERGE:` to the beginning of the title
 - [ ] The branch name and title of this PR contains the text
       `issue-<#>` where `<#>` is replaced by the issue that this PR
       is addressing
 - [ ] I have deleted trailing white space on any lines that this PR
       touches
 - [ ] I have used spaces for indentation on any lines that this PR
       touches
 - [ ] I have included some comments to explain non-obvious code
       changes
 - [ ] I have run the tests localy (`ctest`) and all tests pass
 - [ ] Each commit is a logically atomic, self-consistent, cohesive
       set of changes
 - [ ] The [commit message] should follow [these guidelines]:
     - [ ] First line is directive phrase, starting with a capitalized
           imperative verb, and is no longer than 50 characters
           summarizing your commit
     - [ ] Next line, if necessary is blank
     - [ ] Following lines are all wrapped at 72 characters and can
           include additional paragraphs, bulleted lists, etc.
     - [ ] Use [Github keywords] where appropriate, to indicate the
           commit resolves an open issue.
 - [ ] I have signed  [Contributor License Agreement (CLA)] by
       clicking the "details" link to the right of the `licence/cla`
       check and following the directions on the CLA assistant webpage
 - [ ] I have ensured that the test coverage hasn't gone down and added new [unit tests] to cover an new code added to the library


## For contributors and SI team members with code review priviledges ##

 - [ ] I certify that I will wait 24 hours before self-approving via
       [pullapprove comment] or [Github code review] so that someone
       else has the chance to review my proposed changes

[links]:#
[contributing guidelines]: https://github.com/sourceryinstitute/OpenCoarrays/blob/master/CONTRIBUTING.md
[commit message]: https://robots.thoughtbot.com/5-useful-tips-for-a-better-commit-message
[these guidelines]: http://tbaggery.com/2008/04/19/a-note-about-git-commit-messages.html
[Contributor License Agreement (CLA)]: https://cla-assistant.io/sourceryinstitute/OpenCoarrays
[pullapprove comment]: https://pullapprove.com/sourceryinstitute/OpenCoarrays/settings/
[Github code review]: https://help.github.com/articles/about-pull-request-reviews/
[Github keywords]: https://help.github.com/articles/closing-issues-via-commit-messages/
[unit tests]: https://github.com/sourceryinstitute/OpenCoarrays/tree/master/src/tests/unit
[PR response img]: https://img.shields.io/issuestats/p/github/sourceryinstitute/OpenCoarrays.svg?style=flat-square
[coverage]: https://img.shields.io/codecov/c/github/sourceryinstitute/OpenCoarrays/master.svg?style=flat-square

[This document is formatted with GitHub-Flavored Markdown.              ]:#
[For better viewing, including hyperlinks, read it online at            ]:#
[https://github.com/sourceryinstitute/OpenCoarrays/blob/master/CAF_API.md]:#

OpenCoarrays Application Binary Interface (ABI)
===============================================

[![Download as PDF][pdf img]](http://md2pdf.herokuapp.com/sourceryinstitute/OpenCoarrays/blob/master/CAF_ABI.pdf)

Download this file as a PDF document
[here](http://md2pdf.herokuapp.com/sourceryinstitute/OpenCoarrays/blob/master/CAF_ABI.pdf).

* [To Do](#to-do)
* [Implementation status](#implementation-status)
* [Definitions and types](#definitions-and-types)
* [Provided functions](#provided-functions)

This document describes the OpenCoarrays application binary interface (ABI) through
which a compiler accesses coarray functionality.  As such, the target audience for
this document is compiler developers.  Most application developers need only write
standard-conforming Fortran 2008 or 2018 and compile their code with the OpenCoarrays
`caf` compiler wrapper without knowledge of the ABI.

The actual function names in this document have a PREFIX in the source code to avoid
name clashes.  The prefix can be vendor-specific.

### Warning ###

*This document may be out of date.*

To Do
-----

* [ ] Discuss the current draft
* [ ] Add missing functions of the current gfortran implementation
* [ ] Address the TODO items
* [ ] Extend the functions to match a sensible set
* [ ] Update the implementation status, especially for the ARMCI library

Implementation status
---------------------

The library implementation in this directory should be ABI-compatible
with the wording below, except for some `int errmsg_len` vs. `size_t`
changes that have not yet been implemented.

Definitions and types
---------------------

### 2.1  `caf_token_t` ###

Typedef of type `void *` on the compiler side. Can be any data
type on the library side.

### 2.2  `caf_register_t` ###

Type indicating which kind of coarray variable should be registered.

```c
typedef enum caf_register_t {
  CAF_REGTYPE_COARRAY_STATIC,
  CAF_REGTYPE_COARRAY_ALLOC,
  CAF_REGTYPE_LOCK_STATIC,
  CAF_REGTYPE_LOCK_ALLOC,
  CAF_REGTYPE_CRITICAL,
  CAF_REGTYPE_EVENT_STATIC,
  CAF_REGTYPE_EVENT_ALLOC
  }
caf_register_t;
```

__TODO__:
  Check whether this set is complete and makes sense


### 2.3  `caf_token_t` ###

In terms of the processor, an opaque pointer, which is used to identify a
coarray.  The exact content is implementation-defined by the library.

### 2.4  Stat values ###

```c
#define STAT_UNLOCKED           0
#define STAT_LOCKED             1
#define STAT_LOCKED_OTHER_IMAGE 2
#define STAT_STOPPED_IMAGE      6000
```

__TODO__:
  Define more, allow room for lib-specific values, update for [TS18508].
  Do we need to take care of special vendor choices?

__Note__:
  Some values have to be such that they differ from certain other
  values.


Provided functions
------------------

### 3.1  Initialization function ###

```c
void caf_init (int *argc, char ***argv)
```

This function shall be called at startup of the program before the Fortran main
program.  It takes as arguments the command-line arguments of the program. It is
permitted to pass to NULL pointers as argument; if non-NULL, the library is
permitted to modify the arguments.

| Argument	| `intent`	| description	|
| ------	| ------	| ------	|
| `argc`	| `inout`	| An integer pointer with the number of arguments passed to the program or NULL.	|
| `argv`	| `inout`	| A pointer to an array of strings with the      command-line arguments or NULL.	|

__Note__:
  The function is modeled after the initialization function of the
  Message Passing Interface (MPI) specification.  Due to the way coarray
  registration (3.5) works, it might not be the first call to the libaray. If
  the main program is not written in Fortran and only a library uses coarrays,
  it can happen that this function is never called.  Therefore, it is
  recommended that the library does not rely on the passed arguments and whether
  the call has been done.

__GCC__:
  In gfortran, the function is generated when the Fortran main program is
  compiled with -fcoarray=lib; the call happens before the run-time library
  initialiation such that changes to the command-line arguments will be visible
  when the command-line intrinsics are invoked.


### 3.2  Finalization function ###

```c
void caf_finish (void)
```

This function shall be called at the end of the program to permit a graceful
shutdown.

__Note__:
  It is recommended to add this call at the end of the Fortran main program and
  when invoking `STOP`.  To ensure that the shutdown is also performed for
  programs where this function is not explicitly invoked, for instance
  non-Fortran programs or calls to the system's `exit()` function, the library can
  use a destructor function.  Note that programs can also be terminated using
  the `ERROR STOP` statement, which is handled via its own library call.

__GCC__:
  In gfortran, this function is called at the end of the Fortran main program and
  when before the program stops with a `STOP` command, the respective file has been
  compiled with the `-fcoarray=lib` option.


### 3.3 Querying the image number ###

```c
int caf_this_image (int distance)
```

This function returns the current image number, which is a positive number.

| Argument	| description	|
| ------	| ------	|
| `distance`	| As specified for the `this_image` intrinsic in [TS18508]. Shall be a nonnegative number.	|

__Note__:
  If the Fortran intrinsic `this_image()` is invoked without an argument, which is the only permitted form in Fortran 2008, the processor shall pass 0 as first argument.

__GCC__:
  (No special note.)



### 3.4 Querying the maximal number of images ###

```c
int caf_num_images (int distance, int failed)
```

This function returns the number of images in the current team, if distance is 0
or the number of images in the parent team at the specified distance. If failed
is -1, the function returns the number of all images at the specified
distance; if it is 0, the function returns the number of non-failed images, and
if it is 1, it returns the number of failed images.

| Argument	| description	|
| ------	| ------	|
| `distance`	| the distance from this image to the ancestor. Shall be positive.	|
| `failed`	| shall be -1, 0, or 1	|

__Note__:
  This function follows [TS18508]. If the `num_image` intrinsic has no arguments,
  the processor shall pass `distance = 0` and `failed = -1` to the function.

__GCC__:
  (No special note.)



### 3.5 Registering coarrays ###

```c
void *caf_register (size_t size, caf_register_t type, caf_token_t *token, int *stat, char *errmsg, int errmsg_len)
```

Allocates memory for a coarray and creates a token to identify the coarray. The
function is called for both coarrays with `SAVE` attribute and using an explicit
`ALLOCATE` statement. If an error occurs and `STAT` is a `NULL` pointer, the function
shall abort with printing an error message and starting the error termination.
If no error occurs and `STAT=` is present, it shall be set to zero. Otherwise, it
shall be set to a positive value and, if not-@code{NULL}, @var{ERRMSG} shall be
set to a string describing the failure.  The function returns a pointer to the
requested memory for the local image as a call to `malloc` would do.

For `CAF_REGTYPE_COARRAY_STATIC` and `CAF_REGTYPE_COARRAY_ALLOC`, the passed size is
the byte size requested. For `CAF_REGTYPE_LOCK_STATIC`, `CAF_REGTYPE_LOCK_ALLOC`
and `CAF_REGTYPE_CRITICAL` it is the array size or one for a scalar.

| Argument	| description	|
| ------	| ------	|
| `size`	| For normal coarrays, the byte size of the coarray to be allocated; for lock types, the number of elements.	|
| `type`	| one of the `caf_register_t` types. Possible values: `CAF_REGTYPE_COARRAY_STATIC` - for nonallocatable coarrays `CAF_REGTYPE_COARRAY_ALLOC` - for allocatable coarrays `CAF_REGTYPE_LOCK_STATIC` - for nonallocatable lock variables `CAF_REGTYPE_LOCK_ALLOC` - for allocatable lock variables `CAF_REGTYPE_CRITICAL` - for lock variables used for critical sections	|
| `token`	| `intent(out)` An opaque pointer identifying the coarray.	|
| `stat`	| `intent(out)` For allocatable coarrays, stores the `STAT=`; may be `NULL`	|
| `errmsg`	| intent(out) When an error occurs, this will be set to an error message; may be `NULL`	|
| `errmgs_len`	| the buffer size of errmsg.	|

__TODO__:

  - [ ] Check whether the locking should be handled like that and whether one needs
  more, e.g. for locking types in DT?
  - [ ] Check whether one needs an additional function for to register coarrays
  which are in static memory and used without memory allocation, i.e. just to
  register the address.
  - [ ] Check whether we need an explicit `SYNC ALL` at the beginning of the main
  program or whether we can do without.
  - [ ] Does [TS18508] require more for `SAVE` within teams or within blocks?

__Note__:
  Non-allocatable coarrays have to be registered prior use from remote images.
  In order to guarantee this, they have to be registered before the main
  program. This can be achieved by creating constructor functions.  When using
  `caf_register`, also non-allocatable coarrays the memory is allocated and no
  static memory is used.

  For normal coarrays, the returned pointer is used for accesses on the local
  image. For lock types, the value shall only used for checking the allocation
  status. Note that for critical blocks, the locking is only required on one
  image; in the locking statement, the processor shall always pass always an
  image index of one for critical-section lock variables (`CAF_REGTYPE_CRITICAL`).

__GCC__:
   (no special notes)

__TODO__:
   Change `errmsg_len` to `size_t`



### 3.6  Deregistering coarrays ###

```c
void caf_deregister (const caf_token_t *token, int *stat, char *errmsg, size_t errmsg_len)
```

Called to free the memory of a coarray; the processor calls this function for
automatic and explicit deallocation.  In case of an error, this function shall
fail with an error message, unless the `STAT=` variable is not null.

| Argument	| `intent`	| description	|
| ------	| ------	| -----	|
| `token`	| `inout`	| An opaque pointer identifying the coarray.	|
| `stat`	| `out`	| For allocatable coarrays, stores the `STAT=`; may be `NULL`	|
| `errmsg`	| `out`	| When an error occurs, this will be set to an error message, may be `NULL`	|
| `errmgs_len`	| | the buffersize of `errmsg`.	|

__Note__:
  The implementation is permitted to set the token to `NULL`. However, it is not required to do so.
  For nonalloatable coarrays this function is never called.  If a cleanup is required, it has to be handled via the finish, stop and error stop functions, and via destructors.

__GCC__:
   (no special notes)

__TODO__:
   Change `errmsg_len` to `size_t`


### 3.7  Sending data from a local image to a remote image ###

```c
void caf_send (caf_token_t token, size_t offset, int image_index,
               gfc_descriptor_t *dest, caf_vector_t *dst_vector,
               gfc_descriptor_t *src, int dst_kind, int src_kind)
```

Called to send a scalar, an array section or whole array from a local
to a remote image identified by the `image_index`.

| Argument	| description	|
| ------	| ------	|
| `token`	| `intent(in)`  An opaque pointer identifying the coarray.	|
| `offset`	| By which amount of bytes the actual data is shifted compared to the base address of the coarray.	|
| `image_index`	| The ID of the remote image; must be a positive number.	|
| `dest`	| `intent(in)` Array descriptor for the remote image for the bounds and the size. The `base_addr` shall not be accessed.	|
| `dst_vector`	| `intent(in)`  If not `NULL`, it contains the vector subscript of the destination array; the values are relative to the dimension triplet of the dest argument.	|
| `src`	| `intent(in)` Array descriptor of the local array to be transferred to the remote image	|
| `dst_kind`	| Kind of the destination argument	|
| `src_kind`	| Kind of the source argument	|

__Note__:
  It is permitted to have `image_id` equal the current image; the memory of the
  send-to and the send-from might (partially) overlap in that case. The
  implementation has to take care that it handles this case. Note that the
  assignment of a scalar to an array is permitted. In addition, the library has
  to handle numeric-type conversion and for strings, padding and different
  `character` kinds.

__GCC__:
  Currently, it uses gfortran's private array descriptor. A change to [TS29113]'s
  array descriptor is planned; when that's done, the additional kind arguments
  will be removed.
  Note that the kind arguments permit to distiniguish the `character` kinds and
  `real`/`complex` kinds 10 and 16, which have the same byte size.


__TODO__ `FOR SEND*`:

  - [ ] Wait is missing
  - [ ] Assignment to an address instead of using a token, to handle
    `caf[i]%allocatable%alloc_array(:,:) = ...`
    Or some other means to handle those.
  - [ ] Image index: How to handle references to other TEAMS?

__OTHER TODOs__:

- [ ] 3.x TODO: Handle `GET` and remote-to-remote communication
- [ ] 3.y TODO: Handle `ATOMIC`, `LOCK`, `CRITICAL`
- [ ] 3.z TODO Teams and error recovery

### 3.8  Getting data from a remote image ###

```c
void caf_get_desc (caf_token_t token, size_t offset,
                   int image_index, gfc_descriptor_t *src,
                   caf_vector_t *src_vector, gfc_descriptor_t *dest,
                   int src_kind, int dst_kind)
```

Called to get an array section or whole array from a a remote,
image identified by the `image_index`.

| Argument	| description	|
| ------	| ------	|
| `token`	| `intent(in)` An opaque pointer identifying the coarray.	|
| `offset`	| By which amount of bytes the actual data is shifted compared to the base address of the coarray.	|
| `image_index`	| The ID of the remote image; must be a positive number.	|
| `dest`	| `intent(out)` Array descriptor of the local array to which the data will be transferred	|
| `src`	| `intent(in)` Array descriptor for the remote image for the bounds and the size. The `base_addr` shall not be accessed.
| `src_vector`	| `intent(int)` If not `NULL`, it contains the vector subscript of the destination array; the values are relative to the dimension triplet of the dest argument.	|
| `dst_kind`	| Kind of the destination argument	|
| `src_kind`	| Kind of the source argument	|

__Note__:
  It is permitted to have `image_id` equal the current image; the memory of the
  send-to and the send-from might (partially) overlap in that case. The
  implementation has to take care that it handles this case. Note that the
  library has to handle numeric-type conversion and for strings, padding
  and different `character` kinds.

__GCC__:
  Currently, it uses gfortran's private array descriptor. A change to [TS29113]'s
  array descriptor is planned; when that's done, the additional kind arguments
  will be removed.
  Note that the kind arguments permit to distinguish the `character` kinds and
  `real`/`complex` kinds 10 and 16, which have the same byte size.


### 3.9  Sending data between remote images ###

```c
void caf_sendget (caf_token_t dst_token, size_t dst_offset,
                  int dst_image_index, gfc_descriptor_t *dest,
                  caf_vector_t *dst_vector, caf_token_t src_token,
                  size_t src_offset, int src_image_index,
                  gfc_descriptor_t *src, caf_vector_t *src_vector,
                  int dst_kind, int src_kind)
```

Called to send a scalar, an array section or whole array from a remote image
identified by the `src_image_index` to a remote image identified by the
`dst_image_index`.

| Argument	| description	|
| ------	| ------	|
| `dst_token`	| `intent(in)`  An opaque pointer identifying the destination coarray.	|
| `dst_offset`	| By which amount of bytes the actual data is shifted compared to the base address of the destination coarray.	|
| `dst_image_index`	| The ID of the destination remote image; must be a positive number.	|
| `dest`	| `intent(in)` Array descriptor for the destination remote image for the bounds and the size. The `base_addr` shall not be accessed.	|
| `dst_vector`	| `intent(int)`  If not NULL, it contains the vector subscript of the destination array; the values are relative to the dimension triplet of the dest argument.	|
| `src_token`	| `intent(in)` An opaque pointer identifying the source coarray.	|
| `src_offset`	| By which amount of bytes the actual data is shifted compared to the base address of the source coarray.	|
| `src_image_index`	| The ID of the source remote image; must be a positive number.	|
| `src`	| `intent(in)` Array descriptor of the local array to be transferred to the remote image	|
| `src_vector`	| `intent(in)` Array descriptor of the local array to be transferred to the remote image	|
| `dst_kind`	| Kind of the destination argument	|
| `src_kind`	| Kind of the source argument	|

__Note__:
  It is permitted to have `image_id` equal the current image; the memory of the
  send-to and the send-from might (partially) overlap in that case. The
  implementation has to take care that it handles this case. Note that the
  assignment of a scalar to an array is permitted. In addition, the library has
  to handle numeric-type conversion and for strings, padding and different
  `character` kinds.

__GCC__:
  Currently, it uses gfortran's private array descriptor. A change to [TS29113]'s
  array descriptor is planned; when that's done, the additional kind arguments
  will be removed.
  Note that the kind arguments permit to distinguish the `character` kinds and
  `real`/`complex` kinds 10 and 16, which have the same byte size.



### 3.10  Barriers ###

### 3.10.1  All-Image Barrier ###

```c
void caf_sync_all (int *stat, char *errmsg, size_t errmsg_len)
```

Barrier which waits for all other images, pending asynchronous communication
and other data transfer.

| Argument	| description	|
| ------	| ------	|
| `stat`	| Status variable, if `NULL`, failures are fatal. If non-null, assigned 0 on success, and a stat code (cf. 2.3) in case of an error.	|
| `errmsg`	| If not NULL: Ignored unless stat is present; unmodified when successful, otherwise, an error message is copied into the variable.	|
| `errmsg_len`	| Maximal length of the error string, which is not '\0' terminated. The string should be padded by blanks.	|

__Note__:
  For portability, consider only using 7bit ASCII characters in the error
  message.

__GCC__:
  Implemented in GCC 4.x using an int argument for the length.
  Currently, `size_t` is not implemented.



### 3.10.2  Barrier for Selected Images ###

```c
void sync_images (int count, int images[], int *stat,
                  char *errmsg, size_t errmsg_len)
```

| Argument	| description	|
| ------	| ------	|
| `count`	| Size of the array "images"; has value -1 for `sync images(*)` and value 0 for a zero-sized array.	|
| `image`	| list of images to be synced with.	|
| `stat`	| Status variable, if NULL, failures are fatal. If non-null, assigned 0 on success, and a stat code (cf. 2.3) in case of an error.	|
| `errmsg`	| If not `NULL`: Ignored unless stat is present; unmodified when successful, otherwise, an error message is copied into the variable.	|
| `errmsg_len`	| Maximal length of the error string, which is not `\0` terminated. The string should be padded by blanks.	|

__Note__:
  For portability, consider only using 7bit ASCII characters in the error
  message. Note that the list can contain also the ID of `this_image` or can be
  an empty set. Example use is that image 1 syncs with all others (i.e `sync images(*)`) and the others sync only with that image (`sync image(1)`). Or
  for point-to point communication (`sync image([left_image, right_image]`).

__GCC__:
  Implemented in GCC 4.x using an int argument for the error-string length.
  Currently, `size_t` is not implemented.

### 3.11  Error abort ###

```c
void error_stop_str (const char *string, int32_t str_len);
void error_stop (int32_t exit_error_code)
```

__TODO__

  - [ ] Fix this description by filling-in the missing bits
  - [ ] `STOP` vs `ERROR STOP` handling. Currently, `STOP` calls `finalize` and then the
    normal `STOP` while for `ERROR STOP` directly calls the library
  - [ ] F2008 requires that one prints the raised exceptions with `STOP` and `ERROR
    STOP`. libgfortran's `STOP` and `ERROR STOP` do so - the current implementation
    for `ERROR STOP` does not.


### 3.11  Locking and unlocking ###

#### 3.11.1  Locking a lock variable ####

```c
void caf_lock (caf_token_t token, size_t index, int image_index,
               int *aquired_lock, int *stat, char *errmsg,
               int errmsg_len)
```

Acquire a lock on the given image on a scalar locking variable or for the
given array element for an array-valued variable. If the `acquired_lock`
is `NULL`, the function return after having obtained the lock. If it is
non-null, the result is is assigned the value true (one) when the lock could be
obtained and false (zero) otherwise.  Locking a lock variable which has already
been locked by the same image is an error.

| Argument	| arguments	|
| ------	| ------	|
| `token`	| `intent(in)` An opaque pointer identifying the coarray.	|
| `index`	| Array index; first array index is 0. For scalars, it is always 0.	|
| `image_index`	| The ID of the remote image; must be a positive number.	|
| `aquired_lock`	| `intent(out)` If not NULL, it returns whether lock could be obtained	|
| `stat`	| `intent(out)` For allocatable coarrays, stores the `STAT=`; may be NULL	|
| `errmsg`	| intent(out) When an error occurs, this will be set to an error message; may be NULL	|
| `errmsg_len`	| the buffer size of errmsg.	|

__Note__:
  This function is also called for critical sections; for those, the array index
  is always zero and the image index is one.  Libraries are permitted to use other
  images for critical-section locking variables.

__GCC__:
   (no special notes)

__TODO__:
   Change `errmsg_len` to `size_t`


#### 3.11.2  Unlocking a lock variable ####

```c
void caf_unlock (caf_token_t token, size_t index, int image_index,
                 int *stat, char *errmsg, int errmsg_len)
```

Release a lock on the given image on a scalar locking variable or for the
given array element for an array-valued variable. Unlocking a lock variable
which is unlocked or has been locked by a different image is an error.

| Argument	| description	|
| ------	| ------	|
| `token`	| `intent(in)` An opaque pointer identifying the coarray.	|
| `index`	| Array index; first array index is 0. For scalars, it is always 0.	|
| `image_index`	| The ID of the remote image; must be a positive number.	|
| `stat`	| `intent(out)` For allocatable coarrays, stores the `STAT=`; may be `NULL`	|
| `errmsg`	| `intent(out)` When an error occurs, this will be set to an error message; may be `NULL`	|
| `errmsg_len`	| the buffer size of `errmsg`.	|

__Note__:
  This function is also called for critical sections; for those, the array index
  is always zero and the image index is one.  Libraries are permitted to use other
  images for critical-section locking variables.

__GCC__:
   (no special notes)

__TODO__:
   Change `errmsg_len` to `size_t`

---

[![GitHub forks](https://img.shields.io/github/forks/sourceryinstitute/OpenCoarrays.svg?style=social&label=Fork)](https://github.com/sourceryinstitute/OpenCoarrays/fork)
[![GitHub stars](https://img.shields.io/github/stars/sourceryinstitute/OpenCoarrays.svg?style=social&label=Star)](https://github.com/sourceryinstitute/OpenCoarrays)
[![GitHub watchers](https://img.shields.io/github/watchers/sourceryinstitute/OpenCoarrays.svg?style=social&label=Watch)](https://github.com/sourceryinstitute/OpenCoarrays)
[![Twitter URL](https://img.shields.io/twitter/url/http/shields.io.svg?style=social)](https://twitter.com/intent/tweet?hashtags=HPC,Fortran,PGAS&related=zbeekman,gnutools,HPCwire,HPC_Guru,hpcprogrammer,SciNetHPC,DegenerateConic,jeffdotscience,travisci&text=Stop%20programming%20w%2F%20the%20%23MPI%20docs%20in%20your%20lap%2C%20try%20Coarray%20Fortran%20w%2F%20OpenCoarrays%20%26%20GFortran!&url=https%3A//github.com/sourceryinstitute/OpenCoarrays)


[Hyperlinks]:#

[TS29113]: ftp://ftp.nag.co.uk/sc22wg5/n1901-n1950/n1942.pdf
[TS18508]: http://isotc.iso.org/livelink/livelink?func=ll&objId=17288706&objAction=Open
[To Do]: #to-do
[Implementation status]: #implementation-status
[Definitions and types]: #definitions-and-types
[Provided functions]: #provided-functions
[pdf img]: https://img.shields.io/badge/PDF-CAF_ABI.md-6C2DC7.svg?style=flat-square "Download as PDF"

<a name="top"> </a>

[This document is formatted with GitHub-Flavored Markdown.               ]:#
[For better viewing, including hyperlinks, read it online at             ]:#
[https://github.com/sourceryinstitute/opencoarrays/blob/master/INSTALL.md]:#

Installing OpenCoarrays
=======================

[![Download as PDF][pdf img]](http://md2pdf.herokuapp.com/sourceryinstitute/opencoarrays/blob/master/INSTALL.pdf)

Download this file as a PDF document
[here](http://md2pdf.herokuapp.com/sourceryinstitute/opencoarrays/blob/master/INSTALL.pdf).

 *  [End-User Installation]
     * [Installation Script]
     * [OS X]
     * [Windows]
     * [Linux]
 *  [Advanced Installation from Source]
     *  [Prerequisites]
     *  [CMake]
     *  [Make]
 *  [Obtaining GCC]

End-User Installation
---------------------

### Installation Script###

As of release 1.2.0, users might consider installing by downloading and uncompressing
a file from our [Releases] page and running the installation script in the top-level
source directory:

```
tar xvzf opencoarrays-x.y.z.tar.gz
cd opencoarrays
./install.sh
```

Before installing OpenCoarrays, the above bash script will attempt to detect the presence
of the default prequisite packages: [GCC], [MPICH] , and [CMake].  For additional details, see the [Prerequisites] section. If any of the
aforementioned packages appear to be absent from the user's PATH environment variable,
the [install.sh] script will attempt to download, build, and install any missing packages
after asking permission to do so.  The script has been tested on Linux and OS X.  Please
submit any related problems or questions to our [Issues] page.

A complete installation should result in the creation of the following directories
inside the installation path (.e.g, inside `build` in the above example):

* `bin`: contains the compiler wrapper (`caf`), program launcher (`cafun`), and prerequisites builder (`build`)
* `mod`: contains the `opencoarrays.mod` module file for use with non-OpenCoarrays-aware compilers
* `lib`: contains the `libcaf_mpi.a` static library to which codes link for CAF support

The remainder of this document explains other options that many end users will find
simplest to obtain OpenCoarrays on OS X, Windows, or Linux without building OpenCoarrays
from its source code.

### OS X ###

OS X users might find it easiest to install OpenCoarrays using the [MacPorts]
package management system.  After installing [MacPorts], type the following:

```
sudo port selfupdate
sudo port upgrade outdated
sudo port install opencoarrays
```

where the `sudo` command requires administrator privileges and where the first
two steps above are required only if the [MacPorts] ports were last updated prior
to 30 September 2015, when the OpenCoarrays port was incorporated into [MacPorts].
Repeating the first two steps above will also update OpenCoarrays to the latest
release.

Please also install the `mpstats` port as follows:

```
sudo port install mpstats
```

which supports future OpenCoarrays development by providing download data the
OpenCoarrays team can use in proposals for research grants and development
contracts.

### Windows ###

Windows users will find it easiest to download the Lubuntu Linux virtual
machine from the [Sourcery Institute Store].  The virtual machine boots inside
the open-source [VirtualBox] virtualization package.  In addition to containing
GCC 4.9, 5.2, and 6.0, MPICH, OpenMPI, and OpenCoarrays, the virtual machine
contains dozens of other open-source software packages that support software
development in modern Fortran.  See the [download and installation instructions]
for a partial list of the included packages.

Alternatively, if you desire to use OpenCoarrays under Cygwin, please submit a
feature request via our [Issues] page.

### Linux ###

The [Arch Linux] distribution provides an [aur package] for installing OpenCoarrays.
Users of other Linux distributions who prefer not to build OpenCoarrays from source might
access OpenCoarrays via the the Lubuntu Linux virtual machine from the
[Sourcery Institute Store] after installing the version of [VirtualBox] that is suitable
for the relevant Linux distribution.  Alternatively, if you desire to install using other
Linux package management software such as [yum] or [apt-get], please submit a feature
request via our [Issues] page.

Advanced Installation from Source
--------------------

### Prerequisites: ###

The prerequisites below and their dependencies are recommended for the broadest coverage of CAF features. If a prerequisite is missing or outdated, the [install.sh] script will prompt the user for permission to download, compile, and install it. Before doing so, [install.sh] will verify whether that prerequisite's prerequisites are present and will recursively traverse the dependency tree until reaching an acceptable prerequisite or reaching the end of a branch.

```
opencoarrays
├── cmake-3.4.0
└── mpich-3.1.4
    └── gcc-6.1.0
        ├── flex-2.6.0
        │   └── bison-3.0.4
        │       └── m4-1.4.17
        ├── gmp
        ├── mpc
        └── mpfr
```

If using the advanced [CMake] or [Make] builds detailed below, please ensure that these dependencies are met before attempting to build and install OpenCoarrays.

### CMake ###

[CMake] is the preferred build system.   CMake is a cross-platform Makefile generator that
includes with the testing tool CTest.  To avoid cluttering or clobbering the source tree,
our CMake setup requires that your build directory be any directory other than the top-level
OpenCoarrays source directory.  In a bash shell, the following steps should build
OpenCoarrays, install OpenCoarrays, build the tests, run the tests, and report the test results:

```
tar xvzf opencoarrays.tar.gz
cd opencoarrays
mkdir opencoarrays-build
cd opencoarrays-build
CC=mpicc FC=mpif90 cmake .. -DCMAKE_INSTALL_PREFIX=${PWD}
make
ctest
make install
```

where the the first part of the cmake line sets the CC and FC environment variables
and the final part of the same line defines the installation path as the present
working directory (`opencoarrays-build`).  Please report any test failures via the
OpenCoarrays [Issues] page.

Advanced options (most users should not use these):

    -DLEGACY_ARCHITECTURE=OFF enables the use of FFT libraries that employ AVX instructions
    -DHIGH_RESOLUTION_TIMER=ON enables timers that tick once per clock cycle
    -DCOMPILER_SUPPORTS_ATOMICS enables support for the proposed Fortran 2015 events feature
    -DUSE_EXTENSIONS builds the [opencoarrays] module for use with non-OpenCoarrays-aware compilers
    -DCOMPILER_PROVIDES_MPI is set automatically when building with the Cray Compiler Environment

The first two flags above are not portable and the third enables code that is incomplete as
of release 1.0.0.  The fourth is set automatically by the CMake scripts based on the compiler
identity and version.

### Make ###

Unlike the Makefiles that CMake generates automatically for the chosen platform, static
Makefiles require a great deal more maintenance and are less portable.  Also, the static
Makefiles provided with OpenCoarrays lack several important capabilities.  In particular,
they will not build the tests;  they will not build any of the infrastructure for compiling
CAF source with non-OpenCoarrays-aware compilers (that infrastructure includes the
[opencoarrays] module, the `caf` compiler wrapper, and the `cafrun` program launcher);
nor do the static Makefiles provide a `make install` option so you will need to manually
move the desired library from the corresponding source directory to your intended installation
location as shown below.

If CMake is unavailable, build and install with Make using steps such as the following:

```
tar xvzf opencoarrays.tar.gz
cd opencoarray/src
make
mv mpi/libcaf_mpi.a <installation-path>
```

For the above steps to succeed, you might need to edit the [make.inc] file to match your
system settings.  For example, you might need to remove the `-Werror` option from the
compiler flags or name a different compiler.  In order to activate efficient strided-array
transfer support, uncomment the `-DSTRIDED` flag inside the [make.inc] file.

Obtaining GCC, MPICH, and CMake
-------------------------------

[GFortran Binaries] 5 binary builds are available at <https://gcc.gnu.org/wiki/GFortranBinaries>.  Also,
the Lubuntu Linux virtual machine available for download in the [Sourcery Store] includes
builds of GCC 4.9, 5.2, and 6.0.

To build all prerequisites from source, including the current development branch of GCC,
you might first try the running the provided [install.sh] script as described above in
the [Installation Script] section.  Or try building each prerequisite from source as
follows:

```
cd prerequisites
CC=gcc FC=gfortran CXX=g++ ./build flex
./build gcc
CC=gcc FC=gfortran CXX=g++ ./build mpich
./build cmake
```

where the second line builds the flex package that is required for building gcc from source.

[Links]: #

[End-User Installation]: #end-user-installation
[Installation Script]: #installation-script
[install.sh]: ./install.sh
[OS X]: #os-x
[ticket]: https://trac.macports.org/ticket/47806
[Windows]: #windows
[Linux]: #linux
[Advanced Installation from Source]: #advanced-installation-from-source
[Prerequisites]: #prerequisites
[CMake]: #cmake
[Make]: #make
[Obtaining GCC]: #obtaining-gcc
[Sourcery Store]: http://www.sourceryinstitute.org/store
[Sourcery Institute Store]: http://www.sourceryinstitute.org/store
[VirtualBox]: http://www.virtualbox.org
[download and installation instructions]: http://www.sourceryinstitute.org/uploads/4/9/9/6/49967347/overview.pdf
[yum]: http://yum.baseurl.org
[apt-get]: https://en.wikipedia.org/wiki/Advanced_Packaging_Tool
[Issues]: https://github.com/sourceryinstitute/opencoarrays/issues
[make.inc]: ./src/make.inc
[opencoarrays]: ./src/extensions/opencoarrays.F90
[prerequisites]: ./prerequisites
[MPICH]: http://www.mpich.org
[MVAPICH]:http://mvapich.cse.ohio-state.edu
[MacPorts]: http://www.macports.org
[GCC]: http://gcc.gnu.org
[TS18508 Additional Parallel Features in Fortran]: http://isotc.iso.org/livelink/livelink?func=ll&objId=17181227&objAction=Open
[GFortran Binaries]:  https://gcc.gnu.org/wiki/GFortranBinaries#FromSource
[Installing GCC]: https://gcc.gnu.org/install/
[Arch Linux]: https://www.archlinux.org
[aur package]: https://aur.archlinux.org/packages/opencoarrays/
[Releases]: https://github.com/sourceryinstitute/opencoarrays/releases
[pdf img]: https://img.shields.io/badge/PDF-INSTALL.md-6C2DC7.svg?style=flat-square "Download as PDF"

[This document is formatted with GitHub-Flavored Markdown.               ]:#
[For better viewing, including hyperlinks, read it online at             ]:#
[https://github.com/sourceryinstitute/OpenCoarrays/blob/master/INSTALL.md]:#

<a name="top"> </a>

# Installing OpenCoarrays #

[![GitHub release][GH release badge]][latest release]
[![Github All Releases][GH all releases badge]][latest release]
[![Download as PDF][pdf img]][INSTALL.pdf]

Download this file as a PDF document
[here][INSTALL.pdf].

* [Developer Build and Install]
* [End-User Installation]
  * [macOS]
  * [Windows]
  * [Linux]
  * [FreeBSD]
  * [Virtual machine]
  * [Installation Script]
* [Advanced Installation from Source]
  * [Prerequisites]
  * [CMake]
  * [Make]

## Developer Build and Install ##

If you are a GCC developer, a package maintainer building OpenCoarrays
for distribution, or an advanced user who is comfortable building
software from source (using cmake), then we recommend installing
OpenCoarrays directly via CMake. If you do not fit into one of these
categories, we encourage you to skip ahead to review installation
options via Linux or MacOS package management software, or the
[`install.sh`] script. The text below is a condensed version of the
content available in [`INSTALL`]: plain text instructions for installing
OpenCoarrays in a canonical CMake way.

Prerequites for direct CMake installation:

* An MPI 3 implementation (MPICH is preferred, OpenMPI works too)
* A recent version of GCC with GFortran version 6.1 or newer
* CMake version 3.4 or newer

After obtaining the OpenCoarrays source (from git or our [latest release])
the following commands to build and install OpenCoarrays from source
using CMake:

```bash
mkdir opencoarrays-build
cd opencoarrays-build
export FC=/path/to/gfortran
export CC=/path/to/gcc
cmake /path/to/OpenCoarrays/source \
  -DCMAKE_INSTALL_PREFIX=/path/to/desired/installation/location
make
make test # optional; verify build works
make install
```

If you have either of the CMake gui tools installed, `ccmake` or
`cmake-gui` you may explore different configuration options and/or try
to locate/change which MPI version is found by repeating the steps
above and simply replacing `cmake` with `ccmake` or `cmake-gui`.

Please keep in mind that CMake cache variables are sticky and, once
set, can only be changed by using `ccmake`, `cmake-gui`, or explicitly
setting them on the command line: `cmake ../path/to/src -DVAR=VALUE`
If the wrong compiler or MPI implementation is being used and you
cannot determine why, you can try deleting the entire build directly
and re-running CMake.

## End-User Installation ##

Most users will find it easiest and fastest to use package management
software to install OpenCoarrays. Below is the status of OpenCoarrays
in various package managers. If you do not see your favorite package
manager listed or it is badly out of date, please reach out and ask
for it to be included or updated, or contribute it yourself. We are
happy to work with package managers to resolve issues, and adapt our
build system to play nicely so they don't have to maintain patches.

[![Packaging status][repology-badge]][OC-on-repology]

Package management options for
macOS, Windows, and Linux are described first below. Also described
below are options for installing via the Sourcery Institute virtual
machine or via the bash scripts included that are in the OpenCoarrays
source.

[top]

### macOS ###

* [Homebrew]:
  [![homebrew][Homebrew badge]][braumeister link]
  This is the recommended OpenCoarrays installation method on macOS.
  Basic Homebrew installation steps:

  ```
  brew update
  brew install opencoarrays
  ```

  OpenCoarrays also ships with a [`Brewfile`][Brewfile]
  that will make it easier to install opencoarrays using MPICH built
  with the GNU Compiler Collection ([GCC]). To install using the
  [`Brewfile`][Brewfile] with MPICH wrapping GCC, follow these steps:

  ```
  brew tap homebrew/bundle
  brew update
  brew bundle
  ```

* [MacPorts]:
  An unmaintained [OpenCoarrays Portfile] exists for the [MacPorts] package
  manager.  Although the current OpenCoarrays contributors have no plans to
  update the portfile, new contributors are welcome to asssume the port
  maintainer role and to submit a pull request to update this [INSTALL.md] file.

[top]

### Windows ###

Windows users may run the [`install.sh`] script inside the Windows Subsystem
for Linux ([WSL]). The script uses Ubuntu's [APT] package manager to build
[GCC] 5.4.0, [CMake], and [MPICH].  Windows users who desire a newer version
of GCC are welcome to submit a request via our [Issues] page and suggest a
method for updating. Previously attempted upgrade methods are described in
the discussion thread starting with [commit comment 20539810].

[top]

### Linux ###

Access OpenCoarrays on Linux via any of the following package managers
or pre-installed copies:

* The [linuxbrew] package manager installs OpenCoarrays on all Linux distributions.
* Debian-based distributions such as Ubuntu provide an "open-coarrays" [APT package].
* [Arch Linux] provides an [aur package].
* An [HPCLinux] installation script is in the [developer-scripts] subdirectory (available
  via git clone only).
* [EasyBuild] can install OpenCoarrays on Linux distributions
* [Spack], a multiplatform package manager, can also install OpenCoarrays on Linux
   distributions

[linuxbrew] does not require `sudo` privileges and will generally
provide the most up-to-date OpenCoarrays release because linuxbrew
pulls directly from macOS homebrew, which updates automatically.

Note that distributions are often split into two parts: a "binary" package with the
runtime libraries and a "development" package for developing programs yourself.
Be sure to install both packages.

<a name="easybuild"></a>
With [EasyBuild], the following bash commands install OpenCoarrays:

```bash
# Search available specification files (also known as easyconfigs) for OpenCoarrays
eb --search OpenCoarrays

# Automatically download prerequisites (with the --robot flag) and install OpenCoarrays
# with the desired easyconfig, e.g., OpenCoarrays-1.9.0-gompi-2017a.eb
eb OpenCoarrays-1.9.0-gompi-2017a.eb --robot
```

Once installed, use OpenCoarrays by loading the newly created environment
module `OpenCoarrays/1.9.0-gompi-2017a`:

```
module load OpenCoarrays/1.9.0-gompi-2017a
```

<a name="spack"></a>
With [Spack], the following commands install OpenCoarrays in a bash shell:

```bash
# Check build information for OpenCoarrays in the default specification file
spack spec opencoarrays

# To automatically download prerequisites and install OpenCoarrays with the default
# specification.
# (Note: In addition to its own prerequisites, Spack requires gfortran compiler
# to be installed to compile OpenMPI)
spack install opencoarrays

# Or, To install with customisations (e.g., to install OpenCoarrays [version 2.2.0]
# with MPICH [version default] and GCC [version 7.1.0]).
spack install opencoarrays@2.2.0 ^mpich %gcc@7.1.0
```

In the previous example, it was assumed that GCC [version 7.1.0] is
already installed, and is available as a compiler to Spack. Otherwise,
[add a new compiler to Spack]. Once installed, OpenCoarrays can be
used by [loading the environment modules with Spack], e.g.

```
spack module loads --dependencies opencoarrays
```

[top]

### FreeBSD ###

Use the OpenCoarrays FreeBSD, Port to install OpenCoarrays by
executing the following commands as root:

```
pkg install opencoarrays
```

For more information, please review the [FreeBSD ports/packages installation information].

[top]

## Virtual machine ##

Users of macOS, Windows, or Linux have the option to use OpenCoarrays
by installing the Lubuntu Linux virtual machine from the
[Sourcery Institute Store].  The virtual machine boots inside the
open-source [VirtualBox] virtualization package.  In addition to
containing [GCC], [MPICH], and OpenCoarrays, the virtual machine
contains dozens of other open-source software packages that support
modern Fortran software development.  See the
[download and installation instructions] for a partial list of the
included packages.

[top]

## Installation Script ##

If the above package management or virtualization options are
infeasible or unavailable, Linux, macOS, and [WSL] users may also install
OpenCoarrays by downloading and uncompressing our [latest release] and
running our installation script in the top-level OpenCoarrays source
directory (see above for the corresponding [Windows] script):

```
tar xvzf OpenCoarrays-x.y.z.tar.gz
cd OpenCoarrays-x.y.z
./install.sh
```

where `x.y.z` should be replaced with the appropriate version numbers.
A complete installation should result in the creation of the following
directories inside the installation path (.e.g, inside `build` in the
above example):

* `bin`: contains the compiler wrapper (`caf`) and program launcher
  (`cafun`).
* `mod`: contains the `opencoarrays.mod` module file for use with
  non-OpenCoarrays-aware compilers
* `lib`: contains the `libcaf_mpi.a` static library to which codes
  link for CAF support

### Example script invocations ###

Execute `./install.sh --help` or `./install.sh -h` to see a list of flags
that can be passed to the installer.  Below are examples of useful combinations
of flags. Each flag also has a single-character version not shown here.

1. If you don't care about tailoring installation locations,use

   ```
   ./install.sh
   ```

2. Or build faster by multithreading, skipping user queries, and also specify
    an installation destination for all packages that must be built:

   ```
   ./install.sh \
     --prefix-root ${HOME}/software \
     --num-threads 4 \
     --yes-to-all
   ```

3. Specify the compilers to be used (overriding what is in your `PATH`) as follows:

   ```
   ./install.sh --with-fortran <path-to-gcc-bin>/gfortran \
                --with-cxx <path-to-gcc-bin>/g++ \
                --with-c <path-to-gcc-bin>/gcc
   ```

4. Install only a specific prerequisite package (the default version):

   ```
   ./install.sh --package mpich
   ```

5. Install a specific version of a prerequisite:

   ```
   ./install.sh --package cmake --install-version 3.7.0
   ```

6. Download a prerequisite package (e.g., gcc/gfortran/g++ below) but
   don't build or install it:

   ```
   ./install.sh --only-download gcc
   ```

7. Print the default URL, version, or download mechanism that the
   script will use for a given prerequisite package (e.g., mpich
   below) on this system:

   ```
   ./install.sh --print-url mpich
   ./install.sh --print-version mpich
   ./install.sh --print-downloader mpich
   ```

8. Install a prerelease branch (e.g., trunk below) of the GCC repository:

   ```
   ./install.sh --package gcc --install-branch trunk
   ```

[top]

## Advanced Installation from Source ##

### Prerequisites ###

Package managers and the [`install.sh`] attempt to handle the installation
of all OpenCoarrays prerequisites automatically.  Installing with CMake
or the provided, static Makefile burdens the person installing with the
need to ensure that all prerequisites have been built and are in the
expected or specified locations prior to building OpenCoarrays. The
prerquisite package/version dependency tree is as follows:

```text
opencoarrays
├── cmake-3.4.0
└── mpich-3.2
    └── gcc-6.1.0
        ├── flex-2.6.0
        │   └── bison-3.0.4
        │       └── m4-1.4.17
        ├── gmp
        ├── mpc
        └── mpfr
```

[top]

### CMake ###

On most platforms, the [`install.sh`] script ultimately invokes [CMake] after
performing numerous checks, customizations, and installations of any missing
prerequisites. Users wishing to install OpenCoarrays directly with CMake should
have a look at the documentation in the [`./INSTALL`] file if they encounter
issues or need further guidance. A brief summary is also given at the top of
this document [here][Developer Build and Install].

[top]

### Make ###

Unlike the Makefiles that CMake generates automatically for the chosen
platform, static Makefiles require a great deal more maintenance and are
less portable.  Also, the static Makefiles provided in [src] lack several
important capabilities.  In particular, they will not build the tests;
they will not generate the `caf` compiler wrapper that ensures correct linking
and `cafrun` program launcher that ensures support for advanced features such
as Fortran 2015 failed images; they will not build the [opencoarrays] module
that can be used to provide some Fortran 2015 features with non-Fortran-2015
compilers; nor do the static Makefiles provide a `make install` option so you
will need to manually move the resultant library from the build location to your
chosen installation location.

If none of the installation methods mentioned higher in this document are
work on your platform and if CMake is unavailable, build and install the
OpenCoarrays parallel runtime library as follows:

```
tar xvzf opencoarrays.tar.gz
cd opencoarray/src
make
mv mpi/libcaf_mpi.a <insert-install-path>
```

replacing the angular-bracketed text with your desired install path.

For the above steps to succeed, you might need to edit the [make.inc]
file to match your system settings.  For example, you might need to
remove the `-Werror` option from the compiler flags or name a
different compiler.  In order to activate efficient strided-array
transfer support, uncomment the `-DSTRIDED` flag inside the [make.inc]
file.

[top]

---

<div align="center">

[![GitHub forks][fork badge]][fork url]
[![GitHub stars][star badge]][star url]
[![GitHub watchers][watch badge]][star url]
[![Twitter URL][twitter badge]][twitter url]

</div>

[Internal document links]: #

[top]: #top
[Developer Build and Install]: #developer-build-and-install
[End-User Installation]: #end-user-installation
[macOS]: #macos
[Windows]: #windows
[Linux]: #linux
[FreeBSD]: #freebsd
[Virtual machine]: #virtual-machine
[Installation Script]: #installation-script

[Advanced Installation from Source]: #advanced-installation-from-source
[Prerequisites]: #prerequisites
[CMake]: #cmake
[Make]: #make

[Links to source]: #

[`install.sh`]: ./install.sh
[`INSTALL`]: ./INSTALL

[URLs]: #

[OC-on-repology]: https://repology.org/project/opencoarrays/versions
[repology-badge]: https://repology.org/badge/vertical-allrepos/opencoarrays.svg

[FreeBSD ports/packages installation information]: https://www.freebsd.org/doc/en_US.ISO8859-1/books/handbook/ports.html
[GH all releases badge]: https://img.shields.io/github/downloads/sourceryinstitute/OpenCoarrays/total.svg?style=flat-square
[GH release badge]: https://img.shields.io/github/release/sourceryinstitute/OpenCoarrays.svg?style=flat-square
[Homebrew badge]: https://img.shields.io/homebrew/v/opencoarrays.svg?style=flat-square
[linuxbrew]: http://linuxbrew.sh
[braumeister link]: http://braumeister.org/formula/opencoarrays
[APT package]: https://qa.debian.org/popcon.php?package=open-coarrays
[APT]: https://en.wikipedia.org/wiki/APT_(Debian)
[HPCLinux]: http://www.paratools.com/hpclinux/
[Brewfile]: https://github.com/sourceryinstitute/OpenCoarrays/blob/master/Brewfile
[INSTALL.pdf]: https://md2pdf.herokuapp.com/sourceryinstitute/OpenCoarrays/blob/master/INSTALL.pdf
[INSTALL.md]: https://github.com/sourceryinstitute/OpenCoarrays/blob/master/INSTALL.md
[CMake]: https://cmake.org
[Sourcery Institute Store]: http://www.sourceryinstitute.org/store/c1/Featured_Products.html
[VirtualBox]: https://www.virtualbox.org
[download and installation instructions]: http://www.sourceryinstitute.org/uploads/4/9/9/6/49967347/overview.pdf
[yum]: http://yum.baseurl.org
[apt-get]: https://en.wikipedia.org/wiki/Advanced_Packaging_Tool
[Issues]: https://github.com/sourceryinstitute/OpenCoarrays/issues
[make.inc]: ./src/make.inc
[opencoarrays]: ./src/extensions/opencoarrays.F90
[prerequisites]: #prerequisites
[MPICH]: http://www.mpich.org
[MVAPICH]:http://mvapich.cse.ohio-state.edu
[MacPorts]: https://www.macports.org
[GCC]: http://gcc.gnu.org
[TS18508 Additional Parallel Features in Fortran]: https://isotc.iso.org/livelink/livelink/nfetch/-8919044/8919782/8919787/17001078/ISO%2DIECJTC1%2DSC22%2DWG5_N2056_Draft_TS_18508_Additional_Paralle.pdf?nodeid=17181227&vernum=0
[GFortran Binaries]:  https://gcc.gnu.org/wiki/GFortranBinaries#FromSource
[Installing GCC]: https://gcc.gnu.org/install/
[Arch Linux]: https://www.archlinux.org
[aur package]: https://aur.archlinux.org/packages/opencoarrays/
[latest release]: https://github.com/sourceryinstitute/OpenCoarrays/releases/latest
[pdf img]: https://img.shields.io/badge/PDF-INSTALL.md-6C2DC7.svg?style=flat-square
[commit comment 20539810]: https://github.com/sourceryinstitute/OpenCoarrays/commit/26e99919fe732576f7277a0e1b83f43cc7c9d749#commitcomment-20539810
[Homebrew]: https://brew.sh
[dnf]: https://github.com/rpm-software-management/dnf
[port details]: https://www.freshports.org/lang/opencoarrays
[port search]: https://www.freebsd.org/cgi/ports.cgi?query=opencoarrays
[EasyBuild]: https://github.com/easybuilders/easybuild
[Spack]: https://github.com/spack/spack
[add a new compiler to Spack]: http://spack.readthedocs.io/en/latest/tutorial_modules.html#add-a-new-compiler
[loading the environment modules with Spack]: http://spack.readthedocs.io/en/latest/module_file_support.html#cmd-spack-module-loads
[OpenCoarrays Portfile]: https://www.macports.org/ports.php?by=name&substr=opencoarrays
[WSL]: https://blogs.msdn.microsoft.com/commandline/2017/07/10/ubuntu-now-available-from-the-windows-store/
[developer-scripts]: https://github.com/sourceryinstitute/OpenCoarrays/tree/master/developer-scripts
[src]: https://github.com/sourceryinstitute/OpenCoarrays/tree/master/src
[fork badge]: https://img.shields.io/github/forks/sourceryinstitute/OpenCoarrays.svg?style=social&label=Fork
[fork url]: https://github.com/sourceryinstitute/OpenCoarrays/fork
[star badge]: https://img.shields.io/github/stars/sourceryinstitute/OpenCoarrays.svg?style=social&label=Star
[star url]: https://github.com/sourceryinstitute/OpenCoarrays
[watch badge]: https://img.shields.io/github/watchers/sourceryinstitute/OpenCoarrays.svg?style=social&label=Watch
[twitter badge]: https://img.shields.io/twitter/url/http/shields.io.svg?style=social
[twitter url]: https://twitter.com/intent/tweet?hashtags=HPC,Fortran,PGAS&related=zbeekman,gnutools,HPCwire,HPC_Guru,hpcprogrammer,SciNetHPC,DegenerateConic,jeffdotscience,travisci&text=Stop%20programming%20w%2F%20the%20%23MPI%20docs%20in%20your%20lap%2C%20try%20Coarray%20Fortran%20w%2F%20OpenCoarrays%20%26%20GFortran!&url=https%3A//github.com/sourceryinstitute/OpenCoarrays

Contributors to OpenCoarrays
============================

[![Download as PDF][pdf img]](http://md2pdf.herokuapp.com/sourceryinstitute/opencoarrays/blob/master/AUTHORS.pdf)

Download this file as a PDF document
[here](http://md2pdf.herokuapp.com/sourceryinstitute/opencoarrays/blob/master/AUTHORS.pdf).

 - Alessandro Fanfarillo  <fanfarillo@ing.uniroma2.it>
 - Damian Rouson  <damian@rouson.net>
 - Izaak Beekman  <http://izaakbeekman.com>
 - Daniel Carrera  <dcarrera@gmail.com>
 - Jeff Hammond  <jeff.science@gmail.com>
 - Tobias Burnus  <burnus@net-b.de>

[I think we're missing a number of people here]:#
[@naveen-rn?]:#
[@raul-nasner?]:#
[Others:]:#

[Links]:#
[pdf img]: https://img.shields.io/badge/PDF-AUTHORS.md-6C2DC7.svg?style=flat-square "Download as PDF"

[This document is formatted with GitHub-Flavored Markdown.               ]:#
[For better viewing, including hyperlinks, read it online at             ]:#
[https://github.com/sourceryinstitute/OpenCoarrays/blob/master/INSTALL.md]:#

<a name="top"> </a>

# Installing OpenCoarrays #

[![GitHub release][GH release badge]][latest release]
[![Github All Releases][GH all releases badge]][latest release]
[![Download as PDF][pdf img]][INSTALL.pdf]

Download this file as a PDF document
[here][INSTALL.pdf].

* [Developer Build and Install]
* [End-User Installation]
  * [macOS]
  * [Windows]
  * [Linux]
  * [FreeBSD]
  * [Virtual machine]
  * [Installation Script]
* [Advanced Installation from Source]
  * [Prerequisites]
  * [CMake]
  * [Make]

## Developer Build and Install ##

If you are a GCC developer, a package maintainer building OpenCoarrays
for distribution, or an advanced user who is comfortable building
software from source (using cmake), then we recommend installing
OpenCoarrays directly via CMake. If you do not fit into one of these
categories, we encourage you to skip ahead to review installation
options via Linux or MacOS package management software, or the
[`install.sh`] script. The text below is a condensed version of the
content available in [`INSTALL`]: plain text instructions for installing
OpenCoarrays in a canonical CMake way.

Prerequites for direct CMake installation:

* An MPI 3 implementation (MPICH is preferred, OpenMPI works too)
* A recent version of GCC with GFortran version 6.1 or newer
* CMake version 3.4 or newer

After obtaining the OpenCoarrays source (from git or our [latest release])
the following commands to build and install OpenCoarrays from source
using CMake:

```bash
mkdir opencoarrays-build
cd opencoarrays-build
export FC=/path/to/gfortran
export CC=/path/to/gcc
cmake /path/to/OpenCoarrays/source \
  -DCMAKE_INSTALL_PREFIX=/path/to/desired/installation/location
make
make test # optional; verify build works
make install
```

If you have either of the CMake gui tools installed, `ccmake` or
`cmake-gui` you may explore different configuration options and/or try
to locate/change which MPI version is found by repeating the steps
above and simply replacing `cmake` with `ccmake` or `cmake-gui`.

Please keep in mind that CMake cache variables are sticky and, once
set, can only be changed by using `ccmake`, `cmake-gui`, or explicitly
setting them on the command line: `cmake ../path/to/src -DVAR=VALUE`
If the wrong compiler or MPI implementation is being used and you
cannot determine why, you can try deleting the entire build directly
and re-running CMake.

## End-User Installation ##

Most users will find it easiest and fastest to use package management
software to install OpenCoarrays. Below is the status of OpenCoarrays
in various package managers. If you do not see your favorite package
manager listed or it is badly out of date, please reach out and ask
for it to be included or updated, or contribute it yourself. We are
happy to work with package managers to resolve issues, and adapt our
build system to play nicely so they don't have to maintain patches.

[![Packaging status][repology-badge]][OC-on-repology]

Package management options for
macOS, Windows, and Linux are described first below. Also described
below are options for installing via the Sourcery Institute virtual
machine or via the bash scripts included that are in the OpenCoarrays
source.

[top]

### macOS ###

* [Homebrew]:
  [![homebrew][Homebrew badge]][braumeister link]
  This is the recommended OpenCoarrays installation method on macOS.
  Basic Homebrew installation steps:

  ```
  brew update
  brew install opencoarrays
  ```

  OpenCoarrays also ships with a [`Brewfile`][Brewfile]
  that will make it easier to install opencoarrays using MPICH built
  with the GNU Compiler Collection ([GCC]). To install using the
  [`Brewfile`][Brewfile] with MPICH wrapping GCC, follow these steps:

  ```
  brew tap homebrew/bundle
  brew update
  brew bundle
  ```

* [MacPorts]:
  An unmaintained [OpenCoarrays Portfile] exists for the [MacPorts] package
  manager.  Although the current OpenCoarrays contributors have no plans to
  update the portfile, new contributors are welcome to asssume the port
  maintainer role and to submit a pull request to update this [INSTALL.md] file.

[top]

### Windows ###

Windows installation support has recently been enhanced. The new installation
method doesn't require Cygwin or WSL and relies only a light weight git/bash
distribution like Git-Bash, and the Intel OneAPI base distribution as well as
the Intel OneAPI HPC Toolkit. This allows native and redistributable statically
linked binaries to be built if you use the appropriate compiler flags. Clients
will only require the free redistributable Intel MPI runtime.

#### New and Recommended Windows Installation ####

Please follow these instructions, this is the recommended way to install
OpenCoarrays on Windows.

##### Pre-requisites #####

* [CMake]
* [Git-Bash]
* [GCC, GFortran, Unix Make]
* [Intel OneAPI Base] and [Intel OneAPI HPC toolkit]

##### Installation Procedure #####

1. Ensure all the prerequisites have been installed following the directions of
   the provider.
2. Launch the 64-bit Intel OneAPI developer shell. This will either be in the
   start menu, or you may need to figure out how to launch it manually. See the
   note below for help.
3. Ensure that cmake, git-bash, gfortran, gcc, make are available on your default
   path. The installers should have taken care of this for you.
5. Launch a Git-Bash bash shell from the OneAPI environment, or ensure Git-Bash's
   `bash.exe` is first on your path by either:
     1. Typing `git-bash` from within the windows `CMD.exe` style OneAPI shell, or
     2. Editing your system wide `%PATH%` variable, or updating it in the local shell
        so that git-bash's `bin` subdirectory (containing `bash.exe`) is at the front
        of your `PATH`: `set PATH=C:\path\to\Git-Bash\bin;%PATH%`.
6. At this point, typing `bash --version` should show you you're using Git-Bash, *AND*
   typing `bash -c pwd` should match the current directory. __`bash` provided with
   WSL will show the directory as your home directory, something like `/home/username`
   and this *will* cause problems later__
7. `cd` to the extracted OpenCoarrays source directory (obtained by downloading a
   release archive, or, for advanced useres, checked out with `git`, etc.)
8. Create a build directory and change to it with something like:
   `mkdir build` and `cd build`
9. Set GCC and GFortran as the default C and Fortran compilers with something like:
   `set FC=gfortran` and `set CC=gcc`
10. Check that Intel's MPI is setup correctly by typing `mpifc -show` which should
    show you how the compiler wrapper script is planning to build MPI programs.
    (It's fine if this shows `ifort` being used as the compiler instead of `gfortran`
    at this point.)
11. Configure Open-Coarrays with CMake and specify the installation directory you would
    like to use. (If this is not a user-writable location, you will have to open a new
    shell later as an administrator to perform the installation step.) Run:
    `cmake -G "Unix Makefiles" -DCMAKE_INSTALL_PREFIX="C:\path\to\desired\install\location" ".\path\to\opencoarrays-source-dir"`
    The quotes ensure paths with spaces are handled properly. You may omit them if there
    are no spaces.
12. When the configuration completes, build with:
    `cmake --build . -j <ncores>`
13. Install OpenCoarrays: `cmake --build . -j <ncores> -t install`
14. Optionally run the test suite. There are a few known failures on Windows.
    Also, a large numberof firewall warnings will pop up.
    `cmake --build . -t check`

__NOTE About the Intel OneAPI CMD.exe shell__

If you don't have a "Intel oneAPI command prompt for Intel 64 for Visual Studio 20xx"
in your start menu you can figure out how to launch an equivalent `CMD.exe` or
Powershell instance by examining the shortcut Target that it created for me:

```
%ComSpec% /E:ON /K ""C:\Program Files (x86)\Intel\oneAPI\setvars.bat" intel64 vs2022"
```

So it looks like you can launch `CMD.exe` and then run the appropriate `setvars.bat`
script with the `intel64` and `vs20<xx>` arguments where `vs20<xx>` matches the
appropriate Visual Studio version.

#### Old Procedure ####

__NOTE: Use this method at your own risk, it is no longer officially supported!__

Windows users may run the [`install.sh`] script inside the Windows Subsystem
for Linux ([WSL]). The script uses Ubuntu's [APT] package manager to build
[GCC] 5.4.0, [CMake], and [MPICH].  Windows users who desire a newer version
of GCC are welcome to submit a request via our [Issues] page and suggest a
method for updating. Previously attempted upgrade methods are described in
the discussion thread starting with [commit comment 20539810].

[top]

### Linux ###

Access OpenCoarrays on Linux via any of the following package managers
or pre-installed copies:

* The [linuxbrew] package manager installs OpenCoarrays on all Linux distributions.
* Debian-based distributions such as Ubuntu provide an "open-coarrays" [APT package].
* [Arch Linux] provides an [aur package].
* An [HPCLinux] installation script is in the [developer-scripts] subdirectory (available
  via git clone only).
* [EasyBuild] can install OpenCoarrays on Linux distributions
* [Spack], a multiplatform package manager, can also install OpenCoarrays on Linux
   distributions

[linuxbrew] does not require `sudo` privileges and will generally
provide the most up-to-date OpenCoarrays release because linuxbrew
pulls directly from macOS homebrew, which updates automatically.

Note that distributions are often split into two parts: a "binary" package with the
runtime libraries and a "development" package for developing programs yourself.
Be sure to install both packages.

<a name="easybuild"></a>
With [EasyBuild], the following bash commands install OpenCoarrays:

```bash
# Search available specification files (also known as easyconfigs) for OpenCoarrays
eb --search OpenCoarrays

# Automatically download prerequisites (with the --robot flag) and install OpenCoarrays
# with the desired easyconfig, e.g., OpenCoarrays-1.9.0-gompi-2017a.eb
eb OpenCoarrays-1.9.0-gompi-2017a.eb --robot
```

Once installed, use OpenCoarrays by loading the newly created environment
module `OpenCoarrays/1.9.0-gompi-2017a`:

```
module load OpenCoarrays/1.9.0-gompi-2017a
```

<a name="spack"></a>
With [Spack], the following commands install OpenCoarrays in a bash shell:

```bash
# Check build information for OpenCoarrays in the default specification file
spack spec opencoarrays

# To automatically download prerequisites and install OpenCoarrays with the default
# specification.
# (Note: In addition to its own prerequisites, Spack requires gfortran compiler
# to be installed to compile OpenMPI)
spack install opencoarrays

# Or, To install with customisations (e.g., to install OpenCoarrays [version 2.2.0]
# with MPICH [version default] and GCC [version 7.1.0]).
spack install opencoarrays@2.2.0 ^mpich %gcc@7.1.0
```

In the previous example, it was assumed that GCC [version 7.1.0] is
already installed, and is available as a compiler to Spack. Otherwise,
[add a new compiler to Spack]. Once installed, OpenCoarrays can be
used by [loading the environment modules with Spack], e.g.

```
spack module loads --dependencies opencoarrays
```

[top]

### FreeBSD ###

Use the OpenCoarrays FreeBSD, Port to install OpenCoarrays by
executing the following commands as root:

```
pkg install opencoarrays
```

For more information, please review the [FreeBSD ports/packages installation information].

[top]

## Virtual machine ##

Users of macOS, Windows, or Linux have the option to use OpenCoarrays
by installing the Lubuntu Linux virtual machine from the
[Sourcery Institute Store].  The virtual machine boots inside the
open-source [VirtualBox] virtualization package.  In addition to
containing [GCC], [MPICH], and OpenCoarrays, the virtual machine
contains dozens of other open-source software packages that support
modern Fortran software development.  See the
[download and installation instructions] for a partial list of the
included packages.

[top]

## Installation Script ##

If the above package management or virtualization options are
infeasible or unavailable, Linux, macOS, and [WSL] users may also install
OpenCoarrays by downloading and uncompressing our [latest release] and
running our installation script in the top-level OpenCoarrays source
directory (see above for the corresponding [Windows] script):

```
tar xvzf OpenCoarrays-x.y.z.tar.gz
cd OpenCoarrays-x.y.z
./install.sh
```

where `x.y.z` should be replaced with the appropriate version numbers.
A complete installation should result in the creation of the following
directories inside the installation path (.e.g, inside `build` in the
above example):

* `bin`: contains the compiler wrapper (`caf`) and program launcher
  (`cafun`).
* `mod`: contains the `opencoarrays.mod` module file for use with
  non-OpenCoarrays-aware compilers
* `lib`: contains the `libcaf_mpi.a` static library to which codes
  link for CAF support

### Example script invocations ###

Execute `./install.sh --help` or `./install.sh -h` to see a list of flags
that can be passed to the installer.  Below are examples of useful combinations
of flags. Each flag also has a single-character version not shown here.

1. If you don't care about tailoring installation locations,use

   ```
   ./install.sh
   ```

2. Or build faster by multithreading, skipping user queries, and also specify
    an installation destination for all packages that must be built:

   ```
   ./install.sh \
     --prefix-root ${HOME}/software \
     --num-threads 4 \
     --yes-to-all
   ```

3. Specify the compilers to be used (overriding what is in your `PATH`) as follows:

   ```
   ./install.sh --with-fortran <path-to-gcc-bin>/gfortran \
                --with-cxx <path-to-gcc-bin>/g++ \
                --with-c <path-to-gcc-bin>/gcc
   ```

4. Install only a specific prerequisite package (the default version):

   ```
   ./install.sh --package mpich
   ```

5. Install a specific version of a prerequisite:

   ```
   ./install.sh --package cmake --install-version 3.7.0
   ```

6. Download a prerequisite package (e.g., gcc/gfortran/g++ below) but
   don't build or install it:

   ```
   ./install.sh --only-download gcc
   ```

7. Print the default URL, version, or download mechanism that the
   script will use for a given prerequisite package (e.g., mpich
   below) on this system:

   ```
   ./install.sh --print-url mpich
   ./install.sh --print-version mpich
   ./install.sh --print-downloader mpich
   ```

8. Install a prerelease branch (e.g., trunk below) of the GCC repository:

   ```
   ./install.sh --package gcc --install-branch trunk
   ```

[top]

## Advanced Installation from Source ##

### Prerequisites ###

Package managers and the [`install.sh`] attempt to handle the installation
of all OpenCoarrays prerequisites automatically.  Installing with CMake
or the provided, static Makefile burdens the person installing with the
need to ensure that all prerequisites have been built and are in the
expected or specified locations prior to building OpenCoarrays. The
prerquisite package/version dependency tree is as follows:

```text
opencoarrays
├── cmake-3.4.0
└── mpich-3.2
    └── gcc-6.1.0
        ├── flex-2.6.0
        │   └── bison-3.0.4
        │       └── m4-1.4.17
        ├── gmp
        ├── mpc
        └── mpfr
```

[top]

### CMake ###

On most platforms, the [`install.sh`] script ultimately invokes [CMake] after
performing numerous checks, customizations, and installations of any missing
prerequisites. Users wishing to install OpenCoarrays directly with CMake should
have a look at the documentation in the [`./INSTALL`] file if they encounter
issues or need further guidance. A brief summary is also given at the top of
this document [here][Developer Build and Install].

[top]

### Make ###

Unlike the Makefiles that CMake generates automatically for the chosen
platform, static Makefiles require a great deal more maintenance and are
less portable.  Also, the static Makefiles provided in [src] lack several
important capabilities.  In particular, they will not build the tests;
they will not generate the `caf` compiler wrapper that ensures correct linking
and `cafrun` program launcher that ensures support for advanced features such
as Fortran 2018 failed images; they will not build the [opencoarrays] module
that can be used to provide some Fortran 2018 features with non-Fortran-2018
compilers; nor do the static Makefiles provide a `make install` option so you
will need to manually move the resultant library from the build location to your
chosen installation location.

If none of the installation methods mentioned higher in this document are
work on your platform and if CMake is unavailable, build and install the
OpenCoarrays parallel runtime library as follows:

```
tar xvzf opencoarrays.tar.gz
cd opencoarray/src
make
mv mpi/libcaf_mpi.a <insert-install-path>
```

replacing the angular-bracketed text with your desired install path.

For the above steps to succeed, you might need to edit the [make.inc]
file to match your system settings.  For example, you might need to
remove the `-Werror` option from the compiler flags or name a
different compiler.  In order to activate efficient strided-array
transfer support, uncomment the `-DSTRIDED` flag inside the [make.inc]
file.

[top]

---

<div align="center">

[![GitHub forks][fork badge]][fork url]
[![GitHub stars][star badge]][star url]
[![GitHub watchers][watch badge]][star url]
[![Twitter URL][twitter badge]][twitter url]

</div>

[Internal document links]: #

[top]: #top
[Developer Build and Install]: #developer-build-and-install
[End-User Installation]: #end-user-installation
[macOS]: #macos
[Windows]: #windows
[Linux]: #linux
[FreeBSD]: #freebsd
[Virtual machine]: #virtual-machine
[Installation Script]: #installation-script

[Advanced Installation from Source]: #advanced-installation-from-source
[Prerequisites]: #prerequisites
[CMake]: #cmake
[Make]: #make

[Links to source]: #

[`install.sh`]: ./install.sh
[`INSTALL`]: ./INSTALL

[URLs]: #

[OC-on-repology]: https://repology.org/project/opencoarrays/versions
[repology-badge]: https://repology.org/badge/vertical-allrepos/opencoarrays.svg

[FreeBSD ports/packages installation information]: https://www.freebsd.org/doc/en_US.ISO8859-1/books/handbook/ports.html
[GH all releases badge]: https://img.shields.io/github/downloads/sourceryinstitute/OpenCoarrays/total.svg?style=flat-square
[GH release badge]: https://img.shields.io/github/release/sourceryinstitute/OpenCoarrays.svg?style=flat-square
[Homebrew badge]: https://img.shields.io/homebrew/v/opencoarrays.svg?style=flat-square
[linuxbrew]: http://linuxbrew.sh
[braumeister link]: http://braumeister.org/formula/opencoarrays
[APT package]: https://qa.debian.org/popcon.php?package=open-coarrays
[APT]: https://en.wikipedia.org/wiki/APT_(Debian)
[HPCLinux]: http://www.paratools.com/hpclinux/
[Brewfile]: https://github.com/sourceryinstitute/OpenCoarrays/blob/master/Brewfile
[INSTALL.pdf]: https://md2pdf.herokuapp.com/sourceryinstitute/OpenCoarrays/blob/master/INSTALL.pdf
[INSTALL.md]: https://github.com/sourceryinstitute/OpenCoarrays/blob/master/INSTALL.md
[CMake]: https://cmake.org
[Git-Bash]: https://gitforwindows.org/
[GCC, GFortran, Unix Make]: http://www.equation.com/servlet/equation.cmd?fa=programminglog
[Intel OneAPI Base]: https://www.intel.com/content/www/us/en/developer/tools/oneapi/base-toolkit.htm
[Intel OneAPI HPC toolkit]: https://www.intel.com/content/www/us/en/developer/tools/oneapi/hpc-toolkit.html
[Sourcery Institute Store]: http://www.sourceryinstitute.org/store/c1/Featured_Products.html
[VirtualBox]: https://www.virtualbox.org
[download and installation instructions]: http://www.sourceryinstitute.org/uploads/4/9/9/6/49967347/overview.pdf
[yum]: http://yum.baseurl.org
[apt-get]: https://en.wikipedia.org/wiki/Advanced_Packaging_Tool
[Issues]: https://github.com/sourceryinstitute/OpenCoarrays/issues
[make.inc]: ./src/make.inc
[opencoarrays]: ./src/extensions/opencoarrays.F90
[prerequisites]: #prerequisites
[MPICH]: http://www.mpich.org
[MVAPICH]:http://mvapich.cse.ohio-state.edu
[MacPorts]: https://www.macports.org
[GCC]: http://gcc.gnu.org
[TS18508 Additional Parallel Features in Fortran]: https://isotc.iso.org/livelink/livelink/nfetch/-8919044/8919782/8919787/17001078/ISO%2DIECJTC1%2DSC22%2DWG5_N2056_Draft_TS_18508_Additional_Paralle.pdf?nodeid=17181227&vernum=0
[GFortran Binaries]:  https://gcc.gnu.org/wiki/GFortranBinaries#FromSource
[Installing GCC]: https://gcc.gnu.org/install/
[Arch Linux]: https://www.archlinux.org
[aur package]: https://aur.archlinux.org/packages/opencoarrays/
[latest release]: https://github.com/sourceryinstitute/OpenCoarrays/releases/latest
[pdf img]: https://img.shields.io/badge/PDF-INSTALL.md-6C2DC7.svg?style=flat-square
[commit comment 20539810]: https://github.com/sourceryinstitute/OpenCoarrays/commit/26e99919fe732576f7277a0e1b83f43cc7c9d749#commitcomment-20539810
[Homebrew]: https://brew.sh
[dnf]: https://github.com/rpm-software-management/dnf
[port details]: https://www.freshports.org/lang/opencoarrays
[port search]: https://www.freebsd.org/cgi/ports.cgi?query=opencoarrays
[EasyBuild]: https://github.com/easybuilders/easybuild
[Spack]: https://github.com/spack/spack
[add a new compiler to Spack]: http://spack.readthedocs.io/en/latest/tutorial_modules.html#add-a-new-compiler
[loading the environment modules with Spack]: http://spack.readthedocs.io/en/latest/module_file_support.html#cmd-spack-module-loads
[OpenCoarrays Portfile]: https://www.macports.org/ports.php?by=name&substr=opencoarrays
[WSL]: https://blogs.msdn.microsoft.com/commandline/2017/07/10/ubuntu-now-available-from-the-windows-store/
[developer-scripts]: https://github.com/sourceryinstitute/OpenCoarrays/tree/master/developer-scripts
[src]: https://github.com/sourceryinstitute/OpenCoarrays/tree/master/src
[fork badge]: https://img.shields.io/github/forks/sourceryinstitute/OpenCoarrays.svg?style=social&label=Fork
[fork url]: https://github.com/sourceryinstitute/OpenCoarrays/fork
[star badge]: https://img.shields.io/github/stars/sourceryinstitute/OpenCoarrays.svg?style=social&label=Star
[star url]: https://github.com/sourceryinstitute/OpenCoarrays
[watch badge]: https://img.shields.io/github/watchers/sourceryinstitute/OpenCoarrays.svg?style=social&label=Watch
[twitter badge]: https://img.shields.io/twitter/url/http/shields.io.svg?style=social
[twitter url]: https://twitter.com/intent/tweet?hashtags=HPC,Fortran,PGAS&related=zbeekman,gnutools,HPCwire,HPC_Guru,hpcprogrammer,SciNetHPC,DegenerateConic,jeffdotscience,travisci&text=Stop%20programming%20w%2F%20the%20%23MPI%20docs%20in%20your%20lap%2C%20try%20Coarray%20Fortran%20w%2F%20OpenCoarrays%20%26%20GFortran!&url=https%3A//github.com/sourceryinstitute/OpenCoarrays

<a name="top"> </a>

Contributing to OpenCoarrays
============================

[![Download as PDF][pdf img]](http://md2pdf.herokuapp.com/sourceryinstitute/opencoarrays/blob/master/CONTRIBUTING.pdf)

Download this file as a PDF document
[here](http://md2pdf.herokuapp.com/sourceryinstitute/opencoarrays/blob/master/CONTRIBUTING.pdf).

- [Reporting Defects](#reporting-defects)
- [Requesting Enhancements](#requesting-enhancements)
- [Helping Out](#helping-out)
  - [Outside Contributors](#outside-contributors)
- [OpenCoarrays Branches](#opencoarrays-branches)
  - [Master](#master)
  - [Devel](#devel)

Reporting Defects
-----------------

If you encounter problems during the course of [Installing] OpenCoarrays or [using OpenCoarrays], please take the following actions:

 1. Search the [issues] page (including [closed issues]) to see if anyone has encountered the same problem. If so add your experience to that thread.
 2. Search the [mailing list] to see if the issue has been discussed there.
 3. If unable to resolve the problem, please file a [new issue] and be sure to include the following information:
   - Fortran and companion C compiler, including version number, being used with OpenCoarrays
   - Communication library being used e.g., OpenMPI, MVAPICH or GASNet and the version number
   - Open Coarrays version number, or if building from `master`, commit SHA (`caf --version`)
   - Conditions required to reproduce the problem:
     - OS
     - Type of machine/hardware the code is running on
     - Number of MPI ranks/processing elements/coarray images being run on
     - How the code was compiled, including all flags and commands
     - Minimal reproducer code (a few lines) required to trigger the bug
  4. Any help you can provide diagnosing, isolating and fixing the problem is appreciated! Please see the [helping out] section for more information.

Requesting Enhancements
-----------------------

If you would like OpenCoarrays to support a new communication library, OS, or have any other suggestions for its improvement, please take the following action:

 1. Search the [issues] page and [mailing list] to see if the feature or enhancement has already been requested.
 2. If not, please file a [new issue], and clearly explain your proposed enhancement.
 3. If you are able to help out in the implementation or testing of the proposed feature, please see the [helping out] section of this document.

Helping Out
-----------

Thank you for your interest in contributing to OpenCoarrays! Your help is very appreciated! Below are some tips and guidelines to get started.

### Outside Contributors ###

Here is a checklist to help you get started contributing to OpenCoarrays and walk you through the process:

 - [ ] Take a look at the [issues] page. Make sure that you're not about to duplicate someone else's work.
 - [ ] Post a [new issue] discussing the changes you're proposing to implement; whether bug fix(es) or enhancement(s)/feature request(s)--or give us a heads up that you are going to start work on [an open issue].
 - [ ] Please [Fork] the [OpenCoarrays repo] to your private repository.
 - [ ] Next [Create a branch] and make sure to include the issue number(s) in the branch name, for example: `issue-53-fix-install-dir-logic` or `fix-typo-#23`
 - [ ] Configure your local repository with the whitespace settings (and git hooks to enforce these) by running `./developer-scripts/setup-git.sh`. (Add the `--global` flag to this script to use these settings across all your new repositories, or newly cloned repositories.)  Pull requests introducing errant spaces and non-printing characters will not be accepted until these problems are addressed.
 - [ ] Make your changes and commit them to your local repository, following these guidelines:
   - [ ] Each commit should be a logically atomic, self-consistent, cohesive set of changes.
   - [ ] The code should compile and pass all tests after each commit.
   - [ ] The [commit message] should follow [these guidelines]:
     - [ ] First line is directive phrase, starting with a capitalized imperative verb, and is no longer than 50 characters summarizing your commit
     - [ ] Next line, if necessary is blank
     - [ ] Following lines are all wrapped at 72 characters and can include additional paragraphs, bulleted lists, etc.
     - [ ] Use [Github keywords] where appropriate, to indicate the commit resolves an open issue.
 - [ ] Please do you best to keep a [clean and coherent history]. `git add -p ...`, `git commit --amend` and `git rebase --interactive <root-ref>` can be helpful to rework your commits into a cleaner, clearer state.
 - [ ] Next, [open up a pull request] where the base branch is [`master`] or [`devel`] as appropriate
 - [ ] Please be patient and responsive to requests and comments from SourceryInstitute (SI) team members. You may be asked to amend or otherwise alter commits, or push new commits to your branch.
 - [ ] Make sure that all the automated [Travis-CI tests] pass
 - [ ] Sign the [Contributor License Agreement (CLA)] by clicking the "details" link to the right of the `licence/cla` check and following the directions on the CLA assistant webpage

OpenCoarrays Branches
---------------------

OpenCoarrays uses the [Github flow] workflow. There are [a number of resources] available to learn about the [Github flow] workflow, including a [video]. The gist of it is that the `master` branch is always deployable and deployed. The means at anytime, a new tagged release could be shipped using the `master` branch. For major changes that introduce experimental, or disruptive changes, we have a semi-stable `devel` branch.

### Master ###

The `master` branch should remain in pristine, stable condition all of the time. Any changes are applied atomically via pull requests. It should be assumed that customers are using the code on this branch, and great care should be taken to ensure its stability. Most bug fixes and incremental improvements will get merged into the `master` branch first, and then also the `devel` branch.


### Devel ###

This is the development branch, akin to GCC's `trunk`. Both of `devel` and `master` branches are protected, but `devel` will eventually be merged into `master` when the next major release happens, but until then it is a stable, forward looking branch where experimental features and major changes or enhancements may be applied and tested. Just as with `master` all changes are applied atomically as pull requests.

[Links]: #
[video]: https://youtu.be/EwWZbyjDs9c?list=PLg7s6cbtAD17uAwaZwiykDci_q3te3CTY
[a number of resources]: http://scottchacon.com/2011/08/31/github-flow.html
[Github flow]: https://guides.github.com/introduction/flow/
[Travis-CI tests]: https://travis-ci.org/sourceryinstitute/opencoarrays/pull_requests
[Contributor License Agreement (CLA)]: https://cla-assistant.io/sourceryinstitute/opencoarrays
[`master`]: https://github.com/sourceryinstitute/opencoarrays
[`devel`]: https://github.com/sourceryinstitute/opencoarrays/tree/devel
[open up a pull request]: https://github.com/sourceryinstitute/opencoarrays/compare
[clean and coherent history]: https://www.reviewboard.org/docs/codebase/dev/git/clean-commits/
[Github keywords]: https://help.github.com/articles/closing-issues-via-commit-messages/#closing-an-issue-in-a-different-repository
[commit message]: https://robots.thoughtbot.com/5-useful-tips-for-a-better-commit-message
[these guidelines]: http://tbaggery.com/2008/04/19/a-note-about-git-commit-messages.html
[an open issue]: https://github.com/sourceryinstitute/opencoarrays/issues
[Create a branch]: https://help.github.com/articles/creating-and-deleting-branches-within-your-repository/
[OpenCoarrays repo]: https://github.com/sourceryinstitute/opencoarrays/fork
[Pull Request]: https://help.github.com/articles/using-pull-requests/
[Fork]: https://help.github.com/articles/fork-a-repo/
[helping out]: #helping-out
[closed issues]: https://github.com/sourceryinstitute/opencoarrays/issues?q=is%3Aissue+is%3Aclosed
[Installing]: ./INSTALLING.md
[issues]: https://github.com/sourceryinstitute/opencoarrays/issues
[mailing list]: https://groups.google.com/forum/#!forum/opencoarrays
[using OpenCoarrays]: ./GETTING_STARTED.md
[new issue]: https://github.com/sourceryinstitute/opencoarrays/issues/new
[pdf img]: https://img.shields.io/badge/PDF-CONTRIBUTING.md-6C2DC7.svg?style=flat-square "Download as PDF"

<a name="top"> </a>

Contributing to OpenCoarrays
============================

[![Download as PDF][pdf img]](http://md2pdf.herokuapp.com/sourceryinstitute/opencoarrays/blob/master/CONTRIBUTING.pdf)

Download this file as a PDF document
[here](http://md2pdf.herokuapp.com/sourceryinstitute/opencoarrays/blob/master/CONTRIBUTING.pdf).

- [Reporting Defects](#reporting-defects)
- [Requesting Enhancements](#requesting-enhancements)
- [Helping Out](#helping-out)
  - [Outside Contributors](#outside-contributors)
- [OpenCoarrays Branches](#opencoarrays-branches)
  - [Master](#master)
  - [Devel](#devel)

Reporting Defects
-----------------

If you encounter problems during the course of [Installing] OpenCoarrays or [using OpenCoarrays], please take the following actions:

 1. Search the [issues] page (including [closed issues]) to see if anyone has encountered the same problem. If so add your experience to that thread.
 2. Search the [mailing list] to see if the issue has been discussed there.
 3. If unable to resolve the problem, please file a [new issue] and be sure to include the following information:
   - Fortran and companion C compiler, including version number, being used with OpenCoarrays
   - Communication library being used e.g., OpenMPI, MVAPICH or GASNet and the version number
   - Open Coarrays version number, or if building from `master`, commit SHA (`caf --version`)
   - Conditions required to reproduce the problem:
     - OS
     - Type of machine/hardware the code is running on
     - Number of MPI ranks/processing elements/coarray images being run on
     - How the code was compiled, including all flags and commands
     - Minimal reproducer code (a few lines) required to trigger the bug
  4. Any help you can provide diagnosing, isolating and fixing the problem is appreciated! Please see the [helping out] section for more information.

Requesting Enhancements
-----------------------

If you would like OpenCoarrays to support a new communication library, OS, or have any other suggestions for its improvement, please take the following action:

 1. Search the [issues] page and [mailing list] to see if the feature or enhancement has already been requested.
 2. If not, please file a [new issue], and clearly explain your proposed enhancement.
 3. If you are able to help out in the implementation or testing of the proposed feature, please see the [helping out] section of this document.

Helping Out
-----------

Thank you for your interest in contributing to OpenCoarrays! Your help is very appreciated! Below are some tips and guidelines to get started.

### Outside Contributors ###

Here is a checklist to help you get started contributing to OpenCoarrays and walk you through the process:

 - [ ] Take a look at the [issues] page. Make sure that you're not about to duplicate someone else's work.
 - [ ] Post a [new issue] discussing the changes you're proposing to implement; whether bug fix(es) or enhancement(s)/feature request(s)--or give us a heads up that you are going to start work on [an open issue].
 - [ ] Please [Fork] the [OpenCoarrays repo] to your private repository.
 - [ ] Next [Create a branch] and make sure to include the issue number(s) in the branch name, for example: `issue-53-fix-install-dir-logic` or `fix-typo-#23`
 - [ ] Configure your local repository with the whitespace settings (and git hooks to enforce these) by running `./developer-scripts/setup-git.sh`. (Add the `--global` flag to this script to use these settings across all your new repositories, or newly cloned repositories.)  Pull requests introducing errant spaces and non-printing characters will not be accepted until these problems are addressed.
 - [ ] Make your changes and commit them to your local repository, following these guidelines:
   - [ ] Each commit should be a logically atomic, self-consistent, cohesive set of changes.
   - [ ] The code should compile and pass all tests after each commit.
   - [ ] The [commit message] should follow [these guidelines]:
     - [ ] First line is directive phrase, starting with a capitalized imperative verb, and is no longer than 50 characters summarizing your commit
     - [ ] Next line, if necessary is blank
     - [ ] Following lines are all wrapped at 72 characters and can include additional paragraphs, bulleted lists, etc.
     - [ ] Use [Github keywords] where appropriate, to indicate the commit resolves an open issue.
 - [ ] Please do you best to keep a [clean and coherent history]. `git add -p ...`, `git commit --amend` and `git rebase --interactive <root-ref>` can be helpful to rework your commits into a cleaner, clearer state.
 - [ ] Next, [open up a pull request] where the base branch is [`master`] or [`devel`] as appropriate
 - [ ] Please be patient and responsive to requests and comments from SourceryInstitute (SI) team members. You may be asked to amend or otherwise alter commits, or push new commits to your branch.
 - [ ] Make sure that all the automated [Travis-CI tests] pass
 - [ ] Sign the [Contributor License Agreement (CLA)] by clicking the "details" link to the right of the `licence/cla` check and following the directions on the CLA assistant webpage

OpenCoarrays Branches
---------------------

OpenCoarrays uses the [Github flow] workflow. There are [a number of resources] available to learn about the [Github flow] workflow, including a [video]. The gist of it is that the `master` branch is always deployable and deployed. The means at anytime, a new tagged release could be shipped using the `master` branch. For major changes that introduce experimental, or disruptive changes, we have a semi-stable `devel` branch.

### Master ###

The `master` branch should remain in pristine, stable condition all of the time. Any changes are applied atomically via pull requests. It should be assumed that customers are using the code on this branch, and great care should be taken to ensure its stability. Most bug fixes and incremental improvements will get merged into the `master` branch first, and then also the `devel` branch.


### Devel ###

This is the development branch, akin to GCC's `trunk`. Both of `devel` and `master` branches are protected, but `devel` will eventually be merged into `master` when the next major release happens, but until then it is a stable, forward looking branch where experimental features and major changes or enhancements may be applied and tested. Just as with `master` all changes are applied atomically as pull requests.

[Links]: #
[video]: https://youtu.be/EwWZbyjDs9c?list=PLg7s6cbtAD17uAwaZwiykDci_q3te3CTY
[a number of resources]: http://scottchacon.com/2011/08/31/github-flow.html
[Github flow]: https://guides.github.com/introduction/flow/
[Travis-CI tests]: https://travis-ci.org/sourceryinstitute/opencoarrays/pull_requests
[Contributor License Agreement (CLA)]: https://cla-assistant.io/sourceryinstitute/opencoarrays
[`master`]: https://github.com/sourceryinstitute/opencoarrays
[`devel`]: https://github.com/sourceryinstitute/opencoarrays/tree/devel
[open up a pull request]: https://github.com/sourceryinstitute/opencoarrays/compare
[clean and coherent history]: https://www.reviewboard.org/docs/codebase/dev/git/clean-commits/
[Github keywords]: https://help.github.com/articles/closing-issues-via-commit-messages/#closing-an-issue-in-a-different-repository
[commit message]: https://robots.thoughtbot.com/5-useful-tips-for-a-better-commit-message
[these guidelines]: http://tbaggery.com/2008/04/19/a-note-about-git-commit-messages.html
[an open issue]: https://github.com/sourceryinstitute/opencoarrays/issues
[Create a branch]: https://help.github.com/articles/creating-and-deleting-branches-within-your-repository/
[OpenCoarrays repo]: https://github.com/sourceryinstitute/opencoarrays#fork-destination-box
[Pull Request]: https://help.github.com/articles/using-pull-requests/
[Fork]: https://help.github.com/articles/fork-a-repo/
[helping out]: #helping-out
[closed issues]: https://github.com/sourceryinstitute/opencoarrays/issues?q=is%3Aissue+is%3Aclosed
[Installing]: ./INSTALLING.md
[issues]: https://github.com/sourceryinstitute/opencoarrays/issues
[mailing list]: https://groups.google.com/forum/#!forum/opencoarrays
[using OpenCoarrays]: ./GETTING_STARTED.md
[new issue]: https://github.com/sourceryinstitute/opencoarrays/issues/new
[pdf img]: https://img.shields.io/badge/PDF-CONTRIBUTING.md-6C2DC7.svg?style=flat-square "Download as PDF"

<a name="top"> </a>


[This document is formatted with GitHub-Flavored Markdown.               ]:#
[For better viewing, including hyperlinks, read it online at             ]:#
[https://github.com/sourceryinstitute/OpenCoarrays/blob/master/AUTHORS.md]:#

Contributors to OpenCoarrays
============================

[![CLA assistant][CLA img]](https://cla-assistant.io/sourceryinstitute/OpenCoarrays)
[![Download as PDF][pdf img]](http://md2pdf.herokuapp.com/sourceryinstitute/OpenCoarrays/blob/master/AUTHORS.pdf)

Download this file as a PDF document
[here][pdfloc].

 - [X] Alessandro Fanfarillo  <elfanfa@ucar.edu> @afanfa
 - [X] Damian Rouson  <damian@sourceryinstitute.org> @rouson
 - [X] Izaak "Zaak" Beekman  <https://izaakbeekman.com> @zbeekman
 - [X] Tobias Burnus  <burnus@net-b.de> @tob2
 - [X] Andre Vehreschild <vehre@gmx.de> @vehre
 - [X] Craig Rasmussen <rasmus@uoregon.edu> @rasmussn
 - [X] Jeff Hammond  <jeff.science@gmail.com> @jeffhammond
 - [ ] Salvatore Filippone <Salvatore.Filippone@cranfield.ac.uk> @sfilippone
 - [ ] Raul Laasner <raullaasner@gmail.com> @raullaasner
 - [X] Naveen Ravi <nravi@cray.com> @naveen-rn
 - [X] Soren Rasmussen <s.c.rasmussen@gmail.com> @scrasmussen
 - [X] Götz Waschk <goetz.waschk@desy.de> @LaHaine
 - [ ] John C. Linford <jlinford@paratools.com>
 - [ ] Daniel Carrera  <dcarrera@gmail.com>

[top]

Linux Foundation Contributor License Agreement (CLA)
----------------------------------------------------

All contributors are expected to sign the [Linux Foundation Contributor
License Agreement (CLA), the "Developer Certificate of Origin",
Version 1.1.](https://gist.github.com/zbeekman/0a5d60a1cbd1f6a8cfa5)
using the [CLA-Assistant]

```
Developer Certificate of Origin
Version 1.1

Copyright (C) 2004, 2006 The Linux Foundation and its contributors.
660 York Street, Suite 102,
San Francisco, CA 94110 USA

Everyone is permitted to copy and distribute verbatim copies of this
license document, but changing it is not allowed.


Developer's Certificate of Origin 1.1

By making a contribution to this project, I certify that:

(a) The contribution was created in whole or in part by me and I
    have the right to submit it under the open source license
    indicated in the file; or

(b) The contribution is based upon previous work that, to the best
    of my knowledge, is covered under an appropriate open source
    license and I have the right under that license to submit that
    work with modifications, whether created in whole or in part
    by me, under the same open source license (unless I am
    permitted to submit under a different license), as indicated
    in the file; or

(c) The contribution was provided directly to me by some other
    person who certified (a), (b) or (c) and I have not modified
    it.

(d) I understand and agree that this project and the contribution
    are public and that a record of the contribution (including all
    personal information I submit with it, including my sign-off) is
    maintained indefinitely and may be redistributed consistent with
    this project or the open source license(s) involved.
```

[top]

---

[![GitHub forks](https://img.shields.io/github/forks/sourceryinstitute/OpenCoarrays.svg?style=social&label=Fork)](https://github.com/sourceryinstitute/OpenCoarrays/fork)
[![GitHub stars](https://img.shields.io/github/stars/sourceryinstitute/OpenCoarrays.svg?style=social&label=Star)](https://github.com/sourceryinstitute/OpenCoarrays)
[![GitHub watchers](https://img.shields.io/github/watchers/sourceryinstitute/OpenCoarrays.svg?style=social&label=Watch)](https://github.com/sourceryinstitute/OpenCoarrays)
[![Twitter URL](https://img.shields.io/twitter/url/http/shields.io.svg?style=social)](https://twitter.com/intent/tweet?hashtags=HPC,Fortran,PGAS&related=zbeekman,gnutools,HPCwire,HPC_Guru,hpcprogrammer,SciNetHPC,DegenerateConic,jeffdotscience,travisci&text=Stop%20programming%20w%2F%20the%20%23MPI%20docs%20in%20your%20lap%2C%20try%20Coarray%20Fortran%20w%2F%20OpenCoarrays%20%26%20GFortran!&url=https%3A//github.com/sourceryinstitute/OpenCoarrays)

[Links]:#
[pdf img]: https://img.shields.io/badge/PDF-AUTHORS.md-6C2DC7.svg?style=flat-square "Download as PDF"
[contributor img]: https://img.shields.io/github/contributors/sourceryinstitute/OpenCoarrays.svg?style=flat-square "Contributors"
[CLA img]: https://cla-assistant.io/readme/badge/sourceryinstitute/OpenCoarrays "CLA signees"
[pdfloc]: http://md2pdf.herokuapp.com/sourceryinstitute/OpenCoarrays/blob/master/AUTHORS.pdf "Get this file as a PDF document"
[CLA-Assistant]: https://cla-assistant.io/sourceryinstitute/OpenCoarrays "CLA-Assistant"
[top]: #top

<!-- Please fill out the issue template included below, failure to do -->
<!-- so may result in immediate closure of your issue. -->

<!-- Fill out all portions of this template that apply. Please delete -->
<!-- any unnecessary sections. -->

| Avg response time              |
| ------------------------------ |
| ![Issue Stats][issue stat img] |

Please replace `[ ]` with `[X]` to indicate you have taken the requested action

 - [ ] I have surrounded any code, or log output in codeblock fences
       (` ``` `) if it occupies more than one line, or in single
       backticks if it is short `short code`

<!-- Long code goes in a fenced code block: -->
<!-- ``` -->
<!-- Line one of code output -->
<!-- Line two of output -->
<!-- etc. -->
<!-- ``` -->


# Question: #

<!-- delete this section if it does not apply -->
The title of the issue should start with `Question:` followed by a
succinct title. Add the text of your question here. Be specific. Search for
answers on https://google.com and https://stackoverflow.com
before asking a new question

# RFE: #

<!-- delete this section if it does not apply -->
The title of the issue should start with `RFE:` followed by a succinct
title. Add a description of your requested enhancement here. If you are
willing to help out please also read the [Helping Out] section of
[CONTRIBUTING.md]



# Defect/bug report #

<!-- delete this section if it does not apply -->
The title of the issue should start with `Defect:` followed by a
succinct title.

 - [ ] I have searched the [issues page] and [mailing list] and did
       not find any issue matching the one I would like to report
 - [ ] I have included a succinct description of the problem,
       including the steps necessary to reproduce it
 - [ ] I have included which version of OpenCoarrays I am working
       with, or the output of `git describe` if working with a cloned
       repository rather than an [official release]
 - [ ] I have included the MPI library name and version I am using
       with OpenCoarrays
   - [ ] name: [MPICH] version:
   - [ ] name: [Open-MPI] version:
   - [ ] name: [MVAPICH] version:
   - [ ] name: [MPT] version:
   - [ ] name: [Intel MPI] version:
   - [ ] other:
   <!-- delete all but the matching MPI implementation -->
 - [ ] I have included the Fortran compiler name and version that I am
       using with OpenCoarrays
 - [ ] I have included the output of `uname -a`
 - [ ] I have included the Operating system name and version,
       including linux distro
 - [ ] I have included the machine name if I am allowed to do so and
       wish to seek help debugging on that particular system (Titan,
       Pleiades, Excalibur, Lightening, Mira, etc.)

## Installation/build problem ##

<!-- delete this section if it does not apply -->

 - [ ] I have attached a log of the attempted build/installation,
       changing the extension to `.txt` and uploaded it to this issue
 - [ ] I have indicated if previous versions of OpenCoarrays are or
       were installed on the machine in question

**Please select one from the following top level items** (please be sure to fill out all sub-items)**:**
 - [ ] Build/install was attempted with [install.sh]
    - [ ] I have attached the `install-opencoarrays.log` file
          after re-running the script with the debug flags `-d` and
          `-v` turned on (after renaming the log file to have a `.txt`
          extension)
 - [ ] Build/install was attempted with system package manager like
       [homebrew] (which one?)
 - [ ] Build/install was attempted with manual/advanced
       [CMake install]
   - [ ] Name and version of the C compiler being used
     - [ ] Name and version of the Fortran compiler being used
     - [ ] Attached/included the output of the configure step with
           CMake. (Usually something like `cd build && cmake ..`)
     - [ ] Attached/included the output of `make VERBOSE=1`
     - [ ] Attached/included the output of `ctest --verbose`
 - [ ] Other build/install was attempted (please describe)

Don't forget the description of the problem. The more details you give
us, the faster, and more easily we can help you

## Compile time or run time error

<!-- delete this section if it does not apply -->

**Please choose one of the first two items**
 - [ ] I am experiencing a compile time error (all gfortran ICEs
       should be reported to the [GFortran bug tracker]... You can post
       the ICE here too for tracking purposes, with a link to the
       GFortran problem report)
 - [ ] I am experiencing a runtime issue

**:sparkles: Optional, but you will receive infinite karma for including this: :sparkles:**
 - [ ] I have included a minimally complete verifiable example (MCVE)
       that exhibits the problem and suitable for adding to regression
       tests

Don't forget a description with as many details as possible to reproduce the problem.


[links]:#
[GFortran bug tracker]: https://gcc.gnu.org/bugzilla/
[Intel MPI]: https://software.intel.com/en-us/intel-mpi-library
[MPT]: http://www.sgi.com/products/software/sps.html
[MVAPICH]: http://mvapich.cse.ohio-state.edu
[MPICH]: https://www.mpich.org
[Open-MPI]: https://www.open-mpi.org
[CONTRIBUTING.md]: https://github.com/sourceryinstitute/OpenCoarrays/blob/master/CONTRIBUTING.md
[Helping Out]: https://github.com/sourceryinstitute/OpenCoarrays/blob/master/CONTRIBUTING.md#helping-out
[official release]: https://github.com/sourceryinstitute/OpenCoarrays/releases
[CMake install]: https://github.com/sourceryinstitute/OpenCoarrays/blob/master/INSTALL.md#cmake-scripts
[homebrew]: http://brew.sh
[issues page]: https://github.com/sourceryinstitute/OpenCoarrays/issues
[mailing list]: https://groups.google.com/forum/#!forum/opencoarrays
[install.sh]: https://github.com/sourceryinstitute/OpenCoarrays/blob/master/install.sh
[issue stat img]:https://img.shields.io/issuestats/i/github/sourceryinstitute/OpenCoarrays.svg?style=flat-square

<div align="center">

# Contributing to OpenCoarrays #

[![][closed issues badge]][home]
[![Issue Stats][issue closure time]][issues]
[![][PRs closed]][PRs]
[![Issue Stats][PR closure time]][PRs]
[![Download as PDF][pdf img]][CONTRIBUTING.pdf]

</div>

Download this file as a PDF document
[here][CONTRIBUTING.pdf].

- [Reporting Defects](#reporting-defects)
- [Requesting Enhancements](#requesting-enhancements)
- [Helping Out](#helping-out)
  - [Outside Contributors](#outside-contributors)
- [OpenCoarrays Branches](#opencoarrays-branches)
  - [Master](#master)

## Reporting Defects ##

If you encounter problems during the course of [Installing]
OpenCoarrays or [using OpenCoarrays], please take the following
actions:

 1. Search the [issues] page (including [closed issues]) to see if
    anyone has encountered the same problem. If so add your experience
    to that thread.
 2. Search the [mailing list] to see if the issue has been discussed
    there.
 3. If unable to resolve the problem, please file a [new issue] and be
    sure to include the following information:
    - [ ] Fortran compiler used with OpenCoarrays, including version
          number
    - [ ] C compiler used to build OpenCoarrays
    - [ ] Communication library being used e.g., MPICH, OpenMPI, MVAPICH
          or GASNet and the version number
    - [ ] Open Coarrays version number, or if building from `master`,
          commit SHA (`caf --version` should give you the most detailed
          version information, whether built from the git repository or a
          release tarball.)
    - [ ] Conditions required to reproduce the problem:
      - [ ] OS, name and version
      - [ ] Architecture of machine/hardware the code is running on
      - [ ] Number of MPI ranks/processing elements/coarray images being
            run on
      - [ ] How the code was compiled, including all flags and commands
      - [ ] Minimal reproducer code (a few lines) required to trigger the
            bug
 4. Any help you can provide diagnosing, isolating and fixing the
    problem is appreciated! Please see the [helping out] section for
    more information.

An [issue template] is in the `.github` folder to help ensure
compliance, and adequate information is provided.

## Requesting Enhancements ##

If you would like OpenCoarrays to support a new communication library,
OS, or have any other suggestions for its improvement, please take the
following action:

 1. Search the [issues] page and [mailing list] to see if the feature
    or enhancement has already been requested.
 2. If not, please file a [new issue], and clearly explain your
    proposed enhancement.
 3. If you are able to help out in the implementation or testing of
    the proposed feature, please see the [helping out] section of this
    document.

## Helping Out ##

Thank you for your interest in contributing to OpenCoarrays! Your help
is very appreciated! Below are some tips and guidelines to get
started.

### Outside Contributors ###

Here is a checklist to help you get started contributing to
OpenCoarrays and walk you through the process:

- [ ] Take a look at the [issues] page. Make sure that you're not
      about to duplicate someone else's work.
- [ ] Post a [new issue] discussing the changes you're proposing to
      implement; whether bug fix(es) or enhancement(s)/feature
      request(s)--or give us a heads up that you are going to start work
      on [an open issue][issues].
- [ ] Please [fork the OpenCoarrays repo][fork] to your private repository.
- [ ] Sign the [Contributor License Agreement (CLA)] by clicking the
      "details" link to the right of the `license/cla` check and
      following the directions on the CLA assistant web page
- [ ] Follow the guidelines for [all contributors], listed below

### All Contributors ###

- [ ] Next [Create a branch] and make sure to include the issue
      number(s) in the branch name, for example:
      `issue-53-fix-install-dir-logic` or `fix-typo-#23`
- [ ] Configure your local repository with the white space settings
      (and git hooks to enforce these) by running
      `./developer-scripts/setup-git.sh`. (Add the `--global` flag to
      this script to use these settings across all your new repositories,
      or newly cloned repositories.)  Pull requests introducing errant
      spaces and non-printing characters will not be accepted until these
      problems are addressed.
- [ ] Make your changes and commit them to your local repository,
      following these guidelines:
  - [ ] Each commit should be a logically atomic, self-consistent,
        cohesive set of changes.
  - [ ] The code should compile and pass all tests after each commit.
  - [ ] The code should be legible and any non-obvious features
        commented appropriately.
  - [ ] All unit tests should be run locally and pass. (Run `ctest` in
        the build directory.)
  - [ ] Tests should be added for new features and significant new
        code, steps should be taken to ensure that the total coverage
        remains the same or increases.
  - [ ] The [commit message] should follow [these guidelines]:
    - [ ] First line is directive phrase, starting with a capitalized
          imperative verb, and is no longer than 50 characters
          summarizing your commit
    - [ ] Next line, if necessary is blank
    - [ ] Following lines are all wrapped at 72 characters and can
          include additional paragraphs, bulleted lists, etc.
    - [ ] Use [Github keywords] where appropriate, to indicate the
          commit resolves an open issue.
    - [ ] Please do your best to keep a [clean and coherent
          history]. `git add -p ...`, `git commit --amend` and `git rebase
          --interactive <root-ref>` can be helpful to rework your commits
          into a cleaner, clearer state.
- [ ] Next, [open up a pull request] against the appropriate base
      branch, [`master`] of [sourceryinstitute/OpenCoarrays][home]
  - [ ] In the title, please include the text `issue-<#>`, where `<#>`
        is replaced by the issue number of the feature request or bug
        report corresponding to this PR.
  - [ ] If the PR is a work in progress, please add `WIP: ...` to the
        title, and rename it deleting that text once the PR is ready
        to be merged.
  - [ ] If the PR is problematic for any reason please add `DO NOT
        MERGE` to the title, until it is either abandoned or fixed.
- [ ] Please be patient and responsive to requests and comments from
      SourceryInstitute (SI) team members. You may be asked to amend or
      otherwise alter commits, or push new commits to your branch.

### Contributors with Write Access ###

SI team members and collaborators with push access must wait 24 hours
before self-approving pull requests via [pullapprove comment] or
[Github code review] so that someone else has the chance to review the
proposed changes, and provide a formal code review. Due to the small
size of the development team, it is unrealistic to *require* a code
review under all circumstances. This policy ensures that there is at
least an opportunity for a formal code review by another developer.

## OpenCoarrays Branches ##

OpenCoarrays uses the [Github flow] workflow. There are [a number of
resources] available to learn about the [Github flow] workflow,
including a [video]. The gist of it is that the `master` branch is
always deploy-able and deployed. The means at anytime, a new tagged
release could be shipped using the `master` branch.

### Master ###

The `master` branch should remain in pristine, stable condition all of
the time. Any changes are applied atomically via pull requests. It
should be assumed that users are using the code on this branch,
and great care should be taken to ensure its stability. Most bug fixes
and incremental improvements will get merged into the `master` branch
as soon as they are deemed ready for production.

## Through put ##

[![Waffle.io](https://img.shields.io/waffle/label/sourceryinstitute/OpenCoarrays/blocked.svg?style=flat-square)](https://github.com/sourceryinstitute/OpenCoarrays/labels/blocked)
[![Waffle.io](https://img.shields.io/waffle/label/sourceryinstitute/OpenCoarrays/ready.svg?style=flat-square)](https://github.com/sourceryinstitute/OpenCoarrays/labels/ready)
[![Waffle.io](https://img.shields.io/waffle/label/sourceryinstitute/OpenCoarrays/in-progress.svg?style=flat-square)](https://github.com/sourceryinstitute/OpenCoarrays/labels/in-progress)
[![Waffle.io](https://img.shields.io/waffle/label/sourceryinstitute/OpenCoarrays/needs%20review.svg?style=flat-square)](https://github.com/sourceryinstitute/OpenCoarrays/labels/needs-review)

[![Throughput Graph](https://graphs.waffle.io/sourceryinstitute/OpenCoarrays/throughput.svg)](https://waffle.io/sourceryinstitute/OpenCoarrays/metrics/throughput)

## Coverage ##

[![Codecov branch](https://img.shields.io/codecov/c/github/sourceryinstitute/OpenCoarrays/master.svg?style=flat-square)](https://codecov.io/gh/sourceryinstitute/OpenCoarrays)

[![coverage history](https://codecov.io/gh/sourceryinstitute/OpenCoarrays/branch/master/graphs/commits.svg)](https://codecov.io/gh/sourceryinstitute/OpenCoarrays)

---

<div align="center">

[![GitHub forks][fork img]][fork]
[![GitHub stars][star img]][home]
[![GitHub watchers][watch img]][home]
[![Twitter URL][twitter img]][default tweet]

</div>

[Links]: #
[closed issues badge]: https://img.shields.io/github/issues-closed-raw/sourceryinstitute/OpenCoarrays.svg?style=flat-square
[home]: https://github.com/sourceryinstitute/OpenCoarrays
[issue closure time]: https://img.shields.io/issuestats/i/github/sourceryinstitute/OpenCoarrays.svg?style=flat-square
[PRs closed]: https://img.shields.io/github/issues-pr-closed-raw/sourceryinstitute/OpenCoarrays.svg?style=flat-square
[fork img]: https://img.shields.io/github/forks/sourceryinstitute/OpenCoarrays.svg?style=social&label=Fork
[star img]: https://img.shields.io/github/stars/sourceryinstitute/OpenCoarrays.svg?style=social&label=Star
[watch img]: https://img.shields.io/github/watchers/sourceryinstitute/OpenCoarrays.svg?style=social&label=Watch
[PRs]: https://github.com/sourceryinstitute/OpenCoarrays/pulls
[PR closure time]: https://img.shields.io/issuestats/p/github/sourceryinstitute/OpenCoarrays.svg?style=flat-square
[CONTRIBUTING.pdf]: https://md2pdf.herokuapp.com/sourceryinstitute/OpenCoarrays/blob/master/CONTRIBUTING.pdf
[issue template]: https://github.com/sourceryinstitute/OpenCoarrays/blob/master/.github/ISSUE_TEMPLATE.md
[video]: https://www.youtube.com/watch?v=EwWZbyjDs9c&feature=youtu.be&list=PLg7s6cbtAD17uAwaZwiykDci_q3te3CTY
[a number of resources]: http://scottchacon.com/2011/08/31/github-flow.html
[Github flow]: https://guides.github.com/introduction/flow/
[Travis-CI tests]: https://travis-ci.org/sourceryinstitute/OpenCoarrays/pull_requests
[Contributor License Agreement (CLA)]: https://cla-assistant.io/sourceryinstitute/OpenCoarrays
[`master`]: https://github.com/sourceryinstitute/OpenCoarrays/tree/master
[open up a pull request]: https://github.com/sourceryinstitute/OpenCoarrays/compare
[clean and coherent history]: https://www.notion.so/reviewboard/Keeping-Commit-Histories-Clean-0f717c4e802c4a0ebd852cf9337ce5d2
[Github keywords]: https://help.github.com/articles/closing-issues-via-commit-messages/#closing-an-issue-in-a-different-repository
[commit message]: https://robots.thoughtbot.com/5-useful-tips-for-a-better-commit-message
[these guidelines]: http://tbaggery.com/2008/04/19/a-note-about-git-commit-messages.html
[Create a branch]: https://help.github.com/articles/creating-and-deleting-branches-within-your-repository/
[OpenCoarrays repo]: https://github.com/sourceryinstitute/OpenCoarrays/fork
[Pull Request]: https://help.github.com/articles/using-pull-requests/
[fork]: https://help.github.com/articles/fork-a-repo/
[helping out]: #helping-out
[closed issues]: https://github.com/sourceryinstitute/OpenCoarrays/issues?q=is%3Aissue+is%3Aclosed
[Installing]: ./INSTALLING.md
[issues]: https://github.com/sourceryinstitute/OpenCoarrays/issues
[mailing list]: https://groups.google.com/forum/#!forum/opencoarrays
[using OpenCoarrays]: ./GETTING_STARTED.md
[new issue]: https://github.com/sourceryinstitute/OpenCoarrays/issues/new
[pdf img]: https://img.shields.io/badge/PDF-CONTRIBUTING.md-6C2DC7.svg?style=flat-square
 "Download as PDF"
[twitter img]: https://img.shields.io/twitter/url/http/shields.io.svg?style=social
[default tweet]: https://twitter.com/intent/tweet?hashtags=HPC,Fortran,PGAS&related=zbeekman,gnutools,HPCwire,HPC_Guru,hpcprogrammer,SciNetHPC,DegenerateConic,jeffdotscience,travisci&text=Stop%20programming%20w%2F%20the%20%23MPI%20docs%20in%20your%20lap%2C%20try%20Coarray%20Fortran%20w%2F%20OpenCoarrays%20%26%20GFortran!&url=https%3A//github.com/sourceryinstitute/OpenCoarrays
[pullapprove comment]: https://pullapprove.com/sourceryinstitute/OpenCoarrays/settings/
[Github code review]: https://help.github.com/articles/about-pull-request-reviews/
[Github keywords]: https://help.github.com/articles/closing-issues-via-commit-messages/
[unit tests]: https://github.com/sourceryinstitute/OpenCoarrays/tree/master/src/tests/unit

<a name="top"> </a>

[This document is formatted with GitHub-Flavored Markdown.              ]:#
[For better viewing, including hyperlinks, read it online at            ]:#
[https://github.com/sourceryinstitute/opencoarrays/blob/master/STATUS.md]:#

OpenCoarrays Status
===================

[![Download as PDF][pdf img]](http://md2pdf.herokuapp.com/sourceryinstitute/opencoarrays/blob/master/STATUS.pdf)

Download this file as a PDF document
[here](http://md2pdf.herokuapp.com/sourceryinstitute/opencoarrays/blob/master/STATUS.pdf).

 *  [Feature Coverage](#feature-coverage)
 *  [Compiler Status](#compiler-status)
     * [OpenCoarrays-Aware (OCA) Coarray Fortran (CAF) Compilers]
     * [Non-OCA CAF Compilers]
     * [Non-CAF Compilers]
 *  [Library Status](#libary-status)
     *  [libcaf_mpi]
     *  [libcaf_x]
     *  [libcaf_gasnet]
     *  [libcaf_single]
 *  [Known Issues](#known-issues)
     * [Library Issues](#library-issues)
     * [Compiler Issues](#compiler-issues)
         * [GNU (gfortran)]
         * [Cray (ftn)]
         * [Intel (ifort)]
         * [Numerical Algorithms Group (nagfor)]
         * [Portland Group (pgfortran)]
         * [IBM (xlf)]
 *  [To-Do List](#to-do-list)

Feature Coverage
----------------

 * Except as noted under [Known Issues], [libcaf_mpi] supports the following features as described
   in the Fortran 2008 standard:
     * allocatable and non-allocatable coarrays of intrinsic or derived type
     * synchronization statements
     * atomics
     * locks
     * critical
 * Except as noted under [Known Issues], [libcaf_mpi] supports the collective
   subroutines proposed for Fortran 2015 in the draft Technical Specification
   [TS 18508] _Additional Parallel Features in Fortra_ subroutines for a limited
   set of intrinsic types and kinds.  Adding additional types and kinds is
   straightforward.  Please submit a request via the [Issues] page or consider
   adding the requisite code by [forking the OpenCoarrays repository] and submitting
   [pull request via GitHub]. Also see [CONTRIBUTING.md] for more information.

Compiler Status
---------------

The OpenCoarrays CMake build and test scripts detect the compiler identity, version, and operating system (OS).  The scripts use this information to build and test the approproiate functionality for the compiler and OS. Each current compilers' status falls into one of three categories:

<a name="oca-caf-compilers">
 * **OpenCoarrays-Aware (OCA) Coarray Fortran (CAF) Compilers**</a>
     * _Definition:_ The compiler translates CAF statements into OpenCoarrays application binary interface ([ABI]) calls.
     * _Example_: GNU Fortran 5.1 or later (see <https://gcc.gnu.org/wiki/Coarray> for the compiler's CAF status..)
     * _Use case_: compile most Fortran 2008 coarray programs and some programs that use proposed Fortran 2015 features.
<a name="non-oca-caf-compilers">
 * **Non-OCA CAF Compilers**</a>
     * _Definition:_ The compiler supports CAF but does not generate calls to the OpenCoarrays [ABI].
     * _Examples_: Cray compiler (except on CS Series clusters), Intel compiler (except on OS X).
     * _Use case_: extend the compiler's native CAF using the [opencoarrays module] types and procedures.
<a name="non-caf-compilers">
 * **Non-CAF Compilers**</a>
     * _Definition_: The compiler provides no direct support for CAF, but the user can access a subset of CAF features via use association with the [opencoarrays module], e.g., `use opencoarrays, only : co_sum`.
     * _Examples_: GNU Fortran 4.9 or any compiler not mentioned above.
     * _Use case_: Use the OpenCoarrays `caf` compiler wrapper to compile those CAF  programs for which the proposed Fortran 2015 collective subroutines cover all of the application's communication requirements.

We have encountered several research applications that match the latter use case.  If you encounter difficulties, please submit a bug report or feature request via the [Issues] page. Also submit a feature request to the relevant compiler technical support.

The OpenCoarrays team offers contract development and support for making compilers OpenCoarrays-aware.  If this is of interest, please inform the compiler's technical support as well as the OpenCoarrays team.   To contribute code, including documentation and tests, see the [CONTRIBUTING.md] file.  To contribute funding, including funding in support of feature reqeusts, see the [Sourcery Store].

Library Status
--------------

<a name="libcaf-mpi">
* **libcaf_mpi**</a> (Default CMake build): Production transport layer that uses
  the Message Passing Interface ([MPI]) 3.0 one-sided communication, which
  exploits a hardware platform's native support for Remote Direct Memory
  Access (RDMA) if available.
<a name="libcaf-x">
* **libcaf_x**</a> (where x = [CUDA], [OpenMP], [Pthreads], [OpenSHMEM], etc.): the
  OpenCoarrays [ABI] design facilitates implementation atop any one of several
  low-level parallel programming models, vectorization APIs, or combination
  thereof. We have performed limited evaluations and research development of
  versions based on multiple APIs.  Please email the [OpenCoarrays Google Group]
  for support with targeting other APIs and hardware, including, for example,
  graphics processing units (GPUs) and heterogeneous CPU/GPU platforms.
<a name="libcaf-gasnet">
* **libcaf_gasnet**</a> (Advanced Make build): Experimental transport layer that
  is currently out-of-date but might exhibit higher performance than [MPI] on
  platforms for which [GASNet] provides a tuned conduit.  Contact the
  [OpenCoarrays Google Group] for further information.
<a name="libcaf-single">
* **libcaf_single**</a> (Unsupported): developed to mirror the like-named library that
  is included in GNU Fortran to facilitate compiling single-image (sequential)
  executables from CAF programs in the absence of a parallel communication library.

Known Issues
------------

### Library Issues ###

* The [opencoarrays module] and `caf` compiler wrapper do not support the square-bracket
  syntax required for point-to-point communication.  This limitation only impacts
  [non-CAF compilers]. For a list of other limitations with non-CAF compilers, execute
  the `caf` bash script with no arguments.  The `caf` script is installed in the `bin`
  subdirectory of the installation path.
* Efficient strided array transfer works only for intrinsic types.
* Efficient strided array transfer is not supported for remote-to-remote transfers.
* Overwriting a coarray with itself is not managed efficiently for strided transfers.
* Communication
     * Vector subscripts are not yet supported
     * For character assignments, some issues with padding and character kind conversions exist.
     * For array assignments, some issues with numeric type conversion exist.


### Compiler Issues ###

<a name="compiler-issues-gnu">
* **GNU** (gfortran)</a>
     * Derived-type coarrays with allocatable/pointer components are not yet handled
       properly.
     * Problems exist with combining array access to a corray with a scalar component
        access as in `coarray(:,:)[i]%comp`.
     * An internal compiler error (ICE) occurs with non-allocatable, polymorphic coarrays
       in `associate` or `select type` statements.
     * `co_reduce` requires GCC 5.4.0 or later.
     * `co_reduce` only supports arguments of intrinsic type.
     * Proper execution of `stop` when `this_image()>1` requires GCC 5.4.0 or later.
     * No support for type finalization or allocatable components of derived-type coarrays
       passed to the collective subroutines (e.g., `co_sum`, `co_reduce`, etc.).
     * Optimization levels other than `-O0` require GCC 5.3.0 or later. 
     * Using `stop` to halt an individual image without halting all images requires GCC 5.4.0 or later. 
<a name="compiler-issues-intel">
* **Intel** (ifort)</a>
     * Supported via the [opencoarrays module]  only.
<a name="compiler-issues-cray">
* **Cray** (ftn) </a>
     * Supported via the [opencoarrays module] only.
<a name="compiler-issues-nag">
* **Numerical Algorithms Group** (nagfor)</a>
     * Supported via the [opencoarrays module] only.
<a name="compiler-issues-pg">
* **Portland Group** (pgfortran)</a>
     * Supported via the [opencoarrays module] only.
<a name="compiler-issues-ibm">
* **IBM** (xlf)</a>
     * Supported via the [opencoarrays module] only.

To-Do List
----------

* [ ] Additional tests and documentation.
* [ ] Improvement of error handling and diagnostics, including but not
      limited to filling the `ERRMSG=` variable in case of errors.
* [ ] Providing a diagnostic mode with run-time consistency checks.
* [ ] Better integration with the test cases of GCC.  For more information,
      see the GCC source code files in `gcc/testsuite/gfortran.dg/`,
      in particular, the `dg-do run` tests in `coarray*f90` and `coarray/`).


[Hyperlinks]:#
   [OpenMP]: http://openmp.org
   [CUDA]: http://www.nvidia.com/object/cuda_home_new.html
   [Pthreads]: https://computing.llnl.gov/tutorials/pthreads/
   [MPI]: http://www.mpi-forum.org
   [OpenSHMEM]: http://openshmem.org
   [GASNet]: https://gasnet.lbl.gov
   [CONTRIBUTING.md]: ./CONTRIBUTING.md
   [OpenCoarrays-Aware (OCA) Coarray Fortran (CAF) Compilers]: #oca-caf-compilers
   [Known Issues]: #known-issues
   [Non-OCA CAF Compilers]: #non-oca-caf-compilers
   [Non-CAF Compilers]: #non-caf-compilers
   [libcaf_mpi]: #libcaf-mpi
   [libcaf_x]: #libcaf-x
   [libcaf_gasnet]:  #libcaf-gasnet
   [libcaf_single]: #libcaf-single
  [GNU (gfortran)]: #compiler-issues-gnu
  [Cray (ftn)]: #compiler-issues-cray
  [Intel (ifort)]: #compiler-issues-intel
  [Numerical Algorithms Group (nagfor)]: #compiler-issues-nag
  [Portland Group (pgfortran)]: #compiler-issues-pg
  [IBM (xlf)]: #compiler-issues-ibm
  [forking the OpenCoarrays repository]: https://github.com/sourceryinstitute/opencoarrays/fork

[TS 18508]: http://isotc.iso.org/livelink/livelink?func=ll&objId=17181227&objAction=Open
[opencoarrays module]: ./src/extensions/opencoarrays.F90
[ABI]: https://gcc.gnu.org/onlinedocs/gfortran/Function-ABI-Documentation.html#Function-ABI-Documentation
[pull requests via GitHub]: https://github.com/sourceryinstitute/opencoarrays/compare
[pull request via GitHub]: https://github.com/sourceryinstitute/opencoarrays/compare
[OpenCoarrays Google Group]: https://groups.google.com/forum/#!forum/opencoarrays
[Sourcery Store]: http://www.sourceryinstitute.org/store
[Issues]: https://github.com/sourceryinstitute/opencoarrays/issues
[pdf img]: https://img.shields.io/badge/PDF-STATUS.md-6C2DC7.svg?style=flat-square "Download as PDF"

<a name="top"> </a>

[This document is formatted with GitHub-Flavored Markdown.              ]:#
[For better viewing, including hyperlinks, read it online at            ]:#
[https://github.com/sourceryinstitute/opencoarrays/blob/master/STATUS.md]:#

OpenCoarrays Status
===================

[![Download as PDF][pdf img]](http://md2pdf.herokuapp.com/sourceryinstitute/opencoarrays/blob/master/STATUS.pdf)

Download this file as a PDF document
[here](http://md2pdf.herokuapp.com/sourceryinstitute/opencoarrays/blob/master/STATUS.pdf).

 *  [Feature Coverage](#feature-coverage)
 *  [Compiler Status](#compiler-status)
     * [OpenCoarrays-Aware (OCA) Coarray Fortran (CAF) Compilers]
     * [Non-OCA CAF Compilers]
     * [Non-CAF Compilers]
 *  [Library Status](#libary-status)
     *  [libcaf_mpi]
     *  [libcaf_x]
     *  [libcaf_gasnet]
     *  [libcaf_armci]
     *  [libcaf_single]
 *  [Known Issues](#known-issues)
     * [Library Issues](#library-issues)
     * [Compiler Issues](#compiler-issues)
         * [GNU (gfortran)]
         * [Cray (ftn)]
         * [Intel (ifort)]
         * [Numerical Algorithms Group (nagfor)]
         * [Portland Group (pgfortran)]
         * [IBM (xlf)]
 *  [To-Do List](#to-do-list)

Feature Coverage
----------------

 * Except as noted under [Known Issues], [libcaf_mpi] supports the following features as described
   in the Fortran 2008 standard:
     * allocatable and non-allocatable coarrays of intrinsic or derived type
     * synchronization statements
     * atomics
     * locks
     * critical
 * Except as noted under [Known Issues], [libcaf_mpi] supports the collective
   subroutines proposed for Fortran 2015 in the draft Technical Specification
   [TS 18508] _Additional Parallel Features in Fortra_ subroutines for a limited
   set of intrinsic types and kinds.  Adding additional types and kinds is
   straightforward.  Please submit a request via the [Issues] page or consider
   adding the requisite code by [forking the OpenCoarrays repository] and submitting
   [pull request via GitHub]. Also see [CONTRIBUTING.md] for more information.

Compiler Status
---------------

The OpenCoarrays CMake build and test scripts detect the compiler identity, version, and operating system (OS).  The scripts use this information to build and test the approproiate functionality for the compiler and OS. Each current compilers' status falls into one of three categories:

<a name="oca-caf-compilers">
 * **OpenCoarrays-Aware (OCA) Coarray Fortran (CAF) Compilers**</a>
     * _Definition:_ The compiler translates CAF statements into OpenCoarrays application binary interface ([ABI]) calls.
     * _Example_: GNU Fortran 5.1 or later (see <https://gcc.gnu.org/wiki/Coarray> for the compiler's CAF status..)
     * _Use case_: compile most Fortran 2008 coarray programs and some programs that use proposed Fortran 2015 features.
<a name="non-oca-caf-compilers">
 * **Non-OCA CAF Compilers**</a>
     * _Definition:_ The compiler supports CAF but does not generate calls to the OpenCoarrays [ABI].
     * _Examples_: Cray compiler (except on CS Series clusters), Intel compiler (except on OS X).
     * _Use case_: extend the compiler's native CAF using the [opencoarrays module] types and procedures.
<a name="non-caf-compilers">
 * **Non-CAF Compilers**</a>
     * _Definition_: The compiler provides no direct support for CAF, but the user can access a subset of CAF features via use association with the [opencoarrays module], e.g., `use opencoarrays, only : co_sum`.
     * _Examples_: GNU Fortran 4.9 or any compiler not mentioned above.
     * _Use case_: Use the OpenCoarrays `caf` compiler wrapper to compile those CAF  programs for which the proposed Fortran 2015 collective subroutines cover all of the application's communication requirements.

We have encountered several research applications that match the latter use case.  If you encounter difficulties, please submit a bug report or feature request via the [Issues] page. Also submit a feature request to the relevant compiler technical support.

The OpenCoarrays team offers contract development and support for making compilers OpenCoarrays-aware.  If this is of interest, please inform the compiler's technical support as well as the OpenCoarrays team.   To contribute code, including documentation and tests, see the [CONTRIBUTING.md] file.  To contribute funding, including funding in support of feature reqeusts, see the [Sourcery Store].

Library Status
--------------

<a name="libcaf-mpi">
* **libcaf_mpi**</a> (Default CMake build): Production transport layer that uses
  the Message Passing Interface ([MPI]) 3.0 one-sided communication, which
  exploits a hardware platform's native support for Remote Direct Memory
  Access (RDMA) if available.
<a name="libcaf-x">
* **libcaf_x**</a> (where x = [CUDA], [OpenMP], [Pthreads], [OpenSHMEM], etc.): the
  OpenCoarrays [ABI] design facilitates implementation atop any one of several
  low-level parallel programming models, vectorization APIs, or combination
  thereof. We have performed limited evaluations and research development of
  versions based on multiple APIs.  Please email the [OpenCoarrays Google Group]
  for support with targeting other APIs and hardware, including, for example,
  graphics processing units (GPUs) and heterogeneous CPU/GPU platforms.
<a name="libcaf-gasnet">
* **libcaf_gasnet**</a> (Advanced Make build): Experimental transport layer that
  is currently out-of-date but might exhibit higher performance than [MPI] on
  platforms for which [GASNet] provides a tuned conduit.  Contact the
  [OpenCoarrays Google Group] for further information.
<a name="libcaf-armci">
* **libcaf_armci**</a> (Unsupported): developed for research purposes and evaluation.
<a name="libcaf-single">
* **libcaf_single**</a> (Unsupported): developed to mirror the like-named library that
  is included in GNU Fortran to facilitate compiling single-image (sequential)
  executables from CAF programs in the absence of a parallel communication library.

Known Issues
------------

### Library Issues ###

* The [opencoarrays module] and `caf` compiler wrapper do not support the square-bracket
  syntax required for point-to-point communication.  This limitation only impacts
  [non-CAF compilers]. For a list of other limitations with non-CAF compilers, execute
  the `caf` bash script with no arguments.  The `caf` script is installed in the `bin`
  subdirectory of the installation path.
* Efficient strided array transfer works only for intrinsic types.
* Efficient strided array transfer is not supported for remote-to-remote transfers.
* Overwriting a coarray with itself is not managed efficiently for strided transfers.
* Communication
     * Vector subscripts are not yet supported
     * For character assignments, some issues with padding and character kind conversions exist.
     * For array assignments, some issues with numeric type conversion exist.


### Compiler Issues ###

<a name="compiler-issues-gnu">
* **GNU** (gfortran)</a>
     * Derived-type coarrays with allocatable/pointer components are not yet handled
       properly.
     * Problems exist with combining array access to a corray with a scalar component
        access as in `coarray(:,:)[i]%comp`.
     * An internal compiler error (ICE) occurs with non-allocatable, polymorphic coarrays
       in `associate` or `select type` statements.
     * `co_reduce` requires GCC 5.4.0 or later.
     * `co_reduce` only supports arguments of intrinsic type.
     * Proper execution of `stop` when `this_image()>1` requires GCC 5.4.0 or later.
     * No support for type finalization or allocatable components of derived-type coarrays
       passed to the collective subroutines (e.g., `co_sum`, `co_reduce`, etc.).
     * Optimization levels other than `-O0` require GCC 5.3.0 or later. 
     * Using `stop` to halt an individual image without halting all images requires GCC 5.4.0 or later. 
<a name="compiler-issues-intel">
* **Intel** (ifort)</a>
     * Supported via the [opencoarrays module]  only.
<a name="compiler-issues-cray">
* **Cray** (ftn) </a>
     * Supported via the [opencoarrays module] only.
<a name="compiler-issues-nag">
* **Numerical Algorithms Group** (nagfor)</a>
     * Supported via the [opencoarrays module] only.
<a name="compiler-issues-pg">
* **Portland Group** (pgfortran)</a>
     * Supported via the [opencoarrays module] only.
<a name="compiler-issues-ibm">
* **IBM** (xlf)</a>
     * Supported via the [opencoarrays module] only.

To-Do List
----------

* [ ] Additional tests and documentation.
* [ ] Improvement of error handling and diagnostics, including but not
      limited to filling the `ERRMSG=` variable in case of errors.
* [ ] Providing a diagnostic mode with run-time consistency checks.
* [ ] Better integration with the test cases of GCC.  For more information,
      see the GCC source code files in `gcc/testsuite/gfortran.dg/`,
      in particular, the `dg-do run` tests in `coarray*f90` and `coarray/`).


[Hyperlinks]:#
   [OpenMP]: http://openmp.org
   [CUDA]: http://www.nvidia.com/object/cuda_home_new.html
   [Pthreads]: https://computing.llnl.gov/tutorials/pthreads/
   [MPI]: http://www.mpi-forum.org
   [OpenSHMEM]: http://openshmem.org
   [GASNet]: https://gasnet.lbl.gov
   [CONTRIBUTING.md]: ./CONTRIBUTING.md
   [OpenCoarrays-Aware (OCA) Coarray Fortran (CAF) Compilers]: #oca-caf-compilers
   [Known Issues]: #known-issues
   [Non-OCA CAF Compilers]: #non-oca-caf-compilers
   [Non-CAF Compilers]: #non-caf-compilers
   [libcaf_mpi]: #libcaf-mpi
   [libcaf_x]: #libcaf-x
   [libcaf_gasnet]:  #libcaf-gasnet
   [libcaf_single]: #libcaf-single
   [libcaf_armci]: #libcaf-armci
  [GNU (gfortran)]: #compiler-issues-gnu
  [Cray (ftn)]: #compiler-issues-cray
  [Intel (ifort)]: #compiler-issues-intel
  [Numerical Algorithms Group (nagfor)]: #compiler-issues-nag
  [Portland Group (pgfortran)]: #compiler-issues-pg
  [IBM (xlf)]: #compiler-issues-ibm
  [forking the OpenCoarrays repository]: https://github.com/sourceryinstitute/opencoarrays/blob/master/STATUS.md#fork-destination-box

[TS 18508]: http://isotc.iso.org/livelink/livelink?func=ll&objId=17181227&objAction=Open
[opencoarrays module]: ./src/extensions/opencoarrays.F90
[ABI]: https://gcc.gnu.org/onlinedocs/gfortran/Function-ABI-Documentation.html#Function-ABI-Documentation
[pull requests via GitHub]: https://github.com/sourceryinstitute/opencoarrays/compare
[pull request via GitHub]: https://github.com/sourceryinstitute/opencoarrays/compare
[OpenCoarrays Google Group]: https://groups.google.com/forum/#!forum/opencoarrays
[Sourcery Store]: http://www.sourceryinstitute.org/store
[Issues]: https://github.com/sourceryinstitute/opencoarrays/issues
[pdf img]: https://img.shields.io/badge/PDF-STATUS.md-6C2DC7.svg?style=flat-square "Download as PDF"

<a name="top"> </a>

[This document is formatted with GitHub-Flavored Markdown.                       ]:#
[For better viewing, including hyperlinks, read it online at                     ]:#
[https://github.com/sourceryinstitute/opencoarrays/blob/master/GETTING_STARTED.md]:#

Getting Started
===============

[![Download as PDF][pdf img]](http://md2pdf.herokuapp.com/sourceryinstitute/opencoarrays/blob/master/GETTING_STARTED.pdf)

Download this file as a PDF document
[here](http://md2pdf.herokuapp.com/sourceryinstitute/opencoarrays/blob/master/GETTING_STARTED.pdf).

* [The caf compiler wrapper]
* [A sample basic workflow]
* [An advanced workflow]

The caf compiler wrapper
--------------------------

The preferred method for compiling a CAF program is by invoking the `caf` bash script
that the OpenCoarrays CMake scripts install in the `bin` subdirectory of the installation
path. This is an experimental script with limited but useful capabilities that will
grow over time.  Please submit bug reports and feature requests via our [Issues] page.

The `caf` script liberates the source code and workflow from explicit dependence on the
underlying compiler and communication library in the following ways:

1. With an OpenCoarrays-aware (OCA) CAF compiler, the `caf` script passes the unmodified
   source code to the underlying compiler with the necessary arguments for building a
   CAF program, embedding the paths to OpenCoarrays libraries (e.g., `libcaf_mpi.a`) installed
   in the `lib` subdirectory of the OpenCoarrays installation path.  The `caf` script also
   embeds the path to the relevant module file in the `mod` subdirectory of the installation
   path (e.g., `opencoarrays.mod`).  This supports use association with module entities via
   `use opencoarrays`.
2. With a non-CAF compiler (including gfortran 4.9), `caf` supports a subset of CAF by
   replacing CAF statements with calls to procedures in the [opencoarrays module] before
   passing the source code to the compiler.

When using GCC 4.9, we recommend using the `use` statement's `only` clause to
avoid inadvertent procedure name clashes between OpenCoarrays procedures and their
GCC counterparts.  For example, use `use opencoarrays, only : co_reduce`.

With a non-OCA and OCA CAF compilers, the extensions that `caf` imports include the collective
subroutines proposed for Fortran 2015 in the draft Technical Specification [TS 18508]
_Additional Parallel Features in Fortran_.

The latter use case provides an opportunity to mix a compiler's CAF support with that of OpenCoarrays.
For example, a non-OCA CAF compiler, such as the Cray or Intel compilers, might support all of a
program's coarray square-bracket syntax, while OpenCoarrays supports the same program's calls to
collective subroutine such as `co_sum` and `co_reduce`.

A sample basic workflow
-----------------------

The following program listing, compilation, and execution workflow exemplify
the use of an OCA compiler (e.g., gfortran 5.1.0 or later) in a Linux bash shell
with the `bin` directory of the chosen installation path in the user's PATH
environment variable:

```
$ cat tally.f90
      program main
        use iso_c_binding, only : c_int
        use iso_fortran_env, only : error_unit
        implicit none
        integer(c_int) :: tally
        tally = this_image() ! this image's contribution
        call co_sum(tally)
        verify: block
          integer(c_int) :: image
          if (tally/=sum([(image,image=1,num_images())])) then
             write(error_unit,'(a,i5)') "Incorrect tally on image ",this_image()
             error stop
          end if
        end block verify
        ! Wait for all images to pass the test
        sync all
        if (this_image()==1) print *,"Test passed"
      end program
$ caf tally.f90 -o tally
$ cafrun -np 4 ./tally
        Test passed
```

where "4" is the number of images to be launched at program start-up.

An advanced workflow
--------------------

To extend the capabilities of a non-OCA CAF compiler (e.g., the Intel or Cray compilers),
access the types and procedures of the [opencoarrays module] by use association.  We
recommend using a `use` statement with an `only` clause to reduce the likelihood of a
name clash with the compiler's native CAf support.  For example, insert the following
at line 2 of `tally.f90` above:

```fortran
use opencoarrays, only : co_sum
```

To extend the capabilities of a non-CAF compiler (e.g., GCC 4.9), use an unqualified
`use` statement with no `only` clause.  The latter practice reduces the likelihood of
name clashes with the compiler's or programs existing capabilities.

If the `caf` compiler wrapper cannot process the source code in question, invoke
the underlying communication library directly:

```
mpif90 -fcoarray=lib -L/opt/opencoarrays/ tally.f90 \ -lcaf_mpi -o htally-I<OpenCoarrays-install-path>/mod
```

and also run the program with the lower-level communication library:

```
mpirun -np <number-of-images> ./tally
```

[Hyperlinks]:#

[The caf compiler wrapper]: #the-caf-compiler-wrapper
[A sample basic workflow]: #a-sample-basic-workflow
[An advanced workflow]:  #an-advanced-workflow

[Sourcery Store]: http://www.sourceryinstitute.org/store
[Issues]: https://github.com/sourceryinstitute/opencoarrays/issues
[opencoarrays module]: ./src/extensions/opencoarrays.F90
[GCC]: http://gcc.gnu.org
[TS 18508]: http://isotc.iso.org/livelink/livelink?func=ll&objId=17181227&objAction=Open
[The caf compiler wrapper]: #the-caf-compiler-wrapper
[The cafrun program launcher]: #the-cafrun-program-launcher
[pdf img]: https://img.shields.io/badge/PDF-GETTING_STARTED.md-6C2DC7.svg?style=flat-square "Download as PDF"

Frequently Asked Questions
==========================

* [1. I have installed OpenCoarrays with OpenMPI but I'm having trouble running with more than a few images, why?]
* [2. I have installed OpenCoarrays with a recent version of OpenMPI, but my Coarray Fortran programs won't run when launched with cafrun, why?]
* [3. `install.sh` is trying to download and install GCC/GFortran and its prerequisites, but I want to use GCC version X already present on my system, how can I do this?]
* [4. How can I uninstall OpenCoarrays?]
* [5. OpenCoarrays was built with MPICH as the MPI back end, but I am running into bugs, what should I do?]
* [6. How can I pass additional flags through to the underlying parallel run-time or compiler?]
* [7. When `install.sh` builds the GCC compilers, it takes forever (hours).  How can I speed up the build?]

## 1. I have installed OpenCoarrays with OpenMPI but I'm having trouble running with more than a few images, why? ##

OpenMPI requires oversubscribed jobs (more MPI ranks/coarray
images than logical CPU cores available) to pass the
`--oversubscribe` flag to `mpirun`. To run a Coarray program with
more images than available logical CPU cores, please pass
`--oversubscribe` as an argument to the `cafrun` wrapper
script. `cafrun` will pass any additional flags through to the
underlying run-time launcher (i.e., `mpirun`). Here is an example
invocation of `cafrun` demonstrating this procedure:

```
cafrun -np 32 --oversubscribe ./a.out <arg1> <arg2>
```

## 2. I have installed OpenCoarrays with a recent version of OpenMPI, but my Coarray Fortran programs won't run when launched with `cafrun`, why? ##

Recent versions of OpenMPI require a hostfile to be used,
specifying the number of "slots" (i.e., logical CPU cores)
available on each node or host on the system. If you are running
OpenCoarrays on a production HPC system, your system
administrator should have configured OpenMPI with a default hosts
file or should provide instructions on how to generate your
own. If you are running OpenCoarrays on a shared memory machine,
such as a laptop, desktop, or workstation, then you may have to
provide your own hostfile. On a shared memory machine, this
hostfile should look something like:

```
hostname.local 8
```

where `hostname` is the hostname of the machine you are running on
and `8` is the number of logical CPU cores. On a Macbook Pro (late
2013) with a 4 core Intel core i7 CPU with two hyper threads per
core, 8 is the number of logical CPU cores. When OpenCoarrays is
configured and installed, if OpenMPI is detected a hostfile is
created in the build directory for use when running the test
suite. (This hostfile corresponds to the machine/node used to
configure OpenCoarrays using CMake.) If you installed OpenCoarrays
via the [`install.sh`] script, then it will be located at
`./prerequisites/builds/opencoarrays/<version>/hostfile` or if you
invoked CMake yourself it should be in the top level of your build
directory at `/path/to/build/dir/hostfile`. (You must run CMake
first, to create this file.)

## 3. `install.sh` is trying to download and install GCC/GFortran and its prerequisites, but I want to use GCC version X already present on my system, how can I do this? ##

[`install.sh`] defaults to trying to install the most recent stable
version of GFortran and GCC that has the best functionality with
OpenCoarrays. This is usually the latest stable version of
GCC/GFortran, however, sometimes regressions are present and a
slightly older version is set as the default until most of the serious
regressions are resolved. If you know what you are doing and wish to
use a different Fortran/C compiler, you can explicitly pass arguments
to [`install.sh`] to specify which compilers to use. Please see the
usage information for [`install.sh`] by invoking it with the `--help`
flag. For example, the `-f` or `--with-fortran` flag is passed with
the path to the desired Fortran compiler, the `-c` or `--with-c` flag
is passed with the path to the desired C compiler and the `-C` or
`--with-cxx` flag is passed with the path to the desired C++
compiler. Alternatively the "Developer/quick-start instructions"
(located in the [`INSTALL`] file) may be followed to perform the
installation using CMake directly, without calling [`install.sh`]. The
compilers are specified using the `FC`, `CC` and `CXX` environment
variables, and all prerequisites (GFortran, CMake, and a suitable MPI
implementation) are assumed to be already installed on the system. If
you pass one compiler-specification argument (e.g., `-f`), it is best
to pass all three (e.g., `-f`, `-c`, and `-C`) to ensure consistency.

## 4. How can I uninstall OpenCoarrays? ##

After installing OpenCoarrays, you can enter the build directory
(`prerequisites/builds/opencoarrays/<version>` if installed via
[`install.sh`]) and run `make uninstall`. A script or additional flag
to [`install.sh`] is planned to automate this process, but has yet to
be implemented. When OpenCoarrays is installed a file manifest is
written in this build directory, so you can examine which files get
installed and their locations on your system.

## 5. OpenCoarrays was built with MPICH as the MPI back end, but I am running into bugs, what should I do? ##

There is a bug in MPICH that, as of this writing, is patched, but is
not yet in a stable release. This bug effects the failed images
functionality, which can be disabled during configuration. If you
encounter issues using OpenCoarrays with MPICH, reinstalling
OpenCoarrays _without_ failed image support may resolve the issue. To
do so you will have to perform a manual CMake configuration and
installation as described in the "Developer/quick start" installation
guide documented in the file [`INSTALL`]. Please pass the
`-DCAF_ENABLE_FAILED_IMAGES=FALSE` flag to CMake when configuring
OpenCoarrays. If this doesn't resolve your issue, please file a
[new issue].

## 6. How can I pass additional flags through to the underlying parallel run-time or compiler? ##

The `caf` compiler wrapper script and the `cafrun` Coarray Fortran
program launch script will both pass additional flags through to
the underlying compiler and parallel run-time job launcher,
respectively. Specify the additional flags to be passed to
GFortran or `mpirun` after any flags specific to `caf` or `cafrun`
such as the `-s` flag to show the underlying command, or the `-np <N>`
flag to specify the number of images in the `cafrun` script and before
any files such as Fortran source files or Coarray Fortran executables.

## 7. When `install.sh` builds the GCC compilers, it takes forever (hours).  How can I speed up the build? ##

To increase the odds of success, `install.sh` defaults to a GCC
bootstrap build, which builds a minimal compiler to build the ultimate
compiler (not every version of GCC can build every other version of
GCC).  For a much faster build process that has a somewhat higher
chance of failing, pass the `--disable-bootstrap` or `-z` argument and
use more threads by passing, for example, `--num-threads -4` or `-j 4`
to use four threads.  In combination, these two recommendations can
decrease the GCC build time from several hours to 15 or fewer minutes.


[`install.sh`]: https://github.com/sourceryinstitute/OpenCoarrays/blob/master/install.sh
[`INSTALL']: https://github.com/sourceryinstitute/OpenCoarrays/blob/master/INSTALL
[new issue]: https://github.com/sourceryinstitute/OpenCoarrays/issues/new

[TOC links]: #
[1. I have installed OpenCoarrays with OpenMPI but I'm having trouble running with more than a few images, why?]: #1-i-have-installed-opencoarrays-with-openmpi-but-im-having-trouble-running-with-more-than-a-few-images-why
[2. I have installed OpenCoarrays with a recent version of OpenMPI, but my Coarray Fortran programs won't run when launched with cafrun, why?]: #2-i-have-installed-opencoarrays-with-a-recent-version-of-openmpi-but-my-coarray-fortran-programs-wont-run-when-launched-with-cafrun-why
[3. `install.sh` is trying to download and install GCC/GFortran and its prerequisites, but I want to use GCC version X already present on my system, how can I do this?]: #3-installsh-is-trying-to-download-and-install-gccgfortran-and-its-prerequisites-but-i-want-to-use-gcc-version-x-already-present-on-my-system-how-can-i-do-this
[4. How can I uninstall OpenCoarrays?]: #4-how-can-i-uninstall-opencoarrays
[5. OpenCoarrays was built with MPICH as the MPI back end, but I am running into bugs, what should I do?]: #5-opencoarrays-was-built-with-mpich-as-the-mpi-back-end-but-i-am-running-into-bugs-what-should-i-do
[6. How can I pass additional flags through to the underlying parallel run-time or compiler?]: #6-how-can-i-pass-additional-flags-through-to-the-underlying-parallel-run-time-or-compiler
[7. When `install.sh` builds the GCC compilers, it takes forever (hours).  How can I speed up the build?]: #7-when-installsh-builds-the-gcc-compilers-it-takes-forever-hours--how-can-i-speed-up-the-build

<a name="top"> </a>

[This document is formatted with GitHub-Flavored Markdown.                       ]:#
[For better viewing, including hyperlinks, read it online at                     ]:#
[https://github.com/sourceryinstitute/OpenCoarrays/blob/master/GETTING_STARTED.md]:#

Getting Started
===============

[![Download as PDF][pdf img]](http://md2pdf.herokuapp.com/sourceryinstitute/OpenCoarrays/blob/master/GETTING_STARTED.pdf)

Download this file as a PDF document
[here](http://md2pdf.herokuapp.com/sourceryinstitute/OpenCoarrays/blob/master/GETTING_STARTED.pdf).

* [The caf compiler wrapper]
* [A sample basic workflow]
* [An advanced workflow]

The caf compiler wrapper
--------------------------

The preferred method for compiling a CAF program is by invoking the `caf` bash script
that the OpenCoarrays CMake scripts install in the `bin` subdirectory of the installation
path. This is an experimental script with limited but useful capabilities that will
grow over time.  Please submit bug reports and feature requests via our [Issues] page.

The `caf` script liberates the source code and workflow from explicit dependence on the
underlying compiler and communication library by passing the unmodified source code to 
the compiler with the necessary arguments for building a parallel Fortran 2018 program,
embedding the paths to OpenCoarrays libraries (e.g., `libcaf_mpi.a`) installed
in the `lib` subdirectory of the OpenCoarrays installation path.  

A sample basic workflow
-----------------------

The following program listing, compilation, and execution workflow exemplify
the use of OpenCoarrays with GCC in a Linux bash shell with the `bin`
directory of the chosen installation path in the user's `PATH` environment variable:

```fortran
$ cat tally.f90
      program main
        use iso_c_binding, only : c_int
        use iso_fortran_env, only : error_unit
        implicit none
        integer(c_int) :: tally
        tally = this_image() ! this image's contribution
        call co_sum(tally)
        verify: block
          integer(c_int) :: image
          if (tally/=sum([(image,image=1,num_images())])) then
             write(error_unit,'(a,i5)') "Incorrect tally on image ",this_image()
             error stop
          end if
        end block verify
        ! Wait for all images to pass the test
        sync all
        if (this_image()==1) print *,"Test passed"
      end program
$ caf tally.f90 -o tally
$ cafrun -np 4 ./tally
        Test passed
```

where "4" is the number of images to be launched at program start-up.

An advanced workflow
--------------------

If you prefer to invoke the compiler directly, first run `caf` and `cafrun` with the `--show` flag 
to see the proper linking and file includes.  For example, on a macOS system where OpenCoarrays 
was installed via the [homebrew] package manager, the following results:

```bash
$ caf --show
/usr/local/bin/gfortran -I/usr/local/Cellar/opencoarrays/2.2.0/include/OpenCoarrays-2.2.0_GNU-8.2.0 -fcoarray=lib -Wl,-flat_namespace -Wl,-commons,use_dylibs -L/usr/local/Cellar/libevent/2.1.8/lib -L/usr/local/Cellar/open-mpi/3.1.1/lib ${@} /usr/local/Cellar/opencoarrays/2.2.0/lib/libcaf_mpi.a /usr/local/lib/libmpi_usempif08.dylib /usr/local/lib/libmpi_usempi_ignore_tkr.dylib /usr/local/lib/libmpi_mpifh.dylib /usr/local/lib/libmpi.dylib
$ cafrun --show
/usr/local/bin/mpiexec -n <number_of_images> /path/to/coarray_Fortran_program [arg4 [arg5 [...]]]
```

---

[![GitHub forks](https://img.shields.io/github/forks/sourceryinstitute/OpenCoarrays.svg?style=social&label=Fork)](https://github.com/sourceryinstitute/OpenCoarrays/fork)
[![GitHub stars](https://img.shields.io/github/stars/sourceryinstitute/OpenCoarrays.svg?style=social&label=Star)](https://github.com/sourceryinstitute/OpenCoarrays)
[![GitHub watchers](https://img.shields.io/github/watchers/sourceryinstitute/OpenCoarrays.svg?style=social&label=Watch)](https://github.com/sourceryinstitute/OpenCoarrays)
[![Twitter URL](https://img.shields.io/twitter/url/http/shields.io.svg?style=social)](https://twitter.com/intent/tweet?hashtags=HPC,Fortran,PGAS&related=zbeekman,gnutools,HPCwire,HPC_Guru,hpcprogrammer,SciNetHPC,DegenerateConic,jeffdotscience,travisci&text=Stop%20programming%20w%2F%20the%20%23MPI%20docs%20in%20your%20lap%2C%20try%20Coarray%20Fortran%20w%2F%20OpenCoarrays%20%26%20GFortran!&url=https%3A//github.com/sourceryinstitute/OpenCoarrays)

[Hyperlinks]:#

[The caf compiler wrapper]: #the-caf-compiler-wrapper
[A sample basic workflow]: #a-sample-basic-workflow
[An advanced workflow]:  #an-advanced-workflow

[Sourcery Store]: http://www.sourceryinstitute.org/store
[Issues]: https://github.com/sourceryinstitute/OpenCoarrays/issues
[opencoarrays module]: ./src/extensions/opencoarrays.F90
[GCC]: http://gcc.gnu.org
[TS 18508]: http://isotc.iso.org/livelink/livelink?func=ll&objId=17181227&objAction=Open
[The caf compiler wrapper]: #the-caf-compiler-wrapper
[The cafrun program launcher]: #the-cafrun-program-launcher
[pdf img]: https://img.shields.io/badge/PDF-GETTING_STARTED.md-6C2DC7.svg?style=flat-square "Download as PDF"
[homebrew]: https://brew.sh
